/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/workbench/api/common/extHostTypeConverters","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/platform/extensions/common/extensions","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/charCode","vs/base/common/map","vs/platform/files/common/files","vs/platform/registry/common/platform","vs/platform/contextkey/common/contextkey","vs/editor/common/core/range","vs/base/common/themables","vs/base/common/severity","vs/base/common/uuid","vs/base/common/marshallingIds","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/base/common/iterator","vs/base/common/glob","vs/platform/configuration/common/configuration","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/errorMessage","vs/base/common/marshalling","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/editor/common/model","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTerminalService","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/base/common/performance","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/base/common/hash","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/iconLabels","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/scrollable","vs/base/common/stream","vs/base/common/symbols","vs/base/common/filters","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/chat/common/languageModels","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/contrib/testing/common/constants","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/editor/common/core/wordHelper","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/configuration/common/configurationModels","vs/platform/request/common/request","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/base/common/uint","vs/base/common/codiconsUtil","vs/base/common/arraysFind","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Ie=function(de){for(var e=[],E=0,R=de.length;E<R;E++)e[E]=ke[de[E]];return e};define(ke[72],Ie([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=R,e.$6h=P,e.$7h=O;function E(A){return(M,$,c)=>{let C=null,v=null;if(typeof c.value=="function"?(C="value",v=c.value):typeof c.get=="function"&&(C="get",v=c.get),!v)throw new Error("not supported");c[C]=A(v,$)}}function R(A,M,$){let c=null,C=null;if(typeof $.value=="function"?(c="value",C=$.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(c="get",C=$.get),!C)throw new Error("not supported");const v=`$memoize$${M}`;$[c]=function(...u){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,u)}),this[v]}}function P(A,M,$){return E((c,C)=>{const v=`$debounce$${C}`,u=`$debounce$result$${C}`;return function(...D){this[u]||(this[u]=$?$():void 0),clearTimeout(this[v]),M&&(this[u]=M(this[u],...D),D=[this[u]]),this[v]=setTimeout(()=>{c.apply(this,D),this[u]=$?$():void 0},A)}})}function O(A,M,$){return E((c,C)=>{const v=`$throttle$timer$${C}`,u=`$throttle$result$${C}`,D=`$throttle$lastRun$${C}`,d=`$throttle$pending$${C}`;return function(...r){if(this[u]||(this[u]=$?$():void 0),(this[D]===null||this[D]===void 0)&&(this[D]=-Number.MAX_VALUE),M&&(this[u]=M(this[u],...r)),this[d])return;const o=this[D]+A;o<=Date.now()?(this[D]=Date.now(),c.apply(this,[this[u]]),this[u]=$?$():void 0):(this[d]=!0,this[v]=setTimeout(()=>{this[d]=!1,this[D]=Date.now(),c.apply(this,[this[u]]),this[u]=$?$():void 0},o-Date.now()))}})}}),define(ke[133],Ie([1,0,18]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0,e.$7c=P,e.$8c=O,e.$9c=A,e.$0c=M,e.$$c=$,e.$_c=c;const R=(D,d)=>D===d;e.$6c=R;function P(D=e.$6c){return(d,r)=>E.$ub(d,r,D)}function O(){return(D,d)=>JSON.stringify(D)===JSON.stringify(d)}function A(){return(D,d)=>D.equals(d)}function M(D,d,r){return!D||!d?D===d:r(D,d)}function $(D,d){if(D===d)return!0;if(Array.isArray(D)&&Array.isArray(d)){if(D.length!==d.length)return!1;for(let r=0;r<D.length;r++)if(!$(D[r],d[r]))return!1;return!0}if(D&&typeof D=="object"&&d&&typeof d=="object"&&Object.getPrototypeOf(D)===Object.prototype&&Object.getPrototypeOf(d)===Object.prototype){const r=D,o=d,a=Object.keys(r),h=Object.keys(o),t=new Set(h);if(a.length!==h.length)return!1;for(const s of a)if(!t.has(s)||!$(r[s],o[s]))return!1;return!0}return!1}function c(D){return JSON.stringify(u(D))}let C=0;const v=new WeakMap;function u(D){if(Array.isArray(D))return D.map(u);if(D&&typeof D=="object")if(Object.getPrototypeOf(D)===Object.prototype){const d=D,r=Object.create(null);for(const o of Object.keys(d).sort())r[o]=u(d[o]);return r}else{let d=v.get(D);return d===void 0&&(d=C++,v.set(D,d)),d+"----2b76a038c20c4bcc"}return D}}),define(ke[96],Ie([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5O=e.$4O=void 0;class E{constructor(P){this.a=P,this.b=0}nextId(){return this.a+ ++this.b}}e.$4O=E,e.$5O=new E("id#")}),define(ke[134],Ie([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Nn=A,e.$On=v,e.$Pn=u,e.$Qn=D,e.$Rn=d,e.$Sn=r,e.$Tn=o,e.$Un=a,e.$Vn=h,e.$Wn=t,e.$Xn=s,e.$Yn=n;var E;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(E||(e.ScanError=E={}));var R;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(R||(e.SyntaxKind=R={}));var P;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var O;(function(i){i.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function A(i,g=!1){let f=0;const l=i.length;let b="",I=0,S=R.Unknown,y=E.None;function p(q){let V=0,N=0;for(;V<q;){const L=i.charCodeAt(f);if(L>=C._0&&L<=C._9)N=N*16+L-C._0;else if(L>=C.A&&L<=C.F)N=N*16+L-C.A+10;else if(L>=C.a&&L<=C.f)N=N*16+L-C.a+10;else break;f++,V++}return V<q&&(N=-1),N}function k(q){f=q,b="",I=0,S=R.Unknown,y=E.None}function m(){const q=f;if(i.charCodeAt(f)===C._0)f++;else for(f++;f<i.length&&c(i.charCodeAt(f));)f++;if(f<i.length&&i.charCodeAt(f)===C.dot)if(f++,f<i.length&&c(i.charCodeAt(f)))for(f++;f<i.length&&c(i.charCodeAt(f));)f++;else return y=E.UnexpectedEndOfNumber,i.substring(q,f);let V=f;if(f<i.length&&(i.charCodeAt(f)===C.E||i.charCodeAt(f)===C.e))if(f++,(f<i.length&&i.charCodeAt(f)===C.plus||i.charCodeAt(f)===C.minus)&&f++,f<i.length&&c(i.charCodeAt(f))){for(f++;f<i.length&&c(i.charCodeAt(f));)f++;V=f}else y=E.UnexpectedEndOfNumber;return i.substring(q,V)}function w(){let q="",V=f;for(;;){if(f>=l){q+=i.substring(V,f),y=E.UnexpectedEndOfString;break}const N=i.charCodeAt(f);if(N===C.doubleQuote){q+=i.substring(V,f),f++;break}if(N===C.backslash){if(q+=i.substring(V,f),f++,f>=l){y=E.UnexpectedEndOfString;break}switch(i.charCodeAt(f++)){case C.doubleQuote:q+='"';break;case C.backslash:q+="\\";break;case C.slash:q+="/";break;case C.b:q+="\b";break;case C.f:q+="\f";break;case C.n:q+=`
`;break;case C.r:q+="\r";break;case C.t:q+="	";break;case C.u:{const Z=p(4);Z>=0?q+=String.fromCharCode(Z):y=E.InvalidUnicode;break}default:y=E.InvalidEscapeCharacter}V=f;continue}if(N>=0&&N<=31)if($(N)){q+=i.substring(V,f),y=E.UnexpectedEndOfString;break}else y=E.InvalidCharacter;f++}return q}function F(){if(b="",y=E.None,I=f,f>=l)return I=l,S=R.EOF;let q=i.charCodeAt(f);if(M(q)){do f++,b+=String.fromCharCode(q),q=i.charCodeAt(f);while(M(q));return S=R.Trivia}if($(q))return f++,b+=String.fromCharCode(q),q===C.carriageReturn&&i.charCodeAt(f)===C.lineFeed&&(f++,b+=`
`),S=R.LineBreakTrivia;switch(q){case C.openBrace:return f++,S=R.OpenBraceToken;case C.closeBrace:return f++,S=R.CloseBraceToken;case C.openBracket:return f++,S=R.OpenBracketToken;case C.closeBracket:return f++,S=R.CloseBracketToken;case C.colon:return f++,S=R.ColonToken;case C.comma:return f++,S=R.CommaToken;case C.doubleQuote:return f++,b=w(),S=R.StringLiteral;case C.slash:{const V=f-1;if(i.charCodeAt(f+1)===C.slash){for(f+=2;f<l&&!$(i.charCodeAt(f));)f++;return b=i.substring(V,f),S=R.LineCommentTrivia}if(i.charCodeAt(f+1)===C.asterisk){f+=2;const N=l-1;let L=!1;for(;f<N;){if(i.charCodeAt(f)===C.asterisk&&i.charCodeAt(f+1)===C.slash){f+=2,L=!0;break}f++}return L||(f++,y=E.UnexpectedEndOfComment),b=i.substring(V,f),S=R.BlockCommentTrivia}return b+=String.fromCharCode(q),f++,S=R.Unknown}case C.minus:if(b+=String.fromCharCode(q),f++,f===l||!c(i.charCodeAt(f)))return S=R.Unknown;case C._0:case C._1:case C._2:case C._3:case C._4:case C._5:case C._6:case C._7:case C._8:case C._9:return b+=m(),S=R.NumericLiteral;default:for(;f<l&&T(q);)f++,q=i.charCodeAt(f);if(I!==f){switch(b=i.substring(I,f),b){case"true":return S=R.TrueKeyword;case"false":return S=R.FalseKeyword;case"null":return S=R.NullKeyword}return S=R.Unknown}return b+=String.fromCharCode(q),f++,S=R.Unknown}}function T(q){if(M(q)||$(q))return!1;switch(q){case C.closeBrace:case C.closeBracket:case C.openBrace:case C.openBracket:case C.doubleQuote:case C.colon:case C.comma:case C.slash:return!1}return!0}function G(){let q;do q=F();while(q>=R.LineCommentTrivia&&q<=R.Trivia);return q}return{setPosition:k,getPosition:()=>f,scan:g?G:F,getToken:()=>S,getTokenValue:()=>b,getTokenOffset:()=>I,getTokenLength:()=>f-I,getTokenError:()=>y}}function M(i){return i===C.space||i===C.tab||i===C.verticalTab||i===C.formFeed||i===C.nonBreakingSpace||i===C.ogham||i>=C.enQuad&&i<=C.zeroWidthSpace||i===C.narrowNoBreakSpace||i===C.mathematicalSpace||i===C.ideographicSpace||i===C.byteOrderMark}function $(i){return i===C.lineFeed||i===C.carriageReturn||i===C.lineSeparator||i===C.paragraphSeparator}function c(i){return i>=C._0&&i<=C._9}var C;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(C||(C={}));function v(i,g){const f=[],l=new Object;let b;const I={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function y(p,k,m,w){I.value=p,I.offset=k,I.length=m,I.type=w,I.colonOffset=void 0,b=I}try{t(i,{onObjectBegin:(p,k)=>{if(g<=p)throw l;b=void 0,S=g>p,f.push("")},onObjectProperty:(p,k,m)=>{if(g<k||(y(p,k,m,"property"),f[f.length-1]=p,g<=k+m))throw l},onObjectEnd:(p,k)=>{if(g<=p)throw l;b=void 0,f.pop()},onArrayBegin:(p,k)=>{if(g<=p)throw l;b=void 0,f.push(0)},onArrayEnd:(p,k)=>{if(g<=p)throw l;b=void 0,f.pop()},onLiteralValue:(p,k,m)=>{if(g<k||(y(p,k,m,n(p)),g<=k+m))throw l},onSeparator:(p,k,m)=>{if(g<=k)throw l;if(p===":"&&b&&b.type==="property")b.colonOffset=k,S=!1,b=void 0;else if(p===","){const w=f[f.length-1];typeof w=="number"?f[f.length-1]=w+1:(S=!0,f[f.length-1]=""),b=void 0}}})}catch(p){if(p!==l)throw p}return{path:f,previousNode:b,isAtPropertyKey:S,matches:p=>{let k=0;for(let m=0;k<p.length&&m<f.length;m++)if(p[k]===f[m]||p[k]==="*")k++;else if(p[k]!=="**")return!1;return k===p.length}}}function u(i,g=[],f=O.DEFAULT){let l=null,b=[];const I=[];function S(p){Array.isArray(b)?b.push(p):l!==null&&(b[l]=p)}return t(i,{onObjectBegin:()=>{const p={};S(p),I.push(b),b=p,l=null},onObjectProperty:p=>{l=p},onObjectEnd:()=>{b=I.pop()},onArrayBegin:()=>{const p=[];S(p),I.push(b),b=p,l=null},onArrayEnd:()=>{b=I.pop()},onLiteralValue:S,onError:(p,k,m)=>{g.push({error:p,offset:k,length:m})}},f),b[0]}function D(i,g=[],f=O.DEFAULT){let l={type:"array",offset:-1,length:-1,children:[],parent:void 0};function b(p){l.type==="property"&&(l.length=p-l.offset,l=l.parent)}function I(p){return l.children.push(p),p}t(i,{onObjectBegin:p=>{l=I({type:"object",offset:p,length:-1,parent:l,children:[]})},onObjectProperty:(p,k,m)=>{l=I({type:"property",offset:k,length:-1,parent:l,children:[]}),l.children.push({type:"string",value:p,offset:k,length:m,parent:l})},onObjectEnd:(p,k)=>{l.length=p+k-l.offset,l=l.parent,b(p+k)},onArrayBegin:(p,k)=>{l=I({type:"array",offset:p,length:-1,parent:l,children:[]})},onArrayEnd:(p,k)=>{l.length=p+k-l.offset,l=l.parent,b(p+k)},onLiteralValue:(p,k,m)=>{I({type:n(p),offset:k,length:m,parent:l,value:p}),b(k+m)},onSeparator:(p,k,m)=>{l.type==="property"&&(p===":"?l.colonOffset=k:p===","&&b(k))},onError:(p,k,m)=>{g.push({error:p,offset:k,length:m})}},f);const y=l.children[0];return y&&delete y.parent,y}function d(i,g){if(!i)return;let f=i;for(const l of g)if(typeof l=="string"){if(f.type!=="object"||!Array.isArray(f.children))return;let b=!1;for(const I of f.children)if(Array.isArray(I.children)&&I.children[0].value===l){f=I.children[1],b=!0;break}if(!b)return}else{const b=l;if(f.type!=="array"||b<0||!Array.isArray(f.children)||b>=f.children.length)return;f=f.children[b]}return f}function r(i){if(!i.parent||!i.parent.children)return[];const g=r(i.parent);if(i.parent.type==="property"){const f=i.parent.children[0].value;g.push(f)}else if(i.parent.type==="array"){const f=i.parent.children.indexOf(i);f!==-1&&g.push(f)}return g}function o(i){switch(i.type){case"array":return i.children.map(o);case"object":{const g=Object.create(null);for(const f of i.children){const l=f.children[1];l&&(g[f.children[0].value]=o(l))}return g}case"null":case"string":case"number":case"boolean":return i.value;default:return}}function a(i,g,f=!1){return g>=i.offset&&g<i.offset+i.length||f&&g===i.offset+i.length}function h(i,g,f=!1){if(a(i,g,f)){const l=i.children;if(Array.isArray(l))for(let b=0;b<l.length&&l[b].offset<=g;b++){const I=h(l[b],g,f);if(I)return I}return i}}function t(i,g,f=O.DEFAULT){const l=A(i,!1);function b($e){return $e?()=>$e(l.getTokenOffset(),l.getTokenLength()):()=>!0}function I($e){return $e?se=>$e(se,l.getTokenOffset(),l.getTokenLength()):()=>!0}const S=b(g.onObjectBegin),y=I(g.onObjectProperty),p=b(g.onObjectEnd),k=b(g.onArrayBegin),m=b(g.onArrayEnd),w=I(g.onLiteralValue),F=I(g.onSeparator),T=b(g.onComment),G=I(g.onError),q=f&&f.disallowComments,V=f&&f.allowTrailingComma;function N(){for(;;){const $e=l.scan();switch(l.getTokenError()){case E.InvalidUnicode:L(P.InvalidUnicode);break;case E.InvalidEscapeCharacter:L(P.InvalidEscapeCharacter);break;case E.UnexpectedEndOfNumber:L(P.UnexpectedEndOfNumber);break;case E.UnexpectedEndOfComment:q||L(P.UnexpectedEndOfComment);break;case E.UnexpectedEndOfString:L(P.UnexpectedEndOfString);break;case E.InvalidCharacter:L(P.InvalidCharacter);break}switch($e){case R.LineCommentTrivia:case R.BlockCommentTrivia:q?L(P.InvalidCommentToken):T();break;case R.Unknown:L(P.InvalidSymbol);break;case R.Trivia:case R.LineBreakTrivia:break;default:return $e}}}function L($e,se=[],Ce=[]){if(G($e),se.length+Ce.length>0){let Fe=l.getToken();for(;Fe!==R.EOF;){if(se.indexOf(Fe)!==-1){N();break}else if(Ce.indexOf(Fe)!==-1)break;Fe=N()}}}function Z($e){const se=l.getTokenValue();return $e?w(se):y(se),N(),!0}function re(){switch(l.getToken()){case R.NumericLiteral:{let $e=0;try{$e=JSON.parse(l.getTokenValue()),typeof $e!="number"&&(L(P.InvalidNumberFormat),$e=0)}catch{L(P.InvalidNumberFormat)}w($e);break}case R.NullKeyword:w(null);break;case R.TrueKeyword:w(!0);break;case R.FalseKeyword:w(!1);break;default:return!1}return N(),!0}function fe(){return l.getToken()!==R.StringLiteral?(L(P.PropertyNameExpected,[],[R.CloseBraceToken,R.CommaToken]),!1):(Z(!1),l.getToken()===R.ColonToken?(F(":"),N(),pe()||L(P.ValueExpected,[],[R.CloseBraceToken,R.CommaToken])):L(P.ColonExpected,[],[R.CloseBraceToken,R.CommaToken]),!0)}function be(){S(),N();let $e=!1;for(;l.getToken()!==R.CloseBraceToken&&l.getToken()!==R.EOF;){if(l.getToken()===R.CommaToken){if($e||L(P.ValueExpected,[],[]),F(","),N(),l.getToken()===R.CloseBraceToken&&V)break}else $e&&L(P.CommaExpected,[],[]);fe()||L(P.ValueExpected,[],[R.CloseBraceToken,R.CommaToken]),$e=!0}return p(),l.getToken()!==R.CloseBraceToken?L(P.CloseBraceExpected,[R.CloseBraceToken],[]):N(),!0}function oe(){k(),N();let $e=!1;for(;l.getToken()!==R.CloseBracketToken&&l.getToken()!==R.EOF;){if(l.getToken()===R.CommaToken){if($e||L(P.ValueExpected,[],[]),F(","),N(),l.getToken()===R.CloseBracketToken&&V)break}else $e&&L(P.CommaExpected,[],[]);pe()||L(P.ValueExpected,[],[R.CloseBracketToken,R.CommaToken]),$e=!0}return m(),l.getToken()!==R.CloseBracketToken?L(P.CloseBracketExpected,[R.CloseBracketToken],[]):N(),!0}function pe(){switch(l.getToken()){case R.OpenBracketToken:return oe();case R.OpenBraceToken:return be();case R.StringLiteral:return Z(!0);default:return re()}}return N(),l.getToken()===R.EOF?f.allowEmptyContent?!0:(L(P.ValueExpected,[],[]),!1):pe()?(l.getToken()!==R.EOF&&L(P.EndOfFileExpected,[],[]),!0):(L(P.ValueExpected,[],[]),!1)}function s(i,g){const f=A(i),l=[];let b,I=0,S;do switch(S=f.getPosition(),b=f.scan(),b){case R.LineCommentTrivia:case R.BlockCommentTrivia:case R.EOF:I!==S&&l.push(i.substring(I,S)),g!==void 0&&l.push(f.getTokenValue().replace(/[^\r\n]/g,g)),I=f.getPosition();break}while(b!==R.EOF);return l.join("")}function n(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}}),function(de,e){typeof define=="function"&&define.amd?define(ke[135],Ie([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(de=typeof globalThis<"u"?globalThis:de||self,e(de.marked={}))}(this,function(de){"use strict";function e(he,we){for(var ae=0;ae<we.length;ae++){var Y=we[ae];Y.enumerable=Y.enumerable||!1,Y.configurable=!0,"value"in Y&&(Y.writable=!0),Object.defineProperty(he,Y.key,Y)}}function E(he,we,ae){return we&&e(he.prototype,we),ae&&e(he,ae),Object.defineProperty(he,"prototype",{writable:!1}),he}function R(he,we){if(he){if(typeof he=="string")return P(he,we);var ae=Object.prototype.toString.call(he).slice(8,-1);if(ae==="Object"&&he.constructor&&(ae=he.constructor.name),ae==="Map"||ae==="Set")return Array.from(he);if(ae==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ae))return P(he,we)}}function P(he,we){(we==null||we>he.length)&&(we=he.length);for(var ae=0,Y=new Array(we);ae<we;ae++)Y[ae]=he[ae];return Y}function O(he,we){var ae=typeof Symbol<"u"&&he[Symbol.iterator]||he["@@iterator"];if(ae)return(ae=ae.call(he)).next.bind(ae);if(Array.isArray(he)||(ae=R(he))||we&&he&&typeof he.length=="number"){ae&&(he=ae);var Y=0;return function(){return Y>=he.length?{done:!0}:{done:!1,value:he[Y++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}de.defaults=A();function M(he){de.defaults=he}var $=/[&<>"']/,c=/[&<>"']/g,C=/[<>"']|&(?!#?\w+;)/,v=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},D=function(we){return u[we]};function d(he,we){if(we){if($.test(he))return he.replace(c,D)}else if(C.test(he))return he.replace(v,D);return he}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(he){return he.replace(r,function(we,ae){return ae=ae.toLowerCase(),ae==="colon"?":":ae.charAt(0)==="#"?ae.charAt(1)==="x"?String.fromCharCode(parseInt(ae.substring(2),16)):String.fromCharCode(+ae.substring(1)):""})}var a=/(^|[^\[])\^/g;function h(he,we){he=typeof he=="string"?he:he.source,we=we||"";var ae={replace:function(x,me){return me=me.source||me,me=me.replace(a,"$1"),he=he.replace(x,me),ae},getRegex:function(){return new RegExp(he,we)}};return ae}var t=/[^\w:]/g,s=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function n(he,we,ae){if(he){var Y;try{Y=decodeURIComponent(o(ae)).replace(t,"").toLowerCase()}catch{return null}if(Y.indexOf("javascript:")===0||Y.indexOf("vbscript:")===0||Y.indexOf("data:")===0)return null}we&&!s.test(ae)&&(ae=b(we,ae));try{ae=encodeURI(ae).replace(/%25/g,"%")}catch{return null}return ae}var i={},g=/^[^:]+:\/*[^/]*$/,f=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function b(he,we){i[" "+he]||(g.test(he)?i[" "+he]=he+"/":i[" "+he]=p(he,"/",!0)),he=i[" "+he];var ae=he.indexOf(":")===-1;return we.substring(0,2)==="//"?ae?we:he.replace(f,"$1")+we:we.charAt(0)==="/"?ae?we:he.replace(l,"$1")+we:he+we}var I={exec:function(){}};function S(he){for(var we=1,ae,Y;we<arguments.length;we++){ae=arguments[we];for(Y in ae)Object.prototype.hasOwnProperty.call(ae,Y)&&(he[Y]=ae[Y])}return he}function y(he,we){var ae=he.replace(/\|/g,function(me,ge,Te){for(var Be=!1,Ee=ge;--Ee>=0&&Te[Ee]==="\\";)Be=!Be;return Be?"|":" |"}),Y=ae.split(/ \|/),x=0;if(Y[0].trim()||Y.shift(),Y.length>0&&!Y[Y.length-1].trim()&&Y.pop(),Y.length>we)Y.splice(we);else for(;Y.length<we;)Y.push("");for(;x<Y.length;x++)Y[x]=Y[x].trim().replace(/\\\|/g,"|");return Y}function p(he,we,ae){var Y=he.length;if(Y===0)return"";for(var x=0;x<Y;){var me=he.charAt(Y-x-1);if(me===we&&!ae)x++;else if(me!==we&&ae)x++;else break}return he.slice(0,Y-x)}function k(he,we){if(he.indexOf(we[1])===-1)return-1;for(var ae=he.length,Y=0,x=0;x<ae;x++)if(he[x]==="\\")x++;else if(he[x]===we[0])Y++;else if(he[x]===we[1]&&(Y--,Y<0))return x;return-1}function m(he){he&&he.sanitize&&!he.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function w(he,we){if(we<1)return"";for(var ae="";we>1;)we&1&&(ae+=he),we>>=1,he+=he;return ae+he}function F(he,we,ae,Y){var x=we.href,me=we.title?d(we.title):null,ge=he[1].replace(/\\([\[\]])/g,"$1");if(he[0].charAt(0)!=="!"){Y.state.inLink=!0;var Te={type:"link",raw:ae,href:x,title:me,text:ge,tokens:Y.inlineTokens(ge)};return Y.state.inLink=!1,Te}return{type:"image",raw:ae,href:x,title:me,text:d(ge)}}function T(he,we){var ae=he.match(/^(\s+)(?:```)/);if(ae===null)return we;var Y=ae[1];return we.split(`
`).map(function(x){var me=x.match(/^\s+/);if(me===null)return x;var ge=me[0];return ge.length>=Y.length?x.slice(Y.length):x}).join(`
`)}var G=function(){function he(ae){this.options=ae||de.defaults}var we=he.prototype;return we.space=function(Y){var x=this.rules.block.newline.exec(Y);if(x&&x[0].length>0)return{type:"space",raw:x[0]}},we.code=function(Y){var x=this.rules.block.code.exec(Y);if(x){var me=x[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:x[0],codeBlockStyle:"indented",text:this.options.pedantic?me:p(me,`
`)}}},we.fences=function(Y){var x=this.rules.block.fences.exec(Y);if(x){var me=x[0],ge=T(me,x[3]||"");return{type:"code",raw:me,lang:x[2]?x[2].trim():x[2],text:ge}}},we.heading=function(Y){var x=this.rules.block.heading.exec(Y);if(x){var me=x[2].trim();if(/#$/.test(me)){var ge=p(me,"#");(this.options.pedantic||!ge||/ $/.test(ge))&&(me=ge.trim())}return{type:"heading",raw:x[0],depth:x[1].length,text:me,tokens:this.lexer.inline(me)}}},we.hr=function(Y){var x=this.rules.block.hr.exec(Y);if(x)return{type:"hr",raw:x[0]}},we.blockquote=function(Y){var x=this.rules.block.blockquote.exec(Y);if(x){var me=x[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:x[0],tokens:this.lexer.blockTokens(me,[]),text:me}}},we.list=function(Y){var x=this.rules.block.list.exec(Y);if(x){var me,ge,Te,Be,Ee,Re,Oe,j,z,K,J,te,le=x[1].trim(),Ae=le.length>1,je={type:"list",raw:"",ordered:Ae,start:Ae?+le.slice(0,-1):"",loose:!1,items:[]};le=Ae?"\\d{1,9}\\"+le.slice(-1):"\\"+le,this.options.pedantic&&(le=Ae?le:"[*+-]");for(var Ge=new RegExp("^( {0,3}"+le+")((?:[	 ][^\\n]*)?(?:\\n|$))");Y&&(te=!1,!(!(x=Ge.exec(Y))||this.rules.block.hr.test(Y)));){if(me=x[0],Y=Y.substring(me.length),j=x[2].split(`
`,1)[0],z=Y.split(`
`,1)[0],this.options.pedantic?(Be=2,J=j.trimLeft()):(Be=x[2].search(/[^ ]/),Be=Be>4?1:Be,J=j.slice(Be),Be+=x[1].length),Re=!1,!j&&/^ *$/.test(z)&&(me+=z+`
`,Y=Y.substring(z.length+1),te=!0),!te)for(var Ze=new RegExp("^ {0,"+Math.min(3,Be-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),tt=new RegExp("^ {0,"+Math.min(3,Be-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),_e=new RegExp("^ {0,"+Math.min(3,Be-1)+"}(?:```|~~~)"),it=new RegExp("^ {0,"+Math.min(3,Be-1)+"}#");Y&&(K=Y.split(`
`,1)[0],j=K,this.options.pedantic&&(j=j.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(_e.test(j)||it.test(j)||Ze.test(j)||tt.test(Y)));){if(j.search(/[^ ]/)>=Be||!j.trim())J+=`
`+j.slice(Be);else if(!Re)J+=`
`+j;else break;!Re&&!j.trim()&&(Re=!0),me+=K+`
`,Y=Y.substring(K.length+1)}je.loose||(Oe?je.loose=!0:/\n *\n *$/.test(me)&&(Oe=!0)),this.options.gfm&&(ge=/^\[[ xX]\] /.exec(J),ge&&(Te=ge[0]!=="[ ] ",J=J.replace(/^\[[ xX]\] +/,""))),je.items.push({type:"list_item",raw:me,task:!!ge,checked:Te,loose:!1,text:J}),je.raw+=me}je.items[je.items.length-1].raw=me.trimRight(),je.items[je.items.length-1].text=J.trimRight(),je.raw=je.raw.trimRight();var nt=je.items.length;for(Ee=0;Ee<nt;Ee++){this.lexer.state.top=!1,je.items[Ee].tokens=this.lexer.blockTokens(je.items[Ee].text,[]);var mt=je.items[Ee].tokens.filter(function(rt){return rt.type==="space"}),lt=mt.every(function(rt){for(var at=rt.raw.split(""),dt=0,We=O(at),ze;!(ze=We()).done;){var _=ze.value;if(_===`
`&&(dt+=1),dt>1)return!0}return!1});!je.loose&&mt.length&&lt&&(je.loose=!0,je.items[Ee].loose=!0)}return je}},we.html=function(Y){var x=this.rules.block.html.exec(Y);if(x){var me={type:"html",raw:x[0],pre:!this.options.sanitizer&&(x[1]==="pre"||x[1]==="script"||x[1]==="style"),text:x[0]};if(this.options.sanitize){var ge=this.options.sanitizer?this.options.sanitizer(x[0]):d(x[0]);me.type="paragraph",me.text=ge,me.tokens=this.lexer.inline(ge)}return me}},we.def=function(Y){var x=this.rules.block.def.exec(Y);if(x){x[3]&&(x[3]=x[3].substring(1,x[3].length-1));var me=x[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:me,raw:x[0],href:x[2],title:x[3]}}},we.table=function(Y){var x=this.rules.block.table.exec(Y);if(x){var me={type:"table",header:y(x[1]).map(function(Oe){return{text:Oe}}),align:x[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:x[3]&&x[3].trim()?x[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(me.header.length===me.align.length){me.raw=x[0];var ge=me.align.length,Te,Be,Ee,Re;for(Te=0;Te<ge;Te++)/^ *-+: *$/.test(me.align[Te])?me.align[Te]="right":/^ *:-+: *$/.test(me.align[Te])?me.align[Te]="center":/^ *:-+ *$/.test(me.align[Te])?me.align[Te]="left":me.align[Te]=null;for(ge=me.rows.length,Te=0;Te<ge;Te++)me.rows[Te]=y(me.rows[Te],me.header.length).map(function(Oe){return{text:Oe}});for(ge=me.header.length,Be=0;Be<ge;Be++)me.header[Be].tokens=this.lexer.inline(me.header[Be].text);for(ge=me.rows.length,Be=0;Be<ge;Be++)for(Re=me.rows[Be],Ee=0;Ee<Re.length;Ee++)Re[Ee].tokens=this.lexer.inline(Re[Ee].text);return me}}},we.lheading=function(Y){var x=this.rules.block.lheading.exec(Y);if(x)return{type:"heading",raw:x[0],depth:x[2].charAt(0)==="="?1:2,text:x[1],tokens:this.lexer.inline(x[1])}},we.paragraph=function(Y){var x=this.rules.block.paragraph.exec(Y);if(x){var me=x[1].charAt(x[1].length-1)===`
`?x[1].slice(0,-1):x[1];return{type:"paragraph",raw:x[0],text:me,tokens:this.lexer.inline(me)}}},we.text=function(Y){var x=this.rules.block.text.exec(Y);if(x)return{type:"text",raw:x[0],text:x[0],tokens:this.lexer.inline(x[0])}},we.escape=function(Y){var x=this.rules.inline.escape.exec(Y);if(x)return{type:"escape",raw:x[0],text:d(x[1])}},we.tag=function(Y){var x=this.rules.inline.tag.exec(Y);if(x)return!this.lexer.state.inLink&&/^<a /i.test(x[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(x[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(x[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(x[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:x[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(x[0]):d(x[0]):x[0]}},we.link=function(Y){var x=this.rules.inline.link.exec(Y);if(x){var me=x[2].trim();if(!this.options.pedantic&&/^</.test(me)){if(!/>$/.test(me))return;var ge=p(me.slice(0,-1),"\\");if((me.length-ge.length)%2===0)return}else{var Te=k(x[2],"()");if(Te>-1){var Be=x[0].indexOf("!")===0?5:4,Ee=Be+x[1].length+Te;x[2]=x[2].substring(0,Te),x[0]=x[0].substring(0,Ee).trim(),x[3]=""}}var Re=x[2],Oe="";if(this.options.pedantic){var j=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Re);j&&(Re=j[1],Oe=j[3])}else Oe=x[3]?x[3].slice(1,-1):"";return Re=Re.trim(),/^</.test(Re)&&(this.options.pedantic&&!/>$/.test(me)?Re=Re.slice(1):Re=Re.slice(1,-1)),F(x,{href:Re&&Re.replace(this.rules.inline._escapes,"$1"),title:Oe&&Oe.replace(this.rules.inline._escapes,"$1")},x[0],this.lexer)}},we.reflink=function(Y,x){var me;if((me=this.rules.inline.reflink.exec(Y))||(me=this.rules.inline.nolink.exec(Y))){var ge=(me[2]||me[1]).replace(/\s+/g," ");if(ge=x[ge.toLowerCase()],!ge||!ge.href){var Te=me[0].charAt(0);return{type:"text",raw:Te,text:Te}}return F(me,ge,me[0],this.lexer)}},we.emStrong=function(Y,x,me){me===void 0&&(me="");var ge=this.rules.inline.emStrong.lDelim.exec(Y);if(ge&&!(ge[3]&&me.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Te=ge[1]||ge[2]||"";if(!Te||Te&&(me===""||this.rules.inline.punctuation.exec(me))){var Be=ge[0].length-1,Ee,Re,Oe=Be,j=0,z=ge[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(z.lastIndex=0,x=x.slice(-1*Y.length+Be);(ge=z.exec(x))!=null;)if(Ee=ge[1]||ge[2]||ge[3]||ge[4]||ge[5]||ge[6],!!Ee){if(Re=Ee.length,ge[3]||ge[4]){Oe+=Re;continue}else if((ge[5]||ge[6])&&Be%3&&!((Be+Re)%3)){j+=Re;continue}if(Oe-=Re,!(Oe>0)){if(Re=Math.min(Re,Re+Oe+j),Math.min(Be,Re)%2){var K=Y.slice(1,Be+ge.index+Re);return{type:"em",raw:Y.slice(0,Be+ge.index+Re+1),text:K,tokens:this.lexer.inlineTokens(K)}}var J=Y.slice(2,Be+ge.index+Re-1);return{type:"strong",raw:Y.slice(0,Be+ge.index+Re+1),text:J,tokens:this.lexer.inlineTokens(J)}}}}}},we.codespan=function(Y){var x=this.rules.inline.code.exec(Y);if(x){var me=x[2].replace(/\n/g," "),ge=/[^ ]/.test(me),Te=/^ /.test(me)&&/ $/.test(me);return ge&&Te&&(me=me.substring(1,me.length-1)),me=d(me,!0),{type:"codespan",raw:x[0],text:me}}},we.br=function(Y){var x=this.rules.inline.br.exec(Y);if(x)return{type:"br",raw:x[0]}},we.del=function(Y){var x=this.rules.inline.del.exec(Y);if(x)return{type:"del",raw:x[0],text:x[2],tokens:this.lexer.inlineTokens(x[2])}},we.autolink=function(Y,x){var me=this.rules.inline.autolink.exec(Y);if(me){var ge,Te;return me[2]==="@"?(ge=d(this.options.mangle?x(me[1]):me[1]),Te="mailto:"+ge):(ge=d(me[1]),Te=ge),{type:"link",raw:me[0],text:ge,href:Te,tokens:[{type:"text",raw:ge,text:ge}]}}},we.url=function(Y,x){var me;if(me=this.rules.inline.url.exec(Y)){var ge,Te;if(me[2]==="@")ge=d(this.options.mangle?x(me[0]):me[0]),Te="mailto:"+ge;else{var Be;do Be=me[0],me[0]=this.rules.inline._backpedal.exec(me[0])[0];while(Be!==me[0]);ge=d(me[0]),me[1]==="www."?Te="http://"+ge:Te=ge}return{type:"link",raw:me[0],text:ge,href:Te,tokens:[{type:"text",raw:ge,text:ge}]}}},we.inlineText=function(Y,x){var me=this.rules.inline.text.exec(Y);if(me){var ge;return this.lexer.state.inRawBlock?ge=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(me[0]):d(me[0]):me[0]:ge=d(this.options.smartypants?x(me[0]):me[0]),{type:"text",raw:me[0],text:ge}}},he}(),q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:I,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=h(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.listItemStart=h(/^( *)(bull) */).replace("bull",q.bullet).getRegex(),q.list=h(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=h(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=h(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.blockquote=h(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=S({},q),q.gfm=S({},q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.table=h(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.gfm.paragraph=h(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",q.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.pedantic=S({},q.normal,{html:h(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:I,paragraph:h(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var V={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:I,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:I,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};V._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",V.punctuation=h(V.punctuation).replace(/punctuation/g,V._punctuation).getRegex(),V.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,V.escapedEmSt=/\\\*|\\_/g,V._comment=h(q._comment).replace("(?:-->|$)","-->").getRegex(),V.emStrong.lDelim=h(V.emStrong.lDelim).replace(/punct/g,V._punctuation).getRegex(),V.emStrong.rDelimAst=h(V.emStrong.rDelimAst,"g").replace(/punct/g,V._punctuation).getRegex(),V.emStrong.rDelimUnd=h(V.emStrong.rDelimUnd,"g").replace(/punct/g,V._punctuation).getRegex(),V._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,V._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,V._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,V.autolink=h(V.autolink).replace("scheme",V._scheme).replace("email",V._email).getRegex(),V._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,V.tag=h(V.tag).replace("comment",V._comment).replace("attribute",V._attribute).getRegex(),V._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,V._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,V._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,V.link=h(V.link).replace("label",V._label).replace("href",V._href).replace("title",V._title).getRegex(),V.reflink=h(V.reflink).replace("label",V._label).replace("ref",q._label).getRegex(),V.nolink=h(V.nolink).replace("ref",q._label).getRegex(),V.reflinkSearch=h(V.reflinkSearch,"g").replace("reflink",V.reflink).replace("nolink",V.nolink).getRegex(),V.normal=S({},V),V.pedantic=S({},V.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:h(/^!?\[(label)\]\((.*?)\)/).replace("label",V._label).getRegex(),reflink:h(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",V._label).getRegex()}),V.gfm=S({},V.normal,{escape:h(V.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),V.gfm.url=h(V.gfm.url,"i").replace("email",V.gfm._extended_email).getRegex(),V.breaks=S({},V.gfm,{br:h(V.br).replace("{2,}","*").getRegex(),text:h(V.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function N(he){return he.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function L(he){var we="",ae,Y,x=he.length;for(ae=0;ae<x;ae++)Y=he.charCodeAt(ae),Math.random()>.5&&(Y="x"+Y.toString(16)),we+="&#"+Y+";";return we}var Z=function(){function he(ae){this.tokens=[],this.tokens.links=Object.create(null),this.options=ae||de.defaults,this.options.tokenizer=this.options.tokenizer||new G,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Y={block:q.normal,inline:V.normal};this.options.pedantic?(Y.block=q.pedantic,Y.inline=V.pedantic):this.options.gfm&&(Y.block=q.gfm,this.options.breaks?Y.inline=V.breaks:Y.inline=V.gfm),this.tokenizer.rules=Y}he.lex=function(Y,x){var me=new he(x);return me.lex(Y)},he.lexInline=function(Y,x){var me=new he(x);return me.inlineTokens(Y)};var we=he.prototype;return we.lex=function(Y){Y=Y.replace(/\r\n|\r/g,`
`),this.blockTokens(Y,this.tokens);for(var x;x=this.inlineQueue.shift();)this.inlineTokens(x.src,x.tokens);return this.tokens},we.blockTokens=function(Y,x){var me=this;x===void 0&&(x=[]),this.options.pedantic?Y=Y.replace(/\t/g,"    ").replace(/^ +$/gm,""):Y=Y.replace(/^( *)(\t+)/gm,function(Oe,j,z){return j+"    ".repeat(z.length)});for(var ge,Te,Be,Ee;Y;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Oe){return(ge=Oe.call({lexer:me},Y,x))?(Y=Y.substring(ge.raw.length),x.push(ge),!0):!1}))){if(ge=this.tokenizer.space(Y)){Y=Y.substring(ge.raw.length),ge.raw.length===1&&x.length>0?x[x.length-1].raw+=`
`:x.push(ge);continue}if(ge=this.tokenizer.code(Y)){Y=Y.substring(ge.raw.length),Te=x[x.length-1],Te&&(Te.type==="paragraph"||Te.type==="text")?(Te.raw+=`
`+ge.raw,Te.text+=`
`+ge.text,this.inlineQueue[this.inlineQueue.length-1].src=Te.text):x.push(ge);continue}if(ge=this.tokenizer.fences(Y)){Y=Y.substring(ge.raw.length),x.push(ge);continue}if(ge=this.tokenizer.heading(Y)){Y=Y.substring(ge.raw.length),x.push(ge);continue}if(ge=this.tokenizer.hr(Y)){Y=Y.substring(ge.raw.length),x.push(ge);continue}if(ge=this.tokenizer.blockquote(Y)){Y=Y.substring(ge.raw.length),x.push(ge);continue}if(ge=this.tokenizer.list(Y)){Y=Y.substring(ge.raw.length),x.push(ge);continue}if(ge=this.tokenizer.html(Y)){Y=Y.substring(ge.raw.length),x.push(ge);continue}if(ge=this.tokenizer.def(Y)){Y=Y.substring(ge.raw.length),Te=x[x.length-1],Te&&(Te.type==="paragraph"||Te.type==="text")?(Te.raw+=`
`+ge.raw,Te.text+=`
`+ge.raw,this.inlineQueue[this.inlineQueue.length-1].src=Te.text):this.tokens.links[ge.tag]||(this.tokens.links[ge.tag]={href:ge.href,title:ge.title});continue}if(ge=this.tokenizer.table(Y)){Y=Y.substring(ge.raw.length),x.push(ge);continue}if(ge=this.tokenizer.lheading(Y)){Y=Y.substring(ge.raw.length),x.push(ge);continue}if(Be=Y,this.options.extensions&&this.options.extensions.startBlock&&function(){var Oe=1/0,j=Y.slice(1),z=void 0;me.options.extensions.startBlock.forEach(function(K){z=K.call({lexer:this},j),typeof z=="number"&&z>=0&&(Oe=Math.min(Oe,z))}),Oe<1/0&&Oe>=0&&(Be=Y.substring(0,Oe+1))}(),this.state.top&&(ge=this.tokenizer.paragraph(Be))){Te=x[x.length-1],Ee&&Te.type==="paragraph"?(Te.raw+=`
`+ge.raw,Te.text+=`
`+ge.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Te.text):x.push(ge),Ee=Be.length!==Y.length,Y=Y.substring(ge.raw.length);continue}if(ge=this.tokenizer.text(Y)){Y=Y.substring(ge.raw.length),Te=x[x.length-1],Te&&Te.type==="text"?(Te.raw+=`
`+ge.raw,Te.text+=`
`+ge.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Te.text):x.push(ge);continue}if(Y){var Re="Infinite loop on byte: "+Y.charCodeAt(0);if(this.options.silent){console.error(Re);break}else throw new Error(Re)}}return this.state.top=!0,x},we.inline=function(Y,x){return x===void 0&&(x=[]),this.inlineQueue.push({src:Y,tokens:x}),x},we.inlineTokens=function(Y,x){var me=this;x===void 0&&(x=[]);var ge,Te,Be,Ee=Y,Re,Oe,j;if(this.tokens.links){var z=Object.keys(this.tokens.links);if(z.length>0)for(;(Re=this.tokenizer.rules.inline.reflinkSearch.exec(Ee))!=null;)z.includes(Re[0].slice(Re[0].lastIndexOf("[")+1,-1))&&(Ee=Ee.slice(0,Re.index)+"["+w("a",Re[0].length-2)+"]"+Ee.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Re=this.tokenizer.rules.inline.blockSkip.exec(Ee))!=null;)Ee=Ee.slice(0,Re.index)+"["+w("a",Re[0].length-2)+"]"+Ee.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Re=this.tokenizer.rules.inline.escapedEmSt.exec(Ee))!=null;)Ee=Ee.slice(0,Re.index)+"++"+Ee.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Y;)if(Oe||(j=""),Oe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(J){return(ge=J.call({lexer:me},Y,x))?(Y=Y.substring(ge.raw.length),x.push(ge),!0):!1}))){if(ge=this.tokenizer.escape(Y)){Y=Y.substring(ge.raw.length),x.push(ge);continue}if(ge=this.tokenizer.tag(Y)){Y=Y.substring(ge.raw.length),Te=x[x.length-1],Te&&ge.type==="text"&&Te.type==="text"?(Te.raw+=ge.raw,Te.text+=ge.text):x.push(ge);continue}if(ge=this.tokenizer.link(Y)){Y=Y.substring(ge.raw.length),x.push(ge);continue}if(ge=this.tokenizer.reflink(Y,this.tokens.links)){Y=Y.substring(ge.raw.length),Te=x[x.length-1],Te&&ge.type==="text"&&Te.type==="text"?(Te.raw+=ge.raw,Te.text+=ge.text):x.push(ge);continue}if(ge=this.tokenizer.emStrong(Y,Ee,j)){Y=Y.substring(ge.raw.length),x.push(ge);continue}if(ge=this.tokenizer.codespan(Y)){Y=Y.substring(ge.raw.length),x.push(ge);continue}if(ge=this.tokenizer.br(Y)){Y=Y.substring(ge.raw.length),x.push(ge);continue}if(ge=this.tokenizer.del(Y)){Y=Y.substring(ge.raw.length),x.push(ge);continue}if(ge=this.tokenizer.autolink(Y,L)){Y=Y.substring(ge.raw.length),x.push(ge);continue}if(!this.state.inLink&&(ge=this.tokenizer.url(Y,L))){Y=Y.substring(ge.raw.length),x.push(ge);continue}if(Be=Y,this.options.extensions&&this.options.extensions.startInline&&function(){var J=1/0,te=Y.slice(1),le=void 0;me.options.extensions.startInline.forEach(function(Ae){le=Ae.call({lexer:this},te),typeof le=="number"&&le>=0&&(J=Math.min(J,le))}),J<1/0&&J>=0&&(Be=Y.substring(0,J+1))}(),ge=this.tokenizer.inlineText(Be,N)){Y=Y.substring(ge.raw.length),ge.raw.slice(-1)!=="_"&&(j=ge.raw.slice(-1)),Oe=!0,Te=x[x.length-1],Te&&Te.type==="text"?(Te.raw+=ge.raw,Te.text+=ge.text):x.push(ge);continue}if(Y){var K="Infinite loop on byte: "+Y.charCodeAt(0);if(this.options.silent){console.error(K);break}else throw new Error(K)}}return x},E(he,null,[{key:"rules",get:function(){return{block:q,inline:V}}}]),he}(),re=function(){function he(ae){this.options=ae||de.defaults}var we=he.prototype;return we.code=function(Y,x,me){var ge=(x||"").match(/\S*/)[0];if(this.options.highlight){var Te=this.options.highlight(Y,ge);Te!=null&&Te!==Y&&(me=!0,Y=Te)}return Y=Y.replace(/\n$/,"")+`
`,ge?'<pre><code class="'+this.options.langPrefix+d(ge,!0)+'">'+(me?Y:d(Y,!0))+`</code></pre>
`:"<pre><code>"+(me?Y:d(Y,!0))+`</code></pre>
`},we.blockquote=function(Y){return`<blockquote>
`+Y+`</blockquote>
`},we.html=function(Y){return Y},we.heading=function(Y,x,me,ge){if(this.options.headerIds){var Te=this.options.headerPrefix+ge.slug(me);return"<h"+x+' id="'+Te+'">'+Y+"</h"+x+`>
`}return"<h"+x+">"+Y+"</h"+x+`>
`},we.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},we.list=function(Y,x,me){var ge=x?"ol":"ul",Te=x&&me!==1?' start="'+me+'"':"";return"<"+ge+Te+`>
`+Y+"</"+ge+`>
`},we.listitem=function(Y){return"<li>"+Y+`</li>
`},we.checkbox=function(Y){return"<input "+(Y?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},we.paragraph=function(Y){return"<p>"+Y+`</p>
`},we.table=function(Y,x){return x&&(x="<tbody>"+x+"</tbody>"),`<table>
<thead>
`+Y+`</thead>
`+x+`</table>
`},we.tablerow=function(Y){return`<tr>
`+Y+`</tr>
`},we.tablecell=function(Y,x){var me=x.header?"th":"td",ge=x.align?"<"+me+' align="'+x.align+'">':"<"+me+">";return ge+Y+("</"+me+`>
`)},we.strong=function(Y){return"<strong>"+Y+"</strong>"},we.em=function(Y){return"<em>"+Y+"</em>"},we.codespan=function(Y){return"<code>"+Y+"</code>"},we.br=function(){return this.options.xhtml?"<br/>":"<br>"},we.del=function(Y){return"<del>"+Y+"</del>"},we.link=function(Y,x,me){if(Y=n(this.options.sanitize,this.options.baseUrl,Y),Y===null)return me;var ge='<a href="'+d(Y)+'"';return x&&(ge+=' title="'+x+'"'),ge+=">"+me+"</a>",ge},we.image=function(Y,x,me){if(Y=n(this.options.sanitize,this.options.baseUrl,Y),Y===null)return me;var ge='<img src="'+Y+'" alt="'+me+'"';return x&&(ge+=' title="'+x+'"'),ge+=this.options.xhtml?"/>":">",ge},we.text=function(Y){return Y},he}(),fe=function(){function he(){}var we=he.prototype;return we.strong=function(Y){return Y},we.em=function(Y){return Y},we.codespan=function(Y){return Y},we.del=function(Y){return Y},we.html=function(Y){return Y},we.text=function(Y){return Y},we.link=function(Y,x,me){return""+me},we.image=function(Y,x,me){return""+me},we.br=function(){return""},he}(),be=function(){function he(){this.seen={}}var we=he.prototype;return we.serialize=function(Y){return Y.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},we.getNextSafeSlug=function(Y,x){var me=Y,ge=0;if(this.seen.hasOwnProperty(me)){ge=this.seen[Y];do ge++,me=Y+"-"+ge;while(this.seen.hasOwnProperty(me))}return x||(this.seen[Y]=ge,this.seen[me]=0),me},we.slug=function(Y,x){x===void 0&&(x={});var me=this.serialize(Y);return this.getNextSafeSlug(me,x.dryrun)},he}(),oe=function(){function he(ae){this.options=ae||de.defaults,this.options.renderer=this.options.renderer||new re,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new fe,this.slugger=new be}he.parse=function(Y,x){var me=new he(x);return me.parse(Y)},he.parseInline=function(Y,x){var me=new he(x);return me.parseInline(Y)};var we=he.prototype;return we.parse=function(Y,x){x===void 0&&(x=!0);var me="",ge,Te,Be,Ee,Re,Oe,j,z,K,J,te,le,Ae,je,Ge,Ze,tt,_e,it,nt=Y.length;for(ge=0;ge<nt;ge++){if(J=Y[ge],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[J.type]&&(it=this.options.extensions.renderers[J.type].call({parser:this},J),it!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(J.type))){me+=it||"";continue}switch(J.type){case"space":continue;case"hr":{me+=this.renderer.hr();continue}case"heading":{me+=this.renderer.heading(this.parseInline(J.tokens),J.depth,o(this.parseInline(J.tokens,this.textRenderer)),this.slugger);continue}case"code":{me+=this.renderer.code(J.text,J.lang,J.escaped);continue}case"table":{for(z="",j="",Ee=J.header.length,Te=0;Te<Ee;Te++)j+=this.renderer.tablecell(this.parseInline(J.header[Te].tokens),{header:!0,align:J.align[Te]});for(z+=this.renderer.tablerow(j),K="",Ee=J.rows.length,Te=0;Te<Ee;Te++){for(Oe=J.rows[Te],j="",Re=Oe.length,Be=0;Be<Re;Be++)j+=this.renderer.tablecell(this.parseInline(Oe[Be].tokens),{header:!1,align:J.align[Be]});K+=this.renderer.tablerow(j)}me+=this.renderer.table(z,K);continue}case"blockquote":{K=this.parse(J.tokens),me+=this.renderer.blockquote(K);continue}case"list":{for(te=J.ordered,le=J.start,Ae=J.loose,Ee=J.items.length,K="",Te=0;Te<Ee;Te++)Ge=J.items[Te],Ze=Ge.checked,tt=Ge.task,je="",Ge.task&&(_e=this.renderer.checkbox(Ze),Ae?Ge.tokens.length>0&&Ge.tokens[0].type==="paragraph"?(Ge.tokens[0].text=_e+" "+Ge.tokens[0].text,Ge.tokens[0].tokens&&Ge.tokens[0].tokens.length>0&&Ge.tokens[0].tokens[0].type==="text"&&(Ge.tokens[0].tokens[0].text=_e+" "+Ge.tokens[0].tokens[0].text)):Ge.tokens.unshift({type:"text",text:_e}):je+=_e),je+=this.parse(Ge.tokens,Ae),K+=this.renderer.listitem(je,tt,Ze);me+=this.renderer.list(K,te,le);continue}case"html":{me+=this.renderer.html(J.text);continue}case"paragraph":{me+=this.renderer.paragraph(this.parseInline(J.tokens));continue}case"text":{for(K=J.tokens?this.parseInline(J.tokens):J.text;ge+1<nt&&Y[ge+1].type==="text";)J=Y[++ge],K+=`
`+(J.tokens?this.parseInline(J.tokens):J.text);me+=x?this.renderer.paragraph(K):K;continue}default:{var mt='Token with "'+J.type+'" type was not found.';if(this.options.silent){console.error(mt);return}else throw new Error(mt)}}}return me},we.parseInline=function(Y,x){x=x||this.renderer;var me="",ge,Te,Be,Ee=Y.length;for(ge=0;ge<Ee;ge++){if(Te=Y[ge],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Te.type]&&(Be=this.options.extensions.renderers[Te.type].call({parser:this},Te),Be!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Te.type))){me+=Be||"";continue}switch(Te.type){case"escape":{me+=x.text(Te.text);break}case"html":{me+=x.html(Te.text);break}case"link":{me+=x.link(Te.href,Te.title,this.parseInline(Te.tokens,x));break}case"image":{me+=x.image(Te.href,Te.title,Te.text);break}case"strong":{me+=x.strong(this.parseInline(Te.tokens,x));break}case"em":{me+=x.em(this.parseInline(Te.tokens,x));break}case"codespan":{me+=x.codespan(Te.text);break}case"br":{me+=x.br();break}case"del":{me+=x.del(this.parseInline(Te.tokens,x));break}case"text":{me+=x.text(Te.text);break}default:{var Re='Token with "'+Te.type+'" type was not found.';if(this.options.silent){console.error(Re);return}else throw new Error(Re)}}}return me},he}();function pe(he,we,ae){if(typeof he>"u"||he===null)throw new Error("marked(): input parameter is undefined or null");if(typeof he!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(he)+", string expected");if(typeof we=="function"&&(ae=we,we=null),we=S({},pe.defaults,we||{}),m(we),ae){var Y=we.highlight,x;try{x=Z.lex(he,we)}catch(Ee){return ae(Ee)}var me=function(Re){var Oe;if(!Re)try{we.walkTokens&&pe.walkTokens(x,we.walkTokens),Oe=oe.parse(x,we)}catch(j){Re=j}return we.highlight=Y,Re?ae(Re):ae(null,Oe)};if(!Y||Y.length<3||(delete we.highlight,!x.length))return me();var ge=0;pe.walkTokens(x,function(Ee){Ee.type==="code"&&(ge++,setTimeout(function(){Y(Ee.text,Ee.lang,function(Re,Oe){if(Re)return me(Re);Oe!=null&&Oe!==Ee.text&&(Ee.text=Oe,Ee.escaped=!0),ge--,ge===0&&me()})},0))}),ge===0&&me();return}function Te(Ee){if(Ee.message+=`
Please report this to https://github.com/markedjs/marked.`,we.silent)return"<p>An error occurred:</p><pre>"+d(Ee.message+"",!0)+"</pre>";throw Ee}try{var Be=Z.lex(he,we);if(we.walkTokens){if(we.async)return Promise.all(pe.walkTokens(Be,we.walkTokens)).then(function(){return oe.parse(Be,we)}).catch(Te);pe.walkTokens(Be,we.walkTokens)}return oe.parse(Be,we)}catch(Ee){Te(Ee)}}pe.options=pe.setOptions=function(he){return S(pe.defaults,he),M(pe.defaults),pe},pe.getDefaults=A,pe.defaults=de.defaults,pe.use=function(){for(var he=arguments.length,we=new Array(he),ae=0;ae<he;ae++)we[ae]=arguments[ae];var Y=S.apply(void 0,[{}].concat(we)),x=pe.defaults.extensions||{renderers:{},childTokens:{}},me;we.forEach(function(ge){if(ge.extensions&&(me=!0,ge.extensions.forEach(function(Be){if(!Be.name)throw new Error("extension name required");if(Be.renderer){var Ee=x.renderers?x.renderers[Be.name]:null;Ee?x.renderers[Be.name]=function(){for(var Re=arguments.length,Oe=new Array(Re),j=0;j<Re;j++)Oe[j]=arguments[j];var z=Be.renderer.apply(this,Oe);return z===!1&&(z=Ee.apply(this,Oe)),z}:x.renderers[Be.name]=Be.renderer}if(Be.tokenizer){if(!Be.level||Be.level!=="block"&&Be.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");x[Be.level]?x[Be.level].unshift(Be.tokenizer):x[Be.level]=[Be.tokenizer],Be.start&&(Be.level==="block"?x.startBlock?x.startBlock.push(Be.start):x.startBlock=[Be.start]:Be.level==="inline"&&(x.startInline?x.startInline.push(Be.start):x.startInline=[Be.start]))}Be.childTokens&&(x.childTokens[Be.name]=Be.childTokens)})),ge.renderer&&function(){var Be=pe.defaults.renderer||new re,Ee=function(j){var z=Be[j];Be[j]=function(){for(var K=arguments.length,J=new Array(K),te=0;te<K;te++)J[te]=arguments[te];var le=ge.renderer[j].apply(Be,J);return le===!1&&(le=z.apply(Be,J)),le}};for(var Re in ge.renderer)Ee(Re);Y.renderer=Be}(),ge.tokenizer&&function(){var Be=pe.defaults.tokenizer||new G,Ee=function(j){var z=Be[j];Be[j]=function(){for(var K=arguments.length,J=new Array(K),te=0;te<K;te++)J[te]=arguments[te];var le=ge.tokenizer[j].apply(Be,J);return le===!1&&(le=z.apply(Be,J)),le}};for(var Re in ge.tokenizer)Ee(Re);Y.tokenizer=Be}(),ge.walkTokens){var Te=pe.defaults.walkTokens;Y.walkTokens=function(Be){var Ee=[];return Ee.push(ge.walkTokens.call(this,Be)),Te&&(Ee=Ee.concat(Te.call(this,Be))),Ee}}me&&(Y.extensions=x),pe.setOptions(Y)})},pe.walkTokens=function(he,we){for(var ae=[],Y=function(){var Te=me.value;switch(ae=ae.concat(we.call(pe,Te)),Te.type){case"table":{for(var Be=O(Te.header),Ee;!(Ee=Be()).done;){var Re=Ee.value;ae=ae.concat(pe.walkTokens(Re.tokens,we))}for(var Oe=O(Te.rows),j;!(j=Oe()).done;)for(var z=j.value,K=O(z),J;!(J=K()).done;){var te=J.value;ae=ae.concat(pe.walkTokens(te.tokens,we))}break}case"list":{ae=ae.concat(pe.walkTokens(Te.items,we));break}default:pe.defaults.extensions&&pe.defaults.extensions.childTokens&&pe.defaults.extensions.childTokens[Te.type]?pe.defaults.extensions.childTokens[Te.type].forEach(function(le){ae=ae.concat(pe.walkTokens(Te[le],we))}):Te.tokens&&(ae=ae.concat(pe.walkTokens(Te.tokens,we)))}},x=O(he),me;!(me=x()).done;)Y();return ae},pe.parseInline=function(he,we){if(typeof he>"u"||he===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof he!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(he)+", string expected");we=S({},pe.defaults,we||{}),m(we);try{var ae=Z.lexInline(he,we);return we.walkTokens&&pe.walkTokens(ae,we.walkTokens),oe.parseInline(ae,we)}catch(Y){if(Y.message+=`
Please report this to https://github.com/markedjs/marked.`,we.silent)return"<p>An error occurred:</p><pre>"+d(Y.message+"",!0)+"</pre>";throw Y}},pe.Parser=oe,pe.parser=oe.parse,pe.Renderer=re,pe.TextRenderer=fe,pe.Lexer=Z,pe.lexer=Z.lex,pe.Tokenizer=G,pe.Slugger=be,pe.parse=pe;var $e=pe.options,se=pe.setOptions,Ce=pe.use,Fe=pe.walkTokens,X=pe.parseInline,W=pe,ie=oe.parse,Se=Z.lex;de.Lexer=Z,de.Parser=oe,de.Renderer=re,de.Slugger=be,de.TextRenderer=fe,de.Tokenizer=G,de.getDefaults=A,de.lexer=Se,de.marked=pe,de.options=$e,de.parse=W,de.parseInline=X,de.parser=ie,de.setOptions=se,de.use=Ce,de.walkTokens=Fe,Object.defineProperty(de,"__esModule",{value:!0})}),define(ke[136],Ie([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zk=E;function E(r){const o=O(r);if(o&&o.length>0)return new Uint32Array(o)}let R=0;const P=new Uint32Array(10);function O(r){if(R=0,A(r,v,$.InitialConsonant),R>0||(A(r,u,$.Vowel),R>0)||(A(r,D,$.FinalConsonant),R>0)||(A(r,d,$.CompatibilityJamo),R))return P.subarray(0,R);if(r>=44032&&r<=55203){const o=r-44032,a=o%588,h=Math.floor(o/588),t=Math.floor(a/28),s=a%28-1;if(h<v.length?A(h,v,0):$.InitialConsonant+h-$.CompatibilityJamo<d.length&&A($.InitialConsonant+h,d,$.CompatibilityJamo),t<u.length?A(t,u,0):$.Vowel+t-$.CompatibilityJamo<d.length&&A($.Vowel+t-$.CompatibilityJamo,d,$.CompatibilityJamo),s>=0&&(s<D.length?A(s,D,0):$.FinalConsonant+s-$.CompatibilityJamo<d.length&&A($.FinalConsonant+s-$.CompatibilityJamo,d,$.CompatibilityJamo)),R>0)return P.subarray(0,R)}}function A(r,o,a){r>=a&&r<a+o.length&&M(o[r-a])}function M(r){r!==c.NUL&&(P[R++]=r&255,r>>8&&(P[R++]=r>>8&255),r>>16&&(P[R++]=r>>16&255))}var $;(function(r){r[r.InitialConsonant=4352]="InitialConsonant",r[r.Vowel=4449]="Vowel",r[r.FinalConsonant=4520]="FinalConsonant",r[r.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var c;(function(r){r[r.NUL=0]="NUL",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z"})(c||(c={}));var C;(function(r){r[r.fa=24934]="fa",r[r.fg=26470]="fg",r[r.fq=29030]="fq",r[r.fr=29286]="fr",r[r.ft=29798]="ft",r[r.fv=30310]="fv",r[r.fx=30822]="fx",r[r.hk=27496]="hk",r[r.hl=27752]="hl",r[r.ho=28520]="ho",r[r.ml=27757]="ml",r[r.nj=27246]="nj",r[r.nl=27758]="nl",r[r.np=28782]="np",r[r.qt=29809]="qt",r[r.rt=29810]="rt",r[r.sg=26483]="sg",r[r.sw=30579]="sw"})(C||(C={}));const v=new Uint8Array([c.r,c.R,c.s,c.e,c.E,c.f,c.a,c.q,c.Q,c.t,c.T,c.d,c.w,c.W,c.c,c.z,c.x,c.v,c.g]),u=new Uint16Array([c.k,c.o,c.i,c.O,c.j,c.p,c.u,c.P,c.h,C.hk,C.ho,C.hl,c.y,c.n,C.nj,C.np,C.nl,c.b,c.m,C.ml,c.l]),D=new Uint16Array([c.r,c.R,C.rt,c.s,C.sw,C.sg,c.e,c.f,C.fr,C.fa,C.fq,C.ft,C.fx,C.fv,C.fg,c.a,c.q,C.qt,c.t,c.T,c.d,c.w,c.c,c.z,c.x,c.v,c.g]),d=new Uint16Array([c.r,c.R,C.rt,c.s,C.sw,C.sg,c.e,c.E,c.f,C.fr,C.fa,C.fq,C.ft,C.fx,C.fv,C.fg,c.a,c.q,c.Q,C.qt,c.t,c.T,c.d,c.w,c.W,c.c,c.z,c.x,c.v,c.g,c.k,c.o,c.i,c.O,c.j,c.p,c.u,c.P,c.h,C.hk,C.ho,C.hl,c.y,c.n,C.nj,C.np,C.nl,c.b,c.m,C.ml,c.l])}),define(ke[137],Ie([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Km=e.$Jm=e.$Im=void 0,e.$Gm=E,e.rot=R;function E(M,$,c){return Math.min(Math.max(M,$),c)}function R(M,$){return($+M%$)%$}class P{constructor(){this.a=0}getNext(){return this.a++}}e.$Im=P;class O{constructor(){this.a=1,this.b=0}update($){return this.b=this.b+($-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Jm=O;class A{constructor($){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array($),this.c.fill(0,0,$)}update($){const c=this.c[this.d];return this.c[this.d]=$,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=$,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Km=A}),define(ke[138],Ie([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=void 0,e.$bd=O,e.$cd=u;class E{constructor(d,r,o){this.owner=d,this.debugNameSource=r,this.referenceFn=o}getDebugName(d){return O(d,this)}}e.$ad=E;const R=new Map,P=new WeakMap;function O(D,d){const r=P.get(D);if(r)return r;const o=A(D,d);if(o){let a=R.get(o)??0;a++,R.set(o,a);const h=a===1?o:`${o}#${a}`;return P.set(D,h),h}}function A(D,d){const r=P.get(D);if(r)return r;const o=d.owner?C(d.owner)+".":"";let a;const h=d.debugNameSource;if(h!==void 0)if(typeof h=="function"){if(a=h(),a!==void 0)return o+a}else return o+h;const t=d.referenceFn;if(t!==void 0&&(a=u(t),a!==void 0))return o+a;if(d.owner!==void 0){const s=M(d.owner,D);if(s!==void 0)return o+s}}function M(D,d){for(const r in D)if(D[r]===d)return r}const $=new Map,c=new WeakMap;function C(D){const d=c.get(D);if(d)return d;const r=v(D);let o=$.get(r)??0;o++,$.set(r,o);const a=o===1?r:`${r}#${o}`;return c.set(D,a),a}function v(D){const d=D.constructor;return d?d.name:"Object"}function u(D){const d=D.toString(),o=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(d);return(o?o[1]:void 0)?.trim()}}),define(ke[139],Ie([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0,e.$Hd=R,e.$Id=P;let E;function R(r){E=r}function P(){return E}class O{constructor(){this.a=0,this.d=new WeakMap}b(o){return A([M(D("|  ",this.a)),o])}c(o){return o.hadValue?o.didChange?[M(" "),c(C(o.oldValue,70),{color:"red",strikeThrough:!0}),M(" "),c(C(o.newValue,60),{color:"green"})]:[M(" (unchanged)")]:[M(" "),c(C(o.newValue,60),{color:"green"}),M(" (initial)")]}handleObservableChanged(o,a){console.log(...this.b([$("observable value changed"),c(o.debugName,{color:"BlueViolet"}),...this.c(a)]))}formatChanges(o){if(o.size!==0)return c(" (changed deps: "+[...o].map(a=>a.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(o){const a=o.handleChange;this.d.set(o,new Set),o.handleChange=(h,t)=>(this.d.get(o).add(h),a.apply(o,[h,t]))}handleDerivedRecomputed(o,a){const h=this.d.get(o);console.log(...this.b([$("derived recomputed"),c(o.debugName,{color:"BlueViolet"}),...this.c(a),this.formatChanges(h),{data:[{fn:o._computeFn}]}])),h.clear()}handleFromEventObservableTriggered(o,a){console.log(...this.b([$("observable from event triggered"),c(o.debugName,{color:"BlueViolet"}),...this.c(a),{data:[{fn:o._getValue}]}]))}handleAutorunCreated(o){const a=o.handleChange;this.d.set(o,new Set),o.handleChange=(h,t)=>(this.d.get(o).add(h),a.apply(o,[h,t]))}handleAutorunTriggered(o){const a=this.d.get(o);console.log(...this.b([$("autorun"),c(o.debugName,{color:"BlueViolet"}),this.formatChanges(a),{data:[{fn:o._runFn}]}])),a.clear(),this.a++}handleAutorunFinished(o){this.a--}handleBeginTransaction(o){let a=o.getDebugName();a===void 0&&(a=""),console.log(...this.b([$("transaction"),c(a,{color:"BlueViolet"}),{data:[{fn:o._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Jd=O;function A(r){const o=new Array,a=[];let h="";function t(n){if("length"in n)for(const i of n)i&&t(i);else"text"in n?(h+=`%c${n.text}`,o.push(n.style),n.data&&a.push(...n.data)):"data"in n&&a.push(...n.data)}t(r);const s=[h,...o];return s.push(...a),s}function M(r){return c(r,{color:"black"})}function $(r){return c(d(`${r}: `,10),{color:"black",bold:!0})}function c(r,o={color:"black"}){function a(t){return Object.entries(t).reduce((s,[n,i])=>`${s}${n}:${i};`,"")}const h={color:o.color};return o.strikeThrough&&(h["text-decoration"]="line-through"),o.bold&&(h["font-weight"]="bold"),{text:r,style:a(h)}}function C(r,o){switch(typeof r){case"number":return""+r;case"string":return r.length+2<=o?`"${r}"`:`"${r.substr(0,o-7)}"+...`;case"boolean":return r?"true":"false";case"undefined":return"undefined";case"object":return r===null?"null":Array.isArray(r)?v(r,o):u(r,o);case"symbol":return r.toString();case"function":return`[[Function${r.name?" "+r.name:""}]]`;default:return""+r}}function v(r,o){let a="[ ",h=!0;for(const t of r){if(h||(a+=", "),a.length-5>o){a+="...";break}h=!1,a+=`${C(t,o-a.length)}`}return a+=" ]",a}function u(r,o){let a="{ ",h=!0;for(const[t,s]of Object.entries(r)){if(h||(a+=", "),a.length-5>o){a+="...";break}h=!1,a+=`${t}: ${C(s,o-a.length)}`}return a+=" }",a}function D(r,o){let a="";for(let h=1;h<=o;h++)a+=r;return a}function d(r,o){for(;r.length<o;)r+=" ";return r}}),define(ke[140],Ie([1,0,133,138,139]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7d=e.$5d=e.$2d=e.$Wd=e.$Vd=void 0,e.$Sd=A,e.$Td=$,e.$Ud=C,e.$Xd=D,e.$Yd=r,e.$Zd=o,e.$1d=a,e.$3d=t,e.$4d=s,e.$6d=i;let O;function A(f){O=f}let M;function $(f){M=f}let c;function C(f){c=f}class v{get TChange(){return null}reportChanges(){this.get()}read(l){return l?l.readObservable(this):this.get()}map(l,b){const I=b===void 0?void 0:l,S=b===void 0?l:b;return c({owner:I,debugName:()=>{const y=(0,R.$cd)(S);if(y!==void 0)return y;const k=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(S.toString());if(k)return`${this.debugName}.${k[2]}`;if(!I)return`${this.debugName} (mapped)`},debugReferenceFn:S},y=>S(this.read(y),y))}recomputeInitiallyAndOnChange(l,b){return l.add(O(this,b)),this}keepObserved(l){return l.add(M(this)),this}get a(){return this.get()}}e.$Vd=v;class u extends v{constructor(){super(...arguments),this.b=new Set}addObserver(l){const b=this.b.size;this.b.add(l),b===0&&this.c()}removeObserver(l){this.b.delete(l)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Wd=u;function D(f,l){const b=new h(f,l);try{f(b)}finally{b.finish()}}let d;function r(f){if(d)f(d);else{const l=new h(f,void 0);d=l;try{f(l)}finally{l.finish(),d=void 0}}}async function o(f,l){const b=new h(f,l);try{await f(b)}finally{b.finish()}}function a(f,l,b){f?l(f):D(l,b)}class h{constructor(l,b){this._fn=l,this.b=b,this.a=[],(0,P.$Id)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,R.$cd)(this._fn)}updateObserver(l,b){this.a.push({observer:l,observable:b}),l.beginUpdate(b)}finish(){const l=this.a;for(let b=0;b<l.length;b++){const{observer:I,observable:S}=l[b];I.endUpdate(S)}this.a=null,(0,P.$Id)()?.handleEndTransaction()}}e.$2d=h;function t(f,l){let b;return typeof f=="string"?b=new R.$ad(void 0,f,void 0):b=new R.$ad(f,void 0,void 0),new n(b,l,E.$6c)}function s(f,l){return new n(new R.$ad(f.owner,f.debugName,void 0),l,f.equalsFn??E.$6c)}class n extends u{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(l,b,I){super(),this.e=l,this.g=I,this.d=b}get(){return this.d}set(l,b,I){if(I===void 0&&this.g(this.d,l))return;let S;b||(b=S=new h(()=>{},()=>`Setting ${this.debugName}`));try{const y=this.d;this.h(l),(0,P.$Id)()?.handleObservableChanged(this,{oldValue:y,newValue:l,change:I,didChange:!0,hadValue:!0});for(const p of this.b)b.updateObserver(p,this),p.handleChange(this,I)}finally{S&&S.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(l){this.d=l}}e.$5d=n;function i(f,l){let b;return typeof f=="string"?b=new R.$ad(void 0,f,void 0):b=new R.$ad(f,void 0,void 0),new g(b,l,E.$6c)}class g extends n{h(l){this.d!==l&&(this.d&&this.d.dispose(),this.d=l)}dispose(){this.d?.dispose()}}e.$7d=g}),function(){function de(P){const O=[];typeof P=="number"&&O.push("code/timeOrigin",P);function A($){O.push($,Date.now())}function M(){const $=[];for(let c=0;c<O.length;c+=2)$.push({name:O[c],startTime:O[c+1]});return $}return{mark:A,getMarks:M}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?de():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const A of performance.getEntriesByType("mark"))O.push({name:A.name,startTime:Math.round(P+A.startTime)});return O}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return de(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),de()}function E(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=E(R))}(),define(ke[141],Ie([1,0,40]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NO=void 0;const R=Symbol("unset");class P{constructor(){this.a=new A,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||E.Iterable.empty()}insert($,c,C){this.d($,v=>v._value=c,C)}mutate($,c){this.d($,C=>C._value=c(C._value===R?void 0:C._value))}mutatePath($,c){this.d($,()=>{},C=>c(C))}delete($){const c=this.c($);if(!c)return;let C=c.length-1;const v=c[C].node._value;if(v!==R){for(this.b--,c[C].node._value=R;C>0;C--){const{node:u,part:D}=c[C];if(u.children?.size||u._value!==R)break;c[C-1].node.children.delete(D)}return v}}*deleteRecursive($){const c=this.c($);if(!c)return;const C=c[c.length-1].node;for(let v=c.length-1;v>0;v--){const u=c[v-1];if(u.node.children.delete(c[v].part),u.node.children.size>0||u.node._value!==R)break}for(const v of O(C))v._value!==R&&(this.b--,yield v._value)}find($){let c=this.a;for(const C of $){const v=c.children?.get(C);if(!v)return;c=v}return c._value===R?void 0:c._value}hasKeyOrParent($){let c=this.a;for(const C of $){const v=c.children?.get(C);if(!v)return!1;if(v._value!==R)return!0;c=v}return!1}hasKeyOrChildren($){let c=this.a;for(const C of $){const v=c.children?.get(C);if(!v)return!1;c=v}return!0}hasKey($){let c=this.a;for(const C of $){const v=c.children?.get(C);if(!v)return!1;c=v}return c._value!==R}c($){const c=[{part:"",node:this.a}];let C=0;for(const v of $){const u=c[C].node.children?.get(v);if(!u)return;c.push({part:v,node:u}),C++}return c}d($,c,C){let v=this.a;for(const d of $){if(v.children)if(v.children.has(d))v=v.children.get(d);else{const r=new A;v.children.set(d,r),v=r}else{const r=new A;v.children=new Map([[d,r]]),v=r}C?.(v)}const u=v._value===R?0:1;c(v);const D=v._value===R?0:1;this.b+=D-u}*values(){for(const{_value:$}of O(this.a))$!==R&&(yield $)}}e.$NO=P;function*O(M){const $=[M];for(;$.length>0;){const c=$.pop();if(yield c,c.children)for(const C of c.children.values())$.push(C)}}class A{constructor(){this._value=R}get value(){return this._value===R?void 0:this._value}set value($){this._value=$===void 0?R:$}}}),function(de,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var R in E)(typeof exports=="object"?exports:de)[R]=E[R]}}(typeof self<"u"?self:this,function(){return function(de){var e={};function E(R){if(e[R])return e[R].exports;var P=e[R]={i:R,l:!1,exports:{}};return de[R].call(P.exports,P,P.exports,E),P.l=!0,P.exports}return E.m=de,E.c=e,E.d=function(R,P,O){E.o(R,P)||Object.defineProperty(R,P,{enumerable:!0,get:O})},E.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},E.t=function(R,P){if(1&P&&(R=E(R)),8&P||4&P&&typeof R=="object"&&R&&R.__esModule)return R;var O=Object.create(null);if(E.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:R}),2&P&&typeof R!="string")for(var A in R)E.d(O,A,function(M){return R[M]}.bind(null,A));return O},E.n=function(R){var P=R&&R.__esModule?function(){return R.default}:function(){return R};return E.d(P,"a",P),P},E.o=function(R,P){return Object.prototype.hasOwnProperty.call(R,P)},E.p="",E(E.s=0)}([function(de,e,E){(function(R){var P;e=de.exports=Ce,P=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,M=e.re=[],$=e.src=[],c=0,C=c++;$[C]="0|[1-9]\\d*";var v=c++;$[v]="[0-9]+";var u=c++;$[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var D=c++;$[D]="("+$[C]+")\\.("+$[C]+")\\.("+$[C]+")";var d=c++;$[d]="("+$[v]+")\\.("+$[v]+")\\.("+$[v]+")";var r=c++;$[r]="(?:"+$[C]+"|"+$[u]+")";var o=c++;$[o]="(?:"+$[v]+"|"+$[u]+")";var a=c++;$[a]="(?:-("+$[r]+"(?:\\."+$[r]+")*))";var h=c++;$[h]="(?:-?("+$[o]+"(?:\\."+$[o]+")*))";var t=c++;$[t]="[0-9A-Za-z-]+";var s=c++;$[s]="(?:\\+("+$[t]+"(?:\\."+$[t]+")*))";var n=c++,i="v?"+$[D]+$[a]+"?"+$[s]+"?";$[n]="^"+i+"$";var g="[v=\\s]*"+$[d]+$[h]+"?"+$[s]+"?",f=c++;$[f]="^"+g+"$";var l=c++;$[l]="((?:<|>)?=?)";var b=c++;$[b]=$[v]+"|x|X|\\*";var I=c++;$[I]=$[C]+"|x|X|\\*";var S=c++;$[S]="[v=\\s]*("+$[I]+")(?:\\.("+$[I]+")(?:\\.("+$[I]+")(?:"+$[a]+")?"+$[s]+"?)?)?";var y=c++;$[y]="[v=\\s]*("+$[b]+")(?:\\.("+$[b]+")(?:\\.("+$[b]+")(?:"+$[h]+")?"+$[s]+"?)?)?";var p=c++;$[p]="^"+$[l]+"\\s*"+$[S]+"$";var k=c++;$[k]="^"+$[l]+"\\s*"+$[y]+"$";var m=c++;$[m]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var w=c++;$[w]="(?:~>?)";var F=c++;$[F]="(\\s*)"+$[w]+"\\s+",M[F]=new RegExp($[F],"g");var T=c++;$[T]="^"+$[w]+$[S]+"$";var G=c++;$[G]="^"+$[w]+$[y]+"$";var q=c++;$[q]="(?:\\^)";var V=c++;$[V]="(\\s*)"+$[q]+"\\s+",M[V]=new RegExp($[V],"g");var N=c++;$[N]="^"+$[q]+$[S]+"$";var L=c++;$[L]="^"+$[q]+$[y]+"$";var Z=c++;$[Z]="^"+$[l]+"\\s*("+g+")$|^$";var re=c++;$[re]="^"+$[l]+"\\s*("+i+")$|^$";var fe=c++;$[fe]="(\\s*)"+$[l]+"\\s*("+g+"|"+$[S]+")",M[fe]=new RegExp($[fe],"g");var be=c++;$[be]="^\\s*("+$[S]+")\\s+-\\s+("+$[S]+")\\s*$";var oe=c++;$[oe]="^\\s*("+$[y]+")\\s+-\\s+("+$[y]+")\\s*$";var pe=c++;$[pe]="(<|>)?=?\\s*\\*";for(var $e=0;$e<35;$e++)P($e,$[$e]),M[$e]||(M[$e]=new RegExp($[$e]));function se(z,K){if(z instanceof Ce)return z;if(typeof z!="string"||z.length>O||!(K?M[f]:M[n]).test(z))return null;try{return new Ce(z,K)}catch{return null}}function Ce(z,K){if(z instanceof Ce){if(z.loose===K)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof Ce))return new Ce(z,K);P("SemVer",z,K),this.loose=K;var J=z.trim().match(K?M[f]:M[n]);if(!J)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+J[1],this.minor=+J[2],this.patch=+J[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");J[4]?this.prerelease=J[4].split(".").map(function(te){if(/^[0-9]+$/.test(te)){var le=+te;if(le>=0&&le<A)return le}return te}):this.prerelease=[],this.build=J[5]?J[5].split("."):[],this.format()}e.parse=se,e.valid=function(z,K){var J=se(z,K);return J?J.version:null},e.clean=function(z,K){var J=se(z.trim().replace(/^[=v]+/,""),K);return J?J.version:null},e.SemVer=Ce,Ce.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Ce.prototype.toString=function(){return this.version},Ce.prototype.compare=function(z){return P("SemVer.compare",this.version,this.loose,z),z instanceof Ce||(z=new Ce(z,this.loose)),this.compareMain(z)||this.comparePre(z)},Ce.prototype.compareMain=function(z){return z instanceof Ce||(z=new Ce(z,this.loose)),X(this.major,z.major)||X(this.minor,z.minor)||X(this.patch,z.patch)},Ce.prototype.comparePre=function(z){if(z instanceof Ce||(z=new Ce(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var K=0;do{var J=this.prerelease[K],te=z.prerelease[K];if(P("prerelease compare",K,J,te),J===void 0&&te===void 0)return 0;if(te===void 0)return 1;if(J===void 0)return-1;if(J!==te)return X(J,te)}while(++K)},Ce.prototype.inc=function(z,K){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",K);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",K);break;case"prepatch":this.prerelease.length=0,this.inc("patch",K),this.inc("pre",K);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",K),this.inc("pre",K);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var J=this.prerelease.length;--J>=0;)typeof this.prerelease[J]=="number"&&(this.prerelease[J]++,J=-2);J===-1&&this.prerelease.push(0)}K&&(this.prerelease[0]===K?isNaN(this.prerelease[1])&&(this.prerelease=[K,0]):this.prerelease=[K,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},e.inc=function(z,K,J,te){typeof J=="string"&&(te=J,J=void 0);try{return new Ce(z,J).inc(K,te).version}catch{return null}},e.diff=function(z,K){if(he(z,K))return null;var J=se(z),te=se(K);if(J.prerelease.length||te.prerelease.length){for(var le in J)if((le==="major"||le==="minor"||le==="patch")&&J[le]!==te[le])return"pre"+le;return"prerelease"}for(var le in J)if((le==="major"||le==="minor"||le==="patch")&&J[le]!==te[le])return le},e.compareIdentifiers=X;var Fe=/^[0-9]+$/;function X(z,K){var J=Fe.test(z),te=Fe.test(K);return J&&te&&(z=+z,K=+K),J&&!te?-1:te&&!J?1:z<K?-1:z>K?1:0}function W(z,K,J){return new Ce(z,J).compare(new Ce(K,J))}function ie(z,K,J){return W(z,K,J)>0}function Se(z,K,J){return W(z,K,J)<0}function he(z,K,J){return W(z,K,J)===0}function we(z,K,J){return W(z,K,J)!==0}function ae(z,K,J){return W(z,K,J)>=0}function Y(z,K,J){return W(z,K,J)<=0}function x(z,K,J,te){var le;switch(K){case"===":typeof z=="object"&&(z=z.version),typeof J=="object"&&(J=J.version),le=z===J;break;case"!==":typeof z=="object"&&(z=z.version),typeof J=="object"&&(J=J.version),le=z!==J;break;case"":case"=":case"==":le=he(z,J,te);break;case"!=":le=we(z,J,te);break;case">":le=ie(z,J,te);break;case">=":le=ae(z,J,te);break;case"<":le=Se(z,J,te);break;case"<=":le=Y(z,J,te);break;default:throw new TypeError("Invalid operator: "+K)}return le}function me(z,K){if(z instanceof me){if(z.loose===K)return z;z=z.value}if(!(this instanceof me))return new me(z,K);P("comparator",z,K),this.loose=K,this.parse(z),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(z,K){return X(K,z)},e.major=function(z,K){return new Ce(z,K).major},e.minor=function(z,K){return new Ce(z,K).minor},e.patch=function(z,K){return new Ce(z,K).patch},e.compare=W,e.compareLoose=function(z,K){return W(z,K,!0)},e.rcompare=function(z,K,J){return W(K,z,J)},e.sort=function(z,K){return z.sort(function(J,te){return e.compare(J,te,K)})},e.rsort=function(z,K){return z.sort(function(J,te){return e.rcompare(J,te,K)})},e.gt=ie,e.lt=Se,e.eq=he,e.neq=we,e.gte=ae,e.lte=Y,e.cmp=x,e.Comparator=me;var ge={};function Te(z,K){if(z instanceof Te)return z.loose===K?z:new Te(z.raw,K);if(z instanceof me)return new Te(z.value,K);if(!(this instanceof Te))return new Te(z,K);if(this.loose=K,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(J){return this.parseRange(J.trim())},this).filter(function(J){return J.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function Be(z){return!z||z.toLowerCase()==="x"||z==="*"}function Ee(z,K,J,te,le,Ae,je,Ge,Ze,tt,_e,it,nt){return((K=Be(J)?"":Be(te)?">="+J+".0.0":Be(le)?">="+J+"."+te+".0":">="+K)+" "+(Ge=Be(Ze)?"":Be(tt)?"<"+(+Ze+1)+".0.0":Be(_e)?"<"+Ze+"."+(+tt+1)+".0":it?"<="+Ze+"."+tt+"."+_e+"-"+it:"<="+Ge)).trim()}function Re(z,K){for(var J=0;J<z.length;J++)if(!z[J].test(K))return!1;if(K.prerelease.length){for(J=0;J<z.length;J++)if(P(z[J].semver),z[J].semver!==ge&&z[J].semver.prerelease.length>0){var te=z[J].semver;if(te.major===K.major&&te.minor===K.minor&&te.patch===K.patch)return!0}return!1}return!0}function Oe(z,K,J){try{K=new Te(K,J)}catch{return!1}return K.test(z)}function j(z,K,J,te){var le,Ae,je,Ge,Ze;switch(z=new Ce(z,te),K=new Te(K,te),J){case">":le=ie,Ae=Y,je=Se,Ge=">",Ze=">=";break;case"<":le=Se,Ae=ae,je=ie,Ge="<",Ze="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Oe(z,K,te))return!1;for(var tt=0;tt<K.set.length;++tt){var _e=K.set[tt],it=null,nt=null;if(_e.forEach(function(mt){mt.semver===ge&&(mt=new me(">=0.0.0")),it=it||mt,nt=nt||mt,le(mt.semver,it.semver,te)?it=mt:je(mt.semver,nt.semver,te)&&(nt=mt)}),it.operator===Ge||it.operator===Ze||(!nt.operator||nt.operator===Ge)&&Ae(z,nt.semver)||nt.operator===Ze&&je(z,nt.semver))return!1}return!0}me.prototype.parse=function(z){var K=this.loose?M[Z]:M[re],J=z.match(K);if(!J)throw new TypeError("Invalid comparator: "+z);this.operator=J[1],this.operator==="="&&(this.operator=""),J[2]?this.semver=new Ce(J[2],this.loose):this.semver=ge},me.prototype.toString=function(){return this.value},me.prototype.test=function(z){return P("Comparator.test",z,this.loose),this.semver===ge||(typeof z=="string"&&(z=new Ce(z,this.loose)),x(z,this.operator,this.semver,this.loose))},me.prototype.intersects=function(z,K){if(!(z instanceof me))throw new TypeError("a Comparator is required");var J;if(this.operator==="")return J=new Te(z.value,K),Oe(this.value,J,K);if(z.operator==="")return J=new Te(this.value,K),Oe(z.semver,J,K);var te=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),le=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),Ae=this.semver.version===z.semver.version,je=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),Ge=x(this.semver,"<",z.semver,K)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),Ze=x(this.semver,">",z.semver,K)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return te||le||Ae&&je||Ge||Ze},e.Range=Te,Te.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},Te.prototype.toString=function(){return this.range},Te.prototype.parseRange=function(z){var K=this.loose;z=z.trim(),P("range",z,K);var J=K?M[oe]:M[be];z=z.replace(J,Ee),P("hyphen replace",z),z=z.replace(M[fe],"$1$2$3"),P("comparator trim",z,M[fe]),z=(z=(z=z.replace(M[F],"$1~")).replace(M[V],"$1^")).split(/\s+/).join(" ");var te=K?M[Z]:M[re],le=z.split(" ").map(function(Ae){return function(je,Ge){return P("comp",je),je=function(Ze,tt){return Ze.trim().split(/\s+/).map(function(_e){return function(it,nt){P("caret",it,nt);var mt=nt?M[L]:M[N];return it.replace(mt,function(lt,rt,at,dt,We){var ze;return P("caret",it,lt,rt,at,dt,We),Be(rt)?ze="":Be(at)?ze=">="+rt+".0.0 <"+(+rt+1)+".0.0":Be(dt)?ze=rt==="0"?">="+rt+"."+at+".0 <"+rt+"."+(+at+1)+".0":">="+rt+"."+at+".0 <"+(+rt+1)+".0.0":We?(P("replaceCaret pr",We),We.charAt(0)!=="-"&&(We="-"+We),ze=rt==="0"?at==="0"?">="+rt+"."+at+"."+dt+We+" <"+rt+"."+at+"."+(+dt+1):">="+rt+"."+at+"."+dt+We+" <"+rt+"."+(+at+1)+".0":">="+rt+"."+at+"."+dt+We+" <"+(+rt+1)+".0.0"):(P("no pr"),ze=rt==="0"?at==="0"?">="+rt+"."+at+"."+dt+" <"+rt+"."+at+"."+(+dt+1):">="+rt+"."+at+"."+dt+" <"+rt+"."+(+at+1)+".0":">="+rt+"."+at+"."+dt+" <"+(+rt+1)+".0.0"),P("caret return",ze),ze})}(_e,tt)}).join(" ")}(je,Ge),P("caret",je),je=function(Ze,tt){return Ze.trim().split(/\s+/).map(function(_e){return function(it,nt){var mt=nt?M[G]:M[T];return it.replace(mt,function(lt,rt,at,dt,We){var ze;return P("tilde",it,lt,rt,at,dt,We),Be(rt)?ze="":Be(at)?ze=">="+rt+".0.0 <"+(+rt+1)+".0.0":Be(dt)?ze=">="+rt+"."+at+".0 <"+rt+"."+(+at+1)+".0":We?(P("replaceTilde pr",We),We.charAt(0)!=="-"&&(We="-"+We),ze=">="+rt+"."+at+"."+dt+We+" <"+rt+"."+(+at+1)+".0"):ze=">="+rt+"."+at+"."+dt+" <"+rt+"."+(+at+1)+".0",P("tilde return",ze),ze})}(_e,tt)}).join(" ")}(je,Ge),P("tildes",je),je=function(Ze,tt){return P("replaceXRanges",Ze,tt),Ze.split(/\s+/).map(function(_e){return function(it,nt){it=it.trim();var mt=nt?M[k]:M[p];return it.replace(mt,function(lt,rt,at,dt,We,ze){P("xRange",it,lt,rt,at,dt,We,ze);var _=Be(at),H=_||Be(dt),ye=H||Be(We);return rt==="="&&ye&&(rt=""),_?lt=rt===">"||rt==="<"?"<0.0.0":"*":rt&&ye?(H&&(dt=0),ye&&(We=0),rt===">"?(rt=">=",H?(at=+at+1,dt=0,We=0):ye&&(dt=+dt+1,We=0)):rt==="<="&&(rt="<",H?at=+at+1:dt=+dt+1),lt=rt+at+"."+dt+"."+We):H?lt=">="+at+".0.0 <"+(+at+1)+".0.0":ye&&(lt=">="+at+"."+dt+".0 <"+at+"."+(+dt+1)+".0"),P("xRange return",lt),lt})}(_e,tt)}).join(" ")}(je,Ge),P("xrange",je),je=function(Ze,tt){return P("replaceStars",Ze,tt),Ze.trim().replace(M[pe],"")}(je,Ge),P("stars",je),je}(Ae,K)}).join(" ").split(/\s+/);return this.loose&&(le=le.filter(function(Ae){return!!Ae.match(te)})),le=le.map(function(Ae){return new me(Ae,K)})},Te.prototype.intersects=function(z,K){if(!(z instanceof Te))throw new TypeError("a Range is required");return this.set.some(function(J){return J.every(function(te){return z.set.some(function(le){return le.every(function(Ae){return te.intersects(Ae,K)})})})})},e.toComparators=function(z,K){return new Te(z,K).set.map(function(J){return J.map(function(te){return te.value}).join(" ").trim().split(" ")})},Te.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new Ce(z,this.loose));for(var K=0;K<this.set.length;K++)if(Re(this.set[K],z))return!0;return!1},e.satisfies=Oe,e.maxSatisfying=function(z,K,J){var te=null,le=null;try{var Ae=new Te(K,J)}catch{return null}return z.forEach(function(je){Ae.test(je)&&(te&&le.compare(je)!==-1||(le=new Ce(te=je,J)))}),te},e.minSatisfying=function(z,K,J){var te=null,le=null;try{var Ae=new Te(K,J)}catch{return null}return z.forEach(function(je){Ae.test(je)&&(te&&le.compare(je)!==1||(le=new Ce(te=je,J)))}),te},e.validRange=function(z,K){try{return new Te(z,K).range||"*"}catch{return null}},e.ltr=function(z,K,J){return j(z,K,"<",J)},e.gtr=function(z,K,J){return j(z,K,">",J)},e.outside=j,e.prerelease=function(z,K){var J=se(z,K);return J&&J.prerelease.length?J.prerelease:null},e.intersects=function(z,K,J){return z=new Te(z,J),K=new Te(K,J),z.intersects(K)},e.coerce=function(z){if(z instanceof Ce)return z;if(typeof z!="string")return null;var K=z.match(M[m]);return K==null?null:se((K[1]||"0")+"."+(K[2]||"0")+"."+(K[3]||"0"))}}).call(this,E(1))},function(de,e){var E,R,P=de.exports={};function O(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function M(o){if(E===setTimeout)return setTimeout(o,0);if((E===O||!E)&&setTimeout)return E=setTimeout,setTimeout(o,0);try{return E(o,0)}catch{try{return E.call(null,o,0)}catch{return E.call(this,o,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:O}catch{E=O}try{R=typeof clearTimeout=="function"?clearTimeout:A}catch{R=A}})();var $,c=[],C=!1,v=-1;function u(){C&&$&&(C=!1,$.length?c=$.concat(c):v=-1,c.length&&D())}function D(){if(!C){var o=M(u);C=!0;for(var a=c.length;a;){for($=c,c=[];++v<a;)$&&$[v].run();v=-1,a=c.length}$=null,C=!1,function(h){if(R===clearTimeout)return clearTimeout(h);if((R===A||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(h);try{R(h)}catch{try{return R.call(null,h)}catch{return R.call(this,h)}}}(o)}}function d(o,a){this.fun=o,this.array=a}function r(){}P.nextTick=function(o){var a=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)a[h-1]=arguments[h];c.push(new d(o,a)),c.length!==1||C||M(D)},d.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=r,P.addListener=r,P.once=r,P.off=r,P.removeListener=r,P.removeAllListeners=r,P.emit=r,P.prependListener=r,P.prependOnceListener=r,P.listeners=function(o){return[]},P.binding=function(o){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(o){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(ke[142],Ie([1,0,4,6]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iu=e.$hu=e.$gu=e.$fu=e.ScrollbarVisibility=void 0;var P;(function(D){D[D.Auto=1]="Auto",D[D.Hidden=2]="Hidden",D[D.Visible=3]="Visible"})(P||(e.ScrollbarVisibility=P={}));class O{constructor(d,r,o,a,h,t,s){this.c=d,this._scrollStateBrand=void 0,this.c&&(r=r|0,o=o|0,a=a|0,h=h|0,t=t|0,s=s|0),this.rawScrollLeft=a,this.rawScrollTop=s,r<0&&(r=0),a+r>o&&(a=o-r),a<0&&(a=0),h<0&&(h=0),s+h>t&&(s=t-h),s<0&&(s=0),this.width=r,this.scrollWidth=o,this.scrollLeft=a,this.height=h,this.scrollHeight=t,this.scrollTop=s}equals(d){return this.rawScrollLeft===d.rawScrollLeft&&this.rawScrollTop===d.rawScrollTop&&this.width===d.width&&this.scrollWidth===d.scrollWidth&&this.scrollLeft===d.scrollLeft&&this.height===d.height&&this.scrollHeight===d.scrollHeight&&this.scrollTop===d.scrollTop}withScrollDimensions(d,r){return new O(this.c,typeof d.width<"u"?d.width:this.width,typeof d.scrollWidth<"u"?d.scrollWidth:this.scrollWidth,r?this.rawScrollLeft:this.scrollLeft,typeof d.height<"u"?d.height:this.height,typeof d.scrollHeight<"u"?d.scrollHeight:this.scrollHeight,r?this.rawScrollTop:this.scrollTop)}withScrollPosition(d){return new O(this.c,this.width,this.scrollWidth,typeof d.scrollLeft<"u"?d.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof d.scrollTop<"u"?d.scrollTop:this.rawScrollTop)}createScrollEvent(d,r){const o=this.width!==d.width,a=this.scrollWidth!==d.scrollWidth,h=this.scrollLeft!==d.scrollLeft,t=this.height!==d.height,s=this.scrollHeight!==d.scrollHeight,n=this.scrollTop!==d.scrollTop;return{inSmoothScrolling:r,oldWidth:d.width,oldScrollWidth:d.scrollWidth,oldScrollLeft:d.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:d.height,oldScrollHeight:d.scrollHeight,oldScrollTop:d.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:o,scrollWidthChanged:a,scrollLeftChanged:h,heightChanged:t,scrollHeightChanged:s,scrollTopChanged:n}}}e.$fu=O;class A extends R.$Uc{constructor(d){super(),this._scrollableBrand=void 0,this.j=this.B(new E.$he),this.onScroll=this.j.event,this.c=d.smoothScrollDuration,this.f=d.scheduleAtNextAnimationFrame,this.g=new O(d.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(d){this.c=d}validateScrollPosition(d){return this.g.withScrollPosition(d)}getScrollDimensions(){return this.g}setScrollDimensions(d,r){const o=this.g.withScrollDimensions(d,r);this.n(o,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(d){const r=this.g.withScrollPosition(d);this.h&&(this.h.dispose(),this.h=null),this.n(r,!1)}setScrollPositionSmooth(d,r){if(this.c===0)return this.setScrollPositionNow(d);if(this.h){d={scrollLeft:typeof d.scrollLeft>"u"?this.h.to.scrollLeft:d.scrollLeft,scrollTop:typeof d.scrollTop>"u"?this.h.to.scrollTop:d.scrollTop};const o=this.g.withScrollPosition(d);if(this.h.to.scrollLeft===o.scrollLeft&&this.h.to.scrollTop===o.scrollTop)return;let a;r?a=new C(this.h.from,o,this.h.startTime,this.h.duration):a=this.h.combine(this.g,o,this.c),this.h.dispose(),this.h=a}else{const o=this.g.withScrollPosition(d);this.h=C.start(this.g,o,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const d=this.h.tick(),r=this.g.withScrollPosition(d);if(this.n(r,!0),!!this.h){if(d.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(d,r){const o=this.g;o.equals(d)||(this.g=d,this.j.fire(this.g.createScrollEvent(o,r)))}}e.$gu=A;class M{constructor(d,r,o){this.scrollLeft=d,this.scrollTop=r,this.isDone=o}}e.$hu=M;function $(D,d){const r=d-D;return function(o){return D+r*u(o)}}function c(D,d,r){return function(o){return o<r?D(o/r):d((o-r)/(1-r))}}class C{constructor(d,r,o,a){this.from=d,this.to=r,this.duration=a,this.startTime=o,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(d,r,o){if(Math.abs(d-r)>2.5*o){let h,t;return d<r?(h=d+.75*o,t=r-.75*o):(h=d-.75*o,t=r+.75*o),c($(d,h),$(t,r),.33)}return $(d,r)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(d){this.to=d.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(d){const r=(d-this.startTime)/this.duration;if(r<1){const o=this.c(r),a=this.d(r);return new M(o,a,!1)}return new M(this.to.scrollLeft,this.to.scrollTop,!0)}combine(d,r,o){return C.start(d,r,o)}static start(d,r,o){o=o+10;const a=Date.now()-10;return new C(d,r,a,o)}}e.$iu=C;function v(D){return Math.pow(D,3)}function u(D){return 1-v(1-D)}}),define(ke[143],Ie([1,0,14,6]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=P,e.$ve=O,e.$we=A,e.$xe=M,e.$ye=c,e.$ze=C,e.$Ae=v,e.$Be=u,e.$Ce=D,e.$De=d,e.$Ee=r,e.$Fe=o,e.$Ge=a,e.$He=h,e.$Ie=t;function P(s){const n=s;return n?typeof n.read=="function":!1}function O(s){const n=s;return n?[n.on,n.pause,n.resume,n.destroy].every(i=>typeof i=="function"):!1}function A(s){const n=s;return n?O(n.stream)&&Array.isArray(n.buffer)&&typeof n.ended=="boolean":!1}function M(s,n){return new $(s,n)}class ${constructor(n,i){this.e=n,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(n){if(!this.a.destroyed){if(this.a.flowing)this.g(n);else if(this.b.data.push(n),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(n){this.a.destroyed||(this.a.flowing?this.h(n):this.b.error.push(n))}end(n){this.a.destroyed||(typeof n<"u"&&this.write(n),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(n){this.c.data.slice(0).forEach(i=>i(n))}h(n){this.c.error.length===0?(0,E.$1)(n):this.c.error.slice(0).forEach(i=>i(n))}i(){this.c.end.slice(0).forEach(n=>n())}on(n,i){if(!this.a.destroyed)switch(n){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(n,i){if(this.a.destroyed)return;let g;switch(n){case"data":g=this.c.data;break;case"end":g=this.c.end;break;case"error":g=this.c.error;break}if(g){const f=g.indexOf(i);f>=0&&g.splice(f,1)}}j(){if(this.b.data.length>0){const n=this.e(this.b.data);this.g(n),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(g=>g())}}k(){if(this.c.error.length>0){for(const n of this.b.error)this.h(n);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(s,n){const i=[];let g;for(;(g=s.read())!==null;)i.push(g);return n(i)}function C(s,n,i){const g=[];let f;for(;(f=s.read())!==null&&g.length<i;)g.push(f);return f===null&&g.length>0?n(g):{read:()=>{if(g.length>0)return g.shift();if(typeof f<"u"){const l=f;return f=void 0,l}return s.read()}}}function v(s,n){return new Promise((i,g)=>{const f=[];u(s,{onData:l=>{n&&f.push(l)},onError:l=>{n?g(l):i(void 0)},onEnd:()=>{i(n?n(f):void 0)}})})}function u(s,n,i){s.on("error",g=>{i?.isCancellationRequested||n.onError(g)}),s.on("end",()=>{i?.isCancellationRequested||n.onEnd()}),s.on("data",g=>{i?.isCancellationRequested||n.onData(g)})}function D(s,n){return new Promise((i,g)=>{const f=new R.$Tc,l=[],b=y=>{if(l.push(y),l.length>n)return f.dispose(),s.pause(),i({stream:s,buffer:l,ended:!1})},I=y=>(f.dispose(),g(y)),S=()=>(f.dispose(),i({stream:s,buffer:l,ended:!0}));f.add((0,R.$Sc)(()=>s.removeListener("error",I))),s.on("error",I),f.add((0,R.$Sc)(()=>s.removeListener("end",S))),s.on("end",S),f.add((0,R.$Sc)(()=>s.removeListener("data",b))),s.on("data",b)})}function d(s,n){const i=M(n);return i.end(s),i}function r(){const s=M(()=>{throw new Error("not supported")});return s.end(),s}function o(s){let n=!1;return{read:()=>n?null:(n=!0,s)}}function a(s,n,i){const g=M(i);return u(s,{onData:f=>g.write(n.data(f)),onError:f=>g.error(n.error?n.error(f):f),onEnd:()=>g.end()}),g}function h(s,n,i){let g=!1;return{read:()=>{const f=n.read();return g?f:(g=!0,f!==null?i([s,f]):s)}}}function t(s,n,i){let g=!1;const f=M(i);return u(n,{onData:l=>g?f.write(l):(g=!0,f.write(i([s,l]))),onError:l=>f.error(l),onEnd:()=>{g||(g=!0,f.write(s)),f.end()}}),f}}),define(ke[23],Ie([1,0,47,143]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Je=void 0,e.$Ke=c,e.$Le=C,e.$Me=v,e.$Ne=u,e.$Oe=D,e.$Pe=d,e.$Qe=r,e.$Re=o,e.$Se=a,e.$Te=h,e.$Ue=t,e.$Ve=s,e.$We=n,e.$Xe=i,e.$Ye=g,e.$Ze=f,e.$1e=l,e.$2e=b,e.$3e=I,e.$4e=p;const P=typeof Buffer<"u",O=new E.$V(()=>new Uint8Array(256));let A,M;class ${static alloc(m){return P?new $(Buffer.allocUnsafe(m)):new $(new Uint8Array(m))}static wrap(m){return P&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new $(m)}static fromString(m,w){return!(w?.dontUseNodeBuffer||!1)&&P?new $(Buffer.from(m)):(A||(A=new TextEncoder),new $(A.encode(m)))}static fromByteArray(m){const w=$.alloc(m.length);for(let F=0,T=m.length;F<T;F++)w.buffer[F]=m[F];return w}static concat(m,w){if(typeof w>"u"){w=0;for(let G=0,q=m.length;G<q;G++)w+=m[G].byteLength}const F=$.alloc(w);let T=0;for(let G=0,q=m.length;G<q;G++){const V=m[G];F.set(V,T),T+=V.byteLength}return F}constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}clone(){const m=$.alloc(this.byteLength);return m.set(this),m}toString(){return P?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(m,w){return new $(this.buffer.subarray(m,w))}set(m,w){if(m instanceof $)this.buffer.set(m.buffer,w);else if(m instanceof Uint8Array)this.buffer.set(m,w);else if(m instanceof ArrayBuffer)this.buffer.set(new Uint8Array(m),w);else if(ArrayBuffer.isView(m))this.buffer.set(new Uint8Array(m.buffer,m.byteOffset,m.byteLength),w);else throw new Error("Unknown argument 'array'")}readUInt32BE(m){return u(this.buffer,m)}writeUInt32BE(m,w){D(this.buffer,m,w)}readUInt32LE(m){return d(this.buffer,m)}writeUInt32LE(m,w){r(this.buffer,m,w)}readUInt8(m){return o(this.buffer,m)}writeUInt8(m,w){a(this.buffer,m,w)}indexOf(m,w=0){return c(this.buffer,m instanceof $?m.buffer:m,w)}}e.$Je=$;function c(k,m,w=0){const F=m.byteLength,T=k.byteLength;if(F===0)return 0;if(F===1)return k.indexOf(m[0]);if(F>T-w)return-1;const G=O.value;G.fill(m.length);for(let L=0;L<m.length;L++)G[m[L]]=m.length-L-1;let q=w+m.length-1,V=q,N=-1;for(;q<T;)if(k[q]===m[V]){if(V===0){N=q;break}q--,V--}else q+=Math.max(m.length-V,G[k[q]]),V=m.length-1;return N}function C(k,m){return k[m+0]<<0>>>0|k[m+1]<<8>>>0}function v(k,m,w){k[w+0]=m&255,m=m>>>8,k[w+1]=m&255}function u(k,m){return k[m]*2**24+k[m+1]*2**16+k[m+2]*2**8+k[m+3]}function D(k,m,w){k[w+3]=m,m=m>>>8,k[w+2]=m,m=m>>>8,k[w+1]=m,m=m>>>8,k[w]=m}function d(k,m){return k[m+0]<<0>>>0|k[m+1]<<8>>>0|k[m+2]<<16>>>0|k[m+3]<<24>>>0}function r(k,m,w){k[w+0]=m&255,m=m>>>8,k[w+1]=m&255,m=m>>>8,k[w+2]=m&255,m=m>>>8,k[w+3]=m&255}function o(k,m){return k[m]}function a(k,m,w){k[w]=m}function h(k){return R.$ye(k,m=>$.concat(m))}function t(k){return R.$Fe(k)}function s(k){return R.$Ae(k,m=>$.concat(m))}async function n(k){return k.ended?$.concat(k.buffer):$.concat([...k.buffer,await s(k.stream)])}function i(k){return R.$De(k,m=>$.concat(m))}function g(k){return R.$Ge(k,{data:m=>typeof m=="string"?$.fromString(m):$.wrap(m)},m=>$.concat(m))}function f(k){return R.$xe(m=>$.concat(m),k)}function l(k,m){return R.$He(k,m,w=>$.concat(w))}function b(k,m){return R.$Ie(k,m,w=>$.concat(w))}function I(k){let m=0,w=0,F=0;const T=new Uint8Array(Math.floor(k.length/4*3)),G=V=>{switch(w){case 3:T[F++]=m|V,w=0;break;case 2:T[F++]=m|V>>>2,m=V<<6,w=3;break;case 1:T[F++]=m|V>>>4,m=V<<4,w=2;break;default:m=V<<2,w=1}};for(let V=0;V<k.length;V++){const N=k.charCodeAt(V);if(N>=65&&N<=90)G(N-65);else if(N>=97&&N<=122)G(N-97+26);else if(N>=48&&N<=57)G(N-48+52);else if(N===43||N===45)G(62);else if(N===47||N===95)G(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${k[V]}`)}}const q=F;for(;w>0;)G(0);return $.wrap(T).slice(0,q)}const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function p({buffer:k},m=!0,w=!1){const F=w?y:S;let T="";const G=k.byteLength%3;let q=0;for(;q<k.byteLength-G;q+=3){const V=k[q+0],N=k[q+1],L=k[q+2];T+=F[V>>>2],T+=F[(V<<4|N>>>4)&63],T+=F[(N<<2|L>>>6)&63],T+=F[L&63]}if(G===1){const V=k[q+0];T+=F[V>>>2],T+=F[V<<4&63],m&&(T+="==")}else if(G===2){const V=k[q+0],N=k[q+1];T+=F[V>>>2],T+=F[(V<<4|N>>>4)&63],T+=F[N<<2&63],m&&(T+="=")}return T}}),define(ke[144],Ie([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ce=void 0,e.$ce=Symbol("MicrotaskDelay")}),define(ke[34],Ie([1,0,97]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$1j=P;var R;(function(A){function M($){return $&&typeof $=="object"&&typeof $.id=="string"}A.isThemeColor=M})(R||(e.ThemeColor=R={}));function P(A){return{id:A}}var O;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const M=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function $(h){const t=M.exec(h.id);if(!t)return $(E.$Zj.error);const[,s,n]=t,i=["codicon","codicon-"+s];return n&&i.push("codicon-modifier-"+n.substring(1)),i}A.asClassNameArray=$;function c(h){return $(h).join(" ")}A.asClassName=c;function C(h){return"."+$(h).join(".")}A.asCSSSelector=C;function v(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(typeof h.color>"u"||R.isThemeColor(h.color))}A.isThemeIcon=v;const u=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function D(h){const t=u.exec(h);if(!t)return;const[,s]=t;return{id:s}}A.fromString=D;function d(h){return{id:h}}A.fromId=d;function r(h,t){let s=h.id;const n=s.lastIndexOf("~");return n!==-1&&(s=s.substring(0,n)),t&&(s=`${s}~${t}`),{id:s}}A.modify=r;function o(h){const t=h.id.lastIndexOf("~");if(t!==-1)return h.id.substring(t+1)}A.getModifier=o;function a(h,t){return h.id===t.id&&h.color?.id===t.color?.id}A.isEqual=a})(O||(e.ThemeIcon=O={}))}),define(ke[145],Ie([1,0,28,29,136,13]),function(de,e,E,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=e.FuzzyScore=e.$Ck=e.$Bk=void 0,e.or=A,e.$Dk=$,e.$Ek=c,e.$Fk=u,e.$Gk=S,e.$Hk=y,e.$Ik=T,e.$Jk=G,e.$Kk=q,e.$Lk=V,e.$Mk=ie,e.$Ok=ae,e.$Pk=me,e.$Qk=ge;function A(...Ee){return function(Re,Oe){for(let j=0,z=Ee.length;j<z;j++){const K=Ee[j](Re,Oe);if(K)return K}return null}}e.$Bk=M.bind(void 0,!1),e.$Ck=M.bind(void 0,!0);function M(Ee,Re,Oe){if(!Oe||Oe.length<Re.length)return null;let j;return Ee?j=O.$Cf(Oe,Re):j=Oe.indexOf(Re)===0,j?Re.length>0?[{start:0,end:Re.length}]:[]:null}function $(Ee,Re){const Oe=Re.toLowerCase().indexOf(Ee.toLowerCase());return Oe===-1?null:[{start:Oe,end:Oe+Ee.length}]}function c(Ee,Re){return C(Ee.toLowerCase(),Re.toLowerCase(),0,0)}function C(Ee,Re,Oe,j){if(Oe===Ee.length)return[];if(j===Re.length)return null;if(Ee[Oe]===Re[j]){let z=null;return(z=C(Ee,Re,Oe+1,j+1))?n({start:j,end:j+1},z):null}return C(Ee,Re,Oe,j+1)}function v(Ee){return E.CharCode.a<=Ee&&Ee<=E.CharCode.z}function u(Ee){return E.CharCode.A<=Ee&&Ee<=E.CharCode.Z}function D(Ee){return E.CharCode.Digit0<=Ee&&Ee<=E.CharCode.Digit9}function d(Ee){return Ee===E.CharCode.Space||Ee===E.CharCode.Tab||Ee===E.CharCode.LineFeed||Ee===E.CharCode.CarriageReturn}const r=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Ee=>r.add(Ee.charCodeAt(0)));function o(Ee){return d(Ee)||r.has(Ee)}function a(Ee,Re){return Ee===Re||o(Ee)&&o(Re)}const h=new Map;function t(Ee){if(h.has(Ee))return h.get(Ee);let Re;const Oe=(0,P.$zk)(Ee);return Oe&&(Re=Oe),h.set(Ee,Re),Re}function s(Ee){return v(Ee)||u(Ee)||D(Ee)}function n(Ee,Re){return Re.length===0?Re=[Ee]:Ee.end===Re[0].start?Re[0].start=Ee.start:Re.unshift(Ee),Re}function i(Ee,Re){for(let Oe=Re;Oe<Ee.length;Oe++){const j=Ee.charCodeAt(Oe);if(u(j)||D(j)||Oe>0&&!s(Ee.charCodeAt(Oe-1)))return Oe}return Ee.length}function g(Ee,Re,Oe,j){if(Oe===Ee.length)return[];if(j===Re.length)return null;if(Ee[Oe]!==Re[j].toLowerCase())return null;{let z=null,K=j+1;for(z=g(Ee,Re,Oe+1,j+1);!z&&(K=i(Re,K))<Re.length;)z=g(Ee,Re,Oe+1,K),K++;return z===null?null:n({start:j,end:j+1},z)}}function f(Ee){let Re=0,Oe=0,j=0,z=0,K=0;for(let je=0;je<Ee.length;je++)K=Ee.charCodeAt(je),u(K)&&Re++,v(K)&&Oe++,s(K)&&j++,D(K)&&z++;const J=Re/Ee.length,te=Oe/Ee.length,le=j/Ee.length,Ae=z/Ee.length;return{upperPercent:J,lowerPercent:te,alphaPercent:le,numericPercent:Ae}}function l(Ee){const{upperPercent:Re,lowerPercent:Oe}=Ee;return Oe===0&&Re>.6}function b(Ee){const{upperPercent:Re,lowerPercent:Oe,alphaPercent:j,numericPercent:z}=Ee;return Oe>.2&&Re<.8&&j>.6&&z<.2}function I(Ee){let Re=0,Oe=0,j=0,z=0;for(let K=0;K<Ee.length;K++)j=Ee.charCodeAt(K),u(j)&&Re++,v(j)&&Oe++,d(j)&&z++;return(Re===0||Oe===0)&&z===0?Ee.length<=30:Re<=5}function S(Ee,Re){if(!Re||(Re=Re.trim(),Re.length===0)||!I(Ee))return null;Re.length>60&&(Re=Re.substring(0,60));const Oe=f(Re);if(!b(Oe)){if(!l(Oe))return null;Re=Re.toLowerCase()}let j=null,z=0;for(Ee=Ee.toLowerCase();z<Re.length&&(j=g(Ee,Re,0,z))===null;)z=i(Re,z+1);return j}function y(Ee,Re,Oe=!1){if(!Re||Re.length===0)return null;let j=null,z=0;for(Ee=Ee.toLowerCase(),Re=Re.toLowerCase();z<Re.length&&(j=p(Ee,Re,0,z,Oe),j===null);)z=k(Re,z+1);return j}function p(Ee,Re,Oe,j,z){let K=0;if(Oe===Ee.length)return[];if(j===Re.length)return null;if(!a(Ee.charCodeAt(Oe),Re.charCodeAt(j))){const le=t(Ee.charCodeAt(Oe));if(!le)return null;for(let Ae=0;Ae<le.length;Ae++)if(!a(le[Ae],Re.charCodeAt(j+Ae)))return null;K+=le.length-1}let J=null,te=j+K+1;if(J=p(Ee,Re,Oe+1,te,z),!z)for(;!J&&(te=k(Re,te))<Re.length;)J=p(Ee,Re,Oe+1,te,z),te++;if(!J)return null;if(Ee.charCodeAt(Oe)!==Re.charCodeAt(j)){const le=t(Ee.charCodeAt(Oe));if(!le)return J;for(let Ae=0;Ae<le.length;Ae++)if(le[Ae]!==Re.charCodeAt(j+Ae))return J}return n({start:j,end:j+K+1},J)}function k(Ee,Re){for(let Oe=Re;Oe<Ee.length;Oe++)if(o(Ee.charCodeAt(Oe))||Oe>0&&o(Ee.charCodeAt(Oe-1)))return Oe;return Ee.length}const m=A(e.$Ck,S,$),w=A(e.$Ck,S,c),F=new R.$Dc(1e4);function T(Ee,Re,Oe=!1){if(typeof Ee!="string"||typeof Re!="string")return null;let j=F.get(Ee);j||(j=new RegExp(O.$kf(Ee),"i"),F.set(Ee,j));const z=j.exec(Re);return z?[{start:z.index,end:z.index+z[0].length}]:Oe?w(Ee,Re):m(Ee,Re)}function G(Ee,Re){const Oe=ae(Ee,Ee.toLowerCase(),0,Re,Re.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Oe?V(Oe):null}function q(Ee,Re,Oe,j,z,K){const J=Math.min(13,Ee.length);for(;Oe<J;Oe++){const te=ae(Ee,Re,Oe,j,z,K,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(te)return te}return[0,K]}function V(Ee){if(typeof Ee>"u")return[];const Re=[],Oe=Ee[1];for(let j=Ee.length-1;j>1;j--){const z=Ee[j]+Oe,K=Re[Re.length-1];K&&K.end===z?K.end=z+1:Re.push({start:z,end:z+1})}return Re}const N=128;function L(){const Ee=[],Re=[];for(let Oe=0;Oe<=N;Oe++)Re[Oe]=0;for(let Oe=0;Oe<=N;Oe++)Ee.push(Re.slice(0));return Ee}function Z(Ee){const Re=[];for(let Oe=0;Oe<=Ee;Oe++)Re[Oe]=0;return Re}const re=Z(2*N),fe=Z(2*N),be=L(),oe=L(),pe=L(),$e=!1;function se(Ee,Re,Oe,j,z){function K(te,le,Ae=" "){for(;te.length<le;)te=Ae+te;return te}let J=` |   |${j.split("").map(te=>K(te,3)).join("|")}
`;for(let te=0;te<=Oe;te++)te===0?J+=" |":J+=`${Re[te-1]}|`,J+=Ee[te].slice(0,z+1).map(le=>K(le.toString(),3)).join("|")+`
`;return J}function Ce(Ee,Re,Oe,j){Ee=Ee.substr(Re),Oe=Oe.substr(j),console.log(se(oe,Ee,Ee.length,Oe,Oe.length)),console.log(se(pe,Ee,Ee.length,Oe,Oe.length)),console.log(se(be,Ee,Ee.length,Oe,Oe.length))}function Fe(Ee,Re){if(Re<0||Re>=Ee.length)return!1;const Oe=Ee.codePointAt(Re);switch(Oe){case E.CharCode.Underline:case E.CharCode.Dash:case E.CharCode.Period:case E.CharCode.Space:case E.CharCode.Slash:case E.CharCode.Backslash:case E.CharCode.SingleQuote:case E.CharCode.DoubleQuote:case E.CharCode.Colon:case E.CharCode.DollarSign:case E.CharCode.LessThan:case E.CharCode.GreaterThan:case E.CharCode.OpenParen:case E.CharCode.CloseParen:case E.CharCode.OpenSquareBracket:case E.CharCode.CloseSquareBracket:case E.CharCode.OpenCurlyBrace:case E.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!O.$Uf(Oe)}}function X(Ee,Re){if(Re<0||Re>=Ee.length)return!1;switch(Ee.charCodeAt(Re)){case E.CharCode.Space:case E.CharCode.Tab:return!0;default:return!1}}function W(Ee,Re,Oe){return Re[Ee]!==Oe[Ee]}function ie(Ee,Re,Oe,j,z,K,J=!1){for(;Re<Oe&&z<K;)Ee[Re]===j[z]&&(J&&(re[Re]=z),Re+=1),z+=1;return Re===Oe}var Se;(function(Ee){Ee[Ee.Diag=1]="Diag",Ee[Ee.Left=2]="Left",Ee[Ee.LeftLeft=3]="LeftLeft"})(Se||(Se={}));var he;(function(Ee){Ee.Default=[-100,0];function Re(Oe){return!Oe||Oe.length===2&&Oe[0]===-100&&Oe[1]===0}Ee.isDefault=Re})(he||(e.FuzzyScore=he={}));class we{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Re,Oe){this.firstMatchCanBeWeak=Re,this.boostFullMatch=Oe}}e.$Nk=we;function ae(Ee,Re,Oe,j,z,K,J=we.default){const te=Ee.length>N?N:Ee.length,le=j.length>N?N:j.length;if(Oe>=te||K>=le||te-Oe>le-K||!ie(Re,Oe,te,z,K,le,!0))return;Y(te,le,Oe,K,Re,z);let Ae=1,je=1,Ge=Oe,Ze=K;const tt=[!1];for(Ae=1,Ge=Oe;Ge<te;Ae++,Ge++){const lt=re[Ge],rt=fe[Ge],at=Ge+1<te?fe[Ge+1]:le;for(je=lt-K+1,Ze=lt;Ze<at;je++,Ze++){let dt=Number.MIN_SAFE_INTEGER,We=!1;Ze<=rt&&(dt=x(Ee,Re,Ge,Oe,j,z,Ze,le,K,be[Ae-1][je-1]===0,tt));let ze=0;dt!==Number.MAX_SAFE_INTEGER&&(We=!0,ze=dt+oe[Ae-1][je-1]);const _=Ze>lt,H=_?oe[Ae][je-1]+(be[Ae][je-1]>0?-5:0):0,ye=Ze>lt+1&&be[Ae][je-1]>0,Ke=ye?oe[Ae][je-2]+(be[Ae][je-2]>0?-5:0):0;if(ye&&(!_||Ke>=H)&&(!We||Ke>=ze))oe[Ae][je]=Ke,pe[Ae][je]=Se.LeftLeft,be[Ae][je]=0;else if(_&&(!We||H>=ze))oe[Ae][je]=H,pe[Ae][je]=Se.Left,be[Ae][je]=0;else if(We)oe[Ae][je]=ze,pe[Ae][je]=Se.Diag,be[Ae][je]=be[Ae-1][je-1]+1;else throw new Error("not possible")}}if($e&&Ce(Ee,Oe,j,K),!tt[0]&&!J.firstMatchCanBeWeak)return;Ae--,je--;const _e=[oe[Ae][je],K];let it=0,nt=0;for(;Ae>=1;){let lt=je;do{const rt=pe[Ae][lt];if(rt===Se.LeftLeft)lt=lt-2;else if(rt===Se.Left)lt=lt-1;else break}while(lt>=1);it>1&&Re[Oe+Ae-1]===z[K+je-1]&&!W(lt+K-1,j,z)&&it+1>be[Ae][lt]&&(lt=je),lt===je?it++:it=1,nt||(nt=lt),Ae--,je=lt-1,_e.push(je)}le-K===te&&J.boostFullMatch&&(_e[0]+=2);const mt=nt-te;return _e[0]-=mt,_e}function Y(Ee,Re,Oe,j,z,K){let J=Ee-1,te=Re-1;for(;J>=Oe&&te>=j;)z[J]===K[te]&&(fe[J]=te,J--),te--}function x(Ee,Re,Oe,j,z,K,J,te,le,Ae,je){if(Re[Oe]!==K[J])return Number.MIN_SAFE_INTEGER;let Ge=1,Ze=!1;return J===Oe-j?Ge=Ee[Oe]===z[J]?7:5:W(J,z,K)&&(J===0||!W(J-1,z,K))?(Ge=Ee[Oe]===z[J]?7:5,Ze=!0):Fe(K,J)&&(J===0||!Fe(K,J-1))?Ge=5:(Fe(K,J-1)||X(K,J-1))&&(Ge=5,Ze=!0),Ge>1&&Oe===j&&(je[0]=!0),Ze||(Ze=W(J,z,K)||Fe(K,J-1)||X(K,J-1)),Oe===j?J>le&&(Ge-=Ze?3:5):Ae?Ge+=Ze?2:0:Ge+=Ze?0:1,J+1===te&&(Ge-=Ze?3:5),Ge}function me(Ee,Re,Oe,j,z,K,J){return Te(Ee,Re,Oe,j,z,K,!0,J)}function ge(Ee,Re,Oe,j,z,K,J){return Te(Ee,Re,Oe,j,z,K,!1,J)}function Te(Ee,Re,Oe,j,z,K,J,te){let le=ae(Ee,Re,Oe,j,z,K,te);if(le&&!J)return le;if(Ee.length>=3){const Ae=Math.min(7,Ee.length-1);for(let je=Oe+1;je<Ae;je++){const Ge=Be(Ee,je);if(Ge){const Ze=ae(Ge,Ge.toLowerCase(),Oe,j,z,K,te);Ze&&(Ze[0]-=3,(!le||Ze[0]>le[0])&&(le=Ze))}}}return le}function Be(Ee,Re){if(Re+1>=Ee.length)return;const Oe=Ee[Re],j=Ee[Re+1];if(Oe!==j)return Ee.slice(0,Re)+j+Oe+Ee.slice(Re+2)}}),define(ke[98],Ie([1,0,145,13,34]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rk=$,e.$Sk=C,e.$Tk=u,e.$Uk=D,e.$Vk=r,e.$Wk=o;const O="$(",A=new RegExp(`\\$\\(${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?\\)`,"g"),M=new RegExp(`(\\\\)?${A.source}`,"g");function $(a){return a.replace(M,(h,t)=>t?h:`\\${h}`)}const c=new RegExp(`\\\\${A.source}`,"g");function C(a){return a.replace(c,h=>`\\${h}`)}const v=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function u(a){return a.indexOf(O)===-1?a:a.replace(v,(h,t,s,n)=>s?h:t||n||"")}function D(a){return a?a.replace(/\$\((.*?)\)/g,(h,t)=>` ${t} `).trim():""}const d=new RegExp(`\\$\\(${P.ThemeIcon.iconNameCharacter}+\\)`,"g");function r(a){d.lastIndex=0;let h="";const t=[];let s=0;for(;;){const n=d.lastIndex,i=d.exec(a),g=a.substring(n,i?.index);if(g.length>0){h+=g;for(let f=0;f<g.length;f++)t.push(s)}if(!i)break;s+=i[0].length}return{text:h,iconOffsets:t}}function o(a,h,t=!1){const{text:s,iconOffsets:n}=h;if(!n||n.length===0)return(0,E.$Ik)(a,s,t);const i=(0,R.$if)(s," "),g=s.length-i.length,f=(0,E.$Ik)(a,i,t);if(f)for(const l of f){const b=n[l.start+g]+g;l.start+=b,l.end+=b}return f}}),define(ke[35],Ie([1,0,13]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(R||(R={})),function(P){const O="error",A="warning",M="warn",$="info",c="ignore";function C(u){return u?E.$Bf(O,u)?P.Error:E.$Bf(A,u)||E.$Bf(M,u)?P.Warning:E.$Bf($,u)?P.Info:P.Ignore:P.Ignore}P.fromValue=C;function v(u){switch(u){case P.Error:return O;case P.Warning:return A;case P.Info:return $;default:return c}}P.toString=v}(R||(R={})),e.default=R}),define(ke[58],Ie([1,0,18,28,13]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=void 0;class O{constructor(){this.b="",this.c=0}reset(d){return this.b=d,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(d){const r=d.charCodeAt(0),o=this.b.charCodeAt(this.c);return r-o}value(){return this.b[this.c]}}e.$Ci=O;class A{constructor(d=!0){this.e=d}reset(d){return this.b=d,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let d=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===R.CharCode.Period)if(d)this.c++;else break;else d=!1;return this}cmp(d){return this.e?(0,P.$vf)(d,this.b,0,d.length,this.c,this.d):(0,P.$xf)(d,this.b,0,d.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Di=A;class M{constructor(d=!0,r=!0){this.f=d,this.g=r}reset(d){this.d=0,this.e=0,this.b=d,this.c=d.length;for(let r=d.length-1;r>=0;r--,this.c--){const o=this.b.charCodeAt(r);if(!(o===R.CharCode.Slash||this.f&&o===R.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let d=!0;for(;this.e<this.c;this.e++){const r=this.b.charCodeAt(this.e);if(r===R.CharCode.Slash||this.f&&r===R.CharCode.Backslash)if(d)this.d++;else break;else d=!1}return this}cmp(d){return this.g?(0,P.$vf)(d,this.b,0,d.length,this.d,this.e):(0,P.$xf)(d,this.b,0,d.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ei=M;var $;(function(D){D[D.Scheme=1]="Scheme",D[D.Authority=2]="Authority",D[D.Path=3]="Path",D[D.Query=4]="Query",D[D.Fragment=5]="Fragment"})($||($={}));class c{constructor(d,r){this.f=d,this.g=r,this.d=[],this.e=0}reset(d){return this.c=d,this.d=[],this.c.scheme&&this.d.push($.Scheme),this.c.authority&&this.d.push($.Authority),this.c.path&&(this.b=new M(!1,!this.f(d)),this.b.reset(d.path),this.b.value()&&this.d.push($.Path)),this.g(d)||(this.c.query&&this.d.push($.Query),this.c.fragment&&this.d.push($.Fragment)),this.e=0,this}next(){return this.d[this.e]===$.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===$.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(d){if(this.d[this.e]===$.Scheme)return(0,P.$wf)(d,this.c.scheme);if(this.d[this.e]===$.Authority)return(0,P.$wf)(d,this.c.authority);if(this.d[this.e]===$.Path)return this.b.cmp(d);if(this.d[this.e]===$.Query)return(0,P.$uf)(d,this.c.query);if(this.d[this.e]===$.Fragment)return(0,P.$uf)(d,this.c.fragment);throw new Error}value(){if(this.d[this.e]===$.Scheme)return this.c.scheme;if(this.d[this.e]===$.Authority)return this.c.authority;if(this.d[this.e]===$.Path)return this.b.value();if(this.d[this.e]===$.Query)return this.c.query;if(this.d[this.e]===$.Fragment)return this.c.fragment;throw new Error}}e.$Fi=c;class C{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var v;(function(D){D[D.Left=-1]="Left",D[D.Mid=0]="Mid",D[D.Right=1]="Right"})(v||(v={}));class u{static forUris(d=()=>!1,r=()=>!1){return new u(new c(d,r))}static forPaths(d=!1){return new u(new M(void 0,!d))}static forStrings(){return new u(new O)}static forConfigKeys(){return new u(new A)}constructor(d){this.b=d}clear(){this.c=void 0}fill(d,r){if(r){const o=r.slice(0);(0,E.$Wb)(o);for(const a of o)this.set(a,d)}else{const o=d.slice(0);(0,E.$Wb)(o);for(const a of o)this.set(a[0],a[1])}}set(d,r){const o=this.b.reset(d);let a;this.c||(this.c=new C,this.c.segment=o.value());const h=[];for(a=this.c;;){const s=o.cmp(a.segment);if(s>0)a.left||(a.left=new C,a.left.segment=o.value()),h.push([v.Left,a]),a=a.left;else if(s<0)a.right||(a.right=new C,a.right.segment=o.value()),h.push([v.Right,a]),a=a.right;else if(o.hasNext())o.next(),a.mid||(a.mid=new C,a.mid.segment=o.value()),h.push([v.Mid,a]),a=a.mid;else break}const t=a.value;a.value=r,a.key=d;for(let s=h.length-1;s>=0;s--){const n=h[s][1];n.updateHeight();const i=n.balanceFactor();if(i<-1||i>1){const g=h[s][0],f=h[s+1][0];if(g===v.Right&&f===v.Right)h[s][1]=n.rotateLeft();else if(g===v.Left&&f===v.Left)h[s][1]=n.rotateRight();else if(g===v.Right&&f===v.Left)n.right=h[s+1][1]=h[s+1][1].rotateRight(),h[s][1]=n.rotateLeft();else if(g===v.Left&&f===v.Right)n.left=h[s+1][1]=h[s+1][1].rotateLeft(),h[s][1]=n.rotateRight();else throw new Error;if(s>0)switch(h[s-1][0]){case v.Left:h[s-1][1].left=h[s][1];break;case v.Right:h[s-1][1].right=h[s][1];break;case v.Mid:h[s-1][1].mid=h[s][1];break}else this.c=h[0][1]}}return t}get(d){return this.d(d)?.value}d(d){const r=this.b.reset(d);let o=this.c;for(;o;){const a=r.cmp(o.segment);if(a>0)o=o.left;else if(a<0)o=o.right;else if(r.hasNext())r.next(),o=o.mid;else break}return o}has(d){const r=this.d(d);return!(r?.value===void 0&&r?.mid===void 0)}delete(d){return this.e(d,!1)}deleteSuperstr(d){return this.e(d,!0)}e(d,r){const o=this.b.reset(d),a=[];let h=this.c;for(;h;){const t=o.cmp(h.segment);if(t>0)a.push([v.Left,h]),h=h.left;else if(t<0)a.push([v.Right,h]),h=h.right;else if(o.hasNext())o.next(),a.push([v.Mid,h]),h=h.mid;else break}if(h){if(r?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const t=this.f(h.right);if(t.key){const{key:s,value:n,segment:i}=t;this.e(t.key,!1),h.key=s,h.value=n,h.segment=i}}else{const t=h.left??h.right;if(a.length>0){const[s,n]=a[a.length-1];switch(s){case v.Left:n.left=t;break;case v.Mid:n.mid=t;break;case v.Right:n.right=t;break}}else this.c=t}for(let t=a.length-1;t>=0;t--){const s=a[t][1];s.updateHeight();const n=s.balanceFactor();if(n>1?(s.right.balanceFactor()>=0||(s.right=s.right.rotateRight()),a[t][1]=s.rotateLeft()):n<-1&&(s.left.balanceFactor()<=0||(s.left=s.left.rotateLeft()),a[t][1]=s.rotateRight()),t>0)switch(a[t-1][0]){case v.Left:a[t-1][1].left=a[t][1];break;case v.Right:a[t-1][1].right=a[t][1];break;case v.Mid:a[t-1][1].mid=a[t][1];break}else this.c=a[0][1]}}}f(d){for(;d.left;)d=d.left;return d}findSubstr(d){const r=this.b.reset(d);let o=this.c,a;for(;o;){const h=r.cmp(o.segment);if(h>0)o=o.left;else if(h<0)o=o.right;else if(r.hasNext())r.next(),a=o.value||a,o=o.mid;else break}return o&&o.value||a}findSuperstr(d){return this.g(d,!1)}g(d,r){const o=this.b.reset(d);let a=this.c;for(;a;){const h=o.cmp(a.segment);if(h>0)a=a.left;else if(h<0)a=a.right;else if(o.hasNext())o.next(),a=a.mid;else return a.mid?this.h(a.mid):r?a.value:void 0}}hasElementOrSubtree(d){return this.g(d,!0)!==void 0}forEach(d){for(const[r,o]of this)d(o,r)}*[Symbol.iterator](){yield*this.h(this.c)}h(d){const r=[];return this.j(d,r),r[Symbol.iterator]()}j(d,r){d&&(d.left&&this.j(d.left,r),d.value&&r.push([d.key,d.value]),d.mid&&this.j(d.mid,r),d.right&&this.j(d.right,r))}_isBalanced(){const d=r=>{if(!r)return!0;const o=r.balanceFactor();return o<-1||o>1?!1:d(r.left)&&d(r.right)};return d(this.c)}}e.$Gi=u}),define(ke[36],Ie([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wg=void 0,e.$Vg=R;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(P){return E.test(P)}e.$Wg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(M){for(let $=0;$<M.length;$++)M[$]=Math.floor(Math.random()*256);return M};const O=new Uint8Array(16),A=[];for(let M=0;M<256;M++)A.push(M.toString(16).padStart(2,"0"));return function(){P(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let $=0,c="";return c+=A[O[$++]],c+=A[O[$++]],c+=A[O[$++]],c+=A[O[$++]],c+="-",c+=A[O[$++]],c+=A[O[$++]],c+="-",c+=A[O[$++]],c+=A[O[$++]],c+="-",c+=A[O[$++]],c+=A[O[$++]],c+="-",c+=A[O[$++]],c+=A[O[$++]],c+=A[O[$++]],c+=A[O[$++]],c+=A[O[$++]],c+=A[O[$++]],c}}()}),define(ke[146],Ie([1,0,18,40,36]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_s=e.$0s=void 0,e.$8s=O,e.$9s=A,e.$$s=c;function O(v){return{asString:async()=>v,asFile:()=>{},value:typeof v=="string"?v:void 0}}function A(v,u,D){const d={id:(0,P.$Wg)(),name:v,uri:u,data:D};return{asString:async()=>"",asFile:()=>d,value:void 0}}class M{constructor(){this.a=new Map}get size(){let u=0;for(const D of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const D=[...this.a.keys()];return R.Iterable.some(this,([d,r])=>r.asFile())&&D.push("files"),C($(u),D)}get(u){return this.a.get(this.b(u))?.[0]}append(u,D){const d=this.a.get(u);d?d.push(D):this.a.set(this.b(u),[D])}replace(u,D){this.a.set(this.b(u),[D])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,D]of this.a)for(const d of D)yield[u,d]}b(u){return $(u)}}e.$0s=M;function $(v){return v.toLowerCase()}function c(v,u){return C($(v),u.map($))}function C(v,u){if(v==="*/*")return u.length>0;if(u.includes(v))return!0;const D=v.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!D)return!1;const[d,r,o]=D;return o==="*"?u.some(a=>a.startsWith(r+"/")):!1}e.$_s=Object.freeze({create:v=>(0,E.$Mb)(v.map(u=>u.toString())).join(`\r
`),split:v=>v.split(`\r
`),parse:v=>e.$_s.split(v).filter(u=>!u.startsWith("#"))})}),define(ke[147],Ie([1,0,28]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$jv=P;var R;(function(O){O[O.Unknown=0]="Unknown",O[O.Invalid=3]="Invalid",O[O.LF=1]="LF",O[O.CRLF=2]="CRLF"})(R||(e.StringEOL=R={}));function P(O){let A=0,M=0,$=0,c=R.Unknown;for(let C=0,v=O.length;C<v;C++){const u=O.charCodeAt(C);u===E.CharCode.CarriageReturn?(A===0&&(M=C),A++,C+1<v&&O.charCodeAt(C+1)===E.CharCode.LineFeed?(c|=R.CRLF,C++):c|=R.Invalid,$=C+1):u===E.CharCode.LineFeed&&(c|=R.LF,A===0&&(M=C),A++,$=C+1)}return A===0&&(M=O.length),[A,M,O.length-$,c]}}),define(ke[148],Ie([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nu=void 0,e.$nu={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[149],Ie([1,0,28,150]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dt=e.$Ct=e.IndentAction=void 0;var P;(function($){$[$.None=0]="None",$[$.Indent=1]="Indent",$[$.IndentOutdent=2]="IndentOutdent",$[$.Outdent=3]="Outdent"})(P||(e.IndentAction=P={}));class O{constructor(c){if(this.e=null,this.f=!1,this.open=c.open,this.close=c.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(c.notIn))for(let C=0,v=c.notIn.length;C<v;C++)switch(c.notIn[C]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(c){switch(c){case R.StandardTokenType.Other:return!0;case R.StandardTokenType.Comment:return this.c;case R.StandardTokenType.String:return this.b;case R.StandardTokenType.RegEx:return this.d}}shouldAutoClose(c,C){if(c.getTokenCount()===0)return!0;const v=c.findTokenIndexAtOffset(C-2),u=c.getStandardTokenType(v);return this.isOK(u)}g(c,C){for(let v=c;v<=C;v++){const u=String.fromCharCode(v);if(!this.open.includes(u)&&!this.close.includes(u))return u}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(E.CharCode.Digit0,E.CharCode.Digit9)),this.e||(this.e=this.g(E.CharCode.a,E.CharCode.z)),this.e||(this.e=this.g(E.CharCode.A,E.CharCode.Z))),this.e}}e.$Ct=O;class A{constructor(c){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const C of c)M(this.autoClosingPairsOpenByStart,C.open.charAt(0),C),M(this.autoClosingPairsOpenByEnd,C.open.charAt(C.open.length-1),C),M(this.autoClosingPairsCloseByStart,C.close.charAt(0),C),M(this.autoClosingPairsCloseByEnd,C.close.charAt(C.close.length-1),C),C.close.length===1&&C.open.length===1&&M(this.autoClosingPairsCloseSingleChar,C.close,C)}}e.$Dt=A;function M($,c,C){$.has(c)?$.get(c).push(C):$.set(c,[C])}}),define(ke[151],Ie([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RC=e.NodeColor=e.$QC=void 0,e.$SC=P,e.$TC=O,e.$UC=c,e.$VC=C,e.$WC=v,e.$XC=u,e.$YC=D,e.$ZC=d;class E{constructor(o,a){this.piece=o,this.color=a,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$RC)return P(this.right);let o=this;for(;o.parent!==e.$RC&&o.parent.left!==o;)o=o.parent;return o.parent===e.$RC?e.$RC:o.parent}prev(){if(this.left!==e.$RC)return O(this.left);let o=this;for(;o.parent!==e.$RC&&o.parent.right!==o;)o=o.parent;return o.parent===e.$RC?e.$RC:o.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$QC=E;var R;(function(r){r[r.Black=0]="Black",r[r.Red=1]="Red"})(R||(e.NodeColor=R={})),e.$RC=new E(null,R.Black),e.$RC.parent=e.$RC,e.$RC.left=e.$RC,e.$RC.right=e.$RC,e.$RC.color=R.Black;function P(r){for(;r.left!==e.$RC;)r=r.left;return r}function O(r){for(;r.right!==e.$RC;)r=r.right;return r}function A(r){return r===e.$RC?0:r.size_left+r.piece.length+A(r.right)}function M(r){return r===e.$RC?0:r.lf_left+r.piece.lineFeedCnt+M(r.right)}function $(){e.$RC.parent=e.$RC}function c(r,o){const a=o.right;a.size_left+=o.size_left+(o.piece?o.piece.length:0),a.lf_left+=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),o.right=a.left,a.left!==e.$RC&&(a.left.parent=o),a.parent=o.parent,o.parent===e.$RC?r.root=a:o.parent.left===o?o.parent.left=a:o.parent.right=a,a.left=o,o.parent=a}function C(r,o){const a=o.left;o.left=a.right,a.right!==e.$RC&&(a.right.parent=o),a.parent=o.parent,o.size_left-=a.size_left+(a.piece?a.piece.length:0),o.lf_left-=a.lf_left+(a.piece?a.piece.lineFeedCnt:0),o.parent===e.$RC?r.root=a:o===o.parent.right?o.parent.right=a:o.parent.left=a,a.right=o,o.parent=a}function v(r,o){let a,h;if(o.left===e.$RC?(h=o,a=h.right):o.right===e.$RC?(h=o,a=h.left):(h=P(o.right),a=h.right),h===r.root){r.root=a,a.color=R.Black,o.detach(),$(),r.root.parent=e.$RC;return}const t=h.color===R.Red;if(h===h.parent.left?h.parent.left=a:h.parent.right=a,h===o?(a.parent=h.parent,d(r,a)):(h.parent===o?a.parent=h:a.parent=h.parent,d(r,a),h.left=o.left,h.right=o.right,h.parent=o.parent,h.color=o.color,o===r.root?r.root=h:o===o.parent.left?o.parent.left=h:o.parent.right=h,h.left!==e.$RC&&(h.left.parent=h),h.right!==e.$RC&&(h.right.parent=h),h.size_left=o.size_left,h.lf_left=o.lf_left,d(r,h)),o.detach(),a.parent.left===a){const n=A(a),i=M(a);if(n!==a.parent.size_left||i!==a.parent.lf_left){const g=n-a.parent.size_left,f=i-a.parent.lf_left;a.parent.size_left=n,a.parent.lf_left=i,D(r,a.parent,g,f)}}if(d(r,a.parent),t){$();return}let s;for(;a!==r.root&&a.color===R.Black;)a===a.parent.left?(s=a.parent.right,s.color===R.Red&&(s.color=R.Black,a.parent.color=R.Red,c(r,a.parent),s=a.parent.right),s.left.color===R.Black&&s.right.color===R.Black?(s.color=R.Red,a=a.parent):(s.right.color===R.Black&&(s.left.color=R.Black,s.color=R.Red,C(r,s),s=a.parent.right),s.color=a.parent.color,a.parent.color=R.Black,s.right.color=R.Black,c(r,a.parent),a=r.root)):(s=a.parent.left,s.color===R.Red&&(s.color=R.Black,a.parent.color=R.Red,C(r,a.parent),s=a.parent.left),s.left.color===R.Black&&s.right.color===R.Black?(s.color=R.Red,a=a.parent):(s.left.color===R.Black&&(s.right.color=R.Black,s.color=R.Red,c(r,s),s=a.parent.left),s.color=a.parent.color,a.parent.color=R.Black,s.left.color=R.Black,C(r,a.parent),a=r.root));a.color=R.Black,$()}function u(r,o){for(d(r,o);o!==r.root&&o.parent.color===R.Red;)if(o.parent===o.parent.parent.left){const a=o.parent.parent.right;a.color===R.Red?(o.parent.color=R.Black,a.color=R.Black,o.parent.parent.color=R.Red,o=o.parent.parent):(o===o.parent.right&&(o=o.parent,c(r,o)),o.parent.color=R.Black,o.parent.parent.color=R.Red,C(r,o.parent.parent))}else{const a=o.parent.parent.left;a.color===R.Red?(o.parent.color=R.Black,a.color=R.Black,o.parent.parent.color=R.Red,o=o.parent.parent):(o===o.parent.left&&(o=o.parent,C(r,o)),o.parent.color=R.Black,o.parent.parent.color=R.Red,c(r,o.parent.parent))}r.root.color=R.Black}function D(r,o,a,h){for(;o!==r.root&&o!==e.$RC;)o.parent.left===o&&(o.parent.size_left+=a,o.parent.lf_left+=h),o=o.parent}function d(r,o){let a=0,h=0;if(o!==r.root){for(;o!==r.root&&o===o.parent.right;)o=o.parent;if(o!==r.root)for(o=o.parent,a=A(o.left)-o.size_left,h=M(o.left)-o.lf_left,o.size_left+=a,o.lf_left+=h;o!==r.root&&(a!==0||h!==0);)o.parent.left===o&&(o.parent.size_left+=a,o.parent.lf_left+=h),o=o.parent}}}),define(ke[99],Ie([1,0,28,100,33,52,151,101]),function(de,e,E,R,P,O,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$C=e.$0C=e.$9C=void 0,e.$7C=v,e.$8C=u;const $=65535;function c(h){let t;return h[h.length-1]<65536?t=new Uint16Array(h.length):t=new Uint32Array(h.length),t.set(h,0),t}class C{constructor(t,s,n,i,g){this.lineStarts=t,this.cr=s,this.lf=n,this.crlf=i,this.isBasicASCII=g}}function v(h,t=!0){const s=[0];let n=1;for(let i=0,g=h.length;i<g;i++){const f=h.charCodeAt(i);f===E.CharCode.CarriageReturn?i+1<g&&h.charCodeAt(i+1)===E.CharCode.LineFeed?(s[n++]=i+2,i++):s[n++]=i+1:f===E.CharCode.LineFeed&&(s[n++]=i+1)}return t?c(s):s}function u(h,t){h.length=0,h[0]=0;let s=1,n=0,i=0,g=0,f=!0;for(let b=0,I=t.length;b<I;b++){const S=t.charCodeAt(b);S===E.CharCode.CarriageReturn?b+1<I&&t.charCodeAt(b+1)===E.CharCode.LineFeed?(g++,h[s++]=b+2,b++):(n++,h[s++]=b+1):S===E.CharCode.LineFeed?(i++,h[s++]=b+1):f&&S!==E.CharCode.Tab&&(S<32||S>126)&&(f=!1)}const l=new C(c(h),n,i,g,f);return h.length=0,l}class D{constructor(t,s,n,i,g){this.bufferIndex=t,this.start=s,this.end=n,this.lineFeedCnt=i,this.length=g}}e.$9C=D;class d{constructor(t,s){this.buffer=t,this.lineStarts=s}}e.$0C=d;class r{constructor(t,s){this.a=[],this.c=t,this.d=s,this.b=0,t.root!==A.$RC&&t.iterate(t.root,n=>(n!==A.$RC&&this.a.push(n.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class o{constructor(t){this.a=t,this.b=[]}get(t){for(let s=this.b.length-1;s>=0;s--){const n=this.b[s];if(n.nodeStartOffset<=t&&n.nodeStartOffset+n.node.piece.length>=t)return n}return null}get2(t){for(let s=this.b.length-1;s>=0;s--){const n=this.b[s];if(n.nodeStartLineNumber&&n.nodeStartLineNumber<t&&n.nodeStartLineNumber+n.node.piece.lineFeedCnt>=t)return n}return null}set(t){this.b.length>=this.a&&this.b.shift(),this.b.push(t)}validate(t){let s=!1;const n=this.b;for(let i=0;i<n.length;i++){const g=n[i];if(g.node.parent===null||g.nodeStartOffset>=t){n[i]=null,s=!0;continue}}if(s){const i=[];for(const g of n)g!==null&&i.push(g);this.b=i}}}class a{constructor(t,s,n){this.create(t,s,n)}create(t,s,n){this.a=[new d("",[0])],this.g={line:0,column:0},this.root=A.$RC,this.b=1,this.c=0,this.d=s,this.e=s.length,this.f=n;let i=null;for(let g=0,f=t.length;g<f;g++)if(t[g].buffer.length>0){t[g].lineStarts||(t[g].lineStarts=v(t[g].buffer));const l=new D(g+1,{line:0,column:0},{line:t[g].lineStarts.length-1,column:t[g].buffer.length-t[g].lineStarts[t[g].lineStarts.length-1]},t[g].lineStarts.length-1,t[g].buffer.length);this.a.push(t[g]),i=this.S(i,l)}this.h=new o(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(t){const s=$,n=s-Math.floor(s/3),i=n*2;let g="",f=0;const l=[];if(this.iterate(this.root,b=>{const I=this.R(b),S=I.length;if(f<=n||f+S<i)return g+=I,f+=S,!0;const y=g.replace(/\r\n|\r|\n/g,t);return l.push(new d(y,v(y))),g=I,f=S,!0}),f>0){const b=g.replace(/\r\n|\r|\n/g,t);l.push(new d(b,v(b)))}this.create(l,t,!0)}getEOL(){return this.d}setEOL(t){this.d=t,this.e=this.d.length,this.normalizeEOL(t)}createSnapshot(t){return new r(this,t)}equal(t){if(this.getLength()!==t.getLength()||this.getLineCount()!==t.getLineCount())return!1;let s=0;return this.iterate(this.root,i=>{if(i===A.$RC)return!0;const g=this.R(i),f=g.length,l=t.G(s),b=t.G(s+f),I=t.getValueInRange2(l,b);return s+=f,g===I})}getOffsetAt(t,s){let n=0,i=this.root;for(;i!==A.$RC;)if(i.left!==A.$RC&&i.lf_left+1>=t)i=i.left;else if(i.lf_left+i.piece.lineFeedCnt+1>=t){n+=i.size_left;const g=this.B(i,t-i.lf_left-2);return n+=g+s-1}else t-=i.lf_left+i.piece.lineFeedCnt,n+=i.size_left+i.piece.length,i=i.right;return n}getPositionAt(t){t=Math.floor(t),t=Math.max(0,t);let s=this.root,n=0;const i=t;for(;s!==A.$RC;)if(s.size_left!==0&&s.size_left>=t)s=s.left;else if(s.size_left+s.piece.length>=t){const g=this.A(s,t-s.size_left);if(n+=s.lf_left+g.index,g.index===0){const f=this.getOffsetAt(n+1,1),l=i-f;return new R.$bt(n+1,l+1)}return new R.$bt(n+1,g.remainder+1)}else if(t-=s.size_left+s.piece.length,n+=s.lf_left+s.piece.lineFeedCnt,s.right===A.$RC){const g=this.getOffsetAt(n+1,1),f=i-t-g;return new R.$bt(n+1,f+1)}else s=s.right;return new R.$bt(1,1)}getValueInRange(t,s){if(t.startLineNumber===t.endLineNumber&&t.startColumn===t.endColumn)return"";const n=this.H(t.startLineNumber,t.startColumn),i=this.H(t.endLineNumber,t.endColumn),g=this.getValueInRange2(n,i);return s?s!==this.d||!this.f?g.replace(/\r\n|\r|\n/g,s):s===this.getEOL()&&this.f?g:g.replace(/\r\n|\r|\n/g,s):g}getValueInRange2(t,s){if(t.node===s.node){const l=t.node,b=this.a[l.piece.bufferIndex].buffer,I=this.u(l.piece.bufferIndex,l.piece.start);return b.substring(I+t.remainder,I+s.remainder)}let n=t.node;const i=this.a[n.piece.bufferIndex].buffer,g=this.u(n.piece.bufferIndex,n.piece.start);let f=i.substring(g+t.remainder,g+n.piece.length);for(n=n.next();n!==A.$RC;){const l=this.a[n.piece.bufferIndex].buffer,b=this.u(n.piece.bufferIndex,n.piece.start);if(n===s.node){f+=l.substring(b,b+s.remainder);break}else f+=l.substr(b,n.piece.length);n=n.next()}return f}getLinesContent(){const t=[];let s=0,n="",i=!1;return this.iterate(this.root,g=>{if(g===A.$RC)return!0;const f=g.piece;let l=f.length;if(l===0)return!0;const b=this.a[f.bufferIndex].buffer,I=this.a[f.bufferIndex].lineStarts,S=f.start.line,y=f.end.line;let p=I[S]+f.start.column;if(i&&(b.charCodeAt(p)===E.CharCode.LineFeed&&(p++,l--),t[s++]=n,n="",i=!1,l===0))return!0;if(S===y)return!this.f&&b.charCodeAt(p+l-1)===E.CharCode.CarriageReturn?(i=!0,n+=b.substr(p,l-1)):n+=b.substr(p,l),!0;n+=this.f?b.substring(p,Math.max(p,I[S+1]-this.e)):b.substring(p,I[S+1]).replace(/(\r\n|\r|\n)$/,""),t[s++]=n;for(let k=S+1;k<y;k++)n=this.f?b.substring(I[k],I[k+1]-this.e):b.substring(I[k],I[k+1]).replace(/(\r\n|\r|\n)$/,""),t[s++]=n;return!this.f&&b.charCodeAt(I[y]+f.end.column-1)===E.CharCode.CarriageReturn?(i=!0,f.end.column===0?s--:n=b.substr(I[y],f.end.column-1)):n=b.substr(I[y],f.end.column),!0}),i&&(t[s++]=n,n=""),t[s++]=n,t}getLength(){return this.c}getLineCount(){return this.b}getLineContent(t){return this.j.lineNumber===t?this.j.value:(this.j.lineNumber=t,t===this.b?this.j.value=this.getLineRawContent(t):this.f?this.j.value=this.getLineRawContent(t,this.e):this.j.value=this.getLineRawContent(t).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(t){if(t.remainder===t.node.piece.length){const s=t.node.next();if(!s)return 0;const n=this.a[s.piece.bufferIndex],i=this.u(s.piece.bufferIndex,s.piece.start);return n.buffer.charCodeAt(i)}else{const s=this.a[t.node.piece.bufferIndex],i=this.u(t.node.piece.bufferIndex,t.node.piece.start)+t.remainder;return s.buffer.charCodeAt(i)}}getLineCharCode(t,s){const n=this.H(t,s+1);return this.l(n)}getLineLength(t){if(t===this.getLineCount()){const s=this.getOffsetAt(t,1);return this.getLength()-s}return this.getOffsetAt(t+1,1)-this.getOffsetAt(t,1)-this.e}getCharCode(t){const s=this.G(t);return this.l(s)}findMatchesInNode(t,s,n,i,g,f,l,b,I,S,y){const p=this.a[t.piece.bufferIndex],k=this.u(t.piece.bufferIndex,t.piece.start),m=this.u(t.piece.bufferIndex,g),w=this.u(t.piece.bufferIndex,f);let F;const T={line:0,column:0};let G,q;s._wordSeparators?(G=p.buffer.substring(m,w),q=V=>V+m,s.reset(0)):(G=p.buffer,q=V=>V,s.reset(m));do if(F=s.next(G),F){if(q(F.index)>=w)return S;this.s(t,q(F.index)-k,T);const V=this.t(t.piece.bufferIndex,g,T),N=T.line===g.line?T.column-g.column+i:T.column+1,L=N+F[0].length;if(y[S++]=(0,M.$3C)(new P.$ct(n+V,N,n+V,L),F,b),q(F.index)+F[0].length>=w||S>=I)return S}while(F);return S}findMatchesLineByLine(t,s,n,i){const g=[];let f=0;const l=new M.$6C(s.wordSeparators,s.regex);let b=this.H(t.startLineNumber,t.startColumn);if(b===null)return[];const I=this.H(t.endLineNumber,t.endColumn);if(I===null)return[];let S=this.s(b.node,b.remainder);const y=this.s(I.node,I.remainder);if(b.node===I.node)return this.findMatchesInNode(b.node,l,t.startLineNumber,t.startColumn,S,y,s,n,i,f,g),g;let p=t.startLineNumber,k=b.node;for(;k!==I.node;){const w=this.t(k.piece.bufferIndex,S,k.piece.end);if(w>=1){const T=this.a[k.piece.bufferIndex].lineStarts,G=this.u(k.piece.bufferIndex,k.piece.start),q=T[S.line+w],V=p===t.startLineNumber?t.startColumn:1;if(f=this.findMatchesInNode(k,l,p,V,S,this.s(k,q-G),s,n,i,f,g),f>=i)return g;p+=w}const F=p===t.startLineNumber?t.startColumn-1:0;if(p===t.endLineNumber){const T=this.getLineContent(p).substring(F,t.endColumn-1);return f=this.n(s,l,T,t.endLineNumber,F,f,g,n,i),g}if(f=this.n(s,l,this.getLineContent(p).substr(F),p,F,f,g,n,i),f>=i)return g;p++,b=this.H(p,1),k=b.node,S=this.s(b.node,b.remainder)}if(p===t.endLineNumber){const w=p===t.startLineNumber?t.startColumn-1:0,F=this.getLineContent(p).substring(w,t.endColumn-1);return f=this.n(s,l,F,t.endLineNumber,w,f,g,n,i),g}const m=p===t.startLineNumber?t.startColumn:1;return f=this.findMatchesInNode(I.node,l,p,m,S,y,s,n,i,f,g),g}n(t,s,n,i,g,f,l,b,I){const S=t.wordSeparators;if(!b&&t.simpleSearch){const p=t.simpleSearch,k=p.length,m=n.length;let w=-k;for(;(w=n.indexOf(p,w+k))!==-1;)if((!S||(0,M.$5C)(S,n,m,w,k))&&(l[f++]=new O.$rv(new P.$ct(i,w+1+g,i,w+1+k+g),null),f>=I))return f;return f}let y;s.reset(0);do if(y=s.next(n),y&&(l[f++]=(0,M.$3C)(new P.$ct(i,y.index+1+g,i,y.index+1+y[0].length+g),y,b),f>=I))return f;while(y);return f}insert(t,s,n=!1){if(this.f=this.f&&n,this.j.lineNumber=0,this.j.value="",this.root!==A.$RC){const{node:i,remainder:g,nodeStartOffset:f}=this.G(t),l=i.piece,b=l.bufferIndex,I=this.s(i,g);if(i.piece.bufferIndex===0&&l.end.line===this.g.line&&l.end.column===this.g.column&&f+l.length===t&&s.length<$){this.F(i,s),this.y();return}if(f===t)this.o(s,i),this.h.validate(t);else if(f+i.piece.length>t){const S=[];let y=new D(l.bufferIndex,I,l.end,this.t(l.bufferIndex,I,l.end),this.u(b,l.end)-this.u(b,I));if(this.K()&&this.M(s)&&this.I(i,g)===10){const w={line:y.start.line+1,column:0};y=new D(y.bufferIndex,w,y.end,this.t(y.bufferIndex,w,y.end),y.length-1),s+=`
`}if(this.K()&&this.L(s))if(this.I(i,g-1)===13){const w=this.s(i,g-1);this.C(i,w),s="\r"+s,i.piece.length===0&&S.push(i)}else this.C(i,I);else this.C(i,I);const p=this.w(s);y.length>0&&this.S(i,y);let k=i;for(let m=0;m<p.length;m++)k=this.S(k,p[m]);this.v(S)}else this.q(s,i)}else{const i=this.w(s);let g=this.T(null,i[0]);for(let f=1;f<i.length;f++)g=this.S(g,i[f])}this.y()}delete(t,s){if(this.j.lineNumber=0,this.j.value="",s<=0||this.root===A.$RC)return;const n=this.G(t),i=this.G(t+s),g=n.node,f=i.node;if(g===f){const p=this.s(g,n.remainder),k=this.s(g,i.remainder);if(n.nodeStartOffset===t){if(s===g.piece.length){const m=g.next();(0,A.$WC)(this,g),this.N(m),this.y();return}this.D(g,k),this.h.validate(t),this.N(g),this.y();return}if(n.nodeStartOffset+g.piece.length===t+s){this.C(g,p),this.O(g),this.y();return}this.E(g,p,k),this.y();return}const l=[],b=this.s(g,n.remainder);this.C(g,b),this.h.validate(t),g.piece.length===0&&l.push(g);const I=this.s(f,i.remainder);this.D(f,I),f.piece.length===0&&l.push(f);const S=g.next();for(let p=S;p!==A.$RC&&p!==f;p=p.next())l.push(p);const y=g.piece.length===0?g.prev():g;this.v(l),this.O(y),this.y()}o(t,s){const n=[];if(this.K()&&this.M(t)&&this.L(s)){const f=s.piece,l={line:f.start.line+1,column:0},b=new D(f.bufferIndex,l,f.end,this.t(f.bufferIndex,l,f.end),f.length-1);s.piece=b,t+=`
`,(0,A.$YC)(this,s,-1,-1),s.piece.length===0&&n.push(s)}const i=this.w(t);let g=this.T(s,i[i.length-1]);for(let f=i.length-2;f>=0;f--)g=this.T(g,i[f]);this.N(g),this.v(n)}q(t,s){this.Q(t,s)&&(t+=`
`);const n=this.w(t),i=this.S(s,n[0]);let g=i;for(let f=1;f<n.length;f++)g=this.S(g,n[f]);this.N(i)}s(t,s,n){const i=t.piece,g=t.piece.bufferIndex,f=this.a[g].lineStarts,b=f[i.start.line]+i.start.column+s;let I=i.start.line,S=i.end.line,y=0,p=0,k=0;for(;I<=S&&(y=I+(S-I)/2|0,k=f[y],y!==S);)if(p=f[y+1],b<k)S=y-1;else if(b>=p)I=y+1;else break;return n?(n.line=y,n.column=b-k,null):{line:y,column:b-k}}t(t,s,n){if(n.column===0)return n.line-s.line;const i=this.a[t].lineStarts;if(n.line===i.length-1)return n.line-s.line;const g=i[n.line+1],f=i[n.line]+n.column;if(g>f+1)return n.line-s.line;const l=f-1;return this.a[t].buffer.charCodeAt(l)===13?n.line-s.line+1:n.line-s.line}u(t,s){return this.a[t].lineStarts[s.line]+s.column}v(t){for(let s=0;s<t.length;s++)(0,A.$WC)(this,t[s])}w(t){if(t.length>$){const S=[];for(;t.length>$;){const p=t.charCodeAt($-1);let k;p===E.CharCode.CarriageReturn||p>=55296&&p<=56319?(k=t.substring(0,$-1),t=t.substring($-1)):(k=t.substring(0,$),t=t.substring($));const m=v(k);S.push(new D(this.a.length,{line:0,column:0},{line:m.length-1,column:k.length-m[m.length-1]},m.length-1,k.length)),this.a.push(new d(k,m))}const y=v(t);return S.push(new D(this.a.length,{line:0,column:0},{line:y.length-1,column:t.length-y[y.length-1]},y.length-1,t.length)),this.a.push(new d(t,y)),S}let s=this.a[0].buffer.length;const n=v(t,!1);let i=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===s&&s!==0&&this.L(t)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},i=this.g;for(let S=0;S<n.length;S++)n[S]+=s+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(n.slice(1)),this.a[0].buffer+="_"+t,s+=1}else{if(s!==0)for(let S=0;S<n.length;S++)n[S]+=s;this.a[0].lineStarts=this.a[0].lineStarts.concat(n.slice(1)),this.a[0].buffer+=t}const g=this.a[0].buffer.length,f=this.a[0].lineStarts.length-1,l=g-this.a[0].lineStarts[f],b={line:f,column:l},I=new D(0,i,b,this.t(0,i,b),g-s);return this.g=b,[I]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(t,s=0){let n=this.root,i="";const g=this.h.get2(t);if(g){n=g.node;const f=this.B(n,t-g.nodeStartLineNumber-1),l=this.a[n.piece.bufferIndex].buffer,b=this.u(n.piece.bufferIndex,n.piece.start);if(g.nodeStartLineNumber+n.piece.lineFeedCnt===t)i=l.substring(b+f,b+n.piece.length);else{const I=this.B(n,t-g.nodeStartLineNumber);return l.substring(b+f,b+I-s)}}else{let f=0;const l=t;for(;n!==A.$RC;)if(n.left!==A.$RC&&n.lf_left>=t-1)n=n.left;else if(n.lf_left+n.piece.lineFeedCnt>t-1){const b=this.B(n,t-n.lf_left-2),I=this.B(n,t-n.lf_left-1),S=this.a[n.piece.bufferIndex].buffer,y=this.u(n.piece.bufferIndex,n.piece.start);return f+=n.size_left,this.h.set({node:n,nodeStartOffset:f,nodeStartLineNumber:l-(t-1-n.lf_left)}),S.substring(y+b,y+I-s)}else if(n.lf_left+n.piece.lineFeedCnt===t-1){const b=this.B(n,t-n.lf_left-2),I=this.a[n.piece.bufferIndex].buffer,S=this.u(n.piece.bufferIndex,n.piece.start);i=I.substring(S+b,S+n.piece.length);break}else t-=n.lf_left+n.piece.lineFeedCnt,f+=n.size_left+n.piece.length,n=n.right}for(n=n.next();n!==A.$RC;){const f=this.a[n.piece.bufferIndex].buffer;if(n.piece.lineFeedCnt>0){const l=this.B(n,0),b=this.u(n.piece.bufferIndex,n.piece.start);return i+=f.substring(b,b+l-s),i}else{const l=this.u(n.piece.bufferIndex,n.piece.start);i+=f.substr(l,n.piece.length)}n=n.next()}return i}y(){let t=this.root,s=1,n=0;for(;t!==A.$RC;)s+=t.lf_left+t.piece.lineFeedCnt,n+=t.size_left+t.piece.length,t=t.right;this.b=s,this.c=n,this.h.validate(this.c)}A(t,s){const n=t.piece,i=this.s(t,s),g=i.line-n.start.line;if(this.u(n.bufferIndex,n.end)-this.u(n.bufferIndex,n.start)===s){const f=this.t(t.piece.bufferIndex,n.start,i);if(f!==g)return{index:f,remainder:0}}return{index:g,remainder:i.column}}B(t,s){if(s<0)return 0;const n=t.piece,i=this.a[n.bufferIndex].lineStarts,g=n.start.line+s+1;return g>n.end.line?i[n.end.line]+n.end.column-i[n.start.line]-n.start.column:i[g]-i[n.start.line]-n.start.column}C(t,s){const n=t.piece,i=n.lineFeedCnt,g=this.u(n.bufferIndex,n.end),f=s,l=this.u(n.bufferIndex,f),b=this.t(n.bufferIndex,n.start,f),I=b-i,S=l-g,y=n.length+S;t.piece=new D(n.bufferIndex,n.start,f,b,y),(0,A.$YC)(this,t,S,I)}D(t,s){const n=t.piece,i=n.lineFeedCnt,g=this.u(n.bufferIndex,n.start),f=s,l=this.t(n.bufferIndex,f,n.end),b=this.u(n.bufferIndex,f),I=l-i,S=g-b,y=n.length+S;t.piece=new D(n.bufferIndex,f,n.end,l,y),(0,A.$YC)(this,t,S,I)}E(t,s,n){const i=t.piece,g=i.start,f=i.end,l=i.length,b=i.lineFeedCnt,I=s,S=this.t(i.bufferIndex,i.start,I),y=this.u(i.bufferIndex,s)-this.u(i.bufferIndex,g);t.piece=new D(i.bufferIndex,i.start,I,S,y),(0,A.$YC)(this,t,y-l,S-b);const p=new D(i.bufferIndex,n,f,this.t(i.bufferIndex,n,f),this.u(i.bufferIndex,f)-this.u(i.bufferIndex,n)),k=this.S(t,p);this.N(k)}F(t,s){this.Q(s,t)&&(s+=`
`);const n=this.K()&&this.L(s)&&this.M(t),i=this.a[0].buffer.length;this.a[0].buffer+=s;const g=v(s,!1);for(let k=0;k<g.length;k++)g[k]+=i;if(n){const k=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:i-k}}this.a[0].lineStarts=this.a[0].lineStarts.concat(g.slice(1));const f=this.a[0].lineStarts.length-1,l=this.a[0].buffer.length-this.a[0].lineStarts[f],b={line:f,column:l},I=t.piece.length+s.length,S=t.piece.lineFeedCnt,y=this.t(0,t.piece.start,b),p=y-S;t.piece=new D(t.piece.bufferIndex,t.piece.start,b,y,I),this.g=b,(0,A.$YC)(this,t,s.length,p)}G(t){let s=this.root;const n=this.h.get(t);if(n)return{node:n.node,nodeStartOffset:n.nodeStartOffset,remainder:t-n.nodeStartOffset};let i=0;for(;s!==A.$RC;)if(s.size_left>t)s=s.left;else if(s.size_left+s.piece.length>=t){i+=s.size_left;const g={node:s,remainder:t-s.size_left,nodeStartOffset:i};return this.h.set(g),g}else t-=s.size_left+s.piece.length,i+=s.size_left+s.piece.length,s=s.right;return null}H(t,s){let n=this.root,i=0;for(;n!==A.$RC;)if(n.left!==A.$RC&&n.lf_left>=t-1)n=n.left;else if(n.lf_left+n.piece.lineFeedCnt>t-1){const g=this.B(n,t-n.lf_left-2),f=this.B(n,t-n.lf_left-1);return i+=n.size_left,{node:n,remainder:Math.min(g+s-1,f),nodeStartOffset:i}}else if(n.lf_left+n.piece.lineFeedCnt===t-1){const g=this.B(n,t-n.lf_left-2);if(g+s-1<=n.piece.length)return{node:n,remainder:g+s-1,nodeStartOffset:i};s-=n.piece.length-g;break}else t-=n.lf_left+n.piece.lineFeedCnt,i+=n.size_left+n.piece.length,n=n.right;for(n=n.next();n!==A.$RC;){if(n.piece.lineFeedCnt>0){const g=this.B(n,0),f=this.J(n);return{node:n,remainder:Math.min(s-1,g),nodeStartOffset:f}}else if(n.piece.length>=s-1){const g=this.J(n);return{node:n,remainder:s-1,nodeStartOffset:g}}else s-=n.piece.length;n=n.next()}return null}I(t,s){if(t.piece.lineFeedCnt<1)return-1;const n=this.a[t.piece.bufferIndex],i=this.u(t.piece.bufferIndex,t.piece.start)+s;return n.buffer.charCodeAt(i)}J(t){if(!t)return 0;let s=t.size_left;for(;t!==this.root;)t.parent.right===t&&(s+=t.parent.size_left+t.parent.piece.length),t=t.parent;return s}K(){return!(this.f&&this.d===`
`)}L(t){if(typeof t=="string")return t.charCodeAt(0)===10;if(t===A.$RC||t.piece.lineFeedCnt===0)return!1;const s=t.piece,n=this.a[s.bufferIndex].lineStarts,i=s.start.line,g=n[i]+s.start.column;return i===n.length-1||n[i+1]>g+1?!1:this.a[s.bufferIndex].buffer.charCodeAt(g)===10}M(t){return typeof t=="string"?t.charCodeAt(t.length-1)===13:t===A.$RC||t.piece.lineFeedCnt===0?!1:this.I(t,t.piece.length-1)===13}N(t){if(this.K()&&this.L(t)){const s=t.prev();this.M(s)&&this.P(s,t)}}O(t){if(this.K()&&this.M(t)){const s=t.next();this.L(s)&&this.P(t,s)}}P(t,s){const n=[],i=this.a[t.piece.bufferIndex].lineStarts;let g;t.piece.end.column===0?g={line:t.piece.end.line-1,column:i[t.piece.end.line]-i[t.piece.end.line-1]-1}:g={line:t.piece.end.line,column:t.piece.end.column-1};const f=t.piece.length-1,l=t.piece.lineFeedCnt-1;t.piece=new D(t.piece.bufferIndex,t.piece.start,g,l,f),(0,A.$YC)(this,t,-1,-1),t.piece.length===0&&n.push(t);const b={line:s.piece.start.line+1,column:0},I=s.piece.length-1,S=this.t(s.piece.bufferIndex,b,s.piece.end);s.piece=new D(s.piece.bufferIndex,b,s.piece.end,S,I),(0,A.$YC)(this,s,-1,-1),s.piece.length===0&&n.push(s);const y=this.w(`\r
`);this.S(t,y[0]);for(let p=0;p<n.length;p++)(0,A.$WC)(this,n[p])}Q(t,s){if(this.K()&&this.M(t)){const n=s.next();if(this.L(n)){if(t+=`
`,n.piece.length===1)(0,A.$WC)(this,n);else{const i=n.piece,g={line:i.start.line+1,column:0},f=i.length-1,l=this.t(i.bufferIndex,g,i.end);n.piece=new D(i.bufferIndex,g,i.end,l,f),(0,A.$YC)(this,n,-1,-1)}return!0}}return!1}iterate(t,s){if(t===A.$RC)return s(A.$RC);const n=this.iterate(t.left,s);return n&&s(t)&&this.iterate(t.right,s)}R(t){if(t===A.$RC)return"";const s=this.a[t.piece.bufferIndex],n=t.piece,i=this.u(n.bufferIndex,n.start),g=this.u(n.bufferIndex,n.end);return s.buffer.substring(i,g)}getPieceContent(t){const s=this.a[t.bufferIndex],n=this.u(t.bufferIndex,t.start),i=this.u(t.bufferIndex,t.end);return s.buffer.substring(n,i)}S(t,s){const n=new A.$QC(s,A.NodeColor.Red);if(n.left=A.$RC,n.right=A.$RC,n.parent=A.$RC,n.size_left=0,n.lf_left=0,this.root===A.$RC)this.root=n,n.color=A.NodeColor.Black;else if(t.right===A.$RC)t.right=n,n.parent=t;else{const g=(0,A.$SC)(t.right);g.left=n,n.parent=g}return(0,A.$XC)(this,n),n}T(t,s){const n=new A.$QC(s,A.NodeColor.Red);if(n.left=A.$RC,n.right=A.$RC,n.parent=A.$RC,n.size_left=0,n.lf_left=0,this.root===A.$RC)this.root=n,n.color=A.NodeColor.Black;else if(t.left===A.$RC)t.left=n,n.parent=t;else{const i=(0,A.$TC)(t.left);i.right=n,n.parent=i}return(0,A.$XC)(this,n),n}U(t){let s="";return this.iterate(t,n=>(s+=this.R(n),!0)),s}}e.$$C=a}),define(ke[152],Ie([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$0=e.$00=void 0;class E{constructor(){this.a=new Map}removeDragOperationTransfer(O){if(O&&this.a.has(O)){const A=this.a.get(O);return this.a.delete(O),A}}addDragOperationTransfer(O,A){this.a.set(O,A)}}e.$00=E;class R{constructor(O){this.identifier=O}}e.$$0=R}),define(ke[153],Ie([8,9]),function(de,e){return de.create("vs/base/common/actions",e)}),define(ke[154],Ie([1,0,4,6,153]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=void 0,e.$kj=C;class O extends R.$Uc{constructor(u,D="",d="",r=!0,o){super(),this.j=this.B(new E.$he),this.onDidChange=this.j.event,this.z=!0,this.m=u,this.n=D,this.w=d,this.z=r,this.D=o}get id(){return this.m}get label(){return this.n}set label(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.j.fire({label:u}))}get tooltip(){return this.u||""}set tooltip(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.j.fire({tooltip:u}))}get class(){return this.w}set class(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.j.fire({class:u}))}get enabled(){return this.z}set enabled(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.j.fire({enabled:u}))}get checked(){return this.C}set checked(u){this.J(u)}J(u){this.C!==u&&(this.C=u,this.j.fire({checked:u}))}async run(u,D){this.D&&await this.D(u)}}e.$fj=O;class A extends R.$Uc{constructor(){super(...arguments),this.f=this.B(new E.$he),this.onWillRun=this.f.event,this.m=this.B(new E.$he),this.onDidRun=this.m.event}async run(u,D){if(!u.enabled)return;this.f.fire({action:u});let d;try{await this.u(u,D)}catch(r){d=r}this.m.fire({action:u,error:d})}async u(u,D){await u.run(D)}}e.$gj=A;class M{constructor(){this.id=M.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let D=[];for(const d of u)d.length&&(D.length?D=[...D,new M,...d]:D=d);return D}static{this.ID="vs.actions.separator"}async run(){}}e.$hj=M;class ${get actions(){return this.a}constructor(u,D,d,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=D,this.class=r,this.a=d}async run(){}}e.$ij=$;class c extends O{static{this.ID="vs.actions.empty"}constructor(){super(c.ID,P.localize(0,null),void 0,!1)}}e.$jj=c;function C(v){return{id:v.id,label:v.label,tooltip:v.tooltip??v.label,class:v.class,enabled:v.enabled??!0,checked:v.checked,run:async(...u)=>v.run(...u)}}}),define(ke[155],Ie([8,9]),function(de,e){return de.create("vs/base/common/date",e)}),define(ke[156],Ie([1,0,155]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=c,e.$8m=C,e.$9m=v;const R=60,P=R*60,O=P*24,A=O*7,M=O*30,$=O*365;function c(u,D,d,r){typeof u!="number"&&(u=u.getTime());const o=Math.round((new Date().getTime()-u)/1e3);if(o<-30)return(0,E.localize)(0,null,c(new Date().getTime()+o*1e3,!1));if(!r&&o<30)return(0,E.localize)(1,null);let a;return o<R?(a=o,D?a===1?d?(0,E.localize)(2,null,a):(0,E.localize)(3,null,a):d?(0,E.localize)(4,null,a):(0,E.localize)(5,null,a):a===1?d?(0,E.localize)(6,null,a):(0,E.localize)(7,null,a):d?(0,E.localize)(8,null,a):(0,E.localize)(9,null,a)):o<P?(a=Math.floor(o/R),D?a===1?d?(0,E.localize)(10,null,a):(0,E.localize)(11,null,a):d?(0,E.localize)(12,null,a):(0,E.localize)(13,null,a):a===1?d?(0,E.localize)(14,null,a):(0,E.localize)(15,null,a):d?(0,E.localize)(16,null,a):(0,E.localize)(17,null,a)):o<O?(a=Math.floor(o/P),D?a===1?d?(0,E.localize)(18,null,a):(0,E.localize)(19,null,a):d?(0,E.localize)(20,null,a):(0,E.localize)(21,null,a):a===1?d?(0,E.localize)(22,null,a):(0,E.localize)(23,null,a):d?(0,E.localize)(24,null,a):(0,E.localize)(25,null,a)):o<A?(a=Math.floor(o/O),D?a===1?(0,E.localize)(26,null,a):(0,E.localize)(27,null,a):a===1?(0,E.localize)(28,null,a):(0,E.localize)(29,null,a)):o<M?(a=Math.floor(o/A),D?a===1?d?(0,E.localize)(30,null,a):(0,E.localize)(31,null,a):d?(0,E.localize)(32,null,a):(0,E.localize)(33,null,a):a===1?d?(0,E.localize)(34,null,a):(0,E.localize)(35,null,a):d?(0,E.localize)(36,null,a):(0,E.localize)(37,null,a)):o<$?(a=Math.floor(o/M),D?a===1?d?(0,E.localize)(38,null,a):(0,E.localize)(39,null,a):d?(0,E.localize)(40,null,a):(0,E.localize)(41,null,a):a===1?d?(0,E.localize)(42,null,a):(0,E.localize)(43,null,a):d?(0,E.localize)(44,null,a):(0,E.localize)(45,null,a)):(a=Math.floor(o/$),D?a===1?d?(0,E.localize)(46,null,a):(0,E.localize)(47,null,a):d?(0,E.localize)(48,null,a):(0,E.localize)(49,null,a):a===1?d?(0,E.localize)(50,null,a):(0,E.localize)(51,null,a):d?(0,E.localize)(52,null,a):(0,E.localize)(53,null,a))}function C(u,D){const d=Math.abs(u/1e3);return d<1?D?(0,E.localize)(54,null,u):(0,E.localize)(55,null,u):d<R?D?(0,E.localize)(56,null,Math.round(u)/1e3):(0,E.localize)(57,null,Math.round(u)/1e3):d<P?D?(0,E.localize)(58,null,Math.round(u/(1e3*R))):(0,E.localize)(59,null,Math.round(u/(1e3*R))):d<O?D?(0,E.localize)(60,null,Math.round(u/(1e3*P))):(0,E.localize)(61,null,Math.round(u/(1e3*P))):(0,E.localize)(62,null,Math.round(u/(1e3*O)))}function v(u){return u.getFullYear()+"-"+String(u.getMonth()+1).padStart(2,"0")+"-"+String(u.getDate()).padStart(2,"0")+"T"+String(u.getHours()).padStart(2,"0")+":"+String(u.getMinutes()).padStart(2,"0")+":"+String(u.getSeconds()).padStart(2,"0")+"."+(u.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ke[157],Ie([8,9]),function(de,e){return de.create("vs/base/common/errorMessage",e)}),define(ke[48],Ie([1,0,18,15,157]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=$,e.$mj=c,e.$nj=C;function O(v,u){return u&&(v.stack||v.stacktrace)?P.localize(0,null,M(v),A(v.stack)||A(v.stacktrace)):M(v)}function A(v){return Array.isArray(v)?v.join(`
`):v}function M(v){return v.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${v.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?P.localize(1,null,v.message):v.message||P.localize(2,null)}function $(v=null,u=!1){if(!v)return P.localize(3,null);if(Array.isArray(v)){const D=E.$Hb(v),d=$(D[0],u);return D.length>1?P.localize(4,null,d,D.length):d}if(R.$ag(v))return v;if(v.detail){const D=v.detail;if(D.error)return O(D.error,u);if(D.exception)return O(D.exception,u)}return v.stack?O(v,u):v.message?v.message:P.localize(5,null)}function c(v){const u=v;return u instanceof Error&&Array.isArray(u.actions)}function C(v,u){let D;return typeof v=="string"?D=new Error(v):D=v,D.actions=u,D}}),define(ke[158],Ie([1,0,47,20]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=M,e.$pr=$,e.$qr=c,e.$rr=C,e.$sr=v,e.$tr=u,e.$ur=D,e.$vr=d,e.$wr=r,e.$xr=o,e.$yr=b,e.$zr=I,e.$Ar=S;const P=new E.$V(()=>{const y=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:y,collatorIsNumeric:y.resolvedOptions().numeric}}),O=new E.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new E.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function M(y,p,k=!1){const m=y||"",w=p||"",F=P.value.collator.compare(m,w);return P.value.collatorIsNumeric&&F===0&&m!==w?m<w?-1:1:F}function $(y,p){const k=O.value.collator;return y=y||"",p=p||"",s(k,y,p)}function c(y,p){const k=O.value.collator;return y=y||"",p=p||"",f(y,p)||s(k,y,p)}function C(y,p){const k=O.value.collator;return y=y||"",p=p||"",g(y,p)||s(k,y,p)}function v(y,p){return y=y||"",p=p||"",y===p?0:y<p?-1:1}function u(y,p){const[k,m]=h(y),[w,F]=h(p);let T=P.value.collator.compare(m,F);if(T===0){if(P.value.collatorIsNumeric&&m!==F)return m<F?-1:1;if(T=P.value.collator.compare(k,w),P.value.collatorIsNumeric&&T===0&&k!==w)return k<w?-1:1}return T}function D(y,p){y=y||"",p=p||"";const k=t(y),m=t(p),w=O.value.collator,F=A.value.collator;return s(F,k,m)||s(w,y,p)}function d(y,p){y=y||"",p=p||"";const k=t(y),m=t(p),w=O.value.collator,F=A.value.collator;return s(F,k,m)||f(y,p)||s(w,y,p)}function r(y,p){y=y||"",p=p||"";const k=t(y),m=t(p),w=O.value.collator,F=A.value.collator;return s(F,k,m)||g(y,p)||s(w,y,p)}function o(y,p){y=y||"",p=p||"";const k=t(y).toLowerCase(),m=t(p).toLowerCase();return k!==m?k<m?-1:1:y!==p?y<p?-1:1:0}const a=/^(.*?)(\.([^.]*))?$/;function h(y,p=!1){const k=y?a.exec(y):[];let m=[k&&k[1]||"",k&&k[3]||""];return p&&(!m[0]&&m[1]||m[0]&&m[0].charAt(0)===".")&&(m=[m[0]+"."+m[1],""]),m}function t(y){const p=y?a.exec(y):[];return p&&p[1]&&p[1].charAt(0)!=="."&&p[3]||""}function s(y,p,k){const m=y.compare(p,k);return m!==0?m:p.length!==k.length?p.length<k.length?-1:1:0}function n(y){const p=y.charAt(0);return p.toLocaleUpperCase()!==p}function i(y){const p=y.charAt(0);return p.toLocaleLowerCase()!==p}function g(y,p){return n(y)&&i(p)?-1:i(y)&&n(p)?1:0}function f(y,p){return i(y)&&n(p)?-1:n(y)&&i(p)?1:0}function l(y,p,k=!1){return k||(y=y&&y.toLowerCase(),p=p&&p.toLowerCase()),y===p?0:y<p?-1:1}function b(y,p,k=!1){const m=y.split(R.sep),w=p.split(R.sep),F=m.length-1,T=w.length-1;let G,q;for(let V=0;;V++){if(G=F===V,q=T===V,G&&q)return M(m[V],w[V],k);if(G)return-1;if(q)return 1;const N=l(m[V],w[V],k);if(N!==0)return N}}function I(y,p,k){const m=y.toLowerCase(),w=p.toLowerCase(),F=S(y,p,k);if(F)return F;const T=m.endsWith(k),G=w.endsWith(k);if(T!==G)return T?-1:1;const q=M(m,w);return q!==0?q:m.localeCompare(w)}function S(y,p,k){const m=y.toLowerCase(),w=p.toLowerCase(),F=m.startsWith(k),T=w.startsWith(k);if(F!==T)return F?-1:1;if(F&&T){if(m.length<w.length)return-1;if(m.length>w.length)return 1}return 0}}),define(ke[53],Ie([1,0,28,20,21,13,15]),function(de,e,E,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sg=M,e.$tg=$,e.$ug=c,e.$vg=C,e.$wg=v,e.$xg=r,e.$yg=o,e.$zg=a,e.$Ag=h,e.$Bg=t,e.$Cg=s,e.$Dg=n,e.$Eg=i,e.$Fg=g,e.$Gg=f,e.$Hg=l,e.$Ig=S;function M(y){return y===E.CharCode.Slash||y===E.CharCode.Backslash}function $(y){return y.replace(/[\\/]/g,R.$gc.sep)}function c(y){return y.indexOf("/")===-1&&(y=$(y)),/^[a-zA-Z]:(\/|$)/.test(y)&&(y="/"+y),y}function C(y,p=R.$gc.sep){if(!y)return"";const k=y.length,m=y.charCodeAt(0);if(M(m)){if(M(y.charCodeAt(1))&&!M(y.charCodeAt(2))){let F=3;const T=F;for(;F<k&&!M(y.charCodeAt(F));F++);if(T!==F&&!M(y.charCodeAt(F+1))){for(F+=1;F<k;F++)if(M(y.charCodeAt(F)))return y.slice(0,F+1).replace(/[\\/]/g,p)}}return p}else if(h(m)&&y.charCodeAt(1)===E.CharCode.Colon)return M(y.charCodeAt(2))?y.slice(0,2)+p:y.slice(0,2);let w=y.indexOf("://");if(w!==-1){for(w+=3;w<k;w++)if(M(y.charCodeAt(w)))return y.slice(0,w+1)}return""}function v(y){if(!P.$i||!y||y.length<5)return!1;let p=y.charCodeAt(0);if(p!==E.CharCode.Backslash||(p=y.charCodeAt(1),p!==E.CharCode.Backslash))return!1;let k=2;const m=k;for(;k<y.length&&(p=y.charCodeAt(k),p!==E.CharCode.Backslash);k++);return!(m===k||(p=y.charCodeAt(k+1),isNaN(p)||p===E.CharCode.Backslash))}const u=/[\\/:\*\?"<>\|]/g,D=/[/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function r(y,p=P.$i){const k=p?u:D;return!(!y||y.length===0||/^\s+$/.test(y)||(k.lastIndex=0,k.test(y))||p&&d.test(y)||y==="."||y===".."||p&&y[y.length-1]==="."||p&&y.length!==y.trim().length||y.length>255)}function o(y,p,k){const m=y===p;return!k||m?m:!y||!p?!1:(0,O.$Bf)(y,p)}function a(y,p,k,m=R.sep){if(y===p)return!0;if(!y||!p||p.length>y.length)return!1;if(k){if(!(0,O.$Cf)(y,p))return!1;if(p.length===y.length)return!0;let F=p.length;return p.charAt(p.length-1)===m&&F--,y.charAt(F)===m}return p.charAt(p.length-1)!==m&&(p+=m),y.indexOf(p)===0}function h(y){return y>=E.CharCode.A&&y<=E.CharCode.Z||y>=E.CharCode.a&&y<=E.CharCode.z}function t(y,p){return P.$i&&y.endsWith(":")&&(y+=R.sep),(0,R.$ic)(y)||(y=(0,R.$jc)(p,y)),y=(0,R.$hc)(y),s(y)}function s(y){return P.$i?(y=(0,O.$jf)(y,R.sep),y.endsWith(":")&&(y+=R.sep)):(y=(0,O.$jf)(y,R.sep),y||(y=R.sep)),y}function n(y){const p=(0,R.$hc)(y);return P.$i?y.length>3?!1:i(p)&&(y.length===2||p.charCodeAt(2)===E.CharCode.Backslash):p===R.$gc.sep}function i(y,p=P.$i){return p?h(y.charCodeAt(0))&&y.charCodeAt(1)===E.CharCode.Colon:!1}function g(y,p=P.$i){return i(y,p)?y[0]:void 0}function f(y,p,k){return p.length>y.length?-1:y===p?0:(k&&(y=y.toLowerCase(),p=p.toLowerCase()),y.indexOf(p))}function l(y){const p=y.split(":");let k,m,w;for(const F of p){const T=Number(F);(0,A.$eg)(T)?m===void 0?m=T:w===void 0&&(w=T):k=k?[k,F].join(":"):F}if(!k)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:k,line:m!==void 0?m:void 0,column:w!==void 0?w:m!==void 0?1:void 0}}const b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",I="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function S(y,p,k=8){let m="";for(let F=0;F<k;F++){let T;F===0&&P.$i&&!p&&(k===3||k===4)?T=I:T=b,m+=T.charAt(Math.floor(Math.random()*T.length))}let w;return p?w=`${p}-${m}`:w=m,y?(0,R.$jc)(y,w):w}}),define(ke[73],Ie([1,0,20]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ys=void 0,e.$Zs=O,e.$1s=A,e.$2s=M,e.$3s=c,e.$Ys=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const R={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function O(C){const v=(0,E.$oc)(C),u=R[v.toLowerCase()];return u!==void 0?u:A(C)}function A(C){const v=(0,E.$oc)(C);return P[v.toLowerCase()]}function M(C){for(const v in P)if(P[v]===C)return v}const $=/^(.+)\/(.+?)(;.+)?$/;function c(C,v){const u=$.exec(C);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:v?void 0:C}}),define(ke[49],Ie([1,0,23,2,37]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=O,e.$9h=A,e.$0h=$;function O(c){return JSON.stringify(c,M)}function A(c){let C=JSON.parse(c);return C=$(C),C}function M(c,C){return C instanceof RegExp?{$mid:P.MarshalledId.Regexp,source:C.source,flags:C.flags}:C}function $(c,C=0){if(!c||C>200)return c;if(typeof c=="object"){switch(c.$mid){case P.MarshalledId.Uri:return R.URI.revive(c);case P.MarshalledId.Regexp:return new RegExp(c.source,c.flags);case P.MarshalledId.Date:return new Date(c.source)}if(c instanceof E.$Je||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let v=0;v<c.length;++v)c[v]=$(c[v],C+1);else for(const v in c)Object.hasOwnProperty.call(c,v)&&(c[v]=$(c[v],C+1))}return c}}),define(ke[16],Ie([1,0,14,21,13,2,20]),function(de,e,E,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Ng=e.$Mg=e.$Lg=e.Schemas=void 0,e.$Jg=$,e.$Kg=c,e.$Og=v;var M;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeManagedRemoteResource="vscode-managed-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.vscodeChatCodeBlock="vscode-chat-code-block",d.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",d.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",d.vscodeChatSesssion="vscode-chat-editor",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm",d.commentsInput="comment",d.codeSetting="code-setting"})(M||(e.Schemas=M={}));function $(d,r){return O.URI.isUri(d)?(0,P.$Bf)(d.scheme,r):(0,P.$Cf)(d,r+":")}function c(d,...r){return r.some(o=>$(d,o))}e.$Lg="vscode-tkn",e.$Mg="tkn";class C{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(r){this.d=r}setDelegate(r){this.e=r}setServerRootPath(r,o){this.f=v(r,o)}getServerRootPath(){return this.f}get g(){return A.$gc.join(this.f,M.vscodeRemoteResource)}set(r,o,a){this.a[r]=o,this.b[r]=a}setConnectionToken(r,o){this.c[r]=o}getPreferredWebSchema(){return this.d}rewrite(r){if(this.e)try{return this.e(r)}catch(n){return E.$1(n),r}const o=r.authority;let a=this.a[o];a&&a.indexOf(":")!==-1&&a.indexOf("[")===-1&&(a=`[${a}]`);const h=this.b[o],t=this.c[o];let s=`path=${encodeURIComponent(r.path)}`;return typeof t=="string"&&(s+=`&${e.$Mg}=${encodeURIComponent(t)}`),O.URI.from({scheme:R.$o?this.d:M.vscodeRemoteResource,authority:`${a}:${h}`,path:this.g,query:s})}}e.$Ng=new C;function v(d,r){return A.$gc.join(r??"/",`${d.quality??"oss"}-${d.commit??"dev"}`)}e.$Pg="vs/../../extensions",e.$Qg="vs/../../node_modules",e.$Rg="vs/../../node_modules.asar",e.$Sg="vs/../../node_modules.asar.unpacked",e.$Tg="vscode-app";class u{static{this.a=e.$Tg}asBrowserUri(r){const o=this.b(r,de);return this.uriToBrowserUri(o)}uriToBrowserUri(r){return r.scheme===M.vscodeRemote?e.$Ng.rewrite(r):r.scheme===M.file&&(R.$m||R.$q===`${M.vscodeFileResource}://${u.a}`)?r.with({scheme:M.vscodeFileResource,authority:r.authority||u.a,query:null,fragment:null}):r}asFileUri(r){const o=this.b(r,de);return this.uriToFileUri(o)}uriToFileUri(r){return r.scheme===M.vscodeFileResource?r.with({scheme:M.file,authority:r.authority!==u.a?r.authority:null,query:null,fragment:null}):r}b(r,o){return O.URI.isUri(r)?r:O.URI.parse(o.toUrl(r))}}e.$Ug=new u;var D;(function(d){const r=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(r.get("3"));const o="vscode-coi";function a(t){let s;typeof t=="string"?s=new URL(t).searchParams:t instanceof URL?s=t.searchParams:O.URI.isUri(t)&&(s=new URL(t.toString(!0)).searchParams);const n=s?.get(o);if(n)return r.get(n)}d.getHeadersFromQuery=a;function h(t,s,n){if(!globalThis.crossOriginIsolated)return;const i=s&&n?"3":n?"2":"1";t instanceof URLSearchParams?t.set(o,i):t[o]=i}d.addSearchParam=h})(D||(e.COI=D={}))}),define(ke[24],Ie([1,0,28,53,16,20,21,13,2]),function(de,e,E,R,P,O,A,M,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=void 0,e.$2g=c,e.$kh=v,e.$lh=D;function c(d){return(0,$.$wc)(d,!0)}class C{constructor(r){this.a=r}compare(r,o,a=!1){return r===o?0:(0,M.$uf)(this.getComparisonKey(r,a),this.getComparisonKey(o,a))}isEqual(r,o,a=!1){return r===o?!0:!r||!o?!1:this.getComparisonKey(r,a)===this.getComparisonKey(o,a)}getComparisonKey(r,o=!1){return r.with({path:this.a(r)?r.path.toLowerCase():void 0,fragment:o?null:void 0}).toString()}ignorePathCasing(r){return this.a(r)}isEqualOrParent(r,o,a=!1){if(r.scheme===o.scheme){if(r.scheme===P.Schemas.file)return R.$zg(c(r),c(o),this.a(r))&&r.query===o.query&&(a||r.fragment===o.fragment);if((0,e.$gh)(r.authority,o.authority))return R.$zg(r.path,o.path,this.a(r),"/")&&r.query===o.query&&(a||r.fragment===o.fragment)}return!1}joinPath(r,...o){return $.URI.joinPath(r,...o)}basenameOrAuthority(r){return(0,e.$$g)(r)||r.authority}basename(r){return O.$gc.basename(r.path)}extname(r){return O.$gc.extname(r.path)}dirname(r){if(r.path.length===0)return r;let o;return r.scheme===P.Schemas.file?o=$.URI.file(O.$mc(c(r))).path:(o=O.$gc.dirname(r.path),r.authority&&o.length&&o.charCodeAt(0)!==E.CharCode.Slash&&(console.error(`dirname("${r.toString})) resulted in a relative path`),o="/")),r.with({path:o})}normalizePath(r){if(!r.path.length)return r;let o;return r.scheme===P.Schemas.file?o=$.URI.file(O.$hc(c(r))).path:o=O.$gc.normalize(r.path),r.with({path:o})}relativePath(r,o){if(r.scheme!==o.scheme||!(0,e.$gh)(r.authority,o.authority))return;if(r.scheme===P.Schemas.file){const t=O.$lc(c(r),c(o));return A.$i?R.$tg(t):t}let a=r.path||"/";const h=o.path||"/";if(this.a(r)){let t=0;for(const s=Math.min(a.length,h.length);t<s&&!(a.charCodeAt(t)!==h.charCodeAt(t)&&a.charAt(t).toLowerCase()!==h.charAt(t).toLowerCase());t++);a=h.substr(0,t)+a.substr(t)}return O.$gc.relative(a,h)}resolvePath(r,o){if(r.scheme===P.Schemas.file){const a=$.URI.file(O.$kc(c(r),o));return r.with({authority:a.authority,path:a.path})}return o=R.$ug(o),r.with({path:O.$gc.resolve(r.path,o)})}isAbsolutePath(r){return!!r.path&&r.path[0]==="/"}isEqualAuthority(r,o){return r===o||r!==void 0&&o!==void 0&&(0,M.$Bf)(r,o)}hasTrailingPathSeparator(r,o=O.sep){if(r.scheme===P.Schemas.file){const a=c(r);return a.length>R.$vg(a).length&&a[a.length-1]===o}else{const a=r.path;return a.length>1&&a.charCodeAt(a.length-1)===E.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(r.fsPath)}}removeTrailingPathSeparator(r,o=O.sep){return(0,e.$hh)(r,o)?r.with({path:r.path.substr(0,r.path.length-1)}):r}addTrailingPathSeparator(r,o=O.sep){let a=!1;if(r.scheme===P.Schemas.file){const h=c(r);a=h!==void 0&&h.length===R.$vg(h).length&&h[h.length-1]===o}else{o="/";const h=r.path;a=h.length===1&&h.charCodeAt(h.length-1)===E.CharCode.Slash}return!a&&!(0,e.$hh)(r,o)?r.with({path:r.path+"/"}):r}}e.$3g=C,e.$4g=new C(()=>!1),e.$5g=new C(d=>d.scheme===P.Schemas.file?!A.$k:!0),e.$6g=new C(d=>!0),e.$7g=e.$4g.isEqual.bind(e.$4g),e.$8g=e.$4g.isEqualOrParent.bind(e.$4g),e.$9g=e.$4g.getComparisonKey.bind(e.$4g),e.$0g=e.$4g.basenameOrAuthority.bind(e.$4g),e.$$g=e.$4g.basename.bind(e.$4g),e.$_g=e.$4g.extname.bind(e.$4g),e.$ah=e.$4g.dirname.bind(e.$4g),e.$bh=e.$4g.joinPath.bind(e.$4g),e.$ch=e.$4g.normalizePath.bind(e.$4g),e.$dh=e.$4g.relativePath.bind(e.$4g),e.$eh=e.$4g.resolvePath.bind(e.$4g),e.$fh=e.$4g.isAbsolutePath.bind(e.$4g),e.$gh=e.$4g.isEqualAuthority.bind(e.$4g),e.$hh=e.$4g.hasTrailingPathSeparator.bind(e.$4g),e.$ih=e.$4g.removeTrailingPathSeparator.bind(e.$4g),e.$jh=e.$4g.addTrailingPathSeparator.bind(e.$4g);function v(d,r){const o=[];for(let a=0;a<d.length;a++){const h=r(d[a]);d.some((t,s)=>s===a?!1:(0,e.$8g)(h,r(t)))||o.push(d[a])}return o}var u;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function r(o){const a=new Map;o.path.substring(o.path.indexOf(";")+1,o.path.lastIndexOf(";")).split(";").forEach(s=>{const[n,i]=s.split(":");n&&i&&a.set(n,i)});const t=o.path.substring(0,o.path.indexOf(";"));return t&&a.set(d.META_DATA_MIME,t),a}d.parseMetaData=r})(u||(e.DataUri=u={}));function D(d,r,o){if(r){let a=d.path;return a&&a[0]!==O.$gc.sep&&(a=O.$gc.sep+a),d.with({scheme:o,authority:r,path:a})}return d.with({scheme:o})}}),define(ke[11],Ie([1,0,22,14,4,6,24,21,144,47]),function(de,e,E,R,P,O,A,M,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.Promises=e.$Xh=e.$Wh=e.$Vh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=void 0,e.$mh=C,e.$nh=v,e.$oh=u,e.$ph=D,e.$qh=d,e.$rh=r,e.$sh=o,e.$th=a,e.$Bh=I,e.$Ch=S,e.$Dh=y,e.$Eh=p,e.$Fh=k,e.$Uh=be,e.$3h=he;function C(ae){return!!ae&&typeof ae.then=="function"}function v(ae){const Y=new E.$se,x=ae(Y.token),me=new Promise((ge,Te)=>{const Be=Y.token.onCancellationRequested(()=>{Be.dispose(),Te(new R.$5)});Promise.resolve(x).then(Ee=>{Be.dispose(),Y.dispose(),ge(Ee)},Ee=>{Be.dispose(),Y.dispose(),Te(Ee)})});return new class{cancel(){Y.cancel(),Y.dispose()}then(ge,Te){return me.then(ge,Te)}catch(ge){return this.then(void 0,ge)}finally(ge){return me.finally(ge)}}}function u(ae,Y,x){return new Promise((me,ge)=>{const Te=Y.onCancellationRequested(()=>{Te.dispose(),me(x)});ae.then(me,ge).finally(()=>Te.dispose())})}function D(ae,Y){return new Promise((x,me)=>{const ge=Y.onCancellationRequested(()=>{ge.dispose(),me(new R.$5)});ae.then(x,me).finally(()=>ge.dispose())})}async function d(ae){let Y=-1;const x=ae.map((me,ge)=>me.then(Te=>(Y=ge,Te)));try{return await Promise.race(x)}finally{ae.forEach((me,ge)=>{ge!==Y&&me.cancel()})}}function r(ae,Y,x){let me;const ge=setTimeout(()=>{me?.(void 0),x?.()},Y);return Promise.race([ae.finally(()=>clearTimeout(ge)),new Promise(Te=>me=Te)])}function o(ae){return new Promise((Y,x)=>{const me=ae();C(me)?me.then(Y,x):Y(me)})}function a(){let ae,Y;return{promise:new Promise((me,ge)=>{ae=me,Y=ge}),resolve:ae,reject:Y}}class h{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Y){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Y,!this.b){const x=()=>{if(this.b=null,this.f)return;const me=this.queue(this.d);return this.d=null,me};this.b=new Promise(me=>{this.a.then(x,x).then(me)})}return new Promise((x,me)=>{this.b.then(x,me)})}return this.a=Y(),new Promise((x,me)=>{this.a.then(ge=>{this.a=null,x(ge)},ge=>{this.a=null,me(ge)})})}dispose(){this.f=!0}}e.$uh=h;class t{constructor(){this.a=Promise.resolve(null)}queue(Y){return this.a=this.a.then(()=>Y(),()=>Y())}}e.$vh=t;class s{constructor(){this.a=new Map}queue(Y,x){const ge=(this.a.get(Y)??Promise.resolve()).catch(()=>{}).then(x).finally(()=>{this.a.get(Y)===ge&&this.a.delete(Y)});return this.a.set(Y,ge),ge}}e.$wh=s;const n=(ae,Y)=>{let x=!0;const me=setTimeout(()=>{x=!1,Y()},ae);return{isTriggered:()=>x,dispose:()=>{clearTimeout(me),x=!1}}},i=ae=>{let Y=!0;return queueMicrotask(()=>{Y&&(Y=!1,ae())}),{isTriggered:()=>Y,dispose:()=>{Y=!1}}};class g{constructor(Y){this.defaultDelay=Y,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Y,x=this.defaultDelay){this.g=Y,this.h(),this.b||(this.b=new Promise((ge,Te)=>{this.d=ge,this.f=Te}).then(()=>{if(this.b=null,this.d=null,this.g){const ge=this.g;return this.g=null,ge()}}));const me=()=>{this.a=null,this.d?.(null)};return this.a=x===$.$ce?i(me):n(x,me),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new R.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$xh=g;class f{constructor(Y){this.a=new g(Y),this.b=new h}trigger(Y,x){return this.a.trigger(()=>this.b.queue(Y),x)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$yh=f;class l{constructor(){this.a=!1,this.b=new Promise((Y,x)=>{this.d=Y})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$zh=l;class b extends l{constructor(Y){super(),this.f=setTimeout(()=>this.open(),Y)}open(){clearTimeout(this.f),super.open()}}e.$Ah=b;function I(ae,Y){return Y?new Promise((x,me)=>{const ge=setTimeout(()=>{Te.dispose(),x()},ae),Te=Y.onCancellationRequested(()=>{clearTimeout(ge),Te.dispose(),me(new R.$5)})}):v(x=>I(ae,x))}function S(ae,Y=0,x){const me=setTimeout(()=>{ae(),x&&ge.dispose()},Y),ge=(0,O.$Sc)(()=>{clearTimeout(me),x?.deleteAndLeak(ge)});return x?.add(ge),ge}function y(ae){const Y=[];let x=0;const me=ae.length;function ge(){return x<me?ae[x++]():null}function Te(Be){Be!=null&&Y.push(Be);const Ee=ge();return Ee?Ee.then(Te):Promise.resolve(Y)}return Promise.resolve(null).then(Te)}function p(ae,Y=me=>!!me,x=null){let me=0;const ge=ae.length,Te=()=>{if(me>=ge)return Promise.resolve(x);const Be=ae[me++];return Promise.resolve(Be()).then(Re=>Y(Re)?Promise.resolve(Re):Te())};return Te()}function k(ae,Y=me=>!!me,x=null){if(ae.length===0)return Promise.resolve(x);let me=ae.length;const ge=()=>{me=-1;for(const Te of ae)Te.cancel?.()};return new Promise((Te,Be)=>{for(const Ee of ae)Ee.then(Re=>{--me>=0&&Y(Re)?(ge(),Te(Re)):me===0&&Te(x)}).catch(Re=>{--me>=0&&(ge(),Be(Re))})})}class m{constructor(Y){this.a=0,this.b=!1,this.f=Y,this.g=[],this.d=0,this.h=new P.$he}whenIdle(){return this.size>0?P.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Y){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((x,me)=>{this.g.push({factory:Y,c:x,e:me}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Y=this.g.shift();this.d++;const x=Y.factory();x.then(Y.c,Y.e),x.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Gh=m;class w extends m{constructor(){super(1)}}e.$Hh=w;class F{constructor(){this.a=new oe,this.b=0}queue(Y){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Y())):this.a.run(this.b++,Y())}}e.$Ih=F;class T{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Y=new se;return this.b.add(Y),Y.p}g(){for(const[,Y]of this.a)if(Y.size>0)return!1;return!0}queueSize(Y,x=A.$4g){const me=x.getComparisonKey(Y);return this.a.get(me)?.size??0}queueFor(Y,x,me=A.$4g){const ge=me.getComparisonKey(Y);let Te=this.a.get(ge);if(!Te){Te=new w;const Be=this.f++,Ee=P.Event.once(Te.onDrained)(()=>{Te?.dispose(),this.a.delete(ge),this.h(),this.d?.deleteAndDispose(Be),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new O.$4c),this.d.set(Be,Ee),this.a.set(ge,Te)}return Te.queue(x)}h(){this.g()&&this.j()}j(){for(const Y of this.b)Y.complete();this.b.clear()}dispose(){for(const[,Y]of this.a)Y.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Jh=T;class G{constructor(Y,x){this.b=!1,this.a=-1,typeof Y=="function"&&typeof x=="number"&&this.setIfNotSet(Y,x)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Y,x){if(this.b)throw new R.$cb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,Y()},x)}setIfNotSet(Y,x){if(this.b)throw new R.$cb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Y()},x))}}e.$Kh=G;class q{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Y,x,me=globalThis){if(this.f)throw new R.$cb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const ge=me.setInterval(()=>{Y()},x);this.d=(0,O.$Sc)(()=>{me.clearInterval(ge),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Lh=q;class V{constructor(Y,x){this.b=-1,this.a=Y,this.d=x,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Y=this.d){this.cancel(),this.b=setTimeout(this.f,Y)}get delay(){return this.d}set delay(Y){this.d=Y}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Mh=V;class N{constructor(Y,x){x%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.a=Y,this.b=x,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Y=this.b){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Y/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Nh=N;class L extends V{constructor(Y,x){super(Y,x),this.j=[]}work(Y){this.j.push(Y),this.isScheduled()||this.schedule()}h(){const Y=this.j;this.j=[],this.a?.(Y)}dispose(){this.j=[],super.dispose()}}e.$Oh=L;class Z extends O.$Uc{constructor(Y,x){super(),this.g=Y,this.h=x,this.a=[],this.b=this.B(new O.$Vc),this.f=!1}get pending(){return this.a.length}work(Y){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Y.length>this.g.maxBufferedWork)return!1}else if(this.pending+Y.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const x of Y)this.a.push(x);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new V(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Ph=Z,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Rh=(ae,Y)=>{(0,M.$B)(()=>{if(x)return;const me=Date.now()+15;Y(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,me-Date.now())}}))});let x=!1;return{dispose(){x||(x=!0)}}}:e.$Rh=(ae,Y,x)=>{const me=ae.requestIdleCallback(Y,typeof x=="number"?{timeout:x}:void 0);let ge=!1;return{dispose(){ge||(ge=!0,ae.cancelIdleCallback(me))}}},e.$Qh=ae=>(0,e.$Rh)(globalThis,ae)}();class re{constructor(Y,x){this.g=!1,this.d=()=>{try{this.j=x()}catch(me){this.l=me}finally{this.g=!0}},this.f=(0,e.$Rh)(Y,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Sh=re;class fe extends re{constructor(Y){super(globalThis,Y)}}e.$Th=fe;async function be(ae,Y,x){let me;for(let ge=0;ge<x;ge++)try{return await ae()}catch(Te){me=Te,await I(Y)}throw me}class oe{isRunning(Y){return typeof Y=="number"?this.a?.taskId===Y:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Y,x,me){return this.a={taskId:Y,cancel:()=>me?.(),promise:x},x.then(()=>this.d(Y),()=>this.d(Y)),x}d(Y){this.a&&Y===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Y=this.b;this.b=void 0,Y.run().then(Y.promiseResolve,Y.promiseReject)}}queue(Y){if(this.b)this.b.run=Y;else{const{promise:x,resolve:me,reject:ge}=a();this.b={run:Y,promise:x,promiseResolve:me,promiseReject:ge}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Vh=oe;class pe{constructor(Y,x=()=>Date.now()){this.d=Y,this.f=x,this.a=0,this.b=0}increment(){const Y=this.f();return Y-this.a>this.d&&(this.a=Y,this.b=0),this.b++,this.b}}e.$Wh=pe;var $e;(function(ae){ae[ae.Resolved=0]="Resolved",ae[ae.Rejected=1]="Rejected"})($e||($e={}));class se{get isRejected(){return this.d?.outcome===$e.Rejected}get isResolved(){return this.d?.outcome===$e.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===$e.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((Y,x)=>{this.a=Y,this.b=x})}complete(Y){return new Promise(x=>{this.a(Y),this.d={outcome:$e.Resolved,value:Y},x()})}error(Y){return new Promise(x=>{this.b(Y),this.d={outcome:$e.Rejected,value:Y},x()})}cancel(){return this.error(new R.$5)}}e.$Xh=se;var Ce;(function(ae){async function Y(me){let ge;const Te=await Promise.all(me.map(Be=>Be.then(Ee=>Ee,Ee=>{ge||(ge=Ee)})));if(typeof ge<"u")throw ge;return Te}ae.settled=Y;function x(me){return new Promise(async(ge,Te)=>{try{await me(ge,Te)}catch(Be){Te(Be)}})}ae.withAsyncBody=x})(Ce||(e.Promises=Ce={}));class Fe{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Y){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Y.then(x=>(this.a=x,this.d=!0,x),x=>{throw this.b=x,this.d=!0,x})}requireValue(){if(!this.d)throw new R.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Yh=Fe;class X{constructor(Y){this.b=Y,this.a=new c.$V(()=>new Fe(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Zh=X;var W;(function(ae){ae[ae.Initial=0]="Initial",ae[ae.DoneOK=1]="DoneOK",ae[ae.DoneError=2]="DoneError"})(W||(W={}));class ie{static fromArray(Y){return new ie(x=>{x.emitMany(Y)})}static fromPromise(Y){return new ie(async x=>{x.emitMany(await Y)})}static fromPromises(Y){return new ie(async x=>{await Promise.all(Y.map(async me=>x.emitOne(await me)))})}static merge(Y){return new ie(async x=>{await Promise.all(Y.map(async me=>{for await(const ge of me)x.emitOne(ge)}))})}static{this.EMPTY=ie.fromArray([])}constructor(Y,x){this.a=W.Initial,this.b=[],this.d=null,this.f=x,this.g=new P.$he,queueMicrotask(async()=>{const me={emitOne:ge=>this.h(ge),emitMany:ge=>this.j(ge),reject:ge=>this.l(ge)};try{await Promise.resolve(Y(me)),this.k()}catch(ge){this.l(ge)}finally{me.emitOne=void 0,me.emitMany=void 0,me.reject=void 0}})}[Symbol.asyncIterator](){let Y=0;return{next:async()=>{do{if(this.a===W.DoneError)throw this.d;if(Y<this.b.length)return{done:!1,value:this.b[Y++]};if(this.a===W.DoneOK)return{done:!0,value:void 0};await P.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(Y,x){return new ie(async me=>{for await(const ge of Y)me.emitOne(x(ge))})}map(Y){return ie.map(this,Y)}static filter(Y,x){return new ie(async me=>{for await(const ge of Y)x(ge)&&me.emitOne(ge)})}filter(Y){return ie.filter(this,Y)}static coalesce(Y){return ie.filter(Y,x=>!!x)}coalesce(){return ie.coalesce(this)}static async toPromise(Y){const x=[];for await(const me of Y)x.push(me);return x}toPromise(){return ie.toPromise(this)}h(Y){this.a===W.Initial&&(this.b.push(Y),this.g.fire())}j(Y){this.a===W.Initial&&(this.b=this.b.concat(Y),this.g.fire())}k(){this.a===W.Initial&&(this.a=W.DoneOK,this.g.fire())}l(Y){this.a===W.Initial&&(this.a=W.DoneError,this.d=Y,this.g.fire())}}e.$1h=ie;class Se extends ie{constructor(Y,x){super(x),this.m=Y}cancel(){this.m.cancel()}}e.$2h=Se;function he(ae){const Y=new E.$se,x=ae(Y.token);return new Se(Y,async me=>{const ge=Y.token.onCancellationRequested(()=>{ge.dispose(),Y.dispose(),me.reject(new R.$5)});try{for await(const Te of x){if(Y.token.isCancellationRequested)return;me.emitOne(Te)}ge.dispose(),Y.dispose()}catch(Te){ge.dispose(),Y.dispose(),me.reject(Te)}})}class we{constructor(Y){this.a=new se,this.b=new ie(ge=>{if(x){ge.reject(x);return}return me&&ge.emitMany(me),this.d=Te=>ge.reject(Te),this.f=Te=>ge.emitOne(Te),this.a.p},Y);let x,me;this.f=ge=>{me||(me=[]),me.push(ge)},this.d=ge=>{x||(x=ge)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Y){this.d(Y),this.a.complete()}emitOne(Y){this.f(Y)}}e.$4h=we}),define(ke[41],Ie([1,0,18,11,28,53,29,20,21,13]),function(de,e,E,R,P,O,A,M,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$qk=void 0,e.$pk=C,e.$sk=r,e.$tk=F,e.$uk=T,e.$vk=G,e.$wk=q,e.$xk=V,e.$yk=re;function C(){return Object.create(null)}e.$qk="**",e.$rk="/";const v="[/\\\\]",u="[^/\\\\]",D=/\//g;function d(fe,be){switch(fe){case 0:return"";case 1:return`${u}*?`;default:return`(?:${v}|${u}+${v}${be?`|${v}${u}+`:""})*?`}}function r(fe,be){if(!fe)return[];const oe=[];let pe=!1,$e=!1,se="";for(const Ce of fe){switch(Ce){case be:if(!pe&&!$e){oe.push(se),se="";continue}break;case"{":pe=!0;break;case"}":pe=!1;break;case"[":$e=!0;break;case"]":$e=!1;break}se+=Ce}return se&&oe.push(se),oe}function o(fe){if(!fe)return"";let be="";const oe=r(fe,e.$rk);if(oe.every(pe=>pe===e.$qk))be=".*";else{let pe=!1;oe.forEach(($e,se)=>{if($e===e.$qk){if(pe)return;be+=d(2,se===oe.length-1)}else{let Ce=!1,Fe="",X=!1,W="";for(const ie of $e){if(ie!=="}"&&Ce){Fe+=ie;continue}if(X&&(ie!=="]"||!W)){let Se;ie==="-"?Se=ie:(ie==="^"||ie==="!")&&!W?Se="^":ie===e.$rk?Se="":Se=(0,c.$df)(ie),W+=Se;continue}switch(ie){case"{":Ce=!0;continue;case"[":X=!0;continue;case"}":{const he=`(?:${r(Fe,",").map(we=>o(we)).join("|")})`;be+=he,Ce=!1,Fe="";break}case"]":{be+="["+W+"]",X=!1,W="";break}case"?":be+=u;continue;case"*":be+=d(1);continue;default:be+=(0,c.$df)(ie)}}se<oe.length-1&&(oe[se+1]!==e.$qk||se+2<oe.length)&&(be+=v)}pe=$e===e.$qk})}return be}const a=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,t=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,s=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,n=/^\*\*((\/[\w\.-]+)+)\/?$/,i=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,g=new A.$Dc(1e4),f=function(){return!1},l=function(){return null};function b(fe,be){if(!fe)return l;let oe;typeof fe!="string"?oe=fe.pattern:oe=fe,oe=oe.trim();const pe=`${oe}_${!!be.trimForExclusions}`;let $e=g.get(pe);if($e)return I($e,fe);let se;return a.test(oe)?$e=y(oe.substr(4),oe):(se=h.exec(S(oe,be)))?$e=p(se[1],oe):(be.trimForExclusions?s:t).test(oe)?$e=k(oe,be):(se=n.exec(S(oe,be)))?$e=m(se[1].substr(1),oe,!0):(se=i.exec(S(oe,be)))?$e=m(se[1],oe,!1):$e=w(oe),g.set(pe,$e),I($e,fe)}function I(fe,be){if(typeof be=="string")return fe;const oe=function(pe,$e){return(0,O.$zg)(pe,be.base,!$.$k)?fe((0,c.$if)(pe.substr(be.base.length),M.sep),$e):null};return oe.allBasenames=fe.allBasenames,oe.allPaths=fe.allPaths,oe.basenames=fe.basenames,oe.patterns=fe.patterns,oe}function S(fe,be){return be.trimForExclusions&&fe.endsWith("/**")?fe.substr(0,fe.length-2):fe}function y(fe,be){return function(oe,pe){return typeof oe=="string"&&oe.endsWith(fe)?be:null}}function p(fe,be){const oe=`/${fe}`,pe=`\\${fe}`,$e=function(Ce,Fe){return typeof Ce!="string"?null:Fe?Fe===fe?be:null:Ce===fe||Ce.endsWith(oe)||Ce.endsWith(pe)?be:null},se=[fe];return $e.basenames=se,$e.patterns=[be],$e.allBasenames=se,$e}function k(fe,be){const oe=Z(fe.slice(1,-1).split(",").map(Fe=>b(Fe,be)).filter(Fe=>Fe!==l),fe),pe=oe.length;if(!pe)return l;if(pe===1)return oe[0];const $e=function(Fe,X){for(let W=0,ie=oe.length;W<ie;W++)if(oe[W](Fe,X))return fe;return null},se=oe.find(Fe=>!!Fe.allBasenames);se&&($e.allBasenames=se.allBasenames);const Ce=oe.reduce((Fe,X)=>X.allPaths?Fe.concat(X.allPaths):Fe,[]);return Ce.length&&($e.allPaths=Ce),$e}function m(fe,be,oe){const pe=M.sep===M.$gc.sep,$e=pe?fe:fe.replace(D,M.sep),se=M.sep+$e,Ce=M.$gc.sep+fe;let Fe;return oe?Fe=function(X,W){return typeof X=="string"&&(X===$e||X.endsWith(se)||!pe&&(X===fe||X.endsWith(Ce)))?be:null}:Fe=function(X,W){return typeof X=="string"&&(X===$e||!pe&&X===fe)?be:null},Fe.allPaths=[(oe?"*/":"./")+fe],Fe}function w(fe){try{const be=new RegExp(`^${o(fe)}$`);return function(oe){return be.lastIndex=0,typeof oe=="string"&&be.test(oe)?fe:null}}catch{return l}}function F(fe,be,oe){return!fe||typeof be!="string"?!1:T(fe)(be,void 0,oe)}function T(fe,be={}){if(!fe)return f;if(typeof fe=="string"||G(fe)){const oe=b(fe,be);if(oe===l)return f;const pe=function($e,se){return!!oe($e,se)};return oe.allBasenames&&(pe.allBasenames=oe.allBasenames),oe.allPaths&&(pe.allPaths=oe.allPaths),pe}return N(fe,be)}function G(fe){const be=fe;return be?typeof be.base=="string"&&typeof be.pattern=="string":!1}function q(fe){return fe.allBasenames||[]}function V(fe){return fe.allPaths||[]}function N(fe,be){const oe=Z(Object.getOwnPropertyNames(fe).map(Fe=>L(Fe,fe[Fe],be)).filter(Fe=>Fe!==l)),pe=oe.length;if(!pe)return l;if(!oe.some(Fe=>!!Fe.requiresSiblings)){if(pe===1)return oe[0];const Fe=function(ie,Se){let he;for(let we=0,ae=oe.length;we<ae;we++){const Y=oe[we](ie,Se);if(typeof Y=="string")return Y;(0,R.$mh)(Y)&&(he||(he=[]),he.push(Y))}return he?(async()=>{for(const we of he){const ae=await we;if(typeof ae=="string")return ae}return null})():null},X=oe.find(ie=>!!ie.allBasenames);X&&(Fe.allBasenames=X.allBasenames);const W=oe.reduce((ie,Se)=>Se.allPaths?ie.concat(Se.allPaths):ie,[]);return W.length&&(Fe.allPaths=W),Fe}const $e=function(Fe,X,W){let ie,Se;for(let he=0,we=oe.length;he<we;he++){const ae=oe[he];ae.requiresSiblings&&W&&(X||(X=(0,M.$nc)(Fe)),ie||(ie=X.substr(0,X.length-(0,M.$oc)(Fe).length)));const Y=ae(Fe,X,ie,W);if(typeof Y=="string")return Y;(0,R.$mh)(Y)&&(Se||(Se=[]),Se.push(Y))}return Se?(async()=>{for(const he of Se){const we=await he;if(typeof we=="string")return we}return null})():null},se=oe.find(Fe=>!!Fe.allBasenames);se&&($e.allBasenames=se.allBasenames);const Ce=oe.reduce((Fe,X)=>X.allPaths?Fe.concat(X.allPaths):Fe,[]);return Ce.length&&($e.allPaths=Ce),$e}function L(fe,be,oe){if(be===!1)return l;const pe=b(fe,oe);if(pe===l)return l;if(typeof be=="boolean")return pe;if(be){const $e=be.when;if(typeof $e=="string"){const se=(Ce,Fe,X,W)=>{if(!W||!pe(Ce,Fe))return null;const ie=$e.replace("$(basename)",()=>X),Se=W(ie);return(0,R.$mh)(Se)?Se.then(he=>he?fe:null):Se?fe:null};return se.requiresSiblings=!0,se}}return pe}function Z(fe,be){const oe=fe.filter(Fe=>!!Fe.basenames);if(oe.length<2)return fe;const pe=oe.reduce((Fe,X)=>{const W=X.basenames;return W?Fe.concat(W):Fe},[]);let $e;if(be){$e=[];for(let Fe=0,X=pe.length;Fe<X;Fe++)$e.push(be)}else $e=oe.reduce((Fe,X)=>{const W=X.patterns;return W?Fe.concat(W):Fe},[]);const se=function(Fe,X){if(typeof Fe!="string")return null;if(!X){let ie;for(ie=Fe.length;ie>0;ie--){const Se=Fe.charCodeAt(ie-1);if(Se===P.CharCode.Slash||Se===P.CharCode.Backslash)break}X=Fe.substr(ie)}const W=pe.indexOf(X);return W!==-1?$e[W]:null};se.basenames=pe,se.patterns=$e,se.allBasenames=pe;const Ce=fe.filter(Fe=>!Fe.basenames);return Ce.push(se),Ce}function re(fe,be){return(0,E.$ub)(fe,be,(oe,pe)=>typeof oe=="string"&&typeof pe=="string"?oe===pe:typeof oe!="string"&&typeof pe!="string"?oe.base===pe.base&&oe.pattern===pe.pattern:!1)}}),define(ke[59],Ie([1,0,14,98,24,13,2]),function(de,e,E,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xk=e.MarkdownStringTextNewlineStyle=void 0,e.$Yk=c,e.$Zk=C,e.$1k=v,e.$2k=u,e.$3k=D,e.$4k=d,e.$5k=r,e.$6k=o;var M;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(M||(e.MarkdownStringTextNewlineStyle=M={}));class ${constructor(h="",t=!1){if(this.value=h,typeof this.value!="string")throw(0,E.$7)("value");typeof t=="boolean"?(this.isTrusted=t,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=t.isTrusted??void 0,this.supportThemeIcons=t.supportThemeIcons??!1,this.supportHtml=t.supportHtml??!1)}appendText(h,t=M.Paragraph){return this.value+=u(this.supportThemeIcons?(0,R.$Rk)(h):h).replace(/([ \t]+)/g,(s,n)=>"&nbsp;".repeat(n.length)).replace(/\>/gm,"\\>").replace(/\n/g,t===M.Break?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,t){return this.value+=`
${D(t,h)}
`,this}appendLink(h,t,s){return this.value+="[",this.value+=this.c(t,"]"),this.value+="](",this.value+=this.c(String(h),")"),s&&(this.value+=` "${this.c(this.c(s,'"'),")")}"`),this.value+=")",this}c(h,t){const s=new RegExp((0,O.$df)(t),"g");return h.replace(s,(n,i)=>h.charAt(i-1)!=="\\"?`\\${n}`:n)}}e.$Xk=$;function c(a){return C(a)?!a.value:Array.isArray(a)?a.every(c):!0}function C(a){return a instanceof $?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||typeof a.isTrusted=="object"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}function v(a,h){return a===h?!0:!a||!h?!1:a.value===h.value&&a.isTrusted===h.isTrusted&&a.supportThemeIcons===h.supportThemeIcons&&a.supportHtml===h.supportHtml&&(a.baseUri===h.baseUri||!!a.baseUri&&!!h.baseUri&&(0,P.$7g)(A.URI.from(a.baseUri),A.URI.from(h.baseUri)))}function u(a){return a.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function D(a,h){const t=a.match(/^`+/gm)?.reduce((n,i)=>n.length>i.length?n:i).length??0,s=t>=3?t+1:3;return[`${"`".repeat(s)}${h}`,a,`${"`".repeat(s)}`].join(`
`)}function d(a){return a.replace(/"/g,"&quot;")}function r(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function o(a){const h=[],t=a.split("|").map(n=>n.trim());a=t[0];const s=t[1];if(s){const n=/height=(\d+)/.exec(s),i=/width=(\d+)/.exec(s),g=n?n[1]:"",f=i?i[1]:"",l=isFinite(parseInt(f)),b=isFinite(parseInt(g));l&&h.push(`width="${f}"`),b&&h.push(`height="${g}"`)}return{href:a,dimensions:h}}}),define(ke[102],Ie([1,0,18,53,20,21,24,13]),function(de,e,E,R,P,O,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mw=$,e.$Nw=C,e.$Ow=u,e.$Pw=D,e.$Qw=a,e.$Rw=t,e.$Sw=s,e.$Tw=n,e.$Uw=i,e.$Vw=g;function $(l,b){const{os:I,tildify:S,relative:y}=b;if(y){const m=c(l,y,I);if(typeof m=="string")return m}let p=l.fsPath;if(I===O.OperatingSystem.Windows&&!O.$i?p=p.replace(/\//g,"\\"):I!==O.OperatingSystem.Windows&&O.$i&&(p=p.replace(/\\/g,"/")),I!==O.OperatingSystem.Windows&&S?.userHome){const m=S.userHome.fsPath;let w;l.scheme!==S.userHome.scheme&&l.path[0]===P.$gc.sep&&l.path[1]!==P.$gc.sep?w=S.userHome.with({path:l.path}).fsPath:w=p,p=u(w,m,I)}return(I===O.OperatingSystem.Windows?P.$fc:P.$gc).normalize(C(p,I===O.OperatingSystem.Windows))}function c(l,b,I){const S=I===O.OperatingSystem.Windows?P.$fc:P.$gc,y=I===O.OperatingSystem.Linux?A.$4g:A.$6g,p=b.getWorkspace(),k=(0,E.$Ob)(p.folders);if(!k)return;l.scheme!==k.uri.scheme&&l.path[0]===P.$gc.sep&&l.path[1]!==P.$gc.sep&&(l=k.uri.with({path:l.path}));const m=b.getWorkspaceFolder(l);if(!m)return;let w;if(y.isEqual(m.uri,l)?w="":w=y.relativePath(m.uri,l)??"",w&&(w=S.normalize(w)),p.folders.length>1&&!b.noPrefix){const F=m.name?m.name:y.basenameOrAuthority(m.uri);w=w?`${F} \u2022 ${w}`:F}return w}function C(l,b=O.$i){return(0,R.$Eg)(l,b)?l.charAt(0).toUpperCase()+l.slice(1):l}let v=Object.create(null);function u(l,b,I=O.OS){if(I===O.OperatingSystem.Windows||!l||!b)return l;let S=v.original===b?v.normalized:void 0;S||(S=b,O.$i&&(S=(0,R.$tg)(S)),S=`${(0,M.$jf)(S,P.$gc.sep)}${P.$gc.sep}`,v={original:b,normalized:S});let y=l;return O.$i&&(y=(0,R.$tg)(y)),(I===O.OperatingSystem.Linux?y.startsWith(S):(0,M.$Cf)(y,S))?`~/${y.substr(S.length)}`:l}function D(l,b){return l.replace(/^~($|\/|\\)/,`${b}$1`)}const d="\u2026",r="\\\\",o="~";function a(l,b=P.sep){const I=new Array(l.length);let S=!1;for(let y=0;y<l.length;y++){const p=l[y];if(p===""){I[y]=`.${b}`;continue}if(!p){I[y]=p;continue}S=!0;let k="",m=p;m.indexOf(r)===0?(k=m.substr(0,m.indexOf(r)+r.length),m=m.substr(m.indexOf(r)+r.length)):m.indexOf(b)===0?(k=m.substr(0,m.indexOf(b)+b.length),m=m.substr(m.indexOf(b)+b.length)):m.indexOf(o)===0&&(k=m.substr(0,m.indexOf(o)+o.length),m=m.substr(m.indexOf(o)+o.length));const w=m.split(b);for(let F=1;S&&F<=w.length;F++)for(let T=w.length-F;S&&T>=0;T--){S=!1;let G=w.slice(T,T+F).join(b);for(let q=0;!S&&q<l.length;q++)if(q!==y&&l[q]&&l[q].indexOf(G)>-1){const V=T+F===w.length,N=T>0&&l[q].indexOf(b)>-1?b+G:G,L=l[q].endsWith(N);S=!V||L}if(!S){let q="";(w[0].endsWith(":")||k!=="")&&(T===1&&(T=0,F++,G=w[0]+b+G),T>0&&(q=w[0]+b),q=k+q),T>0&&(q=q+d+b),q=q+G,T+F<w.length&&(q=q+b+d),I[y]=q}}S&&(I[y]=p)}return I}var h;(function(l){l[l.TEXT=0]="TEXT",l[l.VARIABLE=1]="VARIABLE",l[l.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function t(l,b=Object.create(null)){const I=[];let S=!1,y="";for(const p of l)if(p==="$"||S&&p==="{")y&&I.push({value:y,type:h.TEXT}),y="",S=!0;else if(p==="}"&&S){const k=b[y];if(typeof k=="string")k.length&&I.push({value:k,type:h.VARIABLE});else if(k){const m=I[I.length-1];(!m||m.type!==h.SEPARATOR)&&I.push({value:k.label,type:h.SEPARATOR})}y="",S=!1}else y+=p;return y&&!S&&I.push({value:y,type:h.TEXT}),I.filter((p,k)=>{if(p.type===h.SEPARATOR){const m=I[k-1],w=I[k+1];return[m,w].every(F=>F&&(F.type===h.VARIABLE||F.type===h.TEXT)&&F.value.length>0)}return!0}).map(p=>p.value).join("")}function s(l,b){return O.$j||b?l.replace(/\(&&\w\)|&&/g,"").replace(/&/g,O.$j?"&":"&&"):l.replace(/&&|&/g,I=>I==="&"?"&&":"&")}function n(l,b){return O.$j||b?l.replace(/\(&&\w\)|&&/g,""):O.$i?l.replace(/&&|&/g,I=>I==="&"?"&&":"&"):l.replace(/&&/g,"_")}function i(l){return l.replace(/&/g,"&&")}function g(l){if(l.endsWith("]")){const b=l.lastIndexOf(" [",l.length-2);if(b!==-1){const I=f(l.substring(0,b)),S=l.substring(b);return{name:I.name+S,parentPath:I.parentPath}}}return f(l)}function f(l){const b=l.indexOf("/")!==-1?P.$gc:P.$fc,I=b.basename(l),S=b.dirname(l);return I.length?{name:I,parentPath:S}:{name:S,parentPath:""}}}),define(ke[159],Ie([1,0,23,37,2]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$En=e.$Dn=void 0,e.$Fn=$,e.$Gn=C,e.$Hn=v;function O(u){return u.toJSON()}class A{constructor(D){this.a=D}transformIncoming(D){const d=this.a.transformIncoming(D);return d===D?D:O(P.URI.from(d))}transformOutgoing(D){const d=this.a.transformOutgoing(D);return d===D?D:O(P.URI.from(d))}transformOutgoingURI(D){const d=this.a.transformOutgoing(D);return d===D?D:P.URI.from(d)}transformOutgoingScheme(D){return this.a.transformOutgoingScheme(D)}}e.$Dn=A,e.$En=new class{transformIncoming(u){return u}transformOutgoing(u){return u}transformOutgoingURI(u){return u}transformOutgoingScheme(u){return u}};function M(u,D,d){if(!u||d>200)return null;if(typeof u=="object"){if(u instanceof P.URI)return D.transformOutgoing(u);for(const r in u)if(Object.hasOwnProperty.call(u,r)){const o=M(u[r],D,d+1);o!==null&&(u[r]=o)}}return null}function $(u,D){const d=M(u,D,0);return d===null?u:d}function c(u,D,d,r){if(!u||r>200)return null;if(typeof u=="object"){if(u.$mid===R.MarshalledId.Uri)return d?P.URI.revive(D.transformIncoming(u)):D.transformIncoming(u);if(u instanceof E.$Je)return null;for(const o in u)if(Object.hasOwnProperty.call(u,o)){const a=c(u[o],D,d,r+1);a!==null&&(u[o]=a)}}return null}function C(u,D){const d=c(u,D,!1,0);return d===null?u:d}function v(u,D){const d=c(u,D,!0,0);return d===null?u:d}}),define(ke[160],Ie([1,0,11,4,6,49,15]),function(de,e,E,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=e.StorageState=e.StorageHint=void 0,e.$4p=$;var M;(function(u){u[u.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",u[u.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(M||(e.StorageHint=M={}));function $(u){const D=u;return D?.changed instanceof Map||D?.deleted instanceof Set}var c;(function(u){u[u.None=0]="None",u[u.Initialized=1]="Initialized",u[u.Closed=2]="Closed"})(c||(e.StorageState=c={}));class C extends P.$Uc{static{this.a=100}constructor(D,d=Object.create(null)){super(),this.r=D,this.s=d,this.b=this.B(new R.$ke),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new E.$yh(C.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(D=>this.u(D)))}u(D){this.b.pause();try{D.changed?.forEach((d,r)=>this.w(r,d)),D.deleted?.forEach(d=>this.w(d,void 0))}finally{this.b.resume()}}w(D,d){if(this.c===c.Closed)return;let r=!1;(0,A.$jg)(d)?r=this.f.delete(D):this.f.get(D)!==d&&(this.f.set(D,d),r=!0),r&&this.b.fire({key:D,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==M.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(D,d){const r=this.f.get(D);return(0,A.$jg)(r)?d:r}getBoolean(D,d){const r=this.get(D);return(0,A.$jg)(r)?d:r==="true"}getNumber(D,d){const r=this.get(D);return(0,A.$jg)(r)?d:parseInt(r,10)}getObject(D,d){const r=this.get(D);return(0,A.$jg)(r)?d:(0,O.$9h)(r)}async set(D,d,r=!1){if(this.c===c.Closed)return;if((0,A.$jg)(d))return this.delete(D,r);const o=(0,A.$cg)(d)||Array.isArray(d)?(0,O.$8h)(d):String(d);if(this.f.get(D)!==o)return this.f.set(D,o),this.j.set(D,o),this.h.delete(D),this.b.fire({key:D,external:r}),this.D()}async delete(D,d=!1){if(!(this.c===c.Closed||!this.f.delete(D)))return this.h.has(D)||this.h.add(D),this.j.delete(D),this.b.fire({key:D,external:d}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const D={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(D).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(D){if(!(this.c===c.Closed||this.m))return this.D(D)}async D(D){return this.s.hint===M.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),D)}async whenFlushed(){if(this.z)return new Promise(D=>this.n.push(D))}isInMemory(){return this.s.hint===M.STORAGE_IN_MEMORY}}e.$5p=C;class v{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(D){D.insert?.forEach((d,r)=>this.a.set(r,d)),D.delete?.forEach(d=>this.a.delete(d))}async optimize(){}async close(){}}e.$6p=v}),define(ke[161],Ie([1,0,13,21,23]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kt=void 0,e.$it=C,e.$jt=v;let O;function A(){return O||(O=new TextDecoder("UTF-16LE")),O}let M;function $(){return M||(M=new TextDecoder("UTF-16BE")),M}let c;function C(){return c||(c=R.$D()?A():$()),c}function v(d,r,o){const a=new Uint16Array(d.buffer,r,o);return o>0&&(a[0]===65279||a[0]===65534)?u(d,r,o):A().decode(a)}function u(d,r,o){const a=[];let h=0;for(let t=0;t<o;t++){const s=P.$Le(d,r);r+=2,a[h++]=String.fromCharCode(s)}return a.join("")}class D{constructor(r){this.a=r|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const r=new Uint16Array(this.b.buffer,0,this.d);return C().decode(r)}f(){const r=this.e();this.d=0,this.c===null?this.c=[r]:this.c[this.c.length]=r}appendCharCode(r){const o=this.a-this.d;o<=1&&(o===0||E.$Ff(r))&&this.f(),this.b[this.d++]=r}appendASCIICharCode(r){this.d===this.a&&this.f(),this.b[this.d++]=r}appendString(r){const o=r.length;if(this.d+o>=this.a){this.f(),this.c[this.c.length]=r;return}for(let a=0;a<o;a++)this.b[this.d++]=r.charCodeAt(a)}}e.$kt=D}),define(ke[162],Ie([1,0,23,161]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lt=void 0,e.$mt=A;function P($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class O{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(c,C,v,u){this.oldPosition=c,this.oldText=C,this.newPosition=v,this.newText=u}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${P(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${P(this.oldText)}")`:`(replace@${this.oldPosition} "${P(this.oldText)}" with "${P(this.newText)}")`}static a(c){return 4+2*c.length}static c(c,C,v){const u=C.length;E.$Oe(c,u,v),v+=4;for(let D=0;D<u;D++)E.$Me(c,C.charCodeAt(D),v),v+=2;return v}static d(c,C){const v=E.$Ne(c,C);return C+=4,(0,R.$jt)(c,C,v)}writeSize(){return 8+O.a(this.oldText)+O.a(this.newText)}write(c,C){return E.$Oe(c,this.oldPosition,C),C+=4,E.$Oe(c,this.newPosition,C),C+=4,C=O.c(c,this.oldText,C),C=O.c(c,this.newText,C),C}static read(c,C,v){const u=E.$Ne(c,C);C+=4;const D=E.$Ne(c,C);C+=4;const d=O.d(c,C);C+=O.a(d);const r=O.d(c,C);return C+=O.a(r),v.push(new O(u,d,D,r)),C}}e.$lt=O;function A($,c){return $===null||$.length===0?c:new M($,c).compress()}class M{constructor(c,C){this.a=c,this.c=C,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let c=0,C=0,v=this.n(c),u=this.l(C);for(;c<this.f||C<this.h;){if(v===null){this.k(u),u=this.l(++C);continue}if(u===null){this.m(v),v=this.n(++c);continue}if(u.oldEnd<=v.newPosition){this.k(u),u=this.l(++C);continue}if(v.newEnd<=u.oldPosition){this.m(v),v=this.n(++c);continue}if(u.oldPosition<v.newPosition){const[a,h]=M.r(u,v.newPosition-u.oldPosition);this.k(a),u=h;continue}if(v.newPosition<u.oldPosition){const[a,h]=M.q(v,u.oldPosition-v.newPosition);this.m(a),v=h;continue}let r,o;if(u.oldEnd===v.newEnd)r=v,o=u,v=this.n(++c),u=this.l(++C);else if(u.oldEnd<v.newEnd){const[a,h]=M.q(v,u.oldLength);r=a,o=u,v=h,u=this.l(++C)}else{const[a,h]=M.r(u,v.newLength);r=v,o=a,v=this.n(++c),u=h}this.d[this.e++]=new O(r.oldPosition,r.oldText,o.newPosition,o.newText),this.g+=r.newLength-r.oldLength,this.j+=o.newLength-o.oldLength}const D=M.s(this.d);return M.t(D)}k(c){this.d[this.e++]=M.o(this.g,c),this.j+=c.newLength-c.oldLength}l(c){return c<this.h?this.c[c]:null}m(c){this.d[this.e++]=M.p(this.j,c),this.g+=c.newLength-c.oldLength}n(c){return c<this.f?this.a[c]:null}static o(c,C){return new O(C.oldPosition-c,C.oldText,C.newPosition,C.newText)}static p(c,C){return new O(C.oldPosition,C.oldText,C.newPosition+c,C.newText)}static q(c,C){const v=c.newText.substr(0,C),u=c.newText.substr(C);return[new O(c.oldPosition,c.oldText,c.newPosition,v),new O(c.oldEnd,"",c.newPosition+C,u)]}static r(c,C){const v=c.oldText.substr(0,C),u=c.oldText.substr(C);return[new O(c.oldPosition,v,c.newPosition,c.newText),new O(c.oldPosition+C,u,c.newEnd,"")]}static s(c){if(c.length===0)return c;const C=[];let v=0,u=c[0];for(let D=1;D<c.length;D++){const d=c[D];u.oldEnd===d.oldPosition?u=new O(u.oldPosition,u.oldText+d.oldText,u.newPosition,u.newText+d.newText):(C[v++]=u,u=d)}return C[v++]=u,C}static t(c){if(c.length===0)return c;const C=[];let v=0;for(let u=0;u<c.length;u++){const D=c[u];D.oldText!==D.newText&&(C[v++]=D)}return C}}}),define(ke[163],Ie([1,0,41,20]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gt=P,e.$ht=O;function P(A,M,$,c,C,v){if(Array.isArray(A)){let u=0;for(const D of A){const d=P(D,M,$,c,C,v);if(d===10)return d;d>u&&(u=d)}return u}else{if(typeof A=="string")return c?A==="*"?5:A===$?10:0:0;if(A){const{language:u,pattern:D,scheme:d,hasAccessToAllModels:r,notebookType:o}=A;if(!c&&!r)return 0;o&&C&&(M=C);let a=0;if(d)if(d===M.scheme)a=10;else if(d==="*")a=5;else return 0;if(u)if(u===$)a=10;else if(u==="*")a=Math.max(a,5);else return 0;if(o)if(o===v)a=10;else if(o==="*"&&v!==void 0)a=Math.max(a,5);else return 0;if(D){let h;if(typeof D=="string"?h=D:h={...D,base:(0,R.$hc)(D.base)},h===M.fsPath||(0,E.$tk)(h,M.fsPath))a=10;else return 0}return a}else return 0}}function O(A){return typeof A=="string"?!1:Array.isArray(A)?A.some(O):!!A.notebookType}}),define(ke[164],Ie([1,0,4,13,33,52,99,147,162,6]),function(de,e,E,R,P,O,A,M,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_C=void 0;class C extends c.$Uc{constructor(u,D,d,r,o,a,h){super(),this.m=this.B(new E.$he),this.onDidChangeContent=this.m.event,this.f=D,this.j=!a,this.g=r,this.h=o,this.c=new A.$$C(u,d,h)}equals(u){return!(u instanceof C)||this.f!==u.f||this.getEOL()!==u.getEOL()?!1:this.c.equal(u.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(u){return this.c.createSnapshot(u?this.f:"")}getOffsetAt(u,D){return this.c.getOffsetAt(u,D)}getPositionAt(u){return this.c.getPositionAt(u)}getRangeAt(u,D){const d=u+D,r=this.getPositionAt(u),o=this.getPositionAt(d);return new P.$ct(r.lineNumber,r.column,o.lineNumber,o.column)}getValueInRange(u,D=O.EndOfLinePreference.TextDefined){if(u.isEmpty())return"";const d=this.n(D);return this.c.getValueInRange(u,d)}getValueLengthInRange(u,D=O.EndOfLinePreference.TextDefined){if(u.isEmpty())return 0;if(u.startLineNumber===u.endLineNumber)return u.endColumn-u.startColumn;const d=this.getOffsetAt(u.startLineNumber,u.startColumn),r=this.getOffsetAt(u.endLineNumber,u.endColumn);let o=0;const a=this.n(D),h=this.getEOL();if(a.length!==h.length){const t=a.length-h.length,s=u.endLineNumber-u.startLineNumber;o=t*s}return r-d+o}getCharacterCountInRange(u,D=O.EndOfLinePreference.TextDefined){if(this.j){let d=0;const r=u.startLineNumber,o=u.endLineNumber;for(let a=r;a<=o;a++){const h=this.getLineContent(a),t=a===r?u.startColumn-1:0,s=a===o?u.endColumn-1:h.length;for(let n=t;n<s;n++)R.$Ff(h.charCodeAt(n))?(d=d+1,n=n+1):d=d+1}return d+=this.n(D).length*(o-r),d}return this.getValueLengthInRange(u,D)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(u){return this.c.getLineContent(u)}getLineCharCode(u,D){return this.c.getLineCharCode(u,D)}getCharCode(u){return this.c.getCharCode(u)}getLineLength(u){return this.c.getLineLength(u)}getLineMinColumn(u){return 1}getLineMaxColumn(u){return this.getLineLength(u)+1}getLineFirstNonWhitespaceColumn(u){const D=R.$qf(this.getLineContent(u));return D===-1?0:D+1}getLineLastNonWhitespaceColumn(u){const D=R.$sf(this.getLineContent(u));return D===-1?0:D+2}n(u){switch(u){case O.EndOfLinePreference.LF:return`
`;case O.EndOfLinePreference.CRLF:return`\r
`;case O.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(u){this.c.setEOL(u)}applyEdits(u,D,d){let r=this.g,o=this.h,a=this.j,h=!0,t=[];for(let b=0;b<u.length;b++){const I=u[b];h&&I._isTracked&&(h=!1);const S=I.range;if(I.text){let w=!0;a||(w=!R.$Qf(I.text),a=w),!r&&w&&(r=R.$Pf(I.text)),!o&&w&&(o=R.$Sf(I.text))}let y="",p=0,k=0,m=0;if(I.text){let w;[p,k,m,w]=(0,M.$jv)(I.text);const F=this.getEOL(),T=F===`\r
`?M.StringEOL.CRLF:M.StringEOL.LF;w===M.StringEOL.Unknown||w===T?y=I.text:y=I.text.replace(/\r\n|\r|\n/g,F)}t[b]={sortIndex:b,identifier:I.identifier||null,range:S,rangeOffset:this.getOffsetAt(S.startLineNumber,S.startColumn),rangeLength:this.getValueLengthInRange(S),text:y,eolCount:p,firstLineLength:k,lastLineLength:m,forceMoveMarkers:!!I.forceMoveMarkers,isAutoWhitespaceEdit:I.isAutoWhitespaceEdit||!1}}t.sort(C.u);let s=!1;for(let b=0,I=t.length-1;b<I;b++){const S=t[b].range.getEndPosition(),y=t[b+1].range.getStartPosition();if(y.isBeforeOrEqual(S)){if(y.isBefore(S))throw new Error("Overlapping ranges are not allowed!");s=!0}}h&&(t=this.s(t));const n=d||D?C._getInverseEditRanges(t):[],i=[];if(D)for(let b=0;b<t.length;b++){const I=t[b],S=n[b];if(I.isAutoWhitespaceEdit&&I.range.isEmpty())for(let y=S.startLineNumber;y<=S.endLineNumber;y++){let p="";y===S.startLineNumber&&(p=this.getLineContent(I.range.startLineNumber),R.$qf(p)!==-1)||i.push({lineNumber:y,oldContent:p})}}let g=null;if(d){let b=0;g=[];for(let I=0;I<t.length;I++){const S=t[I],y=n[I],p=this.getValueInRange(S.range),k=S.rangeOffset+b;b+=S.text.length-p.length,g[I]={sortIndex:S.sortIndex,identifier:S.identifier,range:y,text:p,textChange:new $.$lt(S.rangeOffset,p,k,S.text)}}s||g.sort((I,S)=>I.sortIndex-S.sortIndex)}this.g=r,this.h=o,this.j=a;const f=this.t(t);let l=null;if(D&&i.length>0){i.sort((b,I)=>I.lineNumber-b.lineNumber),l=[];for(let b=0,I=i.length;b<I;b++){const S=i[b].lineNumber;if(b>0&&i[b-1].lineNumber===S)continue;const y=i[b].oldContent,p=this.getLineContent(S);p.length===0||p===y||R.$qf(p)!==-1||l.push(S)}}return this.m.fire(),new O.$vv(g,f,l)}s(u){return u.length<1e3?u:[this._toSingleEditOperation(u)]}_toSingleEditOperation(u){let D=!1;const d=u[0].range,r=u[u.length-1].range,o=new P.$ct(d.startLineNumber,d.startColumn,r.endLineNumber,r.endColumn);let a=d.startLineNumber,h=d.startColumn;const t=[];for(let f=0,l=u.length;f<l;f++){const b=u[f],I=b.range;D=D||b.forceMoveMarkers,t.push(this.getValueInRange(new P.$ct(a,h,I.startLineNumber,I.startColumn))),b.text.length>0&&t.push(b.text),a=I.endLineNumber,h=I.endColumn}const s=t.join(""),[n,i,g]=(0,M.$jv)(s);return{sortIndex:0,identifier:u[0].identifier,range:o,rangeOffset:this.getOffsetAt(o.startLineNumber,o.startColumn),rangeLength:this.getValueLengthInRange(o,O.EndOfLinePreference.TextDefined),text:s,eolCount:n,firstLineLength:i,lastLineLength:g,forceMoveMarkers:D,isAutoWhitespaceEdit:!1}}t(u){u.sort(C.w);const D=[];for(let d=0;d<u.length;d++){const r=u[d],o=r.range.startLineNumber,a=r.range.startColumn,h=r.range.endLineNumber,t=r.range.endColumn;if(o===h&&a===t&&r.text.length===0)continue;r.text?(this.c.delete(r.rangeOffset,r.rangeLength),this.c.insert(r.rangeOffset,r.text,!0)):this.c.delete(r.rangeOffset,r.rangeLength);const s=new P.$ct(o,a,h,t);D.push({range:s,rangeLength:r.rangeLength,text:r.text,rangeOffset:r.rangeOffset,forceMoveMarkers:r.forceMoveMarkers})}return D}findMatchesLineByLine(u,D,d,r){return this.c.findMatchesLineByLine(u,D,d,r)}getPieceTree(){return this.c}static _getInverseEditRange(u,D){const d=u.startLineNumber,r=u.startColumn,[o,a,h]=(0,M.$jv)(D);let t;if(D.length>0){const s=o+1;s===1?t=new P.$ct(d,r,d,r+a):t=new P.$ct(d,r,d+s-1,h+1)}else t=new P.$ct(d,r,d,r);return t}static _getInverseEditRanges(u){const D=[];let d=0,r=0,o=null;for(let a=0,h=u.length;a<h;a++){const t=u[a];let s,n;o?o.range.endLineNumber===t.range.startLineNumber?(s=d,n=r+(t.range.startColumn-o.range.endColumn)):(s=d+(t.range.startLineNumber-o.range.endLineNumber),n=t.range.startColumn):(s=t.range.startLineNumber,n=t.range.startColumn);let i;if(t.text.length>0){const g=t.eolCount+1;g===1?i=new P.$ct(s,n,s,n+t.firstLineLength):i=new P.$ct(s,n,s+g-1,t.lastLineLength+1)}else i=new P.$ct(s,n,s,n);d=i.endLineNumber,r=i.endColumn,D.push(i),o=t}return D}static u(u,D){const d=P.$ct.compareRangesUsingEnds(u.range,D.range);return d===0?u.sortIndex-D.sortIndex:d}static w(u,D){const d=P.$ct.compareRangesUsingEnds(u.range,D.range);return d===0?D.sortIndex-u.sortIndex:-d}}e.$_C=C}),define(ke[165],Ie([1,0,28,13,52,99,164]),function(de,e,E,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aD=void 0;class M{constructor(C,v,u,D,d,r,o,a,h){this.a=C,this.b=v,this.c=u,this.d=D,this.e=d,this.f=r,this.g=o,this.h=a,this.j=h}k(C){const v=this.c+this.d+this.e,u=this.c+this.e;return v===0?C===P.DefaultEndOfLine.LF?`
`:`\r
`:u>v/2?`\r
`:`
`}create(C){const v=this.k(C),u=this.a;if(this.j&&(v===`\r
`&&(this.c>0||this.d>0)||v===`
`&&(this.c>0||this.e>0)))for(let d=0,r=u.length;d<r;d++){const o=u[d].buffer.replace(/\r\n|\r|\n/g,v),a=(0,O.$7C)(o);u[d]=new O.$0C(o,a)}const D=new A.$_C(u,this.b,v,this.f,this.g,this.h,this.j);return{textBuffer:D,disposable:D}}getFirstLineText(C){return this.a[0].buffer.substr(0,C).split(/\r\n|\r|\n/)[0]}}class ${constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(C){if(C.length===0)return;this.a.length===0&&R.$1f(C)&&(this.b=R.$Zf,C=C.substr(1));const v=C.charCodeAt(C.length-1);v===E.CharCode.CarriageReturn||v>=55296&&v<=56319?(this.m(C.substr(0,C.length-1),!1),this.c=!0,this.d=v):(this.m(C,!1),this.c=!1,this.d=v)}m(C,v){!v&&C.length===0||(this.c?this.n(String.fromCharCode(this.d)+C):this.n(C))}n(C){const v=(0,O.$8C)(this.e,C);this.a.push(new O.$0C(C,v.lineStarts)),this.f+=v.cr,this.g+=v.lf,this.h+=v.crlf,v.isBasicASCII||(this.l=!1,this.j||(this.j=R.$Pf(C)),this.k||(this.k=R.$Sf(C)))}finish(C=!0){return this.o(),new M(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,C)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const C=this.a[this.a.length-1];C.buffer+=String.fromCharCode(this.d);const v=(0,O.$7C)(C.buffer);C.lineStarts=v,this.d===E.CharCode.CarriageReturn&&this.f++}}}e.$aD=$}),define(ke[103],Ie([1,0,23,21]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5bb=$,e.$6bb=C;var P;(function(v){v[v.Full=1]="Full",v[v.Delta=2]="Delta"})(P||(P={}));function O(v){for(let u=0,D=v.length;u<D;u+=4){const d=v[u+0],r=v[u+1],o=v[u+2],a=v[u+3];v[u+0]=a,v[u+1]=o,v[u+2]=r,v[u+3]=d}}function A(v){const u=new Uint8Array(v.buffer,v.byteOffset,v.length*4);return R.$D()||O(u),E.$Je.wrap(u)}function M(v){const u=v.buffer;if(R.$D()||O(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const D=new Uint8Array(u.byteLength);return D.set(u),new Uint32Array(D.buffer,D.byteOffset,D.length/4)}}function $(v){const u=new Uint32Array(c(v));let D=0;if(u[D++]=v.id,v.type==="full")u[D++]=P.Full,u[D++]=v.data.length,u.set(v.data,D),D+=v.data.length;else{u[D++]=P.Delta,u[D++]=v.deltas.length;for(const d of v.deltas)u[D++]=d.start,u[D++]=d.deleteCount,d.data?(u[D++]=d.data.length,u.set(d.data,D),D+=d.data.length):u[D++]=0}return A(u)}function c(v){let u=0;if(u+=2,v.type==="full")u+=1+v.data.length;else{u+=1,u+=3*v.deltas.length;for(const D of v.deltas)D.data&&(u+=D.data.length)}return u}function C(v){const u=M(v);let D=0;const d=u[D++];if(u[D++]===P.Full){const h=u[D++],t=u.subarray(D,D+h);return D+=h,{id:d,type:"full",data:t}}const o=u[D++],a=[];for(let h=0;h<o;h++){const t=u[D++],s=u[D++],n=u[D++];let i;n>0&&(i=u.subarray(D,D+n),D+=n),a[h]={start:t,deleteCount:s,data:i}}return{id:d,type:"delta",deltas:a}}}),define(ke[166],Ie([8,9]),function(de,e){return de.create("vs/editor/common/config/editorOptions",e)}),define(ke[167],Ie([8,9]),function(de,e){return de.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ke[168],Ie([8,9]),function(de,e){return de.create("vs/platform/contextkey/common/contextkey",e)}),define(ke[169],Ie([8,9]),function(de,e){return de.create("vs/platform/contextkey/common/scanner",e)}),define(ke[170],Ie([8,9]),function(de,e){return de.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ke[171],Ie([8,9]),function(de,e){return de.create("vs/platform/extensions/common/extensionValidator",e)}),define(ke[172],Ie([8,9]),function(de,e){return de.create("vs/platform/files/common/files",e)}),define(ke[173],Ie([8,9]),function(de,e){return de.create("vs/platform/log/common/log",e)}),define(ke[174],Ie([8,9]),function(de,e){return de.create("vs/platform/markers/common/markers",e)}),define(ke[175],Ie([8,9]),function(de,e){return de.create("vs/platform/request/common/request",e)}),define(ke[176],Ie([8,9]),function(de,e){return de.create("vs/platform/theme/common/iconRegistry",e)}),define(ke[177],Ie([8,9]),function(de,e){return de.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ke[178],Ie([8,9]),function(de,e){return de.create("vs/platform/workspace/common/workspace",e)}),define(ke[179],Ie([8,9]),function(de,e){return de.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ke[180],Ie([8,9]),function(de,e){return de.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ke[181],Ie([8,9]),function(de,e){return de.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(ke[182],Ie([8,9]),function(de,e){return de.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(ke[183],Ie([8,9]),function(de,e){return de.create("vs/workbench/api/common/extHostLogService",e)}),define(ke[184],Ie([8,9]),function(de,e){return de.create("vs/workbench/api/common/extHostNotebook",e)}),define(ke[185],Ie([8,9]),function(de,e){return de.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ke[186],Ie([8,9]),function(de,e){return de.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ke[187],Ie([8,9]),function(de,e){return de.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ke[188],Ie([8,9]),function(de,e){return de.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ke[189],Ie([8,9]),function(de,e){return de.create("vs/workbench/api/common/extHostTunnelService",e)}),define(ke[190],Ie([8,9]),function(de,e){return de.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ke[191],Ie([8,9]),function(de,e){return de.create("vs/workbench/common/configuration",e)}),define(ke[192],Ie([8,9]),function(de,e){return de.create("vs/workbench/common/editor",e)}),define(ke[193],Ie([8,9]),function(de,e){return de.create("vs/workbench/common/views",e)}),define(ke[194],Ie([8,9]),function(de,e){return de.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(ke[195],Ie([8,9]),function(de,e){return de.create("vs/workbench/contrib/chat/common/languageModels",e)}),define(ke[196],Ie([8,9]),function(de,e){return de.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ke[197],Ie([8,9]),function(de,e){return de.create("vs/workbench/contrib/debug/common/debug",e)}),define(ke[198],Ie([8,9]),function(de,e){return de.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ke[199],Ie([8,9]),function(de,e){return de.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ke[200],Ie([8,9]),function(de,e){return de.create("vs/workbench/contrib/testing/common/constants",e)}),define(ke[201],Ie([8,9]),function(de,e){return de.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ke[202],Ie([8,9]),function(de,e){return de.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(ke[203],Ie([8,9]),function(de,e){return de.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ke[204],Ie([8,9]),function(de,e){return de.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ke[205],Ie([1,0,28,14,169]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vj=e.TokenType=void 0;var O;(function(C){C[C.LParen=0]="LParen",C[C.RParen=1]="RParen",C[C.Neg=2]="Neg",C[C.Eq=3]="Eq",C[C.NotEq=4]="NotEq",C[C.Lt=5]="Lt",C[C.LtEq=6]="LtEq",C[C.Gt=7]="Gt",C[C.GtEq=8]="GtEq",C[C.RegexOp=9]="RegexOp",C[C.RegexStr=10]="RegexStr",C[C.True=11]="True",C[C.False=12]="False",C[C.In=13]="In",C[C.Not=14]="Not",C[C.And=15]="And",C[C.Or=16]="Or",C[C.Str=17]="Str",C[C.QuotedStr=18]="QuotedStr",C[C.Error=19]="Error",C[C.EOF=20]="EOF"})(O||(e.TokenType=O={}));function A(...C){switch(C.length){case 1:return(0,P.localize)(0,null,C[0]);case 2:return(0,P.localize)(1,null,C[0],C[1]);case 3:return(0,P.localize)(2,null,C[0],C[1],C[2]);default:return}}const M=(0,P.localize)(3,null),$=(0,P.localize)(4,null);class c{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(v){switch(v.type){case O.LParen:return"(";case O.RParen:return")";case O.Neg:return"!";case O.Eq:return v.isTripleEq?"===":"==";case O.NotEq:return v.isTripleEq?"!==":"!=";case O.Lt:return"<";case O.LtEq:return"<=";case O.Gt:return">=";case O.GtEq:return">=";case O.RegexOp:return"=~";case O.RegexStr:return v.lexeme;case O.True:return"true";case O.False:return"false";case O.In:return"in";case O.Not:return"not";case O.And:return"&&";case O.Or:return"||";case O.Str:return v.lexeme;case O.QuotedStr:return v.lexeme;case O.Error:return v.lexeme;case O.EOF:return"EOF";default:throw(0,R.$8)(`unhandled token type: ${JSON.stringify(v)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(v=>v.charCodeAt(0)))}static{this.b=new Map([["not",O.Not],["in",O.In],["false",O.False],["true",O.True]])}get errors(){return this.g}reset(v){return this.c=v,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case E.CharCode.OpenParen:this.k(O.LParen);break;case E.CharCode.CloseParen:this.k(O.RParen);break;case E.CharCode.ExclamationMark:if(this.h(E.CharCode.Equals)){const u=this.h(E.CharCode.Equals);this.f.push({type:O.NotEq,offset:this.d,isTripleEq:u})}else this.k(O.Neg);break;case E.CharCode.SingleQuote:this.o();break;case E.CharCode.Slash:this.q();break;case E.CharCode.Equals:if(this.h(E.CharCode.Equals)){const u=this.h(E.CharCode.Equals);this.f.push({type:O.Eq,offset:this.d,isTripleEq:u})}else this.h(E.CharCode.Tilde)?this.k(O.RegexOp):this.l(A("==","=~"));break;case E.CharCode.LessThan:this.k(this.h(E.CharCode.Equals)?O.LtEq:O.Lt);break;case E.CharCode.GreaterThan:this.k(this.h(E.CharCode.Equals)?O.GtEq:O.Gt);break;case E.CharCode.Ampersand:this.h(E.CharCode.Ampersand)?this.k(O.And):this.l(A("&&"));break;case E.CharCode.Pipe:this.h(E.CharCode.Pipe)?this.k(O.Or):this.l(A("||"));break;case E.CharCode.Space:case E.CharCode.CarriageReturn:case E.CharCode.Tab:case E.CharCode.LineFeed:case E.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(O.EOF),Array.from(this.f)}h(v){return this.r()||this.c.charCodeAt(this.e)!==v?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?E.CharCode.Null:this.c.charCodeAt(this.e)}k(v){this.f.push({type:v,offset:this.d})}l(v){const u=this.d,D=this.c.substring(this.d,this.e),d={type:O.Error,offset:this.d,lexeme:D};this.g.push({offset:u,lexeme:D,additionalInfo:v}),this.f.push(d)}n(){this.m.lastIndex=this.d;const v=this.m.exec(this.c);if(v){this.e=this.d+v[0].length;const u=this.c.substring(this.d,this.e),D=c.b.get(u);D?this.k(D):this.f.push({type:O.Str,lexeme:u,offset:this.d})}}o(){for(;this.j()!==E.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(M);return}this.i(),this.f.push({type:O.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let v=this.e,u=!1,D=!1;for(;;){if(v>=this.c.length){this.e=v,this.l($);return}const r=this.c.charCodeAt(v);if(u)u=!1;else if(r===E.CharCode.Slash&&!D){v++;break}else r===E.CharCode.OpenSquareBracket?D=!0:r===E.CharCode.Backslash?u=!0:r===E.CharCode.CloseSquareBracket&&(D=!1);v++}for(;v<this.c.length&&c.a.has(this.c.charCodeAt(v));)v++;this.e=v;const d=this.c.substring(this.d,this.e);this.f.push({type:O.RegexStr,lexeme:d,offset:this.d})}r(){return this.e>=this.c.length}}e.$vj=c}),define(ke[206],Ie([1,0,24,35,171,321]),function(de,e,E,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=$,e.$Pp=c,e.$Qp=C,e.$Rp=v,e.$Sp=u,e.$Tp=D,e.$Up=d;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,M=/^-(\d{4})(\d{2})(\d{2})$/;function $(a){return a=a.trim(),a==="*"||A.test(a)}function c(a){if(!$(a))return null;if(a=a.trim(),a==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const h=a.match(A);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}function C(a){if(!a)return null;const h=a.majorBase,t=a.majorMustEqual,s=a.minorBase;let n=a.minorMustEqual;const i=a.patchBase;let g=a.patchMustEqual;a.hasCaret&&(h===0||(n=!1),g=!1);let f=0;if(a.preRelease){const l=M.exec(a.preRelease);if(l){const[,b,I,S]=l;f=Date.UTC(Number(b),Number(I)-1,Number(S))}}return{majorBase:h,majorMustEqual:t,minorBase:s,minorMustEqual:n,patchBase:i,patchMustEqual:g,isMinimum:a.hasGreaterEquals,notBefore:f}}function v(a,h,t){let s;typeof a=="string"?s=C(c(a)):s=a;let n;h instanceof Date?n=h.getTime():typeof h=="string"&&(n=new Date(h).getTime());let i;if(typeof t=="string"?i=C(c(t)):i=t,!s||!i)return!1;const g=s.majorBase,f=s.minorBase,l=s.patchBase;let b=i.majorBase,I=i.minorBase,S=i.patchBase;const y=i.notBefore;let p=i.majorMustEqual,k=i.minorMustEqual,m=i.patchMustEqual;return i.isMinimum?g>b?!0:g<b?!1:f>I?!0:f<I||n&&n<y?!1:l>=S:(g===1&&b===0&&(!p||!k||!m)&&(b=1,I=0,S=0,p=!0,k=!1,m=!1),g<b?!1:g>b?!p:f<I?!1:f>I?!k:l<S?!1:l>S?!m:!(n&&n<y))}function u(a,h,t,s,n){const i=[];if(typeof s.publisher<"u"&&typeof s.publisher!="string")return i.push([R.default.Error,P.localize(0,null)]),i;if(typeof s.name!="string")return i.push([R.default.Error,P.localize(1,null,"name")]),i;if(typeof s.version!="string")return i.push([R.default.Error,P.localize(2,null,"version")]),i;if(!s.engines)return i.push([R.default.Error,P.localize(3,null,"engines")]),i;if(typeof s.engines.vscode!="string")return i.push([R.default.Error,P.localize(4,null,"engines.vscode")]),i;if(typeof s.extensionDependencies<"u"&&!o(s.extensionDependencies))return i.push([R.default.Error,P.localize(5,null,"extensionDependencies")]),i;if(typeof s.activationEvents<"u"){if(!o(s.activationEvents))return i.push([R.default.Error,P.localize(6,null,"activationEvents")]),i;if(typeof s.main>"u"&&typeof s.browser>"u")return i.push([R.default.Error,P.localize(7,null,"activationEvents","main","browser")]),i}if(typeof s.extensionKind<"u"&&typeof s.main>"u"&&i.push([R.default.Warning,P.localize(8,null,"extensionKind")]),typeof s.main<"u"){if(typeof s.main!="string")return i.push([R.default.Error,P.localize(9,null,"main")]),i;{const l=(0,E.$bh)(t,s.main);(0,E.$8g)(l,t)||i.push([R.default.Warning,P.localize(10,null,l.path,t.path)])}}if(typeof s.browser<"u"){if(typeof s.browser!="string")return i.push([R.default.Error,P.localize(11,null,"browser")]),i;{const l=(0,E.$bh)(t,s.browser);(0,E.$8g)(l,t)||i.push([R.default.Warning,P.localize(12,null,l.path,t.path)])}}if(!O.valid(s.version))return i.push([R.default.Error,P.localize(13,null)]),i;const g=[];if(!D(a,h,s,n,g))for(const l of g)i.push([R.default.Error,l]);return i}function D(a,h,t,s,n){return s||typeof t.main>"u"&&typeof t.browser>"u"?!0:r(a,h,t.engines.vscode,n)}function d(a,h,t){return a==="*"||r(h,t,a)}function r(a,h,t,s=[]){const n=C(c(t));if(!n)return s.push(P.localize(14,null,t)),!1;if(n.majorBase===0){if(!n.majorMustEqual||!n.minorMustEqual)return s.push(P.localize(15,null,t)),!1}else if(!n.majorMustEqual)return s.push(P.localize(16,null,t)),!1;return v(a,h,n)?!0:(s.push(P.localize(17,null,a,t)),!1)}function o(a){if(!Array.isArray(a))return!1;for(let h=0,t=a.length;h<t;h++)if(typeof a[h]!="string")return!1;return!0}}),define(ke[74],Ie([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xi=void 0;class E{constructor(P,O=[],A=!1){this.ctor=P,this.staticArguments=O,this.supportsDelayedInstantiation=A}}e.$xi=E}),define(ke[60],Ie([1,0,74]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Fs=O,e.$Gs=A;const R=[];var P;(function(M){M[M.Eager=0]="Eager",M[M.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function O(M,$,c){$ instanceof E.$xi||($=new E.$xi($,[],!!c)),R.push([M,$])}function A(){return R}}),define(ke[207],Ie([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=e.$ir=void 0;class E{constructor(O,A){this.key=O,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$ir=E;class R{constructor(O){this.b=O,this.a=new Map}roots(){const O=[];for(const A of this.a.values())A.outgoing.size===0&&O.push(A);return O}insertEdge(O,A){const M=this.lookupOrInsertNode(O),$=this.lookupOrInsertNode(A);M.outgoing.set($.key,$),$.incoming.set(M.key,M)}removeNode(O){const A=this.b(O);this.a.delete(A);for(const M of this.a.values())M.outgoing.delete(A),M.incoming.delete(A)}lookupOrInsertNode(O){const A=this.b(O);let M=this.a.get(A);return M||(M=new E(A,O),this.a.set(A,M)),M}lookup(O){return this.a.get(this.b(O))}isEmpty(){return this.a.size===0}toString(){const O=[];for(const[A,M]of this.a)O.push(`${A}
	(-> incoming)[${[...M.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...M.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,A]of this.a){const M=new Set([O]),$=this.c(A,M);if($)return $}}c(O,A){for(const[M,$]of O.outgoing){if(A.has(M))return[...A,M].join(" -> ");A.add(M);const c=this.c($,A);if(c)return c;A.delete(M)}}}e.$jr=R}),define(ke[3],Ie([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e._util=void 0,e.$Ai=P,e.$Bi=O;var E;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function M($){return $[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=M})(E||(e._util=E={})),e.$zi=P("instantiationService");function R(A,M,$){M[E.DI_TARGET]===M?M[E.DI_DEPENDENCIES].push({id:A,index:$}):(M[E.DI_DEPENDENCIES]=[{id:A,index:$}],M[E.DI_TARGET]=M)}function P(A){if(E.serviceIds.has(A))return E.serviceIds.get(A);const M=function($,c,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(M,$,C)};return M.toString=()=>A,E.serviceIds.set(A,M),M}function O(A){return A}}),define(ke[42],Ie([1,0,15,2,3]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$7i=void 0,e.$8i=O,e.$9i=A,e.$0i=$,e.$$i=c,e.$_i=C,e.$aj=v,e.$bj=u,e.$cj=d,e.$dj=r,e.$ej=o,e.$7i=(0,P.$Ai)("configurationService");function O(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof R.URI)}function A(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||Array.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof R.URI)}var M;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.USER=2]="USER",a[a.USER_LOCAL=3]="USER_LOCAL",a[a.USER_REMOTE=4]="USER_REMOTE",a[a.WORKSPACE=5]="WORKSPACE",a[a.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",a[a.DEFAULT=7]="DEFAULT",a[a.MEMORY=8]="MEMORY"})(M||(e.ConfigurationTarget=M={}));function $(a){switch(a){case M.APPLICATION:return"APPLICATION";case M.USER:return"USER";case M.USER_LOCAL:return"USER_LOCAL";case M.USER_REMOTE:return"USER_REMOTE";case M.WORKSPACE:return"WORKSPACE";case M.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case M.DEFAULT:return"DEFAULT";case M.MEMORY:return"MEMORY"}}function c(a){return a.applicationValue!==void 0||a.userValue!==void 0||a.userLocalValue!==void 0||a.userRemoteValue!==void 0||a.workspaceValue!==void 0||a.workspaceFolderValue!==void 0}function C(a,h){const t=Object.create(null);for(const s in a)v(t,s,a[s],h);return t}function v(a,h,t,s){const n=h.split("."),i=n.pop();let g=a;for(let f=0;f<n.length;f++){const l=n[f];let b=g[l];switch(typeof b){case"undefined":b=g[l]=Object.create(null);break;case"object":if(b===null){s(`Ignoring ${h} as ${n.slice(0,f+1).join(".")} is null`);return}break;default:s(`Ignoring ${h} as ${n.slice(0,f+1).join(".")} is ${JSON.stringify(b)}`);return}g=b}if(typeof g=="object"&&g!==null)try{g[i]=t}catch{s(`Ignoring ${h} as ${n.join(".")} is ${JSON.stringify(g)}`)}else s(`Ignoring ${h} as ${n.join(".")} is ${JSON.stringify(g)}`)}function u(a,h){const t=h.split(".");D(a,t)}function D(a,h){const t=h.shift();if(h.length===0){delete a[t];return}if(Object.keys(a).indexOf(t)!==-1){const s=a[t];typeof s=="object"&&!Array.isArray(s)&&(D(s,h),Object.keys(s).length===0&&delete a[t])}}function d(a,h,t){function s(g,f){let l=g;for(const b of f){if(typeof l!="object"||l===null)return;l=l[b]}return l}const n=h.split("."),i=s(a,n);return typeof i>"u"?t:i}function r(a,h,t){Object.keys(h).forEach(s=>{s!=="__proto__"&&(s in a?E.$cg(a[s])&&E.$cg(h[s])?r(a[s],h[s],t):t&&(a[s]=h[s]):a[s]=h[s])})}function o(a){return a.replace(/[\[\]]/g,"")}}),define(ke[32],Ie([1,0,28,21,13,205,3,168,14]),function(de,e,E,R,P,O,A,M,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$yj=e.$xj=e.ContextKeyExprType=void 0,e.$wj=C,e.$zj=f,e.$Aj=l,e.$Tj=se;const c=new Map;c.set("false",!1),c.set("true",!0),c.set("isMac",R.$j),c.set("isLinux",R.$k),c.set("isWindows",R.$i),c.set("isWeb",R.$o),c.set("isMacNative",R.$j&&!R.$o),c.set("isEdge",R.$H),c.set("isFirefox",R.$F),c.set("isChrome",R.$E),c.set("isSafari",R.$G);function C(X,W){if(c.get(X)!==void 0)throw(0,$.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");c.set(X,W)}const v=Object.prototype.hasOwnProperty;var u;(function(X){X[X.False=0]="False",X[X.True=1]="True",X[X.Defined=2]="Defined",X[X.Not=3]="Not",X[X.Equals=4]="Equals",X[X.NotEquals=5]="NotEquals",X[X.And=6]="And",X[X.Regex=7]="Regex",X[X.NotRegex=8]="NotRegex",X[X.Or=9]="Or",X[X.In=10]="In",X[X.NotIn=11]="NotIn",X[X.Greater=12]="Greater",X[X.GreaterEquals=13]="GreaterEquals",X[X.Smaller=14]="Smaller",X[X.SmallerEquals=15]="SmallerEquals"})(u||(e.ContextKeyExprType=u={}));const D={regexParsingWithErrorRecovery:!0},d=(0,M.localize)(0,null),r=(0,M.localize)(1,null),o=(0,M.localize)(2,null),a=(0,M.localize)(3,null),h=(0,M.localize)(4,null),t=(0,M.localize)(5,null),s=(0,M.localize)(6,null),n=(0,M.localize)(7,null);class i{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(W=D){this.k=W,this.d=new O.$vj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(W){if(W===""){this.h.push({message:d,offset:0,lexeme:"",additionalInfo:r});return}this.f=this.d.reset(W).scan(),this.g=0,this.h=[];try{const ie=this.l();if(!this.E()){const Se=this.D(),he=Se.type===O.TokenType.Str?t:void 0;throw this.h.push({message:h,offset:Se.offset,lexeme:O.$vj.getLexeme(Se),additionalInfo:he}),i.c}return ie}catch(ie){if(ie!==i.c)throw ie;return}}l(){return this.m()}m(){const W=[this.o()];for(;this.y(O.TokenType.Or);){const ie=this.o();W.push(ie)}return W.length===1?W[0]:g.or(...W)}o(){const W=[this.s()];for(;this.y(O.TokenType.And);){const ie=this.s();W.push(ie)}return W.length===1?W[0]:g.and(...W)}s(){if(this.y(O.TokenType.Neg)){const W=this.D();switch(W.type){case O.TokenType.True:return this.z(),I.INSTANCE;case O.TokenType.False:return this.z(),S.INSTANCE;case O.TokenType.LParen:{this.z();const ie=this.l();return this.A(O.TokenType.RParen,a),ie?.negate()}case O.TokenType.Str:return this.z(),F.create(W.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",W)}}return this.t()}t(){const W=this.D();switch(W.type){case O.TokenType.True:return this.z(),g.true();case O.TokenType.False:return this.z(),g.false();case O.TokenType.LParen:{this.z();const ie=this.l();return this.A(O.TokenType.RParen,a),ie}case O.TokenType.Str:{const ie=W.lexeme;if(this.z(),this.y(O.TokenType.RegexOp)){const he=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),he.type!==O.TokenType.RegexStr)throw this.B("REGEX",he);const we=he.lexeme,ae=we.lastIndexOf("/"),Y=ae===we.length-1?void 0:this.w(we.substring(ae+1));let x;try{x=new RegExp(we.substring(1,ae),Y)}catch{throw this.B("REGEX",he)}return L.create(ie,x)}switch(he.type){case O.TokenType.RegexStr:case O.TokenType.Error:{const we=[he.lexeme];this.z();let ae=this.D(),Y=0;for(let Be=0;Be<he.lexeme.length;Be++)he.lexeme.charCodeAt(Be)===E.CharCode.OpenParen?Y++:he.lexeme.charCodeAt(Be)===E.CharCode.CloseParen&&Y--;for(;!this.E()&&ae.type!==O.TokenType.And&&ae.type!==O.TokenType.Or;){switch(ae.type){case O.TokenType.LParen:Y++;break;case O.TokenType.RParen:Y--;break;case O.TokenType.RegexStr:case O.TokenType.QuotedStr:for(let Be=0;Be<ae.lexeme.length;Be++)ae.lexeme.charCodeAt(Be)===E.CharCode.OpenParen?Y++:he.lexeme.charCodeAt(Be)===E.CharCode.CloseParen&&Y--}if(Y<0)break;we.push(O.$vj.getLexeme(ae)),this.z(),ae=this.D()}const x=we.join(""),me=x.lastIndexOf("/"),ge=me===x.length-1?void 0:this.w(x.substring(me+1));let Te;try{Te=new RegExp(x.substring(1,me),ge)}catch{throw this.B("REGEX",he)}return g.regex(ie,Te)}case O.TokenType.QuotedStr:{const we=he.lexeme;this.z();let ae=null;if(!(0,P.$$e)(we)){const Y=we.indexOf("/"),x=we.lastIndexOf("/");if(Y!==x&&Y>=0){const me=we.slice(Y+1,x),ge=we[x+1]==="i"?"i":"";try{ae=new RegExp(me,ge)}catch{throw this.B("REGEX",he)}}}if(ae===null)throw this.B("REGEX",he);return L.create(ie,ae)}default:throw this.B("REGEX",this.D())}}if(this.y(O.TokenType.Not)){this.A(O.TokenType.In,o);const he=this.u();return g.notIn(ie,he)}switch(this.D().type){case O.TokenType.Eq:{this.z();const he=this.u();if(this.x().type===O.TokenType.QuotedStr)return g.equals(ie,he);switch(he){case"true":return g.has(ie);case"false":return g.not(ie);default:return g.equals(ie,he)}}case O.TokenType.NotEq:{this.z();const he=this.u();if(this.x().type===O.TokenType.QuotedStr)return g.notEquals(ie,he);switch(he){case"true":return g.not(ie);case"false":return g.has(ie);default:return g.notEquals(ie,he)}}case O.TokenType.Lt:return this.z(),V.create(ie,this.u());case O.TokenType.LtEq:return this.z(),N.create(ie,this.u());case O.TokenType.Gt:return this.z(),G.create(ie,this.u());case O.TokenType.GtEq:return this.z(),q.create(ie,this.u());case O.TokenType.In:return this.z(),g.in(ie,this.u());default:return g.has(ie)}}case O.TokenType.EOF:throw this.h.push({message:s,offset:W.offset,lexeme:"",additionalInfo:n}),i.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const W=this.D();switch(W.type){case O.TokenType.Str:case O.TokenType.QuotedStr:return this.z(),W.lexeme;case O.TokenType.True:return this.z(),"true";case O.TokenType.False:return this.z(),"false";case O.TokenType.In:return this.z(),"in";default:return""}}w(W){return W.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(W){return this.C(W)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(W,ie){if(this.C(W))return this.z();throw this.B(ie,this.D())}B(W,ie,Se){const he=(0,M.localize)(8,null,W,O.$vj.getLexeme(ie)),we=ie.offset,ae=O.$vj.getLexeme(ie);return this.h.push({message:he,offset:we,lexeme:ae,additionalInfo:Se}),i.c}C(W){return this.D().type===W}D(){return this.f[this.g]}E(){return this.D().type===O.TokenType.EOF}}e.$xj=i;class g{static false(){return I.INSTANCE}static true(){return S.INSTANCE}static has(W){return y.create(W)}static equals(W,ie){return p.create(W,ie)}static notEquals(W,ie){return w.create(W,ie)}static regex(W,ie){return L.create(W,ie)}static in(W,ie){return k.create(W,ie)}static notIn(W,ie){return m.create(W,ie)}static not(W){return F.create(W)}static and(...W){return fe.create(W,null,!0)}static or(...W){return be.create(W,null,!0)}static greater(W,ie){return G.create(W,ie)}static greaterEquals(W,ie){return q.create(W,ie)}static smaller(W,ie){return V.create(W,ie)}static smallerEquals(W,ie){return N.create(W,ie)}static{this.c=new i({regexParsingWithErrorRecovery:!1})}static deserialize(W){return W==null?void 0:this.c.parse(W)}}e.$yj=g;function f(X){const W=new i({regexParsingWithErrorRecovery:!1});return X.map(ie=>(W.parse(ie),W.lexingErrors.length>0?W.lexingErrors.map(Se=>({errorMessage:Se.additionalInfo?(0,M.localize)(9,null,Se.additionalInfo):(0,M.localize)(10,null),offset:Se.offset,length:Se.lexeme.length})):W.parsingErrors.length>0?W.parsingErrors.map(Se=>({errorMessage:Se.additionalInfo?`${Se.message}. ${Se.additionalInfo}`:Se.message,offset:Se.offset,length:Se.lexeme.length})):[]))}function l(X,W){const ie=X?X.substituteConstants():void 0,Se=W?W.substituteConstants():void 0;return!ie&&!Se?!0:!ie||!Se?!1:ie.equals(Se)}function b(X,W){return X.cmp(W)}class I{static{this.INSTANCE=new I}constructor(){this.type=u.False}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!1}serialize(){return"false"}keys(){return[]}map(W){return this}negate(){return S.INSTANCE}}e.$Bj=I;class S{static{this.INSTANCE=new S}constructor(){this.type=u.True}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!0}serialize(){return"true"}keys(){return[]}map(W){return this}negate(){return I.INSTANCE}}e.$Cj=S;class y{static create(W,ie=null){const Se=c.get(W);return typeof Se=="boolean"?Se?S.INSTANCE:I.INSTANCE:new y(W,ie)}constructor(W,ie){this.key=W,this.c=ie,this.type=u.Defined}cmp(W){return W.type!==this.type?this.type-W.type:pe(this.key,W.key)}equals(W){return W.type===this.type?this.key===W.key:!1}substituteConstants(){const W=c.get(this.key);return typeof W=="boolean"?W?S.INSTANCE:I.INSTANCE:this}evaluate(W){return!!W.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(W){return W.mapDefined(this.key)}negate(){return this.c||(this.c=F.create(this.key,this)),this.c}}e.$Dj=y;class p{static create(W,ie,Se=null){if(typeof ie=="boolean")return ie?y.create(W,Se):F.create(W,Se);const he=c.get(W);return typeof he=="boolean"?ie===(he?"true":"false")?S.INSTANCE:I.INSTANCE:new p(W,ie,Se)}constructor(W,ie,Se){this.c=W,this.d=ie,this.f=Se,this.type=u.Equals}cmp(W){return W.type!==this.type?this.type-W.type:$e(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=c.get(this.c);if(typeof W=="boolean"){const ie=W?"true":"false";return this.d===ie?S.INSTANCE:I.INSTANCE}return this}evaluate(W){return W.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(W){return W.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.$Ej=p;class k{static create(W,ie){return new k(W,ie)}constructor(W,ie){this.d=W,this.f=ie,this.type=u.In,this.c=null}cmp(W){return W.type!==this.type?this.type-W.type:$e(this.d,this.f,W.d,W.f)}equals(W){return W.type===this.type?this.d===W.d&&this.f===W.f:!1}substituteConstants(){return this}evaluate(W){const ie=W.getValue(this.f),Se=W.getValue(this.d);return Array.isArray(ie)?ie.includes(Se):typeof Se=="string"&&typeof ie=="object"&&ie!==null?v.call(ie,Se):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(W){return W.mapIn(this.d,this.f)}negate(){return this.c||(this.c=m.create(this.d,this.f)),this.c}}e.$Fj=k;class m{static create(W,ie){return new m(W,ie)}constructor(W,ie){this.d=W,this.f=ie,this.type=u.NotIn,this.c=k.create(W,ie)}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(W){return W.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Gj=m;class w{static create(W,ie,Se=null){if(typeof ie=="boolean")return ie?F.create(W,Se):y.create(W,Se);const he=c.get(W);return typeof he=="boolean"?ie===(he?"true":"false")?I.INSTANCE:S.INSTANCE:new w(W,ie,Se)}constructor(W,ie,Se){this.c=W,this.d=ie,this.f=Se,this.type=u.NotEquals}cmp(W){return W.type!==this.type?this.type-W.type:$e(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=c.get(this.c);if(typeof W=="boolean"){const ie=W?"true":"false";return this.d===ie?I.INSTANCE:S.INSTANCE}return this}evaluate(W){return W.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(W){return W.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=p.create(this.c,this.d,this)),this.f}}e.$Hj=w;class F{static create(W,ie=null){const Se=c.get(W);return typeof Se=="boolean"?Se?I.INSTANCE:S.INSTANCE:new F(W,ie)}constructor(W,ie){this.c=W,this.d=ie,this.type=u.Not}cmp(W){return W.type!==this.type?this.type-W.type:pe(this.c,W.c)}equals(W){return W.type===this.type?this.c===W.c:!1}substituteConstants(){const W=c.get(this.c);return typeof W=="boolean"?W?I.INSTANCE:S.INSTANCE:this}evaluate(W){return!W.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(W){return W.mapNot(this.c)}negate(){return this.d||(this.d=y.create(this.c,this)),this.d}}e.$Ij=F;function T(X,W){if(typeof X=="string"){const ie=parseFloat(X);isNaN(ie)||(X=ie)}return typeof X=="string"||typeof X=="number"?W(X):I.INSTANCE}class G{static create(W,ie,Se=null){return T(ie,he=>new G(W,he,Se))}constructor(W,ie,Se){this.c=W,this.d=ie,this.f=Se,this.type=u.Greater}cmp(W){return W.type!==this.type?this.type-W.type:$e(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$Jj=G;class q{static create(W,ie,Se=null){return T(ie,he=>new q(W,he,Se))}constructor(W,ie,Se){this.c=W,this.d=ie,this.f=Se,this.type=u.GreaterEquals}cmp(W){return W.type!==this.type?this.type-W.type:$e(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Kj=q;class V{static create(W,ie,Se=null){return T(ie,he=>new V(W,he,Se))}constructor(W,ie,Se){this.c=W,this.d=ie,this.f=Se,this.type=u.Smaller}cmp(W){return W.type!==this.type?this.type-W.type:$e(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Lj=V;class N{static create(W,ie,Se=null){return T(ie,he=>new N(W,he,Se))}constructor(W,ie,Se){this.c=W,this.d=ie,this.f=Se,this.type=u.SmallerEquals}cmp(W){return W.type!==this.type?this.type-W.type:$e(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.$Mj=N;class L{static create(W,ie){return new L(W,ie)}constructor(W,ie){this.d=W,this.f=ie,this.type=u.Regex,this.c=null}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.d<W.d)return-1;if(this.d>W.d)return 1;const ie=this.f?this.f.source:"",Se=W.f?W.f.source:"";return ie<Se?-1:ie>Se?1:0}equals(W){if(W.type===this.type){const ie=this.f?this.f.source:"",Se=W.f?W.f.source:"";return this.d===W.d&&ie===Se}return!1}substituteConstants(){return this}evaluate(W){const ie=W.getValue(this.d);return this.f?this.f.test(ie):!1}serialize(){const W=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${W}`}keys(){return[this.d]}map(W){return W.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=Z.create(this)),this.c}}e.$Nj=L;class Z{static create(W){return new Z(W)}constructor(W){this.c=W,this.type=u.NotRegex}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(W){return new Z(this.c.map(W))}negate(){return this.c}}e.$Oj=Z;function re(X){let W=null;for(let ie=0,Se=X.length;ie<Se;ie++){const he=X[ie].substituteConstants();if(X[ie]!==he&&W===null){W=[];for(let we=0;we<ie;we++)W[we]=X[we]}W!==null&&(W[ie]=he)}return W===null?X:W}class fe{static create(W,ie,Se){return fe.d(W,ie,Se)}constructor(W,ie){this.expr=W,this.c=ie,this.type=u.And}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let ie=0,Se=this.expr.length;ie<Se;ie++){const he=b(this.expr[ie],W.expr[ie]);if(he!==0)return he}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let ie=0,Se=this.expr.length;ie<Se;ie++)if(!this.expr[ie].equals(W.expr[ie]))return!1;return!0}return!1}substituteConstants(){const W=re(this.expr);return W===this.expr?this:fe.create(W,this.c,!1)}evaluate(W){for(let ie=0,Se=this.expr.length;ie<Se;ie++)if(!this.expr[ie].evaluate(W))return!1;return!0}static d(W,ie,Se){const he=[];let we=!1;for(const ae of W)if(ae){if(ae.type===u.True){we=!0;continue}if(ae.type===u.False)return I.INSTANCE;if(ae.type===u.And){he.push(...ae.expr);continue}he.push(ae)}if(he.length===0&&we)return S.INSTANCE;if(he.length!==0){if(he.length===1)return he[0];he.sort(b);for(let ae=1;ae<he.length;ae++)he[ae-1].equals(he[ae])&&(he.splice(ae,1),ae--);if(he.length===1)return he[0];for(;he.length>1;){const ae=he[he.length-1];if(ae.type!==u.Or)break;he.pop();const Y=he.pop(),x=he.length===0,me=be.create(ae.expr.map(ge=>fe.create([ge,Y],null,Se)),null,x);me&&(he.push(me),he.sort(b))}if(he.length===1)return he[0];if(Se){for(let ae=0;ae<he.length;ae++)for(let Y=ae+1;Y<he.length;Y++)if(he[ae].negate().equals(he[Y]))return I.INSTANCE;if(he.length===1)return he[0]}return new fe(he,ie)}}serialize(){return this.expr.map(W=>W.serialize()).join(" && ")}keys(){const W=[];for(const ie of this.expr)W.push(...ie.keys());return W}map(W){return new fe(this.expr.map(ie=>ie.map(W)),null)}negate(){if(!this.c){const W=[];for(const ie of this.expr)W.push(ie.negate());this.c=be.create(W,this,!0)}return this.c}}e.$Pj=fe;class be{static create(W,ie,Se){return be.d(W,ie,Se)}constructor(W,ie){this.expr=W,this.c=ie,this.type=u.Or}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let ie=0,Se=this.expr.length;ie<Se;ie++){const he=b(this.expr[ie],W.expr[ie]);if(he!==0)return he}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let ie=0,Se=this.expr.length;ie<Se;ie++)if(!this.expr[ie].equals(W.expr[ie]))return!1;return!0}return!1}substituteConstants(){const W=re(this.expr);return W===this.expr?this:be.create(W,this.c,!1)}evaluate(W){for(let ie=0,Se=this.expr.length;ie<Se;ie++)if(this.expr[ie].evaluate(W))return!0;return!1}static d(W,ie,Se){let he=[],we=!1;if(W){for(let ae=0,Y=W.length;ae<Y;ae++){const x=W[ae];if(x){if(x.type===u.False){we=!0;continue}if(x.type===u.True)return S.INSTANCE;if(x.type===u.Or){he=he.concat(x.expr);continue}he.push(x)}}if(he.length===0&&we)return I.INSTANCE;he.sort(b)}if(he.length!==0){if(he.length===1)return he[0];for(let ae=1;ae<he.length;ae++)he[ae-1].equals(he[ae])&&(he.splice(ae,1),ae--);if(he.length===1)return he[0];if(Se){for(let ae=0;ae<he.length;ae++)for(let Y=ae+1;Y<he.length;Y++)if(he[ae].negate().equals(he[Y]))return S.INSTANCE;if(he.length===1)return he[0]}return new be(he,ie)}}serialize(){return this.expr.map(W=>W.serialize()).join(" || ")}keys(){const W=[];for(const ie of this.expr)W.push(...ie.keys());return W}map(W){return new be(this.expr.map(ie=>ie.map(W)),null)}negate(){if(!this.c){const W=[];for(const ie of this.expr)W.push(ie.negate());for(;W.length>1;){const ie=W.shift(),Se=W.shift(),he=[];for(const we of Fe(ie))for(const ae of Fe(Se))he.push(fe.create([we,ae],null,!1));W.unshift(be.create(he,null,!1))}this.c=be.create(W,this,!0)}return this.c}}e.$Qj=be;class oe extends y{static{this.d=[]}static all(){return oe.d.values()}constructor(W,ie,Se){super(W,null),this.f=ie,typeof Se=="object"?oe.d.push({...Se,key:W}):Se!==!0&&oe.d.push({key:W,description:Se,type:ie!=null?typeof ie:void 0})}bindTo(W){return W.createKey(this.key,this.f)}getValue(W){return W.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(W){return p.create(this.key,W)}notEqualsTo(W){return w.create(this.key,W)}}e.$Rj=oe,e.$Sj=(0,A.$Ai)("contextKeyService");function pe(X,W){return X<W?-1:X>W?1:0}function $e(X,W,ie,Se){return X<ie?-1:X>ie?1:W<Se?-1:W>Se?1:0}function se(X,W){if(X.type===u.False||W.type===u.True)return!0;if(X.type===u.Or)return W.type===u.Or?Ce(X.expr,W.expr):!1;if(W.type===u.Or){for(const ie of W.expr)if(se(X,ie))return!0;return!1}if(X.type===u.And){if(W.type===u.And)return Ce(W.expr,X.expr);for(const ie of X.expr)if(se(ie,W))return!0;return!1}return X.equals(W)}function Ce(X,W){let ie=0,Se=0;for(;ie<X.length&&Se<W.length;){const he=X[ie].cmp(W[Se]);if(he<0)return!1;he===0&&ie++,Se++}return ie===X.length}function Fe(X){return X.type===u.Or?X.expr:[X]}}),define(ke[208],Ie([1,0,32,3]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ru=e.$pu=e.AccessibilitySupport=e.$ou=void 0,e.$qu=O,e.$ou=(0,R.$Ai)("accessibilityService");var P;(function(A){A[A.Unknown=0]="Unknown",A[A.Disabled=1]="Disabled",A[A.Enabled=2]="Enabled"})(P||(e.AccessibilitySupport=P={})),e.$pu=new E.$Rj("accessibilityModeEnabled",!1);function O(A){return A&&typeof A=="object"&&typeof A.label=="string"&&(typeof A.role>"u"||typeof A.role=="string")}e.$ru="ACCESSIBLE_VIEW_SHOWN_"}),define(ke[104],Ie([1,0,18,26,21,142,322,148,209,166,208]),function(de,e,E,R,P,O,A,M,$,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=t,e.clampedInt=n,e.clampedFloat=g,e.stringSet=b,e.cursorStyleToString=T,e.filterValidationDecorations=Ee;var v;(function(_){_[_.None=0]="None",_[_.Keep=1]="Keep",_[_.Brackets=2]="Brackets",_[_.Advanced=3]="Advanced",_[_.Full=4]="Full"})(v||(e.EditorAutoIndentStrategy=v={})),e.MINIMAP_GUTTER_WIDTH=8;class u{constructor(H){this.c=H}hasChanged(H){return this.c[H]}}e.ConfigurationChangedEvent=u;class D{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=D;class d{constructor(H,ye,Ke,xe){this.id=H,this.name=ye,this.defaultValue=Ke,this.schema=xe}applyUpdate(H,ye){return o(H,ye)}compute(H,ye,Ke){return Ke}}class r{constructor(H,ye){this.newValue=H,this.didChange=ye}}e.ApplyUpdateResult=r;function o(_,H){if(typeof _!="object"||typeof H!="object"||!_||!H)return new r(H,_!==H);if(Array.isArray(_)||Array.isArray(H)){const Ke=Array.isArray(_)&&Array.isArray(H)&&E.$ub(_,H);return new r(H,!Ke)}let ye=!1;for(const Ke in H)if(H.hasOwnProperty(Ke)){const xe=o(_[Ke],H[Ke]);xe.didChange&&(_[Ke]=xe.newValue,ye=!0)}return new r(_,ye)}class a{constructor(H){this.schema=void 0,this.id=H,this.name="_never_",this.defaultValue=void 0}applyUpdate(H,ye){return o(H,ye)}validate(H){return this.defaultValue}}class h{constructor(H,ye,Ke,xe){this.id=H,this.name=ye,this.defaultValue=Ke,this.schema=xe}applyUpdate(H,ye){return o(H,ye)}validate(H){return typeof H>"u"?this.defaultValue:H}compute(H,ye,Ke){return Ke}}function t(_,H){return typeof _>"u"?H:_==="false"?!1:!!_}class s extends h{constructor(H,ye,Ke,xe=void 0){typeof xe<"u"&&(xe.type="boolean",xe.default=Ke),super(H,ye,Ke,xe)}validate(H){return t(H,this.defaultValue)}}function n(_,H,ye,Ke){if(typeof _>"u")return H;let xe=parseInt(_,10);return isNaN(xe)?H:(xe=Math.max(ye,xe),xe=Math.min(Ke,xe),xe|0)}class i extends h{static clampedInt(H,ye,Ke,xe){return n(H,ye,Ke,xe)}constructor(H,ye,Ke,xe,ct,gt=void 0){typeof gt<"u"&&(gt.type="integer",gt.default=Ke,gt.minimum=xe,gt.maximum=ct),super(H,ye,Ke,gt),this.minimum=xe,this.maximum=ct}validate(H){return i.clampedInt(H,this.defaultValue,this.minimum,this.maximum)}}function g(_,H,ye,Ke){if(typeof _>"u")return H;const xe=f.float(_,H);return f.clamp(xe,ye,Ke)}class f extends h{static clamp(H,ye,Ke){return H<ye?ye:H>Ke?Ke:H}static float(H,ye){if(typeof H=="number")return H;if(typeof H>"u")return ye;const Ke=parseFloat(H);return isNaN(Ke)?ye:Ke}constructor(H,ye,Ke,xe,ct){typeof ct<"u"&&(ct.type="number",ct.default=Ke),super(H,ye,Ke,ct),this.validationFn=xe}validate(H){return this.validationFn(f.float(H,this.defaultValue))}}class l extends h{static string(H,ye){return typeof H!="string"?ye:H}constructor(H,ye,Ke,xe=void 0){typeof xe<"u"&&(xe.type="string",xe.default=Ke),super(H,ye,Ke,xe)}validate(H){return l.string(H,this.defaultValue)}}function b(_,H,ye,Ke){return typeof _!="string"?H:Ke&&_ in Ke?Ke[_]:ye.indexOf(_)===-1?H:_}class I extends h{constructor(H,ye,Ke,xe,ct=void 0){typeof ct<"u"&&(ct.type="string",ct.enum=xe,ct.default=Ke),super(H,ye,Ke,ct),this.c=xe}validate(H){return b(H,this.defaultValue,this.c)}}class S extends d{constructor(H,ye,Ke,xe,ct,gt,Mt=void 0){typeof Mt<"u"&&(Mt.type="string",Mt.enum=ct,Mt.default=xe),super(H,ye,Ke,Mt),this.c=ct,this.d=gt}validate(H){return typeof H!="string"?this.defaultValue:this.c.indexOf(H)===-1?this.defaultValue:this.d(H)}}function y(_){switch(_){case"none":return v.None;case"keep":return v.Keep;case"brackets":return v.Brackets;case"advanced":return v.Advanced;case"full":return v.Full}}class p extends d{constructor(){super(ze.accessibilitySupport,"accessibilitySupport",C.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[c.localize(0,null),c.localize(1,null),c.localize(2,null)],default:"auto",tags:["accessibility"],description:c.localize(3,null)})}validate(H){switch(H){case"auto":return C.AccessibilitySupport.Unknown;case"off":return C.AccessibilitySupport.Disabled;case"on":return C.AccessibilitySupport.Enabled}return this.defaultValue}compute(H,ye,Ke){return Ke===C.AccessibilitySupport.Unknown?H.accessibilitySupport:Ke}}class k extends d{constructor(){const H={insertSpace:!0,ignoreEmptyLines:!0};super(ze.comments,"comments",H,{"editor.comments.insertSpace":{type:"boolean",default:H.insertSpace,description:c.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:H.ignoreEmptyLines,description:c.localize(5,null)}})}validate(H){if(!H||typeof H!="object")return this.defaultValue;const ye=H;return{insertSpace:t(ye.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(ye.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var m;(function(_){_[_.Hidden=0]="Hidden",_[_.Blink=1]="Blink",_[_.Smooth=2]="Smooth",_[_.Phase=3]="Phase",_[_.Expand=4]="Expand",_[_.Solid=5]="Solid"})(m||(e.TextEditorCursorBlinkingStyle=m={}));function w(_){switch(_){case"blink":return m.Blink;case"smooth":return m.Smooth;case"phase":return m.Phase;case"expand":return m.Expand;case"solid":return m.Solid}}var F;(function(_){_[_.Line=1]="Line",_[_.Block=2]="Block",_[_.Underline=3]="Underline",_[_.LineThin=4]="LineThin",_[_.BlockOutline=5]="BlockOutline",_[_.UnderlineThin=6]="UnderlineThin"})(F||(e.TextEditorCursorStyle=F={}));function T(_){switch(_){case F.Line:return"line";case F.Block:return"block";case F.Underline:return"underline";case F.LineThin:return"line-thin";case F.BlockOutline:return"block-outline";case F.UnderlineThin:return"underline-thin"}}function G(_){switch(_){case"line":return F.Line;case"block":return F.Block;case"underline":return F.Underline;case"line-thin":return F.LineThin;case"block-outline":return F.BlockOutline;case"underline-thin":return F.UnderlineThin}}class q extends a{constructor(){super(ze.editorClassName)}compute(H,ye,Ke){const xe=["monaco-editor"];return ye.get(ze.extraEditorClassName)&&xe.push(ye.get(ze.extraEditorClassName)),H.extraEditorClassName&&xe.push(H.extraEditorClassName),ye.get(ze.mouseStyle)==="default"?xe.push("mouse-default"):ye.get(ze.mouseStyle)==="copy"&&xe.push("mouse-copy"),ye.get(ze.showUnused)&&xe.push("showUnused"),ye.get(ze.showDeprecated)&&xe.push("showDeprecated"),xe.join(" ")}}class V extends s{constructor(){super(ze.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:c.localize(6,null)})}compute(H,ye,Ke){return Ke&&H.emptySelectionClipboard}}class N extends d{constructor(){const H={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(ze.find,"find",H,{"editor.find.cursorMoveOnType":{type:"boolean",default:H.cursorMoveOnType,description:c.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:H.seedSearchStringFromSelection,enumDescriptions:[c.localize(8,null),c.localize(9,null),c.localize(10,null)],description:c.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:H.autoFindInSelection,enumDescriptions:[c.localize(12,null),c.localize(13,null),c.localize(14,null)],description:c.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:H.globalFindClipboard,description:c.localize(16,null),included:P.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:H.addExtraSpaceOnTop,description:c.localize(17,null)},"editor.find.loop":{type:"boolean",default:H.loop,description:c.localize(18,null)}})}validate(H){if(!H||typeof H!="object")return this.defaultValue;const ye=H;return{cursorMoveOnType:t(ye.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof H.seedSearchStringFromSelection=="boolean"?H.seedSearchStringFromSelection?"always":"never":b(ye.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof H.autoFindInSelection=="boolean"?H.autoFindInSelection?"always":"never":b(ye.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(ye.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(ye.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(ye.loop,this.defaultValue.loop)}}}class L extends d{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(ze.fontLigatures,"fontLigatures",L.OFF,{anyOf:[{type:"boolean",description:c.localize(19,null)},{type:"string",description:c.localize(20,null)}],description:c.localize(21,null),default:!1})}validate(H){return typeof H>"u"?this.defaultValue:typeof H=="string"?H==="false"||H.length===0?L.OFF:H==="true"?L.ON:H:H?L.ON:L.OFF}}e.EditorFontLigatures=L;class Z extends d{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(ze.fontVariations,"fontVariations",Z.OFF,{anyOf:[{type:"boolean",description:c.localize(22,null)},{type:"string",description:c.localize(23,null)}],description:c.localize(24,null),default:!1})}validate(H){return typeof H>"u"?this.defaultValue:typeof H=="string"?H==="false"?Z.OFF:H==="true"?Z.TRANSLATE:H:H?Z.TRANSLATE:Z.OFF}compute(H,ye,Ke){return H.fontInfo.fontVariationSettings}}e.EditorFontVariations=Z;class re extends a{constructor(){super(ze.fontInfo)}compute(H,ye,Ke){return H.fontInfo}}class fe extends h{constructor(){super(ze.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:c.localize(25,null)})}validate(H){const ye=f.float(H,this.defaultValue);return ye===0?e.EDITOR_FONT_DEFAULTS.fontSize:f.clamp(ye,6,100)}compute(H,ye,Ke){return H.fontInfo.fontSize}}class be extends d{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(ze.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:be.d,maximum:be.e,errorMessage:c.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:be.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:c.localize(27,null)})}validate(H){return H==="normal"||H==="bold"?H:String(i.clampedInt(H,e.EDITOR_FONT_DEFAULTS.fontWeight,be.d,be.e))}}class oe extends d{constructor(){const H={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ye={type:"string",enum:["peek","gotoAndPeek","goto"],default:H.multiple,enumDescriptions:[c.localize(28,null),c.localize(29,null),c.localize(30,null)]},Ke=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(ze.gotoLocation,"gotoLocation",H,{"editor.gotoLocation.multiple":{deprecationMessage:c.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:c.localize(32,null),...ye},"editor.gotoLocation.multipleTypeDefinitions":{description:c.localize(33,null),...ye},"editor.gotoLocation.multipleDeclarations":{description:c.localize(34,null),...ye},"editor.gotoLocation.multipleImplementations":{description:c.localize(35,null),...ye},"editor.gotoLocation.multipleReferences":{description:c.localize(36,null),...ye},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:H.alternativeDefinitionCommand,enum:Ke,description:c.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:H.alternativeTypeDefinitionCommand,enum:Ke,description:c.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:H.alternativeDeclarationCommand,enum:Ke,description:c.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:H.alternativeImplementationCommand,enum:Ke,description:c.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:H.alternativeReferenceCommand,enum:Ke,description:c.localize(41,null)}})}validate(H){if(!H||typeof H!="object")return this.defaultValue;const ye=H;return{multiple:b(ye.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ye.multipleDefinitions??b(ye.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ye.multipleTypeDefinitions??b(ye.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ye.multipleDeclarations??b(ye.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ye.multipleImplementations??b(ye.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ye.multipleReferences??b(ye.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:l.string(ye.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:l.string(ye.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:l.string(ye.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:l.string(ye.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:l.string(ye.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class pe extends d{constructor(){const H={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(ze.hover,"hover",H,{"editor.hover.enabled":{type:"boolean",default:H.enabled,description:c.localize(42,null)},"editor.hover.delay":{type:"number",default:H.delay,minimum:0,maximum:1e4,description:c.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:H.sticky,description:c.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:H.hidingDelay,description:c.localize(45,null)},"editor.hover.above":{type:"boolean",default:H.above,description:c.localize(46,null)}})}validate(H){if(!H||typeof H!="object")return this.defaultValue;const ye=H;return{enabled:t(ye.enabled,this.defaultValue.enabled),delay:i.clampedInt(ye.delay,this.defaultValue.delay,0,1e4),sticky:t(ye.sticky,this.defaultValue.sticky),hidingDelay:i.clampedInt(ye.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:t(ye.above,this.defaultValue.above)}}}var $e;(function(_){_[_.None=0]="None",_[_.Text=1]="Text",_[_.Blocks=2]="Blocks"})($e||(e.RenderMinimap=$e={}));class se extends a{constructor(){super(ze.layoutInfo)}compute(H,ye,Ke){return se.computeLayout(ye,{memory:H.memory,outerWidth:H.outerWidth,outerHeight:H.outerHeight,isDominatedByLongLines:H.isDominatedByLongLines,lineHeight:H.fontInfo.lineHeight,viewLineCount:H.viewLineCount,lineNumbersDigitCount:H.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:H.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:H.fontInfo.maxDigitWidth,pixelRatio:H.pixelRatio,glyphMarginDecorationLaneCount:H.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(H){const ye=H.height/H.lineHeight,Ke=Math.floor(H.paddingTop/H.lineHeight);let xe=Math.floor(H.paddingBottom/H.lineHeight);H.scrollBeyondLastLine&&(xe=Math.max(xe,ye-1));const ct=(Ke+H.viewLineCount+xe)/(H.pixelRatio*H.height),gt=Math.floor(H.viewLineCount/ct);return{typicalViewportLineCount:ye,extraLinesBeforeFirstLine:Ke,extraLinesBeyondLastLine:xe,desiredRatio:ct,minimapLineCount:gt}}static c(H,ye){const Ke=H.outerWidth,xe=H.outerHeight,ct=H.pixelRatio;if(!H.minimap.enabled)return{renderMinimap:$e.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ct*xe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:xe};const gt=ye.stableMinimapLayoutInput,Mt=gt&&H.outerHeight===gt.outerHeight&&H.lineHeight===gt.lineHeight&&H.typicalHalfwidthCharacterWidth===gt.typicalHalfwidthCharacterWidth&&H.pixelRatio===gt.pixelRatio&&H.scrollBeyondLastLine===gt.scrollBeyondLastLine&&H.paddingTop===gt.paddingTop&&H.paddingBottom===gt.paddingBottom&&H.minimap.enabled===gt.minimap.enabled&&H.minimap.side===gt.minimap.side&&H.minimap.size===gt.minimap.size&&H.minimap.showSlider===gt.minimap.showSlider&&H.minimap.renderCharacters===gt.minimap.renderCharacters&&H.minimap.maxColumn===gt.minimap.maxColumn&&H.minimap.scale===gt.minimap.scale&&H.verticalScrollbarWidth===gt.verticalScrollbarWidth&&H.isViewportWrapping===gt.isViewportWrapping,Qt=H.lineHeight,Ut=H.typicalHalfwidthCharacterWidth,li=H.scrollBeyondLastLine,xt=H.minimap.renderCharacters;let Ye=ct>=2?Math.round(H.minimap.scale*2):H.minimap.scale;const Wt=H.minimap.maxColumn,zt=H.minimap.size,ft=H.minimap.side,pt=H.verticalScrollbarWidth,_t=H.viewLineCount,Yt=H.remainingWidth,jt=H.isViewportWrapping,bt=xt?2:3;let Ot=Math.floor(ct*xe);const Gt=Ot/ct;let Bt=!1,Qe=!1,ei=bt*Ye,ti=Ye/ct,ci=1;if(zt==="fill"||zt==="fit"){const{typicalViewportLineCount:ri,extraLinesBeforeFirstLine:Lt,extraLinesBeyondLastLine:Xt,desiredRatio:si,minimapLineCount:Ct}=se.computeContainedMinimapLineCount({viewLineCount:_t,scrollBeyondLastLine:li,paddingTop:H.paddingTop,paddingBottom:H.paddingBottom,height:xe,lineHeight:Qt,pixelRatio:ct});if(_t/Ct>1)Bt=!0,Qe=!0,Ye=1,ei=1,ti=Ye/ct;else{let $t=!1,qt=Ye+1;if(zt==="fit"){const Dt=Math.ceil((Lt+_t+Xt)*ei);jt&&Mt&&Yt<=ye.stableFitRemainingWidth?($t=!0,qt=ye.stableFitMaxMinimapScale):$t=Dt>Ot}if(zt==="fill"||$t){Bt=!0;const Dt=Ye;ei=Math.min(Qt*ct,Math.max(1,Math.floor(1/si))),jt&&Mt&&Yt<=ye.stableFitRemainingWidth&&(qt=ye.stableFitMaxMinimapScale),Ye=Math.min(qt,Math.max(1,Math.floor(ei/bt))),Ye>Dt&&(ci=Math.min(2,Ye/Dt)),ti=Ye/ct/ci,Ot=Math.ceil(Math.max(ri,Lt+_t+Xt)*ei),jt?(ye.stableMinimapLayoutInput=H,ye.stableFitRemainingWidth=Yt,ye.stableFitMaxMinimapScale=Ye):(ye.stableMinimapLayoutInput=null,ye.stableFitRemainingWidth=0)}}}const St=Math.floor(Wt*ti),Tt=Math.min(St,Math.max(0,Math.floor((Yt-pt-2)*ti/(Ut+ti)))+e.MINIMAP_GUTTER_WIDTH);let Pt=Math.floor(ct*Tt);const Nt=Pt/ct;Pt=Math.floor(Pt*ci);const ui=xt?$e.Text:$e.Blocks,Vt=ft==="left"?0:Ke-Tt-pt;return{renderMinimap:ui,minimapLeft:Vt,minimapWidth:Tt,minimapHeightIsEditorHeight:Bt,minimapIsSampling:Qe,minimapScale:Ye,minimapLineHeight:ei,minimapCanvasInnerWidth:Pt,minimapCanvasInnerHeight:Ot,minimapCanvasOuterWidth:Nt,minimapCanvasOuterHeight:Gt}}static computeLayout(H,ye){const Ke=ye.outerWidth|0,xe=ye.outerHeight|0,ct=ye.lineHeight|0,gt=ye.lineNumbersDigitCount|0,Mt=ye.typicalHalfwidthCharacterWidth,Qt=ye.maxDigitWidth,Ut=ye.pixelRatio,li=ye.viewLineCount,xt=H.get(ze.wordWrapOverride2),Ye=xt==="inherit"?H.get(ze.wordWrapOverride1):xt,Wt=Ye==="inherit"?H.get(ze.wordWrap):Ye,zt=H.get(ze.wordWrapColumn),ft=ye.isDominatedByLongLines,pt=H.get(ze.glyphMargin),_t=H.get(ze.lineNumbers).renderType!==Te.Off,Yt=H.get(ze.lineNumbersMinChars),jt=H.get(ze.scrollBeyondLastLine),bt=H.get(ze.padding),Ot=H.get(ze.minimap),Gt=H.get(ze.scrollbar),Bt=Gt.verticalScrollbarSize,Qe=Gt.verticalHasArrows,ei=Gt.arrowSize,ti=Gt.horizontalScrollbarSize,ci=H.get(ze.folding),St=H.get(ze.showFoldingControls)!=="never";let Tt=H.get(ze.lineDecorationsWidth);ci&&St&&(Tt+=16);let Pt=0;if(_t){const Kt=Math.max(gt,Yt);Pt=Math.round(Kt*Qt)}let Nt=0;pt&&(Nt=ct*ye.glyphMarginDecorationLaneCount);let ui=0,Vt=ui+Nt,ri=Vt+Pt,Lt=ri+Tt;const Xt=Ke-Nt-Pt-Tt;let si=!1,Ct=!1,wt=-1;Ye==="inherit"&&ft?(si=!0,Ct=!0):Wt==="on"||Wt==="bounded"?Ct=!0:Wt==="wordWrapColumn"&&(wt=zt);const $t=se.c({outerWidth:Ke,outerHeight:xe,lineHeight:ct,typicalHalfwidthCharacterWidth:Mt,pixelRatio:Ut,scrollBeyondLastLine:jt,paddingTop:bt.top,paddingBottom:bt.bottom,minimap:Ot,verticalScrollbarWidth:Bt,viewLineCount:li,remainingWidth:Xt,isViewportWrapping:Ct},ye.memory||new D);$t.renderMinimap!==$e.None&&$t.minimapLeft===0&&(ui+=$t.minimapWidth,Vt+=$t.minimapWidth,ri+=$t.minimapWidth,Lt+=$t.minimapWidth);const qt=Xt-$t.minimapWidth,Dt=Math.max(1,Math.floor((qt-Bt-2)/Mt)),oi=Qe?ei:0;return Ct&&(wt=Math.max(1,Dt),Wt==="bounded"&&(wt=Math.min(wt,zt))),{width:Ke,height:xe,glyphMarginLeft:ui,glyphMarginWidth:Nt,glyphMarginDecorationLaneCount:ye.glyphMarginDecorationLaneCount,lineNumbersLeft:Vt,lineNumbersWidth:Pt,decorationsLeft:ri,decorationsWidth:Tt,contentLeft:Lt,contentWidth:qt,minimap:$t,viewportColumn:Dt,isWordWrapMinified:si,isViewportWrapping:Ct,wrappingColumn:wt,verticalScrollbarWidth:Bt,horizontalScrollbarHeight:ti,overviewRuler:{top:oi,width:Bt,height:xe-2*oi,right:0}}}}e.EditorLayoutInfoComputer=se;class Ce extends d{constructor(){super(ze.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[c.localize(47,null),c.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:c.localize(49,null)}})}validate(H){return b(H,"simple",["simple","advanced"])}compute(H,ye,Ke){return ye.get(ze.accessibilitySupport)===C.AccessibilitySupport.Enabled?"advanced":Ke}}var Fe;(function(_){_.Off="off",_.OnCode="onCode",_.On="on"})(Fe||(e.ShowLightbulbIconMode=Fe={}));class X extends d{constructor(){const H={enabled:Fe.On};super(ze.lightbulb,"lightbulb",H,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[Fe.Off,Fe.OnCode,Fe.On],default:H.enabled,enumDescriptions:[c.localize(50,null),c.localize(51,null),c.localize(52,null)],description:c.localize(53,null)}})}validate(H){return!H||typeof H!="object"?this.defaultValue:{enabled:b(H.enabled,this.defaultValue.enabled,[Fe.Off,Fe.OnCode,Fe.On])}}}class W extends d{constructor(){const H={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(ze.stickyScroll,"stickyScroll",H,{"editor.stickyScroll.enabled":{type:"boolean",default:H.enabled,description:c.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:H.maxLineCount,minimum:1,maximum:20,description:c.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:H.defaultModel,description:c.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:H.scrollWithEditor,description:c.localize(57,null)}})}validate(H){if(!H||typeof H!="object")return this.defaultValue;const ye=H;return{enabled:t(ye.enabled,this.defaultValue.enabled),maxLineCount:i.clampedInt(ye.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:b(ye.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:t(ye.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ie extends d{constructor(){const H={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(ze.inlayHints,"inlayHints",H,{"editor.inlayHints.enabled":{type:"string",default:H.enabled,description:c.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[c.localize(59,null),c.localize(60,null,P.$j?"Ctrl+Option":"Ctrl+Alt"),c.localize(61,null,P.$j?"Ctrl+Option":"Ctrl+Alt"),c.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:H.fontSize,markdownDescription:c.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:H.fontFamily,markdownDescription:c.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:H.padding,description:c.localize(65,null)}})}validate(H){if(!H||typeof H!="object")return this.defaultValue;const ye=H;return typeof ye.enabled=="boolean"&&(ye.enabled=ye.enabled?"on":"off"),{enabled:b(ye.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:i.clampedInt(ye.fontSize,this.defaultValue.fontSize,0,100),fontFamily:l.string(ye.fontFamily,this.defaultValue.fontFamily),padding:t(ye.padding,this.defaultValue.padding)}}}class Se extends d{constructor(){super(ze.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(H){return typeof H=="string"&&/^\d+(\.\d+)?ch$/.test(H)?-parseFloat(H.substring(0,H.length-2)):i.clampedInt(H,this.defaultValue,0,1e3)}compute(H,ye,Ke){return Ke<0?i.clampedInt(-Ke*H.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ke}}class he extends f{constructor(){super(ze.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,H=>f.clamp(H,0,150),{markdownDescription:c.localize(66,null)})}compute(H,ye,Ke){return H.fontInfo.lineHeight}}class we extends d{constructor(){const H={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(ze.minimap,"minimap",H,{"editor.minimap.enabled":{type:"boolean",default:H.enabled,description:c.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:H.autohide,description:c.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[c.localize(69,null),c.localize(70,null),c.localize(71,null)],default:H.size,description:c.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:H.side,description:c.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:H.showSlider,description:c.localize(74,null)},"editor.minimap.scale":{type:"number",default:H.scale,minimum:1,maximum:3,enum:[1,2,3],description:c.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:H.renderCharacters,description:c.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:H.maxColumn,description:c.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:H.showRegionSectionHeaders,description:c.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:H.showMarkSectionHeaders,description:c.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:H.sectionHeaderFontSize,description:c.localize(80,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:H.sectionHeaderLetterSpacing,description:c.localize(81,null)}})}validate(H){if(!H||typeof H!="object")return this.defaultValue;const ye=H;return{enabled:t(ye.enabled,this.defaultValue.enabled),autohide:t(ye.autohide,this.defaultValue.autohide),size:b(ye.size,this.defaultValue.size,["proportional","fill","fit"]),side:b(ye.side,this.defaultValue.side,["right","left"]),showSlider:b(ye.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(ye.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt(ye.scale,1,1,3),maxColumn:i.clampedInt(ye.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:t(ye.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:t(ye.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:f.clamp(ye.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:f.clamp(ye.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function ae(_){return _==="ctrlCmd"?P.$j?"metaKey":"ctrlKey":"altKey"}class Y extends d{constructor(){super(ze.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(82,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(83,null)}})}validate(H){if(!H||typeof H!="object")return this.defaultValue;const ye=H;return{top:i.clampedInt(ye.top,0,0,1e3),bottom:i.clampedInt(ye.bottom,0,0,1e3)}}}class x extends d{constructor(){const H={enabled:!0,cycle:!0};super(ze.parameterHints,"parameterHints",H,{"editor.parameterHints.enabled":{type:"boolean",default:H.enabled,description:c.localize(84,null)},"editor.parameterHints.cycle":{type:"boolean",default:H.cycle,description:c.localize(85,null)}})}validate(H){if(!H||typeof H!="object")return this.defaultValue;const ye=H;return{enabled:t(ye.enabled,this.defaultValue.enabled),cycle:t(ye.cycle,this.defaultValue.cycle)}}}class me extends a{constructor(){super(ze.pixelRatio)}compute(H,ye,Ke){return H.pixelRatio}}class ge extends d{constructor(){const H={other:"on",comments:"off",strings:"off"},ye=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[c.localize(86,null),c.localize(87,null),c.localize(88,null)]}];super(ze.quickSuggestions,"quickSuggestions",H,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ye,default:H.strings,description:c.localize(89,null)},comments:{anyOf:ye,default:H.comments,description:c.localize(90,null)},other:{anyOf:ye,default:H.other,description:c.localize(91,null)}},default:H,markdownDescription:c.localize(92,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=H}validate(H){if(typeof H=="boolean"){const Ut=H?"on":"off";return{comments:Ut,strings:Ut,other:Ut}}if(!H||typeof H!="object")return this.defaultValue;const{other:ye,comments:Ke,strings:xe}=H,ct=["on","inline","off"];let gt,Mt,Qt;return typeof ye=="boolean"?gt=ye?"on":"off":gt=b(ye,this.defaultValue.other,ct),typeof Ke=="boolean"?Mt=Ke?"on":"off":Mt=b(Ke,this.defaultValue.comments,ct),typeof xe=="boolean"?Qt=xe?"on":"off":Qt=b(xe,this.defaultValue.strings,ct),{other:gt,comments:Mt,strings:Qt}}}var Te;(function(_){_[_.Off=0]="Off",_[_.On=1]="On",_[_.Relative=2]="Relative",_[_.Interval=3]="Interval",_[_.Custom=4]="Custom"})(Te||(e.RenderLineNumbersType=Te={}));class Be extends d{constructor(){super(ze.lineNumbers,"lineNumbers",{renderType:Te.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[c.localize(93,null),c.localize(94,null),c.localize(95,null),c.localize(96,null)],default:"on",description:c.localize(97,null)})}validate(H){let ye=this.defaultValue.renderType,Ke=this.defaultValue.renderFn;return typeof H<"u"&&(typeof H=="function"?(ye=Te.Custom,Ke=H):H==="interval"?ye=Te.Interval:H==="relative"?ye=Te.Relative:H==="on"?ye=Te.On:ye=Te.Off),{renderType:ye,renderFn:Ke}}}function Ee(_){const H=_.get(ze.renderValidationDecorations);return H==="editable"?_.get(ze.readOnly):H!=="on"}class Re extends d{constructor(){const H=[],ye={type:"number",description:c.localize(98,null)};super(ze.rulers,"rulers",H,{type:"array",items:{anyOf:[ye,{type:["object"],properties:{column:ye,color:{type:"string",description:c.localize(99,null),format:"color-hex"}}}]},default:H,description:c.localize(100,null)})}validate(H){if(Array.isArray(H)){const ye=[];for(const Ke of H)if(typeof Ke=="number")ye.push({column:i.clampedInt(Ke,0,0,1e4),color:null});else if(Ke&&typeof Ke=="object"){const xe=Ke;ye.push({column:i.clampedInt(xe.column,0,0,1e4),color:xe.color})}return ye.sort((Ke,xe)=>Ke.column-xe.column),ye}return this.defaultValue}}class Oe extends d{constructor(){super(ze.readOnlyMessage,"readOnlyMessage",void 0)}validate(H){return!H||typeof H!="object"?this.defaultValue:H}}function j(_,H){if(typeof _!="string")return H;switch(_){case"hidden":return O.ScrollbarVisibility.Hidden;case"visible":return O.ScrollbarVisibility.Visible;default:return O.ScrollbarVisibility.Auto}}class z extends d{constructor(){const H={vertical:O.ScrollbarVisibility.Auto,horizontal:O.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(ze.scrollbar,"scrollbar",H,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(101,null),c.localize(102,null),c.localize(103,null)],default:"auto",description:c.localize(104,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(105,null),c.localize(106,null),c.localize(107,null)],default:"auto",description:c.localize(108,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:H.verticalScrollbarSize,description:c.localize(109,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:H.horizontalScrollbarSize,description:c.localize(110,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:H.scrollByPage,description:c.localize(111,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:H.ignoreHorizontalScrollbarInContentHeight,description:c.localize(112,null)}})}validate(H){if(!H||typeof H!="object")return this.defaultValue;const ye=H,Ke=i.clampedInt(ye.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),xe=i.clampedInt(ye.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt(ye.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:j(ye.vertical,this.defaultValue.vertical),horizontal:j(ye.horizontal,this.defaultValue.horizontal),useShadows:t(ye.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(ye.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(ye.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(ye.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(ye.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ke,horizontalSliderSize:i.clampedInt(ye.horizontalSliderSize,Ke,0,1e3),verticalScrollbarSize:xe,verticalSliderSize:i.clampedInt(ye.verticalSliderSize,xe,0,1e3),scrollByPage:t(ye.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:t(ye.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class K extends d{constructor(){const H={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(ze.unicodeHighlighting,"unicodeHighlight",H,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:H.nonBasicASCII,description:c.localize(113,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:H.invisibleCharacters,description:c.localize(114,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:H.ambiguousCharacters,description:c.localize(115,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:H.includeComments,description:c.localize(116,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:H.includeStrings,description:c.localize(117,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:H.allowedCharacters,description:c.localize(118,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:H.allowedLocales,description:c.localize(119,null)}})}applyUpdate(H,ye){let Ke=!1;ye.allowedCharacters&&H&&(R.$ao(H.allowedCharacters,ye.allowedCharacters)||(H={...H,allowedCharacters:ye.allowedCharacters},Ke=!0)),ye.allowedLocales&&H&&(R.$ao(H.allowedLocales,ye.allowedLocales)||(H={...H,allowedLocales:ye.allowedLocales},Ke=!0));const xe=super.applyUpdate(H,ye);return Ke?new r(xe.newValue,!0):xe}validate(H){if(!H||typeof H!="object")return this.defaultValue;const ye=H;return{nonBasicASCII:je(ye.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(ye.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(ye.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:je(ye.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:je(ye.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(H.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(H.allowedLocales,this.defaultValue.allowedLocales)}}c(H,ye){if(typeof H!="object"||!H)return ye;const Ke={};for(const[xe,ct]of Object.entries(H))ct===!0&&(Ke[xe]=!0);return Ke}}class J extends d{constructor(){const H={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(ze.inlineSuggest,"inlineSuggest",H,{"editor.inlineSuggest.enabled":{type:"boolean",default:H.enabled,description:c.localize(120,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:H.showToolbar,enum:["always","onHover","never"],enumDescriptions:[c.localize(121,null),c.localize(122,null),c.localize(123,null)],description:c.localize(124,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:H.suppressSuggestions,description:c.localize(125,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:H.fontFamily,description:c.localize(126,null)}})}validate(H){if(!H||typeof H!="object")return this.defaultValue;const ye=H;return{enabled:t(ye.enabled,this.defaultValue.enabled),mode:b(ye.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:b(ye.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:t(ye.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t(ye.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:l.string(ye.fontFamily,this.defaultValue.fontFamily)}}}class te extends d{constructor(){const H={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(ze.inlineEdit,"experimentalInlineEdit",H,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:H.enabled,description:c.localize(127,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:H.showToolbar,enum:["always","onHover","never"],enumDescriptions:[c.localize(128,null),c.localize(129,null),c.localize(130,null)],description:c.localize(131,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:H.fontFamily,description:c.localize(132,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:H.backgroundColoring,description:c.localize(133,null)}})}validate(H){if(!H||typeof H!="object")return this.defaultValue;const ye=H;return{enabled:t(ye.enabled,this.defaultValue.enabled),showToolbar:b(ye.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:l.string(ye.fontFamily,this.defaultValue.fontFamily),keepOnBlur:t(ye.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:t(ye.backgroundColoring,this.defaultValue.backgroundColoring)}}}class le extends d{constructor(){const H={enabled:M.$nu.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:M.$nu.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(ze.bracketPairColorization,"bracketPairColorization",H,{"editor.bracketPairColorization.enabled":{type:"boolean",default:H.enabled,markdownDescription:c.localize(134,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:H.independentColorPoolPerBracketType,description:c.localize(135,null)}})}validate(H){if(!H||typeof H!="object")return this.defaultValue;const ye=H;return{enabled:t(ye.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(ye.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Ae extends d{constructor(){const H={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(ze.guides,"guides",H,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(136,null),c.localize(137,null),c.localize(138,null)],default:H.bracketPairs,description:c.localize(139,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(140,null),c.localize(141,null),c.localize(142,null)],default:H.bracketPairsHorizontal,description:c.localize(143,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:H.highlightActiveBracketPair,description:c.localize(144,null)},"editor.guides.indentation":{type:"boolean",default:H.indentation,description:c.localize(145,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[c.localize(146,null),c.localize(147,null),c.localize(148,null)],default:H.highlightActiveIndentation,description:c.localize(149,null)}})}validate(H){if(!H||typeof H!="object")return this.defaultValue;const ye=H;return{bracketPairs:je(ye.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:je(ye.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(ye.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(ye.indentation,this.defaultValue.indentation),highlightActiveIndentation:je(ye.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function je(_,H,ye){const Ke=ye.indexOf(_);return Ke===-1?H:ye[Ke]}class Ge extends d{constructor(){const H={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(ze.suggest,"suggest",H,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[c.localize(150,null),c.localize(151,null)],default:H.insertMode,description:c.localize(152,null)},"editor.suggest.filterGraceful":{type:"boolean",default:H.filterGraceful,description:c.localize(153,null)},"editor.suggest.localityBonus":{type:"boolean",default:H.localityBonus,description:c.localize(154,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:H.shareSuggestSelections,markdownDescription:c.localize(155,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[c.localize(156,null),c.localize(157,null),c.localize(158,null),c.localize(159,null)],default:H.selectionMode,markdownDescription:c.localize(160,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:H.snippetsPreventQuickSuggestions,description:c.localize(161,null)},"editor.suggest.showIcons":{type:"boolean",default:H.showIcons,description:c.localize(162,null)},"editor.suggest.showStatusBar":{type:"boolean",default:H.showStatusBar,description:c.localize(163,null)},"editor.suggest.preview":{type:"boolean",default:H.preview,description:c.localize(164,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:H.showInlineDetails,description:c.localize(165,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:c.localize(166,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:c.localize(167,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:c.localize(168,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:c.localize(169,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:c.localize(170,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:c.localize(171,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:c.localize(172,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:c.localize(173,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:c.localize(174,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:c.localize(175,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:c.localize(176,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:c.localize(177,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:c.localize(178,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:c.localize(179,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:c.localize(180,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:c.localize(181,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:c.localize(182,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:c.localize(183,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:c.localize(184,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:c.localize(185,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:c.localize(186,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:c.localize(187,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:c.localize(188,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:c.localize(189,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:c.localize(190,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:c.localize(191,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:c.localize(192,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:c.localize(193,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:c.localize(194,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:c.localize(195,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:c.localize(196,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:c.localize(197,null)}})}validate(H){if(!H||typeof H!="object")return this.defaultValue;const ye=H;return{insertMode:b(ye.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(ye.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(ye.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(ye.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(ye.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:b(ye.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(ye.showIcons,this.defaultValue.showIcons),showStatusBar:t(ye.showStatusBar,this.defaultValue.showStatusBar),preview:t(ye.preview,this.defaultValue.preview),previewMode:b(ye.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(ye.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(ye.showMethods,this.defaultValue.showMethods),showFunctions:t(ye.showFunctions,this.defaultValue.showFunctions),showConstructors:t(ye.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(ye.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(ye.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(ye.showFields,this.defaultValue.showFields),showVariables:t(ye.showVariables,this.defaultValue.showVariables),showClasses:t(ye.showClasses,this.defaultValue.showClasses),showStructs:t(ye.showStructs,this.defaultValue.showStructs),showInterfaces:t(ye.showInterfaces,this.defaultValue.showInterfaces),showModules:t(ye.showModules,this.defaultValue.showModules),showProperties:t(ye.showProperties,this.defaultValue.showProperties),showEvents:t(ye.showEvents,this.defaultValue.showEvents),showOperators:t(ye.showOperators,this.defaultValue.showOperators),showUnits:t(ye.showUnits,this.defaultValue.showUnits),showValues:t(ye.showValues,this.defaultValue.showValues),showConstants:t(ye.showConstants,this.defaultValue.showConstants),showEnums:t(ye.showEnums,this.defaultValue.showEnums),showEnumMembers:t(ye.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(ye.showKeywords,this.defaultValue.showKeywords),showWords:t(ye.showWords,this.defaultValue.showWords),showColors:t(ye.showColors,this.defaultValue.showColors),showFiles:t(ye.showFiles,this.defaultValue.showFiles),showReferences:t(ye.showReferences,this.defaultValue.showReferences),showFolders:t(ye.showFolders,this.defaultValue.showFolders),showTypeParameters:t(ye.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(ye.showSnippets,this.defaultValue.showSnippets),showUsers:t(ye.showUsers,this.defaultValue.showUsers),showIssues:t(ye.showIssues,this.defaultValue.showIssues)}}}class Ze extends d{constructor(){super(ze.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:c.localize(198,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:c.localize(199,null),default:!0,type:"boolean"}})}validate(H){return!H||typeof H!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(H.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:t(H.selectSubwords,this.defaultValue.selectSubwords)}}}class tt extends d{constructor(){const H=[];super(ze.wordSegmenterLocales,"wordSegmenterLocales",H,{anyOf:[{description:c.localize(200,null),type:"string"},{description:c.localize(201,null),type:"array",items:{type:"string"}}]})}validate(H){if(typeof H=="string"&&(H=[H]),Array.isArray(H)){const ye=[];for(const Ke of H)if(typeof Ke=="string")try{Intl.Segmenter.supportedLocalesOf(Ke).length>0&&ye.push(Ke)}catch{}return ye}return this.defaultValue}}var _e;(function(_){_[_.None=0]="None",_[_.Same=1]="Same",_[_.Indent=2]="Indent",_[_.DeepIndent=3]="DeepIndent"})(_e||(e.WrappingIndent=_e={}));class it extends d{constructor(){super(ze.wrappingIndent,"wrappingIndent",_e.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[c.localize(202,null),c.localize(203,null),c.localize(204,null),c.localize(205,null)],description:c.localize(206,null),default:"same"}})}validate(H){switch(H){case"none":return _e.None;case"same":return _e.Same;case"indent":return _e.Indent;case"deepIndent":return _e.DeepIndent}return _e.Same}compute(H,ye,Ke){return ye.get(ze.accessibilitySupport)===C.AccessibilitySupport.Enabled?_e.None:Ke}}class nt extends a{constructor(){super(ze.wrappingInfo)}compute(H,ye,Ke){const xe=ye.get(ze.layoutInfo);return{isDominatedByLongLines:H.isDominatedByLongLines,isWordWrapMinified:xe.isWordWrapMinified,isViewportWrapping:xe.isViewportWrapping,wrappingColumn:xe.wrappingColumn}}}class mt extends d{constructor(){const H={enabled:!0,showDropSelector:"afterDrop"};super(ze.dropIntoEditor,"dropIntoEditor",H,{"editor.dropIntoEditor.enabled":{type:"boolean",default:H.enabled,markdownDescription:c.localize(207,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:c.localize(208,null),enum:["afterDrop","never"],enumDescriptions:[c.localize(209,null),c.localize(210,null)],default:"afterDrop"}})}validate(H){if(!H||typeof H!="object")return this.defaultValue;const ye=H;return{enabled:t(ye.enabled,this.defaultValue.enabled),showDropSelector:b(ye.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class lt extends d{constructor(){const H={enabled:!0,showPasteSelector:"afterPaste"};super(ze.pasteAs,"pasteAs",H,{"editor.pasteAs.enabled":{type:"boolean",default:H.enabled,markdownDescription:c.localize(211,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:c.localize(212,null),enum:["afterPaste","never"],enumDescriptions:[c.localize(213,null),c.localize(214,null)],default:"afterPaste"}})}validate(H){if(!H||typeof H!="object")return this.defaultValue;const ye=H;return{enabled:t(ye.enabled,this.defaultValue.enabled),showPasteSelector:b(ye.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const rt="Consolas, 'Courier New', monospace",at="Menlo, Monaco, 'Courier New', monospace",dt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:P.$j?at:P.$k?dt:rt,fontWeight:"normal",fontSize:P.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function We(_){return e.editorOptionsRegistry[_.id]=_,_}var ze;(function(_){_[_.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",_[_.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",_[_.accessibilitySupport=2]="accessibilitySupport",_[_.accessibilityPageSize=3]="accessibilityPageSize",_[_.ariaLabel=4]="ariaLabel",_[_.ariaRequired=5]="ariaRequired",_[_.autoClosingBrackets=6]="autoClosingBrackets",_[_.autoClosingComments=7]="autoClosingComments",_[_.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",_[_.autoClosingDelete=9]="autoClosingDelete",_[_.autoClosingOvertype=10]="autoClosingOvertype",_[_.autoClosingQuotes=11]="autoClosingQuotes",_[_.autoIndent=12]="autoIndent",_[_.automaticLayout=13]="automaticLayout",_[_.autoSurround=14]="autoSurround",_[_.bracketPairColorization=15]="bracketPairColorization",_[_.guides=16]="guides",_[_.codeLens=17]="codeLens",_[_.codeLensFontFamily=18]="codeLensFontFamily",_[_.codeLensFontSize=19]="codeLensFontSize",_[_.colorDecorators=20]="colorDecorators",_[_.colorDecoratorsLimit=21]="colorDecoratorsLimit",_[_.columnSelection=22]="columnSelection",_[_.comments=23]="comments",_[_.contextmenu=24]="contextmenu",_[_.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",_[_.cursorBlinking=26]="cursorBlinking",_[_.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",_[_.cursorStyle=28]="cursorStyle",_[_.cursorSurroundingLines=29]="cursorSurroundingLines",_[_.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",_[_.cursorWidth=31]="cursorWidth",_[_.disableLayerHinting=32]="disableLayerHinting",_[_.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",_[_.domReadOnly=34]="domReadOnly",_[_.dragAndDrop=35]="dragAndDrop",_[_.dropIntoEditor=36]="dropIntoEditor",_[_.emptySelectionClipboard=37]="emptySelectionClipboard",_[_.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",_[_.extraEditorClassName=39]="extraEditorClassName",_[_.fastScrollSensitivity=40]="fastScrollSensitivity",_[_.find=41]="find",_[_.fixedOverflowWidgets=42]="fixedOverflowWidgets",_[_.folding=43]="folding",_[_.foldingStrategy=44]="foldingStrategy",_[_.foldingHighlight=45]="foldingHighlight",_[_.foldingImportsByDefault=46]="foldingImportsByDefault",_[_.foldingMaximumRegions=47]="foldingMaximumRegions",_[_.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",_[_.fontFamily=49]="fontFamily",_[_.fontInfo=50]="fontInfo",_[_.fontLigatures=51]="fontLigatures",_[_.fontSize=52]="fontSize",_[_.fontWeight=53]="fontWeight",_[_.fontVariations=54]="fontVariations",_[_.formatOnPaste=55]="formatOnPaste",_[_.formatOnType=56]="formatOnType",_[_.glyphMargin=57]="glyphMargin",_[_.gotoLocation=58]="gotoLocation",_[_.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",_[_.hover=60]="hover",_[_.inDiffEditor=61]="inDiffEditor",_[_.inlineSuggest=62]="inlineSuggest",_[_.inlineEdit=63]="inlineEdit",_[_.letterSpacing=64]="letterSpacing",_[_.lightbulb=65]="lightbulb",_[_.lineDecorationsWidth=66]="lineDecorationsWidth",_[_.lineHeight=67]="lineHeight",_[_.lineNumbers=68]="lineNumbers",_[_.lineNumbersMinChars=69]="lineNumbersMinChars",_[_.linkedEditing=70]="linkedEditing",_[_.links=71]="links",_[_.matchBrackets=72]="matchBrackets",_[_.minimap=73]="minimap",_[_.mouseStyle=74]="mouseStyle",_[_.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",_[_.mouseWheelZoom=76]="mouseWheelZoom",_[_.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",_[_.multiCursorModifier=78]="multiCursorModifier",_[_.multiCursorPaste=79]="multiCursorPaste",_[_.multiCursorLimit=80]="multiCursorLimit",_[_.occurrencesHighlight=81]="occurrencesHighlight",_[_.overviewRulerBorder=82]="overviewRulerBorder",_[_.overviewRulerLanes=83]="overviewRulerLanes",_[_.padding=84]="padding",_[_.pasteAs=85]="pasteAs",_[_.parameterHints=86]="parameterHints",_[_.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",_[_.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",_[_.quickSuggestions=89]="quickSuggestions",_[_.quickSuggestionsDelay=90]="quickSuggestionsDelay",_[_.readOnly=91]="readOnly",_[_.readOnlyMessage=92]="readOnlyMessage",_[_.renameOnType=93]="renameOnType",_[_.renderControlCharacters=94]="renderControlCharacters",_[_.renderFinalNewline=95]="renderFinalNewline",_[_.renderLineHighlight=96]="renderLineHighlight",_[_.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",_[_.renderValidationDecorations=98]="renderValidationDecorations",_[_.renderWhitespace=99]="renderWhitespace",_[_.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",_[_.roundedSelection=101]="roundedSelection",_[_.rulers=102]="rulers",_[_.scrollbar=103]="scrollbar",_[_.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",_[_.scrollBeyondLastLine=105]="scrollBeyondLastLine",_[_.scrollPredominantAxis=106]="scrollPredominantAxis",_[_.selectionClipboard=107]="selectionClipboard",_[_.selectionHighlight=108]="selectionHighlight",_[_.selectOnLineNumbers=109]="selectOnLineNumbers",_[_.showFoldingControls=110]="showFoldingControls",_[_.showUnused=111]="showUnused",_[_.snippetSuggestions=112]="snippetSuggestions",_[_.smartSelect=113]="smartSelect",_[_.smoothScrolling=114]="smoothScrolling",_[_.stickyScroll=115]="stickyScroll",_[_.stickyTabStops=116]="stickyTabStops",_[_.stopRenderingLineAfter=117]="stopRenderingLineAfter",_[_.suggest=118]="suggest",_[_.suggestFontSize=119]="suggestFontSize",_[_.suggestLineHeight=120]="suggestLineHeight",_[_.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",_[_.suggestSelection=122]="suggestSelection",_[_.tabCompletion=123]="tabCompletion",_[_.tabIndex=124]="tabIndex",_[_.unicodeHighlighting=125]="unicodeHighlighting",_[_.unusualLineTerminators=126]="unusualLineTerminators",_[_.useShadowDOM=127]="useShadowDOM",_[_.useTabStops=128]="useTabStops",_[_.wordBreak=129]="wordBreak",_[_.wordSegmenterLocales=130]="wordSegmenterLocales",_[_.wordSeparators=131]="wordSeparators",_[_.wordWrap=132]="wordWrap",_[_.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",_[_.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",_[_.wordWrapColumn=135]="wordWrapColumn",_[_.wordWrapOverride1=136]="wordWrapOverride1",_[_.wordWrapOverride2=137]="wordWrapOverride2",_[_.wrappingIndent=138]="wrappingIndent",_[_.wrappingStrategy=139]="wrappingStrategy",_[_.showDeprecated=140]="showDeprecated",_[_.inlayHints=141]="inlayHints",_[_.editorClassName=142]="editorClassName",_[_.pixelRatio=143]="pixelRatio",_[_.tabFocusMode=144]="tabFocusMode",_[_.layoutInfo=145]="layoutInfo",_[_.wrappingInfo=146]="wrappingInfo",_[_.defaultColorDecorators=147]="defaultColorDecorators",_[_.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",_[_.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(ze||(e.EditorOption=ze={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:We(new s(ze.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:c.localize(215,null)})),acceptSuggestionOnEnter:We(new I(ze.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",c.localize(216,null),""],markdownDescription:c.localize(217,null)})),accessibilitySupport:We(new p),accessibilityPageSize:We(new i(ze.accessibilityPageSize,"accessibilityPageSize",10,1,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(218,null),tags:["accessibility"]})),ariaLabel:We(new l(ze.ariaLabel,"ariaLabel",c.localize(219,null))),ariaRequired:We(new s(ze.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:We(new s(ze.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:c.localize(220,null),tags:["accessibility"]})),autoClosingBrackets:We(new I(ze.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(221,null),c.localize(222,null),""],description:c.localize(223,null)})),autoClosingComments:We(new I(ze.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(224,null),c.localize(225,null),""],description:c.localize(226,null)})),autoClosingDelete:We(new I(ze.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",c.localize(227,null),""],description:c.localize(228,null)})),autoClosingOvertype:We(new I(ze.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",c.localize(229,null),""],description:c.localize(230,null)})),autoClosingQuotes:We(new I(ze.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(231,null),c.localize(232,null),""],description:c.localize(233,null)})),autoIndent:We(new S(ze.autoIndent,"autoIndent",v.Full,"full",["none","keep","brackets","advanced","full"],y,{enumDescriptions:[c.localize(234,null),c.localize(235,null),c.localize(236,null),c.localize(237,null),c.localize(238,null)],description:c.localize(239,null)})),automaticLayout:We(new s(ze.automaticLayout,"automaticLayout",!1)),autoSurround:We(new I(ze.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[c.localize(240,null),c.localize(241,null),c.localize(242,null),""],description:c.localize(243,null)})),bracketPairColorization:We(new le),bracketPairGuides:We(new Ae),stickyTabStops:We(new s(ze.stickyTabStops,"stickyTabStops",!1,{description:c.localize(244,null)})),codeLens:We(new s(ze.codeLens,"codeLens",!0,{description:c.localize(245,null)})),codeLensFontFamily:We(new l(ze.codeLensFontFamily,"codeLensFontFamily","",{description:c.localize(246,null)})),codeLensFontSize:We(new i(ze.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:c.localize(247,null)})),colorDecorators:We(new s(ze.colorDecorators,"colorDecorators",!0,{description:c.localize(248,null)})),colorDecoratorActivatedOn:We(new I(ze.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[c.localize(249,null),c.localize(250,null),c.localize(251,null)],description:c.localize(252,null)})),colorDecoratorsLimit:We(new i(ze.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:c.localize(253,null)})),columnSelection:We(new s(ze.columnSelection,"columnSelection",!1,{description:c.localize(254,null)})),comments:We(new k),contextmenu:We(new s(ze.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:We(new s(ze.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:c.localize(255,null)})),cursorBlinking:We(new S(ze.cursorBlinking,"cursorBlinking",m.Blink,"blink",["blink","smooth","phase","expand","solid"],w,{description:c.localize(256,null)})),cursorSmoothCaretAnimation:We(new I(ze.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[c.localize(257,null),c.localize(258,null),c.localize(259,null)],description:c.localize(260,null)})),cursorStyle:We(new S(ze.cursorStyle,"cursorStyle",F.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],G,{description:c.localize(261,null)})),cursorSurroundingLines:We(new i(ze.cursorSurroundingLines,"cursorSurroundingLines",0,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(262,null)})),cursorSurroundingLinesStyle:We(new I(ze.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[c.localize(263,null),c.localize(264,null)],markdownDescription:c.localize(265,null)})),cursorWidth:We(new i(ze.cursorWidth,"cursorWidth",0,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:c.localize(266,null)})),disableLayerHinting:We(new s(ze.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:We(new s(ze.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:We(new s(ze.domReadOnly,"domReadOnly",!1)),dragAndDrop:We(new s(ze.dragAndDrop,"dragAndDrop",!0,{description:c.localize(267,null)})),emptySelectionClipboard:We(new V),dropIntoEditor:We(new mt),stickyScroll:We(new W),experimentalWhitespaceRendering:We(new I(ze.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[c.localize(268,null),c.localize(269,null),c.localize(270,null)],description:c.localize(271,null)})),extraEditorClassName:We(new l(ze.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:We(new f(ze.fastScrollSensitivity,"fastScrollSensitivity",5,_=>_<=0?5:_,{markdownDescription:c.localize(272,null)})),find:We(new N),fixedOverflowWidgets:We(new s(ze.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:We(new s(ze.folding,"folding",!0,{description:c.localize(273,null)})),foldingStrategy:We(new I(ze.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[c.localize(274,null),c.localize(275,null)],description:c.localize(276,null)})),foldingHighlight:We(new s(ze.foldingHighlight,"foldingHighlight",!0,{description:c.localize(277,null)})),foldingImportsByDefault:We(new s(ze.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:c.localize(278,null)})),foldingMaximumRegions:We(new i(ze.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:c.localize(279,null)})),unfoldOnClickAfterEndOfLine:We(new s(ze.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:c.localize(280,null)})),fontFamily:We(new l(ze.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:c.localize(281,null)})),fontInfo:We(new re),fontLigatures2:We(new L),fontSize:We(new fe),fontWeight:We(new be),fontVariations:We(new Z),formatOnPaste:We(new s(ze.formatOnPaste,"formatOnPaste",!1,{description:c.localize(282,null)})),formatOnType:We(new s(ze.formatOnType,"formatOnType",!1,{description:c.localize(283,null)})),glyphMargin:We(new s(ze.glyphMargin,"glyphMargin",!0,{description:c.localize(284,null)})),gotoLocation:We(new oe),hideCursorInOverviewRuler:We(new s(ze.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:c.localize(285,null)})),hover:We(new pe),inDiffEditor:We(new s(ze.inDiffEditor,"inDiffEditor",!1)),letterSpacing:We(new f(ze.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,_=>f.clamp(_,-5,20),{description:c.localize(286,null)})),lightbulb:We(new X),lineDecorationsWidth:We(new Se),lineHeight:We(new he),lineNumbers:We(new Be),lineNumbersMinChars:We(new i(ze.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:We(new s(ze.linkedEditing,"linkedEditing",!1,{description:c.localize(287,null)})),links:We(new s(ze.links,"links",!0,{description:c.localize(288,null)})),matchBrackets:We(new I(ze.matchBrackets,"matchBrackets","always",["always","near","never"],{description:c.localize(289,null)})),minimap:We(new we),mouseStyle:We(new I(ze.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:We(new f(ze.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,_=>_===0?1:_,{markdownDescription:c.localize(290,null)})),mouseWheelZoom:We(new s(ze.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:P.$j?c.localize(291,null):c.localize(292,null)})),multiCursorMergeOverlapping:We(new s(ze.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:c.localize(293,null)})),multiCursorModifier:We(new S(ze.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ae,{markdownEnumDescriptions:[c.localize(294,null),c.localize(295,null)],markdownDescription:c.localize(296,null)})),multiCursorPaste:We(new I(ze.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[c.localize(297,null),c.localize(298,null)],markdownDescription:c.localize(299,null)})),multiCursorLimit:We(new i(ze.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:c.localize(300,null)})),occurrencesHighlight:We(new I(ze.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[c.localize(301,null),c.localize(302,null),c.localize(303,null)],markdownDescription:c.localize(304,null)})),overviewRulerBorder:We(new s(ze.overviewRulerBorder,"overviewRulerBorder",!0,{description:c.localize(305,null)})),overviewRulerLanes:We(new i(ze.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:We(new Y),pasteAs:We(new lt),parameterHints:We(new x),peekWidgetDefaultFocus:We(new I(ze.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[c.localize(306,null),c.localize(307,null)],description:c.localize(308,null)})),definitionLinkOpensInPeek:We(new s(ze.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:c.localize(309,null)})),quickSuggestions:We(new ge),quickSuggestionsDelay:We(new i(ze.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(310,null)})),readOnly:We(new s(ze.readOnly,"readOnly",!1)),readOnlyMessage:We(new Oe),renameOnType:We(new s(ze.renameOnType,"renameOnType",!1,{description:c.localize(311,null),markdownDeprecationMessage:c.localize(312,null)})),renderControlCharacters:We(new s(ze.renderControlCharacters,"renderControlCharacters",!0,{description:c.localize(313,null),restricted:!0})),renderFinalNewline:We(new I(ze.renderFinalNewline,"renderFinalNewline",P.$k?"dimmed":"on",["off","on","dimmed"],{description:c.localize(314,null)})),renderLineHighlight:We(new I(ze.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",c.localize(315,null)],description:c.localize(316,null)})),renderLineHighlightOnlyWhenFocus:We(new s(ze.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:c.localize(317,null)})),renderValidationDecorations:We(new I(ze.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:We(new I(ze.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",c.localize(318,null),c.localize(319,null),c.localize(320,null),""],description:c.localize(321,null)})),revealHorizontalRightPadding:We(new i(ze.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:We(new s(ze.roundedSelection,"roundedSelection",!0,{description:c.localize(322,null)})),rulers:We(new Re),scrollbar:We(new z),scrollBeyondLastColumn:We(new i(ze.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(323,null)})),scrollBeyondLastLine:We(new s(ze.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:c.localize(324,null)})),scrollPredominantAxis:We(new s(ze.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:c.localize(325,null)})),selectionClipboard:We(new s(ze.selectionClipboard,"selectionClipboard",!0,{description:c.localize(326,null),included:P.$k})),selectionHighlight:We(new s(ze.selectionHighlight,"selectionHighlight",!0,{description:c.localize(327,null)})),selectOnLineNumbers:We(new s(ze.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:We(new I(ze.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[c.localize(328,null),c.localize(329,null),c.localize(330,null)],description:c.localize(331,null)})),showUnused:We(new s(ze.showUnused,"showUnused",!0,{description:c.localize(332,null)})),showDeprecated:We(new s(ze.showDeprecated,"showDeprecated",!0,{description:c.localize(333,null)})),inlayHints:We(new ie),snippetSuggestions:We(new I(ze.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[c.localize(334,null),c.localize(335,null),c.localize(336,null),c.localize(337,null)],description:c.localize(338,null)})),smartSelect:We(new Ze),smoothScrolling:We(new s(ze.smoothScrolling,"smoothScrolling",!1,{description:c.localize(339,null)})),stopRenderingLineAfter:We(new i(ze.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,A.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:We(new Ge),inlineSuggest:We(new J),inlineEdit:We(new te),inlineCompletionsAccessibilityVerbose:We(new s(ze.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:c.localize(340,null)})),suggestFontSize:We(new i(ze.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:c.localize(341,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:We(new i(ze.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:c.localize(342,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:We(new s(ze.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:c.localize(343,null)})),suggestSelection:We(new I(ze.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[c.localize(344,null),c.localize(345,null),c.localize(346,null)],description:c.localize(347,null)})),tabCompletion:We(new I(ze.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[c.localize(348,null),c.localize(349,null),c.localize(350,null)],description:c.localize(351,null)})),tabIndex:We(new i(ze.tabIndex,"tabIndex",0,-1,A.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:We(new K),unusualLineTerminators:We(new I(ze.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[c.localize(352,null),c.localize(353,null),c.localize(354,null)],description:c.localize(355,null)})),useShadowDOM:We(new s(ze.useShadowDOM,"useShadowDOM",!0)),useTabStops:We(new s(ze.useTabStops,"useTabStops",!0,{description:c.localize(356,null)})),wordBreak:We(new I(ze.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[c.localize(357,null),c.localize(358,null)],description:c.localize(359,null)})),wordSegmenterLocales:We(new tt),wordSeparators:We(new l(ze.wordSeparators,"wordSeparators",$.$rt,{description:c.localize(360,null)})),wordWrap:We(new I(ze.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[c.localize(361,null),c.localize(362,null),c.localize(363,null),c.localize(364,null)],description:c.localize(365,null)})),wordWrapBreakAfterCharacters:We(new l(ze.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:We(new l(ze.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:We(new i(ze.wordWrapColumn,"wordWrapColumn",80,1,A.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:c.localize(366,null)})),wordWrapOverride1:We(new I(ze.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:We(new I(ze.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:We(new q),defaultColorDecorators:We(new s(ze.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:c.localize(367,null)})),pixelRatio:We(new me),tabFocusMode:We(new s(ze.tabFocusMode,"tabFocusMode",!1,{markdownDescription:c.localize(368,null)})),layoutInfo:We(new se),wrappingInfo:We(new nt),wrappingIndent:We(new it),wrappingStrategy:We(new Ce)}}),define(ke[105],Ie([1,0,3]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=void 0,e.$Hi=(0,E.$Ai)("environmentService"),e.$Ii=(0,E.$Bi)(e.$Hi)}),define(ke[30],Ie([1,0,58,20,13,15,2,172,3,21,16,47]),function(de,e,E,R,P,O,A,M,$,c,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cl=e.$zl=e.FileKind=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.FileOperationResult=e.$rl=e.$ql=e.$pl=e.$nl=e.FileChangeType=e.$ml=e.FileOperation=e.$gl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$7k=void 0,e.$8k=u,e.$9k=o,e.$0k=h,e.$$k=t,e.$_k=s,e.$al=n,e.$bl=i,e.$cl=g,e.$dl=f,e.$el=l,e.$fl=b,e.$hl=y,e.$il=p,e.$jl=k,e.$kl=m,e.$ll=w,e.$ol=V,e.$Al=be,e.$Bl=oe,e.$Dl=$e,e.$7k=(0,$.$Ai)("fileService");function u(se){return se.create===!0}var D;(function(se){se[se.Unknown=0]="Unknown",se[se.File=1]="File",se[se.Directory=2]="Directory",se[se.SymbolicLink=64]="SymbolicLink"})(D||(e.FileType=D={}));var d;(function(se){se[se.Readonly=1]="Readonly",se[se.Locked=2]="Locked"})(d||(e.FilePermission=d={}));var r;(function(se){se[se.UPDATED=2]="UPDATED",se[se.ADDED=4]="ADDED",se[se.DELETED=8]="DELETED"})(r||(e.FileChangeFilter=r={}));function o(se){const Ce=se;return!!Ce&&typeof Ce.onDidChange=="function"}var a;(function(se){se[se.None=0]="None",se[se.FileReadWrite=2]="FileReadWrite",se[se.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",se[se.FileReadStream=16]="FileReadStream",se[se.FileFolderCopy=8]="FileFolderCopy",se[se.PathCaseSensitive=1024]="PathCaseSensitive",se[se.Readonly=2048]="Readonly",se[se.Trash=4096]="Trash",se[se.FileWriteUnlock=8192]="FileWriteUnlock",se[se.FileAtomicRead=16384]="FileAtomicRead",se[se.FileAtomicWrite=32768]="FileAtomicWrite",se[se.FileAtomicDelete=65536]="FileAtomicDelete",se[se.FileClone=131072]="FileClone"})(a||(e.FileSystemProviderCapabilities=a={}));function h(se){return!!(se.capabilities&a.FileReadWrite)}function t(se){return!!(se.capabilities&a.FileFolderCopy)}function s(se){return!!(se.capabilities&a.FileClone)}function n(se){return!!(se.capabilities&a.FileOpenReadWriteClose)}function i(se){return!!(se.capabilities&a.FileReadStream)}function g(se){return h(se)?!!(se.capabilities&a.FileAtomicRead):!1}function f(se){return h(se)?!!(se.capabilities&a.FileAtomicWrite):!1}function l(se){return!!(se.capabilities&a.FileAtomicDelete)}function b(se){return!!(se.capabilities&a.Readonly)}var I;(function(se){se.FileExists="EntryExists",se.FileNotFound="EntryNotFound",se.FileNotADirectory="EntryNotADirectory",se.FileIsADirectory="EntryIsADirectory",se.FileExceedsStorageQuota="EntryExceedsStorageQuota",se.FileTooLarge="EntryTooLarge",se.FileWriteLocked="EntryWriteLocked",se.NoPermissions="NoPermissions",se.Unavailable="Unavailable",se.Unknown="Unknown"})(I||(e.FileSystemProviderErrorCode=I={}));class S extends Error{static create(Ce,Fe){const X=new S(Ce.toString(),Fe);return k(X,Fe),X}constructor(Ce,Fe){super(Ce),this.code=Fe}}e.$gl=S;function y(se,Ce){return S.create(se,Ce)}function p(se){return se||y((0,M.localize)(0,null),I.Unknown)}function k(se,Ce){return se.name=Ce?`${Ce} (FileSystemError)`:"FileSystemError",se}function m(se){if(!se)return I.Unknown;if(se instanceof S)return se.code;const Ce=/^(.+) \(FileSystemError\)$/.exec(se.name);if(!Ce)return I.Unknown;switch(Ce[1]){case I.FileExists:return I.FileExists;case I.FileIsADirectory:return I.FileIsADirectory;case I.FileNotADirectory:return I.FileNotADirectory;case I.FileNotFound:return I.FileNotFound;case I.FileTooLarge:return I.FileTooLarge;case I.FileWriteLocked:return I.FileWriteLocked;case I.NoPermissions:return I.NoPermissions;case I.Unavailable:return I.Unavailable}return I.Unknown}function w(se){if(se instanceof N)return se.fileOperationResult;switch(m(se)){case I.FileNotFound:return re.FILE_NOT_FOUND;case I.FileIsADirectory:return re.FILE_IS_DIRECTORY;case I.FileNotADirectory:return re.FILE_NOT_DIRECTORY;case I.FileWriteLocked:return re.FILE_WRITE_LOCKED;case I.NoPermissions:return re.FILE_PERMISSION_DENIED;case I.FileExists:return re.FILE_MOVE_CONFLICT;case I.FileTooLarge:return re.FILE_TOO_LARGE;default:return re.FILE_OTHER_ERROR}}var F;(function(se){se[se.CREATE=0]="CREATE",se[se.DELETE=1]="DELETE",se[se.MOVE=2]="MOVE",se[se.COPY=3]="COPY",se[se.WRITE=4]="WRITE"})(F||(e.FileOperation=F={}));class T{constructor(Ce,Fe,X){this.resource=Ce,this.operation=Fe,this.target=X}isOperation(Ce){return this.operation===Ce}}e.$ml=T;var G;(function(se){se[se.UPDATED=0]="UPDATED",se[se.ADDED=1]="ADDED",se[se.DELETED=2]="DELETED"})(G||(e.FileChangeType=G={}));class q{static{this.a=null}constructor(Ce,Fe){this.c=Fe,this.b=void 0,this.d=new v.$V(()=>{const X=E.$Gi.forUris(()=>this.c);return X.fill(this.rawAdded.map(W=>[W,!0])),X}),this.f=new v.$V(()=>{const X=E.$Gi.forUris(()=>this.c);return X.fill(this.rawUpdated.map(W=>[W,!0])),X}),this.g=new v.$V(()=>{const X=E.$Gi.forUris(()=>this.c);return X.fill(this.rawDeleted.map(W=>[W,!0])),X}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const X of Ce){switch(X.type){case G.ADDED:this.rawAdded.push(X.resource);break;case G.UPDATED:this.rawUpdated.push(X.resource);break;case G.DELETED:this.rawDeleted.push(X.resource);break}this.b!==q.a&&(typeof X.cId=="number"?this.b===void 0?this.b=X.cId:this.b!==X.cId&&(this.b=q.a):this.b!==void 0&&(this.b=q.a))}}contains(Ce,...Fe){return this.h(Ce,{includeChildren:!1},...Fe)}affects(Ce,...Fe){return this.h(Ce,{includeChildren:!0},...Fe)}h(Ce,Fe,...X){if(!Ce)return!1;const W=X.length>0;return!!((!W||X.includes(G.ADDED))&&(this.d.value.get(Ce)||Fe.includeChildren&&this.d.value.findSuperstr(Ce))||(!W||X.includes(G.UPDATED))&&(this.f.value.get(Ce)||Fe.includeChildren&&this.f.value.findSuperstr(Ce))||(!W||X.includes(G.DELETED))&&(this.g.value.findSubstr(Ce)||Fe.includeChildren&&this.g.value.findSuperstr(Ce)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Ce){return this.b===Ce}hasCorrelation(){return typeof this.b=="number"}}e.$nl=q;function V(se,Ce,Fe){return!se||!Ce||se===Ce||Ce.length>se.length?!1:(Ce.charAt(Ce.length-1)!==R.sep&&(Ce+=R.sep),Fe?(0,P.$Cf)(se,Ce):se.indexOf(Ce)===0)}class N extends Error{constructor(Ce,Fe,X){super(Ce),this.fileOperationResult=Fe,this.options=X}}e.$pl=N;class L extends N{constructor(Ce,Fe,X,W){super(Ce,Fe,W),this.fileOperationResult=Fe,this.size=X}}e.$ql=L;class Z extends N{constructor(Ce,Fe,X){super(Ce,re.FILE_NOT_MODIFIED_SINCE,X),this.stat=Fe}}e.$rl=Z;var re;(function(se){se[se.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",se[se.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",se[se.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",se[se.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",se[se.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",se[se.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",se[se.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",se[se.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",se[se.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",se[se.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",se[se.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(re||(e.FileOperationResult=re={})),e.$sl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$tl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$ul="files.associations",e.$vl="files.exclude",e.$wl="files.readonlyInclude",e.$xl="files.readonlyExclude",e.$yl="files.readonlyFromPermissions";var fe;(function(se){se[se.FILE=0]="FILE",se[se.FOLDER=1]="FOLDER",se[se.ROOT_FOLDER=2]="ROOT_FOLDER"})(fe||(e.FileKind=fe={})),e.$zl="";function be(se){if(!(typeof se.size!="number"||typeof se.mtime!="number"))return se.mtime.toString(29)+se.size.toString(31)}async function oe(se,Ce){if(!Ce.hasProvider(A.URI.from({scheme:se.scheme})))return new Promise(Fe=>{const X=Ce.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===se.scheme&&W.added&&(X.dispose(),Fe())})})}class pe{static{this.KB=1024}static{this.MB=pe.KB*pe.KB}static{this.GB=pe.MB*pe.KB}static{this.TB=pe.GB*pe.KB}static formatSize(Ce){return(0,O.$eg)(Ce)||(Ce=0),Ce<pe.KB?(0,M.localize)(1,null,Ce.toFixed(0)):Ce<pe.MB?(0,M.localize)(2,null,(Ce/pe.KB).toFixed(2)):Ce<pe.GB?(0,M.localize)(3,null,(Ce/pe.MB).toFixed(2)):Ce<pe.TB?(0,M.localize)(4,null,(Ce/pe.GB).toFixed(2)):(0,M.localize)(5,null,(Ce/pe.TB).toFixed(2))}}e.$Cl=pe;function $e(se){const Ce=typeof se=="string"||se?.scheme===C.Schemas.vscodeRemote;return typeof se!="string"&&se?.scheme===C.Schemas.file?1024*pe.MB:Ce?10*pe.MB:c.$o?50*pe.MB:1024*pe.MB}}),define(ke[75],Ie([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=void 0;class E{constructor(...P){this.a=new Map;for(const[O,A]of P)this.set(O,A)}set(P,O){const A=this.a.get(P);return this.a.set(P,O),A}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.$yi=E}),define(ke[210],Ie([1,0,11,14,6,74,207,3,75,211]),function(de,e,E,R,P,O,A,M,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=e.$kr=void 0;const C=!1;class v extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class u{constructor(o=new $.$yi,a=!1,h,t=C){this.i=o,this.j=a,this.k=h,this.l=t,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(M.$zi,this),this._globalGraph=t?h?._globalGraph??new A.$jr(s=>s):void 0}dispose(){if(!this.f){this.f=!0,(0,P.$Pc)(this.h),this.h.clear();for(const o of this.g)(0,P.$Oc)(o)&&o.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(o,a){this.m();const h=this,t=new class extends u{dispose(){h.h.delete(t),super.dispose()}}(o,this.j,this,this.l);return this.h.add(t),a?.add(t),t}invokeFunction(o,...a){this.m();const h=d.traceInvocation(this.l,o);let t=!1;try{return o({get:n=>{if(t)throw(0,R.$8)("service accessor is only valid during the invocation of its target method");const i=this.s(n,h);if(!i)throw new Error(`[invokeFunction] unknown service '${n}'`);return i}},...a)}finally{t=!0,h.stop()}}createInstance(o,...a){this.m();let h,t;return o instanceof O.$xi?(h=d.traceCreation(this.l,o.ctor),t=this.o(o.ctor,o.staticArguments.concat(a),h)):(h=d.traceCreation(this.l,o),t=this.o(o,a,h)),h.stop(),t}o(o,a=[],h){const t=M._util.getServiceDependencies(o).sort((i,g)=>i.index-g.index),s=[];for(const i of t){const g=this.s(i.id,h);g||this.y(`[createInstance] ${o.name} depends on UNKNOWN service ${i.id}.`,!1),s.push(g)}const n=t.length>0?t[0].index:a.length;if(a.length!==n){console.trace(`[createInstance] First service dependency of ${o.name} at position ${n+1} conflicts with ${a.length} static arguments`);const i=n-a.length;i>0?a=a.concat(new Array(i)):a=a.slice(0,n)}return Reflect.construct(o,a.concat(s))}q(o,a){if(this.i.get(o)instanceof O.$xi)this.i.set(o,a);else if(this.k)this.k.q(o,a);else throw new Error("illegalState - setting UNKNOWN service instance")}r(o){const a=this.i.get(o);return!a&&this.k?this.k.r(o):a}s(o,a){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const h=this.r(o);return h instanceof O.$xi?this.u(o,h,a.branch(o,!0)):(a.branch(o,!1),h)}u(o,a,h){if(this.t.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.t.add(o);try{return this.v(o,a,h)}finally{this.t.delete(o)}}v(o,a,h){const t=new A.$jr(i=>i.id.toString());let s=0;const n=[{id:o,desc:a,_trace:h}];for(;n.length;){const i=n.pop();if(t.lookupOrInsertNode(i),s++>1e3)throw new v(t);for(const g of M._util.getServiceDependencies(i.desc.ctor)){const f=this.r(g.id);if(f||this.y(`[createInstance] ${o} depends on ${g.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(g.id)),f instanceof O.$xi){const l={id:g.id,desc:f,_trace:i._trace.branch(g.id,!0)};t.insertEdge(i,l),n.push(l)}}}for(;;){const i=t.roots();if(i.length===0){if(!t.isEmpty())throw new v(t);break}for(const{data:g}of i){if(this.r(g.id)instanceof O.$xi){const l=this.w(g.id,g.desc.ctor,g.desc.staticArguments,g.desc.supportsDelayedInstantiation,g._trace);this.q(g.id,l)}t.removeNode(g)}}return this.r(o)}w(o,a,h=[],t,s){if(this.i.get(o)instanceof O.$xi)return this.x(o,a,h,t,s,this.g);if(this.k)return this.k.w(o,a,h,t,s);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}x(o,a,h=[],t,s,n){if(t){const i=new u(void 0,this.j,this,this.l);i.c=String(o);const g=new Map,f=new E.$Th(()=>{const l=i.o(a,h,s);for(const[b,I]of g){const S=l[b];if(typeof S=="function")for(const y of I)y.disposable=S.apply(l,y.listener)}return g.clear(),n.add(l),l});return new Proxy(Object.create(null),{get(l,b){if(!f.isInitialized&&typeof b=="string"&&(b.startsWith("onDid")||b.startsWith("onWill"))){let y=g.get(b);return y||(y=new c.$5c,g.set(b,y)),(k,m,w)=>{if(f.isInitialized)return f.value[b](k,m,w);{const F={listener:[k,m,w],disposable:void 0},T=y.push(F);return(0,P.$Sc)(()=>{T(),F.disposable?.dispose()})}}}if(b in l)return l[b];const I=f.value;let S=I[b];return typeof S!="function"||(S=S.bind(I),l[b]=S),S},set(l,b,I){return f.value[b]=I,!0},getPrototypeOf(l){return a.prototype}})}else{const i=this.o(a,h,s);return n.add(i),i}}y(o,a){if(a&&console.warn(o),this.j)throw new Error(o)}}e.$kr=u;var D;(function(r){r[r.None=0]="None",r[r.Creation=1]="Creation",r[r.Invocation=2]="Invocation",r[r.Branch=3]="Branch"})(D||(D={}));class d{static{this.all=new Set}static{this.c=new class extends d{constructor(){super(D.None,null)}stop(){}branch(){return this}}}static traceInvocation(o,a){return o?new d(D.Invocation,a.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d.c}static traceCreation(o,a){return o?new d(D.Creation,a.name):d.c}static{this.f=0}constructor(o,a){this.type=o,this.name=a,this.g=Date.now(),this.h=[]}branch(o,a){const h=new d(D.Branch,o.toString());return this.h.push([o,a,h]),h}stop(){const o=Date.now()-this.g;d.f+=o;let a=!1;function h(s,n){const i=[],g=new Array(s+1).join("	");for(const[f,l,b]of n.h)if(l&&b){a=!0,i.push(`${g}CREATES -> ${f}`);const I=h(s+1,b);I&&i.push(I)}else i.push(`${g}uses -> ${f}`);return i.join(`
`)}const t=[`${this.type===D.Creation?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${d.f.toFixed(2)}ms)`];(o>2||a)&&d.all.add(t.join(`
`))}}e.$lr=d}),define(ke[12],Ie([1,0,173,48,4,76,6,29,21,24,15,2,32,3]),function(de,e,E,R,P,O,A,M,$,c,C,v,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$0j=e.LogLevel=e.$8j=e.$7j=void 0,e.$9j=r,e.log=a,e.$ik=S,e.$jk=y,e.$kk=p,e.$lk=k,e.$7j=(0,D.$Ai)("logService"),e.$8j=(0,D.$Ai)("loggerService");function d(){return new Date().toISOString()}function r(m){return(0,C.$eg)(m)}var o;(function(m){m[m.Off=0]="Off",m[m.Trace=1]="Trace",m[m.Debug=2]="Debug",m[m.Info=3]="Info",m[m.Warning=4]="Warning",m[m.Error=5]="Error"})(o||(e.LogLevel=o={})),e.$0j=o.Info;function a(m,w,F){switch(w){case o.Trace:m.trace(F);break;case o.Debug:m.debug(F);break;case o.Info:m.info(F);break;case o.Warning:m.warn(F);break;case o.Error:m.error(F);break;case o.Off:break;default:throw new Error(`Invalid log level ${w}`)}}function h(m,w=!1){let F="";for(let T=0;T<m.length;T++){let G=m[T];if(G instanceof Error&&(G=(0,R.$lj)(G,w)),typeof G=="object")try{G=JSON.stringify(G)}catch{}F+=(T>0?" ":"")+G}return F}class t extends A.$Uc{constructor(){super(...arguments),this.b=e.$0j,this.c=this.B(new P.$he),this.onDidChangeLogLevel=this.c.event}setLevel(w){this.b!==w&&(this.b=w,this.c.fire(this.b))}getLevel(){return this.b}f(w){return this.b!==o.Off&&this.b<=w}}e.$_j=t;class s extends t{constructor(w){super(),this.h=w}f(w){return this.h||super.f(w)}trace(w,...F){this.f(o.Trace)&&this.g(o.Trace,h([w,...F],!0))}debug(w,...F){this.f(o.Debug)&&this.g(o.Debug,h([w,...F]))}info(w,...F){this.f(o.Info)&&this.g(o.Info,h([w,...F]))}warn(w,...F){this.f(o.Warning)&&this.g(o.Warning,h([w,...F]))}error(w,...F){if(this.f(o.Error))if(w instanceof Error){const T=Array.prototype.slice.call(arguments);T[0]=w.stack,this.g(o.Error,h(T))}else this.g(o.Error,h([w,...F]))}flush(){}}e.$ak=s;class n extends t{constructor(w=e.$0j){super(),this.setLevel(w),this.g=!$.$i}trace(w,...F){this.f(o.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,w,...F):console.log(`[main ${d()}]`,w,...F))}debug(w,...F){this.f(o.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,w,...F):console.log(`[main ${d()}]`,w,...F))}info(w,...F){this.f(o.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,w,...F):console.log(`[main ${d()}]`,w,...F))}warn(w,...F){this.f(o.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,w,...F):console.warn(`[main ${d()}]`,w,...F))}error(w,...F){this.f(o.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,w,...F):console.error(`[main ${d()}]`,w,...F))}flush(){}}e.$bk=n;class i extends t{constructor(w=e.$0j,F=!0){super(),this.g=F,this.setLevel(w)}trace(w,...F){this.f(o.Trace)&&(this.g?console.log("%cTRACE","color: #888",w,...F):console.log(w,...F))}debug(w,...F){this.f(o.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",w,...F):console.log(w,...F))}info(w,...F){this.f(o.Info)&&(this.g?console.log("%c INFO","color: #33f",w,...F):console.log(w,...F))}warn(w,...F){this.f(o.Warning)&&(this.g?console.log("%c WARN","color: #993",w,...F):console.log(w,...F))}error(w,...F){this.f(o.Error)&&(this.g?console.log("%c  ERR","color: #f33",w,...F):console.error(w,...F))}flush(){}}e.$ck=i;class g extends t{constructor(w,F=e.$0j){super(),this.g=w,this.setLevel(F)}trace(w,...F){this.f(o.Trace)&&this.g.log(o.Trace,[this.h(w),...F])}debug(w,...F){this.f(o.Debug)&&this.g.log(o.Debug,[this.h(w),...F])}info(w,...F){this.f(o.Info)&&this.g.log(o.Info,[this.h(w),...F])}warn(w,...F){this.f(o.Warning)&&this.g.log(o.Warning,[this.h(w),...F])}error(w,...F){this.f(o.Error)&&this.g.log(o.Error,[this.h(w),...F])}h(w){return typeof w=="string"?w:(0,R.$lj)(w,this.f(o.Trace))}flush(){}}e.$dk=g;class f extends t{constructor(w){super(),this.g=w,w.length&&this.setLevel(w[0].getLevel())}setLevel(w){for(const F of this.g)F.setLevel(w);super.setLevel(w)}trace(w,...F){for(const T of this.g)T.trace(w,...F)}debug(w,...F){for(const T of this.g)T.debug(w,...F)}info(w,...F){for(const T of this.g)T.info(w,...F)}warn(w,...F){for(const T of this.g)T.warn(w,...F)}error(w,...F){for(const T of this.g)T.error(w,...F)}flush(){for(const w of this.g)w.flush()}dispose(){for(const w of this.g)w.dispose();super.dispose()}}e.$ek=f;class l extends A.$Uc{constructor(w,F,T){if(super(),this.h=w,this.j=F,this.b=new M.$Ac,this.c=this.B(new P.$he),this.onDidChangeLoggers=this.c.event,this.f=this.B(new P.$he),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new P.$he),this.onDidChangeVisibility=this.g.event,T)for(const G of T)this.b.set(G.resource,{logger:void 0,info:G})}m(w){return(0,C.$ag)(w)?[...this.b.values()].find(F=>F.info.id===w):this.b.get(w)}getLogger(w){return this.m(w)?.logger}createLogger(w,F){const T=this.n(w),G=(0,C.$ag)(w)?w:F?.id??(0,O.$oj)(T.toString()).toString(16);let q=this.b.get(T)?.logger;const V=F?.logLevel==="always"?o.Trace:F?.logLevel;q||(q=this.s(T,V??this.getLogLevel(T)??this.h,{...F,id:G}));const N={logger:q,info:{resource:T,id:G,logLevel:V,name:F?.name,hidden:F?.hidden,extensionId:F?.extensionId,when:F?.when}};return this.registerLogger(N.info),this.b.set(T,N),q}n(w){return(0,C.$ag)(w)?(0,c.$bh)(this.j,`${w}.log`):w}setLogLevel(w,F){if(v.URI.isUri(w)){const T=w,G=F,q=this.b.get(T);q&&G!==q.info.logLevel&&(q.info.logLevel=G===this.h?void 0:G,q.logger?.setLevel(G),this.b.set(q.info.resource,q),this.f.fire([T,G]))}else{this.h=w;for(const[T,G]of this.b.entries())this.b.get(T)?.info.logLevel===void 0&&G.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(w,F){const T=this.m(w);T&&F!==!T.info.hidden&&(T.info.hidden=!F,this.b.set(T.info.resource,T),this.g.fire([T.info.resource,F]))}getLogLevel(w){let F;return w&&(F=this.b.get(w)?.info.logLevel),F??this.h}registerLogger(w){const F=this.b.get(w.resource);F?F.info.hidden!==w.hidden&&this.setVisibility(w.resource,!w.hidden):(this.b.set(w.resource,{info:w,logger:void 0}),this.c.fire({added:[w],removed:[]}))}deregisterLogger(w){const F=this.b.get(w);F&&(F.logger&&F.logger.dispose(),this.b.delete(w),this.c.fire({added:[],removed:[F.info]}))}*getRegisteredLoggers(){for(const w of this.b.values())yield w.info}getRegisteredLogger(w){return this.b.get(w)?.info}dispose(){this.b.forEach(w=>w.logger?.dispose()),this.b.clear(),super.dispose()}}e.$fk=l;class b{constructor(){this.onDidChangeLogLevel=new P.$he().event}setLevel(w){}getLevel(){return o.Info}trace(w,...F){}debug(w,...F){}info(w,...F){}warn(w,...F){}error(w,...F){}critical(w,...F){}dispose(){}flush(){}}e.$gk=b;class I extends b{}e.$hk=I;function S(m){if(m.verbose)return o.Trace;if(typeof m.logLevel=="string"){const w=k(m.logLevel.toLowerCase());if(w!==void 0)return w}return e.$0j}function y(m){switch(m){case o.Trace:return"trace";case o.Debug:return"debug";case o.Info:return"info";case o.Warning:return"warn";case o.Error:return"error";case o.Off:return"off"}}function p(m){switch(m){case o.Trace:return{original:"Trace",value:E.localize(0,null)};case o.Debug:return{original:"Debug",value:E.localize(1,null)};case o.Info:return{original:"Info",value:E.localize(2,null)};case o.Warning:return{original:"Warning",value:E.localize(3,null)};case o.Error:return{original:"Error",value:E.localize(4,null)};case o.Off:return{original:"Off",value:E.localize(5,null)}}}function k(m){switch(m){case"trace":return o.Trace;case"debug":return o.Debug;case"info":return o.Info;case"warn":return o.Warning;case"error":return o.Error;case"critical":return o.Error;case"off":return o.Off}}e.$mk=new u.$Rj("logLevel",y(o.Info))}),define(ke[212],Ie([1,0,6,12]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mQ=void 0;class P extends E.$Uc{constructor(A,M=[]){super(),this.a=new R.$ek([A,...M]),this.B(A.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...M){this.a.trace(A,...M)}debug(A,...M){this.a.debug(A,...M)}info(A,...M){this.a.info(A,...M)}warn(A,...M){this.a.warn(A,...M)}error(A,...M){this.a.error(A,...M)}flush(){this.a.flush()}}e.$mQ=P}),define(ke[106],Ie([1,0,35,174,3]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gv=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var O;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(O||(e.MarkerTag=O={}));var A;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function($){function c(d,r){return r-d}$.compare=c;const C=Object.create(null);C[$.Error]=(0,R.localize)(0,null),C[$.Warning]=(0,R.localize)(1,null),C[$.Info]=(0,R.localize)(2,null);function v(d){return C[d]||""}$.toString=v;function u(d){switch(d){case E.default.Error:return $.Error;case E.default.Warning:return $.Warning;case E.default.Info:return $.Info;case E.default.Ignore:return $.Hint}}$.fromSeverity=u;function D(d){switch(d){case $.Error:return E.default.Error;case $.Warning:return E.default.Warning;case $.Info:return E.default.Info;case $.Hint:return E.default.Ignore}}$.toSeverity=D}(A||(e.MarkerSeverity=A={}));var M;(function($){const c="";function C(u){return v(u,!0)}$.makeKey=C;function v(u,D){const d=[c];return u.source?d.push(u.source.replace("\xA6","\\\xA6")):d.push(c),u.code?typeof u.code=="string"?d.push(u.code.replace("\xA6","\\\xA6")):d.push(u.code.value.replace("\xA6","\\\xA6")):d.push(c),u.severity!==void 0&&u.severity!==null?d.push(A.toString(u.severity)):d.push(c),u.message&&D?d.push(u.message.replace("\xA6","\\\xA6")):d.push(c),u.startLineNumber!==void 0&&u.startLineNumber!==null?d.push(u.startLineNumber.toString()):d.push(c),u.startColumn!==void 0&&u.startColumn!==null?d.push(u.startColumn.toString()):d.push(c),u.endLineNumber!==void 0&&u.endLineNumber!==null?d.push(u.endLineNumber.toString()):d.push(c),u.endColumn!==void 0&&u.endColumn!==null?d.push(u.endColumn.toString()):d.push(c),d.push(c),d.join("\xA6")}$.makeKeyOptionalMessage=v})(M||(e.IMarkerData=M={})),e.$Gv=(0,P.$Ai)("markerService")}),define(ke[213],Ie([1,0,4,35,3]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jw=e.$iw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$gw=e.Severity=void 0,e.$hw=M,e.Severity=R.default,e.$gw=(0,P.$Ai)("notificationService");var O;(function(v){v[v.DEFAULT=0]="DEFAULT",v[v.SILENT=1]="SILENT",v[v.URGENT=2]="URGENT"})(O||(e.NotificationPriority=O={}));var A;(function(v){v[v.WORKSPACE=0]="WORKSPACE",v[v.PROFILE=1]="PROFILE",v[v.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));function M(v){if(v){const u=v;return typeof u.id=="string"&&typeof u.label=="string"}return!1}var $;(function(v){v[v.OFF=0]="OFF",v[v.ERROR=1]="ERROR"})($||(e.NotificationsFilter=$={}));class c{constructor(){this.progress=new C,this.onDidClose=E.Event.None,this.onDidChangeVisibility=E.Event.None}updateSeverity(u){}updateMessage(u){}updateActions(u){}close(){}}e.$iw=c;class C{infinite(){}done(){}total(u){}worked(u){}}e.$jw=C}),define(ke[107],Ie([1,0,3]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ok=e.$nk=void 0,e.$nk=(0,E.$Ai)("productService"),e.$ok="vscode://schemas/vscode-product"});var He=this&&this.__decorate||function(de,e,E,R){var P=arguments.length,O=P<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,E):R,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(de,e,E,R);else for(var M=de.length-1;M>=0;M--)(A=de[M])&&(O=(P<3?A(O):P>3?A(e,E,O):A(e,E))||O);return P>3&&O&&Object.defineProperty(e,E,O),O},Ve=this&&this.__param||function(de,e){return function(E,R){e(E,R,de)}};define(ke[77],Ie([1,0,11,22,6,3]),function(de,e,E,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qw=e.$pw=e.$ow=e.$nw=e.$mw=e.$lw=e.ProgressLocation=e.$kw=void 0,e.$kw=(0,O.$Ai)("progressService");var A;(function(v){v[v.Explorer=1]="Explorer",v[v.Scm=3]="Scm",v[v.Extensions=5]="Extensions",v[v.Window=10]="Window",v[v.Notification=15]="Notification",v[v.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$lw=Object.freeze({total(){},worked(){},done(){}});class M{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(u){this.b=u}report(u){this.a=u,this.b(this.a)}}e.$mw=M;class ${get value(){return this.a}constructor(u){this.e=u}report(u){this.b?this.b.push(u):this.b=[u],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const u=this.b.shift();this.a=u,await this.e(this.a)}}finally{this.c=!1;const u=this.d;this.d=void 0,u?.()}}drain(){return this.c?new Promise(u=>{const D=this.d;this.d=()=>{D?.(),u()}}):Promise.resolve()}}e.$nw=$;let c=class extends P.$Uc{constructor(u,D){super(),this.a=new E.$Xh,D.withProgress(u,d=>(this.b=d,this.c&&d.report(this.c),this.a.p)),this.B((0,P.$Sc)(()=>this.a.complete()))}report(u){this.b?this.b.report(u):this.c=u}};e.$ow=c,e.$ow=c=He([Ve(1,e.$kw)],c);class C extends P.$Uc{constructor(u){super(),this.g=u,this.a=0,this.b=this.B(new P.$Tc)}start(u){this.stop();const D=++this.a,d=new R.$se;return this.f=setTimeout(()=>{D===this.a&&(this.c=this.g.show(!0))},u),this.b.add((0,P.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,P.$Sc)(()=>d.cancel())),this.b.add((0,P.$Sc)(()=>this.c?this.c.done():void 0)),{id:D,token:d.token,stop:()=>this.h(D),isCurrent:()=>this.a===D}}stop(){this.h(this.a)}h(u){this.a===u&&this.b.clear()}}e.$pw=C,e.$qw=(0,O.$Ai)("editorProgressService")}),define(ke[31],Ie([1,0,61,15]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jo=void 0;class P{constructor(){this.a=new Map}add(A,M){E.ok(R.$ag(A)),E.ok(R.$cg(M)),E.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,M)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$jo=new P}),define(ke[78],Ie([1,0,4,31]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ko=void 0,e.$ko={JSONContribution:"base.contributions.json"};function P(M){return M.length>0&&M.charAt(M.length-1)==="#"?M.substring(0,M.length-1):M}class O{constructor(){this.b=new E.$he,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema($,c){this.a[P($)]=c,this.b.fire($)}notifySchemaChanged($){this.b.fire($)}getSchemaContributions(){return{schemas:this.a}}}const A=new O;R.$jo.add(e.$ko.JSONContribution,A)}),define(ke[54],Ie([1,0,18,4,15,167,42,78,31]),function(de,e,E,R,P,O,A,M,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.ConfigurationScope=e.$oo=e.EditPresentationTypes=void 0,e.$zo=r,e.$Ao=o,e.$Bo=a,e.$Co=t,e.$Do=s;var c;(function(n){n.Multiline="multilineText",n.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$oo={Configuration:"base.contributions.configuration"};var C;(function(n){n[n.APPLICATION=1]="APPLICATION",n[n.MACHINE=2]="MACHINE",n[n.WINDOW=3]="WINDOW",n[n.RESOURCE=4]="RESOURCE",n[n.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",n[n.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C||(e.ConfigurationScope=C={})),e.$po={properties:{},patternProperties:{}},e.$qo={properties:{},patternProperties:{}},e.$ro={properties:{},patternProperties:{}},e.$so={properties:{},patternProperties:{}},e.$to={properties:{},patternProperties:{}},e.$uo={properties:{},patternProperties:{}},e.$vo="vscode://schemas/settings/resourceLanguage",e.$wo="vscode://schemas/settings/configurationDefaults";const v=$.$jo.as(M.$ko.JSONContribution);class u{constructor(){this.h=new Set,this.i=new R.$he,this.onDidSchemaChange=this.i.event,this.j=new R.$he,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},v.registerSchema(e.$vo,this.g),this.v()}registerConfiguration(i,g=!0){this.registerConfigurations([i],g)}registerConfigurations(i,g=!0){const f=new Set;this.n(i,g,f),v.registerSchema(e.$vo,this.g),this.i.fire(),this.j.fire({properties:f})}deregisterConfigurations(i){const g=new Set;this.o(i,g),v.registerSchema(e.$vo,this.g),this.i.fire(),this.j.fire({properties:g})}updateConfigurations({add:i,remove:g}){const f=new Set;this.o(g,f),this.n(i,!1,f),v.registerSchema(e.$vo,this.g),this.i.fire(),this.j.fire({properties:f})}registerDefaultConfigurations(i){const g=new Set;this.k(i,g),this.i.fire(),this.j.fire({properties:g,defaultsOverrides:!0})}k(i,g){const f=[];for(const{overrides:l,source:b}of i)for(const I in l)if(g.add(I),e.$yo.test(I)){const S=this.a.get(I),y=S?.valuesSources??new Map;if(b)for(const w of Object.keys(l[I]))y.set(w,b);const p={...S?.value||{},...l[I]};this.a.set(I,{source:b,value:p,valuesSources:y});const k=(0,A.$ej)(I),m={type:"object",default:p,description:O.localize(1,null,k),$ref:e.$vo,defaultDefaultValue:p,source:P.$ag(b)?void 0:b,defaultValueSource:b};f.push(...r(I)),this.d[I]=m,this.b.properties[I]=m}else{this.a.set(I,{value:l[I],source:b});const S=this.d[I];S&&(this.w(I,S),this.r(I,S))}this.m(f)}deregisterDefaultConfigurations(i){const g=new Set;this.l(i,g),this.i.fire(),this.j.fire({properties:g,defaultsOverrides:!0})}l(i,g){for(const{overrides:f,source:l}of i)for(const b in f){const I=this.a.get(b),S=P.$ag(l)?l:l?.id,y=P.$ag(I?.source)?I?.source:I?.source?.id;if(S===y)if(g.add(b),this.a.delete(b),e.$yo.test(b))delete this.d[b],delete this.b.properties[b];else{const p=this.d[b];p&&(this.w(b,p),this.r(b,p))}}this.u()}deltaConfiguration(i){let g=!1;const f=new Set;i.removedDefaults&&(this.l(i.removedDefaults,f),g=!0),i.addedDefaults&&(this.k(i.addedDefaults,f),g=!0),i.removedConfigurations&&this.o(i.removedConfigurations,f),i.addedConfigurations&&this.n(i.addedConfigurations,!1,f),this.i.fire(),this.j.fire({properties:f,defaultsOverrides:g})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const g of i)this.h.add(g);this.u()}n(i,g,f){i.forEach(l=>{this.p(l,g,l.extensionInfo,l.restrictedProperties,void 0,f),this.c.push(l),this.q(l)})}o(i,g){const f=l=>{if(l.properties)for(const b in l.properties){g.add(b);const I=this.d[b];I?.policy?.name&&this.e.delete(I.policy.name),delete this.d[b],this.s(b,l.properties[b])}l.allOf?.forEach(b=>f(b))};for(const l of i){f(l);const b=this.c.indexOf(l);b!==-1&&this.c.splice(b,1)}}p(i,g=!0,f,l,b=C.WINDOW,I){b=P.$jg(i.scope)?b:i.scope;const S=i.properties;if(S)for(const p in S){const k=S[p];if(g&&t(p,k)){delete S[p];continue}if(k.source=f,k.defaultDefaultValue=S[p].default,this.w(p,k),e.$yo.test(p)?k.scope=void 0:(k.scope=P.$jg(k.scope)?b:k.scope,k.restricted=P.$jg(k.restricted)?!!l?.includes(p):k.restricted),S[p].hasOwnProperty("included")&&!S[p].included){this.f[p]=S[p],delete S[p];continue}else this.d[p]=S[p],S[p].policy?.name&&this.e.set(S[p].policy.name,p);!S[p].deprecationMessage&&S[p].markdownDeprecationMessage&&(S[p].deprecationMessage=S[p].markdownDeprecationMessage),I.add(p)}const y=i.allOf;if(y)for(const p of y)this.p(p,g,f,l,b,I)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const g=f=>{const l=f.properties;if(l)for(const I in l)this.r(I,l[I]);f.allOf?.forEach(g)};g(i)}r(i,g){switch(e.$po.properties[i]=g,g.scope){case C.APPLICATION:e.$qo.properties[i]=g;break;case C.MACHINE:e.$ro.properties[i]=g;break;case C.MACHINE_OVERRIDABLE:e.$so.properties[i]=g;break;case C.WINDOW:e.$to.properties[i]=g;break;case C.RESOURCE:e.$uo.properties[i]=g;break;case C.LANGUAGE_OVERRIDABLE:e.$uo.properties[i]=g,this.g.properties[i]=g;break}}s(i,g){switch(delete e.$po.properties[i],g.scope){case C.APPLICATION:delete e.$qo.properties[i];break;case C.MACHINE:delete e.$ro.properties[i];break;case C.MACHINE_OVERRIDABLE:delete e.$so.properties[i];break;case C.WINDOW:delete e.$to.properties[i];break;case C.RESOURCE:case C.LANGUAGE_OVERRIDABLE:delete e.$uo.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const g=`[${i}]`,f={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:e.$vo};this.w(g,f),e.$po.properties[g]=f,e.$qo.properties[g]=f,e.$ro.properties[g]=f,e.$so.properties[g]=f,e.$to.properties[g]=f,e.$uo.properties[g]=f}}v(){const i={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:e.$vo};e.$po.patternProperties[e.$xo]=i,e.$qo.patternProperties[e.$xo]=i,e.$ro.patternProperties[e.$xo]=i,e.$so.patternProperties[e.$xo]=i,e.$to.patternProperties[e.$xo]=i,e.$uo.patternProperties[e.$xo]=i,this.i.fire()}w(i,g){const f=this.a.get(i);let l=f?.value,b=f?.source;P.$hg(l)&&(l=g.defaultDefaultValue,b=void 0),P.$hg(l)&&(l=a(g.type)),g.default=l,g.defaultValueSource=b}}const D="\\[([^\\]]+)\\]",d=new RegExp(D,"g");e.$xo=`^(${D})+$`,e.$yo=new RegExp(e.$xo);function r(n){const i=[];if(e.$yo.test(n)){let g=d.exec(n);for(;g?.length;){const f=g[1].trim();f&&i.push(f),g=d.exec(n)}}return(0,E.$Mb)(i)}function o(n){return n.reduce((i,g)=>`${i}[${g}]`,"")}function a(n){switch(Array.isArray(n)?n[0]:n){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const h=new u;$.$jo.add(e.$oo.Configuration,h);function t(n,i){return n.trim()?e.$yo.test(n)?O.localize(7,null,n):h.getConfigurationProperties()[n]!==void 0?O.localize(8,null,n):i.policy?.name&&h.getPolicyConfigurations().get(i.policy?.name)!==void 0?O.localize(9,null,n,i.policy?.name,h.getPolicyConfigurations().get(i.policy?.name)):null:O.localize(6,null)}function s(){const n=[],i=h.getConfigurationProperties();for(const g of Object.keys(i))n.push([g,i[g].scope]);return n.push(["launch",C.RESOURCE]),n.push(["task",C.RESOURCE]),n}}),define(ke[214],Ie([1,0,18,4,134,6,29,26,15,2,42,54,30,31]),function(de,e,E,R,P,O,A,M,$,c,C,v,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jo=e.$Ho=e.$Go=e.$Fo=e.$Eo=void 0,e.$Io=s;function d(f){return Object.isFrozen(f)?f:M.$0n(f)}class r{static createEmptyModel(l){return new r({},[],[],void 0,l)}constructor(l,b,I,S,y){this.b=l,this.c=b,this.d=I,this.raw=S,this.f=y,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const l=this.raw.map(b=>{if(b instanceof r)return b;const I=new o("",this.f);return I.parseRaw(b),I.configurationModel});this.g=l.reduce((b,I)=>I===b?I:b.merge(I),l[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(l){return l?(0,C.$cj)(this.contents,l):this.contents}inspect(l,b){const I=this;return{get value(){return d(I.rawConfiguration.getValue(l))},get override(){return b?d(I.rawConfiguration.getOverrideValue(l,b)):void 0},get merged(){return d(b?I.rawConfiguration.override(b).getValue(l):I.rawConfiguration.getValue(l))},get overrides(){const S=[];for(const{contents:y,identifiers:p,keys:k}of I.rawConfiguration.overrides){const m=new r(y,k,[],void 0,I.f).getValue(l);m!==void 0&&S.push({identifiers:p,value:m})}return S.length?d(S):void 0}}}getOverrideValue(l,b){const I=this.j(b);return I?l?(0,C.$cj)(I,l):I:void 0}getKeysForOverrideIdentifier(l){const b=[];for(const I of this.overrides)I.identifiers.includes(l)&&b.push(...I.keys);return E.$Mb(b)}getAllOverrideIdentifiers(){const l=[];for(const b of this.overrides)l.push(...b.identifiers);return E.$Mb(l)}override(l){let b=this.a.get(l);return b||(b=this.h(l),this.a.set(l,b)),b}merge(...l){const b=M.$9n(this.contents),I=M.$9n(this.overrides),S=[...this.keys],y=this.raw?.length?[...this.raw]:[this];for(const p of l)if(y.push(...p.raw?.length?p.raw:[p]),!p.isEmpty()){this.i(b,p.contents);for(const k of p.overrides){const[m]=I.filter(w=>E.$ub(w.identifiers,k.identifiers));m?(this.i(m.contents,k.contents),m.keys.push(...k.keys),m.keys=E.$Mb(m.keys)):I.push(M.$9n(k))}for(const k of p.keys)S.indexOf(k)===-1&&S.push(k)}return new r(b,S,I,y.every(p=>p instanceof r)?void 0:y,this.f)}h(l){const b=this.j(l);if(!b||typeof b!="object"||!Object.keys(b).length)return this;const I={};for(const S of E.$Mb([...Object.keys(this.contents),...Object.keys(b)])){let y=this.contents[S];const p=b[S];p&&(typeof y=="object"&&typeof p=="object"?(y=M.$9n(y),this.i(y,p)):y=p),I[S]=y}return new r(I,this.keys,this.overrides,void 0,this.f)}i(l,b){for(const I of Object.keys(b)){if(I in l&&$.$cg(l[I])&&$.$cg(b[I])){this.i(l[I],b[I]);continue}l[I]=M.$9n(b[I])}}j(l){let b=null,I=null;const S=y=>{y&&(I?this.i(I,y):I=M.$9n(y))};for(const y of this.overrides)y.identifiers.length===1&&y.identifiers[0]===l?b=y.contents:y.identifiers.includes(l)&&S(y.contents);return S(b),I}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(l,b){this.k(l,b,!0)}setValue(l,b){this.k(l,b,!1)}removeValue(l){const b=this.keys.indexOf(l);b!==-1&&(this.keys.splice(b,1),(0,C.$bj)(this.contents,l),v.$yo.test(l)&&this.overrides.splice(this.overrides.findIndex(I=>E.$ub(I.identifiers,(0,v.$zo)(l))),1))}k(l,b,I){(0,C.$aj)(this.contents,l,b,S=>this.f.error(S)),I=I||this.keys.indexOf(l)===-1,I&&this.keys.push(l),v.$yo.test(l)&&this.overrides.push({identifiers:(0,v.$zo)(l),keys:Object.keys(this.contents[l]),contents:(0,C.$_i)(this.contents[l],S=>this.f.error(S))})}}e.$Eo=r;class o{constructor(l,b){this.f=l,this.g=b,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||r.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(l,b){if(!$.$jg(l)){const I=this.h(l);this.parseRaw(I,b)}}reparse(l){this.a&&this.parseRaw(this.a,l)}parseRaw(l,b){this.a=l;const{contents:I,keys:S,overrides:y,restricted:p,hasExcludedProperties:k}=this.i(l,b);this.b=new r(I,S,y,k?[l]:void 0,this.g),this.c=p||[]}h(l){let b={},I=null,S=[];const y=[],p=[];function k(w){Array.isArray(S)?S.push(w):I!==null&&(S[I]=w)}const m={onObjectBegin:()=>{const w={};k(w),y.push(S),S=w,I=null},onObjectProperty:w=>{I=w},onObjectEnd:()=>{S=y.pop()},onArrayBegin:()=>{const w=[];k(w),y.push(S),S=w,I=null},onArrayEnd:()=>{S=y.pop()},onLiteralValue:k,onError:(w,F,T)=>{p.push({error:w,offset:F,length:T})}};if(l)try{P.$Wn(l,m),b=S[0]||{}}catch(w){this.g.error(`Error while parsing settings file ${this.f}: ${w}`),this.d=[w]}return b}i(l,b){const I=D.$jo.as(v.$oo.Configuration).getConfigurationProperties(),S=this.j(l,I,!0,b);l=S.raw;const y=(0,C.$_i)(l,m=>this.g.error(`Conflict in settings file ${this.f}: ${m}`)),p=Object.keys(l),k=this.l(l,m=>this.g.error(`Conflict in settings file ${this.f}: ${m}`));return{contents:y,keys:p,overrides:k,restricted:S.restricted,hasExcludedProperties:S.hasExcludedProperties}}j(l,b,I,S){let y=!1;if(!S?.scopes&&!S?.skipRestricted&&!S?.exclude?.length)return{raw:l,restricted:[],hasExcludedProperties:y};const p={},k=[];for(const m in l)if(v.$yo.test(m)&&I){const w=this.j(l[m],b,!1,S);p[m]=w.raw,y=y||w.hasExcludedProperties,k.push(...w.restricted)}else{const w=b[m],F=w?typeof w.scope<"u"?w.scope:v.ConfigurationScope.WINDOW:void 0;w?.restricted&&k.push(m),!S.exclude?.includes(m)&&(S.include?.includes(m)||(F===void 0||S.scopes===void 0||S.scopes.includes(F))&&!(S.skipRestricted&&w?.restricted))?p[m]=l[m]:y=!0}return{raw:p,restricted:k,hasExcludedProperties:y}}l(l,b){const I=[];for(const S of Object.keys(l))if(v.$yo.test(S)){const y={};for(const p in l[S])y[p]=l[S][p];I.push({identifiers:(0,v.$zo)(S),keys:Object.keys(y),contents:(0,C.$_i)(y,b)})}return I}}e.$Fo=o;class a extends O.$Uc{constructor(l,b,I,S,y){super(),this.c=l,this.f=b,this.g=S,this.h=y,this.b=this.B(new R.$he),this.onDidChange=this.b.event,this.a=new o(this.c.toString(),y),this.B(this.g.watch(I.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(R.Event.any(R.Event.filter(this.g.onDidFilesChange,p=>p.contains(this.c)),R.Event.filter(this.g.onDidRunOperation,p=>(p.isOperation(u.FileOperation.CREATE)||p.isOperation(u.FileOperation.COPY)||p.isOperation(u.FileOperation.DELETE)||p.isOperation(u.FileOperation.WRITE))&&I.isEqual(p.resource,l)))(()=>this.b.fire()))}async loadConfiguration(){try{const l=await this.g.readFile(this.c);return this.a.parse(l.value.toString()||"{}",this.f),this.a.configurationModel}catch{return r.createEmptyModel(this.h)}}reparse(l){return l&&(this.f=l),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Go=a;class h{constructor(l,b,I,S,y,p,k,m,w,F,T,G,q){this.a=l,this.b=b,this.c=I,this.overrideIdentifiers=S,this.d=y,this.f=p,this.g=k,this.h=m,this.i=w,this.j=F,this.k=T,this.l=G,this.m=q}get value(){return d(this.c)}n(l){return l?.value!==void 0||l?.override!==void 0||l?.overrides!==void 0?l:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class t{constructor(l,b,I,S,y,p,k,m,w,F){this.j=l,this.l=b,this.m=I,this.n=S,this.p=y,this.q=p,this.r=k,this.s=m,this.t=w,this.u=F,this.h=null,this.i=new A.$Ac,this.v=null}getValue(l,b,I){return this.w(l,b,I).getValue(l)}updateValue(l,b,I={}){let S;I.resource?(S=this.t.get(I.resource),S||(S=r.createEmptyModel(this.u),this.t.set(I.resource,S))):S=this.s,b===void 0?S.removeValue(l):S.setValue(l,b),I.resource||(this.h=null)}inspect(l,b,I){const S=this.w(l,b,I),y=this.A(b.resource,I),p=b.resource?this.t.get(b.resource)||this.s:this.s,k=new Set;for(const m of S.overrides)for(const w of m.identifiers)S.getOverrideValue(l,w)!==void 0&&k.add(w);return new h(l,b,S.getValue(l),k.size?[...k]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,I?this.q:void 0,y||void 0,p)}keys(l){const b=this.A(void 0,l);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:b?b.keys.slice(0):[]}}updateDefaultConfiguration(l){this.j=l,this.h=null,this.i.clear()}updatePolicyConfiguration(l){this.l=l}updateApplicationConfiguration(l){this.m=l,this.h=null,this.i.clear()}updateLocalUserConfiguration(l){this.n=l,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(l){this.p=l,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(l){this.q=l,this.h=null,this.i.clear()}updateFolderConfiguration(l,b){this.r.set(l,b),this.i.delete(l)}deleteFolderConfiguration(l){this.folderConfigurations.delete(l),this.i.delete(l)}compareAndUpdateDefaultConfiguration(l,b){const I=[];if(!b){const{added:S,updated:y,removed:p}=i(this.j,l);b=[...S,...y,...p]}for(const S of b)for(const y of(0,v.$zo)(S)){const p=this.j.getKeysForOverrideIdentifier(y),k=l.getKeysForOverrideIdentifier(y),m=[...k.filter(w=>p.indexOf(w)===-1),...p.filter(w=>k.indexOf(w)===-1),...p.filter(w=>!M.$ao(this.j.override(y).getValue(w),l.override(y).getValue(w)))];I.push([y,m])}return this.updateDefaultConfiguration(l),{keys:b,overrides:I}}compareAndUpdatePolicyConfiguration(l){const{added:b,updated:I,removed:S}=i(this.l,l),y=[...b,...I,...S];return y.length&&this.updatePolicyConfiguration(l),{keys:y,overrides:[]}}compareAndUpdateApplicationConfiguration(l){const{added:b,updated:I,removed:S,overrides:y}=i(this.applicationConfiguration,l),p=[...b,...I,...S];return p.length&&this.updateApplicationConfiguration(l),{keys:p,overrides:y}}compareAndUpdateLocalUserConfiguration(l){const{added:b,updated:I,removed:S,overrides:y}=i(this.localUserConfiguration,l),p=[...b,...I,...S];return p.length&&this.updateLocalUserConfiguration(l),{keys:p,overrides:y}}compareAndUpdateRemoteUserConfiguration(l){const{added:b,updated:I,removed:S,overrides:y}=i(this.remoteUserConfiguration,l),p=[...b,...I,...S];return p.length&&this.updateRemoteUserConfiguration(l),{keys:p,overrides:y}}compareAndUpdateWorkspaceConfiguration(l){const{added:b,updated:I,removed:S,overrides:y}=i(this.workspaceConfiguration,l),p=[...b,...I,...S];return p.length&&this.updateWorkspaceConfiguration(l),{keys:p,overrides:y}}compareAndUpdateFolderConfiguration(l,b){const I=this.folderConfigurations.get(l),{added:S,updated:y,removed:p,overrides:k}=i(I,b),m=[...S,...y,...p];return(m.length||!I)&&this.updateFolderConfiguration(l,b),{keys:m,overrides:k}}compareAndDeleteFolderConfiguration(l){const b=this.folderConfigurations.get(l);if(!b)throw new Error("Unknown folder");this.deleteFolderConfiguration(l);const{added:I,updated:S,removed:y,overrides:p}=i(b,void 0);return{keys:[...I,...S,...y],overrides:p}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(l,b,I){let S=this.x(b,I);return b.overrideIdentifier&&(S=S.override(b.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(l)!==void 0&&(S=S.merge(this.l)),S}x({resource:l},b){let I=this.y();if(b&&l){const S=b.getFolder(l);S&&(I=this.z(S.uri)||I);const y=this.t.get(l);y&&(I=I.merge(y))}return I}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(l){let b=this.i.get(l);if(!b){const I=this.y(),S=this.r.get(l);S?(b=I.merge(S),this.i.set(l,b)):b=I}return b}A(l,b){if(b&&l){const I=b.getFolder(l);if(I)return this.r.get(I.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((l,b)=>{const{contents:I,overrides:S,keys:y}=this.r.get(b);return l.push([b,{contents:I,overrides:S,keys:y}]),l},[])}}allKeys(){const l=new Set;return this.j.keys.forEach(b=>l.add(b)),this.userConfiguration.keys.forEach(b=>l.add(b)),this.q.keys.forEach(b=>l.add(b)),this.r.forEach(b=>b.keys.forEach(I=>l.add(I))),[...l.values()]}B(){const l=new Set;return this.j.getAllOverrideIdentifiers().forEach(b=>l.add(b)),this.userConfiguration.getAllOverrideIdentifiers().forEach(b=>l.add(b)),this.q.getAllOverrideIdentifiers().forEach(b=>l.add(b)),this.r.forEach(b=>b.getAllOverrideIdentifiers().forEach(I=>l.add(I))),[...l.values()]}D(l){const b=new Set;return this.j.getKeysForOverrideIdentifier(l).forEach(I=>b.add(I)),this.userConfiguration.getKeysForOverrideIdentifier(l).forEach(I=>b.add(I)),this.q.getKeysForOverrideIdentifier(l).forEach(I=>b.add(I)),this.r.forEach(I=>I.getKeysForOverrideIdentifier(l).forEach(S=>b.add(S))),[...b.values()]}static parse(l,b){const I=this.E(l.defaults,b),S=this.E(l.policy,b),y=this.E(l.application,b),p=this.E(l.user,b),k=this.E(l.workspace,b),m=l.folders.reduce((w,F)=>(w.set(c.URI.revive(F[0]),this.E(F[1],b)),w),new A.$Ac);return new t(I,S,y,p,r.createEmptyModel(b),k,m,r.createEmptyModel(b),new A.$Ac,b)}static E(l,b){return new r(l.contents,l.keys,l.overrides,void 0,b)}}e.$Ho=t;function s(...f){if(f.length===0)return{keys:[],overrides:[]};if(f.length===1)return f[0];const l=new Set,b=new Map;for(const S of f)S.keys.forEach(y=>l.add(y)),S.overrides.forEach(([y,p])=>{const k=(0,A.$xc)(b,y,new Set);p.forEach(m=>k.add(m))});const I=[];return b.forEach((S,y)=>I.push([y,[...S.values()]])),{keys:[...l.values()],overrides:I}}class n{constructor(l,b,I,S,y){this.change=l,this.f=b,this.g=I,this.h=S,this.i=y,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const p of l.keys)this.affectedKeys.add(p);for(const[,p]of l.overrides)for(const k of p)this.affectedKeys.add(k);this.d=this.a;for(const p of this.affectedKeys)this.d+=p+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=t.parse(this.f.data,this.i)),this.j}affectsConfiguration(l,b){const I=this.a+l,S=this.d.indexOf(I);if(S<0)return!1;const y=S+I.length;if(y>=this.d.length)return!1;const p=this.d.charCodeAt(y);if(p!==this.b&&p!==this.c)return!1;if(b){const k=this.previousConfiguration?this.previousConfiguration.getValue(l,b,this.f?.workspace):void 0,m=this.g.getValue(l,b,this.h);return!M.$ao(k,m)}return!0}}e.$Jo=n;function i(f,l){const{added:b,removed:I,updated:S}=g(l?.rawConfiguration,f?.rawConfiguration),y=[],p=f?.getAllOverrideIdentifiers()||[],k=l?.getAllOverrideIdentifiers()||[];if(l){const m=k.filter(w=>!p.includes(w));for(const w of m)y.push([w,l.getKeysForOverrideIdentifier(w)])}if(f){const m=p.filter(w=>!k.includes(w));for(const w of m)y.push([w,f.getKeysForOverrideIdentifier(w)])}if(l&&f){for(const m of p)if(k.includes(m)){const w=g({contents:f.getOverrideValue(void 0,m)||{},keys:f.getKeysForOverrideIdentifier(m)},{contents:l.getOverrideValue(void 0,m)||{},keys:l.getKeysForOverrideIdentifier(m)});y.push([m,[...w.added,...w.removed,...w.updated]])}}return{added:b,removed:I,updated:S,overrides:y}}function g(f,l){const b=f?l?f.keys.filter(y=>l.keys.indexOf(y)===-1):[...f.keys]:[],I=l?f?l.keys.filter(y=>f.keys.indexOf(y)===-1):[...l.keys]:[],S=[];if(f&&l){for(const y of l.keys)if(f.keys.indexOf(y)!==-1){const p=(0,C.$cj)(l.contents,y),k=(0,C.$cj)(f.contents,y);M.$ao(p,k)||S.push(y)}}return{added:b,removed:I,updated:S}}}),define(ke[108],Ie([1,0,14,3]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.RemoteAuthorityResolverErrorCode=e.$Nl=e.$Ml=e.RemoteConnectionType=e.$Ll=void 0,e.$Pl=c,e.$Ll=(0,R.$Ai)("remoteAuthorityResolverService");var P;(function(C){C[C.WebSocket=0]="WebSocket",C[C.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class O{constructor(v){this.id=v,this.type=P.Managed}toString(){return`Managed(${this.id})`}}e.$Ml=O;class A{constructor(v,u){this.host=v,this.port=u,this.type=P.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Nl=A;var M;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound",C.InvalidAuthority="InvalidAuthority"})(M||(e.RemoteAuthorityResolverErrorCode=M={}));class $ extends E.$bb{static isNotAvailable(v){return v instanceof $&&v._code===M.NotAvailable}static isTemporarilyNotAvailable(v){return v instanceof $&&v._code===M.TemporarilyNotAvailable}static isNoResolverFound(v){return v instanceof $&&v._code===M.NoResolverFound}static isInvalidAuthority(v){return v instanceof $&&v._code===M.InvalidAuthority}static isHandled(v){return v instanceof $&&v.isHandled}constructor(v,u=M.Unknown,D){super(v),this._message=v,this._code=u,this._detail=D,this.isHandled=u===M.NotAvailable&&D===!0,Object.setPrototypeOf(this,$.prototype)}}e.$Ol=$;function c(C){const v=C.indexOf("+");return v===-1?C:C.substring(0,v)}}),define(ke[62],Ie([1,0,16]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=R,e.$Nm=P,e.$Om=O,e.$Pm=A;function R($){return $.scheme===E.Schemas.vscodeRemote?$.authority:void 0}function P($){if(!$)return;const c=$.indexOf("+");return c<0?$:$.substr(0,c)}function O($){const{host:c,port:C}=M($);if(typeof C>"u")throw new Error(`Invalid remote authority: ${$}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:c,port:C}}function A($,c){let{host:C,port:v}=M($);return typeof v>"u"&&(v=c),{host:C,port:v}}function M($){const c=$.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(c)return{host:c[1],port:parseInt(c[2],10)};const C=$.match(/^(\[[0-9a-z:]+\])$/);if(C)return{host:C[1],port:void 0};const v=$.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:$,port:void 0}}}),define(ke[19],Ie([1,0,13,3,62]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4m=e.$Ym=e.$Xm=e.$Wm=e.TargetPlatform=e.ExtensionType=e.$Vm=e.$Tm=e.$Sm=e.$Rm=e.$Qm=void 0,e.$Um=O,e.$Zm=v,e.$1m=u,e.$2m=D,e.$3m=d,e.$Qm="extensions.user.cache",e.$Rm="extensions.builtin.cache",e.$Sm="undefined_publisher",e.$Tm=["ui","workspace","web"];function O(r){if(typeof r=="object"&&r!==null&&r.supported!==!0)return r.description}e.$Vm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var A;(function(r){r[r.System=0]="System",r[r.User=1]="User"})(A||(e.ExtensionType=A={}));var M;(function(r){r.WIN32_X64="win32-x64",r.WIN32_ARM64="win32-arm64",r.LINUX_X64="linux-x64",r.LINUX_ARM64="linux-arm64",r.LINUX_ARMHF="linux-armhf",r.ALPINE_X64="alpine-x64",r.ALPINE_ARM64="alpine-arm64",r.DARWIN_X64="darwin-x64",r.DARWIN_ARM64="darwin-arm64",r.WEB="web",r.UNIVERSAL="universal",r.UNKNOWN="unknown",r.UNDEFINED="undefined"})(M||(e.TargetPlatform=M={}));class ${constructor(o){this.value=o,this._lower=o.toLowerCase()}static equals(o,a){if(typeof o>"u"||o===null)return typeof a>"u"||a===null;if(typeof a>"u"||a===null)return!1;if(typeof o=="string"||typeof a=="string"){const h=typeof o=="string"?o:o.value,t=typeof a=="string"?a:a.value;return E.$Bf(h,t)}return o._lower===a._lower}static toKey(o){return typeof o=="string"?o.toLowerCase():o._lower}}e.$Wm=$;class c{get size(){return this.c.size}constructor(o){if(this.c=new Set,o)for(const a of o)this.add(a)}add(o){this.c.add($.toKey(o))}delete(o){return this.c.delete($.toKey(o))}has(o){return this.c.has($.toKey(o))}}e.$Xm=c;class C{constructor(){this.c=new Map}clear(){this.c.clear()}delete(o){this.c.delete($.toKey(o))}get(o){return this.c.get($.toKey(o))}has(o){return this.c.has($.toKey(o))}set(o,a){this.c.set($.toKey(o),a)}values(){return this.c.values()}forEach(o){this.c.forEach(o)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Ym=C;function v(r){return u(r)}function u(r){return r.contributes&&r.contributes.localizations?r.contributes.localizations.length>0:!1}function D(r){return r.contributes&&r.contributes.authentication?r.contributes.authentication.length>0:!1}function d(r,o){if(o){const a=`onResolveRemoteAuthority:${(0,P.$Nm)(o)}`;return!!r.activationEvents?.includes(a)}return!1}e.$4m=(0,R.$Ai)("IBuiltinExtensionsScannerService")}),define(ke[109],Ie([1,0,21,170,19,3]),function(de,e,E,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.ExtensionManagementErrorCode=e.$cp=e.ExtensionGalleryErrorCode=e.$bp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=void 0,e.$8o=M,e.$9o=$,e.$0o=c,e.$$o=C,e.$_o=v,e.$ap=u,e.$1o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$2o=new RegExp(e.$1o),e.$3o="__web_extension",e.$4o="skipWalkthrough",e.$5o="extensionInstallSource",e.$6o="dependecyOrPackExtensionInstall",e.$7o="clientTargetPlatform";var A;(function(n){n.COMMAND="command",n.SETTINGS_SYNC="settingsSync"})(A||(e.ExtensionInstallSource=A={}));function M(n){switch(n){case P.TargetPlatform.WIN32_X64:return"Windows 64 bit";case P.TargetPlatform.WIN32_ARM64:return"Windows ARM";case P.TargetPlatform.LINUX_X64:return"Linux 64 bit";case P.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case P.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case P.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case P.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case P.TargetPlatform.DARWIN_X64:return"Mac";case P.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case P.TargetPlatform.WEB:return"Web";case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;case P.TargetPlatform.UNKNOWN:return P.TargetPlatform.UNKNOWN;case P.TargetPlatform.UNDEFINED:return P.TargetPlatform.UNDEFINED}}function $(n){switch(n){case P.TargetPlatform.WIN32_X64:return P.TargetPlatform.WIN32_X64;case P.TargetPlatform.WIN32_ARM64:return P.TargetPlatform.WIN32_ARM64;case P.TargetPlatform.LINUX_X64:return P.TargetPlatform.LINUX_X64;case P.TargetPlatform.LINUX_ARM64:return P.TargetPlatform.LINUX_ARM64;case P.TargetPlatform.LINUX_ARMHF:return P.TargetPlatform.LINUX_ARMHF;case P.TargetPlatform.ALPINE_X64:return P.TargetPlatform.ALPINE_X64;case P.TargetPlatform.ALPINE_ARM64:return P.TargetPlatform.ALPINE_ARM64;case P.TargetPlatform.DARWIN_X64:return P.TargetPlatform.DARWIN_X64;case P.TargetPlatform.DARWIN_ARM64:return P.TargetPlatform.DARWIN_ARM64;case P.TargetPlatform.WEB:return P.TargetPlatform.WEB;case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;default:return P.TargetPlatform.UNKNOWN}}function c(n,i){switch(n){case E.Platform.Windows:return i==="x64"?P.TargetPlatform.WIN32_X64:i==="arm64"?P.TargetPlatform.WIN32_ARM64:P.TargetPlatform.UNKNOWN;case E.Platform.Linux:return i==="x64"?P.TargetPlatform.LINUX_X64:i==="arm64"?P.TargetPlatform.LINUX_ARM64:i==="arm"?P.TargetPlatform.LINUX_ARMHF:P.TargetPlatform.UNKNOWN;case"alpine":return i==="x64"?P.TargetPlatform.ALPINE_X64:i==="arm64"?P.TargetPlatform.ALPINE_ARM64:P.TargetPlatform.UNKNOWN;case E.Platform.Mac:return i==="x64"?P.TargetPlatform.DARWIN_X64:i==="arm64"?P.TargetPlatform.DARWIN_ARM64:P.TargetPlatform.UNKNOWN;case E.Platform.Web:return P.TargetPlatform.WEB}}function C(n,i){return i===P.TargetPlatform.WEB&&!n.includes(P.TargetPlatform.WEB)}function v(n,i,g){return C(i,g)?!1:n===P.TargetPlatform.UNDEFINED||n===P.TargetPlatform.UNIVERSAL?!0:n===P.TargetPlatform.UNKNOWN?!1:n===g}function u(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}var D;(function(n){n[n.NoneOrRelevance=0]="NoneOrRelevance",n[n.LastUpdatedDate=1]="LastUpdatedDate",n[n.Title=2]="Title",n[n.PublisherName=3]="PublisherName",n[n.InstallCount=4]="InstallCount",n[n.PublishedDate=10]="PublishedDate",n[n.AverageRating=6]="AverageRating",n[n.WeightedRating=12]="WeightedRating"})(D||(e.SortBy=D={}));var d;(function(n){n[n.Default=0]="Default",n[n.Ascending=1]="Ascending",n[n.Descending=2]="Descending"})(d||(e.SortOrder=d={}));var r;(function(n){n.Install="install",n.Uninstall="uninstall"})(r||(e.StatisticType=r={}));var o;(function(n){n[n.None=1]="None",n[n.Install=2]="Install",n[n.Update=3]="Update",n[n.Migrate=4]="Migrate"})(o||(e.InstallOperation=o={})),e.$bp=(0,O.$Ai)("extensionGalleryService");var a;(function(n){n.Timeout="Timeout",n.Cancelled="Cancelled",n.Failed="Failed",n.DownloadFailedWriting="DownloadFailedWriting"})(a||(e.ExtensionGalleryErrorCode=a={}));class h extends Error{constructor(i,g){super(i),this.code=g,this.name=g}}e.$cp=h;var t;(function(n){n.Unsupported="Unsupported",n.Deprecated="Deprecated",n.Malicious="Malicious",n.Incompatible="Incompatible",n.IncompatibleTargetPlatform="IncompatibleTargetPlatform",n.ReleaseVersionNotFound="ReleaseVersionNotFound",n.Invalid="Invalid",n.Download="Download",n.DownloadSignature="DownloadSignature",n.DownloadFailedWriting="DownloadFailedWriting",n.UpdateMetadata="UpdateMetadata",n.Extract="Extract",n.Scanning="Scanning",n.ScanningExtension="ScanningExtension",n.ReadUninstalled="ReadUninstalled",n.UnsetUninstalled="UnsetUninstalled",n.Delete="Delete",n.Rename="Rename",n.IntializeDefaultProfile="IntializeDefaultProfile",n.AddToProfile="AddToProfile",n.InstalledExtensionNotFound="InstalledExtensionNotFound",n.PostInstall="PostInstall",n.CorruptZip="CorruptZip",n.IncompleteZip="IncompleteZip",n.Signature="Signature",n.NotAllowed="NotAllowed",n.Gallery="Gallery",n.Cancelled="Cancelled",n.Unknown="Unknown",n.Internal="Internal"})(t||(e.ExtensionManagementErrorCode=t={}));class s extends Error{constructor(i,g){super(i),this.code=g,this.name=g}}e.$dp=s,e.$ep=(0,O.$Ai)("extensionManagementService"),e.$fp="extensionsIdentifiers/disabled",e.$gp="extensionsIdentifiers/enabled",e.$hp=(0,O.$Ai)("IGlobalExtensionEnablementService"),e.$ip=(0,O.$Ai)("IExtensionTipsService"),e.$jp=(0,R.localize2)(0,"Extensions"),e.$kp=(0,R.localize2)(1,"Preferences")}),define(ke[110],Ie([1,0,14,19]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zG=e.$yG=void 0;class P{constructor(){this.a=new Map,this.b=new WeakMap}register(A,M){this.a.set(A,M)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const M=Object.create(null);for(const $ of A){const c=this.readActivationEvents($);c.length>0&&(M[R.$Wm.toKey($.identifier)]=c)}return M}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const M=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];for(let $=0;$<M.length;$++)M[$]==="onUri"&&(M[$]=`onUri:${R.$Wm.toKey(A.identifier)}`);if(!A.contributes)return M;for(const $ in A.contributes){const c=this.a.get($);if(!c)continue;const C=A.contributes[$],v=Array.isArray(C)?C:[C];try{c(v,M)}catch(u){(0,E.$1)(u)}}return M}}e.$yG=P,e.$zG=new P}),define(ke[215],Ie([1,0,23,14,6,175,54,3,12,31]),function(de,e,E,R,P,O,A,M,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=e.$Vp=void 0,e.$Xp=u,e.$Yp=D,e.$Zp=d,e.$1p=r,e.$2p=o,e.$3p=a,e.$Vp=(0,M.$Ai)("requestService");class C{constructor(n){this.b=n}toJSON(){if(!this.a){const n=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?n[i]="*****":n[i]=this.b[i];this.a=n}return this.a}}class v extends P.$Uc{constructor(n){super(),this.b=0,this.a=n.createLogger("network",{name:(0,O.localize)(0,null),when:$.$mk.isEqualTo((0,$.$jk)($.LogLevel.Trace)).serialize()})}async c(n,i,g){const f=`${n} #${++this.b}: ${i.url}`;this.a.trace(`${f} - begin`,i.type,new C(i.headers??{}));try{const l=await g();return this.a.trace(`${f} - end`,i.type,l.res.statusCode,l.res.headers),l}catch(l){throw this.a.error(`${f} - error`,i.type,(0,R.$0)(l)),l}}}e.$Wp=v;function u(s){return s.res.statusCode&&s.res.statusCode>=200&&s.res.statusCode<300||s.res.statusCode===1223}function D(s){return s.res.statusCode===204}async function d(s){return D(s)?null:(await(0,E.$Ve)(s.stream)).toString()}async function r(s){if(!u(s))throw new Error("Server returned "+s.res.statusCode);return d(s)}async function o(s){if(!u(s))throw new Error("Server returned "+s.res.statusCode);if(D(s))return null;const i=(await(0,E.$Ve)(s.stream)).toString();try{return JSON.parse(i)}catch(g){throw g.message+=`:
`+i,g}}function a(s){t(s)}let h;function t(s){const n=c.$jo.as(A.$oo.Configuration),i=h;h={id:"http",order:15,title:(0,O.localize)(1,null),type:"object",scope:s,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,O.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(6,null),(0,O.localize)(7,null),(0,O.localize)(8,null),(0,O.localize)(9,null)],default:"override",description:(0,O.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,O.localize)(12,null),restricted:!0}}},n.updateConfigurations({add:[h],remove:i?[i]:[]})}t(A.ConfigurationScope.APPLICATION)}),define(ke[216],Ie([1,0,21,79,36]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=A,e.$mp=M;function O($){if(E.$u===E.Platform.Linux&&/^penguin(\.|$)/i.test($))return"chromebook"}function A($,c,C,v,u,D,d,r,o,a){const h=Object.create(null);h["common.machineId"]=D,h["common.sqmId"]=d,h["common.devDeviceId"]=r,h.sessionID=(0,P.$Wg)()+Date.now(),h.commitHash=v,h.version=u,h["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,E.$h)(E.$u),h["common.nodePlatform"]=R.$dc,h["common.nodeArch"]=C,h["common.product"]=a||"desktop",o&&(h["common.msftInternal"]=o);let t=0;const s=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>t++,enumerable:!0}}),E.$l&&(h["common.snap"]="true");const n=O(c);return n&&(h["common.platformDetail"]=n),h}function M($){const c=R.env.USERDNSDOMAIN;if(!c)return!1;const C=c.toLowerCase();return $.some(v=>C===v)}}),define(ke[111],Ie([1,0,3]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=void 0,e.$6l=(0,E.$Ai)("telemetryService"),e.$7l=(0,E.$Ai)("customEndpointTelemetryService"),e.$8l="telemetry.currentSessionDate",e.$9l="telemetry.firstSessionDate",e.$0l="telemetry.lastSessionDate",e.$$l="telemetry.machineId",e.$_l="telemetry.sqmId",e.$am="telemetry.devDeviceId",e.$bm="telemetry",e.$cm="telemetry.telemetryLevel",e.$dm="telemetry.enableCrashReporter",e.$em="telemetry.enableTelemetry";var R;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(R||(e.TelemetryLevel=R={}));var P;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(ke[63],Ie([1,0,26,15,62,216,111]),function(de,e,E,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=e.$sp=e.$rp=e.$qp=e.$pp=e.$op=e.$np=void 0,e.$up=C,e.$vp=v,e.$wp=u,e.$xp=D,e.$yp=r,e.$zp=a,e.$Ap=h,e.$Bp=n;class M{constructor(g){this.value=g,this.isTrustedTelemetryValue=!0}}e.$np=M;class ${constructor(){this.telemetryLevel=A.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$op=$,e.$pp=new $;class c{async publicLog(g,f,l){}async publicLogError(g,f,l){}}e.$qp=c,e.$rp="telemetry",e.$sp="extensionTelemetryLog",e.$tp={log:()=>null,flush:()=>Promise.resolve(null)};function C(i,g){return!g.isBuilt&&!g.disableTelemetry?!0:!(g.disableTelemetry||!i.enableTelemetry)}function v(i,g){return g.extensionTestsLocationURI?!0:!(g.isBuilt||g.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}function u(i){const g=i.getValue(A.$cm),f=i.getValue(A.$dm);if(i.getValue(A.$em)===!1||f===!1)return A.TelemetryLevel.NONE;switch(g??A.TelemetryConfiguration.ON){case A.TelemetryConfiguration.ON:return A.TelemetryLevel.USAGE;case A.TelemetryConfiguration.ERROR:return A.TelemetryLevel.ERROR;case A.TelemetryConfiguration.CRASH:return A.TelemetryLevel.CRASH;case A.TelemetryConfiguration.OFF:return A.TelemetryLevel.NONE}}function D(i){const g={},f={},l={};o(i,l);for(let b in l){b=b.length>150?b.substr(b.length-149):b;const I=l[b];typeof I=="number"?f[b]=I:typeof I=="boolean"?f[b]=I?1:0:typeof I=="string"?(I.length>8192&&console.warn(`Telemetry property: ${b} has been trimmed to 8192, the original length is ${I.length}`),g[b]=I.substring(0,8191)):typeof I<"u"&&I!==null&&(g[b]=I)}return{properties:g,measurements:f}}const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(i){if(!i)return"none";const g=(0,P.$Nm)(i);return d.has(g)?g:"other"}function o(i,g,f=0,l){if(i)for(const b of Object.getOwnPropertyNames(i)){const I=i[b],S=l?l+b:b;Array.isArray(I)?g[S]=(0,E.$bo)(I):I instanceof Date?g[S]=I.toISOString():(0,R.$cg)(I)?f<2?o(I,g,f+1,S+"."):g[S]=(0,E.$bo)(I):g[S]=I}}function a(i,g){const f=i.msftInternalDomains||[],l=g.getValue("telemetry.internalTesting");return(0,O.$mp)(f)||l}function h(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}function t(i,g){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let f=i;const l=[];for(const y of g)for(;;){const p=y.exec(i);if(!p)break;l.push([p.index,y.lastIndex])}const b=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,I=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let S=0;for(f="";;){const y=I.exec(i);if(!y)break;const p=l.some(([k,m])=>y.index<m&&k<I.lastIndex);!b.test(y[0])&&!p&&(f+=i.substring(S,y.index)+"<REDACTED: user-file-path>",S=I.lastIndex)}return S<i.length&&(f+=i.substr(S)),f}function s(i){if(!i)return i;const g=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const f of g)if(f.regex.test(i))return`<REDACTED: ${f.label}>`;return i}function n(i,g){return(0,E.$$n)(i,f=>{if(f instanceof M||Object.hasOwnProperty.call(f,"isTrustedTelemetryValue"))return f.value;if(typeof f=="string"){let l=f.replaceAll("%20"," ");l=t(l,g);for(const b of g)l=l.replace(b,"");return l=s(l),l}})}}),define(ke[217],Ie([1,0,13,109,19,21,2,14,79,63]),function(de,e,E,R,P,O,A,M,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=e.$Dp=void 0,e.$Cp=C,e.$Ep=d,e.$Fp=r,e.$Gp=o,e.$Hp=a,e.$Ip=h,e.$Jp=t,e.$Kp=s,e.$Mp=n,e.$Np=g;function C(f,l){return f.uuid&&l.uuid?f.uuid===l.uuid:f.id===l.id?!0:(0,E.$wf)(f.id,l.id)===0}const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(l){const b=l.manifest?l.manifest.version:l.version,I=l.manifest?l.targetPlatform:l.properties.targetPlatform;return new u(l.identifier,b,I)}static parse(l){const b=v.exec(l);return b&&b[1]&&b[2]?new u({id:b[1]},b[2],b[4]||void 0):null}constructor(l,b,I=P.TargetPlatform.UNDEFINED){this.identifier=l,this.version=b,this.targetPlatform=I,this.id=l.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==P.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(l){return l instanceof u?C(this,l)&&this.version===l.version&&this.targetPlatform===l.targetPlatform:!1}}e.$Dp=u;const D=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(f){const l=D.exec(f);return l&&l[1]?[o(l[1]),l[2]]:[o(f),void 0]}function r(f,l){return`${f}.${l}`}function o(f){return f.toLowerCase()}function a(f,l){return o(r(f??P.$Sm,l))}function h(f,l){const b=[],I=S=>{for(const y of b)if(y.some(p=>C(l(p),l(S))))return y;return null};for(const S of f){const y=I(S);y?y.push(S):b.push([S])}return b}function t(f){return{id:f.identifier.id,name:f.manifest.name,galleryId:null,publisherId:f.publisherId,publisherName:f.manifest.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:f.manifest.extensionDependencies&&f.manifest.extensionDependencies.length>0}}function s(f){return{id:new c.$np(f.identifier.id),name:new c.$np(f.name),version:f.version,galleryId:f.identifier.uuid,publisherId:f.publisherId,publisherName:f.publisher,publisherDisplayName:f.publisherDisplayName,isPreReleaseVersion:f.properties.isPreReleaseVersion,dependencies:!!(f.properties.dependencies&&f.properties.dependencies.length>0),isSigned:f.isSigned,...f.telemetryData}}e.$Lp=new P.$Wm("pprice.better-merge");function n(f,l){const b=[],I=l.manifest.extensionDependencies?.slice(0)??[];for(;I.length;){const S=I.shift();if(S&&b.every(y=>!C(y.identifier,{id:S}))){const y=f.filter(p=>C(p.identifier,{id:S}));y.length===1&&(b.push(y[0]),I.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return b}async function i(f,l){if(!O.$k)return!1;let b;try{b=(await f.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{b=(await f.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(S){l.debug("Error while getting the os-release file.",(0,M.$0)(S))}}return!!b&&(b.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function g(f,l){const b=await i(f,l),I=(0,R.$0o)(b?"alpine":O.$u,$.$ec);return l.debug("ComputeTargetPlatform:",I),I}}),define(ke[218],Ie([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ts=E,e.$us=R,e.$vs=P,e.$ws=O,e.$xs=A,e.$ys=M;function E($){return[...$.entries()]}function R($){return $?[...$.entries()]:[]}function P($){return new Map($)}function O($){return new Map($??[])}function A($){return Array.from($.entries()).map(c=>[c[0],E(c[1].map),R(c[1].descriptionMap)])}function M($){return new Map($.map(c=>[c[0],{map:P(c[1]),descriptionMap:O(c[2])}]))}}),define(ke[219],Ie([1,0,3,32,31]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gs=e.$fs=e.$es=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$ds=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$cs=void 0,e.$cs=new R.$Rj("terminalTabFocusMode",!1,!0);var O;(function(n){n.AutomationProfile="terminal.integrated.automationProfile.",n.DefaultProfile="terminal.integrated.defaultProfile.",n.Profiles="terminal.integrated.profiles."})(O||(e.TerminalSettingPrefix=O={}));var A;(function(n){n.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",n.AutomationProfileLinux="terminal.integrated.automationProfile.linux",n.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",n.AutomationProfileWindows="terminal.integrated.automationProfile.windows",n.ProfilesWindows="terminal.integrated.profiles.windows",n.ProfilesMacOs="terminal.integrated.profiles.osx",n.ProfilesLinux="terminal.integrated.profiles.linux",n.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",n.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",n.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",n.UseWslProfiles="terminal.integrated.useWslProfiles",n.TabsDefaultColor="terminal.integrated.tabs.defaultColor",n.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",n.TabsEnabled="terminal.integrated.tabs.enabled",n.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",n.TabsHideCondition="terminal.integrated.tabs.hideCondition",n.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",n.TabsShowActions="terminal.integrated.tabs.showActions",n.TabsLocation="terminal.integrated.tabs.location",n.TabsFocusMode="terminal.integrated.tabs.focusMode",n.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",n.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",n.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",n.CopyOnSelection="terminal.integrated.copyOnSelection",n.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",n.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",n.FontFamily="terminal.integrated.fontFamily",n.FontSize="terminal.integrated.fontSize",n.LetterSpacing="terminal.integrated.letterSpacing",n.LineHeight="terminal.integrated.lineHeight",n.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",n.TabStopWidth="terminal.integrated.tabStopWidth",n.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",n.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",n.BellDuration="terminal.integrated.bellDuration",n.FontWeight="terminal.integrated.fontWeight",n.FontWeightBold="terminal.integrated.fontWeightBold",n.CursorBlinking="terminal.integrated.cursorBlinking",n.CursorStyle="terminal.integrated.cursorStyle",n.CursorStyleInactive="terminal.integrated.cursorStyleInactive",n.CursorWidth="terminal.integrated.cursorWidth",n.Scrollback="terminal.integrated.scrollback",n.DetectLocale="terminal.integrated.detectLocale",n.DefaultLocation="terminal.integrated.defaultLocation",n.GpuAcceleration="terminal.integrated.gpuAcceleration",n.TerminalTitleSeparator="terminal.integrated.tabs.separator",n.TerminalTitle="terminal.integrated.tabs.title",n.TerminalDescription="terminal.integrated.tabs.description",n.RightClickBehavior="terminal.integrated.rightClickBehavior",n.MiddleClickBehavior="terminal.integrated.middleClickBehavior",n.Cwd="terminal.integrated.cwd",n.ConfirmOnExit="terminal.integrated.confirmOnExit",n.ConfirmOnKill="terminal.integrated.confirmOnKill",n.EnableBell="terminal.integrated.enableBell",n.EnableVisualBell="terminal.integrated.enableVisualBell",n.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",n.AllowChords="terminal.integrated.allowChords",n.AllowMnemonics="terminal.integrated.allowMnemonics",n.TabFocusMode="terminal.integrated.tabFocusMode",n.EnvMacOs="terminal.integrated.env.osx",n.EnvLinux="terminal.integrated.env.linux",n.EnvWindows="terminal.integrated.env.windows",n.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",n.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",n.ShowExitAlert="terminal.integrated.showExitAlert",n.SplitCwd="terminal.integrated.splitCwd",n.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",n.WordSeparators="terminal.integrated.wordSeparators",n.EnableFileLinks="terminal.integrated.enableFileLinks",n.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",n.UnicodeVersion="terminal.integrated.unicodeVersion",n.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",n.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",n.HideOnStartup="terminal.integrated.hideOnStartup",n.CustomGlyphs="terminal.integrated.customGlyphs",n.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",n.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",n.InheritEnv="terminal.integrated.inheritEnv",n.ShowLinkHover="terminal.integrated.showLinkHover",n.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",n.AutoReplies="terminal.integrated.autoReplies",n.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",n.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",n.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",n.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",n.EnableImages="terminal.integrated.enableImages",n.SmoothScrolling="terminal.integrated.smoothScrolling",n.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",n.FocusAfterRun="terminal.integrated.focusAfterRun",n.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",n.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",n.DevMode="terminal.integrated.developer.devMode"})(A||(e.TerminalSettingId=A={}));var M;(function(n){n.PowerShell="pwsh",n.Bash="bash",n.Fish="fish",n.Sh="sh",n.Csh="csh",n.Ksh="ksh",n.Zsh="zsh",n.Python="python"})(M||(e.PosixShellType=M={}));var $;(function(n){n.CommandPrompt="cmd",n.PowerShell="pwsh",n.Wsl="wsl",n.GitBash="gitbash",n.Python="python"})($||(e.WindowsShellType=$={}));var c;(function(n){n[n.Api=0]="Api",n[n.Process=1]="Process",n[n.Sequence=2]="Sequence",n[n.Config=3]="Config"})(c||(e.TitleEventSource=c={}));var C;(function(n){n.LocalPty="localPty",n.PtyHost="ptyHost",n.PtyHostWindow="ptyHostWindow",n.Logger="logger",n.Heartbeat="heartbeat"})(C||(e.TerminalIpcChannels=C={}));var v;(function(n){n.Cwd="cwd",n.InitialCwd="initialCwd",n.FixedDimensions="fixedDimensions",n.Title="title",n.ShellType="shellType",n.HasChildProcesses="hasChildProcesses",n.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",n.OverrideDimensions="overrideDimensions",n.FailedShellIntegrationActivation="failedShellIntegrationActivation",n.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(v||(e.ProcessPropertyType=v={})),e.$ds=(0,E.$Ai)("ptyService");var u;(function(n){n[n.BeatInterval=5e3]="BeatInterval",n[n.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",n[n.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",n[n.SecondWaitMultiplier=1]="SecondWaitMultiplier",n[n.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(u||(e.HeartbeatConstants=u={}));var D;(function(n){n[n.Panel=1]="Panel",n[n.Editor=2]="Editor"})(D||(e.TerminalLocation=D={}));var d;(function(n){n.TerminalView="view",n.Editor="editor"})(d||(e.TerminalLocationString=d={}));var r;(function(n){n[n.GraceTime=6e4]="GraceTime",n[n.ShortGraceTime=6e3]="ShortGraceTime"})(r||(e.LocalReconnectConstants=r={}));var o;(function(n){n[n.HighWatermarkChars=1e5]="HighWatermarkChars",n[n.LowWatermarkChars=5e3]="LowWatermarkChars",n[n.CharCountAckSize=5e3]="CharCountAckSize"})(o||(e.FlowControlConstants=o={}));var a;(function(n){n.GitBash="Git Bash",n.Pwsh="PowerShell"})(a||(e.ProfileSource=a={}));var h;(function(n){n[n.Off=0]="Off",n[n.FinalTerm=1]="FinalTerm",n[n.VSCode=2]="VSCode"})(h||(e.ShellIntegrationStatus=h={}));var t;(function(n){n[n.Unknown=0]="Unknown",n[n.Shutdown=1]="Shutdown",n[n.Process=2]="Process",n[n.User=3]="User",n[n.Extension=4]="Extension"})(t||(e.TerminalExitReason=t={})),e.$es={Backend:"workbench.contributions.terminal.processBackend"};class s{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(i){const g=this.b(i.remoteAuthority);if(this.a.has(g))throw new Error(`A terminal backend with remote authority '${g}' was already registered.`);this.a.set(g,i)}getTerminalBackend(i){return this.a.get(this.b(i))}b(i){return i?.toLowerCase()??""}}P.$jo.add(e.$es.Backend,new s),e.$fs=(0,E.$Ai)("localPtyService"),e.$gs=(0,E.$Ai)("terminalLogService")}),define(ke[220],Ie([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5vb=void 0;class E{constructor(P){this.b=P,this.a=new Map}dispose(){for(const P of this.a.values())P.dispose()}startBuffering(P,O,A=5){const M=O($=>{const c=typeof $=="string"?$:$.data;let C=this.a.get(P);if(C){C.data.push(c);return}const v=setTimeout(()=>this.flushBuffer(P),A);C={data:[c],timeoutId:v,dispose:()=>{clearTimeout(v),this.flushBuffer(P),M.dispose()}},this.a.set(P,C)});return M}stopBuffering(P){this.a.get(P)?.dispose()}flushBuffer(P){const O=this.a.get(P);O&&(this.a.delete(P),this.b(P,O.data.join("")))}}e.$5vb=E}),define(ke[221],Ie([1,0,11,97,323,34,4,15,2,176,78,31]),function(de,e,E,R,P,O,A,M,$,c,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vx=e.$ux=e.$tx=e.$sx=e.$rx=e.$qx=e.IconFontDefinition=e.IconContribution=e.$nx=void 0,e.$ox=o,e.$px=a,e.$nx={IconContribution:"base.contributions.icons"};var u;(function(n){function i(g,f){let l=g.defaults;for(;O.ThemeIcon.isThemeIcon(l);){const b=r.getIcon(l.id);if(!b)return;l=b.defaults}return l}n.getDefinition=i})(u||(e.IconContribution=u={}));var D;(function(n){function i(f){return{weight:f.weight,style:f.style,src:f.src.map(l=>({format:l.format,location:l.location.toString()}))}}n.toJSONObject=i;function g(f){const l=b=>(0,M.$ag)(b)?b:void 0;if(f&&Array.isArray(f.src)&&f.src.every(b=>(0,M.$ag)(b.format)&&(0,M.$ag)(b.location)))return{weight:l(f.weight),style:l(f.style),src:f.src.map(b=>({format:b.format,location:$.URI.parse(b.location)}))}}n.fromJSONObject=g})(D||(e.IconFontDefinition=D={}));class d{constructor(){this.a=new A.$he,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,c.localize)(0,null)},fontCharacter:{type:"string",description:(0,c.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${O.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(i,g,f,l){const b=this.b[i];if(b){if(f&&!b.description){b.description=f,this.d.properties[i].markdownDescription=`${f} $(${i})`;const y=this.e.enum.indexOf(i);y!==-1&&(this.e.enumDescriptions[y]=f),this.a.fire()}return b}const I={id:i,description:f,defaults:g,deprecationMessage:l};this.b[i]=I;const S={$ref:"#/definitions/icons"};return l&&(S.deprecationMessage=l),f&&(S.markdownDescription=`${f}: $(${i})`),this.d.properties[i]=S,this.e.enum.push(i),this.e.enumDescriptions.push(f||""),this.a.fire(),{id:i}}deregisterIcon(i){delete this.b[i],delete this.d.properties[i];const g=this.e.enum.indexOf(i);g!==-1&&(this.e.enum.splice(g,1),this.e.enumDescriptions.splice(g,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(i=>this.b[i])}getIcon(i){return this.b[i]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(i,g){const f=this.f[i];return f||(this.f[i]=g,this.a.fire(),g)}deregisterIconFont(i){delete this.f[i]}getIconFont(i){return this.f[i]}toString(){const i=(b,I)=>b.id.localeCompare(I.id),g=b=>{for(;O.ThemeIcon.isThemeIcon(b.defaults);)b=this.b[b.defaults.id];return`codicon codicon-${b?b.id:""}`},f=[];f.push("| preview     | identifier                        | default codicon ID                | description"),f.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const l=Object.keys(this.b).map(b=>this.b[b]);for(const b of l.filter(I=>!!I.description).sort(i))f.push(`|<i class="${g(b)}"></i>|${b.id}|${O.ThemeIcon.isThemeIcon(b.defaults)?b.defaults.id:b.id}|${b.description||""}|`);f.push("| preview     | identifier                        "),f.push("| ----------- | --------------------------------- |");for(const b of l.filter(I=>!O.ThemeIcon.isThemeIcon(I.defaults)).sort(i))f.push(`|<i class="${g(b)}"></i>|${b.id}|`);return f.join(`
`)}}const r=new d;v.$jo.add(e.$nx.IconContribution,r);function o(n,i,g,f){return r.registerIcon(n,i,g,f)}function a(){return r}function h(){const n=(0,P.$Vj)();for(const i in n){const g="\\"+n[i].toString(16);r.registerIcon(i,{fontCharacter:g})}}h(),e.$qx="vscode://schemas/icons";const t=v.$jo.as(C.$ko.JSONContribution);t.registerSchema(e.$qx,r.getIconSchema());const s=new E.$Mh(()=>t.notifySchemaChanged(e.$qx),200);r.onDidChange(()=>{s.isScheduled()||s.schedule()}),e.$rx=o("widget-close",R.$Zj.close,(0,c.localize)(2,null)),e.$sx=o("goto-previous-location",R.$Zj.arrowUp,(0,c.localize)(3,null)),e.$tx=o("goto-next-location",R.$Zj.arrowDown,(0,c.localize)(4,null)),e.$ux=O.ThemeIcon.modify(R.$Zj.sync,"spin"),e.$vx=O.ThemeIcon.modify(R.$Zj.loading,"spin")}),define(ke[222],Ie([1,0,4,21,2,42,3,12]),function(de,e,E,R,P,O,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cw=e.$Bw=e.$yw=e.$ww=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$sw=e.$rw=void 0,e.$tw=C,e.$uw=u,e.$vw=D,e.$xw=d,e.$zw=r,e.$Aw=o,e.$rw=(0,A.$Ai)("tunnelService"),e.$sw=(0,A.$Ai)("sharedTunnelsService");var $;(function(t){t.Http="http",t.Https="https"})($||(e.TunnelProtocol=$={}));var c;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(c||(e.TunnelPrivacyId=c={}));function C(t){return!!t.forwardPort}var v;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(v||(e.ProvidedOnAutoForward=v={}));function u(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const s=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(s)return{address:s[1],port:+s[2]}}function D(t){if(t.scheme!=="http"&&t.scheme!=="https"||!t.query)return;const s=t.query.split("&");for(const n of s){const i=n.split("=")[1];if(/^https?:/.exec(i)){const g=u(P.URI.parse(i));if(g)return g}}}e.$ww=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function d(t){return e.$ww.indexOf(t)>=0}e.$yw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function r(t){return e.$yw.indexOf(t)>=0}function o(t,s,n,i){if(n===R.OperatingSystem.Windows)return!1;if(n===R.OperatingSystem.Macintosh&&r(s)){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(i);if(g?.length===4&&parseInt(g[1])>=18)return!1}return t<1024}class a{constructor(s,n,i){this.remoteAddress=s,this.localAddress=n,this.b=i,this.a=new E.$he,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Bw=a;let h=class{constructor(s,n){this.k=s,this.l=n,this.a=new E.$he,this.onTunnelOpened=this.a.event,this.b=new E.$he,this.onTunnelClosed=this.b.event,this.c=new E.$he,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const s=this.l.getValue("remote.localPortHost");return!s||s==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(s){return this.f=s,s?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(s){this.g=s.elevation,this.i=s.privacyOptions,this.h=s.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const s=[],n=Array.from(this.e.values());for(const i of n){const g=Array.from(i.values());for(const f of g){const l=await f.value;l&&typeof l!="string"&&s.push(l)}}return s}async dispose(){for(const s of this.e.values()){for(const{value:n}of s.values())await n.then(i=>typeof i!="string"?i?.dispose():void 0);s.clear()}this.e.clear()}setEnvironmentTunnel(s,n,i,g,f){this.q(s,n,Promise.resolve({tunnelRemoteHost:s,tunnelRemotePort:n,localAddress:i,privacy:g,protocol:f,dispose:()=>Promise.resolve()}))}async getExistingTunnel(s,n){(r(s)||d(s))&&(s=e.$ww[0]);const i=this.s(s,n);if(i)return++i.refcount,i.value}openTunnel(s,n,i,g,f,l=!1,b,I){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${n}:${i} on local port ${f}.`);const S=this.f??s;if(!S)return;if(n||(n="localhost"),g||(g=this.m),this.f&&this.j.has(i)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const y=this.t(S,n,i,g,f,l,b,I);return y?y.then(p=>{if(p){if(typeof p=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(n,i),p}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(n,i);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const k=this.o(p);return(p.tunnelRemoteHost!==n||p.tunnelRemotePort!==i)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),b&&p.privacy!==b&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(k),k}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),y)}o(s){return{tunnelRemotePort:s.tunnelRemotePort,tunnelRemoteHost:s.tunnelRemoteHost,tunnelLocalPort:s.tunnelLocalPort,localAddress:s.localAddress,privacy:s.privacy,protocol:s.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${s.tunnelRemoteHost}:${s.tunnelRemotePort} `);const n=this.e.get(s.tunnelRemoteHost);if(n){const i=n.get(s.tunnelRemotePort);i&&(i.refcount--,await this.p(s.tunnelRemoteHost,s.tunnelRemotePort,i))}}}}async p(s,n,i){if(i.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${s}:${n}.`);const g=i.value.then(async f=>{f&&typeof f!="string"&&(await f.dispose(!0),this.b.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this.e.has(s)&&this.e.get(s).delete(n),g}}async closeTunnel(s,n){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${s}:${n} `);const i=this.e.get(s);if(i&&i.has(n)){const g=i.get(n);g.refcount=0,await this.p(s,n,g)}}q(s,n,i){this.e.has(s)||this.e.set(s,new Map),this.e.get(s).set(n,{refcount:1,value:i})}async r(s,n){const i=this.e.get(s);if(i){const g=i.get(n),f=g?await g.value:void 0;(!f||typeof f=="string")&&i.delete(n),i.size===0&&this.e.delete(s)}}s(s,n){const i=[s];d(s)?(i.push(...e.$ww),i.push(...e.$yw)):r(s)&&i.push(...e.$yw);const g=i.map(f=>this.e.get(f));for(const f of g){const l=f?.get(n);if(l)return l}}canTunnel(s){return!!u(s)}u(s,n,i,g,f,l,b){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${n}:${i} on local port ${g}.`);const I=i;this.j.add(I);const S=g===void 0?i:g,y={elevationRequired:f?this.isPortPrivileged(S):!1},p={remoteAddress:{host:n,port:i},localAddressPort:g,privacy:l,public:l?l!==c.Private:void 0,protocol:b},k=s.forwardPort(p,y);return k?(this.q(n,i,k),k.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(I)})):this.j.delete(I),k}};e.$Cw=h,e.$Cw=h=He([Ve(0,M.$7j),Ve(1,O.$7i)],h)}),define(ke[223],Ie([1,0,3]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=void 0,e.$El=(0,E.$Ai)("IUriIdentityService")}),define(ke[224],Ie([1,0,3]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Dw=void 0,e.$Dw=(0,E.$Ai)("editSessionIdentityService");var R;(function(P){P[P.Complete=100]="Complete",P[P.Partial=50]="Partial",P[P.None=0]="None"})(R||(e.EditSessionIdentityMatch=R={}))}),define(ke[225],Ie([1,0,16]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4L=R,e.$5L=P,e.$6L=O,e.$7L=A,e.$8L=M;function R($){return $.scheme!==E.Schemas.file&&$.scheme!==E.Schemas.vscodeRemote}function P($){if($.folders.length)return $.folders.every(c=>R(c.uri))?$.folders[0].uri:void 0;if($.configuration&&R($.configuration))return $.configuration}function O($){return P($)?.scheme}function A($){return P($)?.authority}function M($){return P($)!==void 0}}),define(ke[50],Ie([1,0,178,20,58,24,2,3,16]),function(de,e,E,R,P,O,A,M,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Ui=e.$Ti=e.WorkbenchState=e.$Ni=e.$Mi=e.$Ji=void 0,e.$Ki=c,e.$Li=C,e.$Oi=v,e.$Pi=u,e.$Qi=D,e.$Ri=r,e.$Si=o,e.$Vi=t,e.$1i=s,e.$2i=n,e.$4i=i,e.$5i=g,e.$6i=f,e.$Ji=(0,M.$Ai)("contextService");function c(l){const b=l;return typeof b?.id=="string"&&A.URI.isUri(b.uri)}function C(l){return typeof l?.id=="string"&&!c(l)&&!u(l)}e.$Mi={id:"ext-dev"},e.$Ni={id:"empty-window"};function v(l,b){if(typeof l=="string"||typeof l>"u")return typeof l=="string"?{id:(0,R.$nc)(l)}:b?e.$Mi:e.$Ni;const I=l;return I.configuration?{id:I.id,configPath:I.configuration}:I.folders.length===1?{id:I.id,uri:I.folders[0].uri}:{id:I.id}}function u(l){const b=l;return typeof b?.id=="string"&&A.URI.isUri(b.configPath)}function D(l){const b=l;if(b?.uri)return{id:b.id,uri:A.URI.revive(b.uri)};const I=l;if(I?.configPath)return{id:I.id,configPath:A.URI.revive(I.configPath)};if(l?.id)return{id:l.id}}var d;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(d||(e.WorkbenchState=d={}));function r(l){const b=l;return!!(b&&typeof b=="object"&&typeof b.id=="string"&&Array.isArray(b.folders))}function o(l){const b=l;return!!(b&&typeof b=="object"&&A.URI.isUri(b.uri)&&typeof b.name=="string"&&typeof b.toResource=="function")}class a{constructor(b,I,S,y,p){this.h=b,this.j=S,this.k=y,this.l=p,this.c=P.$Gi.forUris(this.l,()=>!0),this.folders=I}update(b){this.h=b.id,this.k=b.configuration,this.j=b.transient,this.l=b.l,this.folders=b.folders}get folders(){return this.g}set folders(b){this.g=b,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(b){this.k=b}getFolder(b){return b&&this.c.findSubstr(b)||null}n(){this.c=P.$Gi.forUris(this.l,()=>!0);for(const b of this.folders)this.c.set(b.uri,b)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ti=a;class h{constructor(b,I){this.raw=I,this.uri=b.uri,this.index=b.index,this.name=b.name}toResource(b){return(0,O.$bh)(this.uri,b)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ui=h;function t(l){return new h({uri:l,index:0,name:(0,O.$0g)(l)},{uri:l.toString()})}e.$Wi="code-workspace",e.$Xi=`.${e.$Wi}`,e.$Yi=[{name:(0,E.localize)(0,null),extensions:[e.$Wi]}],e.$Zi="workspace.json";function s(l,b){return O.$5g.isEqualOrParent(l,b.untitledWorkspacesHome)}function n(l){let b;return A.URI.isUri(l)?b=l:b=l.configuration,b?.scheme===$.Schemas.tmp}e.$3i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(l){return l.id===e.$3i}function g(l,b){return!s(l,b)&&!n(l)}function f(l){return(typeof l=="string"?(0,R.$oc)(l):(0,O.$_g)(l))===e.$Xi}}),define(ke[112],Ie([1,0,76,4,6,24,2,177,105,30,3,12,50,29,223,11,36,13,15]),function(de,e,E,R,P,O,A,M,$,c,C,v,u,D,d,r,o,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=e.$Gl=e.ProfileResourceType=void 0,e.$Fl=s,e.$Hl=n,e.$Il=i;var t;(function(l){l.Settings="settings",l.Keybindings="keybindings",l.Snippets="snippets",l.Tasks="tasks",l.Extensions="extensions",l.GlobalState="globalState"})(t||(e.ProfileResourceType=t={}));function s(l){const b=l;return!!(b&&typeof b=="object"&&typeof b.id=="string"&&typeof b.isDefault=="boolean"&&typeof b.name=="string"&&A.URI.isUri(b.location)&&A.URI.isUri(b.globalStorageHome)&&A.URI.isUri(b.settingsResource)&&A.URI.isUri(b.keybindingsResource)&&A.URI.isUri(b.tasksResource)&&A.URI.isUri(b.snippetsHome)&&A.URI.isUri(b.extensionsResource))}e.$Gl=(0,C.$Ai)("IUserDataProfilesService");function n(l,b){return{id:l.id,isDefault:l.isDefault,name:l.name,shortName:l.shortName,icon:l.icon,location:A.URI.revive(l.location).with({scheme:b}),globalStorageHome:A.URI.revive(l.globalStorageHome).with({scheme:b}),settingsResource:A.URI.revive(l.settingsResource).with({scheme:b}),keybindingsResource:A.URI.revive(l.keybindingsResource).with({scheme:b}),tasksResource:A.URI.revive(l.tasksResource).with({scheme:b}),snippetsHome:A.URI.revive(l.snippetsHome).with({scheme:b}),extensionsResource:A.URI.revive(l.extensionsResource).with({scheme:b}),cacheHome:A.URI.revive(l.cacheHome).with({scheme:b}),useDefaultFlags:l.useDefaultFlags,isTransient:l.isTransient}}function i(l,b,I,S,y,p){return{id:l,name:b,location:I,isDefault:!1,shortName:y?.shortName,icon:y?.icon,globalStorageHome:p&&y?.useDefaultFlags?.globalState?p.globalStorageHome:(0,O.$bh)(I,"globalStorage"),settingsResource:p&&y?.useDefaultFlags?.settings?p.settingsResource:(0,O.$bh)(I,"settings.json"),keybindingsResource:p&&y?.useDefaultFlags?.keybindings?p.keybindingsResource:(0,O.$bh)(I,"keybindings.json"),tasksResource:p&&y?.useDefaultFlags?.tasks?p.tasksResource:(0,O.$bh)(I,"tasks.json"),snippetsHome:p&&y?.useDefaultFlags?.snippets?p.snippetsHome:(0,O.$bh)(I,"snippets"),extensionsResource:p&&y?.useDefaultFlags?.extensions?p.extensionsResource:(0,O.$bh)(I,"extensions.json"),cacheHome:(0,O.$bh)(S,l),useDefaultFlags:y?.useDefaultFlags,isTransient:y?.transient}}let g=class extends P.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(b,I,S,y){super(),this.t=b,this.u=I,this.w=S,this.y=y,this.f=!0,this.h=this.B(new R.$he),this.onDidChangeProfiles=this.h.event,this.j=this.B(new R.$he),this.onWillCreateProfile=this.j.event,this.m=this.B(new R.$he),this.onWillRemoveProfile=this.m.event,this.n=this.B(new R.$he),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new D.$Ac,emptyWindows:new Map},this.profilesHome=(0,O.$bh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,O.$bh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(b){this.f!==b&&(this.z=void 0,this.f=b)}isEnabled(){return this.f}get C(){if(!this.z){const b=this.D(),I=[b];if(this.f)try{for(const p of this.O()){if(!p.name||!(0,h.$ag)(p.name)||!p.location){this.y.warn("Skipping the invalid stored profile",p.location||p.name);continue}I.push(i((0,O.$$g)(p.location),p.name,p.location,this.g,{shortName:p.shortName,icon:p.icon,useDefaultFlags:p.useDefaultFlags},b))}}catch(p){this.y.error(p)}const S=new D.$Ac,y=new Map;if(I.length)try{const p=this.Q();if(p.workspaces)for(const[k,m]of Object.entries(p.workspaces)){const w=A.URI.parse(k),F=I.find(T=>T.id===m);F&&S.set(w,F)}if(p.emptyWindows)for(const[k,m]of Object.entries(p.emptyWindows)){const w=I.find(F=>F.id===m);w&&y.set(k,w)}}catch(p){this.y.error(p)}this.z={profiles:I,workspaces:S,emptyWindows:y}}return this.z}D(){const b=i("__default__profile__",(0,M.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...b,extensionsResource:this.S()??b.extensionsResource,isDefault:!0}}async createTransientProfile(b){const I="Temp",S=new RegExp(`${(0,a.$df)(I)}\\s(\\d+)`);let y=0;for(const k of this.profiles){const m=S.exec(k.name),w=m?parseInt(m[1]):0;y=w>y?w:y}const p=`${I} ${y+1}`;return this.createProfile((0,E.$oj)((0,o.$Wg)()).toString(16),p,{transient:!0},b)}async createNamedProfile(b,I,S){return this.createProfile((0,E.$oj)((0,o.$Wg)()).toString(16),b,I,S)}async createProfile(b,I,S,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const p=await this.F(b,I,S);return y&&await this.setProfileForWorkspace(y,p),p}async F(b,I,S){if(!(0,h.$ag)(I)||!I)throw new Error("Name of the profile is mandatory and must be of type `string`");let y=this.r.get(I);return y||(y=(async()=>{try{if(this.profiles.find(w=>w.name===I||w.id===b))throw new Error(`Profile with ${I} name already exists`);const k=i(b,I,(0,O.$bh)(this.profilesHome,b),this.g,S,this.defaultProfile);await this.u.createFolder(k.location);const m=[];return this.j.fire({profile:k,join(w){m.push(w)}}),await r.Promises.settled(m),this.I([k],[],[]),k}finally{this.r.delete(I)}})(),this.r.set(I,y)),y}async updateProfile(b,I){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let S=this.profiles.find(y=>y.id===b.id);if(!S)throw new Error(`Profile '${b.name}' does not exist`);return S=i(S.id,I.name??S.name,S.location,this.g,{shortName:I.shortName??S.shortName,icon:I.icon===null?void 0:I.icon??S.icon,transient:I.transient??S.isTransient,useDefaultFlags:I.useDefaultFlags??S.useDefaultFlags},this.defaultProfile),this.I([],[],[S]),S}async removeProfile(b){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(b.isDefault)throw new Error("Cannot remove default profile");const I=this.profiles.find(y=>y.id===b.id);if(!I)throw new Error(`Profile '${b.name}' does not exist`);const S=[];this.m.fire({profile:I,join(y){S.push(y)}});try{await Promise.allSettled(S)}catch(y){this.y.error(y)}for(const y of[...this.C.emptyWindows.keys()])I.id===this.C.emptyWindows.get(y)?.id&&this.C.emptyWindows.delete(y);for(const y of[...this.C.workspaces.keys()])I.id===this.C.workspaces.get(y)?.id&&this.C.workspaces.delete(y);this.M(),this.I([],[I],[]);try{await this.u.del(I.cacheHome,{recursive:!0})}catch(y){(0,c.$ll)(y)!==c.FileOperationResult.FILE_NOT_FOUND&&this.y.error(y)}}async setProfileForWorkspace(b,I){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const S=this.profiles.find(y=>y.id===I.id);if(!S)throw new Error(`Profile '${I.name}' does not exist`);this.L(b,S)}unsetWorkspace(b,I){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(b,void 0,I)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const b=await this.u.resolve(this.profilesHome);await Promise.all((b.children||[]).filter(I=>I.isDirectory&&this.profiles.every(S=>!this.w.extUri.isEqual(S.location,I.resource))).map(I=>this.u.del(I.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const b=this.s.profiles.filter(I=>!this.H(I));await Promise.allSettled(b.map(I=>this.removeProfile(I)))}getProfileForWorkspace(b){const I=this.G(b);return A.URI.isUri(I)?this.s.workspaces.get(I)??this.C.workspaces.get(I):this.s.emptyWindows.get(I)??this.C.emptyWindows.get(I)}G(b){return(0,u.$Ki)(b)?b.uri:(0,u.$Pi)(b)?b.configPath:b.id}H(b){return!!([...this.s.emptyWindows.values()].some(I=>this.w.extUri.isEqual(I.location,b.location))||[...this.s.workspaces.values()].some(I=>this.w.extUri.isEqual(I.location,b.location))||[...this.C.emptyWindows.values()].some(I=>this.w.extUri.isEqual(I.location,b.location))||[...this.C.workspaces.values()].some(I=>this.w.extUri.isEqual(I.location,b.location)))}I(b,I,S){const y=[...this.profiles,...b],p=[];this.s.profiles=[];for(let k of y)k.isDefault||I.some(m=>k.id===m.id)||(k=S.find(m=>k.id===m.id)??k,k.isTransient?this.s.profiles.push(k):p.push({location:k.location,name:k.name,shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags}));this.P(p),this.z=void 0,this.J(b,I,S)}J(b,I,S){this.h.fire({added:b,removed:I,updated:S,all:this.profiles})}L(b,I,S){S=I?.isTransient?!0:S,S||this.L(b,void 0,!0);const y=this.G(b),p=S?this.s:this.C;A.URI.isUri(y)?(p.workspaces.delete(y),I&&p.workspaces.set(y,I)):(p.emptyWindows.delete(y),I&&p.emptyWindows.set(y,I)),S||this.M()}M(){const b={};for(const[S,y]of this.C.workspaces.entries())b[S.toString()]=y.id;const I={};for(const[S,y]of this.C.emptyWindows.entries())I[S.toString()]=y.id;this.R({workspaces:b,emptyWindows:I}),this.z=void 0}N(b){const I={},S=this.D();if(b.workspaces)for(const[p,k]of Object.entries(b.workspaces)){const m=A.URI.parse(k);I[p]=this.w.extUri.isEqual(m,S.location)?S.id:this.w.extUri.basename(m)}const y={};if(b.emptyWindows)for(const[p,k]of Object.entries(b.emptyWindows)){const m=A.URI.parse(k);y[p]=this.w.extUri.isEqual(m,S.location)?S.id:this.w.extUri.basename(m)}return{workspaces:I,emptyWindows:y}}O(){return[]}P(b){throw new Error("not implemented")}Q(){return{}}R(b){throw new Error("not implemented")}S(){}};e.$Jl=g,e.$Jl=g=He([Ve(0,$.$Hi),Ve(1,c.$7k),Ve(2,d.$El),Ve(3,v.$7j)],g);class f extends g{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(b){this.a=b}Q(){return this.X}R(b){this.X=b}}e.$Kl=f}),define(ke[226],Ie([1,0,11,4,6,64,15,160,3,112]),function(de,e,E,R,P,O,A,M,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=e.$$p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$9p=e.$8p=e.$7p=void 0,e.$0p=D,e.$_p=r,e.$bq=a,e.$7p="__$__isNewStorageMarker",e.$8p="__$__targetStorageMarker",e.$9p=(0,$.$Ai)("storageService");var C;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(C||(e.WillSaveStateReason=C={}));var v;(function(h){h[h.APPLICATION=-1]="APPLICATION",h[h.PROFILE=0]="PROFILE",h[h.WORKSPACE=1]="WORKSPACE"})(v||(e.StorageScope=v={}));var u;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(u||(e.StorageTarget=u={}));function D(h){const t=h.get(e.$8p);if(t)try{return JSON.parse(t)}catch{}return Object.create(null)}class d extends P.$Uc{static{this.a=60*1e3}constructor(t={flushInterval:d.a}){super(),this.m=t,this.b=this.B(new R.$ke),this.c=this.B(new R.$ke),this.onDidChangeTarget=this.c.event,this.f=this.B(new R.$he),this.onWillSaveState=this.f.event,this.h=this.B(new E.$Mh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new P.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(t,s,n){return R.Event.filter(this.b.event,i=>i.scope===t&&(s===void 0||i.key===s),n)}n(){this.j.value=(0,E.$Qh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,P.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.O()}finally{(0,O.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(t,s){const{key:n,external:i}=s;if(n===e.$8p){switch(t){case v.APPLICATION:this.H=void 0;break;case v.PROFILE:this.F=void 0;break;case v.WORKSPACE:this.C=void 0;break}this.c.fire({scope:t})}else this.b.fire({scope:t,key:n,target:this.J(t)[n],external:i})}w(t){this.f.fire({reason:t})}get(t,s,n){return this.P(s)?.get(t,n)}getBoolean(t,s,n){return this.P(s)?.getBoolean(t,n)}getNumber(t,s,n){return this.P(s)?.getNumber(t,n)}getObject(t,s,n){return this.P(s)?.getObject(t,n)}storeAll(t,s){this.y(()=>{for(const n of t)this.store(n.key,n.value,n.scope,n.target,s)})}store(t,s,n,i,g=!1){if((0,A.$jg)(s)){this.remove(t,n,g);return}this.y(()=>{this.z(t,n,i),this.P(n)?.set(t,s,g)})}remove(t,s,n=!1){this.y(()=>{this.z(t,s,void 0),this.P(s)?.delete(t,n)})}y(t){this.b.pause(),this.c.pause();try{t()}finally{this.b.resume(),this.c.resume()}}keys(t,s){const n=[],i=this.J(t);for(const g of Object.keys(i))i[g]===s&&n.push(g);return n}z(t,s,n,i=!1){const g=this.J(s);typeof n=="number"?g[t]!==n&&(g[t]=n,this.P(s)?.set(e.$8p,JSON.stringify(g),i)):typeof g[t]=="number"&&(delete g[t],this.P(s)?.set(e.$8p,JSON.stringify(g),i))}get D(){return this.C||(this.C=this.L(v.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(v.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(v.APPLICATION)),this.H}J(t){switch(t){case v.APPLICATION:return this.I;case v.PROFILE:return this.G;default:return this.D}}L(t){const s=this.P(t);return s?D(s):Object.create(null)}isNew(t){return this.getBoolean(e.$7p,t)===!0}async flush(t=C.NONE){this.f.fire({reason:t});const s=this.P(v.APPLICATION),n=this.P(v.PROFILE),i=this.P(v.WORKSPACE);switch(t){case C.NONE:await E.Promises.settled([s?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await E.Promises.settled([s?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const t=this.P(v.APPLICATION)?.items??new Map,s=this.P(v.PROFILE)?.items??new Map,n=this.P(v.WORKSPACE)?.items??new Map;return a(t,s,n,this.Q(v.APPLICATION)??"",this.Q(v.PROFILE)??"",this.Q(v.WORKSPACE)??"")}async optimize(t){return await this.flush(),this.P(t)?.optimize()}async switch(t,s){return this.w(C.NONE),(0,c.$Fl)(t)?this.R(t,s):this.S(t,s)}M(t,s){return!(t.id===s.id||r(s)&&r(t))}N(t,s,n){this.y(()=>{const i=new Set;for(const[g,f]of t)i.add(g),s.get(g)!==f&&this.u(n,{key:g,external:!0});for(const[g]of s.items)i.has(g)||this.u(n,{key:g,external:!0})})}}e.$$p=d;function r(h){return h.isDefault||!!h.useDefaultFlags?.globalState}class o extends d{constructor(){super(),this.U=this.B(new M.$5p(new M.$6p,{hint:M.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new M.$5p(new M.$6p,{hint:M.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new M.$5p(new M.$6p,{hint:M.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(t=>this.u(v.WORKSPACE,t))),this.B(this.W.onDidChangeStorage(t=>this.u(v.PROFILE,t))),this.B(this.U.onDidChangeStorage(t=>this.u(v.APPLICATION,t)))}P(t){switch(t){case v.APPLICATION:return this.U;case v.PROFILE:return this.W;default:return this.X}}Q(t){switch(t){case v.APPLICATION:return"inMemory (application)";case v.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(t){return!1}}e.$aq=o;async function a(h,t,s,n,i,g){const f=w=>{try{return JSON.parse(w)}catch{return w}},l=new Map,b=new Map;h.forEach((w,F)=>{l.set(F,w),b.set(F,f(w))});const I=new Map,S=new Map;t.forEach((w,F)=>{I.set(F,w),S.set(F,f(w))});const y=new Map,p=new Map;s.forEach((w,F)=>{y.set(F,w),p.set(F,f(w))}),console.group(n!==i?`Storage: Application (path: ${n})`:`Storage: Application & Profile (path: ${n}, default profile)`);const k=[];if(l.forEach((w,F)=>{k.push({key:F,value:w})}),console.table(k),console.groupEnd(),console.log(b),n!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const w=[];I.forEach((F,T)=>{w.push({key:T,value:F})}),console.table(w),console.groupEnd(),console.log(S)}console.group(`Storage: Workspace (path: ${g})`);const m=[];y.forEach((w,F)=>{m.push({key:F,value:w})}),console.table(m),console.groupEnd(),console.log(p)}}),define(ke[80],Ie([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Imc=void 0;class E{static{this.a=!1}constructor(P){this.d=P,this.b=new Map,this.c=1}add(P){const O=this.c++;return this.b.set(O,P),this.e(),O}get(P,O){return this.b.has(P)?this.b.get(P)[O]:void 0}delete(P){this.b.delete(P),this.e()}e(){E.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Imc=E}),define(ke[51],Ie([1,0,16,24,30,3]),function(de,e,E,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Omc=e.$Nmc=void 0;class A{constructor(){this.a=new Set(Object.keys(E.Schemas)),this.b=new Map,this.extUri=new R.$3g($=>{const c=this.b.get($.scheme);return!(c===void 0||c&P.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos($,c){c===null?this.b.delete($.scheme):this.b.set($.scheme,c)}isFreeScheme($){return!this.b.has($)&&!this.a.has($)}getCapabilities($){return this.b.get($)}}e.$Nmc=A,e.$Omc=(0,O.$Ai)("IExtHostFileSystemInfo")}),define(ke[27],Ie([1,0,3]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cP=void 0,e.$cP=(0,E.$Ai)("IExtHostInitDataService")}),define(ke[227],Ie([1,0,183,12,212,27]),function(de,e,E,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uoc=void 0;let A=class extends P.$mQ{constructor($,c,C){const v=C.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",u=C.remote.isRemote?(0,E.localize)(0,null):$?(0,E.localize)(1,null):(0,E.localize)(2,null);super(c.createLogger(v,{name:u}))}};e.$Uoc=A,e.$Uoc=A=He([Ve(1,R.$8j),Ve(2,O.$cP)],A)}),define(ke[228],Ie([1,0,11]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$unc=e.$tnc=void 0;class R{constructor(A,M,$){this.h=new Map,this.a=A,this.b=M,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(c=>(this.f=c,this)),this.g=this.c.onDidChangeStorage(c=>{c.shared===this.b&&c.key===this.a&&(this.f=c.value)}),this.i=new E.$Mh(()=>{const c=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const C of c.values())C.complete()}catch(C){for(const v of c.values())v.error(C)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,M){let $=this.f[A];return typeof $>"u"&&($=M),$}update(A,M){this.f[A]=M;const $=this.h.get(A);if($!==void 0)return $.p;const c=new E.$Xh;return this.h.set(A,c),this.i.isScheduled()||this.i.schedule(),c.p}dispose(){this.g.dispose()}}e.$tnc=R;class P extends R{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,M){super(A.identifier.value,!0,M),this.j=A}}e.$unc=P}),define(ke[229],Ie([1,0,4,2]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ioc=void 0;class P{constructor(A){this.c=A,this.a=new E.$he,this.onDidSaveNotebookDocument=this.a.event,this.b=new E.$he,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,M,$,c){const v=this.c.getNotebookDocument(R.URI.revive(A)).acceptModelChanged(M.value,$,c);this.b.fire(v)}$acceptDirtyStateChanged(A,M){this.c.getNotebookDocument(R.URI.revive(A)).acceptDirty(M)}$acceptModelSaved(A){const M=this.c.getNotebookDocument(R.URI.revive(A));this.a.fire(M.apiNotebook)}}e.$ioc=P}),define(ke[17],Ie([1,0,3]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZO=e.$YO=void 0,e.$YO=(0,E.$Ai)("IExtHostRpcService");class R{constructor(O){this.getProxy=O.getProxy.bind(O),this.set=O.set.bind(O),this.dispose=O.dispose.bind(O),this.assertRegistered=O.assertRegistered.bind(O),this.drain=O.drain.bind(O)}}e.$ZO=R}),define(ke[230],Ie([1,0,19,4]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dnc=void 0;class P{#e;constructor(A,M){this.b=new R.$he,this.onDidChange=this.b.event,this.a=E.$Wm.toKey(A.identifier),this.#e=M,this.#e.onDidChangePassword($=>{$.extensionId===this.a&&this.b.fire({key:$.key})})}get(A){return this.#e.get(this.a,A)}store(A,M){return this.#e.store(this.a,A,M)}delete(A){return this.#e.delete(this.a,A)}}e.$Dnc=P}),define(ke[65],Ie([1,0,3]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5mc=e.$4mc=void 0,e.$4mc=(0,E.$Ai)("IURITransformerService");class R{constructor(O){O?(this.transformIncoming=O.transformIncoming.bind(O),this.transformOutgoing=O.transformOutgoing.bind(O),this.transformOutgoingURI=O.transformOutgoingURI.bind(O),this.transformOutgoingScheme=O.transformOutgoingScheme.bind(O)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$5mc=R}),define(ke[113],Ie([1,0,192,15,2,6,3,31,30,16,48,154,35]),function(de,e,E,R,P,O,A,M,$,c,C,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$4F=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$TF=e.EditorInputCapabilities=e.$SF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$IF=e.$HF=e.$GF=e.$FF=e.$EF=void 0,e.$JF=r,e.$KF=o,e.$LF=a,e.$MF=h,e.$NF=t,e.$OF=s,e.$PF=n,e.$QF=i,e.$RF=g,e.$UF=y,e.$VF=k,e.$WF=m,e.$XF=w,e.$YF=F,e.$ZF=T,e.$1F=G,e.$2F=q,e.$3F=fe,e.$5F=pe,e.$6F=se,e.$7F=Ce,e.$8F=Fe,e.$EF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$FF={id:"default",displayName:(0,E.localize)(0,null),providerDisplayName:(0,E.localize)(1,null)},e.$GF="workbench.editor.sidebysideEditor",e.$HF="workbench.editors.textDiffEditor",e.$IF="workbench.editors.binaryResourceDiffEditor";var D;(function(X){X[X.PROGRAMMATIC=1]="PROGRAMMATIC",X[X.USER=2]="USER",X[X.EDIT=3]="EDIT",X[X.NAVIGATION=4]="NAVIGATION",X[X.JUMP=5]="JUMP"})(D||(e.EditorPaneSelectionChangeReason=D={}));var d;(function(X){X[X.IDENTICAL=1]="IDENTICAL",X[X.SIMILAR=2]="SIMILAR",X[X.DIFFERENT=3]="DIFFERENT"})(d||(e.EditorPaneSelectionCompareResult=d={}));function r(X){const W=X;return!!W&&typeof W.getSelection=="function"&&!!W.onDidChangeSelection}function o(X){const W=X;return!!W&&typeof W.getScrollPosition=="function"&&typeof W.setScrollPosition=="function"&&!!W.onDidChangeScroll}function a(X,W,ie){for(const Se of ie.visibleEditorPanes)if(Se.group.id===W&&X.matches(Se.input))return Se.getViewState()}function h(X){if(y(X))return!1;const W=X;return P.URI.isUri(W?.resource)}function t(X){if(y(X))return!1;const W=X;return W?.original!==void 0&&W.modified!==void 0}function s(X){if(y(X))return!1;const W=X;return!W||W.resources&&!Array.isArray(W.resources)?!1:!!W.resources||!!W.multiDiffSource}function n(X){if(y(X)||t(X))return!1;const W=X;return W?.primary!==void 0&&W.secondary!==void 0}function i(X){if(y(X))return!1;const W=X;return W?W.resource===void 0||W.resource.scheme===c.Schemas.untitled||W.forceUntitled===!0:!1}function g(X){if(y(X))return!1;const W=X;return P.URI.isUri(W?.base?.resource)&&P.URI.isUri(W?.input1?.resource)&&P.URI.isUri(W?.input2?.resource)&&P.URI.isUri(W?.result?.resource)}var f;(function(X){X[X.SHORT=0]="SHORT",X[X.MEDIUM=1]="MEDIUM",X[X.LONG=2]="LONG"})(f||(e.Verbosity=f={}));var l;(function(X){X[X.EXPLICIT=1]="EXPLICIT",X[X.AUTO=2]="AUTO",X[X.FOCUS_CHANGE=3]="FOCUS_CHANGE",X[X.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(l||(e.SaveReason=l={}));class b{constructor(){this.a=new Map}registerSource(W,ie){let Se=this.a.get(W);return Se||(Se={source:W,label:ie},this.a.set(W,Se)),Se.source}getSourceLabel(W){return this.a.get(W)?.label??W}}e.$SF=new b;var I;(function(X){X[X.None=0]="None",X[X.Readonly=2]="Readonly",X[X.Untitled=4]="Untitled",X[X.Singleton=8]="Singleton",X[X.RequiresTrust=16]="RequiresTrust",X[X.CanSplitInGroup=32]="CanSplitInGroup",X[X.ForceDescription=64]="ForceDescription",X[X.CanDropIntoEditor=128]="CanDropIntoEditor",X[X.MultipleEditors=256]="MultipleEditors",X[X.Scratchpad=512]="Scratchpad"})(I||(e.EditorInputCapabilities=I={}));class S extends O.$Uc{}e.$TF=S;function y(X){return X instanceof S}function p(X){const W=X;return P.URI.isUri(W?.preferredResource)}function k(X){const W=X;return y(W?.primary)&&y(W?.secondary)}function m(X){const W=X;return y(W?.modified)&&y(W?.original)}function w(X,W,ie,Se,he){return Fe(Se,[(0,v.$kj)({id:"workbench.action.openLargeFile",label:(0,E.localize)(2,null),run:()=>{const we={...ie,limits:{size:Number.MAX_VALUE}};X.openEditor(W,we)}}),(0,v.$kj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,E.localize)(3,null),run:()=>he.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}function F(X){return y(X?.editor)}function T(X){const W=X;return F(X)&&W?.group!==void 0}function G(X){const W=X;return typeof W?.groupId=="number"&&y(W.editor)}function q(X){return typeof X?.groupId=="number"}var V;(function(X){X[X.UNKNOWN=0]="UNKNOWN",X[X.REPLACE=1]="REPLACE",X[X.MOVE=2]="MOVE",X[X.UNPIN=3]="UNPIN"})(V||(e.EditorCloseContext=V={}));var N;(function(X){X[X.GROUP_ACTIVE=0]="GROUP_ACTIVE",X[X.GROUP_INDEX=1]="GROUP_INDEX",X[X.GROUP_LABEL=2]="GROUP_LABEL",X[X.GROUP_LOCKED=3]="GROUP_LOCKED",X[X.EDITORS_SELECTION=4]="EDITORS_SELECTION",X[X.EDITOR_OPEN=5]="EDITOR_OPEN",X[X.EDITOR_CLOSE=6]="EDITOR_CLOSE",X[X.EDITOR_MOVE=7]="EDITOR_MOVE",X[X.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",X[X.EDITOR_LABEL=9]="EDITOR_LABEL",X[X.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",X[X.EDITOR_PIN=11]="EDITOR_PIN",X[X.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",X[X.EDITOR_STICKY=13]="EDITOR_STICKY",X[X.EDITOR_DIRTY=14]="EDITOR_DIRTY",X[X.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(N||(e.GroupModelChangeKind=N={}));var L;(function(X){X[X.PRIMARY=1]="PRIMARY",X[X.SECONDARY=2]="SECONDARY",X[X.BOTH=3]="BOTH",X[X.ANY=4]="ANY"})(L||(e.SideBySideEditor=L={}));class Z{getOriginalUri(W,ie){if(!W)return;if(g(W))return e.$4F.getOriginalUri(W.result,ie);if(ie?.supportSideBySide){const{primary:he,secondary:we}=this.a(W);if(he&&we){if(ie?.supportSideBySide===L.BOTH)return{primary:this.getOriginalUri(he,{filterByScheme:ie.filterByScheme}),secondary:this.getOriginalUri(we,{filterByScheme:ie.filterByScheme})};if(ie?.supportSideBySide===L.ANY)return this.getOriginalUri(he,{filterByScheme:ie.filterByScheme})??this.getOriginalUri(we,{filterByScheme:ie.filterByScheme});W=ie.supportSideBySide===L.PRIMARY?he:we}}if(t(W)||s(W)||n(W)||g(W))return;const Se=p(W)?W.preferredResource:W.resource;return!Se||!ie||!ie.filterByScheme?Se:this.b(Se,ie.filterByScheme)}a(W){return k(W)||n(W)?{primary:W.primary,secondary:W.secondary}:m(W)||t(W)?{primary:W.modified,secondary:W.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(W,ie){if(!W)return;if(g(W))return e.$4F.getCanonicalUri(W.result,ie);if(ie?.supportSideBySide){const{primary:he,secondary:we}=this.a(W);if(he&&we){if(ie?.supportSideBySide===L.BOTH)return{primary:this.getCanonicalUri(he,{filterByScheme:ie.filterByScheme}),secondary:this.getCanonicalUri(we,{filterByScheme:ie.filterByScheme})};if(ie?.supportSideBySide===L.ANY)return this.getCanonicalUri(he,{filterByScheme:ie.filterByScheme})??this.getCanonicalUri(we,{filterByScheme:ie.filterByScheme});W=ie.supportSideBySide===L.PRIMARY?he:we}}if(t(W)||s(W)||n(W)||g(W))return;const Se=W.resource;return!Se||!ie||!ie.filterByScheme?Se:this.b(Se,ie.filterByScheme)}b(W,ie){if(Array.isArray(ie)){if(ie.some(Se=>W.scheme===Se))return W}else if(ie===W.scheme)return W}}var re;(function(X){X[X.UNKNOWN=0]="UNKNOWN",X[X.KEYBOARD=1]="KEYBOARD",X[X.MOUSE=2]="MOUSE"})(re||(e.EditorCloseMethod=re={}));function fe(X,W,ie,Se){if(!X.isSticky(W))return!1;switch(Se.preventPinnedEditorClose){case"keyboardAndMouse":return ie===re.MOUSE||ie===re.KEYBOARD;case"mouse":return ie===re.MOUSE;case"keyboard":return ie===re.KEYBOARD}return!1}e.$4F=new Z;var be;(function(X){X[X.LEFT=0]="LEFT",X[X.RIGHT=1]="RIGHT"})(be||(e.CloseDirection=be={}));class oe{constructor(){this.c=new Map,this.d=new Map}start(W){const ie=this.a=W.get(A.$zi);for(const[Se,he]of this.c)this.e(Se,he,ie);this.c.clear()}e(W,ie,Se){const he=Se.createInstance(ie);this.d.set(W,he)}registerFileEditorFactory(W){if(this.b)throw new Error("Can only register one file editor factory.");this.b=W}getFileEditorFactory(){return(0,R.$lg)(this.b)}registerEditorSerializer(W,ie){if(this.c.has(W)||this.d.has(W))throw new Error(`A editor serializer with type ID '${W}' was already registered.`);return this.a?this.e(W,ie,this.a):this.c.set(W,ie),(0,O.$Sc)(()=>{this.c.delete(W),this.d.delete(W)})}getEditorSerializer(W){return this.d.get(typeof W=="string"?W:W.typeId)}}M.$jo.add(e.$EF.EditorFactory,new oe);async function pe(X,W,ie){return!X||!X.length?[]:await Promise.all(X.map(async Se=>{const he=P.URI.revive(Se.fileUri);if(!he){ie.info("Cannot resolve the path because it is not valid.",Se);return}if(!await W.canHandleResource(he)){ie.info("Cannot resolve the path because it cannot be handled",Se);return}let ae=Se.exists,Y=Se.type;if(typeof ae!="boolean"||typeof Y!="number")try{Y=(await W.stat(he)).isDirectory?$.FileType.Directory:$.FileType.Unknown,ae=!0}catch(me){ie.error(me),ae=!1}if(!ae&&Se.openOnlyIfExists){ie.info("Cannot resolve the path because it does not exist",Se);return}if(Y===$.FileType.Directory){ie.info("Cannot resolve the path because it is a directory",Se);return}const x={...Se.options,pinned:!0};return ae?{resource:he,options:x}:{resource:he,options:x,forceUntitled:!0}}))}var $e;(function(X){X[X.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",X[X.SEQUENTIAL=1]="SEQUENTIAL"})($e||(e.EditorsOrder=$e={}));function se(X){const W=X;if(!W)return!1;const ie=W;if(ie.modified)return se(ie.modified);const Se=W;return!!(Se.contributionsState&&Se.viewState&&Array.isArray(Se.cursorState))}function Ce(X){return(0,C.$mj)(X)}function Fe(X,W,ie){const Se=(0,C.$nj)(X,W);return Se.forceMessage=ie?.forceMessage,Se.forceSeverity=ie?.forceSeverity,Se.allowDialog=ie?.allowDialog,Se}}),define(ke[231],Ie([1,0,4,193,3,6,29,31,26,97,221]),function(de,e,E,R,P,O,A,M,$,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dG=e.$cG=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$bG=e.ViewContentGroups=e.$_F=e.ViewContainerLocation=e.Extensions=e.$$F=e.$0F=e.$9F=void 0,e.$aG=D,e.$9F="views",e.$0F=(0,R.localize)(0,null),e.$$F=(0,C.$ox)("default-view-icon",c.$Zj.window,(0,R.localize)(1,null));var v;(function(i){i.ViewContainersRegistry="workbench.registry.view.containers",i.ViewsRegistry="workbench.registry.view"})(v||(e.Extensions=v={}));var u;(function(i){i[i.Sidebar=0]="Sidebar",i[i.Panel=1]="Panel",i[i.AuxiliaryBar=2]="AuxiliaryBar"})(u||(e.ViewContainerLocation=u={})),e.$_F=[u.Sidebar,u.Panel,u.AuxiliaryBar];function D(i){switch(i){case u.Sidebar:return"sidebar";case u.Panel:return"panel";case u.AuxiliaryBar:return"auxiliarybar"}}class d extends O.$Uc{constructor(){super(...arguments),this.c=this.B(new E.$he),this.onDidRegister=this.c.event,this.f=this.B(new E.$he),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(g,f,l){const b=this.get(g.id);if(b)return b;const I=g;return I.openCommandActionDescriptor=l?.doNotRegisterOpenCommand?void 0:I.openCommandActionDescriptor??{id:I.id},(0,A.$xc)(this.g,f,[]).push(I),l?.isDefault&&this.h.push(I),this.c.fire({viewContainer:I,viewContainerLocation:f}),I}deregisterViewContainer(g){for(const f of this.g.keys()){const l=this.g.get(f),b=l?.indexOf(g);if(b!==-1){l?.splice(b,1),l.length===0&&this.g.delete(f),this.f.fire({viewContainer:g,viewContainerLocation:f});return}}}get(g){return this.all.filter(f=>f.id===g)[0]}getViewContainers(g){return[...this.g.get(g)||[]]}getViewContainerLocation(g){return[...this.g.keys()].filter(f=>this.getViewContainers(f).filter(l=>l?.id===g.id).length>0)[0]}getDefaultViewContainer(g){return this.h.find(f=>this.getViewContainerLocation(f)===g)}}M.$jo.add(v.ViewContainersRegistry,new d);var r;(function(i){i.Open="2_open",i.Debug="4_debug",i.SCM="5_scm",i.More="9_more"})(r||(e.ViewContentGroups=r={}));function o(i,g){const f=i.group??r.More,l=g.group??r.More;return f!==l?f.localeCompare(l):(i.order??5)-(g.order??5)}class a extends O.$Uc{constructor(){super(...arguments),this.c=this.B(new E.$he),this.onViewsRegistered=this.c.event,this.f=this.B(new E.$he),this.onViewsDeregistered=this.f.event,this.g=this.B(new E.$he),this.onDidChangeContainer=this.g.event,this.h=this.B(new E.$he),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Hc}registerViews(g,f){this.registerViews2([{views:g,viewContainer:f}])}registerViews2(g){g.forEach(({views:f,viewContainer:l})=>this.r(f,l)),this.c.fire(g)}deregisterViews(g,f){const l=this.s(g,f);l.length&&this.f.fire({views:l,viewContainer:f})}moveViews(g,f){for(const l of this.m.keys())if(l!==f){const b=this.s(g,l);b.length&&(this.r(b,f),this.g.fire({views:b,from:l,to:f}))}}getViews(g){return this.m.get(g)||[]}getView(g){for(const f of this.j){const l=(this.m.get(f)||[]).filter(b=>b.id===g)[0];if(l)return l}return null}getViewContainer(g){for(const f of this.j)if((this.m.get(f)||[]).filter(b=>b.id===g)[0])return f;return null}registerViewWelcomeContent(g,f){return this.n.add(g,f),this.h.fire(g),(0,O.$Sc)(()=>{this.n.delete(g,f),this.h.fire(g)})}registerViewWelcomeContent2(g,f){const l=new Map;for(const[b,I]of f)this.n.add(g,I),l.set(b,(0,O.$Sc)(()=>{this.n.delete(g,I),this.h.fire(g)}));return this.h.fire(g),l}getViewWelcomeContent(g){const f=[];return this.n.forEach(g,l=>f.push(l)),f.sort(o)}r(g,f){let l=this.m.get(f);l||(l=[],this.m.set(f,l),this.j.push(f));for(const b of g){if(this.getView(b.id)!==null)throw new Error((0,R.localize)(2,null,b.id));l.push(b)}}s(g,f){const l=this.m.get(f);if(!l)return[];const b=[],I=[];for(const S of l)g.includes(S)?b.push(S):I.push(S);return b.length&&(I.length?this.m.set(f,I):(this.m.delete(f),this.j.splice(this.j.indexOf(f),1))),b}}M.$jo.add(v.ViewsRegistry,new a),e.$bG=(0,P.$Ai)("viewDescriptorService");var h;(function(i){i[i.Default=0]="Default",i[i.Expand=1]="Expand"})(h||(e.ViewVisibilityState=h={}));var t;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(t||(e.TreeItemCollapsibleState=t={}));class s{constructor(g,f){this.c=!1,this.d=!1,(0,$.$_n)(this,g),this.d=!!f,this.resolve=async l=>{if(f&&!this.c){const b=await f(l);b&&(this.tooltip=this.tooltip??b.tooltip,this.command=this.command??b.command)}l.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$cG=s;class n extends Error{constructor(g){super((0,R.localize)(3,null,g)),this.name="NoTreeViewError"}static is(g){return g.name==="NoTreeViewError"}}e.$dG=n}),define(ke[232],Ie([1,0,194,32]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=void 0,e.$hG=new R.$Rj("chatSessionResponseVote","",{type:"string",description:(0,E.localize)(0,null)}),e.$iG=new R.$Rj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,E.localize)(1,null)}),e.$jG=new R.$Rj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,E.localize)(2,null)}),e.$kG=new R.$Rj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,E.localize)(3,null)}),e.$lG=new R.$Rj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,E.localize)(4,null)}),e.$mG=new R.$Rj("chatResponse",!1,{type:"boolean",description:(0,E.localize)(5,null)}),e.$nG=new R.$Rj("chatRequest",!1,{type:"boolean",description:(0,E.localize)(6,null)}),e.$oG=new R.$Rj("chatEditApplied",!1,{type:"boolean",description:(0,E.localize)(7,null)}),e.$pG=new R.$Rj("chatInputHasText",!1,{type:"boolean",description:(0,E.localize)(8,null)}),e.$qG=new R.$Rj("chatInputHasFocus",!1,{type:"boolean",description:(0,E.localize)(9,null)}),e.$rG=new R.$Rj("inChatInput",!1,{type:"boolean",description:(0,E.localize)(10,null)}),e.$sG=new R.$Rj("inChat",!1,{type:"boolean",description:(0,E.localize)(11,null)}),e.$tG=new R.$Rj("chatIsEnabled",!1,{type:"boolean",description:(0,E.localize)(12,null)}),e.$uG=new R.$Rj("chatCursorAtTop",!1),e.$vG=new R.$Rj("chatInputHasAgent",!1),e.$wG=new R.$Rj("chatLocation",void 0),e.$xG=new R.$Rj("quickChatHasFocus",!1,{type:"boolean",description:(0,E.localize)(13,null)})}),define(ke[233],Ie([1,0,324,11,22,4,40,6,49,140,13,32,19,3,12,107,215,226,232]),function(de,e,E,R,P,O,A,M,$,c,C,v,u,D,d,r,o,a,h){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$BH=e.$AH=e.$zH=e.$yH=e.$xH=e.ChatAgentLocation=void 0,e.$CH=f,e.$DH=l;var s;(function(b){b.Panel="panel",b.Terminal="terminal",b.Notebook="notebook",b.Editor="editor"})(s||(e.ChatAgentLocation=s={})),function(b){function I(S){switch(S){case"panel":return b.Panel;case"terminal":return b.Terminal;case"notebook":return b.Notebook;case"editor":return b.Editor}return b.Panel}b.fromRaw=I}(s||(e.ChatAgentLocation=s={})),e.$xH=(0,D.$Ai)("chatAgentService");let n=class{static{this.AGENT_LEADER="@"}constructor(I){this.f=I,this.b=new Map,this.d=new O.$he,this.onDidChangeAgents=this.d.event,this.g=new Map,this.e=h.$tG.bindTo(this.f)}registerAgent(I,S){if(this.getAgent(I))throw new Error(`Agent already registered: ${JSON.stringify(I)}`);const p=this,k=S.slashCommands;S={...S,get slashCommands(){return k.filter(w=>!w.when||p.f.contextMatchesRules(v.$yj.deserialize(w.when)))}};const m={data:S};return this.b.set(I,m),(0,M.$Sc)(()=>{this.b.delete(I),this.d.fire(void 0)})}registerAgentImplementation(I,S){const y=this.b.get(I);if(!y)throw new Error(`Unknown agent: ${JSON.stringify(I)}`);if(y.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(I)}`);return y.data.isDefault&&this.e.set(!0),y.impl=S,this.d.fire(new i(y.data,S)),(0,M.$Sc)(()=>{y.impl=void 0,this.d.fire(void 0),y.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(I,S){I.isDynamic=!0;const y={data:I,impl:S};return this.b.set(I.id,y),this.d.fire(new i(I,S)),(0,M.$Sc)(()=>{this.b.delete(I.id),this.d.fire(void 0)})}registerAgentCompletionProvider(I,S){return this.g.set(I,S),{dispose:()=>{this.g.delete(I)}}}async getAgentCompletionItems(I,S,y){return await this.g.get(I)?.(S,y)??[]}updateAgent(I,S){const y=this.b.get(I);if(!y?.impl)throw new Error(`No activated agent with id ${JSON.stringify(I)} registered`);y.data.metadata={...y.data.metadata,...S},this.d.fire(new i(y.data,y.impl))}getDefaultAgent(I){return(0,E.$fb)(this.getActivatedAgents(),S=>!!S.isDefault&&S.locations.includes(I))}getContributedDefaultAgent(I){return this.getAgents().find(S=>!!S.isDefault&&S.locations.includes(I))}getSecondaryAgent(){return A.Iterable.find(this.b.values(),I=>!!I.data.metadata.isSecondary)?.data}getAgent(I){if(this.h(I))return this.b.get(I)?.data}h(I){const S=this.b.get(I);return!S?.data.when||this.f.contextMatchesRules(v.$yj.deserialize(S.data.when))}getAgentByFullyQualifiedId(I){const S=A.Iterable.find(this.b.values(),y=>f(y.data)===I)?.data;if(!(S&&!this.h(S.id)))return S}getAgents(){return Array.from(this.b.values()).map(I=>I.data).filter(I=>this.h(I.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(I=>!!I.impl).filter(I=>this.h(I.data.id)).map(I=>new i(I.data,I.impl))}getAgentsByName(I){return this.getAgents().filter(S=>S.name===I)}async invokeAgent(I,S,y,p,k){const m=this.b.get(I);if(!m?.impl)throw new Error(`No activated agent with id "${I}"`);return await m.impl.invoke(S,y,p,k)}async getFollowups(I,S,y,p,k){const m=this.b.get(I);if(!m?.impl)throw new Error(`No activated agent with id "${I}"`);return m.impl?.provideFollowups?m.impl.provideFollowups(S,y,p,k):[]}};e.$yH=n,e.$yH=n=He([Ve(0,v.$Sj)],n);class i{constructor(I,S){this.b=I,this.d=S}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(I,S,y,p){return this.d.invoke(I,S,y,p)}async provideFollowups(I,S,y,p){return this.d.provideFollowups?this.d.provideFollowups(I,S,y,p):[]}provideWelcomeMessage(I,S){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(I,S)}provideSampleQuestions(I,S){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(I,S)}}e.$zH=i,e.$AH=(0,D.$Ai)("chatAgentNameService");let g=class{static{t=this}static{this.b="chat.participantNameRegistry"}constructor(I,S,y,p){if(this.g=S,this.h=y,this.i=p,this.e=(0,c.$3d)(this,Object.create(null)),this.f=!1,!I.chatParticipantRegistry)return;this.d=I.chatParticipantRegistry;const k=p.get(t.b,a.StorageScope.APPLICATION);try{this.e.set(JSON.parse(k??"{}"),void 0)}catch{p.remove(t.b,a.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(I=>this.h.warn("Failed to fetch chat participant registry",I)).then(()=>(0,R.$Bh)(5*60*1e3)).then(()=>this.j())}async k(){const I=await this.g.request({type:"GET",url:this.d},P.CancellationToken.None);if(I.res.statusCode!==200)throw new Error("Could not get extensions report.");const S=await(0,o.$2p)(I);if(!S||S.version!==1)throw new Error("Unexpected chat participant registry response.");const y=S.restrictedChatParticipants;this.e.set(y,void 0),this.i.store(t.b,JSON.stringify(y),a.StorageScope.APPLICATION,a.StorageTarget.MACHINE)}getAgentNameRestriction(I){const S=this.l(I.name,I).get(),y=!I.fullName||this.l(I.fullName.replace(/\s/g,""),I).get();return S&&y}l(I,S){return this.e.map(p=>p[I.toLowerCase()]).map(p=>p?p.some(k=>(0,C.$Bf)(k,k.includes(".")?S.extensionId.value:S.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$BH=g,e.$BH=g=t=He([Ve(0,r.$nk),Ve(1,o.$Vp),Ve(2,d.$7j),Ve(3,a.$9p)],g);function f(b){return`${b.extensionId.value}.${b.id}`}function l(b){const I="name"in b?b:{...b,name:b.id};return"extensionPublisherId"in I||(I.extensionPublisherId=I.extensionPublisher??""),"extensionDisplayName"in I||(I.extensionDisplayName=""),"extensionId"in I||(I.extensionId=new u.$Wm("")),(0,$.$0h)(I)}}),define(ke[234],Ie([1,0,2,33,3]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9G=e.$8G=e.ChatCopyKind=e.ChatAgentVoteDirection=void 0,e.$6G=O,e.$7G=A;function O(c){return!!c&&typeof c=="object"&&"uri"in c&&c.uri instanceof E.URI&&"version"in c&&typeof c.version=="number"&&"ranges"in c&&Array.isArray(c.ranges)&&c.ranges.every(R.$ct.isIRange)}function A(c){return!!c&&typeof c=="object"&&"documents"in c&&Array.isArray(c.documents)&&c.documents.every(O)}var M;(function(c){c[c.Down=0]="Down",c[c.Up=1]="Up"})(M||(e.ChatAgentVoteDirection=M={}));var $;(function(c){c[c.Action=1]="Action",c[c.Toolbar=2]="Toolbar"})($||(e.ChatCopyKind=$={})),e.$8G=(0,P.$Ai)("IChatService"),e.$9G="accessibility.voice.keywordActivation"}),define(ke[235],Ie([1,0,4,11,196]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fsb=void 0;class O{constructor(){this.f=new Map,this.m=[],this.n=new E.$he,this.o=new E.$he,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(M){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=M}onEvent(M){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=M}onRequest(M){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=M}sendResponse(M){M.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${M.command}`)):this.u("response",M)}sendRequest(M,$,c,C){const v={command:M};if($&&Object.keys($).length>0&&(v.arguments=$),this.u("request",v),typeof C=="number"){const u=setTimeout(()=>{clearTimeout(u);const D=this.f.get(v.seq);if(D){this.f.delete(v.seq);const d={type:"response",seq:0,request_seq:v.seq,success:!1,command:M,message:(0,P.localize)(0,null,C,M)};D(d)}},C)}return c&&this.f.set(v.seq,c),v.seq}acceptMessage(M){this.k?this.k(M):(this.m.push(M),this.m.length===1&&this.s())}q(M,$){return M.type!=="event"||$.type!=="event"}async s(){let M;for(;this.m.length;){if((!M||this.q(this.m[0],M))&&await(0,R.$Bh)(0),M=this.m.shift(),!M)return;switch(M.type){case"event":this.j?.(M);break;case"request":this.g?.(M);break;case"response":{const $=M,c=this.f.get($.request_seq);c&&(this.f.delete($.request_seq),c($));break}}}}u(M,$){$.type=M,$.seq=this.d++,this.sendMessage($)}async w(){if(this.f.size===0)return Promise.resolve();const M=new Map;this.f.forEach(($,c)=>M.set(c,$)),await(0,R.$Bh)(500),M.forEach(($,c)=>{$({type:"response",seq:0,request_seq:c,success:!1,command:"canceled",message:"canceled"}),this.f.delete(c)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$fsb=O}),define(ke[81],Ie([1,0,2,197,32,3]),function(de,e,E,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$TJ=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$RJ=e.MemoryRangeType=e.State=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=void 0,e.$QJ=$,e.$SJ=C,e.$EI="workbench.view.debug",e.$FI="workbench.debug.variablesView",e.$GI="workbench.debug.watchExpressionsView",e.$HI="workbench.debug.callStackView",e.$II="workbench.debug.loadedScriptsView",e.$JI="workbench.debug.breakPointsView",e.$KI="workbench.debug.disassemblyView",e.$LI="workbench.panel.repl",e.$MI="workbench.panel.repl.view",e.$NI=new P.$Rj("debugType",void 0,{type:"string",description:R.localize(0,null)}),e.$OI=new P.$Rj("debugConfigurationType",void 0,{type:"string",description:R.localize(1,null)}),e.$PI=new P.$Rj("debugState","inactive",{type:"string",description:R.localize(2,null)}),e.$QI="debugUx",e.$RI=new P.$Rj(e.$QI,"default",{type:"string",description:R.localize(3,null)}),e.$SI=new P.$Rj("hasDebugged",!1,{type:"boolean",description:R.localize(4,null)}),e.$TI=new P.$Rj("inDebugMode",!1,{type:"boolean",description:R.localize(5,null)}),e.$UI=new P.$Rj("inDebugRepl",!1,{type:"boolean",description:R.localize(6,null)}),e.$VI=new P.$Rj("breakpointWidgetVisible",!1,{type:"boolean",description:R.localize(7,null)}),e.$WI=new P.$Rj("inBreakpointWidget",!1,{type:"boolean",description:R.localize(8,null)}),e.$XI=new P.$Rj("breakpointsFocused",!0,{type:"boolean",description:R.localize(9,null)}),e.$YI=new P.$Rj("watchExpressionsFocused",!0,{type:"boolean",description:R.localize(10,null)}),e.$ZI=new P.$Rj("watchExpressionsExist",!1,{type:"boolean",description:R.localize(11,null)}),e.$1I=new P.$Rj("variablesFocused",!0,{type:"boolean",description:R.localize(12,null)}),e.$2I=new P.$Rj("expressionSelected",!1,{type:"boolean",description:R.localize(13,null)}),e.$3I=new P.$Rj("breakpointInputFocused",!1,{type:"boolean",description:R.localize(14,null)}),e.$4I=new P.$Rj("callStackItemType",void 0,{type:"string",description:R.localize(15,null)}),e.$5I=new P.$Rj("callStackSessionIsAttach",!1,{type:"boolean",description:R.localize(16,null)}),e.$6I=new P.$Rj("callStackItemStopped",!1,{type:"boolean",description:R.localize(17,null)}),e.$7I=new P.$Rj("callStackSessionHasOneThread",!1,{type:"boolean",description:R.localize(18,null)}),e.$8I=new P.$Rj("watchItemType",void 0,{type:"string",description:R.localize(19,null)}),e.$9I=new P.$Rj("canViewMemory",void 0,{type:"boolean",description:R.localize(20,null)}),e.$0I=new P.$Rj("breakpointItemType",void 0,{type:"string",description:R.localize(21,null)}),e.$$I=new P.$Rj("breakpointItemBytes",void 0,{type:"boolean",description:R.localize(22,null)}),e.$_I=new P.$Rj("breakpointHasModes",!1,{type:"boolean",description:R.localize(23,null)}),e.$aJ=new P.$Rj("breakpointSupportsCondition",!1,{type:"boolean",description:R.localize(24,null)}),e.$bJ=new P.$Rj("loadedScriptsSupported",!1,{type:"boolean",description:R.localize(25,null)}),e.$cJ=new P.$Rj("loadedScriptsItemType",void 0,{type:"string",description:R.localize(26,null)}),e.$dJ=new P.$Rj("focusedSessionIsAttach",!1,{type:"boolean",description:R.localize(27,null)}),e.$eJ=new P.$Rj("focusedSessionIsNoDebug",!1,{type:"boolean",description:R.localize(28,null)}),e.$fJ=new P.$Rj("stepBackSupported",!1,{type:"boolean",description:R.localize(29,null)}),e.$gJ=new P.$Rj("restartFrameSupported",!1,{type:"boolean",description:R.localize(30,null)}),e.$hJ=new P.$Rj("stackFrameSupportsRestart",!1,{type:"boolean",description:R.localize(31,null)}),e.$iJ=new P.$Rj("jumpToCursorSupported",!1,{type:"boolean",description:R.localize(32,null)}),e.$jJ=new P.$Rj("stepIntoTargetsSupported",!1,{type:"boolean",description:R.localize(33,null)}),e.$kJ=new P.$Rj("breakpointsExist",!1,{type:"boolean",description:R.localize(34,null)}),e.$lJ=new P.$Rj("debuggersAvailable",!1,{type:"boolean",description:R.localize(35,null)}),e.$mJ=new P.$Rj("debugExtensionAvailable",!0,{type:"boolean",description:R.localize(36,null)}),e.$nJ=new P.$Rj("debugProtocolVariableMenuContext",void 0,{type:"string",description:R.localize(37,null)}),e.$oJ=new P.$Rj("debugSetVariableSupported",!1,{type:"boolean",description:R.localize(38,null)}),e.$pJ=new P.$Rj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:R.localize(39,null)}),e.$qJ=new P.$Rj("debugSetExpressionSupported",!1,{type:"boolean",description:R.localize(40,null)}),e.$rJ=new P.$Rj("breakWhenValueChangesSupported",!1,{type:"boolean",description:R.localize(41,null)}),e.$sJ=new P.$Rj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:R.localize(42,null)}),e.$tJ=new P.$Rj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:R.localize(43,null)}),e.$uJ=new P.$Rj("terminateDebuggeeSupported",!1,{type:"boolean",description:R.localize(44,null)}),e.$vJ=new P.$Rj("suspendDebuggeeSupported",!1,{type:"boolean",description:R.localize(45,null)}),e.$wJ=new P.$Rj("variableEvaluateNamePresent",!1,{type:"boolean",description:R.localize(46,null)}),e.$xJ=new P.$Rj("variableIsReadonly",!1,{type:"boolean",description:R.localize(47,null)}),e.$yJ=new P.$Rj("variableValue",!1,{type:"string",description:R.localize(48,null)}),e.$zJ=new P.$Rj("variableType",!1,{type:"string",description:R.localize(49,null)}),e.$AJ=new P.$Rj("variableInterfaces",!1,{type:"array",description:R.localize(50,null)}),e.$BJ=new P.$Rj("variableName",!1,{type:"string",description:R.localize(51,null)}),e.$CJ=new P.$Rj("variableLanguage",!1,{type:"string",description:R.localize(52,null)}),e.$DJ=new P.$Rj("variableExtensionId",!1,{type:"string",description:R.localize(53,null)}),e.$EJ=new P.$Rj("exceptionWidgetVisible",!1,{type:"boolean",description:R.localize(54,null)}),e.$FJ=new P.$Rj("multiSessionRepl",!1,{type:"boolean",description:R.localize(55,null)}),e.$GJ=new P.$Rj("multiSessionDebug",!1,{type:"boolean",description:R.localize(56,null)}),e.$HJ=new P.$Rj("disassembleRequestSupported",!1,{type:"boolean",description:R.localize(57,null)}),e.$IJ=new P.$Rj("disassemblyViewFocus",!1,{type:"boolean",description:R.localize(58,null)}),e.$JJ=new P.$Rj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:R.localize(59,null)}),e.$KJ=new P.$Rj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:R.localize(60,null)});const A=t=>R.localize(61,null,t);e.$LJ=A,e.$MJ="editor.contrib.debug",e.$NJ="editor.contrib.breakpoint",e.$OJ="debug",e.$PJ={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:R.localize(62,null)};var M;(function(t){t[t.Inactive=0]="Inactive",t[t.Initializing=1]="Initializing",t[t.Stopped=2]="Stopped",t[t.Running=3]="Running"})(M||(e.State=M={}));function $(t){switch(t){case M.Initializing:return"initializing";case M.Stopped:return"stopped";case M.Running:return"running";default:return"inactive"}}var c;(function(t){t[t.Valid=0]="Valid",t[t.Unreadable=1]="Unreadable",t[t.Error=2]="Error"})(c||(e.MemoryRangeType=c={})),e.$RJ="vscode-debug-memory";function C(t){return t.source.presentationHint==="deemphasize"||t.presentationHint==="deemphasize"||t.presentationHint==="subtle"}var v;(function(t){t[t.Variable=0]="Variable",t[t.Address=1]="Address"})(v||(e.DataBreakpointSetType=v={}));var u;(function(t){t[t.Initial=1]="Initial",t[t.Dynamic=2]="Dynamic"})(u||(e.DebugConfigurationProviderTriggerKind=u={}));var D;(function(t){t.UnverifiedBreakpoints="unverifiedBreakpoints"})(D||(e.DebuggerString=D={})),e.$TJ=(0,O.$Ai)("debugService");var d;(function(t){t[t.CONDITION=0]="CONDITION",t[t.HIT_COUNT=1]="HIT_COUNT",t[t.LOG_MESSAGE=2]="LOG_MESSAGE",t[t.TRIGGER_POINT=3]="TRIGGER_POINT"})(d||(e.BreakpointWidgetContext=d={}));var r;(function(t){t[t.Command=0]="Command",t[t.Tree=1]="Tree"})(r||(e.DebugVisualizationType=r={}));var o;(function(t){t[t.None=0]="None",t[t.Collapsed=1]="Collapsed",t[t.Expanded=2]="Expanded"})(o||(e.DebugTreeItemCollapsibleState=o={}));var a;(function(t){t.deserialize=s=>s,t.serialize=s=>s})(a||(e.IDebugVisualizationTreeItem=a={}));var h;(function(t){t.deserialize=s=>({id:s.id,name:s.name,iconPath:s.iconPath&&{light:E.URI.revive(s.iconPath.light),dark:E.URI.revive(s.iconPath.dark)},iconClass:s.iconClass,visualization:s.visualization}),t.serialize=s=>s})(h||(e.IDebugVisualization=h={}))}),define(ke[236],Ie([1,0,13,2,20,26,16,33,22,18]),function(de,e,E,R,P,O,A,M,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SH=void 0,e.$GH=v,e.$HH=u,e.$IH=D,e.$JH=d,e.$KH=r,e.$LH=o,e.$MH=a,e.$NH=t,e.$OH=i,e.$PH=g,e.$QH=l,e.$RH=I;const C=/{([^}]+)}/g;function v(y,p,k){return y.replace(C,function(m,w){return p&&w.length>0&&w[0]!=="_"?m:k&&k.hasOwnProperty(w)?k[w]:m})}function u(y){const p={};for(const k of Object.keys(y))k.startsWith("!")||(p[k]=y[k]);return p}function D(y){return y.configuration.request==="attach"&&!d(y)&&(!y.parentSession||D(y.parentSession))}function d(y){let p=y.configuration.type;if(p)return p==="vslsShare"&&(p=y.configuration.adapterProxy.configuration.type),(0,E.$Bf)(p,"extensionhost")||(0,E.$Bf)(p,"pwa-extensionhost")?y:y.parentSession?d(y.parentSession):void 0}function r(y){return y.type&&(y.label||y.program||y.runtime)}function o(y,p,k){let m,w=0;const F=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let T=null;for(;T=F.exec(y);){const G=T.index+1,q=G+T[0].length;if(G<=p&&q>=k){m=T[0],w=G;break}}if(m){const G=/\w+/g;let q=null;for(;(q=G.exec(m))&&!(q.index+1+w+q[0].length>=k););q&&(m=m.substring(0,G.lastIndex))}return m?{start:w,end:w+m.length-1}:{start:0,end:0}}async function a(y,p,k,m){if(y.evaluatableExpressionProvider.has(p)){const w=y.evaluatableExpressionProvider.ordered(p),F=(0,c.$Hb)(await Promise.all(w.map(async T=>{try{return await T.provideEvaluatableExpression(p,k,m??$.CancellationToken.None)}catch{return}})));if(F.length>0){let T=F[0].expression;const G=F[0].range;return T||(T=p.getLineContent(k.lineNumber).substring(G.startColumn-1,G.endColumn-1)),{range:G,matchingExpression:T}}}else{const w=p.getLineContent(k.lineNumber),{start:F,end:T}=o(w,k.column,k.column),G=w.substring(F-1,T);return{matchingExpression:G,range:new M.$ct(k.lineNumber,F,k.lineNumber,F+G.length)}}return null}const h=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function t(y){return!!(y&&y.match(h))}function s(y){if(typeof y.path=="string"&&!(typeof y.sourceReference=="number"&&y.sourceReference>0)){if(t(y.path))return R.URI.parse(y.path);if((0,P.$ic)(y.path))return R.URI.file(y.path)}return y.path}function n(y){if(typeof y.path=="object"){const p=R.URI.revive(y.path);if(p)return p.scheme===A.Schemas.file?p.fsPath:p.toString()}return y.path}function i(y,p){const k=p?s:n,m=(0,O.$9n)(y);return f(m,(w,F)=>{w&&F&&(F.path=k(F))}),m}function g(y,p){const k=p?s:n,m=(0,O.$9n)(y);return f(m,(w,F)=>{!w&&F&&(F.path=k(F))}),m}function f(y,p){switch(y.type){case"event":{const k=y;switch(k.event){case"output":p(!1,k.body.source);break;case"loadedSource":p(!1,k.body.source);break;case"breakpoint":p(!1,k.body.breakpoint.source);break;default:break}break}case"request":{const k=y;switch(k.command){case"setBreakpoints":p(!0,k.arguments.source);break;case"breakpointLocations":p(!0,k.arguments.source);break;case"source":p(!0,k.arguments.source);break;case"gotoTargets":p(!0,k.arguments.source);break;case"launchVSCode":k.arguments.args.forEach(m=>p(!1,m));break;default:break}break}case"response":{const k=y;if(k.success&&k.body)switch(k.command){case"stackTrace":k.body.stackFrames.forEach(m=>p(!1,m.source));break;case"loadedSources":k.body.sources.forEach(m=>p(!1,m));break;case"scopes":k.body.scopes.forEach(m=>p(!1,m.source));break;case"setFunctionBreakpoints":k.body.breakpoints.forEach(m=>p(!1,m.source));break;case"setBreakpoints":k.body.breakpoints.forEach(m=>p(!1,m.source));break;case"disassemble":k.body?.instructions.forEach(w=>p(!1,w.location));break;default:break}break}}}function l(y){return y.filter(p=>!p.presentation?.hidden).sort((p,k)=>p.presentation?k.presentation?p.presentation.group?k.presentation.group?p.presentation.group!==k.presentation.group?p.presentation.group.localeCompare(k.presentation.group):b(p.presentation.order,k.presentation.order):-1:k.presentation.group?1:b(p.presentation.order,k.presentation.order):-1:k.presentation?1:0)}function b(y,p){return typeof y!="number"?typeof p!="number"?0:1:typeof p!="number"?-1:y-p}async function I(y,p){const k=y.getValue("debug.saveBeforeStart",{overrideIdentifier:p.activeTextEditorLanguageId});if(k!=="none"&&(await p.saveAll(),k==="allEditorsInActiveGroup")){const m=p.activeEditorPane;m&&m.input.resource?.scheme===A.Schemas.untitled&&await p.save({editor:m.input,groupId:m.group.id})}await y.reloadConfiguration()}const S=(y,p)=>!y||!p?y===p:y.name===p.name&&y.path===p.path&&y.sourceReference===p.sourceReference;e.$SH=S}),define(ke[237],Ie([1,0,3]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_J=e.CellExecutionUpdateType=void 0;var R;(function(P){P[P.Output=1]="Output",P[P.OutputItems=2]="OutputItems",P[P.ExecutionState=3]="ExecutionState"})(R||(e.CellExecutionUpdateType=R={})),e.$_J=(0,E.$Ai)("INotebookExecutionService")}),define(ke[238],Ie([1,0,3]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ujb=e.$tjb=e.ProxyKernelState=e.$sjb=void 0,e.$sjb=100;var R;(function(P){P[P.Disconnected=1]="Disconnected",P[P.Connected=2]="Connected",P[P.Initializing=3]="Initializing"})(R||(e.ProxyKernelState=R={})),e.$tjb=(0,E.$Ai)("INotebookKernelService"),e.$ujb=(0,E.$Ai)("INotebookKernelHistoryService")}),define(ke[239],Ie([1,0,6,33,52,165,101]),function(de,e,E,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0Xb=void 0;class M extends E.$Uc{constructor(c,C,v){super(),this._source=c,this.b=C,this.c=v,this.a=void 0}f(c){const C=c.getLineCount();return new R.$ct(1,1,C,this.g(c,C))}g(c,C){if(C<1||C>c.getLineCount())throw new Error("Illegal value for lineNumber");return c.getLineLength(C)+1}get inputTextBuffer(){if(!this.b){const c=new O.$aD;c.acceptChunk(this._source);const C=c.finish(!0),{textBuffer:v,disposable:u}=C.create(P.DefaultEndOfLine.LF);this.b=v,this.B(u)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(c=>{const C=new O.$aD;C.acceptChunk(c);const v=C.finish(!0),{textBuffer:u,disposable:D}=v.create(P.DefaultEndOfLine.LF);return this.B(D),u})),this.a}findInInputs(c){const v=new A.$1C(c,!1,!1,null).parseSearchRequest();if(!v)return[];const u=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(u,v,!0,5e3)}findInOutputs(c){const v=new A.$1C(c,!1,!1,null).parseSearchRequest();return v?this.outputTextBuffers.map(u=>{const D=u.findMatchesLineByLine(this.f(u),v,!0,5e3);if(D.length!==0)return{textBuffer:u,matches:D}}).filter(u=>!!u):[]}}e.$0Xb=M}),define(ke[55],Ie([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gL=e.TestPosition=e.TestIdPathParts=void 0;var E;(function(O){O.Delimiter="\0"})(E||(e.TestIdPathParts=E={}));var R;(function(O){O[O.IsSame=0]="IsSame",O[O.Disconnected=1]="Disconnected",O[O.IsChild=2]="IsChild",O[O.IsParent=3]="IsParent"})(R||(e.TestPosition=R={}));class P{static fromExtHostTestItem(A,M,$=A.parent){if(A._isRoot)return new P([M]);const c=[A.id];for(let C=$;C&&C.id!==M;C=C.parent)c.push(C.id);return c.push(M),new P(c.reverse())}static isRoot(A){return!A.includes(E.Delimiter)}static root(A){const M=A.indexOf(E.Delimiter);return M===-1?A:A.slice(0,M)}static fromString(A){return new P(A.split(E.Delimiter))}static join(A,M){return new P([...A.path,M])}static joinToString(A,M){return A.toString()+E.Delimiter+M}static parentId(A){const M=A.lastIndexOf(E.Delimiter);return M===-1?void 0:A.slice(0,M)}static localId(A){const M=A.lastIndexOf(E.Delimiter);return M===-1?A:A.slice(M+E.Delimiter.length)}static isChild(A,M){return M.startsWith(A)&&M[A.length]===E.Delimiter}static compare(A,M){return A===M?R.IsSame:P.isChild(A,M)?R.IsChild:P.isChild(M,A)?R.IsParent:R.Disconnected}static getLengthOfCommonPrefix(A,M){if(A===0)return 0;let $=0;for(;$<A-1;){for(let c=1;c<A;c++){const C=M(c-1),v=M(c);if(C.path[$]!==v.path[$])return $}$++}return $}constructor(A,M=A.length){if(this.path=A,this.d=M,A.length===0||M<1)throw new Error("cannot create test with empty path")}get rootId(){return new P(this.path,1)}get parentId(){return this.d>1?new P(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new P(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new P(this.path,A)}compare(A){if(typeof A=="string")return P.compare(this.toString(),A);for(let M=0;M<A.d&&M<this.d;M++)if(A.path[M]!==this.path[M])return R.Disconnected;return A.d>this.d?R.IsChild:A.d<this.d?R.IsParent:R.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+=E.Delimiter,this.c+=this.path[A]}return this.c}}e.$gL=P}),define(ke[56],Ie([1,0,2,100,33,55]),function(de,e,E,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$oL=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$nL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$mL=e.$lL=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$kL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$jL=e.$iL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$hL=e.TestResultState=void 0;var A;(function(V){V[V.Unset=0]="Unset",V[V.Queued=1]="Queued",V[V.Running=2]="Running",V[V.Passed=3]="Passed",V[V.Failed=4]="Failed",V[V.Skipped=5]="Skipped",V[V.Errored=6]="Errored"})(A||(e.TestResultState=A={})),e.$hL={[A.Unset]:"unset",[A.Queued]:"queued",[A.Running]:"running",[A.Passed]:"passed",[A.Failed]:"failed",[A.Skipped]:"skipped",[A.Errored]:"errored"};var M;(function(V){V[V.Run=1]="Run",V[V.Debug=2]="Debug",V[V.Coverage=3]="Coverage"})(M||(e.ExtTestRunProfileKind=M={}));var $;(function(V){V[V.Run=2]="Run",V[V.Debug=4]="Debug",V[V.Coverage=8]="Coverage",V[V.HasNonDefaultProfile=16]="HasNonDefaultProfile",V[V.HasConfigurable=32]="HasConfigurable",V[V.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$iL=[$.Run,$.Debug,$.Coverage,$.HasNonDefaultProfile,$.HasConfigurable,$.SupportsContinuousRun];const c=V=>"runId"in V;e.$jL=c;var C;(function(V){V.serialize=N=>({range:N.range.toJSON(),uri:N.uri.toJSON()}),V.deserialize=(N,L)=>({range:P.$ct.lift(L.range),uri:N.asCanonicalUri(E.URI.revive(L.uri))})})(C||(e.IRichLocation=C={}));var v;(function(V){V[V.Error=0]="Error",V[V.Output=1]="Output"})(v||(e.TestMessageType=v={}));var u;(function(V){V.serialize=N=>({message:N.message,type:v.Error,expected:N.expected,actual:N.actual,contextValue:N.contextValue,location:N.location&&C.serialize(N.location)}),V.deserialize=(N,L)=>({message:L.message,type:v.Error,expected:L.expected,actual:L.actual,contextValue:L.contextValue,location:L.location&&C.deserialize(N,L.location)})})(u||(e.ITestErrorMessage=u={}));const D=(V,N)=>`${N?"s":"e"}${V}`;e.$kL=D;var d;(function(V){V.serialize=N=>({message:N.message,type:v.Output,offset:N.offset,length:N.length,location:N.location&&C.serialize(N.location)}),V.deserialize=(N,L)=>({message:L.message,type:v.Output,offset:L.offset,length:L.length,location:L.location&&C.deserialize(N,L.location)})})(d||(e.ITestOutputMessage=d={}));var r;(function(V){V.serialize=N=>N.type===v.Error?u.serialize(N):d.serialize(N),V.deserialize=(N,L)=>L.type===v.Error?u.deserialize(N,L):d.deserialize(N,L)})(r||(e.ITestMessage=r={}));var o;(function(V){V.serializeWithoutMessages=N=>({state:N.state,duration:N.duration,messages:[]}),V.serialize=N=>({state:N.state,duration:N.duration,messages:N.messages.map(r.serialize)}),V.deserialize=(N,L)=>({state:L.state,duration:L.duration,messages:L.messages.map(Z=>r.deserialize(N,Z))})})(o||(e.ITestTaskState=o={}));const a="\0",h=(V,N)=>V+a+N;e.$lL=h;const t=V=>{const N=V.indexOf(a);return{ctrlId:V.slice(0,N),tagId:V.slice(N+1)}};e.$mL=t;var s;(function(V){V.serialize=N=>({extId:N.extId,label:N.label,tags:N.tags,busy:N.busy,children:void 0,uri:N.uri?.toJSON(),range:N.range?.toJSON()||null,description:N.description,error:N.error,sortText:N.sortText}),V.deserialize=(N,L)=>({extId:L.extId,label:L.label,tags:L.tags,busy:L.busy,children:void 0,uri:L.uri?N.asCanonicalUri(E.URI.revive(L.uri)):void 0,range:L.range?P.$ct.lift(L.range):null,description:L.description,error:L.error,sortText:L.sortText})})(s||(e.ITestItem=s={}));var n;(function(V){V[V.NotExpandable=0]="NotExpandable",V[V.Expandable=1]="Expandable",V[V.BusyExpanding=2]="BusyExpanding",V[V.Expanded=3]="Expanded"})(n||(e.TestItemExpandState=n={}));var i;(function(V){V.serialize=N=>({expand:N.expand,item:s.serialize(N.item)}),V.deserialize=(N,L)=>({controllerId:O.$gL.root(L.item.extId),expand:L.expand,item:s.deserialize(N,L.item)})})(i||(e.InternalTestItem=i={}));var g;(function(V){V.serialize=N=>{let L;return N.item&&(L={},N.item.label!==void 0&&(L.label=N.item.label),N.item.tags!==void 0&&(L.tags=N.item.tags),N.item.busy!==void 0&&(L.busy=N.item.busy),N.item.uri!==void 0&&(L.uri=N.item.uri?.toJSON()),N.item.range!==void 0&&(L.range=N.item.range?.toJSON()),N.item.description!==void 0&&(L.description=N.item.description),N.item.error!==void 0&&(L.error=N.item.error),N.item.sortText!==void 0&&(L.sortText=N.item.sortText)),{extId:N.extId,expand:N.expand,item:L}},V.deserialize=N=>{let L;return N.item&&(L={},N.item.label!==void 0&&(L.label=N.item.label),N.item.tags!==void 0&&(L.tags=N.item.tags),N.item.busy!==void 0&&(L.busy=N.item.busy),N.item.range!==void 0&&(L.range=N.item.range?P.$ct.lift(N.item.range):null),N.item.description!==void 0&&(L.description=N.item.description),N.item.error!==void 0&&(L.error=N.item.error),N.item.sortText!==void 0&&(L.sortText=N.item.sortText)),{extId:N.extId,expand:N.expand,item:L}}})(g||(e.ITestItemUpdate=g={}));const f=(V,N)=>{N.expand!==void 0&&(V.expand=N.expand),N.item!==void 0&&(V.item=V.item?Object.assign(V.item,N.item):N.item)};e.$nL=f;var l;(function(V){V.serializeWithoutMessages=N=>({...i.serialize(N),ownComputedState:N.ownComputedState,computedState:N.computedState,tasks:N.tasks.map(o.serializeWithoutMessages)}),V.serialize=N=>({...i.serialize(N),ownComputedState:N.ownComputedState,computedState:N.computedState,tasks:N.tasks.map(o.serialize)}),V.deserialize=(N,L)=>({...i.deserialize(N,L),ownComputedState:L.ownComputedState,computedState:L.computedState,tasks:L.tasks.map(Z=>o.deserialize(N,Z)),retired:!0})})(l||(e.TestResultItem=l={}));var b;(function(V){V.empty=()=>({covered:0,total:0}),V.sum=(N,L)=>{N.covered+=L.covered,N.total+=L.total}})(b||(e.ICoverageCount=b={}));var I;(function(V){V.serialize=N=>({id:N.id,statement:N.statement,branch:N.branch,declaration:N.declaration,testId:N.testId?.toString(),uri:N.uri.toJSON()}),V.deserialize=(N,L)=>({id:L.id,statement:L.statement,branch:L.branch,declaration:L.declaration,testId:L.testId?O.$gL.fromString(L.testId):void 0,uri:N.asCanonicalUri(E.URI.revive(L.uri))}),V.empty=(N,L)=>({id:N,uri:L,testId:void 0,statement:b.empty()})})(I||(e.IFileCoverage=I={}));function S(V){return{...V,location:V.location?.toJSON()}}function y(V){return V.location=V.location?R.$bt.isIPosition(V.location)?R.$bt.lift(V.location):P.$ct.lift(V.location):void 0,V}e.$oL=3;var p;(function(V){V[V.Declaration=0]="Declaration",V[V.Statement=1]="Statement",V[V.Branch=2]="Branch"})(p||(e.DetailType=p={}));var k;(function(V){V.serialize=N=>N.type===p.Declaration?w.serialize(N):F.serialize(N),V.deserialize=N=>N.type===p.Declaration?w.deserialize(N):F.deserialize(N)})(k||(e.CoverageDetails=k={}));var m;(function(V){V.serialize=S,V.deserialize=y})(m||(e.IBranchCoverage=m={}));var w;(function(V){V.serialize=S,V.deserialize=y})(w||(e.IDeclarationCoverage=w={}));var F;(function(V){V.serialize=N=>({...S(N),branches:N.branches?.map(m.serialize)}),V.deserialize=N=>({...y(N),branches:N.branches?.map(m.deserialize)})})(F||(e.IStatementCoverage=F={}));var T;(function(V){V[V.Add=0]="Add",V[V.Update=1]="Update",V[V.DocumentSynced=2]="DocumentSynced",V[V.Remove=3]="Remove",V[V.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",V[V.Retire=5]="Retire",V[V.AddTag=6]="AddTag",V[V.RemoveTag=7]="RemoveTag"})(T||(e.TestDiffOpType=T={}));var G;(function(V){V.deserialize=(N,L)=>L.op===T.Add?{op:L.op,item:i.deserialize(N,L.item)}:L.op===T.Update?{op:L.op,item:g.deserialize(L.item)}:L.op===T.DocumentSynced?{op:L.op,uri:N.asCanonicalUri(E.URI.revive(L.uri)),docv:L.docv}:L,V.serialize=N=>N.op===T.Add?{op:N.op,item:i.serialize(N.item)}:N.op===T.Update?{op:N.op,item:g.serialize(N.item)}:N})(G||(e.TestsDiffOp=G={}));class q{constructor(N){this.k=N,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(N){const L=this.w();for(const Z of N)switch(Z.op){case T.Add:this.l(i.deserialize(this.k,Z.item),L);break;case T.Update:this.p(g.deserialize(Z.item),L);break;case T.Remove:this.q(Z.itemId,L);break;case T.Retire:this.v(Z.itemId);break;case T.IncrementPendingExtHosts:this.updatePendingRoots(Z.amount);break;case T.AddTag:this.c.set(Z.tag.id,Z.tag);break;case T.RemoveTag:this.c.delete(Z.id);break}L.complete?.()}l(N,L){const Z=O.$gL.parentId(N.item.extId)?.toString();let re;if(!Z)re=this.x(N),this.g.add(re),this.f.set(N.item.extId,re);else if(this.f.has(Z)){const fe=this.f.get(Z);fe.children.add(N.item.extId),re=this.x(N,fe),this.f.set(N.item.extId,re)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(N)}`);return}return L.add?.(re),N.expand===n.BusyExpanding&&this.h++,re}p(N,L){const Z=this.f.get(N.extId);if(Z)return N.expand!==void 0&&(Z.expand===n.BusyExpanding&&this.h--,N.expand===n.BusyExpanding&&this.h++),(0,e.$nL)(Z,N),L.update?.(Z),Z}q(N,L){const Z=this.f.get(N);if(!Z)return;const re=O.$gL.parentId(Z.item.extId)?.toString();re?this.f.get(re).children.delete(Z.item.extId):this.g.delete(Z);const fe=[[N]];for(;fe.length;)for(const be of fe.pop()){const oe=this.f.get(be);oe&&(fe.push(oe.children),this.f.delete(be),L.remove?.(oe,oe!==Z),oe.expand===n.BusyExpanding&&this.h--)}}v(N){}updatePendingRoots(N){this.j+=N}w(){return{}}}e.$pL=q}),define(ke[240],Ie([1,0,98,200,56]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.$_Eb=e.$$Eb=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var O;(function(v){v.ViewletId="workbench.view.extension.test",v.ExplorerViewId="workbench.view.testing",v.OutputPeekContributionId="editor.contrib.testingOutputPeek",v.DecorationsContributionId="editor.contrib.testingDecorations",v.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",v.CoverageViewId="workbench.view.testCoverage",v.ResultsPanelId="workbench.panel.testResults",v.ResultsViewId="workbench.panel.testResults.view",v.MessageLanguageId="vscodeInternalTestMessage"})(O||(e.Testing=O={}));var A;(function(v){v.List="list",v.Tree="true"})(A||(e.TestExplorerViewMode=A={}));var M;(function(v){v.ByLocation="location",v.ByStatus="status",v.ByDuration="duration"})(M||(e.TestExplorerViewSorting=M={}));const $={[P.TestResultState.Errored]:(0,R.localize)(0,null),[P.TestResultState.Failed]:(0,R.localize)(1,null),[P.TestResultState.Passed]:(0,R.localize)(2,null),[P.TestResultState.Queued]:(0,R.localize)(3,null),[P.TestResultState.Running]:(0,R.localize)(4,null),[P.TestResultState.Skipped]:(0,R.localize)(5,null),[P.TestResultState.Unset]:(0,R.localize)(6,null)},c=(v,u)=>(0,R.localize)(7,null,(0,E.$Tk)(v),$[u]);e.$$Eb=c,e.$_Eb={[P.TestRunProfileBitset.Debug]:(0,R.localize)(8,null),[P.TestRunProfileBitset.Run]:(0,R.localize)(9,null),[P.TestRunProfileBitset.Coverage]:(0,R.localize)(10,null)};var C;(function(v){v.CancelTestRefreshAction="testing.cancelTestRefresh",v.CancelTestRunAction="testing.cancelRun",v.ClearTestResultsAction="testing.clearTestResults",v.CollapseAllAction="testing.collapseAll",v.ConfigureTestProfilesAction="testing.configureProfile",v.ContinousRunUsingForTest="testing.continuousRunUsingForTest",v.CoverageAtCursor="testing.coverageAtCursor",v.CoverageByUri="testing.coverage.uri",v.CoverageClear="testing.coverage.close",v.CoverageCurrentFile="testing.coverageCurrentFile",v.CoverageFilterToTest="testing.coverageFilterToTest",v.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",v.CoverageLastRun="testing.coverageLastRun",v.CoverageSelectedAction="testing.coverageSelected",v.CoverageToggleToolbar="testing.coverageToggleToolbar",v.CoverageViewChangeSorting="testing.coverageViewChangeSorting",v.DebugAction="testing.debug",v.DebugAllAction="testing.debugAll",v.DebugAtCursor="testing.debugAtCursor",v.DebugByUri="testing.debug.uri",v.DebugCurrentFile="testing.debugCurrentFile",v.DebugFailedTests="testing.debugFailTests",v.DebugLastRun="testing.debugLastRun",v.DebugSelectedAction="testing.debugSelected",v.FilterAction="workbench.actions.treeView.testExplorer.filter",v.GetExplorerSelection="_testing.getExplorerSelection",v.GetSelectedProfiles="testing.getSelectedProfiles",v.GoToTest="testing.editFocusedTest",v.HideTestAction="testing.hideTest",v.OpenCoverage="testing.openCoverage",v.OpenOutputPeek="testing.openOutputPeek",v.RefreshTestsAction="testing.refreshTests",v.ReRunFailedTests="testing.reRunFailTests",v.ReRunLastRun="testing.reRunLastRun",v.RunAction="testing.run",v.RunAllAction="testing.runAll",v.RunAllWithCoverageAction="testing.coverageAll",v.RunAtCursor="testing.runAtCursor",v.RunByUri="testing.run.uri",v.RunCurrentFile="testing.runCurrentFile",v.RunSelectedAction="testing.runSelected",v.RunUsingProfileAction="testing.runUsing",v.RunWithCoverageAction="testing.coverage",v.SearchForTestExtension="testing.searchForTestExtension",v.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",v.ShowMostRecentOutputAction="testing.showMostRecentOutput",v.StartContinousRun="testing.startContinuousRun",v.StopContinousRun="testing.stopContinuousRun",v.TestingSortByDurationAction="testing.sortByDuration",v.TestingSortByLocationAction="testing.sortByLocation",v.TestingSortByStatusAction="testing.sortByStatus",v.TestingViewAsListAction="testing.viewAsList",v.TestingViewAsTreeAction="testing.viewAsTree",v.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",v.ToggleInlineTestOutput="testing.toggleInlineTestOutput",v.UnhideAllTestsAction="testing.unhideAllTests",v.UnhideTestAction="testing.unhideTest"})(C||(e.TestCommandId=C={}))}),define(ke[82],Ie([1,0,11,4,6,61,56,55]),function(de,e,E,R,P,O,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SO=e.$RO=e.$QO=e.$PO=e.$OO=e.TestItemEventOp=void 0;var $;(function(h){h[h.Upsert=0]="Upsert",h[h.SetTags=1]="SetTags",h[h.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",h[h.RemoveChild=3]="RemoveChild",h[h.SetProp=4]="SetProp",h[h.Bulk=5]="Bulk",h[h.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const c=(h,t)=>h===t,v=Object.entries({range:(h,t)=>h===t?!0:!h||!t?!1:h.equalsRange(t),busy:c,label:c,description:c,error:c,sortText:c,tags:(h,t)=>!(h.length!==t.length||h.some(s=>!t.includes(s)))}),u=(h,t)=>{let s;for(const[n,i]of v)i(h[n],t[n])||(s?s[n]=t[n]:s={[n]:t[n]});return s};class D extends P.$Uc{get root(){return this.s.root}constructor(t){super(),this.s=t,this.f=this.B(new E.$Mh(()=>this.flushDiff(),200)),this.g=this.B(new R.$he),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(t){this.h=t;for(const s of this.tree.values())this.J(s)}get resolveHandler(){return this.h}collectDiff(){const t=this.m;return this.m=[],t}pushDiff(t){switch(t.op){case A.TestDiffOpType.DocumentSynced:{for(const s of this.m)if(s.op===A.TestDiffOpType.DocumentSynced&&s.uri===t.uri){s.docv=t.docv;return}break}case A.TestDiffOpType.Update:{const s=this.m[this.m.length-1];if(s){if(s.op===A.TestDiffOpType.Update&&s.item.extId===t.item.extId){(0,A.$nL)(s.item,t.item);return}if(s.op===A.TestDiffOpType.Add&&s.item.item.extId===t.item.extId){(0,A.$nL)(s.item,t.item);return}}break}}this.m.push(t),this.f.isScheduled()||this.f.schedule()}expand(t,s){const n=this.tree.get(t);if(n){if((n.expandLevels===void 0||s>n.expandLevels)&&(n.expandLevels=s),n.expand===A.TestItemExpandState.Expandable){const i=this.M(n);return i.isOpen()?this.L(n,s-1):i.wait().then(()=>this.L(n,s-1))}else if(n.expand===A.TestItemExpandState.Expanded)return n.resolveBarrier?.isOpen()===!1?n.resolveBarrier.wait().then(()=>this.L(n,s-1)):this.L(n,s-1)}}dispose(){for(const t of this.tree.values())this.s.getApiFor(t.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(t,s){switch(s.op){case $.RemoveChild:this.O(M.$gL.joinToString(t.fullId,s.id));break;case $.Upsert:this.z(s.item,t);break;case $.Bulk:for(const n of s.ops)this.w(t,n);break;case $.SetTags:this.C(s.new,s.old,t.fullId.toString());break;case $.UpdateCanResolveChildren:this.J(t);break;case $.SetProp:this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:t.fullId.toString(),item:s.update}});break;case $.DocumentSynced:this.y(t.actual.uri);break;default:(0,O.$ed)(s)}}y(t){t&&this.pushDiff({op:A.TestDiffOpType.DocumentSynced,uri:t,docv:this.s.getDocumentVersion(t)})}z(t,s){const n=M.$gL.fromExtHostTestItem(t,this.root.id,s?.actual),i=this.s.getApiFor(t);i.parent&&i.parent!==s?.actual&&this.s.getChildren(i.parent).delete(t.id);let g=this.tree.get(n.toString());if(!g){g={fullId:n,actual:t,expandLevels:s?.expandLevels?s.expandLevels-1:void 0,expand:A.TestItemExpandState.NotExpandable},t.tags.forEach(this.D,this),this.tree.set(g.fullId.toString(),g),this.G(t,s),this.pushDiff({op:A.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:g.expand,item:this.s.toITestItem(t)}}),this.I(t,g,s);return}if(g.actual===t){this.H(t,g,s);return}if(g.actual.uri?.toString()!==t.uri?.toString())return this.O(n.toString()),this.z(t,s);const f=this.s.getChildren(g.actual),l=g.actual,b=u(this.s.toITestItem(l),this.s.toITestItem(t));this.s.getApiFor(l).listener=void 0,g.actual=t,g.resolveBarrier=void 0,g.expand=A.TestItemExpandState.NotExpandable,b&&(b.hasOwnProperty("tags")&&(this.C(t.tags,l.tags,n.toString()),delete b.tags),this.w(g,{op:$.SetProp,update:b})),this.I(t,g,s);for(const[S,y]of f)this.s.getChildren(t).get(y.id)||this.O(M.$gL.joinToString(n,y.id));const I=g.expandLevels;I!==void 0&&queueMicrotask(()=>{g.expand===A.TestItemExpandState.Expandable&&(g.expandLevels=void 0,this.expand(n.toString(),I))}),this.y(g.actual.uri)}C(t,s,n){const i=new Set(s.map(g=>g.id));for(const g of t)i.delete(g.id)||this.D(g);this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:n,item:{tags:t.map(g=>(0,A.$lL)(this.s.controllerId,g.id))}}}),i.forEach(this.F,this)}D(t){const s=this.j.get(t.id);s?s.refCount++:(this.j.set(t.id,{refCount:1}),this.pushDiff({op:A.TestDiffOpType.AddTag,tag:{id:(0,A.$lL)(this.s.controllerId,t.id)}}))}F(t){const s=this.j.get(t);s&&!--s.refCount&&(this.j.delete(t),this.pushDiff({op:A.TestDiffOpType.RemoveTag,id:(0,A.$lL)(this.s.controllerId,t)}))}G(t,s){this.s.getApiFor(t).parent=s&&s.actual!==this.root?s.actual:void 0}H(t,s,n){this.G(t,n);const i=this.s.getApiFor(t);i.parent=n?.actual,i.listener=g=>this.w(s,g),this.J(s)}I(t,s,n){this.H(t,s,n);for(const[i,g]of this.s.getChildren(t))this.z(g,s)}J(t){let s;this.h?t.resolveBarrier?s=t.resolveBarrier.isOpen()?A.TestItemExpandState.Expanded:A.TestItemExpandState.BusyExpanding:s=t.actual.canResolveChildren?A.TestItemExpandState.Expandable:A.TestItemExpandState.NotExpandable:s=A.TestItemExpandState.NotExpandable,s!==t.expand&&(t.expand=s,this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:t.fullId.toString(),expand:s}}),s===A.TestItemExpandState.Expandable&&t.expandLevels!==void 0&&this.M(t))}L(t,s){if(s<0)return;const n=[];for(const[i,g]of this.s.getChildren(t.actual)){const f=this.expand(M.$gL.joinToString(t.fullId,g.id),s);(0,E.$mh)(f)&&n.push(f)}if(n.length)return Promise.all(n).then(()=>{})}M(t){if(t.resolveBarrier)return t.resolveBarrier;if(!this.h){const g=new E.$zh;return g.open(),g}t.expand=A.TestItemExpandState.BusyExpanding,this.N(t);const s=t.resolveBarrier=new E.$zh,n=g=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,g)};let i;try{i=this.h(t.actual===this.root?void 0:t.actual)}catch(g){n(g)}return(0,E.$mh)(i)?i.catch(n).then(()=>{s.open(),this.J(t)}):(s.open(),this.J(t)),t.resolveBarrier}N(t){this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:t.fullId.toString(),expand:t.expand}})}O(t){const s=this.tree.get(t);if(!s)throw new Error("attempting to remove non-existent child");this.pushDiff({op:A.TestDiffOpType.Remove,itemId:t});const n=[s];for(;n.length;){const i=n.pop();if(i){this.s.getApiFor(i.actual).listener=void 0;for(const g of i.actual.tags)this.F(g.id);this.tree.delete(i.fullId.toString());for(const[g,f]of this.s.getChildren(i.actual))n.push(this.tree.get(M.$gL.joinToString(i.fullId,f.id)))}}}flushDiff(){const t=this.collectDiff();t.length&&this.g.fire(t)}}e.$OO=D;class d extends Error{constructor(t){super(`Attempted to insert a duplicate test item ID ${t}`)}}e.$PO=d;class r extends Error{constructor(t){super(`TestItem with ID "${t}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$QO=r;class o extends Error{constructor(t,s,n){super(`TestItem with ID "${t}" is from controller "${s}" and cannot be added as a child of an item from controller "${n}".`)}}e.$RO=o;const a=(h,t,s)=>{let n=new Map;return{get size(){return n.size},forEach(i,g){for(const f of n.values())i.call(g,f,this)},[Symbol.iterator](){return n.entries()},replace(i){const g=new Map,f=new Set(n.keys()),l={op:$.Bulk,ops:[]};for(const b of i){if(!(b instanceof s))throw new r(b.id);const I=t(b).controllerId;if(I!==h.controllerId)throw new o(b.id,I,h.controllerId);if(g.has(b.id))throw new d(b.id);g.set(b.id,b),f.delete(b.id),l.ops.push({op:$.Upsert,item:b})}for(const b of f.keys())l.ops.push({op:$.RemoveChild,id:b});h.listener?.(l),n=g},add(i){if(!(i instanceof s))throw new r(i.id);n.set(i.id,i),h.listener?.({op:$.Upsert,item:i})},delete(i){n.delete(i)&&h.listener?.({op:$.RemoveChild,id:i})},get(i){return n.get(i)},toJSON(){return Array.from(n.values())}}};e.$SO=a}),define(ke[114],Ie([1,0,82]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UO=e.$TO=void 0;const R=new WeakMap,P=(A,M)=>{const $={controllerId:M};return R.set(A,$),$};e.$TO=P;const O=A=>{const M=R.get(A);if(!M)throw new E.$QO(A?.id||"<unknown>");return M};e.$UO=O}),define(ke[83],Ie([1,0,28,16,2]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FBb=e.$EBb=e.$DBb=void 0,e.$GBb=O,e.$HBb=M,e.$DBb="vscode-cdn.net",e.$EBb=`vscode-resource.${e.$DBb}`,e.$FBb=`'self' https://*.${e.$DBb}`;function O($,c){return $.scheme===R.Schemas.http||$.scheme===R.Schemas.https?$:(c&&c.authority&&c.isRemote&&$.scheme===R.Schemas.file&&($=P.URI.from({scheme:R.Schemas.vscodeRemote,authority:c.authority,path:$.path})),P.URI.from({scheme:R.Schemas.https,authority:`${$.scheme}+${A($.authority)}.${e.$EBb}`,path:$.path,fragment:$.fragment,query:$.query}))}function A($){return $.replace(/./g,c=>{const C=c.charCodeAt(0);return C>=E.CharCode.a&&C<=E.CharCode.z||C>=E.CharCode.A&&C<=E.CharCode.Z||C>=E.CharCode.Digit0&&C<=E.CharCode.Digit9?c:"-"+C.toString(16).padStart(4,"0")})}function M($){return $.replace(/-([0-9a-f]{4})/g,(c,C)=>String.fromCharCode(parseInt(C,16)))}}),define(ke[241],Ie([1,0,4,6,83]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2mc=void 0;class O{constructor(M,$,c){this.d=M,this.e=$,this.f=c,this.a=0,this.b=new R.$Tc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const C=$.getVisibleTextEditors();for(const v of this.c.values())C.indexOf(v.editor)<0&&v.inset.dispose()}))}dispose(){this.c.forEach(M=>M.inset.dispose()),this.b.dispose()}createWebviewEditorInset(M,$,c,C,v){let u;for(const t of this.e.getVisibleTextEditors(!0))if(t.value===M){u=t;break}if(!u)throw new Error("not a visible editor");const D=this,d=this.a++,r=new E.$he,o=new E.$he,a=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(t){return(0,P.$GBb)(t,D.f)}get cspSource(){return P.$FBb}set options(t){this.b=t,D.d.$setOptions(d,t)}get options(){return this.b}set html(t){this.a=t,D.d.$setHtml(d,t)}get html(){return this.a}get onDidReceiveMessage(){return r.event}postMessage(t){return D.d.$postMessage(d,t)}},h=new class{constructor(){this.editor=M,this.line=$,this.height=c,this.webview=a,this.onDidDispose=o.event}dispose(){D.c.has(d)&&(D.c.delete(d),D.d.$disposeEditorInset(d),o.fire(),o.dispose(),r.dispose())}};return this.d.$createEditorInset(d,u.id,u.value.document.uri,$+1,c,C||{},v.identifier,v.extensionLocation),this.c.set(d,{editor:M,inset:h,onDidReceiveMessage:r}),h}$onDidDispose(M){const $=this.c.get(M);$&&$.inset.dispose()}$onDidReceiveMessage(M,$){this.c.get(M)?.onDidReceiveMessage.fire($)}}e.$2mc=O}),define(ke[115],Ie([1,0,3]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yL=e.$xL=e.$wL=void 0,e.$wL="__",e.$xL=(0,E.$Ai)("IAuthenticationService"),e.$yL=(0,E.$Ai)("IAuthenticationExtensionsService")}),define(ke[242],Ie([1,0,3]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NP=e.VariableKind=e.$MP=void 0,e.$MP=(0,E.$Ai)("configurationResolverService");var R;(function(O){O.Unknown="unknown",O.Env="env",O.Config="config",O.Command="command",O.Input="input",O.ExtensionInstallFolder="extensionInstallFolder",O.WorkspaceFolder="workspaceFolder",O.Cwd="cwd",O.WorkspaceFolderBasename="workspaceFolderBasename",O.UserHome="userHome",O.LineNumber="lineNumber",O.SelectedText="selectedText",O.File="file",O.FileWorkspaceFolder="fileWorkspaceFolder",O.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",O.RelativeFile="relativeFile",O.RelativeFileDirname="relativeFileDirname",O.FileDirname="fileDirname",O.FileExtname="fileExtname",O.FileBasename="fileBasename",O.FileBasenameNoExtension="fileBasenameNoExtension",O.FileDirnameBasename="fileDirnameBasename",O.ExecPath="execPath",O.ExecInstallFolder="execInstallFolder",O.PathSeparator="pathSeparator",O.PathSeparatorAlias="/"})(R||(e.VariableKind=R={}));class P extends Error{constructor(A,M){super(M),this.variable=A}}e.$NP=P}),define(ke[243],Ie([1,0,20,79,15,26,21,102,201,242,13]),function(de,e,E,R,P,O,A,M,$,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3P=void 0;class v{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(D,d,r,o){this.h=new Map,this.a=D,this.b=d,this.g=r,o&&(this.c=o.then(a=>this.i(a)))}i(D){if(A.$i){const d=Object.create(null);return Object.keys(D).forEach(r=>{d[r.toLowerCase()]=D[r]}),d}return D}resolveWithEnvironment(D,d,r){return this.l({env:this.i(D),userHome:void 0},d?d.uri:void 0,r)}async resolveAsync(D,d){const r={env:await this.c,userHome:await this.g};return this.l(r,D?D.uri:void 0,d)}async j(D,d,r,o){const a=O.$9n(d);A.$i&&a.windows?Object.keys(a.windows).forEach(t=>a[t]=a.windows[t]):A.$j&&a.osx?Object.keys(a.osx).forEach(t=>a[t]=a.osx[t]):A.$k&&a.linux&&Object.keys(a.linux).forEach(t=>a[t]=a.linux[t]),delete a.windows,delete a.osx,delete a.linux;const h={env:await this.c,userHome:await this.g};return this.l(h,D?D.uri:void 0,a,r,o)}async resolveAnyAsync(D,d,r){return this.j(D,d,r)}async resolveAnyMap(D,d,r){const o=new Map;return{newConfig:await this.j(D,d,r,o),resolvedVariables:o}}resolveWithInteractionReplace(D,d,r,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(D,d,r,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(D,d){if(this.h.has(D))throw new Error("Variable "+D+" is contributed twice.");this.h.set(D,d)}async l(D,d,r,o,a){if(P.$ag(r))return this.m(D,d,r,o,a);if(Array.isArray(r))return Promise.all(r.map(h=>this.l(D,d,h,o,a)));if(P.$cg(r)){const h=Object.create(null),t=await Promise.all(Object.keys(r).map(async s=>[await this.m(D,d,s,o,a),await this.l(D,d,r[s],o,a)]));for(const[s,n]of t)h[s]=n;return h}return r}m(D,d,r,o,a){return(0,C.$tf)(r,v.VARIABLE_REGEXP,async(h,t)=>{if(t.includes(v.VARIABLE_LHS))return h;let s=await this.o(D,h,t,d,o);return a?.set(t,s),s!==h&&P.$ag(s)&&s.match(v.VARIABLE_REGEXP)&&(s=await this.m(D,d,s,o,a)),s})}n(D){return this.b?this.b.getUriLabel(D,{noPrefix:!0}):D.fsPath}async o(D,d,r,o,a){let h;const t=r.split(":");t.length>1&&(r=t[0],h=t[1]);const s=g=>{const f=this.a.getFilePath();if(f)return(0,M.$Nw)(f);throw new c.$NP(g,(0,$.localize)(0,null,d))},n=g=>{const f=s(g);if(this.a.getWorkspaceFolderPathForFile){const l=this.a.getWorkspaceFolderPathForFile();if(l)return(0,M.$Nw)(l)}throw new c.$NP(g,(0,$.localize)(1,null,d,E.$nc(f)))},i=g=>{if(h){const f=this.a.getFolderUri(h);if(f)return f;throw new c.$NP(g,(0,$.localize)(2,null,d,h))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new c.$NP(g,(0,$.localize)(3,null,d)):new c.$NP(g,(0,$.localize)(4,null,d))};switch(r){case"env":if(h){if(D.env){const g=D.env[A.$i?h.toLowerCase():h];if(P.$ag(g))return g}return""}throw new c.$NP(c.VariableKind.Env,(0,$.localize)(5,null,d));case"config":if(h){const g=this.a.getConfigurationValue(o,h);if(P.$jg(g))throw new c.$NP(c.VariableKind.Config,(0,$.localize)(6,null,d,h));if(P.$cg(g))throw new c.$NP(c.VariableKind.Config,(0,$.localize)(7,null,d,h));return g}throw new c.$NP(c.VariableKind.Config,(0,$.localize)(8,null,d));case"command":return this.p(c.VariableKind.Command,d,h,a,"command");case"input":return this.p(c.VariableKind.Input,d,h,a,"input");case"extensionInstallFolder":if(h){const g=await this.a.getExtension(h);if(!g)throw new c.$NP(c.VariableKind.ExtensionInstallFolder,(0,$.localize)(9,null,d,h));return this.n(g.extensionLocation)}throw new c.$NP(c.VariableKind.ExtensionInstallFolder,(0,$.localize)(10,null,d));default:switch(r){case"workspaceRoot":case"workspaceFolder":return(0,M.$Nw)(this.n(i(c.VariableKind.WorkspaceFolder)));case"cwd":return o||h?(0,M.$Nw)(this.n(i(c.VariableKind.Cwd))):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,M.$Nw)(E.$nc(this.n(i(c.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(D.userHome)return D.userHome;throw new c.$NP(c.VariableKind.UserHome,(0,$.localize)(11,null,d))}case"lineNumber":{const g=this.a.getLineNumber();if(g)return g;throw new c.$NP(c.VariableKind.LineNumber,(0,$.localize)(12,null,d))}case"selectedText":{const g=this.a.getSelectedText();if(g)return g;throw new c.$NP(c.VariableKind.SelectedText,(0,$.localize)(13,null,d))}case"file":return s(c.VariableKind.File);case"fileWorkspaceFolder":return n(c.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return E.$nc(n(c.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return o||h?E.$lc(this.n(i(c.VariableKind.RelativeFile)),s(c.VariableKind.RelativeFile)):s(c.VariableKind.RelativeFile);case"relativeFileDirname":{const g=E.$mc(s(c.VariableKind.RelativeFileDirname));if(o||h){const f=E.$lc(this.n(i(c.VariableKind.RelativeFileDirname)),g);return f.length===0?".":f}return g}case"fileDirname":return E.$mc(s(c.VariableKind.FileDirname));case"fileExtname":return E.$oc(s(c.VariableKind.FileExtname));case"fileBasename":return E.$nc(s(c.VariableKind.FileBasename));case"fileBasenameNoExtension":{const g=E.$nc(s(c.VariableKind.FileBasenameNoExtension));return g.slice(0,g.length-E.$oc(g).length)}case"fileDirnameBasename":return E.$nc(E.$mc(s(c.VariableKind.FileDirnameBasename)));case"execPath":{const g=this.a.getExecPath();return g||d}case"execInstallFolder":{const g=this.a.getAppRoot();return g||d}case"pathSeparator":case"/":return E.sep;default:try{const g=h?`${r}:${h}`:r;return this.p(c.VariableKind.Unknown,d,g,a,void 0)}catch{return d}}}}p(D,d,r,o,a){if(r&&o){const h=a===void 0?o[r]:o[a+":"+r];if(typeof h=="string")return h;throw new c.$NP(D,(0,$.localize)(14,null,d))}return d}}e.$3P=v}),define(ke[116],Ie([1,0,3,113]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$0D=void 0,e.$$D=c,e.$_D=u,e.$aE=D,e.$0D=(0,E.$Ai)("editorGroupsService");var P;(function(d){d[d.UP=0]="UP",d[d.DOWN=1]="DOWN",d[d.LEFT=2]="LEFT",d[d.RIGHT=3]="RIGHT"})(P||(e.GroupDirection=P={}));var O;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(O||(e.GroupOrientation=O={}));var A;(function(d){d[d.FIRST=0]="FIRST",d[d.LAST=1]="LAST",d[d.NEXT=2]="NEXT",d[d.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var M;(function(d){d[d.MAXIMIZE=0]="MAXIMIZE",d[d.EXPAND=1]="EXPAND",d[d.EVEN=2]="EVEN"})(M||(e.GroupsArrangement=M={}));var $;(function(d){d[d.COPY_EDITORS=0]="COPY_EDITORS",d[d.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function c(d){const r=d;return(0,R.$UF)(r?.editor)&&(0,R.$UF)(r?.replacement)}var C;(function(d){d[d.CREATION_TIME=0]="CREATION_TIME",d[d.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",d[d.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(C||(e.GroupsOrder=C={}));var v;(function(d){d[d.NEW_EDITOR=1]="NEW_EDITOR",d[d.MOVE_EDITOR=2]="MOVE_EDITOR",d[d.COPY_EDITOR=3]="COPY_EDITOR"})(v||(e.OpenEditorContext=v={}));function u(d){const r=d;return!!r&&typeof r.id=="number"&&Array.isArray(r.editors)}function D(d){return d.getValue("workbench.editor.openSideBySideDirection")==="down"?P.DOWN:P.RIGHT}}),define(ke[244],Ie([1,0,3,116]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eE=e.$dE=e.$cE=e.$bE=void 0,e.$fE=P,e.$bE=(0,E.$Ai)("editorService"),e.$cE=-1,e.$dE=-2,e.$eE=-3;function P(O){const A=O;return typeof O=="number"||(0,R.$_D)(A)}}),define(ke[245],Ie([1,0,3,105]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RL=void 0,e.$RL=(0,E.$Bi)(R.$Hi)}),define(ke[117],Ie([1,0,19,4,20,6,11]),function(de,e,E,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ebc=e.$dbc=e.$cbc=e.$bbc=e.$abc=void 0;class M{constructor(h,t){this.versionId=h,this.removedDueToLooping=t}}e.$abc=M;class ${static isHostExtension(h,t,s){if(t.getExtensionDescription(h))return!1;const n=s.getExtensionDescription(h);return n?!!((n.main||n.browser)&&n.api==="none"):!1}constructor(h,t){this.j=h,this.c=new R.$he,this.onDidChange=this.c.event,this.d=0,this.e=t,this.k()}k(){this.e.sort(r),this.f=new E.$Ym,this.g=[],this.h=new Map;for(const h of this.e){if(this.f.has(h.identifier)){console.error("Extension `"+h.identifier.value+"` is already registered");continue}this.f.set(h.identifier,h),this.g.push(h);const t=this.j.readActivationEvents(h);for(const s of t)this.h.has(s)||this.h.set(s,[]),this.h.get(s).push(h)}}set(h){return this.e=h,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(h,t){this.e=o(this.e,t),this.e=this.e.concat(h);const s=$.l(this.e);return this.e=o(this.e,s.map(n=>n.identifier)),this.k(),this.d++,this.c.fire(void 0),new M(this.d,s)}static l(h){const t=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(f){this.d.has(f)||(this.d.add(f),this.e.push(f))}addArc(f,l){this.addNode(f),this.addNode(l),this.c.has(f)?this.c.get(f).push(l):this.c.set(f,[l])}getArcs(f){return this.c.has(f)?this.c.get(f):[]}hasOnlyGoodArcs(f,l){const b=t.getArcs(f);for(let I=0;I<b.length;I++)if(!l.has(b[I]))return!1;return!0}getNodes(){return this.e}},s=new E.$Ym;for(const f of h)if(s.set(f.identifier,f),f.extensionDependencies)for(const l of f.extensionDependencies)t.addArc(E.$Wm.toKey(f.identifier),E.$Wm.toKey(l));const n=new Set;t.getNodes().filter(f=>t.getArcs(f).length===0).forEach(f=>n.add(f));const i=t.getNodes().filter(f=>!n.has(f));let g;do{g=!1;for(let f=0;f<i.length;f++){const l=i[f];t.hasOnlyGoodArcs(l,n)&&(i.splice(f,1),f--,n.add(l),g=!0)}}while(g);return i.map(f=>s.get(f))}containsActivationEvent(h){return this.h.has(h)}containsExtension(h){return this.f.has(h)}getExtensionDescriptionsForActivationEvent(h){const t=this.h.get(h);return t?t.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new c(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(h){const t=this.f.get(h);return t||void 0}getExtensionDescriptionByUUID(h){for(const t of this.g)if(t.uuid===h)return t}getExtensionDescriptionByIdOrUUID(h,t){return this.getExtensionDescription(h)??(t?this.getExtensionDescriptionByUUID(t):void 0)}}e.$bbc=$;class c{constructor(h,t){this.versionId=h,this.extensions=t}}e.$cbc=c;class C{constructor(h){this.d=new D,this.c=new $(h,[])}async acquireLock(h){const t=await this.d.acquire(h);return new v(this,t)}deltaExtensions(h,t,s){if(!h.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(t,s)}containsActivationEvent(h){return this.c.containsActivationEvent(h)}containsExtension(h){return this.c.containsExtension(h)}getExtensionDescriptionsForActivationEvent(h){return this.c.getExtensionDescriptionsForActivationEvent(h)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(h){return this.c.getExtensionDescription(h)}getExtensionDescriptionByUUID(h){return this.c.getExtensionDescriptionByUUID(h)}getExtensionDescriptionByIdOrUUID(h,t){return this.c.getExtensionDescriptionByIdOrUUID(h,t)}}e.$dbc=C;class v extends O.$Uc{constructor(h,t){super(),this.f=h,this.c=!1,this.B(t)}isAcquiredFor(h){return!this.c&&this.f===h}}e.$ebc=v;class u{constructor(h){this.name=h;const t=(0,A.$th)();this.promise=t.promise,this.c=t.resolve}resolve(h){this.c(h)}}class D{constructor(){this.c=[],this.d=!1}async acquire(h){const t=new u(h);return this.c.push(t),this.e(),t.promise}e(){if(this.d||this.c.length===0)return;const h=this.c.shift();this.d=!0;let t=!0;const s=setTimeout(()=>{t&&console.warn(`The customer named ${h.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),n=()=>{t&&(clearTimeout(s),t=!1,this.d=!1,this.e())};h.resolve((0,O.$Sc)(n))}}var d;(function(a){a[a.Builtin=0]="Builtin",a[a.User=1]="User",a[a.Dev=2]="Dev"})(d||(d={}));function r(a,h){const t=a.isBuiltin?d.Builtin:a.isUnderDevelopment?d.Dev:d.User,s=h.isBuiltin?d.Builtin:h.isUnderDevelopment?d.Dev:d.User;if(t!==s)return t-s;const n=P.$gc.basename(a.extensionLocation.path),i=P.$gc.basename(h.extensionLocation.path);return n<i?-1:n>i?1:0}function o(a,h){const t=new E.$Xm(h);return a.filter(s=>!t.has(s.identifier))}}),define(ke[84],Ie([1,0,23]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$5m=A,e.$6m=M;var R;(function(c){c[c.Desktop=1]="Desktop",c[c.Web=2]="Web"})(R||(e.UIKind=R={}));var P;(function(c){c[c.VersionMismatch=55]="VersionMismatch",c[c.UnexpectedError=81]="UnexpectedError"})(P||(e.ExtensionHostExitCode=P={}));var O;(function(c){c[c.Initialized=0]="Initialized",c[c.Ready=1]="Ready",c[c.Terminate=2]="Terminate"})(O||(e.MessageType=O={}));function A(c){const C=E.$Je.alloc(1);switch(c){case O.Initialized:C.writeUInt8(1,0);break;case O.Ready:C.writeUInt8(2,0);break;case O.Terminate:C.writeUInt8(3,0);break}return C}function M(c,C){if(c.byteLength!==1)return!1;switch(c.readUInt8(0)){case 1:return C===O.Initialized;case 2:return C===O.Ready;case 3:return C===O.Terminate;default:return!1}}var $;(function(c){c.Start="START_NATIVE_LOG",c.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(ke[66],Ie([1,0,3,4,111,12,27,84,62,63,26,2,6,186]),function(de,e,E,R,P,O,A,M,$,c,C,v,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gP=e.$eP=e.$dP=void 0,e.$fP=o;let d=class extends u.$Uc{constructor(h,t){super(),this.s=h,this.t=t,this.a=this.B(new R.$he),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new R.$he),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=P.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=v.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=t.createLogger(this.m,{id:c.$sp,name:(0,D.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(t.onDidChangeLogLevel(s=>{(0,O.$9j)(s)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===O.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===P.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=P.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=P.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=P.TelemetryLevel.USAGE:!1}}instantiateLogger(h,t,s){const n=this.getTelemetryDetails(),i=new r(t,s,h,this.n,this.j,this.getBuiltInCommonProperties(h),{isUsageEnabled:n.isUsageEnabled,isErrorsEnabled:n.isErrorsEnabled}),g=this.r.get(h.identifier.value)??[];return this.r.set(h.identifier.value,[...g,i]),i.apiTelemetryLogger}$initializeTelemetryLevel(h,t,s){this.f=h,this.g=t,this.c=s??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(h){const t=Object.create(null);switch(t["common.extname"]=`${h.publisher}.${h.name}`,t["common.extversion"]=h.version,t["common.vscodemachineid"]=this.s.telemetryInfo.machineId,t["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,t["common.sqmid"]=this.s.telemetryInfo.sqmId,t["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,t["common.vscodeversion"]=this.s.version,t["common.isnewappinstall"]=o(this.s.telemetryInfo.firstSessionDate),t["common.product"]=this.s.environment.appHost,this.s.uiKind){case M.UIKind.Web:t["common.uikind"]="web";break;case M.UIKind.Desktop:t["common.uikind"]="desktop";break;default:t["common.uikind"]="unknown"}return t["common.remotename"]=(0,$.$Nm)((0,c.$yp)(this.s.remote.authority)),t}$onDidChangeTelemetryLevel(h){this.h=this.getTelemetryConfiguration(),this.f=h;const t=this.getTelemetryDetails();this.r.forEach((s,n)=>{const i=s.filter(g=>!g.isDisposed);i.length===0?this.r.delete(n):this.r.set(n,i)}),this.r.forEach(s=>{for(const n of s)n.updateTelemetryEnablements(t.isUsageEnabled,t.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(h,t){const n=this.r.get(h.value)?.filter(g=>!g.isDisposed);if(!n)return this.r.delete(h.value),!1;let i=!1;for(const g of n)g.ignoreUnhandledExtHostErrors||(g.logError(t),i=!0);return i}};e.$dP=d,e.$dP=d=He([Ve(0,A.$cP),Ve(1,O.$8j)],d);class r{static validateSender(h){if(typeof h!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof h.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof h.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof h.flush<"u"&&typeof h.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(h,t,s,n,i,g,f){this.g=s,this.h=n,this.i=i,this.j=g,this.a=new R.$he,this.ignoreUnhandledExtHostErrors=t?.ignoreUnhandledErrors??!1,this.b=t?.ignoreBuiltInCommonProperties??!1,this.c=t?.additionalCommonProperties,this.f=h,this.d={isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled}}updateTelemetryEnablements(h,t){this.e&&(this.d={isUsageEnabled:h,isErrorsEnabled:t},this.a.fire(this.e))}mixInCommonPropsAndCleanData(h){let t="properties"in h?h.properties??{}:h;return t=(0,c.$Bp)(t,[]),this.c&&(t=(0,C.$_n)(t,this.c)),this.b||(t=(0,C.$_n)(t,this.j)),"properties"in h?h.properties=t:h=t,h}k(h,t){this.f&&(this.g.publisher==="vscode"?h=this.g.name+"/"+h:h=this.g.identifier.value+"/"+h,t=this.mixInCommonPropsAndCleanData(t||{}),this.i||this.f?.sendEventData(h,t),this.h.trace(h,t))}logUsage(h,t){this.d.isUsageEnabled&&this.k(h,t)}logError(h,t){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof h=="string")this.k(h,t);else{const s={name:h.name,message:h.message,stack:h.stack,cause:h.cause},n=(0,c.$Bp)(s,[]),i=new Error(n.message,{cause:n.cause});i.stack=n.stack,i.name=n.name,t=this.mixInCommonPropsAndCleanData(t||{}),this.i||this.f.sendErrorData(i,t),this.h.trace("exception",t)}}get apiTelemetryLogger(){if(!this.e){const h=this,t={logUsage:h.logUsage.bind(h),get isUsageEnabled(){return h.d.isUsageEnabled},get isErrorsEnabled(){return h.d.isErrorsEnabled},logError:h.logError.bind(h),dispose:h.dispose.bind(h),onDidChangeEnableStates:h.a.event.bind(h)};this.e=Object.freeze(t)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let h=this.f;this.f=void 0,Promise.resolve(h.flush()).then(h=void 0),this.e=void 0}else this.f=void 0}}e.$eP=r;function o(a){const h=Date.now()-new Date(a).getTime();return isNaN(h)?!1:h<1e3*60*60*24}e.$gP=(0,E.$Ai)("IExtHostTelemetry")}),define(ke[25],Ie([1,0,4,2,217,110,19,3]),function(de,e,E,R,P,O,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZG=e.ActivationKind=e.$WG=e.$VG=e.$SG=e.ExtensionHostStartup=e.$RG=e.$QG=e.$PG=e.$OG=void 0,e.$TG=u,e.$UG=D,e.$XG=a,e.$YG=h,e.$OG=Object.freeze({identifier:new A.$Wm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1,targetPlatform:A.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$PG="extensions.webWorker",e.$QG=(0,M.$Ai)("extensionService");class ${constructor(n){this.dependency=n}}e.$RG=$;var c;(function(s){s[s.EagerAutoStart=1]="EagerAutoStart",s[s.EagerManualStart=2]="EagerManualStart",s[s.Lazy=3]="Lazy"})(c||(e.ExtensionHostStartup=c={}));class C{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(n,i,g){this.c=n,this.d=i.slice(0),this.e=g.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:O.$zG.createActivationEventsMap(this.d)}}set(n,i,g){if(this.c>n)throw new Error(`ExtensionHostExtensions: invalid versionId ${n} (current: ${this.c})`);const f=[],l=[],b=[],I=[],S=v(this.d),y=v(i),p=(T,G)=>T.extensionLocation.toString()===G.extensionLocation.toString()||T.isBuiltin===G.isBuiltin||T.isUserBuiltin===G.isUserBuiltin||T.isUnderDevelopment===G.isUnderDevelopment;for(const T of this.d){const G=y.get(T.identifier);if(!G){f.push(T.identifier),S.delete(T.identifier);continue}if(!p(T,G)){f.push(T.identifier),S.delete(T.identifier);continue}}for(const T of i){const G=S.get(T.identifier);if(!G){l.push(T);continue}if(!p(G,T)){f.push(G.identifier),S.delete(G.identifier);continue}}const k=new A.$Xm(this.e),m=new A.$Xm(g);for(const T of this.e)m.has(T)||b.push(T);for(const T of g)k.has(T)||I.push(T);const w=O.$zG.createActivationEventsMap(l),F={versionId:n,toRemove:f,toAdd:l,addActivationEvents:w,myToRemove:b,myToAdd:I};return this.delta(F),F}delta(n){if(this.c>=n.versionId)return null;const{toRemove:i,toAdd:g,myToRemove:f,myToAdd:l}=n,b=new A.$Xm(i),I=new A.$Xm(f);for(let S=0;S<this.d.length;S++)b.has(this.d[S].identifier)&&(this.d.splice(S,1),S--);for(let S=0;S<this.e.length;S++)I.has(this.e[S])&&(this.e.splice(S,1),S--);for(const S of g)this.d.push(S);for(const S of l)this.e.push(S);return this.f=null,n}containsExtension(n){for(const i of this.e)if(A.$Wm.equals(i,n))return!0;return!1}containsActivationEvent(n){return this.f||(this.f=this.g()),this.f.has(n)}g(){const n=new Set;for(const i of this.d){if(!this.containsExtension(i.identifier))continue;const g=O.$zG.readActivationEvents(i);for(const f of g)n.add(f)}return n}}e.$SG=C;function v(s){const n=new A.$Ym;for(const i of s)n.set(i.identifier,i);return n}function u(s,n){return s.enabledApiProposals?s.enabledApiProposals.includes(n):!1}function D(s,n){if(!u(s,n))throw new Error(`Extension '${s.identifier.value}' CANNOT use API proposal: ${n}.
Its package.json#enabledApiProposals-property declares: ${s.enabledApiProposals?.join(", ")??"[]"} but NOT ${n}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${s.identifier.value}`)}class d{constructor(n,i,g,f){this.codeLoadingTime=n,this.activateCallTime=i,this.activateResolvedTime=g,this.activationReason=f}}e.$VG=d;class r{constructor(n,i){this.description=n,this.value=i}}e.$WG=r;var o;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(o||(e.ActivationKind=o={}));function a(s){return{type:s.isBuiltin?A.ExtensionType.System:A.ExtensionType.User,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,P.$Hp)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation,targetPlatform:s.targetPlatform,validations:[],isValid:!0}}function h(s,n){return{identifier:new A.$Wm((0,P.$Fp)(s.manifest.publisher,s.manifest.name)),isBuiltin:s.type===A.ExtensionType.System,isUserBuiltin:s.type===A.ExtensionType.User&&s.isBuiltin,isUnderDevelopment:!!n,extensionLocation:s.location,...s.manifest,uuid:s.identifier.uuid,targetPlatform:s.targetPlatform,publisherDisplayName:s.publisherDisplayName}}class t{constructor(){this.onDidRegisterExtensions=E.Event.None,this.onDidChangeExtensionsStatus=E.Event.None,this.onDidChangeExtensions=E.Event.None,this.onWillActivateByEvent=E.Event.None,this.onDidChangeResponsiveChange=E.Event.None,this.onWillStop=E.Event.None,this.extensions=[]}activateByEvent(n){return Promise.resolve(void 0)}activateById(n,i){return Promise.resolve(void 0)}activationEventIsDone(n){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(n){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(n,i){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(n){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$ZG=t}),define(ke[246],Ie([1,0,14,117,19,25,12,11]),function(de,e,E,R,P,O,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qnc=e.$pnc=e.$onc=e.$nnc=e.$mnc=e.$lnc=void 0;class ${static{this.NONE=new $(!1,-1,-1,-1)}constructor(a,h,t,s){this.startup=a,this.codeLoadingTime=h,this.activateCallTime=t,this.activateResolvedTime=s}}e.$lnc=$;class c{constructor(a){this.a=a,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(a,h){return a===-1||h===-1?-1:h-a}build(){return new $(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$mnc=c;class C{constructor(a,h,t,s,n,i){this.activationFailed=a,this.activationFailedError=h,this.activationTimes=t,this.module=s,this.exports=n,this.subscriptions=i}}e.$nnc=C;class v extends C{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.$onc=v;class u extends C{constructor(){super(!1,null,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$pnc=u;class D extends C{constructor(a){super(!0,a,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let d=class{constructor(a,h,t,s){this.g=s,this.a=a,this.b=h,this.c=t,this.d=new P.$Ym,this.f=Object.create(null)}dispose(){for(const[a,h]of this.d)h.dispose()}async waitForActivatingExtensions(){const a=[];for(const[h,t]of this.d)a.push(t.wait());await Promise.all(a)}isActivated(a){const h=this.d.get(a);return!!(h&&h.value)}getActivatedExtension(a){const h=this.d.get(a);if(!h||!h.value)throw new Error(`Extension '${a.value}' is not known or not activated`);return h.value}async activateByEvent(a,h){if(this.f[a])return;const t=this.a.getExtensionDescriptionsForActivationEvent(a);await this.h(t.map(s=>({id:s.identifier,reason:{startup:h,extensionId:s.identifier,activationEvent:a}}))),this.f[a]=!0}activateById(a,h){const t=this.a.getExtensionDescription(a);if(!t)throw new Error(`Extension '${a.value}' is not known`);return this.h([{id:t.identifier,reason:h}])}async h(a){const h=a.filter(t=>!this.isActivated(t.id)).map(t=>this.j(t));await Promise.all(h.map(t=>t.wait()))}j(a){if(this.d.has(a.id))return this.d.get(a.id);if(this.l(a.id))return this.k(a,null,[],null);const h=this.a.getExtensionDescription(a.id);if(!h){const n=new Error(`Cannot activate unknown extension '${a.id.value}'`),i=this.k(a,null,[],new D(n));return this.c.onExtensionActivationError(a.id,n,new O.$RG(a.id.value)),i}const t=[],s=typeof h.extensionDependencies>"u"?[]:h.extensionDependencies;for(const n of s){if(this.m(n))continue;const i=this.d.get(n);if(i){t.push(i);continue}if(this.l(n)){t.push(this.j({id:this.b.getExtensionDescription(n).identifier,reason:a.reason}));continue}const g=this.a.getExtensionDescription(n);if(g){if(!g.main&&!g.browser)continue;t.push(this.j({id:g.identifier,reason:a.reason}));continue}const f=h.displayName||h.identifier.value,l=new Error(`Cannot activate the '${f}' extension because it depends on unknown extension '${n}'`),b=this.k(a,h.displayName,[],new D(l));return this.c.onExtensionActivationError(h.identifier,l,new O.$RG(n)),b}return this.k(a,h.displayName,t,null)}k(a,h,t,s){const n=new r(a.id,h,a.reason,t,s,this.c,this.g);return this.d.set(a.id,n),n}l(a){return R.$bbc.isHostExtension(a,this.a,this.b)}m(a){const h=this.b.getExtensionDescription(a);return h?!h.main&&!h.browser:!1}};e.$qnc=d,e.$qnc=d=He([Ve(3,A.$7j)],d);let r=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(a,h,t,s,n,i,g){this.c=a,this.d=h,this.f=t,this.g=s,this.h=n,this.j=i,this.k=g,this.a=new M.$zh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let a=0;a<this.g.length;a++){const h=this.g[a];if(h.value&&!h.value.activationFailed){this.g.splice(a,1),a--;continue}if(h.value&&h.value.activationFailed){const t=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${h.friendlyName}' failed to activate`);t.detail=h.value.activationFailedError,this.h=new D(t),this.j.onExtensionActivationError(this.c,t,null);return}}this.g.length>0&&await Promise.race(this.g.map(a=>a.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(a){const h=new Error;if(a&&a.name&&(h.name=a.name),a&&a.message?h.message=`Activating extension '${this.c.value}' failed: ${a.message}.`:h.message=`Activating extension '${this.c.value}' failed: ${a}.`,a&&a.stack&&(h.stack=a.stack),this.h=new D(h),this.b&&E.$4(a))return;this.j.onExtensionActivationError(this.c,h,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(a)}}};r=He([Ve(6,A.$7j)],r)}),define(ke[247],Ie([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",attributableCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatParticipantPrivate:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorHoverVerbosityLevel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",embeddings:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModelSystem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ke[118],Ie([1,0,203,14,35,109,78,31,19,247,107,110]),function(de,e,E,R,P,O,A,M,$,c,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=void 0;const u=M.$jo.as(A.$ko.JSONContribution);class D{constructor(n,i,g){this.a=n,this.b=i,this.c=g}d(n,i){this.a({type:n,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(n){this.d(P.default.Error,n)}warn(n){this.d(P.default.Warning,n)}info(n){this.d(P.default.Info,n)}}e.$IG=D;class d{static a(n){const i=new $.$Xm;for(let g=0,f=n.length;g<f;g++)i.add(n[g].description.identifier);return i}static compute(n,i){if(!n||!n.length)return new d(i,[]);if(!i||!i.length)return new d([],n);const g=this.a(n),f=this.a(i),l=i.filter(I=>!g.has(I.description.identifier)),b=n.filter(I=>!f.has(I.description.identifier));return new d(l,b)}constructor(n,i){this.added=n,this.removed=i}}e.$JG=d;class r{constructor(n,i){this.name=n,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(n){if(this.a!==null)throw new Error("Handler already set!");return this.a=n,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(n){this.c=d.compute(this.b,n),this.b=n,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(n){(0,R.$1)(n)}}}e.$KG=r;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[E.localize(0,null),E.localize(1,null)]},a="vscode://schemas/vscode-extensions";e.$LG={properties:{engines:{type:"object",description:E.localize(2,null),properties:{vscode:{type:"string",description:E.localize(3,null),default:"^1.22.0"}}},publisher:{description:E.localize(4,null),type:"string"},displayName:{description:E.localize(5,null),type:"string"},categories:{description:E.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$Vm},{type:"string",const:"Languages",deprecationMessage:E.localize(7,null)}]}},galleryBanner:{type:"object",description:E.localize(8,null),properties:{color:{description:E.localize(9,null),type:"string"},theme:{description:E.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:E.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:E.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:E.localize(13,null)},enabledApiProposals:{markdownDescription:E.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(c.allApiProposals),markdownEnumDescriptions:Object.values(c.allApiProposals)}},api:{markdownDescription:E.localize(15,null),type:"string",enum:["none"],enumDescriptions:[E.localize(16,null)]},activationEvents:{description:E.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:E.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:E.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:E.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:E.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:E.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:E.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:E.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:E.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:E.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:E.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:E.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:E.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:E.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:E.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:E.localize(32,null)},{label:"onUri",body:"onUri",description:E.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:E.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:E.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:E.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:E.localize(37,null)},{label:"onRenderer",description:E.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:E.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:E.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:E.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:E.localize(42,null)},{label:"*",description:E.localize(43,null),body:"*"}]}},badges:{type:"array",description:E.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:E.localize(45,null)},href:{type:"string",description:E.localize(46,null)},description:{type:"string",description:E.localize(47,null)}}}},markdown:{type:"string",description:E.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:E.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:E.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$1o}},extensionPack:{description:E.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$1o}},extensionKind:{description:E.localize(52,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:E.localize(53,null)},{body:["workspace"],description:E.localize(54,null)},{body:["ui","workspace"],description:E.localize(55,null)},{body:["workspace","ui"],description:E.localize(56,null)},{body:[],description:E.localize(57,null)}]},capabilities:{description:E.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:E.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:E.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[E.localize(61,null),E.localize(62,null),E.localize(63,null)]},description:{type:"string",markdownDescription:E.localize(64,null)}}},untrustedWorkspaces:{description:E.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:E.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[E.localize(67,null),E.localize(68,null),E.localize(69,null)]},restrictedConfigurations:{description:E.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:E.localize(71,null)}}}}},sponsor:{description:E.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:E.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:E.localize(74,null),type:"string"},"vscode:uninstall":{description:E.localize(75,null),type:"string"}}},icon:{type:"string",description:E.localize(76,null)},l10n:{type:"string",description:E.localize(77,null)},pricing:{type:"string",markdownDescription:E.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class h{constructor(){this.a=new Map}registerExtensionPoint(n){if(this.a.has(n.extensionPoint))throw new Error("Duplicate extension point: "+n.extensionPoint);const i=new r(n.extensionPoint,n.defaultExtensionKind);return this.a.set(n.extensionPoint,i),n.activationEventsGenerator&&v.$zG.register(n.extensionPoint,n.activationEventsGenerator),e.$LG.properties.contributes.properties[n.extensionPoint]=n.jsonSchema,u.registerSchema(a,e.$LG),i}getExtensionPoints(){return Array.from(this.a.values())}}e.$MG=h;const t={ExtensionsRegistry:"ExtensionsRegistry"};M.$jo.add(t.ExtensionsRegistry,new h),e.$NG=M.$jo.as(t.ExtensionsRegistry),u.registerSchema(a,e.$LG),u.registerSchema(C.$ok,{properties:{extensionEnabledApiProposals:{description:E.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(c.allApiProposals),markdownEnumDescriptions:Object.values(c.allApiProposals)}}]}}}})}),define(ke[248],Ie([1,0,4,40,6,13,195,19,3,12,25,118]),function(de,e,E,R,P,O,A,M,$,c,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3G=e.$2G=e.$1G=e.ChatMessageRole=void 0;var u;(function(r){r[r.System=0]="System",r[r.User=1]="User",r[r.Assistant=2]="Assistant"})(u||(e.ChatMessageRole=u={})),e.$1G=(0,$.$Ai)("ILanguageModelsService");const D={type:"object",properties:{vendor:{type:"string",description:(0,A.localize)(0,null)}}};e.$2G=v.$NG.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,A.localize)(1,null),oneOf:[D,{type:"array",items:D}]},activationEventsGenerator:(r,o)=>{for(const a of r)o.push(`onLanguageModelChat:${a.vendor}`)}});let d=class{constructor(o,a){this.e=o,this.f=a,this.a=new P.$Tc,this.b=new Map,this.c=new Set,this.d=this.a.add(new E.$he),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$2G.setHandler(h=>{this.c.clear();for(const s of h){if(!(0,C.$TG)(s.description,"chatProvider")){s.collector.error((0,A.localize)(2,null));continue}for(const n of R.Iterable.wrap(s.value)){if(this.c.has(n.vendor)){s.collector.error((0,A.localize)(3,null,n.vendor));continue}if((0,O.$$e)(n.vendor)){s.collector.error((0,A.localize)(4,null));continue}if(n.vendor.trim()!==n.vendor){s.collector.error((0,A.localize)(5,null));continue}this.c.add(n.vendor)}}const t=[];for(const[s,n]of this.b)this.c.has(n.metadata.vendor)||(this.b.delete(s),t.push(s));t.length>0&&this.d.fire({removed:t})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel(o){return this.b.get(o)?.metadata}async selectLanguageModels(o){if(o.vendor)await this.e.activateByEvent(`onLanguageModelChat:${o.vendor}}`);else{const h=Array.from(this.c).map(t=>this.e.activateByEvent(`onLanguageModelChat:${t}`));await Promise.all(h)}const a=[];for(const[h,t]of this.b)(o.vendor===void 0||t.metadata.vendor===o.vendor)&&(o.family===void 0||t.metadata.family===o.family)&&(o.version===void 0||t.metadata.version===o.version)&&(o.identifier===void 0||t.metadata.id===o.identifier)&&(!t.metadata.targetExtensions||t.metadata.targetExtensions.some(s=>M.$Wm.equals(s,o.extension)))&&a.push(h);return this.f.trace("[LM] selected language models",o,a),a}registerLanguageModelChat(o,a){if(this.f.trace("[LM] registering language model chat",o,a.metadata),!this.c.has(a.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${a.metadata.vendor}.`);if(this.b.has(o))throw new Error(`Chat response provider with identifier ${o} is already registered.`);return this.b.set(o,a),this.d.fire({added:[{identifier:o,metadata:a.metadata}]}),(0,P.$Sc)(()=>{this.b.delete(o)&&(this.d.fire({removed:[o]}),this.f.trace("[LM] UNregistered language model chat",o,a.metadata))})}makeLanguageModelChatRequest(o,a,h,t,s,n){const i=this.b.get(o);if(!i)throw new Error(`Chat response provider with identifier ${o} is not registered.`);return i.provideChatResponse(h,a,t,s,n)}computeTokenLength(o,a,h){const t=this.b.get(o);if(!t)throw new Error(`Chat response provider with identifier ${o} is not registered.`);return t.provideTokenCount(a,h)}};e.$3G=d,e.$3G=d=He([Ve(0,C.$QG),Ve(1,c.$7j)],d)}),define(ke[249],Ie([1,0,198,15,26,118,32,4]),function(de,e,E,R,P,O,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tI=void 0;const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:E.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:E.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:E.localize(2,null),default:""}}};var c;(function(u){function D(d,r,o){if(!d)return;const a=R.$ag(d.type)?d.type:void 0;if(!a||a.length===0){o.error(E.localize(3,null));return}const h=[];if(Array.isArray(d.required))for(const t of d.required)R.$ag(t)&&h.push(t);return{extensionId:r.value,taskType:a,required:h,properties:d.properties?P.$9n(d.properties):{},when:d.when?A.$yj.deserialize(d.when):void 0}}u.from=D})(c||(c={}));const C=O.$NG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,D)=>{for(const d of u)d.type&&D.push(`onTaskType:${d.type}`)},jsonSchema:{description:E.localize(4,null),type:"array",items:$}});class v{constructor(){this.d=new M.$he,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((D,d)=>{C.setHandler((r,o)=>{this.c=void 0;try{for(const a of o.removed){const h=a.value;for(const t of h)this.a&&t.type&&this.a[t.type]&&delete this.a[t.type]}for(const a of o.added){const h=a.value;for(const t of h){const s=c.from(t,a.description.identifier,a.collector);s&&(this.a[s.taskType]=s)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}D(void 0)})})}onReady(){return this.b}get(D){return this.a[D]}all(){return Object.keys(this.a).map(D=>this.a[D])}getJsonSchema(){if(this.c===void 0){const D=[];for(const d of this.all()){const r={type:"object",additionalProperties:!1};d.required.length>0&&(r.required=d.required.slice(0)),d.properties!==void 0?r.properties=P.$9n(d.properties):r.properties=Object.create(null),r.properties.type={type:"string",enum:[d.taskType]},D.push(r)}this.c={oneOf:D}}return this.c}}e.$tI=new v}),define(ke[250],Ie([1,0,199,15,24,26,32,249,42]),function(de,e,E,R,P,O,A,M,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$DI=e.JsonSchemaVersion=e.ExecutionEngine=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$xI=e.ShellQuoting=e.$wI=e.$vI=e.$uI=void 0,e.$uI="settings",e.$vI=new A.$Rj("taskRunning",!1,E.localize(0,null)),e.$wI=E.localize2(2,"Tasks");var c;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(c||(e.ShellQuoting=c={})),e.$xI="$customized",function(N){function L(Z){if(!Z)return N.Strong;switch(Z.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=L}(c||(e.ShellQuoting=c={}));var C;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(C||(e.CommandOptions=C={}));var v;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(v||(e.RevealKind=v={})),function(N){function L(Z){switch(Z.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=L}(v||(e.RevealKind=v={}));var u;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(u||(e.RevealProblemKind=u={})),function(N){function L(Z){switch(Z.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=L}(u||(e.RevealProblemKind=u={}));var D;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(D||(e.PanelKind=D={})),function(N){function L(Z){switch(Z.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=L}(D||(e.PanelKind=D={}));var d;(function(N){N.defaults={echo:!0,reveal:v.Always,revealProblems:u.Never,focus:!1,panel:D.Shared,showReuseMessage:!0,clear:!1}})(d||(e.PresentationOptions=d={}));var r;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(r||(e.RuntimeType=r={})),function(N){function L(re){switch(re.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=L;function Z(re){switch(re){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=Z}(r||(e.RuntimeType=r={}));var o;(function(N){function L(Z){return R.$ag(Z)?Z:Z.value}N.value=L})(o||(e.CommandString=o={}));var a;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function L(re){return re===N.Clean._id||re===N.Build._id||re===N.Rebuild._id||re===N.Test._id}N.is=L;function Z(re){if(re!==void 0)return R.$ag(re)?L(re)?{_id:re,isDefault:!1}:void 0:re}N.from=Z})(a||(e.TaskGroup=a={}));var h;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(h||(e.TaskScope=h={}));var t;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function L(Z){switch(Z){case N.User:return $.ConfigurationTarget.USER;case N.WorkspaceFile:return $.ConfigurationTarget.WORKSPACE;default:return $.ConfigurationTarget.WORKSPACE_FOLDER}}N.toConfigurationTarget=L})(t||(e.TaskSourceKind=t={}));var s;(function(N){N.parallel="parallel",N.sequence="sequence"})(s||(e.DependsOrder=s={}));var n;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(n||(e.RunOnOptions=n={}));var i;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:n.default,instanceLimit:1}})(i||(e.RunOptions=i={}));class g{constructor(L,Z,re,fe,be,oe){this._label="",this._id=L,Z&&(this._label=Z),re&&(this.type=re),this.runOptions=fe,this.configurationProperties=be,this._source=oe}getDefinition(L){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const L={folder:this.d(),id:this._id};return JSON.stringify(L)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(L,Z=!1){if(L===void 0)return!1;if(R.$ag(L))return L===this._label||L===this.configurationProperties.identifier||Z&&L===this._id;const re=this.getDefinition(!0);return re!==void 0&&re._key===L._key}getQualifiedLabel(){const L=this.getWorkspaceFolder();return L?`${this._label} (${L.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(L){this.c===void 0&&(this.c=[]),L&&(this.c=this.c.concat(L))}get taskLoadMessages(){return this.c}}e.$yI=g;class f extends g{constructor(L,Z,re,fe,be,oe,pe,$e){super(L,re,void 0,pe,$e,Z),this.command={},this._source=Z,this.hasDefinedMatchers=oe,be&&(this.command=be)}clone(){return new f(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(L=!1){if(L&&this._source.customizes!==void 0)return this._source.customizes;{let Z;switch(this.command?this.command.runtime:void 0){case r.Shell:Z="shell";break;case r.Process:Z="process";break;case r.CustomExecution:Z="customExecution";break;case void 0:Z="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:Z,_key:this._id,id:this._id}}}static is(L){return L instanceof f}getMapKey(){const L=this._source.config.workspaceFolder;return L?`${L.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===t.User?e.$uI:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const L=this.d();if(!L)return;let Z=this.configurationProperties.identifier;this._source.kind!==t.Workspace&&(Z+=this._source.kind);const re={type:e.$xI,folder:L,id:Z};return JSON.stringify(re)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$$g(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(L){return new f(L._id,L._source,L._label,L.type,L.command,L.hasDefinedMatchers,L.runOptions,L.configurationProperties)}}e.$zI=f;class l extends g{constructor(L,Z,re,fe,be,oe,pe){super(L,re,fe,oe,pe,Z),this._source=Z,this.configures=be}static is(L){return L instanceof l}f(L){return L}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$$g(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===t.User?e.$uI:this._source.config.workspaceFolder?.uri.toString()}getKey(){const L=this.d();if(!L)return;let Z=this.configurationProperties.identifier;this._source.kind!==t.Workspace&&(Z+=this._source.kind);const re={type:e.$xI,folder:L,id:Z};return JSON.stringify(re)}}e.$AI=l;class b extends g{constructor(L,Z,re,fe,be,oe,pe,$e,se){super(L,re,fe,$e,se,Z),this.defines=be,this.hasDefinedMatchers=pe,this.command=oe,this.icon=se.icon,this.hide=se.hide}clone(){return new b(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(L){return L instanceof b}getMapKey(){const L=this._source.workspaceFolder;return L?`${this._source.scope.toString()}|${L.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===h.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const L={type:"contributed",scope:this._source.scope,id:this._id};return L.folder=this.d(),JSON.stringify(L)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(L){return new b(L._id,L._source,L._label,L.type,L.defines,L.command,L.hasDefinedMatchers,L.runOptions,L.configurationProperties)}}e.$BI=b;class I extends g{constructor(L,Z,re,fe,be,oe){super(L,re,fe,be,oe,Z),this._source=Z}clone(){return new I(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(L){return L instanceof I}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(L){return new I(L._id,L._source,L._label,L.type,L.runOptions,L.configurationProperties)}}e.$CI=I;var S;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(S||(e.ExecutionEngine=S={})),function(N){N._default=N.Terminal}(S||(e.ExecutionEngine=S={}));var y;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(y||(e.JsonSchemaVersion=y={}));class p{constructor(L){this.c=new Map;for(let Z=0;Z<L.length;Z++)this.c.set(L[Z].uri.toString(),Z)}compare(L,Z){const re=L.getWorkspaceFolder(),fe=Z.getWorkspaceFolder();if(re&&fe){let be=this.c.get(re.uri.toString());be=be===void 0?0:be+1;let oe=this.c.get(fe.uri.toString());return oe=oe===void 0?0:oe+1,be===oe?L._label.localeCompare(Z._label):be-oe}else return!re&&fe?-1:re&&!fe?1:0}}e.$DI=p;var k;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(k||(e.TaskEventKind=k={}));var m;(function(N){N.SingleRun="singleRun",N.Background="background"})(m||(e.TaskRunType=m={}));var w;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(w||(e.TaskRunSource=w={}));var F;(function(N){function L($e){return{taskId:$e._id,taskName:$e.configurationProperties.name,runType:$e.configurationProperties.isBackground?m.Background:m.SingleRun,group:$e.configurationProperties.group,__task:$e}}function Z($e,se,Ce){return{...L($e),kind:k.Start,terminalId:se,resolvedVariables:Ce}}N.start=Z;function re($e,se,Ce){return{...L($e),kind:k.ProcessStarted,terminalId:se,processId:Ce}}N.processStarted=re;function fe($e,se,Ce){return{...L($e),kind:k.ProcessEnded,terminalId:se,exitCode:Ce}}N.processEnded=fe;function be($e,se,Ce){return{...L($e),kind:k.Terminated,exitReason:Ce,terminalId:se}}N.terminated=be;function oe($e,se,Ce){return{...L(se),kind:$e,terminalId:Ce}}N.general=oe;function pe(){return{kind:k.Changed}}N.changed=pe})(F||(e.TaskEvent=F={}));var T;(function(N){function L(re){const fe=Object.keys(re).sort();let be="";for(const oe of fe){let pe=re[oe];pe instanceof Object?pe=L(pe):typeof pe=="string"&&(pe=pe.replace(/,/g,",,")),be+=oe+","+pe+","}return be}function Z(re){const be={_key:L(re),type:re.taskType};return Object.assign(be,re),be}N.create=Z})(T||(e.KeyedTaskIdentifier=T={}));var G;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection",N.VerboseLogging="task.verboseLogging"})(G||(e.TaskSettingId=G={}));var q;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(q||(e.TasksSchemaProperties=q={}));var V;(function(N){function L(Z,re){const fe=M.$tI.get(Z.type);if(fe===void 0){const $e=O.$9n(Z);return delete $e._key,T.create($e)}const be=Object.create(null);be.type=fe.taskType;const oe=new Set;fe.required.forEach($e=>oe.add($e));const pe=fe.properties;for(const $e of Object.keys(pe)){const se=Z[$e];if(se!=null)be[$e]=se;else if(oe.has($e)){const Ce=pe[$e];if(Ce.default!==void 0)be[$e]=O.$9n(Ce.default);else switch(Ce.type){case"boolean":be[$e]=!1;break;case"number":case"integer":be[$e]=0;break;case"string":be[$e]="";break;default:re.error(E.localize(1,null,JSON.stringify(Z,void 0,0),$e));return}}}return T.create(be)}N.createTaskIdentifier=L})(V||(e.TaskDefinition=V={}))}),define(ke[251],Ie([1,0,14]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gbc=e.$fbc=void 0;class R{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,M)=>{this.b=A,this.d=M,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,E.$1)(A))}then(A,M){return this.j().then(A,M)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$fbc=R;class P extends R{constructor(){super(),this.h=!0,this.i=new E.$5}}e.$gbc=P}),define(ke[38],Ie([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kw=e.$Hw=void 0,e.$Iw=P,e.$Jw=O;class E{static{this.count=0}constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++E.count}}e.$Hw=E;const R=[];function P(M){const $=new E(M);return R[$.nid]=$,$}function O(M){return R[M].sid}class A{constructor($){this.value=$}}e.$Kw=A}),define(ke[5],Ie([1,0,38]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vM=e.$uM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$tM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var R;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(R||(e.TextEditorRevealType=R={}));var P;(function(r){r[r.UnknownInput=0]="UnknownInput",r[r.TextInput=1]="TextInput",r[r.TextDiffInput=2]="TextDiffInput",r[r.TextMergeInput=3]="TextMergeInput",r[r.NotebookInput=4]="NotebookInput",r[r.NotebookDiffInput=5]="NotebookDiffInput",r[r.CustomEditorInput=6]="CustomEditorInput",r[r.WebviewEditorInput=7]="WebviewEditorInput",r[r.TerminalEditorInput=8]="TerminalEditorInput",r[r.InteractiveEditorInput=9]="InteractiveEditorInput",r[r.ChatEditorInput=10]="ChatEditorInput",r[r.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(P||(e.TabInputKind=P={}));var O;(function(r){r[r.TAB_OPEN=0]="TAB_OPEN",r[r.TAB_CLOSE=1]="TAB_CLOSE",r[r.TAB_UPDATE=2]="TAB_UPDATE",r[r.TAB_MOVE=3]="TAB_MOVE"})(O||(e.TabModelOperationKind=O={}));var A;(function(r){r[r.Editable=0]="Editable",r[r.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var M;(function(r){r[r.Int8Array=1]="Int8Array",r[r.Uint8Array=2]="Uint8Array",r[r.Uint8ClampedArray=3]="Uint8ClampedArray",r[r.Int16Array=4]="Int16Array",r[r.Uint16Array=5]="Uint16Array",r[r.Int32Array=6]="Int32Array",r[r.Uint32Array=7]="Uint32Array",r[r.Float32Array=8]="Float32Array",r[r.Float64Array=9]="Float64Array",r[r.BigInt64Array=10]="BigInt64Array",r[r.BigUint64Array=11]="BigUint64Array"})(M||(e.WebviewMessageArrayBufferViewType=M={}));var $;(function(r){r[r.Text=1]="Text",r[r.Error=2]="Error",r[r.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var c;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(c||(e.NotebookEditorRevealType=c={}));var C;(function(r){r[r.None=0]="None",r[r.Process=1]="Process",r[r.Output=2]="Output",r[r.Hybrid=3]="Hybrid"})(C||(e.CandidatePortSource=C={}));class v{static{this.a=0}static mixin(o){return o._id=v.a++,o}}e.$tM=v;var u;(function(r){r.label="a",r.kind="b",r.detail="c",r.documentation="d",r.sortText="e",r.filterText="f",r.preselect="g",r.insertText="h",r.insertTextRules="i",r.range="j",r.commitCharacters="k",r.additionalTextEdits="l",r.kindModifier="m",r.commandIdent="n",r.commandId="o",r.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var D;(function(r){r.defaultRanges="a",r.completions="b",r.isIncomplete="c",r.duration="d"})(D||(e.ISuggestResultDtoField=D={}));var d;(function(r){r[r.Workspace=0]="Workspace",r[r.TextDocument=1]="TextDocument"})(d||(e.ExtHostTestingResource=d={})),e.$uM={MainThreadAuthentication:(0,E.$Iw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,E.$Iw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,E.$Iw)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,E.$Iw)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,E.$Iw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,E.$Iw)("MainThreadChatVariables"),MainThreadClipboard:(0,E.$Iw)("MainThreadClipboard"),MainThreadCommands:(0,E.$Iw)("MainThreadCommands"),MainThreadComments:(0,E.$Iw)("MainThreadComments"),MainThreadConfiguration:(0,E.$Iw)("MainThreadConfiguration"),MainThreadConsole:(0,E.$Iw)("MainThreadConsole"),MainThreadDebugService:(0,E.$Iw)("MainThreadDebugService"),MainThreadDecorations:(0,E.$Iw)("MainThreadDecorations"),MainThreadDiagnostics:(0,E.$Iw)("MainThreadDiagnostics"),MainThreadDialogs:(0,E.$Iw)("MainThreadDiaglogs"),MainThreadDocuments:(0,E.$Iw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,E.$Iw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,E.$Iw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,E.$Iw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,E.$Iw)("MainThreadEditorTabs"),MainThreadErrors:(0,E.$Iw)("MainThreadErrors"),MainThreadTreeViews:(0,E.$Iw)("MainThreadTreeViews"),MainThreadDownloadService:(0,E.$Iw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,E.$Iw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,E.$Iw)("MainThreadLanguages"),MainThreadLogger:(0,E.$Iw)("MainThreadLogger"),MainThreadMessageService:(0,E.$Iw)("MainThreadMessageService"),MainThreadOutputService:(0,E.$Iw)("MainThreadOutputService"),MainThreadProgress:(0,E.$Iw)("MainThreadProgress"),MainThreadQuickDiff:(0,E.$Iw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,E.$Iw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,E.$Iw)("MainThreadStatusBar"),MainThreadSecretState:(0,E.$Iw)("MainThreadSecretState"),MainThreadStorage:(0,E.$Iw)("MainThreadStorage"),MainThreadSpeech:(0,E.$Iw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,E.$Iw)("MainThreadTelemetry"),MainThreadTerminalService:(0,E.$Iw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,E.$Iw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,E.$Iw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,E.$Iw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,E.$Iw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,E.$Iw)("MainThreadCustomEditors"),MainThreadUrls:(0,E.$Iw)("MainThreadUrls"),MainThreadUriOpeners:(0,E.$Iw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,E.$Iw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,E.$Iw)("MainThreadWorkspace"),MainThreadFileSystem:(0,E.$Iw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,E.$Iw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,E.$Iw)("MainThreadExtensionService"),MainThreadSCM:(0,E.$Iw)("MainThreadSCM"),MainThreadSearch:(0,E.$Iw)("MainThreadSearch"),MainThreadShare:(0,E.$Iw)("MainThreadShare"),MainThreadTask:(0,E.$Iw)("MainThreadTask"),MainThreadWindow:(0,E.$Iw)("MainThreadWindow"),MainThreadLabelService:(0,E.$Iw)("MainThreadLabelService"),MainThreadNotebook:(0,E.$Iw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,E.$Iw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,E.$Iw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,E.$Iw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,E.$Iw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,E.$Iw)("MainThreadInteractive"),MainThreadTheming:(0,E.$Iw)("MainThreadTheming"),MainThreadTunnelService:(0,E.$Iw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,E.$Iw)("MainThreadManagedSockets"),MainThreadTimeline:(0,E.$Iw)("MainThreadTimeline"),MainThreadTesting:(0,E.$Iw)("MainThreadTesting"),MainThreadLocalization:(0,E.$Iw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,E.$Iw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,E.$Iw)("MainThreadAiEmbeddingVector")},e.$vM={ExtHostCommands:(0,E.$Iw)("ExtHostCommands"),ExtHostConfiguration:(0,E.$Iw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,E.$Iw)("ExtHostDiagnostics"),ExtHostDebugService:(0,E.$Iw)("ExtHostDebugService"),ExtHostDecorations:(0,E.$Iw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,E.$Iw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,E.$Iw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,E.$Iw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,E.$Iw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,E.$Iw)("ExtHostEditors"),ExtHostTreeViews:(0,E.$Iw)("ExtHostTreeViews"),ExtHostFileSystem:(0,E.$Iw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,E.$Iw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,E.$Iw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,E.$Iw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,E.$Iw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,E.$Iw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,E.$Iw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,E.$Iw)("ExtHostStatusBar"),ExtHostShare:(0,E.$Iw)("ExtHostShare"),ExtHostExtensionService:(0,E.$Iw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,E.$Iw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,E.$Iw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,E.$Iw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,E.$Iw)("ExtHostSCM"),ExtHostSearch:(0,E.$Iw)("ExtHostSearch"),ExtHostTask:(0,E.$Iw)("ExtHostTask"),ExtHostWorkspace:(0,E.$Iw)("ExtHostWorkspace"),ExtHostWindow:(0,E.$Iw)("ExtHostWindow"),ExtHostWebviews:(0,E.$Iw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,E.$Iw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,E.$Iw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,E.$Iw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,E.$Iw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,E.$Iw)("ExtHostEditorTabs"),ExtHostProgress:(0,E.$Iw)("ExtHostProgress"),ExtHostComments:(0,E.$Iw)("ExtHostComments"),ExtHostSecretState:(0,E.$Iw)("ExtHostSecretState"),ExtHostStorage:(0,E.$Iw)("ExtHostStorage"),ExtHostUrls:(0,E.$Iw)("ExtHostUrls"),ExtHostUriOpeners:(0,E.$Iw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,E.$Iw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,E.$Iw)("ExtHostOutputService"),ExtHostLabelService:(0,E.$Iw)("ExtHostLabelService"),ExtHostNotebook:(0,E.$Iw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,E.$Iw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,E.$Iw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,E.$Iw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,E.$Iw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,E.$Iw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,E.$Iw)("ExtHostInteractive"),ExtHostChatAgents2:(0,E.$Iw)("ExtHostChatAgents"),ExtHostChatVariables:(0,E.$Iw)("ExtHostChatVariables"),ExtHostChatProvider:(0,E.$Iw)("ExtHostChatProvider"),ExtHostSpeech:(0,E.$Iw)("ExtHostSpeech"),ExtHostEmbeddings:(0,E.$Iw)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,E.$Iw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,E.$Iw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,E.$Iw)("ExtHostTheming"),ExtHostTunnelService:(0,E.$Iw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,E.$Iw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,E.$Iw)("ExtHostAuthentication"),ExtHostTimeline:(0,E.$Iw)("ExtHostTimeline"),ExtHostTesting:(0,E.$Iw)("ExtHostTesting"),ExtHostTelemetry:(0,E.$Iw)("ExtHostTelemetry"),ExtHostLocalization:(0,E.$Iw)("ExtHostLocalization")}}),define(ke[85],Ie([1,0,3,12,5,17]),function(de,e,E,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mmc=e.$Lmc=e.$Kmc=void 0,e.$Kmc=(0,E.$Ai)("IExtHostApiDeprecationService");let A=class{constructor($,c){this.c=c,this.a=new Set,this.b=$.getProxy(P.$uM.MainThreadTelemetry)}report($,c,C){const v=this.d($,c);this.a.has(v)||(this.a.add(v),c.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${C}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:c.identifier.value,apiId:$}))}d($,c){return`${$}-${c.identifier.value}`}};e.$Lmc=A,e.$Lmc=A=He([Ve(0,O.$YO),Ve(1,R.$7j)],A),e.$Mmc=Object.freeze(new class{report(M,$,c){}})}),define(ke[252],Ie([1,0,5]),function(de,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zmc=void 0;class R{constructor(O){const A=O.getProxy(E.$uM.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(M){return A.$writeText(M)}})}}e.$Zmc=R}),define(ke[253],Ie([1,0,26,5,27,17]),function(de,e,E,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Toc=void 0;let A=class{constructor(C,v){this.a=C.getProxy(R.$uM.MainThreadConsole),this.b=v.consoleForward.includeStack,this.c=v.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(C,v){const u=this,D=console[C];Object.defineProperty(console,C,{set:()=>{},get:()=>function(){u.e(C,v,D,arguments)}})}e(C,v,u,D){this.a.$logExtensionHostMessage({type:"__$console",severity:v,arguments:$(D,this.b)}),this.c&&this.f(C,u,D)}};e.$Toc=A,e.$Toc=A=He([Ve(0,O.$YO),Ve(1,P.$cP)],A);const M=1e5;function $(c,C){const v=[];if(c.length)for(let u=0;u<c.length;u++){let D=c[u];if(typeof D>"u")D="undefined";else if(D instanceof Error){const d=D;d.stack?D=d.stack:D=d.toString()}v.push(D)}if(C){const u=new Error().stack;u&&v.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,E.$bo)(v);return u.length>M?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(ke[254],Ie([1,0,2,5,25]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wnc=void 0;class O{constructor(M){this.a=M.getProxy(R.$uM.MainThreadDialogs)}showOpenDialog(M,$){return $?.allowUIResources&&(0,P.$UG)(M,"showLocal"),this.a.$showOpenDialog($).then(c=>c?c.map(C=>E.URI.revive(C)):void 0)}showSaveDialog(M){return this.a.$showSaveDialog(M).then($=>$?E.URI.revive($):void 0)}}e.$Wnc=O}),define(ke[255],Ie([1,0,22,4,6,5]),function(de,e,E,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Znc=void 0;class A{constructor($){this.b=new Map,this.c=new R.$he,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=$.getProxy(O.$uM.MainThreadEmbeddings)}registerEmbeddingsProvider($,c,C){if(this.d.has(c))throw new Error("An embeddings provider for this model is already registered");const v=this.e++;return this.a.$registerEmbeddingProvider(v,c),this.b.set(v,{id:c,provider:C}),(0,P.$Sc)(()=>{this.a.$unregisterEmbeddingProvider(v),this.b.delete(v)})}async computeEmbeddings($,c,C){C??=E.CancellationToken.None;let v=!1;typeof c=="string"&&(c=[c],v=!0);const u=await this.a.$computeEmbeddings($,c,C);if(u.length!==c.length)throw new Error;if(v){if(u.length!==1)throw new Error;return u[0]}return u}async $provideEmbeddings($,c,C){const v=this.b.get($);if(!v)return[];const u=await v.provider.provideEmbeddings(c,C);return u||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels($){this.d=new Set($),this.c.fire()}}e.$Znc=A}),define(ke[256],Ie([1,0,6,5]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eoc=void 0;class P{constructor(A){this.b=0,this.a=A.getProxy(R.$uM.MainThreadLabelService)}$registerResourceLabelFormatter(A){const M=this.b++;return this.a.$registerResourceLabelFormatter(M,A),(0,E.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(M)})}}e.$eoc=P}),define(ke[86],Ie([1,0,21,13,2,3,12,5,27,17]),function(de,e,E,R,P,O,A,M,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fnc=e.$Enc=void 0;let C=class{constructor(u,D,d){this.f=d,this.d=new Map,this.a=D.getProxy(M.$uM.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===E.$g}getMessage(u,D){const{message:d,args:r,comment:o}=D;if(this.c)return(0,R.$af)(d,r??{});let a=d;o&&o.length>0&&(a+=`/${Array.isArray(o)?o.join(""):o}`);const h=this.d.get(u)?.contents[a];return h||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${a}`),(0,R.$af)(h??d,r??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let D;const d=await this.g(u);if(!d){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const r=await this.a.$fetchBundleContents(d),o=JSON.parse(r);D=u.isBuiltin?o.contents?.bundle:o}catch(r){this.f.error(`Failed to load translations for ${u.identifier.value} from ${d}: ${r.message}`);return}D&&this.d.set(u.identifier.value,{contents:D,uri:d})}async g(u){if(u.isBuiltin){const D=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return P.URI.revive(D)}return u.l10n?P.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Enc=C,e.$Enc=C=He([Ve(0,$.$cP),Ve(1,c.$YO),Ve(2,A.$7j)],C),e.$Fnc=(0,O.$Ai)("IExtHostLocalizationService")}),define(ke[257],Ie([1,0,12,5,27,17,2,49]),function(de,e,E,R,P,O,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Soc=void 0;let $=class extends E.$fk{constructor(v,u){super(u.logLevel,u.logsLocation,u.loggers.map(D=>(0,M.$0h)(D))),this.r=v.getProxy(R.$uM.MainThreadLogger)}$setLogLevel(v,u){u?this.setLogLevel(A.URI.revive(u),v):this.setLogLevel(v)}setVisibility(v,u){super.setVisibility(v,u),this.r.$setVisibility(v,u)}s(v,u,D){return new c(this.r,v,u,D)}};e.$Soc=$,e.$Soc=$=He([Ve(0,O.$YO),Ve(1,P.$cP)],$);class c extends E.$ak{constructor(v,u,D,d){super(d?.logLevel==="always"),this.r=v,this.s=u,this.m=!1,this.n=[],this.setLevel(D),this.r.$createLogger(u,d).then(()=>{this.u(this.n),this.m=!0})}g(v,u){const D=[[v,u]];this.m?this.u(D):this.n.push(...D)}u(v){this.r.$log(this.s,v)}flush(){this.r.$flush(this.s)}}}),define(ke[87],Ie([1,0,5,3,6,17,23]),function(de,e,E,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hnc=e.$Gnc=void 0,e.$Gnc=(0,R.$Ai)("IExtHostManagedSockets");let M=class{constructor(v){this.b=0,this.c=null,this.d=new Map,this.a=v.getProxy(E.$uM.MainThreadManagedSockets)}setFactory(v,u){for(const D of this.d.values())D.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(v,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(v){if(!this.c||this.c.socketFactoryId!==v)throw new Error(`No socket factory with id ${v}`);const u=++this.b,D=await this.c.makeConnection(),d=new P.$Tc;return this.d.set(u,new c(u,D,d)),d.add((0,P.$Sc)(()=>this.d.delete(u))),d.add(D.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),d.dispose()})),d.add(D.onDidClose(r=>{this.a.$onDidManagedSocketClose(u,r?.stack??r?.message),d.dispose()})),d.add(D.onDidReceiveMessage(r=>this.a.$onDidManagedSocketHaveData(u,A.$Je.wrap(r)))),u}$remoteSocketWrite(v,u){this.d.get(v)?.actual.send(u.buffer)}$remoteSocketEnd(v){const u=this.d.get(v);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(v){await this.d.get(v)?.actual.drain?.()}};e.$Hnc=M,e.$Hnc=M=He([Ve(0,O.$YO)],M);class ${constructor(v,u){this.socketFactoryId=v,this.makeConnection=u}}class c extends P.$Uc{constructor(v,u,D){super(),this.socketId=v,this.actual=u,this.B(D)}}}),define(ke[258],Ie([1,0,5,12,25]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$goc=void 0;function O(M){return M&&M.title}let A=class{constructor($,c){this.b=c,this.a=$.getProxy(E.$uM.MainThreadMessageService)}showMessage($,c,C,v,u){const D={source:{identifier:$.identifier,label:$.displayName||$.name}};let d;typeof v=="string"||O(v)?d=[v,...u]:(D.modal=v?.modal,D.useCustom=v?.useCustom,D.detail=v?.detail,d=u),D.useCustom&&(0,P.$UG)($,"resolvers");const r=[];let o=!1;for(let a=0;a<d.length;a++){const h=d[a];if(typeof h=="string")r.push({title:h,handle:a,isCloseAffordance:!1});else if(typeof h=="object"){const{title:t,isCloseAffordance:s}=h;r.push({title:t,isCloseAffordance:!!s,handle:a}),s&&(o?this.b.warn(`[${$.identifier}] Only one message item can have 'isCloseAffordance':`,h):o=!0)}else this.b.warn(`[${$.identifier}] Invalid message item:`,h)}return this.a.$showMessage(c,C,D,r).then(a=>{if(typeof a=="number")return d[a]})}};e.$goc=A,e.$goc=A=He([Ve(1,R.$7j)],A)}),define(ke[259],Ie([1,0,6,15,2,25,5]),function(de,e,E,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$poc=void 0;class M{constructor(c){this.b=new Map,this.a=c.getProxy(A.$uM.MainThreadProfileContentHandlers)}registerProfileContentHandler(c,C,v){if((0,O.$UG)(c,"profileContentHandlers"),this.b.has(C))throw new Error(`Handler with id '${C}' already registered`);return this.b.set(C,v),this.a.$registerProfileContentHandler(C,v.name,v.description,c.identifier.value),(0,E.$Sc)(()=>{this.b.delete(C),this.a.$unregisterProfileContentHandler(C)})}async $saveProfile(c,C,v,u){const D=this.b.get(c);if(!D)throw new Error(`Unknown handler with id: ${c}`);return D.saveProfile(C,v,u)}async $readProfile(c,C,v){const u=this.b.get(c);if(!u)throw new Error(`Unknown handler with id: ${c}`);return u.readProfile((0,R.$ag)(C)?C:P.URI.revive(C),v)}}e.$poc=M}),define(ke[88],Ie([1,0,5,4,3]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cnc=e.$Bnc=void 0;class O{constructor(M){this.b=new R.$he,this.onDidChangePassword=this.b.event,this.a=M.getProxy(E.$uM.MainThreadSecretState)}async $onDidChangePassword(M){this.b.fire(M)}get(M,$){return this.a.$getPassword(M,$)}store(M,$,c){return this.a.$setPassword(M,$,c)}delete(M,$){return this.a.$deletePassword(M,$)}}e.$Bnc=O,e.$Cnc=(0,P.$Ai)("IExtHostSecretState")}),define(ke[260],Ie([1,0,22,6,5]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$woc=void 0;class O{static{this.a=1}constructor(M){this.c=new Map,this.d=new Map,this.f=new Map,this.b=M.getProxy(P.$uM.MainThreadSpeech)}async $createSpeechToTextSession(M,$,c){const C=this.c.get(M);if(!C)return;const v=new R.$Tc,u=new E.$se;this.d.set($,u);const D=await C.provideSpeechToTextSession(u.token,c?{language:c}:void 0);D&&(v.add(D.onDidChange(d=>{u.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,d)})),v.add(u.token.onCancellationRequested(()=>v.dispose())))}async $cancelSpeechToTextSession(M){this.d.get(M)?.dispose(!0),this.d.delete(M)}async $createTextToSpeechSession(M,$,c){const C=this.c.get(M);if(!C)return;const v=new R.$Tc,u=new E.$se;this.d.set($,u);const D=await C.provideTextToSpeechSession(u.token,c?{language:c}:void 0);D&&(this.f.set($,D),v.add(D.onDidChange(d=>{u.token.isCancellationRequested||this.b.$emitTextToSpeechEvent($,d)})),v.add(u.token.onCancellationRequested(()=>v.dispose())))}async $synthesizeSpeech(M,$){this.f.get(M)?.synthesize($)}async $cancelTextToSpeechSession(M){this.d.get(M)?.dispose(!0),this.d.delete(M),this.f.delete(M)}async $createKeywordRecognitionSession(M,$){const c=this.c.get(M);if(!c)return;const C=new R.$Tc,v=new E.$se;this.d.set($,v);const u=await c.provideKeywordRecognitionSession(v.token);u&&(C.add(u.onDidChange(D=>{v.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent($,D)})),C.add(v.token.onCancellationRequested(()=>C.dispose())))}async $cancelKeywordRecognitionSession(M){this.d.get(M)?.dispose(!0),this.d.delete(M)}registerProvider(M,$,c){const C=O.a++;return this.c.set(C,c),this.b.$registerProvider(C,$,{extension:M,displayName:M.value}),(0,R.$Sc)(()=>{this.b.$unregisterProvider(C),this.c.delete(C)})}}e.$woc=O}),define(ke[89],Ie([1,0,5,4,3]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$snc=e.$rnc=void 0;class O{constructor(M,$){this.c=$,this.b=new R.$he,this.onDidChangeStorage=this.b.event,this.a=M.getProxy(E.$uM.MainThreadStorage)}registerExtensionStorageKeysToSync(M,$){this.a.$registerExtensionStorageKeysToSync(M,$)}async initializeExtensionStorage(M,$,c){const C=await this.a.$initializeExtensionStorage(M,$);let v;return C&&(v=this.d(M,$,C)),v||c}setValue(M,$,c){return this.a.$setValue(M,$,c)}$acceptValue(M,$,c){const C=this.d(M,$,c);C&&this.b.fire({shared:M,key:$,value:C})}d(M,$,c){try{return JSON.parse(c)}catch(C){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${M}): ${C}`)}}}e.$rnc=O,e.$snc=(0,P.$Ai)("IExtHostStorage")}),define(ke[261],Ie([1,0,6,16,2,5]),function(de,e,E,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Moc=void 0;class A{static{this.a=new Set([R.Schemas.http,R.Schemas.https])}constructor($){this.c=new Map,this.b=$.getProxy(O.$uM.MainThreadUriOpeners)}registerExternalUriOpener($,c,C,v){if(this.c.has(c))throw new Error(`Opener with id '${c}' already registered`);const u=v.schemes.find(D=>!A.a.has(D));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(c,C),this.b.$registerUriOpener(c,v.schemes,$,v.label),(0,E.$Sc)(()=>{this.c.delete(c),this.b.$unregisterUriOpener(c)})}async $canOpenUri($,c,C){const v=this.c.get($);if(!v)throw new Error(`Unknown opener with id: ${$}`);const u=P.URI.revive(c);return v.canOpenExternalUri(u,C)}async $openUri($,c,C){const v=this.c.get($);if(!v)throw new Error(`Unknown opener id: '${$}'`);return v.openExternalUri(P.URI.revive(c.resolvedUri),{sourceUri:P.URI.revive(c.sourceUri)},C)}}e.$Moc=A}),define(ke[262],Ie([1,0,5,2,6,14,19]),function(de,e,E,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Noc=void 0;class M{static{this.a=0}constructor(c){this.c=new A.$Xm,this.d=new Map,this.b=c.getProxy(E.$uM.MainThreadUrls)}registerUriHandler(c,C){const v=c.identifier;if(this.c.has(v))throw new Error(`Protocol handler already registered for extension ${v}`);const u=M.a++;return this.c.add(v),this.d.set(u,C),this.b.$registerUriHandler(u,v,c.displayName||c.name),(0,P.$Sc)(()=>{this.c.delete(v),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(c,C){const v=this.d.get(c);if(!v)return Promise.resolve(void 0);try{v.handleUri(R.URI.revive(C))}catch(u){(0,O.$1)(u)}return Promise.resolve(void 0)}async createAppUri(c){return R.URI.revive(await this.b.$createAppUri(c))}}e.$Noc=M}),define(ke[263],Ie([1,0,23,5]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5rb=O,e.$6rb=M;class P{constructor(){this.buffers=[]}add(c){let C=this.buffers.indexOf(c);return C<0&&(C=this.buffers.length,this.buffers.push(c)),C}}function O($,c){if(c.serializeBuffersForPostMessage){const C=new P,u=JSON.stringify($,(d,r)=>{if(r instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:C.add(r)};if(ArrayBuffer.isView(r)){const o=A(r);if(o)return{$$vscode_array_buffer_reference$$:!0,index:C.add(r.buffer),view:{type:o,byteLength:r.byteLength,byteOffset:r.byteOffset}}}return r}),D=C.buffers.map(d=>{const r=new Uint8Array(d);return E.$Je.wrap(r)});return{message:u,buffers:D}}else return{message:JSON.stringify($),buffers:[]}}function A($){switch($.constructor.name){case"Int8Array":return R.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return R.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return R.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return R.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return R.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return R.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return R.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return R.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return R.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return R.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return R.WebviewMessageArrayBufferViewType.BigUint64Array}}function M($,c){const C=c.map(D=>{const d=new ArrayBuffer(D.byteLength);return new Uint8Array(d).set(D.buffer),d}),v=c.length?(D,d)=>{if(d&&typeof d=="object"&&d.$$vscode_array_buffer_reference$$){const r=d,{index:o}=r,a=C[o];if(r.view)switch(r.view.type){case R.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array(a,r.view.byteOffset,r.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array(a,r.view.byteOffset,r.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray(a,r.view.byteOffset,r.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array(a,r.view.byteOffset,r.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array(a,r.view.byteOffset,r.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array(a,r.view.byteOffset,r.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array(a,r.view.byteOffset,r.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array(a,r.view.byteOffset,r.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array(a,r.view.byteOffset,r.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array(a,r.view.byteOffset,r.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array(a,r.view.byteOffset,r.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return a}return d}:void 0;return{message:JSON.parse($,v),arrayBuffers:C}}}),define(ke[67],Ie([1,0,4,6,16,26,2,206,263,83,5]),function(de,e,E,R,P,O,A,M,$,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$enc=e.$cnc=void 0,e.$dnc=u,e.$fnc=r,e.$gnc=o;class v{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(s,n,i,g,f,l,b){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new E.$he,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new E.$he,this._onDidDispose=this.#h.event,this.#e=s,this.#t=n,this.#o=i,this.#n=g,this.#s=f,this.#r=l,this.#l=u(l),this.#d=D(l),this.#i=b}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(s){return this.#u=!0,(0,c.$GBb)(s,this.#n)}get cspSource(){const s=this.#r.extensionLocation;if(s.scheme===P.Schemas.https||s.scheme===P.Schemas.http){let n=s.toString();return n.endsWith("/")||(n+="/"),n+" "+c.$FBb}return c.$FBb}get html(){return this.a(),this.#a}set html(s){this.a(),this.#a!==s&&(this.#a=s,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(s)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(s)))}get options(){return this.a(),this.#o}set options(s){this.a(),O.$ao(this.#o,s)||this.#t.$setOptions(this.#e,o(this.#r,this.#s,s)),this.#o=s}async postMessage(s){if(this.#c)return!1;const n=(0,$.$5rb)(s,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,n.message,...n.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(s){if(!this.#d)return s;const n=this.#r.extensionLocation?.scheme===P.Schemas.vscodeRemote,i=this.#r.extensionLocation.scheme===P.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return s.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(g,f,l,b,I,S)=>{const y=A.URI.from({scheme:b||"file",path:decodeURIComponent(I)}),p=(0,c.$GBb)(y,{isRemote:n,authority:i}).toString();return`${f}${p}${S}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(g,f,l,b,I,S)=>{const y=A.URI.from({scheme:b||"file",path:decodeURIComponent(I)}),p=(0,c.$GBb)(y,{isRemote:n,authority:i}).toString();return`${f}${p}${S}`})}}e.$cnc=v;function u(t){try{const s=(0,M.$Qp)((0,M.$Pp)(t.engines.vscode));return!!s&&s.majorBase>=1&&s.minorBase>=57}catch{return!1}}function D(t){try{const s=(0,M.$Qp)((0,M.$Pp)(t.engines.vscode));return s?s.majorBase<1||s.majorBase===1&&s.minorBase<60:!1}catch{return!1}}class d extends R.$Uc{constructor(s,n,i,g,f){super(),this.c=n,this.f=i,this.g=g,this.h=f,this.b=new Map,this.a=s.getProxy(C.$uM.MainThreadWebviews)}dispose(){super.dispose();for(const s of this.b.values())s.dispose();this.b.clear()}$onMessage(s,n,i){const g=this.j(s);if(g){const{message:f}=(0,$.$6rb)(n,i.value);g._onMessageEmitter.fire(f)}}$onMissingCsp(s,n){this.g.warn(`${n} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(s,n,i){const g=new v(s,this.a,a(n),this.c,this.f,i,this.h);this.b.set(s,g);const f=g._onDidDispose(()=>{f.dispose(),this.deleteWebview(s)});return g}deleteWebview(s){this.b.delete(s)}j(s){return this.b.get(s)}}e.$enc=d;function r(t){return{id:t.identifier,location:t.extensionLocation}}function o(t,s,n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots||h(t,s)}}function a(t){return{enableCommandUris:t.enableCommandUris,enableScripts:t.enableScripts,enableForms:t.enableForms,portMapping:t.portMapping,localResourceRoots:t.localResourceRoots?.map(s=>A.URI.from(s))}}function h(t,s){return[...(s?.getWorkspaceFolders()||[]).map(n=>n.uri),t.extensionLocation]}}),define(ke[119],Ie([1,0,4,16,13,2,3,17,5]),function(de,e,E,R,P,O,A,M,$){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qoc=e.$Poc=void 0;let C=class{static{c=this}static{this.a={focused:!0,active:!0}}getState(){const u=this.d;return{get focused(){return u.focused},get active(){return u.active}}}constructor(u){this.c=new E.$he,this.onDidChangeWindowState=this.c.event,this.d=c.a,this.b=u.getProxy($.$uM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:D,isActive:d})=>{this.onDidChangeWindowProperty("focused",D),this.onDidChangeWindowProperty("active",d)})}$onDidChangeWindowFocus(u){this.onDidChangeWindowProperty("focused",u)}$onDidChangeWindowActive(u){this.onDidChangeWindowProperty("active",u)}onDidChangeWindowProperty(u,D){D!==this.d[u]&&(this.d={...this.d,[u]:D},this.c.fire(this.d))}openUri(u,D){let d;if(typeof u=="string"){d=u;try{u=O.URI.parse(u)}catch{return Promise.reject(`Invalid uri - '${u}'`)}}return(0,P.$$e)(u.scheme)?Promise.reject("Invalid scheme - cannot be empty"):u.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${u.scheme}'`):this.b.$openUri(u,d,D)}async asExternalUri(u,D){if((0,P.$$e)(u.scheme))return Promise.reject("Invalid scheme - cannot be empty");const d=await this.b.$asExternalUri(u,D);return O.URI.from(d)}};e.$Poc=C,e.$Poc=C=c=He([Ve(0,M.$YO)],C),e.$Qoc=(0,A.$Ai)("IExtHostWindow")}),define(ke[264],Ie([1,0,253,27,17]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4qc=void 0;let O=class extends E.$Toc{constructor(M,$){super(M,$)}f(M,$,c){$.apply(console,c)}};e.$4qc=O,e.$4qc=O=He([Ve(0,P.$YO),Ve(1,R.$cP)],O)}),define(ke[265],Ie([1,0,11,23,22,28,14,4,6,37,159,251,38]),function(de,e,E,R,P,O,A,M,$,c,C,v,u){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$jbc=e.ResponsiveState=e.RequestInitiator=void 0,e.$hbc=h,e.$ibc=t;function d(F,T){try{return JSON.stringify(F,T)}catch{return"null"}}const r="$$ref$$",o={[r]:-1};class a{constructor(T,G){this.jsonString=T,this.referencedBuffers=G}}function h(F,T=null,G=!1){const q=[];return{jsonString:(G?d:JSON.stringify)(F,(N,L)=>{if(typeof L>"u")return o;if(typeof L=="object"){if(L instanceof R.$Je){const Z=q.push(L)-1;return{[r]:Z}}if(T)return T(N,L)}return L}),referencedBuffers:q}}function t(F,T,G){return JSON.parse(F,(q,V)=>{if(V){const N=V[r];if(typeof N=="number")return T[N];if(G&&V.$mid===c.MarshalledId.Uri)return G.transformIncoming(V)}return V})}function s(F,T){return JSON.stringify(F,T)}function n(F){return F?(T,G)=>G&&G.$mid===c.MarshalledId.Uri?F.transformOutgoing(G):G:null}var i;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(i||(e.RequestInitiator=i={}));var g;(function(F){F[F.Responsive=0]="Responsive",F[F.Unresponsive=1]="Unresponsive"})(g||(e.ResponsiveState=g={}));const f=()=>{},l=Symbol.for("rpcProtocol"),b=Symbol.for("rpcProxy");class I extends $.$Uc{static{D=l}static{this.a=3*1e3}constructor(T,G=null,q=null){super(),this[D]=!0,this.b=this.B(new M.$he),this.onDidChangeResponsiveState=this.b.event,this.c=T,this.f=G,this.g=q,this.h=n(this.g),this.j=!1,this.m=[],this.s=[];for(let V=0,N=u.$Hw.count;V<N;V++)this.m[V]=null,this.s[V]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=g.Responsive,this.z=0,this.C=0,this.D=this.B(new E.$Mh(()=>this.H(),1e3)),this.c.onMessage(V=>this.L(V))}dispose(){this.j=!0,Object.keys(this.w).forEach(T=>{const G=this.w[T];delete this.w[T],G.resolveErr(A.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(T){this.z===0&&(this.C=Date.now()+I.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(T){this.C=Date.now()+I.a,this.z--,this.z===0&&this.D.cancel(),this.I(g.Responsive)}H(){this.z!==0&&(Date.now()>this.C?this.I(g.Unresponsive):this.D.schedule())}I(T){this.y!==T&&(this.y=T,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(T){return this.g?(0,C.$Gn)(T,this.g):T}getProxy(T){const{nid:G,sid:q}=T;return this.s[G]||(this.s[G]=this.J(G,q)),this.s[G]}J(T,G){const q={get:(V,N)=>(typeof N=="string"&&!V[N]&&N.charCodeAt(0)===O.CharCode.DollarSign&&(V[N]=(...L)=>this.U(T,N,L)),N===b?G:V[N])};return new Proxy(Object.create(null),q)}set(T,G){return this.m[T.nid]=G,G}assertRegistered(T){for(let G=0,q=T.length;G<q;G++){const V=T[G];if(!this.m[V.nid])throw new Error(`Missing proxy instance ${V.sid}`)}}L(T){if(this.j)return;const G=T.byteLength,q=y.read(T,0),V=q.readUInt8(),N=q.readUInt32();switch(V){case m.RequestJSONArgs:case m.RequestJSONArgsWithCancellation:{let{rpcId:L,method:Z,args:re}=k.deserializeRequestJSONArgs(q);this.g&&(re=(0,C.$Gn)(re,this.g)),this.M(G,N,L,Z,re,V===m.RequestJSONArgsWithCancellation);break}case m.RequestMixedArgs:case m.RequestMixedArgsWithCancellation:{let{rpcId:L,method:Z,args:re}=k.deserializeRequestMixedArgs(q);this.g&&(re=(0,C.$Gn)(re,this.g)),this.M(G,N,L,Z,re,V===m.RequestMixedArgsWithCancellation);break}case m.Acknowledged:{this.f?.logIncoming(G,N,i.LocalSide,"ack"),this.G(N);break}case m.Cancel:{this.N(G,N);break}case m.ReplyOKEmpty:{this.O(G,N,void 0);break}case m.ReplyOKJSON:{let L=k.deserializeReplyOKJSON(q);this.g&&(L=(0,C.$Gn)(L,this.g)),this.O(G,N,L);break}case m.ReplyOKJSONWithBuffers:{const L=k.deserializeReplyOKJSONWithBuffers(q,this.g);this.O(G,N,L);break}case m.ReplyOKVSBuffer:{const L=k.deserializeReplyOKVSBuffer(q);this.O(G,N,L);break}case m.ReplyErrError:{let L=k.deserializeReplyErrError(q);this.g&&(L=(0,C.$Gn)(L,this.g)),this.P(G,N,L);break}case m.ReplyErrEmpty:{this.P(G,N,void 0);break}default:console.error("received unexpected message"),console.error(T)}}M(T,G,q,V,N,L){this.f?.logIncoming(T,G,i.OtherSide,`receiveRequest ${(0,u.$Jw)(q)}.${V}(`,N);const Z=String(G);let re,fe;if(L){const oe=new P.$se;N.push(oe.token),re=this.Q(q,V,N),fe=()=>oe.cancel()}else re=this.Q(q,V,N),fe=f;this.u[Z]=fe;const be=k.serializeAcknowledged(G);this.f?.logOutgoing(be.byteLength,G,i.OtherSide,"ack"),this.c.send(be),re.then(oe=>{delete this.u[Z];const pe=k.serializeReplyOK(G,oe,this.h);this.f?.logOutgoing(pe.byteLength,G,i.OtherSide,"reply:",oe),this.c.send(pe)},oe=>{delete this.u[Z];const pe=k.serializeReplyErr(G,oe);this.f?.logOutgoing(pe.byteLength,G,i.OtherSide,"replyErr:",oe),this.c.send(pe)})}N(T,G){this.f?.logIncoming(T,G,i.OtherSide,"receiveCancel");const q=String(G);this.u[q]?.()}O(T,G,q){this.f?.logIncoming(T,G,i.LocalSide,"receiveReply:",q);const V=String(G);if(!this.w.hasOwnProperty(V))return;const N=this.w[V];delete this.w[V],N.resolveOk(q)}P(T,G,q){this.f?.logIncoming(T,G,i.LocalSide,"receiveReplyErr:",q);const V=String(G);if(!this.w.hasOwnProperty(V))return;const N=this.w[V];delete this.w[V];let L;q&&(q.$isError?(L=new Error,L.name=q.name,L.message=q.message,L.stack=q.stack):L=q),N.resolveErr(L)}Q(T,G,q){try{return Promise.resolve(this.S(T,G,q))}catch(V){return Promise.reject(V)}}S(T,G,q){const V=this.m[T];if(!V)throw new Error("Unknown actor "+(0,u.$Jw)(T));const N=V[G];if(typeof N!="function")throw new Error("Unknown method "+G+" on actor "+(0,u.$Jw)(T));return N.apply(V,q)}U(T,G,q){if(this.j)return new v.$gbc;let V=null;if(q.length>0&&P.CancellationToken.isCancellationToken(q[q.length-1])&&(V=q.pop()),V&&V.isCancellationRequested)return Promise.reject(A.$6());const N=k.serializeRequestArguments(q,this.h),L=++this.t,Z=String(L),re=new v.$fbc,fe=new $.$Tc;V&&fe.add(V.onCancellationRequested(()=>{const oe=k.serializeCancel(L);this.f?.logOutgoing(oe.byteLength,L,i.LocalSide,"cancel"),this.c.send(k.serializeCancel(L))})),this.w[Z]=new S(re,fe),this.F(L);const be=k.serializeRequest(L,T,G,N,!!V);return this.f?.logOutgoing(be.byteLength,L,i.LocalSide,`request: ${(0,u.$Jw)(T)}.${G}(`,q),this.c.send(be),re}}e.$jbc=I;class S{constructor(T,G){this.a=T,this.b=G}resolveOk(T){this.a.resolveOk(T),this.b.dispose()}resolveErr(T){this.a.resolveErr(T),this.b.dispose()}}class y{static alloc(T,G,q){const V=new y(R.$Je.alloc(q+1+4),0);return V.writeUInt8(T),V.writeUInt32(G),V}static read(T,G){return new y(T,G)}get buffer(){return this.a}constructor(T,G){this.a=T,this.b=G}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(T){this.a.writeUInt8(T,this.b),this.b+=1}readUInt8(){const T=this.a.readUInt8(this.b);return this.b+=1,T}writeUInt32(T){this.a.writeUInt32BE(T,this.b),this.b+=4}readUInt32(){const T=this.a.readUInt32BE(this.b);return this.b+=4,T}static sizeShortString(T){return 1+T.byteLength}writeShortString(T){this.a.writeUInt8(T.byteLength,this.b),this.b+=1,this.a.set(T,this.b),this.b+=T.byteLength}readShortString(){const T=this.a.readUInt8(this.b);this.b+=1;const q=this.a.slice(this.b,this.b+T).toString();return this.b+=T,q}static sizeLongString(T){return 4+T.byteLength}writeLongString(T){this.a.writeUInt32BE(T.byteLength,this.b),this.b+=4,this.a.set(T,this.b),this.b+=T.byteLength}readLongString(){const T=this.a.readUInt32BE(this.b);this.b+=4;const q=this.a.slice(this.b,this.b+T).toString();return this.b+=T,q}writeBuffer(T){this.a.writeUInt32BE(T.byteLength,this.b),this.b+=4,this.a.set(T,this.b),this.b+=T.byteLength}static sizeVSBuffer(T){return 4+T.byteLength}writeVSBuffer(T){this.a.writeUInt32BE(T.byteLength,this.b),this.b+=4,this.a.set(T,this.b),this.b+=T.byteLength}readVSBuffer(){const T=this.a.readUInt32BE(this.b);this.b+=4;const G=this.a.slice(this.b,this.b+T);return this.b+=T,G}static sizeMixedArray(T){let G=0;G+=1;for(let q=0,V=T.length;q<V;q++){const N=T[q];switch(G+=1,N.type){case w.String:G+=this.sizeLongString(N.value);break;case w.VSBuffer:G+=this.sizeVSBuffer(N.value);break;case w.SerializedObjectWithBuffers:G+=this.sizeUInt32,G+=this.sizeLongString(N.value);for(let L=0;L<N.buffers.length;++L)G+=this.sizeVSBuffer(N.buffers[L]);break;case w.Undefined:break}}return G}writeMixedArray(T){this.a.writeUInt8(T.length,this.b),this.b+=1;for(let G=0,q=T.length;G<q;G++){const V=T[G];switch(V.type){case w.String:this.writeUInt8(w.String),this.writeLongString(V.value);break;case w.VSBuffer:this.writeUInt8(w.VSBuffer),this.writeVSBuffer(V.value);break;case w.SerializedObjectWithBuffers:this.writeUInt8(w.SerializedObjectWithBuffers),this.writeUInt32(V.buffers.length),this.writeLongString(V.value);for(let N=0;N<V.buffers.length;++N)this.writeBuffer(V.buffers[N]);break;case w.Undefined:this.writeUInt8(w.Undefined);break}}}readMixedArray(){const T=this.a.readUInt8(this.b);this.b+=1;const G=new Array(T);for(let q=0;q<T;q++)switch(this.readUInt8()){case w.String:G[q]=this.readLongString();break;case w.VSBuffer:G[q]=this.readVSBuffer();break;case w.SerializedObjectWithBuffers:{const N=this.readUInt32(),L=this.readLongString(),Z=[];for(let re=0;re<N;++re)Z.push(this.readVSBuffer());G[q]=new u.$Kw(t(L,Z,null));break}case w.Undefined:G[q]=void 0;break}return G}}var p;(function(F){F[F.Simple=0]="Simple",F[F.Mixed=1]="Mixed"})(p||(p={}));class k{static a(T){for(let G=0,q=T.length;G<q;G++)if(T[G]instanceof R.$Je||T[G]instanceof u.$Kw||typeof T[G]>"u")return!0;return!1}static serializeRequestArguments(T,G){if(this.a(T)){const q=[];for(let V=0,N=T.length;V<N;V++){const L=T[V];if(L instanceof R.$Je)q[V]={type:w.VSBuffer,value:L};else if(typeof L>"u")q[V]={type:w.Undefined};else if(L instanceof u.$Kw){const{jsonString:Z,referencedBuffers:re}=h(L.value,G);q[V]={type:w.SerializedObjectWithBuffers,value:R.$Je.fromString(Z),buffers:re}}else q[V]={type:w.String,value:R.$Je.fromString(s(L,G))}}return{type:p.Mixed,args:q}}return{type:p.Simple,args:s(T,G)}}static serializeRequest(T,G,q,V,N){switch(V.type){case p.Simple:return this.b(T,G,q,V.args,N);case p.Mixed:return this.c(T,G,q,V.args,N)}}static b(T,G,q,V,N){const L=R.$Je.fromString(q),Z=R.$Je.fromString(V);let re=0;re+=y.sizeUInt8(),re+=y.sizeShortString(L),re+=y.sizeLongString(Z);const fe=y.alloc(N?m.RequestJSONArgsWithCancellation:m.RequestJSONArgs,T,re);return fe.writeUInt8(G),fe.writeShortString(L),fe.writeLongString(Z),fe.buffer}static deserializeRequestJSONArgs(T){const G=T.readUInt8(),q=T.readShortString(),V=T.readLongString();return{rpcId:G,method:q,args:JSON.parse(V)}}static c(T,G,q,V,N){const L=R.$Je.fromString(q);let Z=0;Z+=y.sizeUInt8(),Z+=y.sizeShortString(L),Z+=y.sizeMixedArray(V);const re=y.alloc(N?m.RequestMixedArgsWithCancellation:m.RequestMixedArgs,T,Z);return re.writeUInt8(G),re.writeShortString(L),re.writeMixedArray(V),re.buffer}static deserializeRequestMixedArgs(T){const G=T.readUInt8(),q=T.readShortString(),V=T.readMixedArray(),N=new Array(V.length);for(let L=0,Z=V.length;L<Z;L++){const re=V[L];typeof re=="string"?N[L]=JSON.parse(re):N[L]=re}return{rpcId:G,method:q,args:N}}static serializeAcknowledged(T){return y.alloc(m.Acknowledged,T,0).buffer}static serializeCancel(T){return y.alloc(m.Cancel,T,0).buffer}static serializeReplyOK(T,G,q){if(typeof G>"u")return this.d(T);if(G instanceof R.$Je)return this.e(T,G);if(G instanceof u.$Kw){const{jsonString:V,referencedBuffers:N}=h(G.value,q,!0);return this.g(T,V,N)}else return this.f(T,d(G,q))}static d(T){return y.alloc(m.ReplyOKEmpty,T,0).buffer}static e(T,G){let q=0;q+=y.sizeVSBuffer(G);const V=y.alloc(m.ReplyOKVSBuffer,T,q);return V.writeVSBuffer(G),V.buffer}static deserializeReplyOKVSBuffer(T){return T.readVSBuffer()}static f(T,G){const q=R.$Je.fromString(G);let V=0;V+=y.sizeLongString(q);const N=y.alloc(m.ReplyOKJSON,T,V);return N.writeLongString(q),N.buffer}static g(T,G,q){const V=R.$Je.fromString(G);let N=0;N+=y.sizeUInt32,N+=y.sizeLongString(V);for(const Z of q)N+=y.sizeVSBuffer(Z);const L=y.alloc(m.ReplyOKJSONWithBuffers,T,N);L.writeUInt32(q.length),L.writeLongString(V);for(const Z of q)L.writeBuffer(Z);return L.buffer}static deserializeReplyOKJSON(T){const G=T.readLongString();return JSON.parse(G)}static deserializeReplyOKJSONWithBuffers(T,G){const q=T.readUInt32(),V=T.readLongString(),N=[];for(let L=0;L<q;++L)N.push(T.readVSBuffer());return new u.$Kw(t(V,N,G))}static serializeReplyErr(T,G){const q=G?d(A.$3(G),null):void 0;if(typeof q!="string")return this.h(T);const V=R.$Je.fromString(q);let N=0;N+=y.sizeLongString(V);const L=y.alloc(m.ReplyErrError,T,N);return L.writeLongString(V),L.buffer}static deserializeReplyErrError(T){const G=T.readLongString();return JSON.parse(G)}static h(T){return y.alloc(m.ReplyErrEmpty,T,0).buffer}}var m;(function(F){F[F.RequestJSONArgs=1]="RequestJSONArgs",F[F.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",F[F.RequestMixedArgs=3]="RequestMixedArgs",F[F.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",F[F.Acknowledged=5]="Acknowledged",F[F.Cancel=6]="Cancel",F[F.ReplyOKEmpty=7]="ReplyOKEmpty",F[F.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",F[F.ReplyOKJSON=9]="ReplyOKJSON",F[F.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",F[F.ReplyErrError=11]="ReplyErrError",F[F.ReplyErrEmpty=12]="ReplyErrEmpty"})(m||(m={}));var w;(function(F){F[F.String=1]="String",F[F.VSBuffer=2]="VSBuffer",F[F.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",F[F.Undefined=4]="Undefined"})(w||(w={}))}),define(ke[266],Ie([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6qc=void 0;const E=function(O){const A=M=>{globalThis.removeEventListener("message",A);const $=M.data;Object.defineProperties(globalThis,{postMessage:{value(c,C){$.postMessage(c,C)}},onmessage:{get(){return $.onmessage},set(c){$.onmessage=c}}}),$.addEventListener("message",c=>{globalThis.dispatchEvent(new MessageEvent("message",{data:c.data,ports:c.ports?[...c.ports]:void 0}))}),$.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(O)};globalThis.addEventListener("message",A)}.toString();class R extends EventTarget{constructor(O,A,M){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const $=`((${E})('${A}'))`,c=new Blob([$],{type:"application/javascript"}),C=URL.createObjectURL(c),v=new MessageChannel,u=C,D={type:"_newWorker",id:u,port:v.port2,url:C,options:M};O(D,[v.port2]),this.postMessage=v.port1.postMessage.bind(v.port1),this.terminate=()=>{O({type:"_terminateWorker",id:u}),URL.revokeObjectURL(C),v.port1.close(),v.port2.close()},Object.defineProperties(this,{onmessage:{get(){return v.port1.onmessage},set(d){v.port1.onmessage=d}},onmessageerror:{get(){return v.port1.onmessageerror},set(d){v.port1.onmessageerror=d}}}),v.port1.addEventListener("messageerror",d=>{const r=new MessageEvent("messageerror",{data:d.data});this.dispatchEvent(r)}),v.port1.addEventListener("message",d=>{const r=new MessageEvent("message",{data:d.data});this.dispatchEvent(r)}),v.port1.start()}}e.$6qc=R}),define(ke[267],Ie([1,0,23,29,16,60,3]),function(de,e,E,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$J=e.$8J=void 0,e.$9J=C,e.$0J=v,e.$8J=(0,A.$Ai)("notebookDocumentService");const M=["W","X","Y","Z","a","b","c","d","e","f"],$=new RegExp(`^[${M.join("")}]+`),c=7;function C(D){if(D.scheme!==P.Schemas.vscodeNotebookCell)return;const d=D.fragment.indexOf("s");if(d<0)return;const r=parseInt(D.fragment.substring(0,d).replace($,""),c),o=(0,E.$3e)(D.fragment.substring(d+1)).toString();if(!isNaN(r))return{handle:r,notebook:D.with({scheme:o,fragment:null})}}function v(D,d){const r=d.toString(c),a=`${r.length<M.length?M[r.length-1]:"z"}${r}s${(0,E.$4e)(E.$Je.fromString(D.scheme),!0,!0)}`;return D.with({scheme:P.Schemas.vscodeNotebookCell,fragment:a})}class u{constructor(){this.a=new R.$Ac}getNotebook(d){if(d.scheme===P.Schemas.vscodeNotebookCell){const r=C(d);if(r){const o=this.a.get(r.notebook);if(o)return o}}return this.a.get(d)}addNotebookDocument(d){this.a.set(d.uri,d)}removeNotebookDocument(d){this.a.delete(d.uri)}}e.$$J=u,(0,O.$Fs)(e.$8J,u,O.InstantiationType.Delayed)}),define(ke[90],Ie([1,0,23,41,40,73,16,20,21,32,267]),function(de,e,E,R,P,O,A,M,$,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sK=e.$pK=e.CellStatusbarAlignment=e.$oK=e.NotebookEditorPriority=e.$lK=e.$kK=e.$iK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$hK=e.$gK=e.$fK=e.$eK=e.CellKind=e.$dK=e.$cK=e.$bK=void 0,e.$jK=g,e.$mK=l,e.$nK=b,e.$qK=y,e.$rK=k,e.$bK="workbench.editor.notebook",e.$cK="workbench.editor.notebookTextDiffEditor",e.$dK="workbench.editor.interactive";var v;(function(L){L[L.Markup=1]="Markup",L[L.Code=2]="Code"})(v||(e.CellKind=v={})),e.$eK=["application/json","application/javascript","text/html","image/svg+xml",O.$Ys.latex,O.$Ys.markdown,"image/png","image/jpeg",O.$Ys.text],e.$fK=[O.$Ys.latex,O.$Ys.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",O.$Ys.text],e.$gK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$hK="_notAvailable";var u;(function(L){L[L.Running=1]="Running",L[L.Idle=2]="Idle"})(u||(e.NotebookRunState=u={}));var D;(function(L){L[L.Unconfirmed=1]="Unconfirmed",L[L.Pending=2]="Pending",L[L.Executing=3]="Executing"})(D||(e.NotebookCellExecutionState=D={}));var d;(function(L){L[L.Unconfirmed=1]="Unconfirmed",L[L.Pending=2]="Pending",L[L.Executing=3]="Executing"})(d||(e.NotebookExecutionState=d={}));var r;(function(L){L[L.WithHardKernelDependency=0]="WithHardKernelDependency",L[L.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",L[L.Pure=2]="Pure",L[L.Never=3]="Never"})(r||(e.NotebookRendererMatch=r={}));var o;(function(L){L.Always="always",L.Never="never",L.Optional="optional"})(o||(e.RendererMessagingSpec=o={}));var a;(function(L){L[L.ModelChange=1]="ModelChange",L[L.Move=2]="Move",L[L.ChangeCellLanguage=5]="ChangeCellLanguage",L[L.Initialize=6]="Initialize",L[L.ChangeCellMetadata=7]="ChangeCellMetadata",L[L.Output=8]="Output",L[L.OutputItem=9]="OutputItem",L[L.ChangeCellContent=10]="ChangeCellContent",L[L.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",L[L.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",L[L.ChangeCellMime=13]="ChangeCellMime",L[L.Unknown=100]="Unknown"})(a||(e.NotebookCellsChangeType=a={}));var h;(function(L){L[L.Handle=0]="Handle",L[L.Index=1]="Index"})(h||(e.SelectionStateType=h={}));var t;(function(L){L[L.Replace=1]="Replace",L[L.Output=2]="Output",L[L.Metadata=3]="Metadata",L[L.CellLanguage=4]="CellLanguage",L[L.DocumentMetadata=5]="DocumentMetadata",L[L.Move=6]="Move",L[L.OutputItems=7]="OutputItems",L[L.PartialMetadata=8]="PartialMetadata",L[L.PartialInternalMetadata=9]="PartialInternalMetadata"})(t||(e.CellEditType=t={}));var s;(function(L){L.scheme=A.Schemas.vscodeNotebookCell;function Z($e,se){return(0,C.$0J)($e,se)}L.generate=Z;function re($e){return(0,C.$9J)($e)}L.parse=re;function fe($e,se){return $e.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${se??""},${$e.scheme!==A.Schemas.file?$e.scheme:""}`})}L.generateCellOutputUri=fe;function be($e){if($e.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const se=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec($e.fragment);if(!se)return;const Ce=se[1]&&se[1]!==""?se[1]:void 0,Fe=se[2];return{outputId:Ce,notebook:$e.with({scheme:Fe||A.Schemas.file,fragment:null})}}L.parseCellOutputUri=be;function oe($e,se,Ce){return L.generate($e,se).with({scheme:Ce})}L.generateCellPropertyUri=oe;function pe($e,se){if($e.scheme===se)return L.parse($e.with({scheme:L.scheme}))}L.parseCellPropertyUri=pe})(s||(e.CellUri=s={}));const n=L=>$.$i?L.replace(/\//g,"\\"):L;class i{constructor(Z=[],re=e.$eK){this.e=re,this.d=[...new Set(Z)].map(fe=>({pattern:fe,matches:R.$uk(n(fe))}))}sort(Z){const re=new Map(P.Iterable.map(Z,be=>[be,n(be)]));let fe=[];for(const{matches:be}of this.d)for(const[oe,pe]of re)if(be(pe)){fe.push(oe),re.delete(oe);break}return re.size&&(fe=fe.concat([...re.keys()].sort((be,oe)=>this.e.indexOf(be)-this.e.indexOf(oe)))),fe}prioritize(Z,re){const fe=this.f(Z);if(fe===-1){this.d.unshift({pattern:Z,matches:R.$uk(n(Z))});return}const be=new Set(re.map(pe=>this.f(pe,fe)));be.delete(-1);const oe=Array.from(be).sort();this.d.splice(fe+1,0,...oe.map(pe=>this.d[pe]));for(let pe=oe.length-1;pe>=0;pe--)this.d.splice(oe[pe],1)}toArray(){return this.d.map(Z=>Z.pattern)}f(Z,re=this.d.length){const fe=n(Z);for(let be=0;be<re;be++)if(this.d[be].matches(fe))return be;return-1}}e.$iK=i;function g(L,Z,re,fe=(be,oe)=>be===oe){const be=[];function oe(se,Ce,Fe){if(Ce===0&&Fe.length===0)return;const X=be[be.length-1];X&&X.start+X.deleteCount===se?(X.deleteCount+=Ce,X.toInsert.push(...Fe)):be.push({start:se,deleteCount:Ce,toInsert:Fe})}let pe=0,$e=0;for(;;){if(pe===L.length){oe(pe,0,Z.slice($e));break}if($e===Z.length){oe(pe,L.length-pe,[]);break}const se=L[pe],Ce=Z[$e];if(fe(se,Ce)){pe+=1,$e+=1;continue}re(Ce)?(oe(pe,1,[]),pe+=1):(oe(pe,0,[Ce]),$e+=1)}return be}e.$kK=new c.$Rj("notebookEditorCursorAtBoundary","none"),e.$lK=new c.$Rj("notebookEditorCursorAtLineBoundary","none");var f;(function(L){L.default="default",L.option="option"})(f||(e.NotebookEditorPriority=f={}));function l(L){const Z=L;return!!((typeof Z.include=="string"||R.$vk(Z.include))&&(typeof Z.exclude=="string"||R.$vk(Z.exclude)))}function b(L,Z,re){if(Array.isArray(L.viewType)&&L.viewType.indexOf(Z)>=0||L.viewType===Z)return!0;if(L.filenamePattern){const fe=l(L.filenamePattern)?L.filenamePattern.include:L.filenamePattern,be=l(L.filenamePattern)?L.filenamePattern.exclude:void 0;if(R.$tk(fe,(0,M.$nc)(re.fsPath).toLowerCase()))return!(be&&R.$tk(be,(0,M.$nc)(re.fsPath).toLowerCase()))}return!1}e.$oK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",findScope:"notebook.experimental.find.scope.enabled",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var I;(function(L){L[L.Left=1]="Left",L[L.Right=2]="Right"})(I||(e.CellStatusbarAlignment=I={}));class S{static{this.d="notebook/"}static create(Z){return`${S.d}${Z}`}static parse(Z){if(Z.startsWith(S.d))return Z.substring(S.d.length)}}e.$pK=S;function y(L){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(L)}const p=new TextDecoder;function k(L){const Z=[];let re=!1;for(const pe of L)(Z.length===0||re)&&(Z.push(pe),re=!0);let fe=F(Z);const be=E.$Je.concat(Z.map(pe=>E.$Je.wrap(pe))),oe=N(be);return fe=fe||oe.byteLength!==be.byteLength,{data:oe,didCompression:fe}}e.$sK="\x1B[A";const m=e.$sK.split("").map(L=>L.charCodeAt(0)),w=10;function F(L){let Z=!1;return L.forEach((re,fe)=>{if(fe===0||re.length<e.$sK.length)return;const be=L[fe-1],oe=re.subarray(0,e.$sK.length);if(oe[0]===m[0]&&oe[1]===m[1]&&oe[2]===m[2]){const pe=be.lastIndexOf(w);if(pe===-1)return;Z=!0,L[fe-1]=be.subarray(0,pe),L[fe]=re.subarray(e.$sK.length)}}),Z}function T(L){let Z=L;do L=Z,Z=L.replace(/[^\n]\x08/gm,"");while(Z.length<L.length);return L}function G(L){for(L=L.replace(/\r+\n/gm,`
`);L.search(/\r[^$]/g)>-1;){const Z=L.match(/^(.*)\r+/m)[1];let re=L.match(/\r+(.*)$/m)[1];re=re+Z.slice(re.length,Z.length),L=L.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,re)}return L}const q=8,V=13;function N(L){return!L.buffer.includes(q)&&!L.buffer.includes(V)?L:E.$Je.fromString(G(T(p.decode(L.buffer))))}}),define(ke[7],Ie([1,0,18,14,59,29,73,13,15,2,36,19,30,108,90]),function(de,e,E,R,P,O,A,M,$,c,C,v,u,D,d){"use strict";var r,o,a,h,t,s,n,i,g,f,l,b,I,S,y,p,k;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$MO=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$LO=e.$KO=e.$JO=e.$IO=e.$HO=e.LanguageModelChatMessageRole=e.ChatLocation=e.$GO=e.$FO=e.$EO=e.$DO=e.$CO=e.$BO=e.$AO=e.$zO=e.$yO=e.$xO=e.$wO=e.$vO=e.$uO=e.$tO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$sO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$rO=e.$qO=e.$pO=e.$oO=e.$nO=e.$mO=e.$lO=e.$kO=e.$jO=e.$iO=e.$hO=e.$gO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$fO=e.$eO=e.$dO=e.$cO=e.$aO=e.$_N=e.$$N=e.$0N=e.TestRunProfileKind=e.TestResultState=e.$9N=e.$8N=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$7N=e.NotebookVariablesRequestKind=e.$6N=e.$5N=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$4N=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$3N=e.$2N=e.$1N=e.$ZN=e.$YN=e.ColorThemeKind=e.$XN=e.$WN=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$VN=e.$UN=e.DebugConsoleMode=e.$TN=e.$SN=e.$RN=e.$QN=e.$PN=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$ON=e.$NN=e.FileChangeType=e.$MN=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$LN=e.$KN=e.$JN=e.$IN=e.InlineCompletionTriggerKind=e.$HN=e.$GN=e.$FN=e.$EN=e.$DN=e.$CN=e.$BN=e.$AN=e.$zN=e.$yN=e.$xN=e.$vN=e.ConfigurationTarget=e.$uN=e.$tN=e.$sN=e.$rN=e.DocumentPasteTriggerKind=e.$qN=e.$pN=e.$oN=e.$nN=e.$mN=e.$lN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$kN=e.ViewBadge=e.ProgressLocation=e.$jN=e.$iN=e.TaskScope=e.ShellQuoting=e.$hN=e.$gN=e.$fN=e.TaskPanelKind=e.TaskRevealKind=e.$eN=e.TerminalLocation=e.$dN=e.$cN=e.$bN=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$aN=e.$_M=e.$$M=e.$0M=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$8M=e.$7M=e.$6M=e.$5M=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$4M=e.$3M=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$2M=e.$1M=e.$ZM=e.$YM=e.$XM=e.LanguageStatusSeverity=e.$WM=e.$VM=e.$UM=e.$TM=e.$SM=e.$RM=e.CodeActionTriggerKind=e.$QM=e.$PM=e.SymbolTag=e.SymbolKind=e.$OM=e.$NM=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$MM=e.$LM=e.$KM=e.$JM=e.$IM=e.DiagnosticSeverity=e.DiagnosticTag=e.$HM=e.$GM=e.FileEditType=e.$FM=e.$EM=e.$DM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$CM=e.$BM=e.$AM=e.$zM=e.$yM=e.$xM=e.$wM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$9M=ct,e.$wN=Ri,e.$bO=En;function m(B){return Object.assign(B,{apply:function(...ne){if(ne.length===0)return Reflect.construct(B,[]);{const De=ne.length===1?[]:ne[1];return Reflect.construct(B,De,ne[0].constructor)}},call:function(...ne){if(ne.length===0)return Reflect.construct(B,[]);{const[De,...Je]=ne;return Reflect.construct(B,Je,De.constructor)}}})}var w;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(w||(e.TerminalOutputAnchor=w={}));var F;(function(B){B[B.TerminalCommand=0]="TerminalCommand",B[B.Opener=1]="Opener",B[B.Command=3]="Command"})(F||(e.TerminalQuickFixType=F={}));let T=r=class{static from(...U){let ne=U;return new r(function(){if(ne){for(const De of ne)De&&typeof De.dispose=="function"&&De.dispose();ne=void 0}})}#e;constructor(U){this.#e=U}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$wM=T,e.$wM=T=r=He([m],T);let G=o=class{static Min(...U){if(U.length===0)throw new TypeError;let ne=U[0];for(let De=1;De<U.length;De++){const Je=U[De];Je.isBefore(ne)&&(ne=Je)}return ne}static Max(...U){if(U.length===0)throw new TypeError;let ne=U[0];for(let De=1;De<U.length;De++){const Je=U[De];Je.isAfter(ne)&&(ne=Je)}return ne}static isPosition(U){if(!U)return!1;if(U instanceof o)return!0;const{line:ne,character:De}=U;return typeof ne=="number"&&typeof De=="number"}static of(U){if(U instanceof o)return U;if(this.isPosition(U))return new o(U.line,U.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(U,ne){if(U<0)throw(0,R.$7)("line must be non-negative");if(ne<0)throw(0,R.$7)("character must be non-negative");this.c=U,this.e=ne}isBefore(U){return this.c<U.c?!0:U.c<this.c?!1:this.e<U.e}isBeforeOrEqual(U){return this.c<U.c?!0:U.c<this.c?!1:this.e<=U.e}isAfter(U){return!this.isBeforeOrEqual(U)}isAfterOrEqual(U){return!this.isBefore(U)}isEqual(U){return this.c===U.c&&this.e===U.e}compareTo(U){return this.c<U.c?-1:this.c>U.line?1:this.e<U.e?-1:this.e>U.e?1:0}translate(U,ne=0){if(U===null||ne===null)throw(0,R.$7)();let De;return typeof U>"u"?De=0:typeof U=="number"?De=U:(De=typeof U.lineDelta=="number"?U.lineDelta:0,ne=typeof U.characterDelta=="number"?U.characterDelta:0),De===0&&ne===0?this:new o(this.line+De,this.character+ne)}with(U,ne=this.character){if(U===null||ne===null)throw(0,R.$7)();let De;return typeof U>"u"?De=this.line:typeof U=="number"?De=U:(De=typeof U.line=="number"?U.line:this.line,ne=typeof U.character=="number"?U.character:this.character),De===this.line&&ne===this.character?this:new o(De,ne)}toJSON(){return{line:this.line,character:this.character}}};e.$xM=G,e.$xM=G=o=He([m],G);let q=a=class{static isRange(U){return U instanceof a?!0:U?G.isPosition(U.start)&&G.isPosition(U.end):!1}static of(U){if(U instanceof a)return U;if(this.isRange(U))return new a(U.start,U.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(U,ne,De,Je){let et,ht;if(typeof U=="number"&&typeof ne=="number"&&typeof De=="number"&&typeof Je=="number"?(et=new G(U,ne),ht=new G(De,Je)):G.isPosition(U)&&G.isPosition(ne)&&(et=G.of(U),ht=G.of(ne)),!et||!ht)throw new Error("Invalid arguments");et.isBefore(ht)?(this.c=et,this.e=ht):(this.c=ht,this.e=et)}contains(U){return a.isRange(U)?this.contains(U.start)&&this.contains(U.end):G.isPosition(U)?!(G.of(U).isBefore(this.c)||this.e.isBefore(U)):!1}isEqual(U){return this.c.isEqual(U.c)&&this.e.isEqual(U.e)}intersection(U){const ne=G.Max(U.start,this.c),De=G.Min(U.end,this.e);if(!ne.isAfter(De))return new a(ne,De)}union(U){if(this.contains(U))return this;if(U.contains(this))return U;const ne=G.Min(U.start,this.c),De=G.Max(U.end,this.end);return new a(ne,De)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(U,ne=this.end){if(U===null||ne===null)throw(0,R.$7)();let De;return U?G.isPosition(U)?De=U:(De=U.start||this.start,ne=U.end||this.end):De=this.start,De.isEqual(this.c)&&ne.isEqual(this.end)?this:new a(De,ne)}toJSON(){return[this.start,this.end]}};e.$yM=q,e.$yM=q=a=He([m],q);let V=h=class extends q{static isSelection(U){return U instanceof h?!0:U?q.isRange(U)&&G.isPosition(U.anchor)&&G.isPosition(U.active)&&typeof U.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(U,ne,De,Je){let et,ht;if(typeof U=="number"&&typeof ne=="number"&&typeof De=="number"&&typeof Je=="number"?(et=new G(U,ne),ht=new G(De,Je)):G.isPosition(U)&&G.isPosition(ne)&&(et=G.of(U),ht=G.of(ne)),!et||!ht)throw new Error("Invalid arguments");super(et,ht),this.f=et,this.g=ht}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$zM=V,e.$zM=V=h=He([m],V);const N=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,R.$7)("connectionToken")};class L{static isResolvedAuthority(U){return U&&typeof U=="object"&&typeof U.host=="string"&&typeof U.port=="number"&&(U.connectionToken===void 0||typeof U.connectionToken=="string")}constructor(U,ne,De){if(typeof U!="string"||U.length===0)throw(0,R.$7)("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw(0,R.$7)("port");typeof De<"u"&&N(De),this.host=U,this.port=Math.round(ne),this.connectionToken=De}}e.$AM=L;class Z{static isManagedResolvedAuthority(U){return U&&typeof U=="object"&&typeof U.makeConnection=="function"&&(U.connectionToken===void 0||typeof U.connectionToken=="string")}constructor(U,ne){this.makeConnection=U,this.connectionToken=ne,typeof ne<"u"&&N(ne)}}e.$BM=Z;class re extends Error{static NotAvailable(U,ne){return new re(U,D.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(U){return new re(U,D.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(U,ne=D.RemoteAuthorityResolverErrorCode.Unknown,De){super(U),this._message=U,this._code=ne,this._detail=De,Object.setPrototypeOf(this,re.prototype)}}e.$CM=re;var fe;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(fe||(e.EndOfLine=fe={}));var be;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(be||(e.EnvironmentVariableMutatorType=be={}));let oe=t=class{static isTextEdit(U){return U instanceof t?!0:U?q.isRange(U)&&typeof U.newText=="string":!1}static replace(U,ne){return new t(U,ne)}static insert(U,ne){return t.replace(new q(U,U),ne)}static delete(U){return t.replace(U,"")}static setEndOfLine(U){const ne=new t(new q(new G(0,0),new G(0,0)),"");return ne.newEol=U,ne}get range(){return this.c}set range(U){if(U&&!q.isRange(U))throw(0,R.$7)("range");this.c=U}get newText(){return this.e||""}set newText(U){if(U&&typeof U!="string")throw(0,R.$7)("newText");this.e=U}get newEol(){return this.f}set newEol(U){if(U&&typeof U!="number")throw(0,R.$7)("newEol");this.f=U}constructor(U,ne){this.c=U,this.e=ne}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$DM=oe,e.$DM=oe=t=He([m],oe);let pe=s=class{static isNotebookCellEdit(U){return U instanceof s?!0:U?bi.isNotebookRange(U)&&Array.isArray(U.newCells):!1}static replaceCells(U,ne){return new s(U,ne)}static insertCells(U,ne){return new s(new bi(U,U),ne)}static deleteCells(U){return new s(U,[])}static updateCellMetadata(U,ne){const De=new s(new bi(U,U),[]);return De.newCellMetadata=ne,De}static updateNotebookMetadata(U){const ne=new s(new bi(0,0),[]);return ne.newNotebookMetadata=U,ne}constructor(U,ne){this.range=U,this.newCells=ne}};e.$EM=pe,e.$EM=pe=s=He([m],pe);class $e{static isSnippetTextEdit(U){return U instanceof $e?!0:U?q.isRange(U.range)&&Fe.isSnippetString(U.snippet):!1}static replace(U,ne){return new $e(U,ne)}static insert(U,ne){return $e.replace(new q(U,U),ne)}constructor(U,ne){this.range=U,this.snippet=ne}}e.$FM=$e;var se;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})(se||(e.FileEditType=se={}));let Ce=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(U,ne,De,Je){this.c.push({_type:se.File,from:U,to:ne,options:De,metadata:Je})}createFile(U,ne,De){this.c.push({_type:se.File,from:void 0,to:U,options:ne,metadata:De})}deleteFile(U,ne,De){this.c.push({_type:se.File,from:U,to:void 0,options:ne,metadata:De})}e(U,ne,De){this.c.push({_type:se.Cell,metadata:De,uri:U,edit:{editType:d.CellEditType.DocumentMetadata,metadata:ne},notebookMetadata:ne})}f(U,ne,De,Je){const et=ne.start,ht=ne.end;(et!==ht||De.length>0)&&this.c.push({_type:se.CellReplace,uri:U,index:et,count:ht-et,cells:De,metadata:Je})}g(U,ne,De,Je){this.c.push({_type:se.Cell,metadata:Je,uri:U,edit:{editType:d.CellEditType.Metadata,index:ne,metadata:De}})}replace(U,ne,De,Je){this.c.push({_type:se.Text,uri:U,edit:new oe(ne,De),metadata:Je})}insert(U,ne,De,Je){this.replace(U,new q(ne,ne),De,Je)}delete(U,ne,De){this.replace(U,ne,"",De)}has(U){return this.c.some(ne=>ne._type===se.Text&&ne.uri.toString()===U.toString())}set(U,ne){if(ne)for(const De of ne){if(!De)continue;let Je,et;Array.isArray(De)?(Je=De[0],et=De[1]):Je=De,pe.isNotebookCellEdit(Je)?Je.newCellMetadata?this.g(U,Je.range.start,Je.newCellMetadata,et):Je.newNotebookMetadata?this.e(U,Je.newNotebookMetadata,et):this.f(U,Je.range,Je.newCells,et):$e.isSnippetTextEdit(Je)?this.c.push({_type:se.Snippet,uri:U,range:Je.range,edit:Je.snippet,metadata:et}):this.c.push({_type:se.Text,uri:U,edit:Je,metadata:et})}else{for(let De=0;De<this.c.length;De++){const Je=this.c[De];switch(Je._type){case se.Text:case se.Snippet:case se.Cell:case se.CellReplace:Je.uri.toString()===U.toString()&&(this.c[De]=void 0);break}}(0,E.$Ib)(this.c)}}get(U){const ne=[];for(const De of this.c)De._type===se.Text&&De.uri.toString()===U.toString()&&ne.push(De.edit);return ne}entries(){const U=new O.$Ac;for(const ne of this.c)if(ne._type===se.Text){let De=U.get(ne.uri);De||(De=[ne.uri,[]],U.set(ne.uri,De)),De[1].push(ne.edit)}return[...U.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$GM=Ce,e.$GM=Ce=He([m],Ce);let Fe=n=class{static isSnippetString(U){return U instanceof n?!0:U?typeof U.value=="string":!1}static c(U){return U.replace(/\$|}|\\/g,"\\$&")}constructor(U){this.e=1,this.value=U||""}appendText(U){return this.value+=n.c(U),this}appendTabstop(U=this.e++){return this.value+="$",this.value+=U,this}appendPlaceholder(U,ne=this.e++){if(typeof U=="function"){const De=new n;De.e=this.e,U(De),this.e=De.e,U=De.value}else U=n.c(U);return this.value+="${",this.value+=ne,this.value+=":",this.value+=U,this.value+="}",this}appendChoice(U,ne=this.e++){const De=U.map(Je=>Je.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(U,ne){if(typeof ne=="function"){const De=new n;De.e=this.e,ne(De),this.e=De.e,ne=De.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=U,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};e.$HM=Fe,e.$HM=Fe=n=He([m],Fe);var X;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(X||(e.DiagnosticTag=X={}));var W;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(W||(e.DiagnosticSeverity=W={}));let ie=i=class{static isLocation(U){return U instanceof i?!0:U?q.isRange(U.range)&&c.URI.isUri(U.uri):!1}constructor(U,ne){if(this.uri=U,ne)if(q.isRange(ne))this.range=q.of(ne);else if(G.isPosition(ne))this.range=new q(ne,ne);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$IM=ie,e.$IM=ie=i=He([m],ie);let Se=class{static is(U){return U?typeof U.message=="string"&&U.location&&q.isRange(U.location.range)&&c.URI.isUri(U.location.uri):!1}constructor(U,ne){this.location=U,this.message=ne}static isEqual(U,ne){return U===ne?!0:!U||!ne?!1:U.message===ne.message&&U.location.range.isEqual(ne.location.range)&&U.location.uri.toString()===ne.location.uri.toString()}};e.$JM=Se,e.$JM=Se=He([m],Se);let he=class{constructor(U,ne,De=W.Error){if(!q.isRange(U))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=U,this.message=ne,this.severity=De}toJSON(){return{severity:W[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(U,ne){return U===ne?!0:!U||!ne?!1:U.message===ne.message&&U.severity===ne.severity&&U.code===ne.code&&U.severity===ne.severity&&U.source===ne.source&&U.range.isEqual(ne.range)&&(0,E.$ub)(U.tags,ne.tags)&&(0,E.$ub)(U.relatedInformation,ne.relatedInformation,Se.isEqual)}};e.$KM=he,e.$KM=he=He([m],he);let we=class{constructor(U,ne){if(!U)throw new Error("Illegal argument, contents must be defined");Array.isArray(U)?this.contents=U:this.contents=[U],this.range=ne}};e.$LM=we,e.$LM=we=He([m],we);let ae=class extends we{constructor(U,ne,De,Je){super(U,ne),this.canIncreaseHover=De,this.canDecreaseHover=Je}};e.$MM=ae,e.$MM=ae=He([m],ae);var Y;(function(B){B[B.Increase=0]="Increase",B[B.Decrease=1]="Decrease"})(Y||(e.HoverVerbosityAction=Y={}));var x;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(x||(e.DocumentHighlightKind=x={}));let me=class{constructor(U,ne=x.Text){this.range=U,this.kind=ne}toJSON(){return{range:this.range,kind:x[this.kind]}}};e.$NM=me,e.$NM=me=He([m],me);let ge=class{constructor(U,ne){this.uri=U,this.highlights=ne}toJSON(){return{uri:this.uri,highlights:this.highlights.map(U=>U.toJSON())}}};e.$OM=ge,e.$OM=ge=He([m],ge);var Te;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(Te||(e.SymbolKind=Te={}));var Be;(function(B){B[B.Deprecated=1]="Deprecated"})(Be||(e.SymbolTag=Be={}));let Ee=g=class{static validate(U){if(!U.name)throw new Error("name must not be falsy")}constructor(U,ne,De,Je,et){this.name=U,this.kind=ne,this.containerName=et,typeof De=="string"&&(this.containerName=De),Je instanceof ie?this.location=Je:De instanceof q&&(this.location=new ie(Je,De)),g.validate(this)}toJSON(){return{name:this.name,kind:Te[this.kind],location:this.location,containerName:this.containerName}}};e.$PM=Ee,e.$PM=Ee=g=He([m],Ee);let Re=f=class{static validate(U){if(!U.name)throw new Error("name must not be falsy");if(!U.range.contains(U.selectionRange))throw new Error("selectionRange must be contained in fullRange");U.children?.forEach(f.validate)}constructor(U,ne,De,Je,et){this.name=U,this.detail=ne,this.kind=De,this.range=Je,this.selectionRange=et,this.children=[],f.validate(this)}};e.$QM=Re,e.$QM=Re=f=He([m],Re);var Oe;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(Oe||(e.CodeActionTriggerKind=Oe={}));let j=class{constructor(U,ne){this.title=U,this.kind=ne}};e.$RM=j,e.$RM=j=He([m],j);let z=class{static{l=this}static{this.c="."}constructor(U){this.value=U}append(U){return new l(this.value?this.value+l.c+U:U)}intersects(U){return this.contains(U)||U.contains(this)}contains(U){return this.value===U.value||U.value.startsWith(this.value+l.c)}};e.$SM=z,e.$SM=z=l=He([m],z),z.Empty=new z(""),z.QuickFix=z.Empty.append("quickfix"),z.Refactor=z.Empty.append("refactor"),z.RefactorExtract=z.Refactor.append("extract"),z.RefactorInline=z.Refactor.append("inline"),z.RefactorMove=z.Refactor.append("move"),z.RefactorRewrite=z.Refactor.append("rewrite"),z.Source=z.Empty.append("source"),z.SourceOrganizeImports=z.Source.append("organizeImports"),z.SourceFixAll=z.Source.append("fixAll"),z.Notebook=z.Empty.append("notebook");let K=class{constructor(U,ne){if(this.range=U,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$TM=K,e.$TM=K=He([m],K);class J{constructor(U,ne,De,Je,et,ht){this.kind=U,this.name=ne,this.detail=De,this.uri=Je,this.range=et,this.selectionRange=ht}}e.$UM=J;class te{constructor(U,ne){this.fromRanges=ne,this.from=U}}e.$VM=te;class le{constructor(U,ne){this.fromRanges=ne,this.to=U}}e.$WM=le;var Ae;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(Ae||(e.LanguageStatusSeverity=Ae={}));let je=class{constructor(U,ne){this.range=U,this.command=ne}get isResolved(){return!!this.command}};e.$XM=je,e.$XM=je=He([m],je);let Ge=b=class{#e;static isMarkdownString(U){return U instanceof b?!0:U&&U.appendCodeblock&&U.appendMarkdown&&U.appendText&&U.value!==void 0}constructor(U,ne=!1){this.#e=new P.$Xk(U,{supportThemeIcons:ne})}get value(){return this.#e.value}set value(U){this.#e.value=U}get isTrusted(){return this.#e.isTrusted}set isTrusted(U){this.#e.isTrusted=U}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(U){this.#e.supportThemeIcons=U}get supportHtml(){return this.#e.supportHtml}set supportHtml(U){this.#e.supportHtml=U}get baseUri(){return this.#e.baseUri}set baseUri(U){this.#e.baseUri=U}appendText(U){return this.#e.appendText(U),this}appendMarkdown(U){return this.#e.appendMarkdown(U),this}appendCodeblock(U,ne){return this.#e.appendCodeblock(ne??"",U),this}};e.$YM=Ge,e.$YM=Ge=b=He([m],Ge);let Ze=class{constructor(U,ne){this.label=U,this.documentation=ne}};e.$ZM=Ze,e.$ZM=Ze=He([m],Ze);let tt=class{constructor(U,ne){this.label=U,this.documentation=ne,this.parameters=[]}};e.$1M=tt,e.$1M=tt=He([m],tt);let _e=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$2M=_e,e.$2M=_e=He([m],_e);var it;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(it||(e.SignatureHelpTriggerKind=it={}));var nt;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(nt||(e.InlayHintKind=nt={}));let mt=class{constructor(U){this.value=U}};e.$3M=mt,e.$3M=mt=He([m],mt);let lt=class{constructor(U,ne,De){this.position=U,this.label=ne,this.kind=De}};e.$4M=lt,e.$4M=lt=He([m],lt);var rt;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(rt||(e.CompletionTriggerKind=rt={}));var at;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(at||(e.CompletionItemKind=at={}));var dt;(function(B){B[B.Deprecated=1]="Deprecated"})(dt||(e.CompletionItemTag=dt={}));let We=class{constructor(U,ne){this.label=U,this.kind=ne}toJSON(){return{label:this.label,kind:this.kind&&at[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$5M=We,e.$5M=We=He([m],We);let ze=class{constructor(U=[],ne=!1){this.items=U,this.isIncomplete=ne}};e.$6M=ze,e.$6M=ze=He([m],ze);let _=class{constructor(U,ne,De){this.insertText=U,this.range=ne,this.command=De}};e.$7M=_,e.$7M=_=He([m],_);let H=class{constructor(U){this.commands=void 0,this.suppressSuggestions=void 0,this.items=U}};e.$8M=H,e.$8M=H=He([m],H);var ye;(function(B){B[B.Unknown=0]="Unknown",B[B.Word=1]="Word",B[B.Line=2]="Line",B[B.Suggest=3]="Suggest"})(ye||(e.PartialAcceptTriggerKind=ye={}));var Ke;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(Ke||(e.ViewColumn=Ke={}));var xe;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(xe||(e.StatusBarAlignment=xe={}));function ct(B,U){return`${v.$Wm.toKey(B)}.${U}`}var gt;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative",B[B.Interval=3]="Interval"})(gt||(e.TextEditorLineNumbersStyle=gt={}));var Mt;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(Mt||(e.TextDocumentSaveReason=Mt={}));var Qt;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Qt||(e.TextEditorRevealType=Qt={}));var Ut;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(Ut||(e.TextEditorSelectionChangeKind=Ut={}));var li;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(li||(e.TextDocumentChangeReason=li={}));var xt;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(xt||(e.DecorationRangeBehavior=xt={})),function(B){function U(ne){switch(ne){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=U}(Ut||(e.TextEditorSelectionChangeKind=Ut={}));var Ye;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(Ye||(e.SyntaxTokenType=Ye={})),function(B){function U(ne){switch(ne){case B.Other:return"other";case B.Comment:return"comment";case B.String:return"string";case B.RegEx:return"regex"}return"other"}B.toString=U}(Ye||(e.SyntaxTokenType=Ye={}));let Wt=class{constructor(U,ne){if(ne&&!c.URI.isUri(ne))throw(0,R.$7)("target");if(!q.isRange(U)||U.isEmpty)throw(0,R.$7)("range");this.range=U,this.target=ne}};e.$0M=Wt,e.$0M=Wt=He([m],Wt);let zt=class{constructor(U,ne,De,Je){this.red=U,this.green=ne,this.blue=De,this.alpha=Je}};e.$$M=zt,e.$$M=zt=He([m],zt);let ft=class{constructor(U,ne){if(ne&&!(ne instanceof zt))throw(0,R.$7)("color");if(!q.isRange(U)||U.isEmpty)throw(0,R.$7)("range");this.range=U,this.color=ne}};e.$_M=ft,e.$_M=ft=He([m],ft);let pt=class{constructor(U){if(!U||typeof U!="string")throw(0,R.$7)("label");this.label=U}};e.$aN=pt,e.$aN=pt=He([m],pt);var _t;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(_t||(e.ColorFormat=_t={}));var Yt;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(Yt||(e.SourceControlInputBoxValidationType=Yt={}));var jt;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(jt||(e.TerminalExitReason=jt={}));var bt;(function(B){B[B.Low=0]="Low",B[B.Medium=1]="Medium",B[B.High=2]="High"})(bt||(e.TerminalShellExecutionCommandLineConfidence=bt={}));class Ot{constructor(U,ne,De){if(this.startIndex=U,this.length=ne,this.tooltip=De,typeof U!="number"||U<0)throw(0,R.$7)("startIndex");if(typeof ne!="number"||ne<1)throw(0,R.$7)("length");if(De!==void 0&&typeof De!="string")throw(0,R.$7)("tooltip")}}e.$bN=Ot;class Gt{constructor(U){this.uri=U}}e.$cN=Gt;class Bt{constructor(U){this.terminalCommand=U}}e.$dN=Bt;var Qe;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(Qe||(e.TerminalLocation=Qe={}));class ei{constructor(U){if(this.options=U,typeof U!="object")throw(0,R.$7)("options")}}e.$eN=ei;var ti;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(ti||(e.TaskRevealKind=ti={}));var ci;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(ci||(e.TaskPanelKind=ci={}));let St=class{static{I=this}static{this.Clean=new I("clean","Clean")}static{this.Build=new I("build","Build")}static{this.Rebuild=new I("rebuild","Rebuild")}static{this.Test=new I("test","Test")}static from(U){switch(U){case"clean":return I.Clean;case"build":return I.Build;case"rebuild":return I.Rebuild;case"test":return I.Test;default:return}}constructor(U,ne){if(this.label=ne,typeof U!="string"||typeof ne!="string")throw(0,R.$7)("name");this.c=U}get id(){return this.c}};e.$fN=St,e.$fN=St=I=He([m],St);function Tt(B){let U="";for(let ne=0;ne<B.length;ne++)U+=B[ne].replace(/,/g,",,")+",";return U}let Pt=class{constructor(U,ne,De){if(typeof U!="string")throw(0,R.$7)("process");this.e=[],this.c=U,ne!==void 0&&(Array.isArray(ne)?(this.e=ne,this.f=De):this.f=ne)}get process(){return this.c}set process(U){if(typeof U!="string")throw(0,R.$7)("process");this.c=U}get args(){return this.e}set args(U){Array.isArray(U)||(U=[]),this.e=U}get options(){return this.f}set options(U){this.f=U}computeId(){const U=[];if(U.push("process"),this.c!==void 0&&U.push(this.c),this.e&&this.e.length>0)for(const ne of this.e)U.push(ne);return Tt(U)}};e.$gN=Pt,e.$gN=Pt=He([m],Pt);let Nt=class{constructor(U,ne,De){if(this.f=[],Array.isArray(ne)){if(!U)throw(0,R.$7)("command can't be undefined or null");if(typeof U!="string"&&typeof U.value!="string")throw(0,R.$7)("command");this.e=U,this.f=ne,this.g=De}else{if(typeof U!="string")throw(0,R.$7)("commandLine");this.c=U,this.g=ne}}get commandLine(){return this.c}set commandLine(U){if(typeof U!="string")throw(0,R.$7)("commandLine");this.c=U}get command(){return this.e?this.e:""}set command(U){if(typeof U!="string"&&typeof U.value!="string")throw(0,R.$7)("command");this.e=U}get args(){return this.f}set args(U){this.f=U||[]}get options(){return this.g}set options(U){this.g=U}computeId(){const U=[];if(U.push("shell"),this.c!==void 0&&U.push(this.c),this.e!==void 0&&U.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ne of this.f)U.push(typeof ne=="string"?ne:ne.value);return Tt(U)}};e.$hN=Nt,e.$hN=Nt=He([m],Nt);var ui;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(ui||(e.ShellQuoting=ui={}));var Vt;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(Vt||(e.TaskScope=Vt={}));class ri{constructor(U){this.c=U}computeId(){return"customExecution"+(0,C.$Wg)()}set callback(U){this.c=U}get callback(){return this.c}}e.$iN=ri;let Lt=class{static{S=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(U,ne,De,Je,et,ht){this.k=!1,this.l=this.definition=U;let vt;typeof ne=="string"?(this.o=this.name=ne,this.w=this.source=De,this.execution=Je,vt=et,this.k=!0):ne===Vt.Global||ne===Vt.Workspace?(this.target=ne,this.o=this.name=De,this.w=this.source=Je,this.execution=et,vt=ht):(this.target=ne,this.o=this.name=De,this.w=this.source=Je,this.execution=et,vt=ht),typeof vt=="string"?(this.r=[vt],this.t=!0):Array.isArray(vt)?(this.r=vt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(U){this.j=U}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Pt?this.l={type:S.e,id:this.q.computeId()}:this.q instanceof Nt?this.l={type:S.f,id:this.q.computeId()}:this.q instanceof ri?this.l={type:S.c,id:this.q.computeId()}:this.l={type:S.g,id:(0,C.$Wg)()}}get definition(){return this.l}set definition(U){if(U==null)throw(0,R.$7)("Kind can't be undefined or null");this.B(),this.l=U}get scope(){return this.m}set target(U){this.B(),this.m=U}get name(){return this.o}set name(U){if(typeof U!="string")throw(0,R.$7)("name");this.B(),this.o=U}get execution(){return this.q}set execution(U){U===null&&(U=void 0),this.B(),this.q=U;const ne=this.l.type;(S.g===ne||S.e===ne||S.f===ne||S.c===ne)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(U){if(Array.isArray(U))this.B(),this.r=U,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(U){U!==!0&&U!==!1&&(U=!1),this.B(),this.u=U}get source(){return this.w}set source(U){if(typeof U!="string"||U.length===0)throw(0,R.$7)("source must be a string of length > 0");this.B(),this.w=U}get group(){return this.x}set group(U){U===null&&(U=void 0),this.B(),this.x=U}get detail(){return this.A}set detail(U){U===null&&(U=void 0),this.A=U}get presentationOptions(){return this.y}set presentationOptions(U){U==null&&(U=Object.create(null)),this.B(),this.y=U}get runOptions(){return this.z}set runOptions(U){U==null&&(U=Object.create(null)),this.B(),this.z=U}};e.$jN=Lt,e.$jN=Lt=S=He([m],Lt);var Xt;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(Xt||(e.ProgressLocation=Xt={}));var si;(function(B){function U(ne){const De=ne;return(0,$.$eg)(De.value)?De.tooltip&&!(0,$.$ag)(De.tooltip)?(console.log("INVALID view badge, invalid tooltip",De.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",De.value),!1)}B.isViewBadge=U})(si||(e.ViewBadge=si={}));let Ct=y=class{static isTreeItem(U,ne){const De=U;if(De.checkboxState!==void 0){const Je=(0,$.$eg)(De.checkboxState)?De.checkboxState:(0,$.$cg)(De.checkboxState)&&(0,$.$eg)(De.checkboxState.state)?De.checkboxState.state:void 0,et=!(0,$.$eg)(De.checkboxState)&&(0,$.$cg)(De.checkboxState)?De.checkboxState.tooltip:void 0;if(Je===void 0||Je!==$t.Checked&&Je!==$t.Unchecked||et!==void 0&&!(0,$.$ag)(et))return console.log("INVALID tree item, invalid checkboxState",De.checkboxState),!1}if(U instanceof y)return!0;if(De.label!==void 0&&!(0,$.$ag)(De.label)&&!De.label?.label)return console.log("INVALID tree item, invalid label",De.label),!1;if(De.id!==void 0&&!(0,$.$ag)(De.id))return console.log("INVALID tree item, invalid id",De.id),!1;if(De.iconPath!==void 0&&!(0,$.$ag)(De.iconPath)&&!c.URI.isUri(De.iconPath)&&(!De.iconPath||!(0,$.$ag)(De.iconPath.id))){const Je=De.iconPath;if(!Je||!(0,$.$ag)(Je.light)&&!c.URI.isUri(Je.light)&&!(0,$.$ag)(Je.dark)&&!c.URI.isUri(Je.dark))return console.log("INVALID tree item, invalid iconPath",De.iconPath),!1}return De.description!==void 0&&!(0,$.$ag)(De.description)&&typeof De.description!="boolean"?(console.log("INVALID tree item, invalid description",De.description),!1):De.resourceUri!==void 0&&!c.URI.isUri(De.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",De.resourceUri),!1):De.tooltip!==void 0&&!(0,$.$ag)(De.tooltip)&&!(De.tooltip instanceof Ge)?(console.log("INVALID tree item, invalid tooltip",De.tooltip),!1):De.command!==void 0&&!De.command.command?(console.log("INVALID tree item, invalid command",De.command),!1):De.collapsibleState!==void 0&&De.collapsibleState<wt.None&&De.collapsibleState>wt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",De.collapsibleState),!1):De.contextValue!==void 0&&!(0,$.$ag)(De.contextValue)?(console.log("INVALID tree item, invalid contextValue",De.contextValue),!1):De.accessibilityInformation!==void 0&&!De.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",De.accessibilityInformation),!1):!0}constructor(U,ne=wt.None){this.collapsibleState=ne,c.URI.isUri(U)?this.resourceUri=U:this.label=U}};e.$kN=Ct,e.$kN=Ct=y=He([m],Ct);var wt;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(wt||(e.TreeItemCollapsibleState=wt={}));var $t;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})($t||(e.TreeItemCheckboxState=$t={}));let qt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(U){this.value=U}};e.$lN=qt,e.$lN=qt=He([m],qt);class Dt extends qt{}e.$mN=Dt;class oi extends Dt{#e;constructor(U){super(""),this.#e=U}asFile(){return this.#e}}e.$nN=oi;class Kt{constructor(U,ne,De,Je){this.name=U,this.uri=ne,this._itemId=De,this.c=Je}data(){return this.c()}}e.$oN=Kt;let pi=class{#e=new Map;constructor(U){for(const[ne,De]of U??[]){const Je=this.#e.get(this.#t(ne));Je?Je.push(De):this.#e.set(this.#t(ne),[De])}}get(U){return this.#e.get(this.#t(U))?.[0]}set(U,ne){this.#e.set(this.#t(U),[ne])}forEach(U,ne){for(const[De,Je]of this.#e)for(const et of Je)U.call(ne,et,De,this)}*[Symbol.iterator](){for(const[U,ne]of this.#e)for(const De of ne)yield[U,De]}#t(U){return U.toLowerCase()}};e.$pN=pi,e.$pN=pi=He([m],pi);let di=class{constructor(U,ne,De){this.insertText=U,this.title=ne,this.kind=De}};e.$qN=di,e.$qN=di=He([m],di);var ki;(function(B){B[B.Automatic=0]="Automatic",B[B.PasteAs=1]="PasteAs"})(ki||(e.DocumentPasteTriggerKind=ki={}));class Rt{static{this.c="."}constructor(U){this.value=U}append(...U){return new Rt((this.value?[this.value,...U]:U).join(Rt.c))}intersects(U){return this.contains(U)||U.contains(this)}contains(U){return this.value===U.value||U.value.startsWith(this.value+Rt.c)}}e.$rN=Rt,Rt.Empty=new Rt("");class Pi{constructor(U,ne,De){this.title=ne,this.insertText=U,this.kind=De}}e.$sN=Pi;let ai=class{constructor(U,ne){this.id=U,this.color=ne}static isThemeIcon(U){return typeof U.id!="string"?(console.log("INVALID ThemeIcon, invalid id",U.id),!1):!0}};e.$tN=ai,e.$tN=ai=He([m],ai),ai.File=new ai("file"),ai.Folder=new ai("folder");let It=class{constructor(U){this.id=U}};e.$uN=It,e.$uN=It=He([m],It);var Ii;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(Ii||(e.ConfigurationTarget=Ii={}));let wi=class{get base(){return this.c}set base(U){this.c=U,this.e=c.URI.file(U)}get baseUri(){return this.e}set baseUri(U){this.e=U,this.c=U.fsPath}constructor(U,ne){if(typeof U!="string"&&(!U||!c.URI.isUri(U)&&!c.URI.isUri(U.uri)))throw(0,R.$7)("base");if(typeof ne!="string")throw(0,R.$7)("pattern");typeof U=="string"?this.baseUri=c.URI.file(U):c.URI.isUri(U)?this.baseUri=U:this.baseUri=U.uri,this.pattern=ne}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$vN=wi,e.$vN=wi=He([m],wi);const $i=new WeakMap;function Ri(B,U){$i.set(B,U)}let fi=class{constructor(U,ne,De,Je,et){this.enabled=typeof U=="boolean"?U:!0,typeof ne=="string"&&(this.condition=ne),typeof De=="string"&&(this.hitCondition=De),typeof Je=="string"&&(this.logMessage=Je),typeof et=="string"&&(this.mode=et)}get id(){return this.c||(this.c=$i.get(this)??(0,C.$Wg)()),this.c}};e.$xN=fi,e.$xN=fi=He([m],fi);let ve=class extends fi{constructor(U,ne,De,Je,et,ht){if(super(ne,De,Je,et,ht),U===null)throw(0,R.$7)("location");this.location=U}};e.$yN=ve,e.$yN=ve=He([m],ve);let Me=class extends fi{constructor(U,ne,De,Je,et,ht){super(ne,De,Je,et,ht),this.functionName=U}};e.$zN=Me,e.$zN=Me=He([m],Me);let ue=class extends fi{constructor(U,ne,De,Je,et,ht,vt,Jt){if(super(Je,et,ht,vt,Jt),!ne)throw(0,R.$7)("dataId");this.label=U,this.dataId=ne,this.canPersist=De}};e.$AN=ue,e.$AN=ue=He([m],ue);let Q=class{constructor(U,ne,De){this.command=U,this.args=ne||[],this.options=De}};e.$BN=Q,e.$BN=Q=He([m],Q);let Pe=class{constructor(U,ne){this.port=U,this.host=ne}};e.$CN=Pe,e.$CN=Pe=He([m],Pe);let Ue=class{constructor(U){this.path=U}};e.$DN=Ue,e.$DN=Ue=He([m],Ue);let Xe=class{constructor(U){this.implementation=U}};e.$EN=Xe,e.$EN=Xe=He([m],Xe);class qe{constructor(U,ne,De){this.session=U,this.threadId=ne,this.frameId=De}}e.$FN=qe;class ut{constructor(U,ne){this.session=U,this.threadId=ne}}e.$GN=ut;let kt=class{constructor(U,ne){this.range=U,this.expression=ne}};e.$HN=kt,e.$HN=kt=He([m],kt);var Zt;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Zt||(e.InlineCompletionTriggerKind=Zt={}));let ii=class{constructor(U,ne){this.range=U,this.text=ne}};e.$IN=ii,e.$IN=ii=He([m],ii);let Ft=class{constructor(U,ne,De=!0){this.range=U,this.variableName=ne,this.caseSensitiveLookup=De}};e.$JN=Ft,e.$JN=Ft=He([m],Ft);let Ht=class{constructor(U,ne){this.range=U,this.expression=ne}};e.$KN=Ht,e.$KN=Ht=He([m],Ht);let Li=class{constructor(U,ne){this.frameId=U,this.stoppedLocation=ne}};e.$LN=Li,e.$LN=Li=He([m],Li);var Ui;(function(B){B[B.AIGenerated=1]="AIGenerated"})(Ui||(e.NewSymbolNameTag=Ui={}));var Xi;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Xi||(e.NewSymbolNameTriggerKind=Xi={}));class zi{constructor(U,ne){this.newSymbolName=U,this.tags=ne}}e.$MN=zi;var Mi;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Mi||(e.FileChangeType=Mi={}));let ji=p=class extends Error{static FileExists(U){return new p(U,u.FileSystemProviderErrorCode.FileExists,p.FileExists)}static FileNotFound(U){return new p(U,u.FileSystemProviderErrorCode.FileNotFound,p.FileNotFound)}static FileNotADirectory(U){return new p(U,u.FileSystemProviderErrorCode.FileNotADirectory,p.FileNotADirectory)}static FileIsADirectory(U){return new p(U,u.FileSystemProviderErrorCode.FileIsADirectory,p.FileIsADirectory)}static NoPermissions(U){return new p(U,u.FileSystemProviderErrorCode.NoPermissions,p.NoPermissions)}static Unavailable(U){return new p(U,u.FileSystemProviderErrorCode.Unavailable,p.Unavailable)}constructor(U,ne=u.FileSystemProviderErrorCode.Unknown,De){super(c.URI.isUri(U)?U.toString(!0):U),this.code=De?.name??"Unknown",(0,u.$jl)(this,ne),Object.setPrototypeOf(this,p.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}};e.$NN=ji,e.$NN=ji=p=He([m],ji);let Bi=class{constructor(U,ne,De){this.start=U,this.end=ne,this.kind=De}};e.$ON=Bi,e.$ON=Bi=He([m],Bi);var yi;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(yi||(e.FoldingRangeKind=yi={}));var Zi;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(Zi||(e.CommentThreadCollapsibleState=Zi={}));var xi;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(xi||(e.CommentMode=xi={}));var Ti;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(Ti||(e.CommentState=Ti={}));var Wi;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(Wi||(e.CommentThreadState=Wi={}));var Vi;(function(B){B[B.Current=0]="Current",B[B.Outdated=1]="Outdated"})(Vi||(e.CommentThreadApplicability=Vi={}));class gn{constructor(U,ne=[]){this.tokenTypes=U,this.tokenModifiers=ne}}e.$PN=gn;function _i(B){return typeof B>"u"||(0,$.$bg)(B)}class qi{constructor(U){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,U){this.m=!0;for(let ne=0,De=U.tokenTypes.length;ne<De;ne++)this.k.set(U.tokenTypes[ne],ne);for(let ne=0,De=U.tokenModifiers.length;ne<De;ne++)this.l.set(U.tokenModifiers[ne],ne)}}push(U,ne,De,Je,et){if(typeof U=="number"&&typeof ne=="number"&&typeof De=="number"&&typeof Je=="number"&&(typeof et=="number"||typeof et>"u"))return typeof et>"u"&&(et=0),this.q(U,ne,De,Je,et);if(q.isRange(U)&&typeof ne=="string"&&_i(De))return this.o(U,ne,De);throw(0,R.$7)()}o(U,ne,De){if(!this.m)throw new Error("Legend must be provided in constructor");if(U.start.line!==U.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(ne))throw new Error("`tokenType` is not in the provided legend");const Je=U.start.line,et=U.start.character,ht=U.end.character-U.start.character,vt=this.k.get(ne);let Jt=0;if(De)for(const hi of De){if(!this.l.has(hi))throw new Error("`tokenModifier` is not in the provided legend");const mi=this.l.get(hi);Jt|=1<<mi>>>0}this.q(Je,et,ht,vt,Jt)}q(U,ne,De,Je,et){if(this.f&&(U<this.c||U===this.c&&ne<this.e)){this.f=!1;const Jt=this.g.length/5|0;let hi=0,mi=0;for(let vi=0;vi<Jt;vi++){let Si=this.g[5*vi],Qi=this.g[5*vi+1];Si===0?(Si=hi,Qi+=mi):Si+=hi,this.g[5*vi]=Si,this.g[5*vi+1]=Qi,hi=Si,mi=Qi}}let ht=U,vt=ne;this.f&&this.j>0&&(ht-=this.c,ht===0&&(vt-=this.e)),this.g[this.j++]=ht,this.g[this.j++]=vt,this.g[this.j++]=De,this.g[this.j++]=Je,this.g[this.j++]=et,this.c=U,this.e=ne}static r(U){const ne=[],De=U.length/5|0;for(let vt=0;vt<De;vt++)ne[vt]=vt;ne.sort((vt,Jt)=>{const hi=U[5*vt],mi=U[5*Jt];if(hi===mi){const vi=U[5*vt+1],Si=U[5*Jt+1];return vi-Si}return hi-mi});const Je=new Uint32Array(U.length);let et=0,ht=0;for(let vt=0;vt<De;vt++){const Jt=5*ne[vt],hi=U[Jt+0],mi=U[Jt+1],vi=U[Jt+2],Si=U[Jt+3],Qi=U[Jt+4],Un=hi-et,br=Un===0?mi-ht:mi,Yi=5*vt;Je[Yi+0]=Un,Je[Yi+1]=br,Je[Yi+2]=vi,Je[Yi+3]=Si,Je[Yi+4]=Qi,et=hi,ht=mi}return Je}build(U){return this.f?new Ei(new Uint32Array(this.g),U):new Ei(qi.r(this.g),U)}}e.$QN=qi;class Ei{constructor(U,ne){this.resultId=ne,this.data=U}}e.$RN=Ei;class mn{constructor(U,ne,De){this.start=U,this.deleteCount=ne,this.data=De}}e.$SN=mn;class pn{constructor(U,ne){this.resultId=ne,this.edits=U}}e.$TN=pn;var en;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(en||(e.DebugConsoleMode=en={}));class Gi{constructor(U){this.name=U}}e.$UN=Gi;let Oi=class{static{this.Back={iconPath:new ai("arrow-left")}}constructor(){}};e.$VN=Oi,e.$VN=Oi=He([m],Oi);var Le;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(Le||(e.QuickPickItemKind=Le={}));var gi;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(gi||(e.InputBoxValidationSeverity=gi={}));var Ki;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(Ki||(e.ExtensionKind=Ki={}));class st{static validate(U){if(typeof U.badge=="string"){let ne=(0,M.$Lf)(U.badge,0);if(ne<U.badge.length&&(ne+=(0,M.$Lf)(U.badge,ne)),U.badge.length>ne)throw new Error("The 'badge'-property must be undefined or a short character")}else if(U.badge&&!ai.isThemeIcon(U.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!U.color&&!U.badge&&!U.tooltip)throw new Error("The decoration is empty");return!0}constructor(U,ne,De){this.badge=U,this.tooltip=ne,this.color=De}}e.$WN=st;let yt=class{constructor(U){this.kind=U}};e.$XN=yt,e.$XN=yt=He([m],yt);var tn;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(tn||(e.ColorThemeKind=tn={}));class bi{static isNotebookRange(U){return U instanceof bi?!0:U?typeof U.start=="number"&&typeof U.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(U,ne){if(U<0)throw(0,R.$7)("start must be positive");if(ne<0)throw(0,R.$7)("end must be positive");U<=ne?(this.c=U,this.e=ne):(this.c=ne,this.e=U)}with(U){let ne=this.c,De=this.e;return U.start!==void 0&&(ne=U.start),U.end!==void 0&&(De=U.end),ne===this.c&&De===this.e?this:new bi(ne,De)}}e.$YN=bi;class Ai{static validate(U){if(typeof U.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof U.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof U.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(U){return Array.isArray(U)&&U.every(ne=>Ai.isNotebookCellData(ne))}static isNotebookCellData(U){return!0}constructor(U,ne,De,Je,et,ht,vt){this.kind=U,this.value=ne,this.languageId=De,this.mime=Je,this.outputs=et??[],this.metadata=ht,this.executionSummary=vt,Ai.validate(this)}}e.$ZN=Ai;class $n{constructor(U){this.cells=U}}e.$1N=$n;class ni{static isNotebookCellOutputItem(U){return U instanceof ni?!0:U?typeof U.mime=="string"&&U.data instanceof Uint8Array:!1}static error(U){const ne={name:U.name,message:U.message,stack:U.stack};return ni.json(ne,"application/vnd.code.notebook.error")}static stdout(U){return ni.text(U,"application/vnd.code.notebook.stdout")}static stderr(U){return ni.text(U,"application/vnd.code.notebook.stderr")}static bytes(U,ne="application/octet-stream"){return new ni(U,ne)}static#e=new TextEncoder;static text(U,ne=A.$Ys.text){const De=ni.#e.encode(String(U));return new ni(De,ne)}static json(U,ne="text/x-json"){const De=JSON.stringify(U,void 0,"	");return ni.text(De,ne)}constructor(U,ne){this.data=U,this.mime=ne;const De=(0,A.$3s)(ne,!0);if(!De)throw new Error(`INVALID mime type: ${ne}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}}e.$2N=ni;class Ni{static isNotebookCellOutput(U){return U instanceof Ni?!0:!U||typeof U!="object"?!1:typeof U.id=="string"&&Array.isArray(U.items)}static ensureUniqueMimeTypes(U,ne=!1){const De=new Set,Je=new Set;for(let et=0;et<U.length;et++){const ht=U[et],vt=(0,A.$3s)(ht.mime);if(!De.has(vt)||(0,d.$qK)(vt)){De.add(vt);continue}Je.add(et),ne&&console.warn(`DUPLICATED mime type '${ht.mime}' will be dropped`)}return Je.size===0?U:U.filter((et,ht)=>!Je.has(ht))}constructor(U,ne,De){this.items=Ni.ensureUniqueMimeTypes(U,!0),typeof ne=="string"?(this.id=ne,this.metadata=De):(this.id=(0,C.$Wg)(),this.metadata=ne??De)}}e.$3N=Ni;var nn;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(nn||(e.NotebookCellKind=nn={}));var rn;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(rn||(e.NotebookCellExecutionState=rn={}));var Hi;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(Hi||(e.NotebookCellStatusBarAlignment=Hi={}));var sn;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(sn||(e.NotebookEditorRevealType=sn={}));class bn{constructor(U,ne){this.text=U,this.alignment=ne}}e.$4N=bn;var on;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(on||(e.NotebookControllerAffinity=on={}));var an;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(an||(e.NotebookControllerAffinity2=an={}));class vn{constructor(U,ne=[]){this.uri=U,this.provides=(0,E.$2b)(ne)}}e.$5N=vn;class wn{constructor(U){this.label=U}}e.$6N=wn;var cn;(function(B){B[B.Named=1]="Named",B[B.Indexed=2]="Indexed"})(cn||(e.NotebookVariablesRequestKind=cn={}));let Ji=class{constructor(U,ne){this.label=U,this.timestamp=ne}};e.$7N=Ji,e.$7N=Ji=He([m],Ji);var un;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(un||(e.ExtensionMode=un={}));var ln;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(ln||(e.ExtensionRuntime=ln={}));var hn;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(hn||(e.StandardTokenType=hn={}));class ee{constructor(U,ne){this.ranges=U,this.wordPattern=ne}}e.$8N=ee;class ce{constructor(U){this.c=U}get autoForwardAction(){return this.c}}e.$9N=ce;var Ne;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(Ne||(e.TestResultState=Ne={}));var ot;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(ot||(e.TestRunProfileKind=ot={}));let Et=class{constructor(U=void 0,ne=void 0,De=void 0,Je=!1,et=!0){this.include=U,this.exclude=ne,this.profile=De,this.continuous=Je,this.preserveFocus=et}};e.$0N=Et,e.$0N=Et=He([m],Et);let At=k=class{static diff(U,ne,De){const Je=new k(U);return Je.expectedOutput=ne,Je.actualOutput=De,Je}constructor(U){this.message=U}};e.$$N=At,e.$$N=At=k=He([m],At);let Di=class{constructor(U){this.id=U}};e.$_N=Di,e.$_N=Di=He([m],Di);class Fi{constructor(U,ne){this.covered=U,this.total=ne,En(this)}}e.$aO=Fi;function En(B){if(B){if(B.covered>B.total)throw new Error(`The total number of covered items (${B.covered}) cannot be greater than the total (${B.total})`);if(B.total<0)throw new Error(`The number of covered items (${B.total}) cannot be negative`)}}class yn{static fromDetails(U,ne){const De=new Fi(0,0),Je=new Fi(0,0),et=new Fi(0,0);for(const vt of ne)if("branches"in vt){De.total+=1,De.covered+=vt.executed?1:0;for(const Jt of vt.branches)Je.total+=1,Je.covered+=Jt.executed?1:0}else et.total+=1,et.covered+=vt.executed?1:0;const ht=new yn(U,De,Je.total>0?Je:void 0,et.total>0?et:void 0);return ht.detailedCoverage=ne,ht}constructor(U,ne,De,Je,et){this.uri=U,this.statementCoverage=ne,this.branchCoverage=De,this.declarationCoverage=Je,this.testItem=et}}e.$cO=yn;class zn{get executionCount(){return+this.executed}set executionCount(U){this.executed=U}constructor(U,ne,De=[]){this.executed=U,this.location=ne,this.branches=De}}e.$dO=zn;class jn{get executionCount(){return+this.executed}set executionCount(U){this.executed=U}constructor(U,ne,De){this.executed=U,this.location=ne,this.label=De}}e.$eO=jn;class Bn{get executionCount(){return+this.executed}set executionCount(U){this.executed=U}constructor(U,ne,De){this.name=U,this.executed=ne,this.location=De}}e.$fO=Bn;var Dn;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(Dn||(e.ExternalUriOpenerPriority=Dn={}));var Sn;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(Sn||(e.WorkspaceTrustState=Sn={}));var kn;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(kn||(e.PortAutoForwardAction=kn={}));class Wn{constructor(U,ne,De,Je,et,ht){this.kind=U,this.name=ne,this.detail=De,this.uri=Je,this.range=et,this.selectionRange=ht}}e.$gO=Wn;class Vn{constructor(U){this.uri=U}}e.$hO=Vn;class qn{constructor(U,ne){this.original=U,this.modified=ne}}e.$iO=qn;class Gn{constructor(U,ne,De,Je){this.base=U,this.input1=ne,this.input2=De,this.result=Je}}e.$jO=Gn;class Kn{constructor(U,ne){this.uri=U,this.viewType=ne}}e.$kO=Kn;class Hn{constructor(U){this.viewType=U}}e.$lO=Hn;class Jn{constructor(U,ne){this.uri=U,this.notebookType=ne}}e.$mO=Jn;class Qn{constructor(U,ne,De){this.original=U,this.modified=ne,this.notebookType=De}}e.$nO=Qn;class Yn{constructor(){}}e.$oO=Yn;class Xn{constructor(U,ne){this.uri=U,this.inputBoxUri=ne}}e.$pO=Xn;class Zn{constructor(){}}e.$qO=Zn;class xn{constructor(U){this.textDiffs=U}}e.$rO=xn;var In;(function(B){B[B.Down=0]="Down",B[B.Up=1]="Up"})(In||(e.InteractiveSessionVoteDirection=In={}));var Cn;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(Cn||(e.ChatCopyKind=Cn={}));var Pn;(function(B){B[B.Short=1]="Short",B[B.Medium=2]="Medium",B[B.Full=3]="Full"})(Pn||(e.ChatVariableLevel=Pn={}));class _n{constructor(U,ne,De){this.id=U,this.label=ne,this.values=De}}e.$sO=_n;var Rn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone",B[B.Accepted=3]="Accepted",B[B.Bug=4]="Bug"})(Rn||(e.InteractiveEditorResponseFeedbackKind=Rn={}));var An;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful"})(An||(e.ChatResultFeedbackKind=An={}));class er{constructor(U){if(typeof U!="string"&&U.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof U=="string"?new Ge(U):U}}e.$tO=er;class tr{constructor(U,ne){if(typeof U!="string"&&U.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof U=="string"?new Ge(U):U,this.vulnerabilities=ne}}e.$uO=tr;class ir{constructor(U,ne){this.participant=U,this.command=ne}}e.$vO=ir;class nr{constructor(U,ne,De){this.title=U,this.message=ne,this.data=De}}e.$wO=nr;class rr{constructor(U,ne){this.value=U,this.baseUri=ne}}e.$xO=rr;class sr{constructor(U,ne){this.value=U,this.title=ne}}e.$yO=sr;class or{constructor(U){this.value=U}}e.$zO=or;class ar{constructor(U,ne){this.value=U,this.task=ne}}e.$AO=ar;class cr{constructor(U){if(typeof U!="string"&&U.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof U=="string"?new Ge(U):U}}e.$BO=cr;class ur{constructor(U){this.value=U}}e.$CO=ur;class lr{constructor(U,ne){this.value=U,this.iconPath=ne}}e.$DO=lr;class hr{constructor(U,ne){this.uri=U,this.edits=Array.isArray(ne)?ne:[ne]}}e.$EO=hr;class dr{constructor(U,ne,De,Je){this.prompt=U,this.command=ne,this.references=De,this.participant=Je}}e.$FO=dr;class fr{constructor(U,ne,De,Je){this.response=U,this.result=ne,this.participant=De,this.command=Je}}e.$GO=fr;var Mn;(function(B){B[B.Panel=1]="Panel",B[B.Terminal=2]="Terminal",B[B.Notebook=3]="Notebook",B[B.Editor=4]="Editor"})(Mn||(e.ChatLocation=Mn={}));var dn;(function(B){B[B.User=1]="User",B[B.Assistant=2]="Assistant",B[B.System=3]="System"})(dn||(e.LanguageModelChatMessageRole=dn={}));class fn{static User(U,ne){return new fn(dn.User,U,ne)}static Assistant(U,ne){return new fn(dn.Assistant,U,ne)}constructor(U,ne,De){this.role=U,this.content=ne,this.name=De}}e.$HO=fn;class gr{constructor(U){this.content=U}}e.$IO=gr;class mr{constructor(U,ne){this.content=U,this.name=ne}}e.$JO=mr;class pr{constructor(U,ne){this.content=U,this.name=ne}}e.$KO=pr;class Ci extends Error{static NotFound(U){return new Ci(U,Ci.NotFound.name)}static NoPermissions(U){return new Ci(U,Ci.NoPermissions.name)}static Blocked(U){return new Ci(U,Ci.Blocked.name)}constructor(U,ne,De){super(U,{cause:De}),this.name="LanguageModelError",this.code=ne??""}}e.$LO=Ci;var Tn;(function(B){B[B.SymbolInformation=1]="SymbolInformation",B[B.CommandInformation=2]="CommandInformation",B[B.SearchInformation=3]="SearchInformation",B[B.SettingInformation=4]="SettingInformation"})(Tn||(e.RelatedInformationType=Tn={}));var On;(function(B){B[B.Started=1]="Started",B[B.Recognizing=2]="Recognizing",B[B.Recognized=3]="Recognized",B[B.Stopped=4]="Stopped",B[B.Error=5]="Error"})(On||(e.SpeechToTextStatus=On={}));var Nn;(function(B){B[B.Started=1]="Started",B[B.Stopped=2]="Stopped",B[B.Error=3]="Error"})(Nn||(e.TextToSpeechStatus=Nn={}));var Fn;(function(B){B[B.Recognized=1]="Recognized",B[B.Stopped=2]="Stopped"})(Fn||(e.KeywordRecognitionStatus=Fn={}));class $r{constructor(U,ne){this.text=U,this.range=ne}}e.$MO=$r;var Ln;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Ln||(e.InlineEditTriggerKind=Ln={}))}),define(ke[268],Ie([1,0,5,7]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jmc=void 0;class P{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(E.$uM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,M,$){if(this.a.size===0)throw new Error("No related information providers registered");const c=this.a.get(A);if(!c)throw new Error("related information provider not found");return await c.provideRelatedInformation(M,$)??[]}getRelatedInformation(A,M,$){return this.c.$getAiRelatedInformation(M,$)}registerRelatedInformationProvider(A,M,$){const c=this.b;return this.b++,this.a.set(c,$),this.c.$registerAiRelatedInformationProvider(c,M),new R.$wM(()=>{this.c.$unregisterAiRelatedInformationProvider(c),this.a.delete(c)})}}e.$Jmc=P}),define(ke[91],Ie([1,0,4,5,7,19,115,3,17]),function(de,e,E,R,P,O,A,M,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vmc=e.$Umc=void 0,e.$Umc=(0,M.$Ai)("IExtHostAuthentication");let c=class{constructor(u){this.b=new Map,this.c=new E.$he,this.onDidChangeSessions=this.c.event,this.d=new C,this.f=new C,this.a=u.getProxy(R.$uM.MainThreadAuthentication)}async getSession(u,D,d,r={}){const o=O.$Wm.toKey(u.identifier),a=[...d].sort().join(" ");return await this.d.getOrCreate(`${o} ${D} ${a}`,async()=>{await this.a.$ensureProvider(D);const h=u.displayName||u.name;return this.a.$getSession(D,d,o,h,r)})}async getSessions(u,D,d){const r=O.$Wm.toKey(u.identifier),o=[...d].sort().join(" ");return await this.f.getOrCreate(`${r} ${o}`,async()=>{await this.a.$ensureProvider(D);const a=u.displayName||u.name;return this.a.$getSessions(D,d,r,a)})}async removeSession(u,D){const d=this.b.get(u);return d?d.provider.removeSession(D):this.a.$removeSession(u,D)}registerAuthenticationProvider(u,D,d,r){if(this.b.get(u))throw new Error(`An authentication provider with id '${u}' is already registered.`);this.b.set(u,{label:D,provider:d,options:r??{supportsMultipleAccounts:!1}});const o=d.onDidChangeSessions(a=>this.a.$sendDidChangeSessions(u,a));return this.a.$registerAuthenticationProvider(u,D,r?.supportsMultipleAccounts??!1),new P.$wM(()=>{o.dispose(),this.b.delete(u),this.a.$unregisterAuthenticationProvider(u)})}async $createSession(u,D,d){const r=this.b.get(u);if(r)return await r.provider.createSession(D,d);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $removeSession(u,D){const d=this.b.get(u);if(d)return await d.provider.removeSession(D);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $getSessions(u,D){const d=this.b.get(u);if(d)return await d.provider.getSessions(D);throw new Error(`Unable to find authentication provider with handle: ${u}`)}$onDidChangeAuthenticationSessions(u,D){return u.startsWith(A.$wL)||this.c.fire({provider:{id:u,label:D}}),Promise.resolve()}};e.$Vmc=c,e.$Vmc=c=He([Ve(0,$.$YO)],c);class C{constructor(){this.a=new Map}getOrCreate(u,D){const d=this.a.get(u);if(d)return d;const r=D().finally(()=>this.a.delete(u));return this.a.set(u,r),r}}}),define(ke[120],Ie([1,0,2,5,7,3,17,12,18,13,20,25]),function(de,e,E,R,P,O,A,M,$,c,C,v){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Vnc=e.$Unc=void 0;let D=class{static{u=this}static{this.c=0}static{this.d=250}constructor(r,o){this.h=o,this.f=new Map,this.g=r.getProxy(R.$uM.MainThreadDecorations)}registerFileDecorationProvider(r,o){const a=u.c++;this.f.set(a,{provider:r,extensionDescription:o}),this.g.$registerDecorationProvider(a,o.identifier.value);const h=r.onDidChangeFileDecorations&&r.onDidChangeFileDecorations(t=>{if(!t){this.g.$onDidChange(a,null);return}const s=(0,$.$2b)(t);if(s.length<=u.d){this.g.$onDidChange(a,s);return}this.h.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,s.length);const n=s.map(f=>({uri:f,rank:(0,c.$ef)(f.path,"/")})),i=(0,$.$zb)(n,(f,l)=>f.rank-l.rank||(0,c.$uf)(f.uri.path,l.uri.path)),g=[];e:for(const f of i){let l;for(const b of f){const I=(0,C.$mc)(b.uri.path);if(l!==I&&(l=I,g.push(b.uri)>=u.d))break e}}this.g.$onDidChange(a,g)});return new P.$wM(()=>{h?.dispose(),this.g.$unregisterDecorationProvider(a),this.f.delete(a)})}async $provideDecorations(r,o,a){if(!this.f.has(r))return Object.create(null);const h=Object.create(null),{provider:t,extensionDescription:s}=this.f.get(r);return await Promise.all(o.map(async n=>{try{const{uri:i,id:g}=n,f=await Promise.resolve(t.provideFileDecoration(E.URI.revive(i),a));if(!f)return;try{P.$WN.validate(f),f.badge&&typeof f.badge!="string"&&(0,v.$UG)(s,"codiconDecoration"),h[g]=[f.propagate,f.tooltip,f.badge,f.color]}catch(l){this.h.warn(`INVALID decoration from extension '${s.identifier.value}': ${l}`)}}catch(i){this.h.error(i)}})),h}};e.$Unc=D,e.$Unc=D=u=He([Ve(0,A.$YO),Ve(1,M.$7j)],D),e.$Vnc=(0,O.$Ai)("IExtHostDecorations")}),define(ke[269],Ie([1,0,14,2,7,5,16,22,13]),function(de,e,E,R,P,O,A,M,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xnc=void 0;class c{static{this.a=0}constructor(v,u,D){this.d=u,this.e=D,this.b=new Map,this.c=v.getProxy(O.$uM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(v,u){if(Object.keys(A.Schemas).indexOf(v)>=0)throw new Error(`scheme '${v}' already registered`);const D=c.a++;this.b.set(D,u),this.c.$registerTextContentProvider(D,v);let d;if(typeof u.onDidChange=="function"){let r;d=u.onDidChange(async o=>{if(o.scheme!==v){this.e.warn(`Provider for scheme '${v}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(o))return;r&&await r;const a=this.$provideTextDocumentContent(D,o).then(async h=>{if(!h&&typeof h!="string")return;const t=this.d.getDocument(o);if(!t)return;const s=(0,$.$of)(h);if(!t.equalLines(s))return this.c.$onVirtualDocumentChange(o,h)}).catch(E.$1).finally(()=>{r===a&&(r=void 0)});r=a})}return new P.$wM(()=>{this.b.delete(D)&&this.c.$unregisterTextContentProvider(D),d&&(d.dispose(),d=void 0)})}$provideTextDocumentContent(v,u){const D=this.b.get(v);return D?Promise.resolve(D.provideTextDocumentContent(R.URI.revive(u),M.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$Xnc=c}),define(ke[121],Ie([1,0,61,16,13,325,209,7,18]),function(de,e,E,R,P,O,A,M,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3O=e.$2O=void 0,e.$1O=C;const c=new Map;function C(d,r){r?c.set(d,r):c.delete(d)}function v(d){return c.get(d)}class u extends O.$cw{constructor(r,o,a,h,t,s,n){super(o,a,h,t),this.c=r,this.m=s,this.q=n,this.b=!1}dispose(){(0,E.ok)(!this.b),this.b=!0,this.q=!1}equalLines(r){return(0,$.$ub)(this.f,r)}get document(){if(!this.a){const r=this;this.a={get uri(){return r.d},get fileName(){return r.d.fsPath},get isUntitled(){return r.d.scheme===R.Schemas.untitled},get languageId(){return r.m},get version(){return r.h},get isClosed(){return r.b},get isDirty(){return r.q},save(){return r.r()},getText(o){return o?r.s(o):r.getText()},get eol(){return r.g===`
`?M.EndOfLine.LF:M.EndOfLine.CRLF},get lineCount(){return r.f.length},lineAt(o){return r.t(o)},offsetAt(o){return r.u(o)},positionAt(o){return r.v(o)},validateRange(o){return r.w(o)},validatePosition(o){return r.x(o)},getWordRangeAtPosition(o,a){return r.y(o,a)}}}return Object.freeze(this.a)}_acceptLanguageId(r){(0,E.ok)(!this.b),this.m=r}_acceptIsDirty(r){(0,E.ok)(!this.b),this.q=r}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(r){const o=this.w(r);if(o.isEmpty)return"";if(o.isSingleLine)return this.f[o.start.line].substring(o.start.character,o.end.character);const a=this.g,h=o.start.line,t=o.end.line,s=[];s.push(this.f[h].substring(o.start.character));for(let n=h+1;n<t;n++)s.push(this.f[n]);return s.push(this.f[t].substring(0,o.end.character)),s.join(a)}t(r){let o;if(r instanceof M.$xM?o=r.line:typeof r=="number"&&(o=r),typeof o!="number"||o<0||o>=this.f.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new D(o,this.f[o],o===this.f.length-1)}u(r){return r=this.x(r),this.l(),this.j.getPrefixSum(r.line-1)+r.character}v(r){r=Math.floor(r),r=Math.max(0,r),this.l();const o=this.j.getIndexOf(r),a=this.f[o.index].length;return new M.$xM(o.index,Math.min(o.remainder,a))}w(r){if(!(r instanceof M.$yM))throw new Error("Invalid argument");const o=this.x(r.start),a=this.x(r.end);return o===r.start&&a===r.end?r:new M.$yM(o.line,o.character,a.line,a.character)}x(r){if(!(r instanceof M.$xM))throw new Error("Invalid argument");if(this.f.length===0)return r.with(0,0);let{line:o,character:a}=r,h=!1;if(o<0)o=0,a=0,h=!0;else if(o>=this.f.length)o=this.f.length-1,a=this.f[o].length,h=!0;else{const t=this.f[o].length;a<0?(a=0,h=!0):a>t&&(a=t,h=!0)}return h?new M.$xM(o,a):r}y(r,o){const a=this.x(r);if(!o)o=v(this.m);else if((0,P.$nf)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const h=(0,A.$vt)(a.character+1,(0,A.$tt)(o),this.f[a.line],0);if(h)return new M.$yM(a.line,h.startColumn-1,a.line,h.endColumn-1)}}e.$2O=u;class D{constructor(r,o,a){this.a=r,this.b=o,this.c=a}get lineNumber(){return this.a}get text(){return this.b}get range(){return new M.$yM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new M.$yM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$3O=D}),define(ke[270],Ie([1,0,5,7]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1nc=void 0;class P{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(E.$uM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,M,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const c=this.a.get(A);if(!c)throw new Error("Embedding vector provider not found");const C=await c.provideEmbeddingVector(M,$);if(!C)throw new Error("Embedding vector provider returned undefined");return C}registerEmbeddingVectorProvider(A,M,$){const c=this.b;return this.b++,this.a.set(c,$),this.c.$registerAiEmbeddingVectorProvider(M,c),new R.$wM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(c),this.a.delete(c)})}}e.$1nc=P}),define(ke[68],Ie([1,0,5,30,7,23,3,17,51,6,11,24,16]),function(de,e,E,R,P,O,A,M,$,c,C,v,u){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$_mc=e.$$mc=void 0;let d=D=class{constructor(o,a){this.b=new Map,this.c=new C.$Jh,this.a=o.getProxy(E.$uM.MainThreadFileSystem);const h=this;this.value=Object.freeze({async stat(t){try{let s;const n=h.b.get(t.scheme);return n?(await h.a.$ensureActivation(t.scheme),s=await n.impl.stat(t)):s=await h.a.$stat(t),{type:s.type,ctime:s.ctime,mtime:s.mtime,size:s.size,permissions:s.permissions===R.FilePermission.Readonly?1:void 0}}catch(s){D.e(s)}},async readDirectory(t){try{const s=h.b.get(t.scheme);return s?(await h.a.$ensureActivation(t.scheme),(await s.impl.readDirectory(t)).slice()):await h.a.$readdir(t)}catch(s){return D.e(s)}},async createDirectory(t){try{const s=h.b.get(t.scheme);return s&&!s.isReadonly?(await h.a.$ensureActivation(t.scheme),await h.d(s.impl,s.extUri,t)):await h.a.$mkdir(t)}catch(s){return D.e(s)}},async readFile(t){try{const s=h.b.get(t.scheme);return s?(await h.a.$ensureActivation(t.scheme),(await s.impl.readFile(t)).slice()):(await h.a.$readFile(t)).buffer}catch(s){return D.e(s)}},async writeFile(t,s){try{const n=h.b.get(t.scheme);return n&&!n.isReadonly?(await h.a.$ensureActivation(t.scheme),await h.d(n.impl,n.extUri,n.extUri.dirname(t)),await h.c.queueFor(t,()=>Promise.resolve(n.impl.writeFile(t,s,{create:!0,overwrite:!0})))):await h.a.$writeFile(t,O.$Je.wrap(s))}catch(n){return D.e(n)}},async delete(t,s){try{const n=h.b.get(t.scheme);return n&&!n.isReadonly&&!s?.useTrash?(await h.a.$ensureActivation(t.scheme),await n.impl.delete(t,{recursive:!1,...s})):await h.a.$delete(t,{recursive:!1,useTrash:!1,atomic:!1,...s})}catch(n){return D.e(n)}},async rename(t,s,n){try{return await h.a.$rename(t,s,{overwrite:!1,...n})}catch(i){return D.e(i)}},async copy(t,s,n){try{return await h.a.$copy(t,s,{overwrite:!1,...n})}catch(i){return D.e(i)}},isWritableFileSystem(t){const s=a.getCapabilities(t);if(typeof s=="number")return!(s&R.FileSystemProviderCapabilities.Readonly)}})}async d(o,a,h){const t=[];for(;!a.isEqual(h,a.dirname(h));)try{if(!((await o.stat(h)).type&R.FileType.Directory))throw P.$NN.FileExists(`Unable to create folder '${h.scheme===u.Schemas.file?h.fsPath:h.toString(!0)}' that already exists but is not a directory`);break}catch(s){if(R.$kl(s)!==R.FileSystemProviderErrorCode.FileNotFound)throw s;t.push(a.basename(h)),h=a.dirname(h)}for(let s=t.length-1;s>=0;s--){h=a.joinPath(h,t[s]);try{await o.createDirectory(h)}catch(n){if(R.$kl(n)!==R.FileSystemProviderErrorCode.FileExists)throw n}}}static e(o){if(o instanceof P.$NN)throw o;if(o instanceof R.$gl)switch(o.code){case R.FileSystemProviderErrorCode.FileExists:throw P.$NN.FileExists(o.message);case R.FileSystemProviderErrorCode.FileNotFound:throw P.$NN.FileNotFound(o.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw P.$NN.FileNotADirectory(o.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw P.$NN.FileIsADirectory(o.message);case R.FileSystemProviderErrorCode.NoPermissions:throw P.$NN.NoPermissions(o.message);case R.FileSystemProviderErrorCode.Unavailable:throw P.$NN.Unavailable(o.message);default:throw new P.$NN(o.message,o.name)}if(!(o instanceof Error))throw new P.$NN(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw P.$NN.Unavailable(o.message);switch(o.name){case R.FileSystemProviderErrorCode.FileExists:throw P.$NN.FileExists(o.message);case R.FileSystemProviderErrorCode.FileNotFound:throw P.$NN.FileNotFound(o.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw P.$NN.FileNotADirectory(o.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw P.$NN.FileIsADirectory(o.message);case R.FileSystemProviderErrorCode.NoPermissions:throw P.$NN.NoPermissions(o.message);case R.FileSystemProviderErrorCode.Unavailable:throw P.$NN.Unavailable(o.message);default:throw new P.$NN(o.message,o.name)}}addFileSystemProvider(o,a,h){return this.b.set(o,{impl:a,extUri:h?.isCaseSensitive?v.$4g:v.$6g,isReadonly:!!h?.isReadonly}),(0,c.$Sc)(()=>this.b.delete(o))}getFileSystemProviderExtUri(o){return this.b.get(o)?.extUri??v.$4g}};e.$$mc=d,e.$$mc=d=D=He([Ve(0,M.$YO),Ve(1,$.$Omc)],d),e.$_mc=(0,A.$Ai)("IExtHostConsumerFileSystem")}),define(ke[92],Ie([1,0,3,27,12,68,2]),function(de,e,E,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bnc=e.$anc=void 0,e.$anc=(0,E.$Ai)("IExtensionStoragePaths");let M=class{constructor(c,C,v){this.d=C,this.f=v,this.a=c.workspace??void 0,this.b=c.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(c){return A.URI.joinPath(this.b.workspaceStorageHome,c)}async h(){if(!this.a)return Promise.resolve(void 0);const c=this.a.id,C=await this.g(c);try{return await this.f.value.stat(C),this.d.trace("[ExtHostStorage] storage dir already exists",C),C}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",C),await this.f.value.createDirectory(C),await this.f.value.writeFile(A.URI.joinPath(C,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),C}catch(v){this.d.error("[ExtHostStorage]",v);return}}workspaceValue(c){if(this.c)return A.URI.joinPath(this.c,c.identifier.value)}globalValue(c){return A.URI.joinPath(this.b.globalStorageHome,c.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$bnc=M,e.$bnc=M=He([Ve(0,R.$cP),Ve(1,P.$7j),Ve(2,O.$_mc)],M)}),define(ke[271],Ie([1,0,7,17,4]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ioc=void 0;let O=class{constructor(M){this.a=new E.$XN(E.ColorThemeKind.Dark),this.b=new P.$he}get activeColorTheme(){return this.a}$onColorThemeChange(M){let $;switch(M){case"light":$=E.ColorThemeKind.Light;break;case"hcDark":$=E.ColorThemeKind.HighContrast;break;case"hcLight":$=E.ColorThemeKind.HighContrastLight;break;default:$=E.ColorThemeKind.Dark}this.a=new E.$XN($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Ioc=O,e.$Ioc=O=He([Ve(0,R.$YO)],O)}),define(ke[93],Ie([1,0,22,4,6,189,3,12,222,5,27,17,7]),function(de,e,E,R,P,O,A,M,$,c,C,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oEb=e.$nEb=e.TunnelDtoConverter=void 0;class D extends $.$Bw{}var d;(function(o){function a(t){return{remoteAddress:t.remoteAddress,localAddress:t.localAddress,public:!!t.public,privacy:t.privacy??(t.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:t.protocol}}o.fromApiTunnel=a;function h(t){return{remoteAddress:{host:t.tunnelRemoteHost,port:t.tunnelRemotePort},localAddress:t.localAddress,public:t.privacy!==$.TunnelPrivacyId.ConstantPrivate&&t.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:t.privacy,protocol:t.protocol}}o.fromServiceTunnel=h})(d||(e.TunnelDtoConverter=d={})),e.$nEb=(0,A.$Ai)("IExtHostTunnelService");let r=class extends P.$Uc{constructor(a,h,t){super(),this.s=t,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new R.$he,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=a.getProxy(c.$uM.MainThreadTunnelService)}async openTunnel(a,h){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${a.identifier.value} called openTunnel API for ${h.remoteAddress.host}:${h.remoteAddress.port}.`);const t=await this.a.$openTunnel(h,a.displayName);if(t){const s=new D(t.remoteAddress,t.localAddress,()=>this.a.$closeTunnel(t.remoteAddress));return this.B(s),s}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(a,h){a.portRange===void 0&&a.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const t=this.u();return this.r.set(t,{selector:a,provider:h}),this.a.$registerPortsAttributesProvider(a,t),new u.$wM(()=>{this.r.delete(t),this.a.$unregisterPortsAttributesProvider(t)})}async $providePortAttributes(a,h,t,s,n){const i=[];for(const f of a){const l=this.r.get(f);if(!l)return[];i.push(...await Promise.all(h.map(async b=>{let I;try{I=await l.provider.providePortAttributes({port:b,pid:t,commandLine:s},n)}catch{I=await l.provider.providePortAttributes(b,t,s,n)}return{providedAttributes:I,port:b}})))}const g=i.filter(f=>!!f.providedAttributes);return g.length>0?g.map(f=>({autoForwardAction:f.providedAttributes.autoForwardAction,port:f.port})):[]}async $registerCandidateFinder(a){}registerTunnelProvider(a,h){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(s,n)=>await a.provideTunnel(s,n,E.CancellationToken.None)??void 0;const t=h.tunnelFeatures?{elevation:!!h.tunnelFeatures?.elevation,privacyOptions:h.tunnelFeatures?.privacyOptions,protocol:h.tunnelFeatures.protocol===void 0?!0:h.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(t),Promise.resolve((0,P.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(a,h){if(a){a.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(a.candidatePortSource),a.showCandidatePort&&(this.f=a.showCandidatePort,this.a.$setCandidateFilter());const t=a.tunnelFactory??(h?this.w(h):void 0);if(t){this.b=t;let s=a.tunnelFeatures?.privacyOptions??[];a.tunnelFeatures?.public&&s.length===0&&(s=[{id:"private",label:O.localize(0,null),themeIcon:"lock"},{id:"public",label:O.localize(1,null),themeIcon:"eye"}]);const n=a.tunnelFeatures?{elevation:!!a.tunnelFeatures?.elevation,public:!!a.tunnelFeatures?.public,privacyOptions:s,protocol:!0}:void 0;this.a.$setTunnelProvider(n)}}else this.b=void 0;return(0,P.$Sc)(()=>{this.b=void 0})}w(a){}async $closeTunnel(a,h){if(this.g.has(a.host)){const t=this.g.get(a.host);t.has(a.port)&&(h&&t.get(a.port).disposeListener.dispose(),await t.get(a.port).tunnel.dispose(),t.delete(a.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(a,h){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const t=this.b(a,h);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),t!==void 0){const s=await t;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),s===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(a.remoteAddress.host)||this.g.set(a.remoteAddress.host,new Map);const n=this.B(s.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(s.remoteAddress))));return this.g.get(a.remoteAddress.host).set(a.remoteAddress.port,{tunnel:s,disposeListener:n}),d.fromApiTunnel(s)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(t){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),t instanceof Error)return t.message}}async $applyCandidateFilter(a){const h=await Promise.all(a.map(s=>this.f(s.host,s.port,s.detail??""))),t=a.filter((s,n)=>h[n]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${a.map(s=>s.port).join(", ")} to ${t.map(s=>s.port).join(", ")}`),t}};e.$oEb=r,e.$oEb=r=He([Ve(0,v.$YO),Ve(1,C.$cP),Ve(2,M.$7j)],r)}),define(ke[10],Ie([1,0,18,23,146,272,59,29,135,49,73,26,141,24,34,15,2,104,33,150,94,52,106,77,114,113,233,248,81,90,55,56,244,7]),function(de,e,E,R,P,O,A,M,$,c,C,v,u,D,d,r,o,a,h,t,s,n,i,g,f,l,b,I,S,y,p,k,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$VO=pe,e.$WO=se,e.$XO=Ce;var F;(function(ve){function Me(Q){const{selectionStartLineNumber:Pe,selectionStartColumn:Ue,positionLineNumber:Xe,positionColumn:qe}=Q,ut=new w.$xM(Pe-1,Ue-1),kt=new w.$xM(Xe-1,qe-1);return new w.$zM(ut,kt)}ve.to=Me;function ue(Q){const{anchor:Pe,active:Ue}=Q;return{selectionStartLineNumber:Pe.line+1,selectionStartColumn:Pe.character+1,positionLineNumber:Ue.line+1,positionColumn:Ue.character+1}}ve.from=ue})(F||(e.Selection=F={}));var T;(function(ve){function Me(Q){if(!Q)return;const{start:Pe,end:Ue}=Q;return{startLineNumber:Pe.line+1,startColumn:Pe.character+1,endLineNumber:Ue.line+1,endColumn:Ue.character+1}}ve.from=Me;function ue(Q){if(!Q)return;const{startLineNumber:Pe,startColumn:Ue,endLineNumber:Xe,endColumn:qe}=Q;return new w.$yM(Pe-1,Ue-1,Xe-1,qe-1)}ve.to=ue})(T||(e.Range=T={}));var G;(function(ve){function Me(Q){return{uri:Q.uri,range:T.from(Q.range)}}ve.from=Me;function ue(Q){return new w.$IM(o.URI.revive(Q.uri),T.to(Q.range))}ve.to=ue})(G||(e.Location=G={}));var q;(function(ve){function Me(ue){switch(ue){case t.StandardTokenType.Comment:return w.StandardTokenType.Comment;case t.StandardTokenType.Other:return w.StandardTokenType.Other;case t.StandardTokenType.RegEx:return w.StandardTokenType.RegEx;case t.StandardTokenType.String:return w.StandardTokenType.String}}ve.to=Me})(q||(e.TokenType=q={}));var V;(function(ve){function Me(Q){return new w.$xM(Q.lineNumber-1,Q.column-1)}ve.to=Me;function ue(Q){return{lineNumber:Q.line+1,column:Q.character+1}}ve.from=ue})(V||(e.Position=V={}));var N;(function(ve){function Me(Pe,Ue,Xe){return(0,E.$Hb)((0,E.$2b)(Pe).map(qe=>ue(qe,Ue,Xe)))}ve.from=Me;function ue(Pe,Ue,Xe){if(typeof Pe=="string")return{$serialized:!0,language:Pe,isBuiltin:Xe?.isBuiltin};if(Pe)return{$serialized:!0,language:Pe.language,scheme:Q(Pe.scheme,Ue),pattern:ct.from(Pe.pattern)??void 0,exclusive:Pe.exclusive,notebookType:Pe.notebookType,isBuiltin:Xe?.isBuiltin}}function Q(Pe,Ue){return Ue&&typeof Pe=="string"?Ue.transformOutgoingScheme(Pe):Pe}})(N||(e.DocumentSelector=N={}));var L;(function(ve){function Me(Q){switch(Q){case w.DiagnosticTag.Unnecessary:return i.MarkerTag.Unnecessary;case w.DiagnosticTag.Deprecated:return i.MarkerTag.Deprecated}}ve.from=Me;function ue(Q){switch(Q){case i.MarkerTag.Unnecessary:return w.DiagnosticTag.Unnecessary;case i.MarkerTag.Deprecated:return w.DiagnosticTag.Deprecated;default:return}}ve.to=ue})(L||(e.DiagnosticTag=L={}));var Z;(function(ve){function Me(Q){let Pe;return Q.code&&((0,r.$ag)(Q.code)||(0,r.$eg)(Q.code)?Pe=String(Q.code):Pe={value:String(Q.code.value),target:Q.code.target}),{...T.from(Q.range),message:Q.message,source:Q.source,code:Pe,severity:fe.from(Q.severity),relatedInformation:Q.relatedInformation&&Q.relatedInformation.map(re.from),tags:Array.isArray(Q.tags)?(0,E.$Hb)(Q.tags.map(L.from)):void 0}}ve.from=Me;function ue(Q){const Pe=new w.$KM(T.to(Q),Q.message,fe.to(Q.severity));return Pe.source=Q.source,Pe.code=(0,r.$ag)(Q.code)?Q.code:Q.code?.value,Pe.relatedInformation=Q.relatedInformation&&Q.relatedInformation.map(re.to),Pe.tags=Q.tags&&(0,E.$Hb)(Q.tags.map(L.to)),Pe}ve.to=ue})(Z||(e.Diagnostic=Z={}));var re;(function(ve){function Me(Q){return{...T.from(Q.location.range),message:Q.message,resource:Q.location.uri}}ve.from=Me;function ue(Q){return new w.$JM(new w.$IM(Q.resource,T.to(Q)),Q.message)}ve.to=ue})(re||(e.DiagnosticRelatedInformation=re={}));var fe;(function(ve){function Me(Q){switch(Q){case w.DiagnosticSeverity.Error:return i.MarkerSeverity.Error;case w.DiagnosticSeverity.Warning:return i.MarkerSeverity.Warning;case w.DiagnosticSeverity.Information:return i.MarkerSeverity.Info;case w.DiagnosticSeverity.Hint:return i.MarkerSeverity.Hint}return i.MarkerSeverity.Error}ve.from=Me;function ue(Q){switch(Q){case i.MarkerSeverity.Info:return w.DiagnosticSeverity.Information;case i.MarkerSeverity.Warning:return w.DiagnosticSeverity.Warning;case i.MarkerSeverity.Error:return w.DiagnosticSeverity.Error;case i.MarkerSeverity.Hint:return w.DiagnosticSeverity.Hint;default:return w.DiagnosticSeverity.Error}}ve.to=ue})(fe||(e.DiagnosticSeverity=fe={}));var be;(function(ve){function Me(Q){return typeof Q=="number"&&Q>=w.ViewColumn.One?Q-1:Q===w.ViewColumn.Beside?m.$dE:m.$cE}ve.from=Me;function ue(Q){if(typeof Q=="number"&&Q>=0)return Q+1;throw new Error("invalid 'EditorGroupColumn'")}ve.to=ue})(be||(e.ViewColumn=be={}));function oe(ve){return typeof ve.range<"u"}function pe(ve){return ve.length===0?!0:!!oe(ve[0])}var $e;(function(ve){function Me(qe){return qe.map(ve.from)}ve.fromMany=Me;function ue(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function Q(qe){let ut;if(ue(qe)){const{language:Ft,value:Ht}=qe;ut={value:"```"+Ft+`
`+Ht+"\n```\n"}}else w.$YM.isMarkdownString(qe)?ut={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml,baseUri:qe.baseUri}:typeof qe=="string"?ut={value:qe}:ut={value:""};const kt=Object.create(null);ut.uris=kt;const Zt=Ft=>{try{let Ht=o.URI.parse(Ft,!0);Ht=Ht.with({query:Pe(Ht.query,kt)}),kt[Ft]=Ht}catch{}return""},ii=new $.marked.Renderer;return ii.link=Zt,ii.image=Ft=>typeof Ft=="string"?Zt(A.$6k(Ft).href):"",(0,$.marked)(ut.value,{renderer:ii}),ut}ve.from=Q;function Pe(qe,ut){if(!qe)return qe;let kt;try{kt=(0,c.$9h)(qe)}catch{}if(!kt)return qe;let Zt=!1;return kt=(0,v.$$n)(kt,ii=>{if(o.URI.isUri(ii)){const Ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[Ft]=ii,Zt=!0,Ft}else return}),Zt?JSON.stringify(kt):qe}function Ue(qe){const ut=new w.$YM(qe.value,qe.supportThemeIcons);return ut.isTrusted=qe.isTrusted,ut.supportHtml=qe.supportHtml,ut.baseUri=qe.baseUri?o.URI.from(qe.baseUri):void 0,ut}ve.to=Ue;function Xe(qe){if(qe)return typeof qe=="string"?qe:ve.from(qe)}ve.fromStrict=Xe})($e||(e.MarkdownString=$e={}));function se(ve){return pe(ve)?ve.map(Me=>({range:T.from(Me.range),hoverMessage:Array.isArray(Me.hoverMessage)?$e.fromMany(Me.hoverMessage):Me.hoverMessage?$e.from(Me.hoverMessage):void 0,renderOptions:Me.renderOptions})):ve.map(Me=>({range:T.from(Me)}))}function Ce(ve){return typeof ve>"u"?ve:typeof ve=="string"?o.URI.file(ve):ve}var Fe;(function(ve){function Me(ue){return typeof ue>"u"?ue:{contentText:ue.contentText,contentIconPath:ue.contentIconPath?Ce(ue.contentIconPath):void 0,border:ue.border,borderColor:ue.borderColor,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,color:ue.color,backgroundColor:ue.backgroundColor,margin:ue.margin,width:ue.width,height:ue.height}}ve.from=Me})(Fe||(e.ThemableDecorationAttachmentRenderOptions=Fe={}));var X;(function(ve){function Me(ue){return typeof ue>"u"?ue:{backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?Ce(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?Fe.from(ue.before):void 0,after:ue.after?Fe.from(ue.after):void 0}}ve.from=Me})(X||(e.ThemableDecorationRenderOptions=X={}));var W;(function(ve){function Me(ue){if(typeof ue>"u")return ue;switch(ue){case w.DecorationRangeBehavior.OpenOpen:return n.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case w.DecorationRangeBehavior.ClosedClosed:return n.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case w.DecorationRangeBehavior.OpenClosed:return n.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case w.DecorationRangeBehavior.ClosedOpen:return n.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}ve.from=Me})(W||(e.DecorationRangeBehavior=W={}));var ie;(function(ve){function Me(ue){return{isWholeLine:ue.isWholeLine,rangeBehavior:ue.rangeBehavior?W.from(ue.rangeBehavior):void 0,overviewRulerLane:ue.overviewRulerLane,light:ue.light?X.from(ue.light):void 0,dark:ue.dark?X.from(ue.dark):void 0,backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?Ce(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?Fe.from(ue.before):void 0,after:ue.after?Fe.from(ue.after):void 0}}ve.from=Me})(ie||(e.DecorationRenderOptions=ie={}));var Se;(function(ve){function Me(Q){return{text:Q.newText,eol:Q.newEol&&_.from(Q.newEol),range:T.from(Q.range)}}ve.from=Me;function ue(Q){const Pe=new w.$DM(T.to(Q.range),Q.text);return Pe.newEol=typeof Q.eol>"u"?void 0:_.to(Q.eol),Pe}ve.to=ue})(Se||(e.TextEdit=Se={}));var he;(function(ve){function Me(Q,Pe){const Ue={edits:[]};if(Q instanceof w.$GM){const Xe=new M.$Bc;for(const qe of Q._allEntries())qe._type===w.FileEditType.File&&o.URI.isUri(qe.to)&&qe.from===void 0&&Xe.add(qe.to);for(const qe of Q._allEntries())if(qe._type===w.FileEditType.File){let ut;qe.options?.contents&&(ArrayBuffer.isView(qe.options.contents)?ut={type:"base64",value:(0,R.$4e)(R.$Je.wrap(qe.options.contents))}:ut={type:"dataTransferItem",id:qe.options.contents._itemId}),Ue.edits.push({oldResource:qe.from,newResource:qe.to,options:{...qe.options,contents:ut},metadata:qe.metadata})}else qe._type===w.FileEditType.Text?Ue.edits.push({resource:qe.uri,textEdit:Se.from(qe.edit),versionId:Xe.has(qe.uri)?void 0:Pe?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===w.FileEditType.Snippet?Ue.edits.push({resource:qe.uri,textEdit:{range:T.from(qe.range),text:qe.edit.value,insertAsSnippet:!0},versionId:Xe.has(qe.uri)?void 0:Pe?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===w.FileEditType.Cell?Ue.edits.push({metadata:qe.metadata,resource:qe.uri,cellEdit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Pe?.getNotebookDocumentVersion(qe.uri)}):qe._type===w.FileEditType.CellReplace&&Ue.edits.push({metadata:qe.metadata,resource:qe.uri,notebookVersionId:Pe?.getNotebookDocumentVersion(qe.uri),cellEdit:{editType:y.CellEditType.Replace,index:qe.index,count:qe.count,cells:qe.cells.map(Wt.from)}})}return Ue}ve.from=Me;function ue(Q){const Pe=new w.$GM,Ue=new M.$Ac;for(const Xe of Q.edits)if(Xe.textEdit){const qe=Xe,ut=o.URI.revive(qe.resource),kt=T.to(qe.textEdit.range),Zt=qe.textEdit.text,ii=qe.textEdit.insertAsSnippet;let Ft;ii?Ft=w.$FM.replace(kt,new w.$HM(Zt)):Ft=w.$DM.replace(kt,Zt);const Ht=Ue.get(ut);Ht?Ht.push(Ft):Ue.set(ut,[Ft])}else Pe.renameFile(o.URI.revive(Xe.oldResource),o.URI.revive(Xe.newResource),Xe.options);for(const[Xe,qe]of Ue)Pe.set(Xe,qe);return Pe}ve.to=ue})(he||(e.WorkspaceEdit=he={}));var we;(function(ve){const Me=Object.create(null);Me[w.SymbolKind.File]=s.SymbolKind.File,Me[w.SymbolKind.Module]=s.SymbolKind.Module,Me[w.SymbolKind.Namespace]=s.SymbolKind.Namespace,Me[w.SymbolKind.Package]=s.SymbolKind.Package,Me[w.SymbolKind.Class]=s.SymbolKind.Class,Me[w.SymbolKind.Method]=s.SymbolKind.Method,Me[w.SymbolKind.Property]=s.SymbolKind.Property,Me[w.SymbolKind.Field]=s.SymbolKind.Field,Me[w.SymbolKind.Constructor]=s.SymbolKind.Constructor,Me[w.SymbolKind.Enum]=s.SymbolKind.Enum,Me[w.SymbolKind.Interface]=s.SymbolKind.Interface,Me[w.SymbolKind.Function]=s.SymbolKind.Function,Me[w.SymbolKind.Variable]=s.SymbolKind.Variable,Me[w.SymbolKind.Constant]=s.SymbolKind.Constant,Me[w.SymbolKind.String]=s.SymbolKind.String,Me[w.SymbolKind.Number]=s.SymbolKind.Number,Me[w.SymbolKind.Boolean]=s.SymbolKind.Boolean,Me[w.SymbolKind.Array]=s.SymbolKind.Array,Me[w.SymbolKind.Object]=s.SymbolKind.Object,Me[w.SymbolKind.Key]=s.SymbolKind.Key,Me[w.SymbolKind.Null]=s.SymbolKind.Null,Me[w.SymbolKind.EnumMember]=s.SymbolKind.EnumMember,Me[w.SymbolKind.Struct]=s.SymbolKind.Struct,Me[w.SymbolKind.Event]=s.SymbolKind.Event,Me[w.SymbolKind.Operator]=s.SymbolKind.Operator,Me[w.SymbolKind.TypeParameter]=s.SymbolKind.TypeParameter;function ue(Pe){return typeof Me[Pe]=="number"?Me[Pe]:s.SymbolKind.Property}ve.from=ue;function Q(Pe){for(const Ue in Me)if(Me[Ue]===Pe)return Number(Ue);return w.SymbolKind.Property}ve.to=Q})(we||(e.SymbolKind=we={}));var ae;(function(ve){function Me(Q){switch(Q){case w.SymbolTag.Deprecated:return s.SymbolTag.Deprecated}}ve.from=Me;function ue(Q){switch(Q){case s.SymbolTag.Deprecated:return w.SymbolTag.Deprecated}}ve.to=ue})(ae||(e.SymbolTag=ae={}));var Y;(function(ve){function Me(Q){return{name:Q.name,kind:we.from(Q.kind),tags:Q.tags&&Q.tags.map(ae.from),containerName:Q.containerName,location:Be.from(Q.location)}}ve.from=Me;function ue(Q){const Pe=new w.$PM(Q.name,we.to(Q.kind),Q.containerName,Be.to(Q.location));return Pe.tags=Q.tags&&Q.tags.map(ae.to),Pe}ve.to=ue})(Y||(e.WorkspaceSymbol=Y={}));var x;(function(ve){function Me(Q){const Pe={name:Q.name||"!!MISSING: name!!",detail:Q.detail,range:T.from(Q.range),selectionRange:T.from(Q.selectionRange),kind:we.from(Q.kind),tags:Q.tags?.map(ae.from)??[]};return Q.children&&(Pe.children=Q.children.map(Me)),Pe}ve.from=Me;function ue(Q){const Pe=new w.$QM(Q.name,Q.detail,we.to(Q.kind),T.to(Q.range),T.to(Q.selectionRange));return(0,E.$Lb)(Q.tags)&&(Pe.tags=Q.tags.map(ae.to)),Q.children&&(Pe.children=Q.children.map(ue)),Pe}ve.to=ue})(x||(e.DocumentSymbol=x={}));var me;(function(ve){function Me(Q){const Pe=new w.$UM(we.to(Q.kind),Q.name,Q.detail||"",o.URI.revive(Q.uri),T.to(Q.range),T.to(Q.selectionRange));return Pe._sessionId=Q._sessionId,Pe._itemId=Q._itemId,Pe}ve.to=Me;function ue(Q,Pe,Ue){if(Pe=Pe??Q._sessionId,Ue=Ue??Q._itemId,Pe===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Ue,name:Q.name,detail:Q.detail,kind:we.from(Q.kind),uri:Q.uri,range:T.from(Q.range),selectionRange:T.from(Q.selectionRange),tags:Q.tags?.map(ae.from)}}ve.from=ue})(me||(e.CallHierarchyItem=me={}));var ge;(function(ve){function Me(ue){return new w.$VM(me.to(ue.from),ue.fromRanges.map(Q=>T.to(Q)))}ve.to=Me})(ge||(e.CallHierarchyIncomingCall=ge={}));var Te;(function(ve){function Me(ue){return new w.$WM(me.to(ue.to),ue.fromRanges.map(Q=>T.to(Q)))}ve.to=Me})(Te||(e.CallHierarchyOutgoingCall=Te={}));var Be;(function(ve){function Me(Q){return{range:Q.range&&T.from(Q.range),uri:Q.uri}}ve.from=Me;function ue(Q){return new w.$IM(o.URI.revive(Q.uri),T.to(Q.range))}ve.to=ue})(Be||(e.location=Be={}));var Ee;(function(ve){function Me(Q){const Pe=Q,Ue=Q;return{originSelectionRange:Pe.originSelectionRange?T.from(Pe.originSelectionRange):void 0,uri:Pe.targetUri?Pe.targetUri:Ue.uri,range:T.from(Pe.targetRange?Pe.targetRange:Ue.range),targetSelectionRange:Pe.targetSelectionRange?T.from(Pe.targetSelectionRange):void 0}}ve.from=Me;function ue(Q){return{targetUri:o.URI.revive(Q.uri),targetRange:T.to(Q.range),targetSelectionRange:Q.targetSelectionRange?T.to(Q.targetSelectionRange):void 0,originSelectionRange:Q.originSelectionRange?T.to(Q.originSelectionRange):void 0}}ve.to=ue})(Ee||(e.DefinitionLink=Ee={}));var Re;(function(ve){function Me(Q){return{range:T.from(Q.range),contents:$e.fromMany(Q.contents),canIncreaseVerbosity:Q.canIncreaseVerbosity,canDecreaseVerbosity:Q.canDecreaseVerbosity}}ve.from=Me;function ue(Q){const Pe=Q.contents.map($e.to),Ue=T.to(Q.range),Xe=Q.canIncreaseVerbosity,qe=Q.canDecreaseVerbosity;return new w.$MM(Pe,Ue,Xe,qe)}ve.to=ue})(Re||(e.Hover=Re={}));var Oe;(function(ve){function Me(Q){return{range:T.from(Q.range),expression:Q.expression}}ve.from=Me;function ue(Q){return new w.$HN(T.to(Q.range),Q.expression)}ve.to=ue})(Oe||(e.EvaluatableExpression=Oe={}));var j;(function(ve){function Me(Q){if(Q instanceof w.$IN)return{type:"text",range:T.from(Q.range),text:Q.text};if(Q instanceof w.$JN)return{type:"variable",range:T.from(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};if(Q instanceof w.$KN)return{type:"expression",range:T.from(Q.range),expression:Q.expression};throw new Error("Unknown 'InlineValue' type")}ve.from=Me;function ue(Q){switch(Q.type){case"text":return{range:T.to(Q.range),text:Q.text};case"variable":return{range:T.to(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};case"expression":return{range:T.to(Q.range),expression:Q.expression}}}ve.to=ue})(j||(e.InlineValue=j={}));var z;(function(ve){function Me(Q){return{frameId:Q.frameId,stoppedLocation:T.from(Q.stoppedLocation)}}ve.from=Me;function ue(Q){return new w.$LN(Q.frameId,T.to(Q.stoppedLocation))}ve.to=ue})(z||(e.InlineValueContext=z={}));var K;(function(ve){function Me(Q){return{range:T.from(Q.range),kind:Q.kind}}ve.from=Me;function ue(Q){return new w.$NM(T.to(Q.range),Q.kind)}ve.to=ue})(K||(e.DocumentHighlight=K={}));var J;(function(ve){function Me(Q){return{uri:Q.uri,highlights:Q.highlights.map(K.from)}}ve.from=Me;function ue(Q){return new w.$OM(o.URI.revive(Q.uri),Q.highlights.map(K.to))}ve.to=ue})(J||(e.MultiDocumentHighlight=J={}));var te;(function(ve){function Me(ue){switch(ue){case s.CompletionTriggerKind.TriggerCharacter:return w.CompletionTriggerKind.TriggerCharacter;case s.CompletionTriggerKind.TriggerForIncompleteCompletions:return w.CompletionTriggerKind.TriggerForIncompleteCompletions;case s.CompletionTriggerKind.Invoke:default:return w.CompletionTriggerKind.Invoke}}ve.to=Me})(te||(e.CompletionTriggerKind=te={}));var le;(function(ve){function Me(ue){return{triggerKind:te.to(ue.triggerKind),triggerCharacter:ue.triggerCharacter}}ve.to=Me})(le||(e.CompletionContext=le={}));var Ae;(function(ve){function Me(Q){switch(Q){case w.CompletionItemTag.Deprecated:return s.CompletionItemTag.Deprecated}}ve.from=Me;function ue(Q){switch(Q){case s.CompletionItemTag.Deprecated:return w.CompletionItemTag.Deprecated}}ve.to=ue})(Ae||(e.CompletionItemTag=Ae={}));var je;(function(ve){const Me=new Map([[w.CompletionItemKind.Method,s.CompletionItemKind.Method],[w.CompletionItemKind.Function,s.CompletionItemKind.Function],[w.CompletionItemKind.Constructor,s.CompletionItemKind.Constructor],[w.CompletionItemKind.Field,s.CompletionItemKind.Field],[w.CompletionItemKind.Variable,s.CompletionItemKind.Variable],[w.CompletionItemKind.Class,s.CompletionItemKind.Class],[w.CompletionItemKind.Interface,s.CompletionItemKind.Interface],[w.CompletionItemKind.Struct,s.CompletionItemKind.Struct],[w.CompletionItemKind.Module,s.CompletionItemKind.Module],[w.CompletionItemKind.Property,s.CompletionItemKind.Property],[w.CompletionItemKind.Unit,s.CompletionItemKind.Unit],[w.CompletionItemKind.Value,s.CompletionItemKind.Value],[w.CompletionItemKind.Constant,s.CompletionItemKind.Constant],[w.CompletionItemKind.Enum,s.CompletionItemKind.Enum],[w.CompletionItemKind.EnumMember,s.CompletionItemKind.EnumMember],[w.CompletionItemKind.Keyword,s.CompletionItemKind.Keyword],[w.CompletionItemKind.Snippet,s.CompletionItemKind.Snippet],[w.CompletionItemKind.Text,s.CompletionItemKind.Text],[w.CompletionItemKind.Color,s.CompletionItemKind.Color],[w.CompletionItemKind.File,s.CompletionItemKind.File],[w.CompletionItemKind.Reference,s.CompletionItemKind.Reference],[w.CompletionItemKind.Folder,s.CompletionItemKind.Folder],[w.CompletionItemKind.Event,s.CompletionItemKind.Event],[w.CompletionItemKind.Operator,s.CompletionItemKind.Operator],[w.CompletionItemKind.TypeParameter,s.CompletionItemKind.TypeParameter],[w.CompletionItemKind.Issue,s.CompletionItemKind.Issue],[w.CompletionItemKind.User,s.CompletionItemKind.User]]);function ue(Ue){return Me.get(Ue)??s.CompletionItemKind.Property}ve.from=ue;const Q=new Map([[s.CompletionItemKind.Method,w.CompletionItemKind.Method],[s.CompletionItemKind.Function,w.CompletionItemKind.Function],[s.CompletionItemKind.Constructor,w.CompletionItemKind.Constructor],[s.CompletionItemKind.Field,w.CompletionItemKind.Field],[s.CompletionItemKind.Variable,w.CompletionItemKind.Variable],[s.CompletionItemKind.Class,w.CompletionItemKind.Class],[s.CompletionItemKind.Interface,w.CompletionItemKind.Interface],[s.CompletionItemKind.Struct,w.CompletionItemKind.Struct],[s.CompletionItemKind.Module,w.CompletionItemKind.Module],[s.CompletionItemKind.Property,w.CompletionItemKind.Property],[s.CompletionItemKind.Unit,w.CompletionItemKind.Unit],[s.CompletionItemKind.Value,w.CompletionItemKind.Value],[s.CompletionItemKind.Constant,w.CompletionItemKind.Constant],[s.CompletionItemKind.Enum,w.CompletionItemKind.Enum],[s.CompletionItemKind.EnumMember,w.CompletionItemKind.EnumMember],[s.CompletionItemKind.Keyword,w.CompletionItemKind.Keyword],[s.CompletionItemKind.Snippet,w.CompletionItemKind.Snippet],[s.CompletionItemKind.Text,w.CompletionItemKind.Text],[s.CompletionItemKind.Color,w.CompletionItemKind.Color],[s.CompletionItemKind.File,w.CompletionItemKind.File],[s.CompletionItemKind.Reference,w.CompletionItemKind.Reference],[s.CompletionItemKind.Folder,w.CompletionItemKind.Folder],[s.CompletionItemKind.Event,w.CompletionItemKind.Event],[s.CompletionItemKind.Operator,w.CompletionItemKind.Operator],[s.CompletionItemKind.TypeParameter,w.CompletionItemKind.TypeParameter],[s.CompletionItemKind.User,w.CompletionItemKind.User],[s.CompletionItemKind.Issue,w.CompletionItemKind.Issue]]);function Pe(Ue){return Q.get(Ue)??w.CompletionItemKind.Property}ve.to=Pe})(je||(e.CompletionItemKind=je={}));var Ge;(function(ve){function Me(ue,Q){const Pe=new w.$5M(ue.label);return Pe.insertText=ue.insertText,Pe.kind=je.to(ue.kind),Pe.tags=ue.tags?.map(Ae.to),Pe.detail=ue.detail,Pe.documentation=A.$Zk(ue.documentation)?$e.to(ue.documentation):ue.documentation,Pe.sortText=ue.sortText,Pe.filterText=ue.filterText,Pe.preselect=ue.preselect,Pe.commitCharacters=ue.commitCharacters,h.$ct.isIRange(ue.range)?Pe.range=T.to(ue.range):typeof ue.range=="object"&&(Pe.range={inserting:T.to(ue.range.insert),replacing:T.to(ue.range.replace)}),Pe.keepWhitespace=typeof ue.insertTextRules>"u"?!1:!!(ue.insertTextRules&s.CompletionItemInsertTextRule.KeepWhitespace),typeof ue.insertTextRules<"u"&&ue.insertTextRules&s.CompletionItemInsertTextRule.InsertAsSnippet?Pe.insertText=new w.$HM(ue.insertText):(Pe.insertText=ue.insertText,Pe.textEdit=Pe.range instanceof w.$yM?new w.$DM(Pe.range,Pe.insertText):void 0),ue.additionalTextEdits&&ue.additionalTextEdits.length>0&&(Pe.additionalTextEdits=ue.additionalTextEdits.map(Ue=>Se.to(Ue))),Pe.command=Q&&ue.command?Q.fromInternal(ue.command):void 0,Pe}ve.to=Me})(Ge||(e.CompletionItem=Ge={}));var Ze;(function(ve){function Me(Q){if(typeof Q.label!="string"&&!Array.isArray(Q.label))throw new TypeError("Invalid label");return{label:Q.label,documentation:$e.fromStrict(Q.documentation)}}ve.from=Me;function ue(Q){return{label:Q.label,documentation:A.$Zk(Q.documentation)?$e.to(Q.documentation):Q.documentation}}ve.to=ue})(Ze||(e.ParameterInformation=Ze={}));var tt;(function(ve){function Me(Q){return{label:Q.label,documentation:$e.fromStrict(Q.documentation),parameters:Array.isArray(Q.parameters)?Q.parameters.map(Ze.from):[],activeParameter:Q.activeParameter}}ve.from=Me;function ue(Q){return{label:Q.label,documentation:A.$Zk(Q.documentation)?$e.to(Q.documentation):Q.documentation,parameters:Array.isArray(Q.parameters)?Q.parameters.map(Ze.to):[],activeParameter:Q.activeParameter}}ve.to=ue})(tt||(e.SignatureInformation=tt={}));var _e;(function(ve){function Me(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(tt.from):[]}}ve.from=Me;function ue(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(tt.to):[]}}ve.to=ue})(_e||(e.SignatureHelp=_e={}));var it;(function(ve){function Me(ue,Q){const Pe=new w.$4M(V.to(Q.position),typeof Q.label=="string"?Q.label:Q.label.map(nt.to.bind(void 0,ue)),Q.kind&&mt.to(Q.kind));return Pe.textEdits=Q.textEdits&&Q.textEdits.map(Se.to),Pe.tooltip=A.$Zk(Q.tooltip)?$e.to(Q.tooltip):Q.tooltip,Pe.paddingLeft=Q.paddingLeft,Pe.paddingRight=Q.paddingRight,Pe}ve.to=Me})(it||(e.InlayHint=it={}));var nt;(function(ve){function Me(ue,Q){const Pe=new w.$3M(Q.label);return Pe.tooltip=A.$Zk(Q.tooltip)?$e.to(Q.tooltip):Q.tooltip,s.Command.is(Q.command)&&(Pe.command=ue.fromInternal(Q.command)),Q.location&&(Pe.location=Be.to(Q.location)),Pe}ve.to=Me})(nt||(e.InlayHintLabelPart=nt={}));var mt;(function(ve){function Me(Q){return Q}ve.from=Me;function ue(Q){return Q}ve.to=ue})(mt||(e.InlayHintKind=mt={}));var lt;(function(ve){function Me(Q){return{range:T.from(Q.range),url:Q.target,tooltip:Q.tooltip}}ve.from=Me;function ue(Q){let Pe;if(Q.url)try{Pe=typeof Q.url=="string"?o.URI.parse(Q.url,!0):o.URI.revive(Q.url)}catch{}return new w.$0M(T.to(Q.range),Pe)}ve.to=ue})(lt||(e.DocumentLink=lt={}));var rt;(function(ve){function Me(Q){const Pe=new w.$aN(Q.label);return Q.textEdit&&(Pe.textEdit=Se.to(Q.textEdit)),Q.additionalTextEdits&&(Pe.additionalTextEdits=Q.additionalTextEdits.map(Ue=>Se.to(Ue))),Pe}ve.to=Me;function ue(Q){return{label:Q.label,textEdit:Q.textEdit?Se.from(Q.textEdit):void 0,additionalTextEdits:Q.additionalTextEdits?Q.additionalTextEdits.map(Pe=>Se.from(Pe)):void 0}}ve.from=ue})(rt||(e.ColorPresentation=rt={}));var at;(function(ve){function Me(Q){return new w.$$M(Q[0],Q[1],Q[2],Q[3])}ve.to=Me;function ue(Q){return[Q.red,Q.green,Q.blue,Q.alpha]}ve.from=ue})(at||(e.Color=at={}));var dt;(function(ve){function Me(Q){return{range:T.from(Q.range)}}ve.from=Me;function ue(Q){return new w.$TM(T.to(Q.range))}ve.to=ue})(dt||(e.SelectionRange=dt={}));var We;(function(ve){function Me(ue){switch(ue){case l.SaveReason.AUTO:return w.TextDocumentSaveReason.AfterDelay;case l.SaveReason.EXPLICIT:return w.TextDocumentSaveReason.Manual;case l.SaveReason.FOCUS_CHANGE:case l.SaveReason.WINDOW_CHANGE:return w.TextDocumentSaveReason.FocusOut}}ve.to=Me})(We||(e.TextDocumentSaveReason=We={}));var ze;(function(ve){function Me(Q){switch(Q){case w.TextEditorLineNumbersStyle.Off:return a.RenderLineNumbersType.Off;case w.TextEditorLineNumbersStyle.Relative:return a.RenderLineNumbersType.Relative;case w.TextEditorLineNumbersStyle.Interval:return a.RenderLineNumbersType.Interval;case w.TextEditorLineNumbersStyle.On:default:return a.RenderLineNumbersType.On}}ve.from=Me;function ue(Q){switch(Q){case a.RenderLineNumbersType.Off:return w.TextEditorLineNumbersStyle.Off;case a.RenderLineNumbersType.Relative:return w.TextEditorLineNumbersStyle.Relative;case a.RenderLineNumbersType.Interval:return w.TextEditorLineNumbersStyle.Interval;case a.RenderLineNumbersType.On:default:return w.TextEditorLineNumbersStyle.On}}ve.to=ue})(ze||(e.TextEditorLineNumbersStyle=ze={}));var _;(function(ve){function Me(Q){if(Q===w.EndOfLine.CRLF)return n.EndOfLineSequence.CRLF;if(Q===w.EndOfLine.LF)return n.EndOfLineSequence.LF}ve.from=Me;function ue(Q){if(Q===n.EndOfLineSequence.CRLF)return w.EndOfLine.CRLF;if(Q===n.EndOfLineSequence.LF)return w.EndOfLine.LF}ve.to=ue})(_||(e.EndOfLine=_={}));var H;(function(ve){function Me(ue){if(typeof ue=="object")return ue.viewId;switch(ue){case w.ProgressLocation.SourceControl:return g.ProgressLocation.Scm;case w.ProgressLocation.Window:return g.ProgressLocation.Window;case w.ProgressLocation.Notification:return g.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}ve.from=Me})(H||(e.ProgressLocation=H={}));var ye;(function(ve){function Me(Q){const Pe={start:Q.start+1,end:Q.end+1};return Q.kind&&(Pe.kind=Ke.from(Q.kind)),Pe}ve.from=Me;function ue(Q){const Pe={start:Q.start-1,end:Q.end-1};return Q.kind&&(Pe.kind=Ke.to(Q.kind)),Pe}ve.to=ue})(ye||(e.FoldingRange=ye={}));var Ke;(function(ve){function Me(Q){if(Q)switch(Q){case w.FoldingRangeKind.Comment:return s.$Pv.Comment;case w.FoldingRangeKind.Imports:return s.$Pv.Imports;case w.FoldingRangeKind.Region:return s.$Pv.Region}}ve.from=Me;function ue(Q){if(Q)switch(Q.value){case s.$Pv.Comment.value:return w.FoldingRangeKind.Comment;case s.$Pv.Imports.value:return w.FoldingRangeKind.Imports;case s.$Pv.Region.value:return w.FoldingRangeKind.Region}}ve.to=ue})(Ke||(e.FoldingRangeKind=Ke={}));var xe;(function(ve){function Me(ue){if(ue)return{pinned:typeof ue.preview=="boolean"?!ue.preview:void 0,inactive:ue.background,preserveFocus:ue.preserveFocus,selection:typeof ue.selection=="object"?T.from(ue.selection):void 0,override:typeof ue.override=="boolean"?l.$FF.id:void 0}}ve.from=Me})(xe||(e.TextEditorOpenOptions=xe={}));var ct;(function(ve){function Me(Ue){return Ue instanceof w.$vN?Ue.toJSON():typeof Ue=="string"?Ue:ue(Ue)||Q(Ue)?new w.$vN(Ue.baseUri??Ue.base,Ue.pattern).toJSON():Ue}ve.from=Me;function ue(Ue){const Xe=Ue;return Xe?o.URI.isUri(Xe.baseUri)&&typeof Xe.pattern=="string":!1}function Q(Ue){const Xe=Ue;return Xe?typeof Xe.base=="string"&&typeof Xe.pattern=="string":!1}function Pe(Ue){return typeof Ue=="string"?Ue:new w.$vN(o.URI.revive(Ue.baseUri),Ue.pattern)}ve.to=Pe})(ct||(e.GlobPattern=ct={}));var gt;(function(ve){function Me(ue){if(ue){if(Array.isArray(ue))return ue.map(Me);if(typeof ue=="string")return ue;{const Q=ue;return{language:Q.language,scheme:Q.scheme,pattern:ct.from(Q.pattern),exclusive:Q.exclusive,notebookType:Q.notebookType}}}else return}ve.from=Me})(gt||(e.LanguageSelector=gt={}));var Mt;(function(ve){function Me(Q){return!!Q&&typeof Q=="object"&&"documents"in Q&&Array.isArray(Q.documents)&&Q.documents.every(Pe=>Array.isArray(Pe)&&Pe.every(Ue=>Ue&&typeof Ue=="object"&&"uri"in Ue&&o.URI.isUri(Ue.uri)&&"version"in Ue&&typeof Ue.version=="number"&&"ranges"in Ue&&Array.isArray(Ue.ranges)&&Ue.ranges.every(Xe=>Xe instanceof w.$yM)))}ve.is=Me;function ue(Q){return{documents:Q.documents.map(Pe=>Pe.map(Ue=>({uri:o.URI.from(Ue.uri),version:Ue.version,ranges:Ue.ranges.map(Xe=>T.from(Xe))})))}}ve.from=ue})(Mt||(e.MappedEditsContext=Mt={}));var Qt;(function(ve){function Me(Q){return{start:Q.start,end:Q.end}}ve.from=Me;function ue(Q){return new w.$YN(Q.start,Q.end)}ve.to=ue})(Qt||(e.NotebookRange=Qt={}));var Ut;(function(ve){function Me(Q){return{timing:typeof Q.runStartTime=="number"&&typeof Q.runEndTime=="number"?{startTime:Q.runStartTime,endTime:Q.runEndTime}:void 0,executionOrder:Q.executionOrder,success:Q.lastRunSuccess}}ve.to=Me;function ue(Q){return{lastRunSuccess:Q.success,runStartTime:Q.timing?.startTime,runEndTime:Q.timing?.endTime,executionOrder:Q.executionOrder}}ve.from=ue})(Ut||(e.NotebookCellExecutionSummary=Ut={}));var li;(function(ve){function Me(ue){if(ue===y.NotebookCellExecutionState.Unconfirmed)return w.NotebookCellExecutionState.Pending;if(ue===y.NotebookCellExecutionState.Pending)return;if(ue===y.NotebookCellExecutionState.Executing)return w.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ue}`)}ve.to=Me})(li||(e.NotebookCellExecutionState=li={}));var xt;(function(ve){function Me(Q){switch(Q){case w.NotebookCellKind.Markup:return y.CellKind.Markup;case w.NotebookCellKind.Code:default:return y.CellKind.Code}}ve.from=Me;function ue(Q){switch(Q){case y.CellKind.Markup:return w.NotebookCellKind.Markup;case y.CellKind.Code:default:return w.NotebookCellKind.Code}}ve.to=ue})(xt||(e.NotebookCellKind=xt={}));var Ye;(function(ve){function Me(Q){const Pe={metadata:Q.metadata??Object.create(null),cells:[]};for(const Ue of Q.cells)w.$ZN.validate(Ue),Pe.cells.push(Wt.from(Ue));return Pe}ve.from=Me;function ue(Q){const Pe=new w.$1N(Q.cells.map(Wt.to));return(0,r.$ng)(Q.metadata)||(Pe.metadata=Q.metadata),Pe}ve.to=ue})(Ye||(e.NotebookData=Ye={}));var Wt;(function(ve){function Me(Q){return{cellKind:xt.from(Q.kind),language:Q.languageId,mime:Q.mime,source:Q.value,metadata:Q.metadata,internalMetadata:Ut.from(Q.executionSummary??{}),outputs:Q.outputs?Q.outputs.map(ft.from):[]}}ve.from=Me;function ue(Q){return new w.$ZN(xt.to(Q.cellKind),Q.source,Q.language,Q.mime,Q.outputs?Q.outputs.map(ft.to):void 0,Q.metadata,Q.internalMetadata?Ut.to(Q.internalMetadata):void 0)}ve.to=ue})(Wt||(e.NotebookCellData=Wt={}));var zt;(function(ve){function Me(Q){return{mime:Q.mime,valueBytes:R.$Je.wrap(Q.data)}}ve.from=Me;function ue(Q){return new w.$2N(Q.valueBytes.buffer,Q.mime)}ve.to=ue})(zt||(e.NotebookCellOutputItem=zt={}));var ft;(function(ve){function Me(Q){return{outputId:Q.id,items:Q.items.map(zt.from),metadata:Q.metadata}}ve.from=Me;function ue(Q){const Pe=Q.items.map(zt.to);return new w.$3N(Pe,Q.outputId,Q.metadata)}ve.to=ue})(ft||(e.NotebookCellOutput=ft={}));var pt;(function(ve){function Me(Pe){return Q(Pe)?{include:ct.from(Pe.include)??void 0,exclude:ct.from(Pe.exclude)??void 0}:ct.from(Pe)??void 0}ve.from=Me;function ue(Pe){return Q(Pe)?{include:ct.to(Pe.include),exclude:ct.to(Pe.exclude)}:ct.to(Pe)}ve.to=ue;function Q(Pe){const Ue=Pe;return Ue?!(0,r.$jg)(Ue.include)&&!(0,r.$jg)(Ue.exclude):!1}})(pt||(e.NotebookExclusiveDocumentPattern=pt={}));var _t;(function(ve){function Me(ue,Q,Pe){const Ue=typeof ue.command=="string"?{title:"",command:ue.command}:ue.command;return{alignment:ue.alignment===w.NotebookCellStatusBarAlignment.Left?y.CellStatusbarAlignment.Left:y.CellStatusbarAlignment.Right,command:Q.toInternal(Ue,Pe),text:ue.text,tooltip:ue.tooltip,accessibilityInformation:ue.accessibilityInformation,priority:ue.priority}}ve.from=Me})(_t||(e.NotebookStatusBarItem=_t={}));var Yt;(function(ve){function Me(ue,Q,Pe){const Ue=typeof ue.command=="string"?{title:"",command:ue.command}:ue.command;return{command:Q.toInternal(Ue,Pe),label:ue.label,description:ue.description,detail:ue.detail,documentation:ue.documentation}}ve.from=Me})(Yt||(e.NotebookKernelSourceAction=Yt={}));var jt;(function(ve){function Me(ue){return{transientOutputs:ue?.transientOutputs??!1,transientCellMetadata:ue?.transientCellMetadata??{},transientDocumentMetadata:ue?.transientDocumentMetadata??{},cellContentMetadata:ue?.cellContentMetadata??{}}}ve.from=Me})(jt||(e.NotebookDocumentContentOptions=jt={}));var bt;(function(ve){function Me(Q){return{uri:Q.uri,provides:Q.provides}}ve.from=Me;function ue(Q){return new w.$5N(o.URI.revive(Q.uri),Q.provides)}ve.to=ue})(bt||(e.NotebookRendererScript=bt={}));var Ot;(function(ve){function Me(Q){return{message:$e.fromStrict(Q.message)||"",type:k.TestMessageType.Error,expected:Q.expectedOutput,actual:Q.actualOutput,contextValue:Q.contextValue,location:Q.location&&{range:T.from(Q.location.range),uri:Q.location.uri}}}ve.from=Me;function ue(Q){const Pe=new w.$$N(typeof Q.message=="string"?Q.message:$e.to(Q.message));return Pe.actualOutput=Q.actual,Pe.expectedOutput=Q.expected,Pe.contextValue=Q.contextValue,Pe.location=Q.location?Be.to(Q.location):void 0,Pe}ve.to=ue})(Ot||(e.TestMessage=Ot={}));var Gt;(function(ve){ve.namespace=k.$lL,ve.denamespace=k.$mL})(Gt||(e.TestTag=Gt={}));var Bt;(function(ve){function Me(Q){const Pe=(0,f.$UO)(Q).controllerId;return{extId:p.$gL.fromExtHostTestItem(Q,Pe).toString(),label:Q.label,uri:o.URI.revive(Q.uri),busy:Q.busy,tags:Q.tags.map(Ue=>Gt.namespace(Pe,Ue.id)),range:h.$ct.lift(T.from(Q.range)),description:Q.description||null,sortText:Q.sortText||null,error:Q.error&&$e.fromStrict(Q.error)||null}}ve.from=Me;function ue(Q){return{parent:void 0,error:void 0,id:p.$gL.fromString(Q.extId).localId,label:Q.label,uri:o.URI.revive(Q.uri),tags:(Q.tags||[]).map(Pe=>{const{tagId:Ue}=Gt.denamespace(Pe);return new w.$_N(Ue)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:T.to(Q.range||void 0),canResolveChildren:!1,busy:Q.busy,description:Q.description||void 0,sortText:Q.sortText||void 0}}ve.toPlain=ue})(Bt||(e.TestItem=Bt={})),function(ve){function Me(Q){return{id:Q.id}}ve.from=Me;function ue(Q){return new w.$_N(Q.id)}ve.to=ue}(Gt||(e.TestTag=Gt={}));var Qe;(function(ve){const Me=(Q,Pe)=>{const Ue=Q.value;if(!Ue)return;const Xe={...Bt.toPlain(Ue.item),parent:Pe,taskStates:Ue.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(ut=>ut.type===k.TestMessageType.Error).map(Ot.to)})),children:[]};if(Q.children)for(const qe of Q.children.values()){const ut=Me(qe,Xe);ut&&Xe.children.push(ut)}return Xe};function ue(Q){const Pe=new u.$NO;for(const qe of Q.items)Pe.insert(p.$gL.fromString(qe.item.extId).path,qe);const Ue=[Pe.nodes],Xe=[];for(;Ue.length;)for(const qe of Ue.pop())qe.value?Xe.push(qe):qe.children&&Ue.push(qe.children.values());return{completedAt:Q.completedAt,results:Xe.map(qe=>Me(qe)).filter(r.$ig)}}ve.to=ue})(Qe||(e.TestResults=Qe={}));var ei;(function(ve){function Me(Ue){return{covered:Ue.covered,total:Ue.total}}function ue(Ue){return"line"in Ue?V.from(Ue):T.from(Ue)}function Q(Ue){if(typeof Ue.executed=="number"&&Ue.executed<0)throw new Error(`Invalid coverage count ${Ue.executed}`);return"branches"in Ue?{count:Ue.executed,location:ue(Ue.location),type:k.DetailType.Statement,branches:Ue.branches.length?Ue.branches.map(Xe=>({count:Xe.executed,location:Xe.location&&ue(Xe.location),label:Xe.label})):void 0}:{type:k.DetailType.Declaration,name:Ue.name,count:Ue.executed,location:ue(Ue.location)}}ve.fromDetails=Q;function Pe(Ue,Xe,qe){return w.$bO(qe.statementCoverage),w.$bO(qe.branchCoverage),w.$bO(qe.declarationCoverage),{id:Xe,uri:qe.uri,statement:Me(qe.statementCoverage),branch:qe.branchCoverage&&Me(qe.branchCoverage),declaration:qe.declarationCoverage&&Me(qe.declarationCoverage),testId:qe instanceof w.$cO&&qe.testItem?p.$gL.fromExtHostTestItem(qe.testItem,Ue).toString():void 0}}ve.fromFile=Pe})(ei||(e.TestCoverage=ei={}));var ti;(function(ve){function Me(ue){switch(ue){case s.CodeActionTriggerType.Invoke:return w.CodeActionTriggerKind.Invoke;case s.CodeActionTriggerType.Auto:return w.CodeActionTriggerKind.Automatic}}ve.to=Me})(ti||(e.CodeActionTriggerKind=ti={}));var ci;(function(ve){function Me(Q){const Pe=new w.$gO(we.to(Q.kind),Q.name,Q.detail||"",o.URI.revive(Q.uri),T.to(Q.range),T.to(Q.selectionRange));return Pe._sessionId=Q._sessionId,Pe._itemId=Q._itemId,Pe}ve.to=Me;function ue(Q,Pe,Ue){if(Pe=Pe??Q._sessionId,Ue=Ue??Q._itemId,Pe===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Ue,kind:we.from(Q.kind),name:Q.name,detail:Q.detail??"",uri:Q.uri,range:T.from(Q.range),selectionRange:T.from(Q.selectionRange),tags:Q.tags?.map(ae.from)}}ve.from=ue})(ci||(e.TypeHierarchyItem=ci={}));var St;(function(ve){function Me(ue){if(ue)return{value:ue.value,tooltip:ue.tooltip}}ve.from=Me})(St||(e.ViewBadge=St={}));var Tt;(function(ve){function Me(Ue,Xe,qe){const ut=Xe.fileData;return ut?new w.$nN(new w.$oN(ut.name,o.URI.revive(ut.uri),ut.id,(0,O.$db)(()=>qe(ut.id)))):Ue===C.$Ys.uriList&&Xe.uriListData?new w.$mN(Pe(Xe.uriListData)):new w.$mN(Xe.asString)}ve.to=Me;async function ue(Ue,Xe){const qe=await Xe.asString();if(Ue===C.$Ys.uriList)return{asString:qe,fileData:void 0,uriListData:Q(qe)};const ut=Xe.asFile();return{asString:qe,fileData:ut?{name:ut.name,uri:ut.uri,id:ut._itemId??ut.id}:void 0}}ve.from=ue;function Q(Ue){return P.$_s.split(Ue).map(Xe=>{if(Xe.startsWith("#"))return Xe;try{return o.URI.parse(Xe)}catch{}return Xe})}function Pe(Ue){return P.$_s.create(Ue.map(Xe=>typeof Xe=="string"?Xe:o.URI.revive(Xe)))}})(Tt||(e.DataTransferItem=Tt={}));var Pt;(function(ve){function Me(Q,Pe){const Ue=Q.items.map(([Xe,qe])=>[Xe,Tt.to(Xe,qe,Pe)]);return new w.$pN(Ue)}ve.toDataTransfer=Me;async function ue(Q){const Pe={items:[]},Ue=[];for(const[Xe,qe]of Q)Ue.push((async()=>{Pe.items.push([Xe,await Tt.from(Xe,qe)])})());return await Promise.all(Ue),Pe}ve.from=ue})(Pt||(e.DataTransfer=Pt={}));var Nt;(function(ve){function Me(Q,Pe){return{kind:"reply",agentId:Q.participant??Pe?.agentId??"",subCommand:Q.command??Pe?.command,message:Q.prompt,title:Q.label}}ve.from=Me;function ue(Q){return{prompt:Q.message,label:Q.title,participant:Q.agentId,command:Q.subCommand}}ve.to=ue})(Nt||(e.ChatFollowup=Nt={}));var ui;(function(ve){function Me(Q){switch(Q.role){case I.ChatMessageRole.System:return new w.$HO(w.LanguageModelChatMessageRole.System,Q.content);case I.ChatMessageRole.User:return new w.$HO(w.LanguageModelChatMessageRole.User,Q.content);case I.ChatMessageRole.Assistant:return new w.$HO(w.LanguageModelChatMessageRole.Assistant,Q.content)}}ve.to=Me;function ue(Q){switch(Q.role){case w.LanguageModelChatMessageRole.System:return{role:I.ChatMessageRole.System,content:Q.content};case w.LanguageModelChatMessageRole.User:return{role:I.ChatMessageRole.User,content:Q.content};case w.LanguageModelChatMessageRole.Assistant:return{role:I.ChatMessageRole.Assistant,content:Q.content}}}ve.from=ue})(ui||(e.LanguageModelChatMessage=ui={}));var Vt;(function(ve){function Me(Q){return{kind:"markdownContent",content:$e.from(Q.value)}}ve.from=Me;function ue(Q){return new w.$tO($e.to(Q.content))}ve.to=ue})(Vt||(e.ChatResponseMarkdownPart=Vt={}));var ri;(function(ve){function Me(Q){return{kind:"markdownVuln",content:$e.from(Q.value),vulnerabilities:Q.vulnerabilities}}ve.from=Me;function ue(Q){return new w.$uO($e.to(Q.content),Q.vulnerabilities)}ve.to=ue})(ri||(e.ChatResponseMarkdownWithVulnerabilitiesPart=ri={}));var Lt;(function(ve){function Me(Q){return{kind:"agentDetection",agentId:Q.participant,command:Q.command}}ve.from=Me;function ue(Q){return new w.$vO(Q.agentId,Q.command)}ve.to=ue})(Lt||(e.ChatResponseDetectedParticipantPart=Lt={}));var Xt;(function(ve){function Me(ue){return{kind:"confirmation",title:ue.title,message:ue.message,data:ue.data}}ve.from=Me})(Xt||(e.ChatResponseConfirmationPart=Xt={}));var si;(function(ve){function Me(Q){const{value:Pe,baseUri:Ue}=Q;function Xe(qe,ut){return qe.map(kt=>{const Zt=o.URI.joinPath(ut,kt.name);return{label:kt.name,uri:Zt,children:kt.children&&Xe(kt.children,Zt)}})}return{kind:"treeData",treeData:{label:(0,D.$$g)(Ue),uri:Ue,children:Xe(Pe,Ue)}}}ve.from=Me;function ue(Q){const Pe=(0,c.$0h)(Q.treeData);function Ue(ut){return ut.map(kt=>({name:kt.label,children:kt.children&&Ue(kt.children)}))}const Xe=Pe.uri,qe=Pe.children?Ue(Pe.children):[];return new w.$xO(qe,Xe)}ve.to=ue})(si||(e.ChatResponseFilesPart=si={}));var Ct;(function(ve){function Me(Q){const Pe=Ue=>o.URI.isUri(Ue);return{kind:"inlineReference",name:Q.title,inlineReference:Pe(Q.value)?Q.value:G.from(Q.value)}}ve.from=Me;function ue(Q){const Pe=(0,c.$0h)(Q);return new w.$yO(o.URI.isUri(Pe.inlineReference)?Pe.inlineReference:G.to(Pe.inlineReference),Q.name)}ve.to=ue})(Ct||(e.ChatResponseAnchorPart=Ct={}));var wt;(function(ve){function Me(Q){return{kind:"progressMessage",content:$e.from(Q.value)}}ve.from=Me;function ue(Q){return new w.$zO(Q.content.value)}ve.to=ue})(wt||(e.ChatResponseProgressPart=wt={}));var $t;(function(ve){function Me(Q){return{kind:"warning",content:$e.from(Q.value)}}ve.from=Me;function ue(Q){return new w.$BO(Q.content.value)}ve.to=ue})($t||(e.ChatResponseWarningPart=$t={}));var qt;(function(ve){function Me(ue){return{kind:"progressTask",content:$e.from(ue.value)}}ve.from=Me})(qt||(e.ChatTask=qt={}));var Dt;(function(ve){function Me(ue){return{kind:"progressTaskResult",content:typeof ue=="string"?$e.from(ue):void 0}}ve.from=Me})(Dt||(e.ChatTaskResult=Dt={}));var oi;(function(ve){function Me(Q,Pe,Ue){return{kind:"command",command:Pe.toInternal(Q.value,Ue)??{command:Q.value.command,title:Q.value.title}}}ve.from=Me;function ue(Q,Pe){return new w.$CO(Pe.fromInternal(Q.command)??{command:Q.command.id,title:Q.command.title})}ve.to=ue})(oi||(e.ChatResponseCommandButtonPart=oi={}));var Kt;(function(ve){function Me(Q){return{kind:"textEdit",uri:Q.uri,edits:Q.edits.map(Pe=>Se.from(Pe))}}ve.from=Me;function ue(Q){return new w.$EO(o.URI.revive(Q.uri),Q.edits.map(Pe=>Se.to(Pe)))}ve.to=ue})(Kt||(e.ChatResponseTextEditPart=Kt={}));var pi;(function(ve){function Me(Q){const Pe=d.ThemeIcon.isThemeIcon(Q.iconPath)?Q.iconPath:o.URI.isUri(Q.iconPath)?{light:o.URI.revive(Q.iconPath)}:Q.iconPath&&"light"in Q.iconPath&&"dark"in Q.iconPath&&o.URI.isUri(Q.iconPath.light)&&o.URI.isUri(Q.iconPath.dark)?{light:o.URI.revive(Q.iconPath.light),dark:o.URI.revive(Q.iconPath.dark)}:void 0;return"variableName"in Q.value?{kind:"reference",reference:{variableName:Q.value.variableName,value:o.URI.isUri(Q.value.value)||!Q.value.value?Q.value.value:G.from(Q.value.value)},iconPath:Pe}:{kind:"reference",reference:o.URI.isUri(Q.value)?Q.value:G.from(Q.value),iconPath:Pe}}ve.from=Me;function ue(Q){const Pe=(0,c.$0h)(Q),Ue=Xe=>o.URI.isUri(Xe)?Xe:G.to(Xe);return new w.$DO("variableName"in Pe.reference?{variableName:Pe.reference.variableName,value:Pe.reference.value&&Ue(Pe.reference.value)}:Ue(Pe.reference))}ve.to=ue})(pi||(e.ChatResponseReferencePart=pi={}));var di;(function(ve){function Me(Pe,Ue,Xe){return Pe instanceof w.$tO?Vt.from(Pe):Pe instanceof w.$yO?Ct.from(Pe):Pe instanceof w.$DO?pi.from(Pe):Pe instanceof w.$zO?wt.from(Pe):Pe instanceof w.$xO?si.from(Pe):Pe instanceof w.$CO?oi.from(Pe,Ue,Xe):Pe instanceof w.$EO?Kt.from(Pe):Pe instanceof w.$uO?ri.from(Pe):Pe instanceof w.$vO?Lt.from(Pe):Pe instanceof w.$BO?$t.from(Pe):{kind:"markdownContent",content:$e.from("")}}ve.from=Me;function ue(Pe,Ue){switch(Pe.kind){case"reference":return pi.to(Pe);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return Q(Pe,Ue)}}ve.to=ue;function Q(Pe,Ue){switch(Pe.kind){case"markdownContent":return Vt.to(Pe);case"inlineReference":return Ct.to(Pe);case"progressMessage":return;case"treeData":return si.to(Pe);case"command":return oi.to(Pe,Ue)}}ve.toContent=Q})(di||(e.ChatResponsePart=di={}));var ki;(function(ve){function Me(ue){return{prompt:ue.message,command:ue.command,attempt:ue.attempt??0,enableCommandDetection:ue.enableCommandDetection??!0,references:ue.variables.variables.map(Pi.to),location:Rt.to(ue.location),acceptedConfirmationData:ue.acceptedConfirmationData,rejectedConfirmationData:ue.rejectedConfirmationData}}ve.to=Me})(ki||(e.ChatAgentRequest=ki={}));var Rt;(function(ve){function Me(Q){switch(Q){case b.ChatAgentLocation.Notebook:return w.ChatLocation.Notebook;case b.ChatAgentLocation.Terminal:return w.ChatLocation.Terminal;case b.ChatAgentLocation.Panel:return w.ChatLocation.Panel;case b.ChatAgentLocation.Editor:return w.ChatLocation.Editor}}ve.to=Me;function ue(Q){switch(Q){case w.ChatLocation.Notebook:return b.ChatAgentLocation.Notebook;case w.ChatLocation.Terminal:return b.ChatAgentLocation.Terminal;case w.ChatLocation.Panel:return b.ChatAgentLocation.Panel;case w.ChatLocation.Editor:return b.ChatAgentLocation.Editor}}ve.from=ue})(Rt||(e.ChatLocation=Rt={}));var Pi;(function(ve){function Me(ue){const Q=ue.value;if(!Q)throw new Error("Invalid value reference");return{id:ue.id,name:ue.name,range:ue.range&&[ue.range.start,ue.range.endExclusive],value:(0,o.$vc)(Q)?o.URI.revive(Q):Q&&typeof Q=="object"&&"uri"in Q&&"range"in Q&&(0,o.$vc)(Q.uri)?G.to((0,c.$0h)(Q)):Q,modelDescription:ue.modelDescription}}ve.to=Me})(Pi||(e.ChatAgentValueReference=Pi={}));var ai;(function(ve){function Me(ue,Q,Pe){return{id:ue.id,label:ue.label,fullName:ue.fullName,icon:ue.icon?.id,value:ue.values[0].value,insertText:ue.insertText,detail:ue.detail,documentation:ue.documentation,command:Q.toInternal(ue.command,Pe)}}ve.from=Me})(ai||(e.ChatAgentCompletionItem=ai={}));var It;(function(ve){function Me(ue){return{errorDetails:ue.errorDetails,metadata:ue.metadata}}ve.to=Me})(It||(e.ChatAgentResult=It={}));var Ii;(function(ve){function Me(ue,Q,Pe){if(Q.action.kind==="vote")return;const Ue=It.to(ue);if(Q.action.kind==="command"){const Xe=Q.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Pe.fromInternal(Xe)??{command:Xe.id,title:Xe.title}}},result:Ue}}else return Q.action.kind==="followUp"?{action:{kind:"followUp",followup:Nt.to(Q.action.followup)},result:Ue}:Q.action.kind==="inlineChat"?{action:{kind:"editor",accepted:Q.action.action==="accepted"},result:Ue}:{action:Q.action,result:Ue}}ve.to=Me})(Ii||(e.ChatAgentUserActionEvent=Ii={}));var wi;(function(ve){function Me(ue,Q,Pe){return"terminalCommand"in ue?{terminalCommand:ue.terminalCommand,shouldExecute:ue.shouldExecute}:"uri"in ue?{uri:ue.uri}:Q.toInternal(ue,Pe)}ve.from=Me})(wi||(e.TerminalQuickFix=wi={}));var $i;(function(ve){function Me(ue){return{kind:Ri.to(ue.kind)}}ve.to=Me})($i||(e.PartialAcceptInfo=$i={}));var Ri;(function(ve){function Me(ue){switch(ue){case s.PartialAcceptTriggerKind.Word:return w.PartialAcceptTriggerKind.Word;case s.PartialAcceptTriggerKind.Line:return w.PartialAcceptTriggerKind.Line;case s.PartialAcceptTriggerKind.Suggest:return w.PartialAcceptTriggerKind.Suggest;default:return w.PartialAcceptTriggerKind.Unknown}}ve.to=Me})(Ri||(e.PartialAcceptTriggerKind=Ri={}));var fi;(function(ve){function Me(ue,Q){return{id:Q,label:ue.label,description:ue.description,canEdit:ue.canEdit,collapsibleState:ue.collapsibleState||S.DebugTreeItemCollapsibleState.None,contextValue:ue.contextValue}}ve.from=Me})(fi||(e.DebugTreeItem=fi={}))}),define(ke[273],Ie([1,0,5,17,10,38]),function(de,e,E,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wmc=void 0;let A=class{constructor($,c){this.a=$.getProxy(E.$uM.MainThreadBulkEdits),this.b={getTextDocumentVersion:C=>c.getDocument(C)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,c,C){const v=new O.$Kw(P.WorkspaceEdit.from($,this.b));return this.a.$tryApplyWorkspaceEdit(v,void 0,C?.isRefactoring??!1)}};e.$Wmc=A,e.$Wmc=A=He([Ve(0,R.$YO)],A)}),define(ke[274],Ie([1,0,18,11,48,4,40,6,69,15,2,19,5,10,7,234,25]),function(de,e,E,R,P,O,A,M,$,c,C,v,u,D,d,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xmc=void 0;class a{constructor(n,i,g,f,l){this.j=n,this.k=i,this.l=g,this.m=f,this.n=l,this.b=$.$be.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let i=function(f){if(n.c){const l=new Error("Response stream has been closed");throw Error.captureStackTrace(l,f),l}};const n=this;this.b.reset();const g=(f,l)=>{if(typeof this.d>"u"&&"content"in f&&(this.d=this.b.elapsed()),l){const b=this.l.$handleProgressChunk(this.k.requestId,f),I={report:S=>{b?.then(y=>{y&&(d.$YM.isMarkdownString(S.value)?this.l.$handleProgressChunk(this.k.requestId,D.ChatResponseWarningPart.from(S),y):this.l.$handleProgressChunk(this.k.requestId,D.ChatResponseReferencePart.from(S),y))})}};Promise.all([b,l?.(I)]).then(([S,y])=>{S!==void 0&&y!==void 0&&this.l.$handleProgressChunk(this.k.requestId,D.ChatTaskResult.from(y),S)})}else this.l.$handleProgressChunk(this.k.requestId,f)};this.g={markdown(f){i(this.markdown);const l=new d.$tO(f),b=D.ChatResponseMarkdownPart.from(l);return g(b),this},markdownWithVulnerabilities(f,l){i(this.markdown),l&&(0,o.$UG)(n.j,"chatParticipantAdditions");const b=new d.$uO(f,l),I=D.ChatResponseMarkdownWithVulnerabilitiesPart.from(b);return g(I),this},filetree(f,l){i(this.filetree);const b=new d.$xO(f,l),I=D.ChatResponseFilesPart.from(b);return g(I),this},anchor(f,l){i(this.anchor);const b=new d.$yO(f,l),I=D.ChatResponseAnchorPart.from(b);return g(I),this},button(f){i(this.anchor);const l=new d.$CO(f),b=D.ChatResponseCommandButtonPart.from(l,n.m,n.n);return g(b),this},progress(f,l){i(this.progress);const b=new d.$AO(f,l),I=l?D.ChatTask.from(b):D.ChatResponseProgressPart.from(b);return g(I,l),this},warning(f){i(this.progress),(0,o.$UG)(n.j,"chatParticipantAdditions");const l=new d.$BO(f),b=D.ChatResponseWarningPart.from(l);return g(b),this},reference(f,l){if(i(this.reference),"variableName"in f&&(0,o.$UG)(n.j,"chatParticipantAdditions"),"variableName"in f&&!f.value){const b=n.k.variables.variables.find(I=>I.name===f.variableName);if(b){let I;if(b.references?.length)I=b.references.map(S=>({kind:"reference",reference:{variableName:f.variableName,value:S.reference}}));else{const S=new d.$DO(f,l);I=[D.ChatResponseReferencePart.from(S)]}return I.forEach(S=>g(S)),this}}else{const b=new d.$DO(f,l),I=D.ChatResponseReferencePart.from(b);g(I)}return this},textEdit(f,l){i(this.textEdit),(0,o.$UG)(n.j,"chatParticipantAdditions");const b=new d.$EO(f,l),I=D.ChatResponseTextEditPart.from(b);return g(I),this},detectedParticipant(f,l){i(this.detectedParticipant),(0,o.$UG)(n.j,"chatParticipantAdditions");const b=new d.$vO(f,l),I=D.ChatResponseDetectedParticipantPart.from(b);return g(I),this},confirmation(f,l,b){i(this.confirmation),(0,o.$UG)(n.j,"chatParticipantAdditions");const I=new d.$wO(f,l,b),S=D.ChatResponseConfirmationPart.from(I);return g(S),this},push(f){if(i(this.push),(f instanceof d.$EO||f instanceof d.$uO||f instanceof d.$vO||f instanceof d.$BO||f instanceof d.$wO)&&(0,o.$UG)(n.j,"chatParticipantAdditions"),f instanceof d.$DO)this.reference(f.value,f.iconPath);else{const l=D.ChatResponsePart.from(f,n.m,n.n);g(l)}return this}}}return this.g}}class h extends M.$Uc{static{this.b=0}constructor(n,i,g,f){super(),this.n=i,this.s=g,this.t=f,this.c=new Map,this.j=this.B(new M.$4c),this.m=this.B(new M.$4c),this.g=n.getProxy(u.$uM.MainThreadChatAgents2)}transferActiveChat(n){this.g.$transferActiveChatSession(n)}createChatAgent(n,i,g){const f=h.b++,l=new t(n,this.t,i,this.g,f,g);return this.c.set(f,l),l.isAgentEnabled()&&this.g.$registerAgent(f,n.identifier,i,{},void 0),l.apiAgent}createDynamicChatAgent(n,i,g,f){const l=h.b++,b=new t(n,this.t,i,this.g,l,f);return this.c.set(l,b),this.g.$registerAgent(l,n.identifier,i,{isSticky:!0},g),b.apiAgent}async $invokeAgent(n,i,g,f){const l=this.c.get(n);if(!l)throw new Error(`[CHAT](${n}) CANNOT invoke agent because the agent is not registered`);let b=this.j.get(i.sessionId);b||(b=new M.$Tc,this.j.set(i.sessionId,b));const I=new a(l.extension,i,this.g,this.s.converter,b);try{const S=await this.u(i.agentId,g),y=l.invoke(D.ChatAgentRequest.to(i),{history:S},I.apiObject,f);return await(0,R.$oh)(Promise.resolve(y).then(p=>{if(p?.metadata)try{JSON.stringify(p.metadata)}catch(m){const w=`result.metadata MUST be JSON.stringify-able. Got error: ${m.message}`;return this.n.error(`[${l.extension.identifier.value}] [@${l.id}] ${w}`,l.extension),{errorDetails:{message:w},timings:I.timings}}let k;return p?.errorDetails&&(k={...p.errorDetails,responseIsIncomplete:!0}),k?.responseIsRedacted&&(0,o.$UG)(l.extension,"chatParticipantPrivate"),{errorDetails:k,timings:I.timings,metadata:p?.metadata}}),f)}catch(S){return this.n.error(S,l.extension),S instanceof d.$LO&&S.cause&&(S=S.cause),{errorDetails:{message:(0,P.$lj)(S),responseIsIncomplete:!0}}}finally{I.close()}}async u(n,i){const g=[];for(const f of i.history){const l=D.ChatAgentResult.to(f.result),b=n===f.request.agentId?l:{...l,metadata:void 0};g.push(new d.$FO(f.request.message,f.request.command,f.request.variables.variables.map(D.ChatAgentValueReference.to),f.request.agentId));const I=(0,E.$Hb)(f.response.map(S=>D.ChatResponsePart.toContent(S,this.s.converter)));g.push(new d.$GO(I,b,f.request.agentId,f.request.command))}return g}$releaseSession(n){this.j.deleteAndDispose(n)}async $provideFollowups(n,i,g,f,l){const b=this.c.get(i);if(!b)return Promise.resolve([]);const I=await this.u(b.id,f),S=D.ChatAgentResult.to(g);return(await b.provideFollowups(S,{history:I},l)).filter(y=>{const p=!y.participant||A.Iterable.some(this.c.values(),k=>k.id===y.participant&&v.$Wm.equals(k.extension.identifier,b.extension.identifier));return p||this.n.warn(`[@${b.id}] ChatFollowup refers to an unknown participant: ${y.participant}`),p}).map(y=>D.ChatFollowup.from(y,n))}$acceptFeedback(n,i,g,f){const l=this.c.get(n);if(!l)return;const b=D.ChatAgentResult.to(i);let I;switch(g){case r.ChatAgentVoteDirection.Down:I=d.ChatResultFeedbackKind.Unhelpful;break;case r.ChatAgentVoteDirection.Up:I=d.ChatResultFeedbackKind.Helpful;break}l.acceptFeedback(Object.freeze(f?{result:b,kind:I,reportIssue:f}:{result:b,kind:I}))}$acceptAction(n,i,g){const f=this.c.get(n);if(!f||g.action.kind==="vote")return;const l=D.ChatAgentUserActionEvent.to(i,g,this.s.converter);l&&f.acceptAction(Object.freeze(l))}async $invokeCompletionProvider(n,i,g){const f=this.c.get(n);if(!f)return[];let l=this.m.get(n);return l?l.clear():(l=new M.$Tc,this.m.set(n,l)),(await f.invokeCompletionProvider(i,g)).map(I=>D.ChatAgentCompletionItem.from(I,this.s.converter,l))}async $provideWelcomeMessage(n,i,g){const f=this.c.get(n);if(f)return await f.provideWelcomeMessage(D.ChatLocation.to(i),g)}async $provideSampleQuestions(n,i,g){const f=this.c.get(n);if(f)return(await f.provideSampleQuestions(D.ChatLocation.to(i),g)).map(l=>D.ChatFollowup.from(l,void 0))}}e.$Xmc=h;class t{constructor(n,i,g,f,l,b){this.extension=n,this.w=i,this.id=g,this.x=f,this.y=l,this.z=b,this.m=new O.$he,this.n=new O.$he}acceptFeedback(n){this.m.fire(n)}acceptAction(n){this.n.fire(n)}async invokeCompletionProvider(n,i){return this.q?await this.q.provider.provideCompletionItems(n,i)??[]:[]}isAgentEnabled(){return!(this.w==="stable"&&!(0,o.$TG)(this.extension,"chatParticipantPrivate"))}async provideFollowups(n,i,g){if(!this.b)return[];const f=await this.b.provideFollowups(n,i,g);return f?f.filter(l=>!(l&&"commandId"in l)).filter(l=>!(l&&"message"in l)):[]}async provideWelcomeMessage(n,i){if(!this.s)return[];const g=await this.s.provideWelcomeMessage(n,i);return g?g.map(f=>typeof f=="string"?f:D.MarkdownString.from(f)):[]}async provideSampleQuestions(n,i){if(!this.s||!this.s.provideSampleQuestions)return[];const g=await this.s.provideSampleQuestions(n,i);return g||[]}get apiAgent(){let n=!1,i=!1;const g=()=>{n||i||(i=!0,queueMicrotask(()=>{f.isAgentEnabled()&&(this.x.$updateAgent(this.y,{icon:this.c?this.c instanceof C.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof d.$tN?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.l,helpTextPrefix:!this.g||typeof this.g=="string"?this.g:D.MarkdownString.from(this.g),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:D.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:D.MarkdownString.from(this.k),supportIssueReporting:this.o,requester:this.t,supportsSlowVariables:this.u}),i=!1)}))},f=this;return{get id(){return f.id},get iconPath(){return f.c},set iconPath(l){f.c=l,g()},get requestHandler(){return f.z},set requestHandler(l){(0,c.$kg)(typeof l=="function","Invalid request handler"),f.z=l},get followupProvider(){return f.b},set followupProvider(l){f.b=l,g()},get isDefault(){return(0,o.$UG)(f.extension,"defaultChatParticipant"),f.d},set isDefault(l){(0,o.$UG)(f.extension,"defaultChatParticipant"),f.d=l,g()},get helpTextPrefix(){return(0,o.$UG)(f.extension,"defaultChatParticipant"),f.g},set helpTextPrefix(l){(0,o.$UG)(f.extension,"defaultChatParticipant"),f.g=l,g()},get helpTextVariablesPrefix(){return(0,o.$UG)(f.extension,"defaultChatParticipant"),f.j},set helpTextVariablesPrefix(l){(0,o.$UG)(f.extension,"defaultChatParticipant"),f.j=l,g()},get helpTextPostfix(){return(0,o.$UG)(f.extension,"defaultChatParticipant"),f.k},set helpTextPostfix(l){(0,o.$UG)(f.extension,"defaultChatParticipant"),f.k=l,g()},get isSecondary(){return(0,o.$UG)(f.extension,"defaultChatParticipant"),f.l},set isSecondary(l){(0,o.$UG)(f.extension,"defaultChatParticipant"),f.l=l,g()},get supportIssueReporting(){return(0,o.$UG)(f.extension,"chatParticipantPrivate"),f.o},set supportIssueReporting(l){(0,o.$UG)(f.extension,"chatParticipantPrivate"),f.o=l,g()},get onDidReceiveFeedback(){return f.m.event},set participantVariableProvider(l){if((0,o.$UG)(f.extension,"chatParticipantAdditions"),f.q=l,l){if(!l.triggerCharacters.length)throw new Error("triggerCharacters are required");f.x.$registerAgentCompletionsProvider(f.y,f.id,l.triggerCharacters)}else f.x.$unregisterAgentCompletionsProvider(f.y,f.id)},get participantVariableProvider(){return(0,o.$UG)(f.extension,"chatParticipantAdditions"),f.q},set welcomeMessageProvider(l){(0,o.$UG)(f.extension,"defaultChatParticipant"),f.s=l,g()},get welcomeMessageProvider(){return(0,o.$UG)(f.extension,"defaultChatParticipant"),f.s},onDidPerformAction:(0,o.$TG)(this.extension,"chatParticipantAdditions")?this.n.event:void 0,set requester(l){f.t=l,g()},get requester(){return f.t},set supportsSlowReferences(l){(0,o.$UG)(f.extension,"chatParticipantPrivate"),f.u=l,g()},get supportsSlowReferences(){return(0,o.$UG)(f.extension,"chatParticipantPrivate"),f.u},dispose(){n=!0,f.b=void 0,f.m.dispose(),f.x.$unregisterAgent(f.y)}}}invoke(n,i,g,f){return this.z(n,i,g,f)}}}),define(ke[275],Ie([1,0,14,6,34,5,10,7,25]),function(de,e,E,R,P,O,A,M,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ymc=void 0;class c{static{this.a=0}constructor(u){this.b=new Map,this.c=u.getProxy(O.$uM.MainThreadChatVariables)}async $resolveVariable(u,D,d,r){const o=this.b.get(u);if(o)try{if(o.resolver.resolve2){(0,$.$UG)(o.extension,"chatParticipantAdditions");const a=new C(D,this.c),h=await o.resolver.resolve2(o.data.name,{prompt:d},a.apiObject,r);if(h&&h[0])return h[0].value}else{const a=await o.resolver.resolve(o.data.name,{prompt:d},r);if(a&&a[0])return a[0].value}}catch(a){(0,E.$2)(a)}}registerVariableResolver(u,D,d,r,o,a,h,t,s){const n=c.a++,i=s?P.ThemeIcon.fromId(s):void 0;return this.b.set(n,{extension:u,data:{id:D,name:d,description:r,modelDescription:o,icon:i},resolver:h}),this.c.$registerVariable(n,{id:D,name:d,description:r,modelDescription:o,isSlow:a,fullName:t,icon:i}),(0,R.$Sc)(()=>{this.b.delete(n),this.c.$unregisterVariable(n)})}attachContext(u,D,d){this.c.$attachContext(u,M.$IM.isLocation(D)?A.Location.from(D):D,A.ChatLocation.from(d))}}e.$Ymc=c;class C{constructor(u,D){this.c=u,this.d=D,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let D=function(r){if(u.a){const o=new Error("Response stream has been closed");throw Error.captureStackTrace(o,r),o}};const u=this,d=r=>{this.d.$handleProgressChunk(this.c,r)};this.b={progress(r){D(this.progress);const o=new M.$zO(r),a=A.ChatResponseProgressPart.from(o);return d(a),this},reference(r){D(this.reference);const o=new M.$DO(r),a=A.ChatResponseReferencePart.from(o);return d(a),this},push(r){return D(this.push),r instanceof M.$DO?d(A.ChatResponseReferencePart.from(r)):r instanceof M.$zO&&d(A.ChatResponseProgressPart.from(r)),this}}}return this.b}}}),define(ke[276],Ie([1,0,11,72,4,6,37,2,94,19,10,7,5,25]),function(de,e,E,R,P,O,A,M,$,c,C,v,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3mc=d;function d(r,o,a){const h=r.getProxy(u.$uM.MainThreadComments);class t{static{this.a=0}constructor(){this.b=new Map,this.c=new c.$Ym,o.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===A.MarshalledId.CommentController){const p=this.b.get(y.handle);return p?p.value:y}else if(y&&y.$mid===A.MarshalledId.CommentThread){const p=y,k=this.b.get(p.commentControlHandle);if(!k)return p;const m=k.getCommentThread(p.commentThreadHandle);return m?m.value:p}else if(y&&(y.$mid===A.MarshalledId.CommentThreadReply||y.$mid===A.MarshalledId.CommentThreadInstance)){const p=this.b.get(y.thread.commentControlHandle);if(!p)return y;const k=p.getCommentThread(y.thread.commentThreadHandle);return k?y.$mid===A.MarshalledId.CommentThreadInstance?k.value:{thread:k.value,text:y.text}:y}else if(y&&y.$mid===A.MarshalledId.CommentNode){const p=this.b.get(y.thread.commentControlHandle);if(!p)return y;const k=p.getCommentThread(y.thread.commentThreadHandle);if(!k)return y;const m=y.commentUniqueId,w=k.getCommentByUniqueId(m);return w||y}else if(y&&y.$mid===A.MarshalledId.CommentThreadNode){const p=this.b.get(y.thread.commentControlHandle);if(!p)return y;const k=p.getCommentThread(y.thread.commentThreadHandle);if(!k)return y;const m=y.text,w=y.commentUniqueId,F=k.getCommentByUniqueId(w);return F?(typeof F.body=="string"?F.body=m:F.body=new v.$YM(m),F):y}return y}})}createCommentController(y,p,k){const m=t.a++,w=new n(y,m,p,k);this.b.set(w.handle,w);const F=this.c.get(y.identifier)||[];return F.push(w),this.c.set(y.identifier,F),w.value}async $createCommentThreadTemplate(y,p,k,m){const w=this.b.get(y);w&&w.$createCommentThreadTemplate(p,k,m)}async $setActiveComment(y,p){const k=this.b.get(y);k&&k.$setActiveComment(p??void 0)}async $updateCommentThreadTemplate(y,p,k){const m=this.b.get(y);m&&m.$updateCommentThreadTemplate(p,k)}$deleteCommentThread(y,p){this.b.get(y)?.$deleteCommentThread(p)}async $provideCommentingRanges(y,p,k){const m=this.b.get(y);if(!m||!m.commentingRangeProvider)return Promise.resolve(void 0);const w=await a.ensureDocumentData(M.URI.revive(p));return(0,E.$sh)(async()=>{const F=await m.commentingRangeProvider.provideCommentingRanges(w.document,k);let T;return Array.isArray(F)?T={ranges:F,fileComments:!1}:F?T={ranges:F.ranges||[],fileComments:F.fileComments||!1}:T=F??void 0,T}).then(F=>{let T;return F&&(T={ranges:F.ranges.map(G=>C.Range.from(G)),fileComments:F.fileComments}),T})}$toggleReaction(y,p,k,m,w){const F=this.b.get(y);return!F||!F.reactionHandler?Promise.resolve(void 0):(0,E.$sh)(()=>{const T=F.getCommentThread(p);if(T){const G=T.getCommentByUniqueId(m.uniqueIdInThread);if(F!==void 0&&G&&F.reactionHandler)return F.reactionHandler(G,f(w))}return Promise.resolve(void 0)})}}class s{static{this.a=0}set threadId(y){this.n=y}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(y){(y===void 0!=(this.p===void 0)||!y||!this.p||!y.isEqual(this.p))&&(this.p=y,this.b.range=y,this.c.fire())}get range(){return this.p}set canReply(y){this.d!==y&&(this.d=y,this.b.canReply=y,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(y){this.e=y,this.b.label=y,this.c.fire()}get contextValue(){return this.f}set contextValue(y){this.f=y,this.b.contextValue=y,this.c.fire()}get comments(){return this.q}set comments(y){this.q=y,this.b.comments=y,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(y){this.g=y,this.b.collapsibleState=y,this.c.fire()}get state(){return this.h}set state(y){this.h=y,typeof y=="object"?((0,D.$UG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=y.resolved,this.b.applicability=y.applicability):this.b.state=y,this.c.fire()}get isDisposed(){return this.j}constructor(y,p,k,m,w,F,T,G,q){this.m=p,this.n=k,this.o=m,this.p=w,this.q=F,this.extensionDescription=T,this.r=G,this.handle=s.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new P.$he,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new O.$Vc,this.l.value=new O.$Tc,this.n===void 0&&(this.n=`${y}.${this.handle}`),h.$createCommentThread(p,this.handle,this.n,this.o,C.Range.from(this.p),T.identifier,this.r,q),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=F,this.i.push({dispose:()=>{h.$deleteCommentThread(p,this.handle)}});const V=this;this.value={get uri(){return V.uri},get range(){return V.range},set range(N){V.range=N},get comments(){return V.comments},set comments(N){V.comments=N},get collapsibleState(){return V.collapsibleState},set collapsibleState(N){V.collapsibleState=N},get canReply(){return V.canReply},set canReply(N){V.canReply=N},get contextValue(){return V.contextValue},set contextValue(N){V.contextValue=N},get label(){return V.label},set label(N){V.label=N},get state(){return V.state},set state(N){V.state=N},dispose:()=>{V.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new O.$Tc);const y=k=>Object.prototype.hasOwnProperty.call(this.b,k),p={};y("range")&&(p.range=C.Range.from(this.p)),y("label")&&(p.label=this.label),y("contextValue")&&(p.contextValue=this.contextValue??null),y("comments")&&(p.comments=this.q.map(k=>i(this,k,this.k,this.extensionDescription))),y("collapsibleState")&&(p.collapseState=l(this.g)),y("canReply")&&(p.canReply=this.canReply),y("state")&&(p.state=b(this.h)),y("applicability")&&(p.applicability=I(this.h)),y("isTemplate")&&(p.isTemplate=this.r),this.b={},h.$updateCommentThread(this.m,this.handle,this.n,this.o,p)}getCommentByUniqueId(y){for(const p of this.k){const k=p[0],m=p[1];if(y===m)return k}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(y=>y.dispose())}}He([(0,R.$6h)(100)],s.prototype,"eventuallyUpdateCommentThread",null);class n{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(y){this.b=y,y?.resourceHints&&(0,D.$UG)(this.h,"commentingRangeHint"),h.$updateCommentingRanges(this.handle,y?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(y){this.c=y,h.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!y})}get options(){return this.d}set options(y){this.d=y,h.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,D.$UG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,D.$UG)(this.h,"activeComment"),this.f}constructor(y,p,k,m){this.h=y,this.i=p,this.j=k,this.k=m,this.a=new Map,h.$registerCommentController(this.handle,k,m,this.h.identifier.value);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(F){w.options=F},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(F){w.commentingRangeProvider=F},get reactionHandler(){return w.reactionHandler},set reactionHandler(F){w.reactionHandler=F},get activeCommentThread(){return w.activeCommentThread},createCommentThread(F,T,G){return w.createCommentThread(F,T,G).value},dispose:()=>{w.dispose()}}),this.g=[],this.g.push({dispose:()=>{h.$unregisterCommentController(this.handle)}})}createCommentThread(y,p,k){p===void 0&&(0,D.$UG)(this.h,"fileComments");const m=new s(this.id,this.handle,void 0,y,p,k,this.h,!1);return this.a.set(m.handle,m),m}$setActiveComment(y){if(!y){this.e=void 0,this.f=void 0;return}const p=this.a.get(y.commentThreadHandle);p&&(this.e=y.uniqueIdInThread?p.getCommentByUniqueId(y.uniqueIdInThread):void 0,this.f=p)}$createCommentThreadTemplate(y,p,k){const m=new s(this.id,this.handle,void 0,M.URI.revive(y),C.Range.to(p),[],this.h,!0,k);return m.collapsibleState=$.CommentThreadCollapsibleState.Expanded,this.a.set(m.handle,m),m}$updateCommentThreadTemplate(y,p){const k=this.a.get(y);k&&(k.range=C.Range.to(p))}$deleteCommentThread(y){this.a.get(y)?.dispose(),this.a.delete(y)}getCommentThread(y){return this.a.get(y)}dispose(){this.a.forEach(y=>{y.dispose()}),this.g.forEach(y=>y.dispose())}}function i(S,y,p,k){let m=p.get(y);return m||(m=++S.commentHandle,p.set(y,m)),y.state!==void 0&&(0,D.$UG)(k,"commentsDraftState"),y.reactions?.some(w=>w.reactors!==void 0)&&(0,D.$UG)(k,"commentReactor"),{mode:y.mode,contextValue:y.contextValue,uniqueIdInThread:m,body:typeof y.body=="string"?y.body:C.MarkdownString.from(y.body),userName:y.author.name,userIconPath:y.author.iconPath,label:y.label,commentReactions:y.reactions?y.reactions.map(w=>g(w)):void 0,state:y.state,timestamp:y.timestamp?.toJSON()}}function g(S){return{label:S.label,iconPath:S.iconPath?C.$XO(S.iconPath):void 0,count:S.count,hasReacted:S.authorHasReacted,reactors:S.reactors&&S.reactors.length>0&&typeof S.reactors[0]!="string"?S.reactors.map(y=>y.name):S.reactors}}function f(S){return{label:S.label||"",count:S.count||0,iconPath:S.iconPath?M.URI.revive(S.iconPath):"",authorHasReacted:S.hasReacted||!1,reactors:S.reactors?.map(y=>({name:y}))}}function l(S){if(S!==void 0)switch(S){case v.CommentThreadCollapsibleState.Expanded:return $.CommentThreadCollapsibleState.Expanded;case v.CommentThreadCollapsibleState.Collapsed:return $.CommentThreadCollapsibleState.Collapsed}return $.CommentThreadCollapsibleState.Collapsed}function b(S){let y;if(typeof S=="object"?y=S.resolved:y=S,y!==void 0)switch(y){case v.CommentThreadState.Unresolved:return $.CommentThreadState.Unresolved;case v.CommentThreadState.Resolved:return $.CommentThreadState.Resolved}return $.CommentThreadState.Unresolved}function I(S){let y;if(typeof S=="object"&&(y=S.applicability),y!==void 0)switch(y){case v.CommentThreadApplicability.Current:return $.CommentThreadApplicability.Current;case v.CommentThreadApplicability.Outdated:return $.CommentThreadApplicability.Outdated}return $.CommentThreadApplicability.Current}return new t}}),define(ke[277],Ie([1,0,22,76,6,16,24,2,10,67,80,5,7]),function(de,e,E,R,P,O,A,M,$,c,C,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$inc=void 0;class D{constructor(g,f){this.document=g,this.b=f,this.a=1,this.c=new C.$Imc("custom documents")}addEdit(g){return this.c.add([g])}async undo(g,f){await this.f(g).undo(),f||this.disposeBackup()}async redo(g,f){await this.f(g).redo(),f||this.disposeBackup()}disposeEdits(g){for(const f of g)this.c.delete(f)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const g=n(this.document.uri)+this.a++;return(0,A.$bh)(this.b,g)}updateBackup(g){this.d?.delete(),this.d=g}disposeBackup(){this.d?.delete(),this.d=void 0}f(g){const f=this.c.get(g,0);if(!f)throw new Error("No edit found");return f}}class d{constructor(){this.a=new Map}get(g,f){return this.a.get(this.b(g,f))}add(g,f,l){const b=this.b(g,f.uri);if(this.a.has(b))throw new Error(`Document already exists for viewType:${g} resource:${f.uri}`);const I=new D(f,l);return this.a.set(b,I),I}delete(g,f){const l=this.b(g,f.uri);this.a.delete(l)}b(g,f){return`${g}@@@${f}`}}var r;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(r||(r={}));class o{constructor(){this.a=new Map}addTextProvider(g,f,l){return this.b(g,{type:r.Text,extension:f,provider:l})}addCustomProvider(g,f,l){return this.b(g,{type:r.Custom,extension:f,provider:l})}get(g){return this.a.get(g)}b(g,f){if(this.a.has(g))throw new Error(`Provider for viewType:${g} already registered`);return this.a.set(g,f),new u.$wM(()=>this.a.delete(g))}}class a{constructor(g,f,l,b,I){this.d=f,this.f=l,this.g=b,this.h=I,this.b=new o,this.c=new d,this.a=g.getProxy(v.$uM.MainThreadCustomEditors)}registerCustomEditorProvider(g,f,l,b){const I=new P.$Tc;return t(l)?(I.add(this.b.addTextProvider(f,g,l)),this.a.$registerTextEditorProvider((0,c.$fnc)(g),f,b.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,c.$dnc)(g))):(I.add(this.b.addCustomProvider(f,g,l)),h(l)&&I.add(l.onDidChangeCustomDocument(S=>{const y=this.i(f,S.document.uri);if(s(S)){const p=y.addEdit(S);this.a.$onDidEdit(S.document.uri,f,p,S.label)}else this.a.$onContentChange(S.document.uri,f)})),this.a.$registerCustomEditorProvider((0,c.$fnc)(g),f,b.webviewOptions||{},!!b.supportsMultipleEditorsPerDocument,(0,c.$dnc)(g))),u.$wM.from(I,new u.$wM(()=>{this.a.$unregisterEditorProvider(f)}))}async $createCustomDocument(g,f,l,b,I){const S=this.b.get(f);if(!S)throw new Error(`No provider found for '${f}'`);if(S.type!==r.Custom)throw new Error(`Invalid provide type for '${f}'`);const y=M.URI.revive(g),p=await S.provider.openCustomDocument(y,{backupId:l,untitledDocumentData:b?.buffer},I);let k;return h(S.provider)&&this.f&&(k=this.f.workspaceValue(S.extension)??this.f.globalValue(S.extension)),this.c.add(f,p,k),{editable:h(S.provider)}}async $disposeCustomDocument(g,f){const l=this.b.get(f);if(!l)throw new Error(`No provider found for '${f}'`);if(l.type!==r.Custom)throw new Error(`Invalid provider type for '${f}'`);const b=M.URI.revive(g),{document:I}=this.i(f,b);this.c.delete(f,I),I.dispose()}async $resolveCustomEditor(g,f,l,b,I,S){const y=this.b.get(l);if(!y)throw new Error(`No provider found for '${l}'`);const p=$.ViewColumn.to(I),k=this.g.createNewWebview(f,b.contentOptions,y.extension),m=this.h.createNewWebviewPanel(f,l,b.title,p,b.options,k,b.active),w=M.URI.revive(g);switch(y.type){case r.Custom:{const{document:F}=this.i(l,w);return y.provider.resolveCustomEditor(F,m,S)}case r.Text:{const F=this.d.getDocument(w);return y.provider.resolveCustomTextEditor(F,m,S)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(g,f,l){this.i(f,g).disposeEdits(l)}async $onMoveCustomEditor(g,f,l){const b=this.b.get(l);if(!b)throw new Error(`No provider found for '${l}'`);if(!b.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const I=this.h.getWebviewPanel(g);if(!I)throw new Error("No webview found");const S=M.URI.revive(f),y=this.d.getDocument(S);await b.provider.moveCustomTextEditor(y,I,E.CancellationToken.None)}async $undo(g,f,l,b){return this.i(f,g).undo(l,b)}async $redo(g,f,l,b){return this.i(f,g).redo(l,b)}async $revert(g,f,l){const b=this.i(f,g);await this.j(f).revertCustomDocument(b.document,l),b.disposeBackup()}async $onSave(g,f,l){const b=this.i(f,g);await this.j(f).saveCustomDocument(b.document,l),b.disposeBackup()}async $onSaveAs(g,f,l,b){const I=this.i(f,g);return this.j(f).saveCustomDocumentAs(I.document,M.URI.revive(l),b)}async $backup(g,f,l){const b=this.i(f,g),S=await this.j(f).backupCustomDocument(b.document,{destination:b.getNewBackupUri()},l);return b.updateBackup(S),S.id}i(g,f){const l=this.c.get(g,M.URI.revive(f));if(!l)throw new Error("No custom document found");return l}j(g){const l=this.b.get(g)?.provider;if(!l||!h(l))throw new Error("Custom document is not editable");return l}}e.$inc=a;function h(i){return!!i.onDidChangeCustomDocument}function t(i){return typeof i.resolveCustomTextEditor=="function"}function s(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function n(i){const g=i.scheme===O.Schemas.file||i.scheme===O.Schemas.untitled?i.fsPath:i.toString();return(0,R.$oj)(g)+""}}),define(ke[278],Ie([1,0,179,106,2,5,7,10,4,12,29,51]),function(de,e,E,R,P,O,A,M,$,c,C,v){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qmc=e.$Pmc=void 0;class D{#e;#t;#i;constructor(o,a,h,t,s,n,i,g){this.d=o,this.e=a,this.f=h,this.g=t,this.h=s,this.c=!1,this.f=Math.max(t,h),this.#i=new C.$Ac(f=>n.getComparisonKey(f)),this.#e=i,this.#t=g}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(o,a){if(!o){this.clear();return}this.j();let h=[];if(P.URI.isUri(o)){if(!a){this.delete(o);return}this.#i.set(o,a.slice()),h=[o]}else if(Array.isArray(o)){h=[];let n;o=[...o].sort(D.k);for(const i of o){const[g,f]=i;if((!n||g.toString()!==n.toString())&&(n&&this.#i.get(n).length===0&&this.#i.delete(n),n=g,h.push(g),this.#i.set(g,[])),f)this.#i.get(g)?.push(...f);else{const l=this.#i.get(g);l&&(l.length=0)}}}if(this.#t.fire(h),!this.#e)return;const t=[];let s=0;for(const n of h){let i=[];const g=this.#i.get(n);if(g)if(g.length>this.g){i=[];const f=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let l=0;l<4;l++)for(const b of g)if(b.severity===f[l]&&i.push({...M.Diagnostic.from(b),modelVersionId:this.h(n)})===this.g)break e;i.push({severity:R.MarkerSeverity.Info,message:(0,E.localize)(0,null,g.length-this.g),startLineNumber:i[i.length-1].startLineNumber,startColumn:i[i.length-1].startColumn,endLineNumber:i[i.length-1].endLineNumber,endColumn:i[i.length-1].endColumn})}else i=g.map(f=>({...M.Diagnostic.from(f),modelVersionId:this.h(n)}));if(t.push([n,i]),s+=i.length,s>this.f)break}this.#e.$changeMany(this.e,t)}delete(o){this.j(),this.#t.fire([o]),this.#i.delete(o),this.#e?.$changeMany(this.e,[[o,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(o,a){this.j();for(const[h,t]of this)o.call(a,h,t,this)}*[Symbol.iterator](){this.j();for(const o of this.#i.keys())yield[o,this.get(o)]}get(o){this.j();const a=this.#i.get(o);return Array.isArray(a)?Object.freeze(a.slice(0)):[]}has(o){return this.j(),Array.isArray(this.#i.get(o))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(o,a){return o[0].toString()<a[0].toString()?-1:o[0].toString()>a[0].toString()?1:0}}e.$Pmc=D;let d=class{static{u=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*u.d}static _mapper(o){const a=new C.$Ac;for(const h of o)a.set(h,h);return{uris:Object.freeze(Array.from(a.values()))}}constructor(o,a,h,t){this.j=a,this.k=h,this.l=t,this.g=new Map,this.h=new $.$le({merge:s=>s.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,u._mapper),this.f=o.getProxy(O.$uM.MainThreadDiagnostics)}createDiagnosticCollection(o,a){const{g:h,f:t,h:s,j:n,k:i,l:g}=this,f=new class{$changeMany(I,S){t.$changeMany(I,S),n.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,I,S.length===0?"CLEARING":S)}$clear(I){t.$clear(I),n.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,I)}dispose(){t.dispose()}};let l;if(!a)a="_generated_diagnostic_collection_name_#"+u.c++,l=a;else if(!h.has(a))l=a;else{this.j.warn(`DiagnosticCollection with name '${a}' does already exist.`);do l=a+u.c++;while(h.has(l))}return new class extends D{constructor(){super(a,l,u.e,u.d,I=>g.getDocument(I)?.version,i.extUri,f,s),h.set(l,this)}dispose(){super.dispose(),h.delete(l)}}}getDiagnostics(o){if(o)return this.m(o);{const a=new Map,h=[];for(const t of this.g.values())t.forEach((s,n)=>{let i=a.get(s.toString());typeof i>"u"&&(i=h.length,a.set(s.toString(),i),h.push([s,[]])),h[i][1]=h[i][1].concat(...n)});return h}}m(o){let a=[];for(const h of this.g.values())h.has(o)&&(a=a.concat(h.get(o)));return a}$acceptMarkersChange(o){if(!this.n){const a="_generated_mirror",h=new D(a,a,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,t=>{},this.k.extUri,void 0,this.h);this.g.set(a,h),this.n=h}for(const[a,h]of o)this.n.set(P.URI.revive(a),h.map(M.Diagnostic.to))}};e.$Qmc=d,e.$Qmc=d=u=He([Ve(1,c.$7j),Ve(2,v.$Omc)],d)}),define(ke[279],Ie([1,0,2,14,7,10,211,38]),function(de,e,E,R,P,O,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ync=void 0;class ${constructor(C,v,u,D={timeout:1500,errors:3}){this.c=C,this.d=v,this.f=u,this.g=D,this.a=new A.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(C){return(v,u,D)=>{const r={dispose:this.a.push([v,u,C])};return Array.isArray(D)&&D.push(r),r}}async $participateInSave(C,v){const u=E.URI.revive(C);let D=!1;const d=setTimeout(()=>D=!0,this.g.timeout),r=[];try{for(const o of[...this.a]){if(D)break;const a=this.d.getDocument(u),h=await this.h(o,{document:a,reason:O.TextDocumentSaveReason.to(v)});r.push(h)}}finally{clearTimeout(d)}return r}h([C,v,u],D){const d=this.b.get(C);return typeof d=="number"&&d>this.g.errors?Promise.resolve(!1):this.i(u,C,v,D).then(()=>!0,r=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' threw ERROR`),this.c.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const o=this.b.get(C);this.b.set(C,o?o+1:1),typeof o=="number"&&o>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(C,v,u,D){const d=[],r=Date.now(),{document:o,reason:a}=D,{version:h}=o,t=Object.freeze({document:o,reason:a,waitUntil(s){if(Object.isFrozen(d))throw(0,R.$8)("waitUntil can not be called async");d.push(Promise.resolve(s))}});try{v.apply(u,[t])}catch(s){return Promise.reject(s)}return Object.freeze(d),new Promise((s,n)=>{const i=setTimeout(()=>n(new Error("timeout")),this.g.timeout);return Promise.all(d).then(g=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(i),s(g)}).catch(g=>{clearTimeout(i),n(g)})}).then(s=>{const n={edits:[]};for(const i of s)if(Array.isArray(i)&&i.every(g=>g instanceof P.$DM))for(const{newText:g,newEol:f,range:l}of i)n.edits.push({resource:o.uri,versionId:void 0,textEdit:{range:l&&O.Range.from(l),text:g,eol:f&&O.EndOfLine.from(f)}});if(n.edits.length!==0)return h===o.version?this.f.$tryApplyWorkspaceEdit(new M.$Kw(n)):Promise.reject(new Error("concurrent_edits"))})}}e.$Ync=$}),define(ke[280],Ie([1,0,4,6,2,5,121,10,15,26,7]),function(de,e,E,R,P,O,A,M,$,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rmc=void 0;class v{constructor(D,d){this.a=new E.$he,this.b=new E.$he,this.c=new E.$he,this.d=new E.$he,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new R.$Tc,this.h=new Map,this.f=D.getProxy(O.$uM.MainThreadDocuments),this.g=d,this.g.onDidRemoveDocuments(r=>{for(const o of r)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(r=>{for(const o of r)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(D){if(!D)return;const d=this.g.getDocument(D);if(d)return d}getDocument(D){const d=this.getDocumentData(D);if(!d?.document)throw new Error(`Unable to retrieve document from URI '${D}'`);return d.document}ensureDocumentData(D){const d=this.g.getDocument(D);if(d)return Promise.resolve(d);let r=this.h.get(D.toString());return r||(r=this.f.$tryOpenDocument(D).then(o=>{this.h.delete(D.toString());const a=P.URI.revive(o);return(0,$.$lg)(this.g.getDocument(a))},o=>(this.h.delete(D.toString()),Promise.reject(o))),this.h.set(D.toString(),r)),r}createDocumentData(D){return this.f.$tryCreateDocument(D).then(d=>P.URI.revive(d))}$acceptModelLanguageChanged(D,d){const r=P.URI.revive(D),o=this.g.getDocument(r);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(d),this.a.fire(o.document)}$acceptModelSaved(D){const d=P.URI.revive(D),r=this.g.getDocument(d);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(D,!1),this.d.fire(r.document)}$acceptDirtyStateChanged(D,d){const r=P.URI.revive(D),o=this.g.getDocument(r);if(!o)throw new Error("unknown document");o._acceptIsDirty(d),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(D,d,r){const o=P.URI.revive(D),a=this.g.getDocument(o);if(!a)throw new Error("unknown document");a._acceptIsDirty(r),a.onEvents(d);let h;d.isUndoing?h=C.TextDocumentChangeReason.Undo:d.isRedoing&&(h=C.TextDocumentChangeReason.Redo),this.c.fire((0,c.$0n)({document:a.document,contentChanges:d.changes.map(t=>({range:M.Range.to(t.range),rangeOffset:t.rangeOffset,rangeLength:t.rangeLength,text:t.text})),reason:h}))}setWordDefinitionFor(D,d){(0,A.$1O)(D,d)}}e.$Rmc=v}),define(ke[70],Ie([1,0,281,4,15,2,3,5,17,10,7]),function(de,e,E,R,P,O,A,M,$,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$knc=e.$jnc=void 0,e.$jnc=(0,A.$Ai)("IExtHostEditorTabs");class v{constructor(o,a,h){this.e=h,this.d=a,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,a={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(a)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case M.TabInputKind.TextInput:return new C.$hO(O.URI.revive(this.b.input.uri));case M.TabInputKind.TextDiffInput:return new C.$iO(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified));case M.TabInputKind.TextMergeInput:return new C.$jO(O.URI.revive(this.b.input.base),O.URI.revive(this.b.input.input1),O.URI.revive(this.b.input.input2),O.URI.revive(this.b.input.result));case M.TabInputKind.CustomEditorInput:return new C.$kO(O.URI.revive(this.b.input.uri),this.b.input.viewType);case M.TabInputKind.WebviewEditorInput:return new C.$lO(this.b.input.viewType);case M.TabInputKind.NotebookInput:return new C.$mO(O.URI.revive(this.b.input.uri),this.b.input.notebookType);case M.TabInputKind.NotebookDiffInput:return new C.$nO(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified),this.b.input.notebookType);case M.TabInputKind.TerminalEditorInput:return new C.$oO;case M.TabInputKind.InteractiveEditorInput:return new C.$pO(O.URI.revive(this.b.input.uri),O.URI.revive(this.b.input.inputBoxUri));case M.TabInputKind.ChatEditorInput:return new C.$qO;case M.TabInputKind.MultiDiffEditorInput:return new C.$rO(this.b.input.diffEditors.map(o=>new C.$iO(O.URI.revive(o.original),O.URI.revive(o.modified))));default:return}}}class u{constructor(o,a){this.c=[],this.d="",this.b=o,this.e=a;for(const h of o.tabs)h.isActive&&(this.d=h.id),this.c.push(new v(h,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,a={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return c.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(h=>h.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(h=>h.apiObject))}};this.a=Object.freeze(a)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===M.TabModelOperationKind.TAB_OPEN){const h=new v(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,h),o.tabDto.isActive&&(this.d=h.tabId),h}else if(o.kind===M.TabModelOperationKind.TAB_CLOSE){const h=this.c.splice(o.index,1)[0];if(!h)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return h.tabId===this.d&&(this.d=""),h}else if(o.kind===M.TabModelOperationKind.TAB_MOVE){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const h=this.c.splice(o.oldIndex,1)[0];if(!h)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,h),h}const a=this.c.find(h=>h.tabId===o.tabDto.id);if(!a)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),a.acceptDtoUpdate(o.tabDto),a}activeTabId(){return this.d}}let D=class{constructor(o){this.b=new R.$he,this.c=new R.$he,this.e=[],this.a=o.getProxy(M.$uM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,a={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(h=>h.apiObject))},get activeTabGroup(){const h=o.d;return(0,P.$lg)(o.e.find(s=>s.groupId===h)?.apiObject)},close:async(h,t)=>{const s=Array.isArray(h)?h:[h];return s.length?d(s[0])?this.j(s,t):this.i(s,t):!0}};this.f=Object.freeze(a)}return this.f}$acceptEditorTabModel(o){const a=new Set(this.e.map(f=>f.groupId)),h=new Set(o.map(f=>f.groupId)),t=(0,E.$L)(a,h),s=this.e.filter(f=>t.removed.includes(f.groupId)).map(f=>f.apiObject),n=[],i=[];this.e=o.map(f=>{const l=new u(f,()=>this.d);return t.added.includes(l.groupId)?n.push(l.apiObject):i.push(l.apiObject),l});const g=(0,P.$lg)(o.find(f=>f.isActive===!0)?.groupId);g!==void 0&&this.d!==g&&(this.d=g),this.c.fire(Object.freeze({opened:n,closed:s,changed:i}))}$acceptTabGroupUpdate(o){const a=this.e.find(h=>h.groupId===o.groupId);if(!a)throw new Error("Update Group IPC call received before group creation.");a.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[a.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const a=this.e.find(t=>t.groupId===o.groupId);if(!a)throw new Error("Update Tabs IPC call received before group creation.");const h=a.acceptTabOperation(o);switch(o.kind){case M.TabModelOperationKind.TAB_OPEN:this.b.fire(Object.freeze({opened:[h.apiObject],closed:[],changed:[]}));return;case M.TabModelOperationKind.TAB_CLOSE:this.b.fire(Object.freeze({opened:[],closed:[h.apiObject],changed:[]}));return;case M.TabModelOperationKind.TAB_MOVE:case M.TabModelOperationKind.TAB_UPDATE:this.b.fire(Object.freeze({opened:[],closed:[],changed:[h.apiObject]}));return}}g(o){for(const a of this.e)for(const h of a.tabs)if(h.apiObject===o)return h}h(o){return this.e.find(a=>a.apiObject===o)}async i(o,a){const h=[];for(const t of o){const s=this.g(t);if(!s)throw new Error("Tab close: Invalid tab not found!");h.push(s.tabId)}return this.a.$closeTab(h,a)}async j(o,a){const h=[];for(const t of o){const s=this.h(t);if(!s)throw new Error("Group close: Invalid group not found!");h.push(s.groupId)}return this.a.$closeGroup(h,a)}};e.$knc=D,e.$knc=D=He([Ve(0,$.$YO)],D);function d(r){return r.tabs!==void 0}}),define(ke[282],Ie([1,0,2,5,30,6,7,10,326,13,28,23,25,59]),function(de,e,E,R,P,O,A,M,$,c,C,v,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2nc=void 0;class d{constructor(){this.a=[]}add(a){this.b=void 0,this.a.push(a)}delete(a){const h=this.a.indexOf(a);h>=0&&(this.a.splice(h,1),this.b=void 0)}c(){if(!this.b){const a=this.a.sort(),h=[];let t,s,n=$.State.LastKnownState,i=$.State.LastKnownState;for(const g of a){let f=t?(0,c.$Df)(t,g):0;for(f===0?s=$.State.Start:s=i;f<g.length;f++)f+1===g.length?(n=i,i=$.State.BeforeColon):i+=1,h.push([s,g.toUpperCase().charCodeAt(f),i]),h.push([s,g.toLowerCase().charCodeAt(f),i]),s=i;t=g,i=n}h.push([$.State.BeforeColon,C.CharCode.Colon,$.State.AfterColon]),h.push([$.State.AfterColon,C.CharCode.Slash,$.State.End]),this.b=new $.$52(h)}}provideDocumentLinks(a){this.c();const h=[],t=$.$62.computeLinks({getLineContent(s){return a.lineAt(s-1).text},getLineCount(){return a.lineCount}},this.b);for(const s of t){const n=M.DocumentLink.to(s);n.target&&h.push(n)}return h}}class r{constructor(a,h){this.i=h,this.b=new d,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=a.getProxy(R.$uM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(a,h,t,s={}){if(r.j(t),this.d.has(h))throw new Error(`a provider for the scheme '${h}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(a,"*",this.b));const n=this.h++;this.b.add(h),this.d.add(h),this.c.set(n,t);let i=P.FileSystemProviderCapabilities.FileReadWrite;s.isCaseSensitive&&(i+=P.FileSystemProviderCapabilities.PathCaseSensitive),s.isReadonly&&(i+=P.FileSystemProviderCapabilities.Readonly),typeof t.copy=="function"&&(i+=P.FileSystemProviderCapabilities.FileFolderCopy),typeof t.open=="function"&&typeof t.close=="function"&&typeof t.read=="function"&&typeof t.write=="function"&&((0,u.$UG)(a,"fsChunks"),i+=P.FileSystemProviderCapabilities.FileOpenReadWriteClose);let g;s.isReadonly&&(0,D.$Zk)(s.isReadonly)&&s.isReadonly.value!==""&&(g={value:s.isReadonly.value,isTrusted:s.isReadonly.isTrusted,supportThemeIcons:s.isReadonly.supportThemeIcons,supportHtml:s.isReadonly.supportHtml,baseUri:s.isReadonly.baseUri,uris:s.isReadonly.uris}),this.a.$registerFileSystemProvider(n,h,i,g).catch(l=>{console.error(`FAILED to register filesystem provider of ${a.identifier.value}-extension for the scheme ${h}`),console.error(l)});const f=t.onDidChangeFile(l=>{const b=[];for(const I of l){const{uri:S,type:y}=I;if(S.scheme!==h)continue;let p;switch(y){case A.FileChangeType.Changed:p=P.FileChangeType.UPDATED;break;case A.FileChangeType.Created:p=P.FileChangeType.ADDED;break;case A.FileChangeType.Deleted:p=P.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}b.push({resource:S,type:p})}this.a.$onFileSystemChange(n,b)});return(0,O.$Sc)(()=>{f.dispose(),this.b.delete(h),this.d.delete(h),this.c.delete(n),this.a.$unregisterProvider(n)})}static j(a){if(!a)throw new Error("MISSING provider");if(typeof a.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof a.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof a.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof a.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof a.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof a.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof a.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof a.rename!="function")throw new Error("Provider does NOT implement rename")}static k(a){const{type:h,ctime:t,mtime:s,size:n,permissions:i}=a;return{type:h,ctime:t,mtime:s,size:n,permissions:i}}$stat(a,h){return Promise.resolve(this.l(a).stat(E.URI.revive(h))).then(t=>r.k(t))}$readdir(a,h){return Promise.resolve(this.l(a).readDirectory(E.URI.revive(h)))}$readFile(a,h){return Promise.resolve(this.l(a).readFile(E.URI.revive(h))).then(t=>v.$Je.wrap(t))}$writeFile(a,h,t,s){return Promise.resolve(this.l(a).writeFile(E.URI.revive(h),t.buffer,s))}$delete(a,h,t){return Promise.resolve(this.l(a).delete(E.URI.revive(h),t))}$rename(a,h,t,s){return Promise.resolve(this.l(a).rename(E.URI.revive(h),E.URI.revive(t),s))}$copy(a,h,t,s){const n=this.l(a);if(!n.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(n.copy(E.URI.revive(h),E.URI.revive(t),s))}$mkdir(a,h){return Promise.resolve(this.l(a).createDirectory(E.URI.revive(h)))}$watch(a,h,t,s){const n=this.l(a).watch(E.URI.revive(t),s);this.f.set(h,n)}$unwatch(a,h){const t=this.f.get(h);t&&(t.dispose(),this.f.delete(h))}$open(a,h,t){const s=this.l(a);if(!s.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(s.open(E.URI.revive(h),t))}$close(a,h){const t=this.l(a);if(!t.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(t.close(h))}$read(a,h,t,s){const n=this.l(a);if(!n.read)throw new Error('FileSystemProvider does not implement "read"');const i=v.$Je.alloc(s);return Promise.resolve(n.read(h,t,i.buffer,0,s)).then(g=>i.slice(0,g))}$write(a,h,t,s){const n=this.l(a);if(!n.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(n.write(h,t,s.buffer,0,s.byteLength))}l(a){const h=this.c.get(a);if(!h){const t=new Error;throw t.name="ENOPRO",t.message="no provider",t}return h}}e.$2nc=r}),define(ke[283],Ie([1,0,4,41,2,5,10,7,30,47]),function(de,e,E,R,P,O,A,M,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3nc=void 0;class C{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(d,r,o,a,h,t){this.a=Math.random(),this.b=new E.$he,this.c=new E.$he,this.d=new E.$he,this.h=0,t?.ignoreCreateEvents&&(this.h+=1),t?.ignoreChangeEvents&&(this.h+=2),t?.ignoreDeleteEvents&&(this.h+=4);const s=(0,R.$uk)(h),n=typeof h=="string",i=t?.correlate,g=a(f=>{if(!(typeof f.session=="number"&&f.session!==this.a)&&!(i&&typeof f.session>"u")){if(!t?.ignoreCreateEvents)for(const l of f.created){const b=P.URI.revive(l);s(b.fsPath)&&(!n||r.getWorkspaceFolder(b))&&this.b.fire(b)}if(!t?.ignoreChangeEvents)for(const l of f.changed){const b=P.URI.revive(l);s(b.fsPath)&&(!n||r.getWorkspaceFolder(b))&&this.c.fire(b)}if(!t?.ignoreDeleteEvents)for(const l of f.deleted){const b=P.URI.revive(l);s(b.fsPath)&&(!n||r.getWorkspaceFolder(b))&&this.d.fire(b)}}});this.g=M.$wM.from(this.i(d,o,h,t,t?.correlate),this.b,this.c,this.d,g)}i(d,r,o,a,h){const t=M.$wM.from();if(typeof o=="string"||a?.ignoreChangeEvents&&a?.ignoreCreateEvents&&a?.ignoreDeleteEvents)return t;const s=d.getProxy(O.$uM.MainThreadFileSystemEventService);let n=!1;(o.pattern.includes(R.$qk)||o.pattern.includes(R.$rk))&&(n=!0);let i;return h&&(a?.ignoreChangeEvents||a?.ignoreCreateEvents||a?.ignoreDeleteEvents)&&(i=$.FileChangeFilter.UPDATED|$.FileChangeFilter.ADDED|$.FileChangeFilter.DELETED,a?.ignoreChangeEvents&&(i&=~$.FileChangeFilter.UPDATED),a?.ignoreCreateEvents&&(i&=~$.FileChangeFilter.ADDED),a?.ignoreDeleteEvents&&(i&=~$.FileChangeFilter.DELETED)),s.$watch(r.identifier.value,this.a,o.baseUri,{recursive:n,excludes:a?.excludes??[],filter:i},!!h),M.$wM.from({dispose:()=>s.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class v{constructor(d){this.a=d,this.session=this.a.session,this.b=new c.$V(()=>this.a.created.map(P.URI.revive)),this.c=new c.$V(()=>this.a.changed.map(P.URI.revive)),this.d=new c.$V(()=>this.a.deleted.map(P.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class u{constructor(d,r,o){this.j=d,this.k=r,this.l=o,this.a=new E.$he,this.b=new E.$he,this.c=new E.$he,this.d=new E.$he,this.g=new E.$je,this.h=new E.$je,this.i=new E.$je,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(d,r,o,a){return new C(this.j,d,r,this.a.event,A.GlobPattern.from(o),a)}$onFileEvent(d){this.a.fire(new v(d))}$onDidRunFileOperation(d,r){switch(d){case $.FileOperation.MOVE:this.b.fire(Object.freeze({files:r.map(o=>({oldUri:P.URI.revive(o.source),newUri:P.URI.revive(o.target)}))}));break;case $.FileOperation.DELETE:this.d.fire(Object.freeze({files:r.map(o=>P.URI.revive(o.target))}));break;case $.FileOperation.CREATE:case $.FileOperation.COPY:this.c.fire(Object.freeze({files:r.map(o=>P.URI.revive(o.target))}));break;default:}}getOnWillRenameFileEvent(d){return this.m(d,this.g)}getOnWillCreateFileEvent(d){return this.m(d,this.h)}getOnWillDeleteFileEvent(d){return this.m(d,this.i)}m(d,r){return(o,a,h)=>{const t=function(n){o.call(a,n)};return t.extension=d,r.event(t,void 0,h)}}async $onWillRunFileOperation(d,r,o,a){switch(d){case $.FileOperation.MOVE:return await this.n(this.g,{files:r.map(h=>({oldUri:P.URI.revive(h.source),newUri:P.URI.revive(h.target)}))},o,a);case $.FileOperation.DELETE:return await this.n(this.i,{files:r.map(h=>P.URI.revive(h.target))},o,a);case $.FileOperation.CREATE:case $.FileOperation.COPY:return await this.n(this.h,{files:r.map(h=>P.URI.revive(h.target))},o,a)}}async n(d,r,o,a){const h=new Set,t=[];if(await d.fireAsync(r,a,async(n,i)=>{const g=Date.now(),f=await Promise.resolve(n);f instanceof M.$GM&&(t.push([i.extension,f]),h.add(i.extension.displayName??i.extension.identifier.value)),Date.now()-g>o&&this.k.warn("SLOW file-participant",i.extension.identifier)}),a.isCancellationRequested||t.length===0)return;const s={edits:[]};for(const[,n]of t){const{edits:i}=A.WorkspaceEdit.from(n,{getTextDocumentVersion:g=>this.l.getDocument(g)?.version,getNotebookDocumentVersion:()=>{}});s.edits=s.edits.concat(i)}return{edit:s,extensionNames:Array.from(h)}}}e.$3nc=u}),define(ke[284],Ie([1,0,18,11,22,14,96,6,26,69,13,15,2,33,327,94,103,181,19,10,7,25,80,5]),function(de,e,E,R,P,O,A,M,$,c,C,v,u,D,d,r,o,a,h,t,s,n,i,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Smc=void 0;class f{constructor(j,z){this.d=j,this.e=z}async provideDocumentSymbols(j,z){const K=this.d.getDocument(j),J=await this.e.provideDocumentSymbols(K,z);if(!(0,E.$Kb)(J))return J[0]instanceof s.$QM?J.map(t.DocumentSymbol.from):f.f(J)}static f(j){j=j.slice(0).sort((J,te)=>{let le=J.location.range.start.compareTo(te.location.range.start);return le===0&&(le=te.location.range.end.compareTo(J.location.range.end)),le});const z=[],K=[];for(const J of j){const te={name:J.name||"!!MISSING: name!!",kind:t.SymbolKind.from(J.kind),tags:J.tags?.map(t.SymbolTag.from)||[],detail:"",containerName:J.containerName,range:t.Range.from(J.location.range),selectionRange:t.Range.from(J.location.range),children:[]};for(;;){if(K.length===0){K.push(te),z.push(te);break}const le=K[K.length-1];if(D.$ct.containsRange(le.range,te.range)&&!D.$ct.equalsRange(le.range,te.range)){le.children?.push(te),K.push(te);break}K.pop()}}return z}}class l{constructor(j,z,K,J,te,le){this.f=j,this.g=z,this.h=K,this.j=J,this.k=te,this.l=le,this.d=new i.$Imc("CodeLens"),this.e=new Map}async provideCodeLenses(j,z){const K=this.f.getDocument(j),J=await this.h.provideCodeLenses(K,z);if(!J||z.isCancellationRequested)return;const te=this.d.add(J),le=new M.$Tc;this.e.set(te,le);const Ae={cacheId:te,lenses:[]};for(let je=0;je<J.length;je++)Ae.lenses.push({cacheId:[te,je],range:t.Range.from(J[je].range),command:this.g.toInternal(J[je].command,le)});return Ae}async resolveCodeLens(j,z){const K=j.cacheId&&this.d.get(...j.cacheId);if(!K)return;let J;if(typeof this.h.resolveCodeLens!="function"||K.isResolved?J=K:J=await this.h.resolveCodeLens(K,z),J||(J=K),z.isCancellationRequested)return;const te=j.cacheId&&this.e.get(j.cacheId[0]);if(te){if(!J.command){const le=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,le),this.l.error(le);return}return j.command=this.g.toInternal(J.command,te),j}}releaseCodeLenses(j){this.e.get(j)?.dispose(),this.e.delete(j),this.d.delete(j)}}function b(Oe){return Array.isArray(Oe)?Oe.map(t.DefinitionLink.from):Oe?[t.DefinitionLink.from(Oe)]:[]}class I{constructor(j,z){this.d=j,this.e=z}async provideDefinition(j,z,K){const J=this.d.getDocument(j),te=t.Position.to(z),le=await this.e.provideDefinition(J,te,K);return b(le)}}class S{constructor(j,z){this.d=j,this.e=z}async provideDeclaration(j,z,K){const J=this.d.getDocument(j),te=t.Position.to(z),le=await this.e.provideDeclaration(J,te,K);return b(le)}}class y{constructor(j,z){this.d=j,this.e=z}async provideImplementation(j,z,K){const J=this.d.getDocument(j),te=t.Position.to(z),le=await this.e.provideImplementation(J,te,K);return b(le)}}class p{constructor(j,z){this.d=j,this.e=z}async provideTypeDefinition(j,z,K){const J=this.d.getDocument(j),te=t.Position.to(z),le=await this.e.provideTypeDefinition(J,te,K);return b(le)}}class k{static{this.f=10}constructor(j,z){this.g=j,this.h=z,this.d=0,this.e=new Map}async provideHover(j,z,K,J){const te=this.g.getDocument(j),le=t.Position.to(z);let Ae;if(K&&K.verbosityRequest){const tt=K.verbosityRequest.previousHover.id,_e=this.e.get(tt);if(!_e)throw new Error(`Hover with id ${tt} not found`);const it={verbosityDelta:K.verbosityRequest.verbosityDelta,previousHover:_e};Ae=await this.h.provideHover(te,le,J,it)}else Ae=await this.h.provideHover(te,le,J);if(!Ae||(0,E.$Kb)(Ae.contents))return;Ae.range||(Ae.range=te.getWordRangeAtPosition(le)),Ae.range||(Ae.range=new s.$yM(le,le));const je=t.Hover.from(Ae),Ge=this.d;if(this.e.size===k.f){const tt=Math.min(...this.e.keys());this.e.delete(tt)}return this.e.set(Ge,Ae),this.d+=1,{...je,id:Ge}}releaseHover(j){this.e.delete(j)}}class m{constructor(j,z){this.d=j,this.e=z}async provideEvaluatableExpression(j,z,K){const J=this.d.getDocument(j),te=t.Position.to(z),le=await this.e.provideEvaluatableExpression(J,te,K);if(le)return t.EvaluatableExpression.from(le)}}class w{constructor(j,z){this.d=j,this.e=z}async provideInlineValues(j,z,K,J){const te=this.d.getDocument(j),le=await this.e.provideInlineValues(te,t.Range.to(z),t.InlineValueContext.to(K),J);if(Array.isArray(le))return le.map(Ae=>t.InlineValue.from(Ae))}}class F{constructor(j,z){this.d=j,this.e=z}async provideDocumentHighlights(j,z,K){const J=this.d.getDocument(j),te=t.Position.to(z),le=await this.e.provideDocumentHighlights(J,te,K);if(Array.isArray(le))return le.map(t.DocumentHighlight.from)}}class T{constructor(j,z){this.d=j,this.e=z}async provideMultiDocumentHighlights(j,z,K,J){const te=this.d.getDocument(j),le=K.map(Ge=>this.d.getDocument(Ge)),Ae=t.Position.to(z),je=await this.e.provideMultiDocumentHighlights(te,Ae,le,J);if(Array.isArray(je))return je.map(t.MultiDocumentHighlight.from)}}class G{constructor(j,z){this.d=j,this.e=z}async provideLinkedEditingRanges(j,z,K){const J=this.d.getDocument(j),te=t.Position.to(z),le=await this.e.provideLinkedEditingRanges(J,te,K);if(le&&Array.isArray(le.ranges))return{ranges:(0,E.$Hb)(le.ranges.map(t.Range.from)),wordPattern:le.wordPattern}}}class q{constructor(j,z){this.d=j,this.e=z}async provideReferences(j,z,K,J){const te=this.d.getDocument(j),le=t.Position.to(z),Ae=await this.e.provideReferences(te,le,K,J);if(Array.isArray(Ae))return Ae.map(t.location.from)}}class V{static{this.d=1e3}constructor(j,z,K,J,te,le,Ae){this.g=j,this.h=z,this.j=K,this.k=J,this.l=te,this.m=le,this.n=Ae,this.e=new i.$Imc("CodeAction"),this.f=new Map}async provideCodeActions(j,z,K,J){const te=this.g.getDocument(j),le=d.$et.isISelection(z)?t.Selection.to(z):t.Range.to(z),Ae=[];for(const it of this.j.getDiagnostics(j))if(le.intersection(it.range)&&Ae.push(it)>V.d)break;const je={diagnostics:Ae,only:K.only?new s.$SM(K.only):void 0,triggerKind:t.CodeActionTriggerKind.to(K.trigger)},Ge=await this.k.provideCodeActions(te,le,je,J);if(!(0,E.$Lb)(Ge)||J.isCancellationRequested)return;const Ze=this.e.add(Ge),tt=new M.$Tc;this.f.set(Ze,tt);const _e=[];for(let it=0;it<Ge.length;it++){const nt=Ge[it];if(nt)if(V.o(nt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),_e.push({_isSynthetic:!0,title:nt.title,command:this.h.toInternal(nt,tt)});else{je.only&&(nt.kind?je.only.contains(nt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action is of kind '${nt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const mt=nt.ranges??[];_e.push({cacheId:[Ze,it],title:nt.title,command:nt.command&&this.h.toInternal(nt.command,tt),diagnostics:nt.diagnostics&&nt.diagnostics.map(t.Diagnostic.from),edit:nt.edit&&t.WorkspaceEdit.from(nt.edit,void 0),kind:nt.kind&&nt.kind.value,isPreferred:nt.isPreferred,isAI:(0,n.$TG)(this.m,"codeActionAI")?nt.isAI:!1,ranges:(0,n.$TG)(this.m,"codeActionRanges")?(0,E.$Hb)(mt.map(t.Range.from)):void 0,disabled:nt.disabled?.reason})}}return{cacheId:Ze,actions:_e}}async resolveCodeAction(j,z){const[K,J]=j,te=this.e.get(K,J);if(!te||V.o(te))return{};if(!this.k.resolveCodeAction)return{};const le=await this.k.resolveCodeAction(te,z)??te;let Ae;le.edit&&(Ae=t.WorkspaceEdit.from(le.edit,void 0));let je;if(le.command){const Ge=this.f.get(K);Ge&&(je=this.h.toInternal(le.command,Ge))}return{edit:Ae,command:je}}releaseCodeActions(j){this.f.get(j)?.dispose(),this.f.delete(j),this.e.delete(j)}static o(j){return typeof j.command=="string"&&typeof j.title=="string"}}class N{constructor(j,z,K,J,te){this.e=j,this.f=z,this.g=K,this.h=J,this.j=te,this.d=new i.$Imc("DocumentPasteEdit")}async prepareDocumentPaste(j,z,K,J){if(!this.g.prepareDocumentPaste)return;const te=this.f.getDocument(j),le=z.map(Ge=>t.Range.to(Ge)),Ae=t.DataTransfer.toDataTransfer(K,()=>{throw new O.$$});if(await this.g.prepareDocumentPaste(te,le,Ae,J),J.isCancellationRequested)return;const je=Array.from(Ae).filter(([,Ge])=>!(Ge instanceof s.$mN));return t.DataTransfer.from(je)}async providePasteEdits(j,z,K,J,te,le){if(!this.g.provideDocumentPasteEdits)return[];const Ae=this.f.getDocument(z),je=K.map(_e=>t.Range.to(_e)),Ge=t.DataTransfer.toDataTransfer(J,async _e=>(await this.e.$resolvePasteFileData(this.h,j,_e)).buffer),Ze=await this.g.provideDocumentPasteEdits(Ae,je,Ge,{only:te.only?new s.$rN(te.only):void 0,triggerKind:te.triggerKind},le);if(!Ze||le.isCancellationRequested)return[];const tt=this.d.add(Ze);return Ze.map((_e,it)=>({_cacheId:[tt,it],title:_e.title??(0,a.localize)(0,null,this.j.displayName||this.j.name),kind:_e.kind,yieldTo:_e.yieldTo?.map(nt=>nt.value),insertText:typeof _e.insertText=="string"?_e.insertText:{snippet:_e.insertText.value},additionalEdit:_e.additionalEdit?t.WorkspaceEdit.from(_e.additionalEdit,void 0):void 0}))}async resolvePasteEdit(j,z){const[K,J]=j,te=this.d.get(K,J);if(!te||!this.g.resolveDocumentPasteEdit)return{};const le=await this.g.resolveDocumentPasteEdit(te,z)??te;return{additionalEdit:le.additionalEdit?t.WorkspaceEdit.from(le.additionalEdit,void 0):void 0}}releasePasteEdits(j){this.d.delete(j)}}class L{constructor(j,z){this.d=j,this.e=z}async provideDocumentFormattingEdits(j,z,K){const J=this.d.getDocument(j),te=await this.e.provideDocumentFormattingEdits(J,z,K);if(Array.isArray(te))return te.map(t.TextEdit.from)}}class Z{constructor(j,z){this.d=j,this.e=z}async provideDocumentRangeFormattingEdits(j,z,K,J){const te=this.d.getDocument(j),le=t.Range.to(z),Ae=await this.e.provideDocumentRangeFormattingEdits(te,le,K,J);if(Array.isArray(Ae))return Ae.map(t.TextEdit.from)}async provideDocumentRangesFormattingEdits(j,z,K,J){(0,v.$kg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const te=this.d.getDocument(j),le=z.map(t.Range.to),Ae=await this.e.provideDocumentRangesFormattingEdits(te,le,K,J);if(Array.isArray(Ae))return Ae.map(t.TextEdit.from)}}class re{constructor(j,z){this.d=j,this.e=z,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(j,z,K,J,te){const le=this.d.getDocument(j),Ae=t.Position.to(z),je=await this.e.provideOnTypeFormattingEdits(le,Ae,K,J,te);if(Array.isArray(je))return je.map(t.TextEdit.from)}}class fe{constructor(j,z){this.e=j,this.f=z,this.d=new i.$Imc("WorkspaceSymbols")}async provideWorkspaceSymbols(j,z){const K=await this.e.provideWorkspaceSymbols(j,z);if(!(0,E.$Lb)(K))return{symbols:[]};const J=this.d.add(K),te={cacheId:J,symbols:[]};for(let le=0;le<K.length;le++){const Ae=K[le];if(!Ae||!Ae.name){this.f.warn("INVALID SymbolInformation",Ae);continue}te.symbols.push({...t.WorkspaceSymbol.from(Ae),cacheId:[J,le]})}return te}async resolveWorkspaceSymbol(j,z){if(typeof this.e.resolveWorkspaceSymbol!="function"||!j.cacheId)return j;const K=this.d.get(...j.cacheId);if(K){const J=await this.e.resolveWorkspaceSymbol(K,z);return J&&(0,$.$_n)(j,t.WorkspaceSymbol.from(J),!0)}}releaseWorkspaceSymbols(j){this.d.delete(j)}}class be{static supportsResolving(j){return typeof j.prepareRename=="function"}constructor(j,z,K){this.d=j,this.e=z,this.f=K}async provideRenameEdits(j,z,K,J){const te=this.d.getDocument(j),le=t.Position.to(z);try{const Ae=await this.e.provideRenameEdits(te,le,K,J);return Ae?t.WorkspaceEdit.from(Ae):void 0}catch(Ae){const je=be.g(Ae);return je?{rejectReason:je,edits:void 0}:Promise.reject(Ae)}}async resolveRenameLocation(j,z,K){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const J=this.d.getDocument(j),te=t.Position.to(z);try{const le=await this.e.prepareRename(J,te,K);let Ae,je;if(s.$yM.isRange(le)?(Ae=le,je=J.getText(le)):(0,v.$cg)(le)&&(Ae=le.range,je=le.placeholder),!Ae||!je)return;if(Ae.start.line>te.line||Ae.end.line<te.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:t.Range.from(Ae),text:je}}catch(le){const Ae=be.g(le);return Ae?{rejectReason:Ae,range:void 0,text:void 0}:Promise.reject(le)}}static g(j){return typeof j=="string"?j:j instanceof Error&&typeof j.message=="string"?j.message:void 0}}class oe{static{this.d={[r.NewSymbolNameTriggerKind.Invoke]:s.NewSymbolNameTriggerKind.Invoke,[r.NewSymbolNameTriggerKind.Automatic]:s.NewSymbolNameTriggerKind.Automatic}}constructor(j,z,K){this.e=j,this.f=z,this.g=K}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(j,z,K,J){const te=this.e.getDocument(j),le=t.Range.to(z);try{const Ae=oe.d[K],je=await this.f.provideNewSymbolNames(te,le,Ae,J);return je?je.map(Ge=>typeof Ge=="string"?{newSymbolName:Ge}:{newSymbolName:Ge.newSymbolName,tags:Ge.tags}):void 0}catch(Ae){this.g.error(oe.h(Ae)??JSON.stringify(Ae,null,"	"));return}}static h(j){return typeof j=="string"?j:j instanceof Error&&typeof j.message=="string"?j.message:void 0}}class pe{constructor(j,z){this.resultId=j,this.tokens=z}}class $e{constructor(j,z){this.f=j,this.g=z,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(j,z,K){const J=this.f.getDocument(j),te=z!==0?this.d.get(z):null;let le=typeof te?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(J,te.resultId,K):await this.g.provideDocumentSemanticTokens(J,K);return te&&this.d.delete(z),le?(le=$e.h(le),this.o($e.n(te,le),le)):null}async releaseDocumentSemanticColoring(j){this.d.delete(j)}static h(j){return $e.j(j)?$e.k(j)?j:new s.$RN(new Uint32Array(j.data),j.resultId):$e.l(j)?$e.m(j)?j:new s.$TN(j.edits.map(z=>new s.$SN(z.start,z.deleteCount,z.data?new Uint32Array(z.data):z.data)),j.resultId):j}static j(j){return j&&!!j.data}static k(j){return j.data instanceof Uint32Array}static l(j){return j&&Array.isArray(j.edits)}static m(j){for(const z of j.edits)if(!(z.data instanceof Uint32Array))return!1;return!0}static n(j,z){if(!$e.j(z)||!j||!j.tokens)return z;const K=j.tokens,J=K.length,te=z.data,le=te.length;let Ae=0;const je=Math.min(J,le);for(;Ae<je&&K[Ae]===te[Ae];)Ae++;if(Ae===J&&Ae===le)return new s.$TN([],z.resultId);let Ge=0;const Ze=je-Ae;for(;Ge<Ze&&K[J-Ge-1]===te[le-Ge-1];)Ge++;return new s.$TN([{start:Ae,deleteCount:J-Ae-Ge,data:te.subarray(Ae,le-Ge)}],z.resultId)}o(j,z){if($e.j(j)){const K=this.e++;return this.d.set(K,new pe(j.resultId,j.data)),(0,o.$5bb)({id:K,type:"full",data:j.data})}if($e.l(j)){const K=this.e++;return $e.j(z)?this.d.set(K,new pe(z.resultId,z.data)):this.d.set(K,new pe(j.resultId)),(0,o.$5bb)({id:K,type:"delta",deltas:(j.edits||[]).map(J=>({start:J.start,deleteCount:J.deleteCount,data:J.data}))})}return null}}class se{constructor(j,z){this.d=j,this.e=z}async provideDocumentRangeSemanticTokens(j,z,K){const J=this.d.getDocument(j),te=await this.e.provideDocumentRangeSemanticTokens(J,t.Range.to(z),K);return te?this.f(te):null}f(j){return(0,o.$5bb)({id:0,type:"full",data:j.data})}}class Ce{static supportsResolving(j){return typeof j.resolveCompletionItem=="function"}constructor(j,z,K,J,te){this.f=j,this.g=z,this.h=K,this.j=J,this.k=te,this.d=new i.$Imc("CompletionItem"),this.e=new Map}async provideCompletionItems(j,z,K,J){const te=this.f.getDocument(j),le=t.Position.to(z),Ae=te.getWordRangeAtPosition(le)||new s.$yM(le,le),je=Ae.with({end:le}),Ge=new c.$be,Ze=await this.h.provideCompletionItems(te,le,J,t.CompletionContext.to(K));if(!Ze||J.isCancellationRequested)return;const tt=Array.isArray(Ze)?new s.$6M(Ze):Ze,_e=Ce.supportsResolving(this.h)?this.d.add(tt.items):this.d.add([]),it=new M.$Tc;this.e.set(_e,it);const nt=[],mt={x:_e,[g.ISuggestResultDtoField.completions]:nt,[g.ISuggestResultDtoField.defaultRanges]:{replace:t.Range.from(Ae),insert:t.Range.from(je)},[g.ISuggestResultDtoField.isIncomplete]:tt.isIncomplete||void 0,[g.ISuggestResultDtoField.duration]:Ge.elapsed()};for(let lt=0;lt<tt.items.length;lt++){const rt=tt.items[lt],at=this.l(rt,[_e,lt],je,Ae);nt.push(at)}return mt}async resolveCompletionItem(j,z){if(typeof this.h.resolveCompletionItem!="function")return;const K=this.d.get(...j);if(!K)return;const J=this.l(K,j),te=await this.h.resolveCompletionItem(K,z);if(!te)return;const le=this.l(te,j);return(J[g.ISuggestDataDtoField.insertText]!==le[g.ISuggestDataDtoField.insertText]||J[g.ISuggestDataDtoField.insertTextRules]!==le[g.ISuggestDataDtoField.insertTextRules])&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(J[g.ISuggestDataDtoField.commandIdent]!==le[g.ISuggestDataDtoField.commandIdent]||J[g.ISuggestDataDtoField.commandId]!==le[g.ISuggestDataDtoField.commandId]||!(0,$.$ao)(J[g.ISuggestDataDtoField.commandArguments],le[g.ISuggestDataDtoField.commandArguments]))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...J,[g.ISuggestDataDtoField.documentation]:le[g.ISuggestDataDtoField.documentation],[g.ISuggestDataDtoField.detail]:le[g.ISuggestDataDtoField.detail],[g.ISuggestDataDtoField.additionalTextEdits]:le[g.ISuggestDataDtoField.additionalTextEdits],[g.ISuggestDataDtoField.insertText]:le[g.ISuggestDataDtoField.insertText],[g.ISuggestDataDtoField.insertTextRules]:le[g.ISuggestDataDtoField.insertTextRules],[g.ISuggestDataDtoField.commandIdent]:le[g.ISuggestDataDtoField.commandIdent],[g.ISuggestDataDtoField.commandId]:le[g.ISuggestDataDtoField.commandId],[g.ISuggestDataDtoField.commandArguments]:le[g.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(j){this.e.get(j)?.dispose(),this.e.delete(j),this.d.delete(j)}l(j,z,K,J){const te=this.e.get(z[0]);if(!te)throw Error("DisposableStore is missing...");const le=this.g.toInternal(j.command,te),Ae={x:z,[g.ISuggestDataDtoField.label]:j.label,[g.ISuggestDataDtoField.kind]:j.kind!==void 0?t.CompletionItemKind.from(j.kind):void 0,[g.ISuggestDataDtoField.kindModifier]:j.tags&&j.tags.map(t.CompletionItemTag.from),[g.ISuggestDataDtoField.detail]:j.detail,[g.ISuggestDataDtoField.documentation]:typeof j.documentation>"u"?void 0:t.MarkdownString.fromStrict(j.documentation),[g.ISuggestDataDtoField.sortText]:j.sortText!==j.label?j.sortText:void 0,[g.ISuggestDataDtoField.filterText]:j.filterText!==j.label?j.filterText:void 0,[g.ISuggestDataDtoField.preselect]:j.preselect||void 0,[g.ISuggestDataDtoField.insertTextRules]:j.keepWhitespace?r.CompletionItemInsertTextRule.KeepWhitespace:r.CompletionItemInsertTextRule.None,[g.ISuggestDataDtoField.commitCharacters]:j.commitCharacters?.join(""),[g.ISuggestDataDtoField.additionalTextEdits]:j.additionalTextEdits&&j.additionalTextEdits.map(t.TextEdit.from),[g.ISuggestDataDtoField.commandIdent]:le?.$ident,[g.ISuggestDataDtoField.commandId]:le?.id,[g.ISuggestDataDtoField.commandArguments]:le?.$ident?void 0:le?.arguments};j.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ae[g.ISuggestDataDtoField.insertText]=j.textEdit.newText):typeof j.insertText=="string"?Ae[g.ISuggestDataDtoField.insertText]=j.insertText:j.insertText instanceof s.$HM&&(Ae[g.ISuggestDataDtoField.insertText]=j.insertText.value,Ae[g.ISuggestDataDtoField.insertTextRules]|=r.CompletionItemInsertTextRule.InsertAsSnippet);let je;return j.textEdit?je=j.textEdit.range:j.range&&(je=j.range),s.$yM.isRange(je)?Ae[g.ISuggestDataDtoField.range]=t.Range.from(je):je&&(!K?.isEqual(je.inserting)||!J?.isEqual(je.replacing))&&(Ae[g.ISuggestDataDtoField.range]={insert:t.Range.from(je.inserting),replace:t.Range.from(je.replacing)}),Ae}}class Fe{async provideInlineCompletions(j,z,K,J){}disposeCompletions(j){}handleDidShowCompletionItem(j,z,K){}handlePartialAccept(j,z,K,J){}}class X extends Fe{constructor(j,z,K,J){super(),this.f=j,this.g=z,this.h=K,this.j=J,this.d=new ie,this.e=(0,n.$TG)(this.f,"inlineCompletionsAdditions"),this.k={[r.InlineCompletionTriggerKind.Automatic]:s.InlineCompletionTriggerKind.Automatic,[r.InlineCompletionTriggerKind.Explicit]:s.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,n.$TG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(j,z,K,J){const te=this.g.getDocument(j),le=t.Position.to(z),Ae=await this.h.provideInlineCompletionItems(te,le,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:t.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[K.triggerKind]},J);if(!Ae||J.isCancellationRequested)return;const je=Array.isArray(Ae)?Ae:Ae.items,Ge=this.e?Array.isArray(Ae)?[]:Ae.commands||[]:[],Ze=this.e&&!Array.isArray(Ae)?Ae.enableForwardStability:void 0;let tt;return{pid:this.d.createReferenceId({dispose(){tt?.dispose()},items:je}),items:je.map((it,nt)=>{let mt;it.command&&(tt||(tt=new M.$Tc),mt=this.j.toInternal(it.command,tt));const lt=it.insertText;return{insertText:typeof lt=="string"?lt:{snippet:lt.value},filterText:it.filterText,range:it.range?t.Range.from(it.range):void 0,command:mt,idx:nt,completeBracketPairs:this.e?it.completeBracketPairs:!1}}),commands:Ge.map(it=>(tt||(tt=new M.$Tc),this.j.toInternal(it,tt))),suppressSuggestions:!1,enableForwardStability:Ze}}disposeCompletions(j){this.d.disposeReferenceId(j)?.dispose()}handleDidShowCompletionItem(j,z,K){const J=this.d.get(j)?.items[z];J&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(J,K)}handlePartialAccept(j,z,K,J){const te=this.d.get(j)?.items[z];te&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(te,K),this.h.handleDidPartiallyAcceptCompletionItem(te,t.PartialAcceptInfo.to(J)))}}class W{async provideInlineEdits(j,z,K){const J=this.f.getDocument(j),te=await this.g.provideInlineEdit(J,{triggerKind:this.e[z.triggerKind]},K);if(!te||K.isCancellationRequested)return;let le;const Ae=this.d.createReferenceId({dispose(){le?.dispose()},item:te});let je;te.accepted&&(le||(le=new M.$Tc),je=this.h.toInternal(te.accepted,le));let Ge;return te.rejected&&(le||(le=new M.$Tc),Ge=this.h.toInternal(te.rejected,le)),{pid:Ae,text:te.text,range:t.Range.from(te.range),accepted:je,rejected:Ge}}disposeEdit(j){this.d.disposeReferenceId(j)?.dispose()}constructor(j,z,K,J){this.f=z,this.g=K,this.h=J,this.d=new ie,this.e={[r.InlineEditTriggerKind.Automatic]:s.InlineEditTriggerKind.Automatic,[r.InlineEditTriggerKind.Invoke]:s.InlineEditTriggerKind.Invoke}}}class ie{constructor(){this.d=new Map,this.e=1}createReferenceId(j){const z=this.e++;return this.d.set(z,j),z}disposeReferenceId(j){const z=this.d.get(j);return this.d.delete(j),z}get(j){return this.d.get(j)}}class Se{constructor(j,z){this.e=j,this.f=z,this.d=new i.$Imc("SignatureHelp")}async provideSignatureHelp(j,z,K,J){const te=this.e.getDocument(j),le=t.Position.to(z),Ae=this.g(K),je=await this.f.provideSignatureHelp(te,le,J,Ae);if(je){const Ge=this.d.add([je]);return{...t.SignatureHelp.from(je),id:Ge}}}g(j){let z;if(j.activeSignatureHelp){const K=t.SignatureHelp.to(j.activeSignatureHelp),J=this.d.get(j.activeSignatureHelp.id,0);J?(z=J,z.activeSignature=K.activeSignature,z.activeParameter=K.activeParameter):z=K}return{...j,activeSignatureHelp:z}}releaseSignatureHelp(j){this.d.delete(j)}}class he{constructor(j,z,K,J,te){this.f=j,this.g=z,this.h=K,this.j=J,this.k=te,this.d=new i.$Imc("InlayHints"),this.e=new Map}async provideInlayHints(j,z,K){const J=this.f.getDocument(j),te=t.Range.to(z),le=await this.h.provideInlayHints(J,te,K);if(!Array.isArray(le)||le.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(z)}`);return}if(K.isCancellationRequested)return;const Ae=this.d.add(le);this.e.set(Ae,new M.$Tc);const je={hints:[],cacheId:Ae};for(let Ge=0;Ge<le.length;Ge++)this.l(le[Ge],te)&&je.hints.push(this.m(le[Ge],[Ae,Ge]));return this.j.trace(`[InlayHints] ${je.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(z)}`),je}async resolveInlayHint(j,z){if(typeof this.h.resolveInlayHint!="function")return;const K=this.d.get(...j);if(!K)return;const J=await this.h.resolveInlayHint(K,z);if(J&&this.l(J))return this.m(J,j)}releaseHints(j){this.e.get(j)?.dispose(),this.e.delete(j),this.d.delete(j)}l(j,z){return j.label.length===0||Array.isArray(j.label)&&j.label.every(K=>K.value.length===0)?(console.log("INVALID inlay hint, empty label",j),!1):!(z&&!z.contains(j.position))}m(j,z){const K=this.e.get(z[0]);if(!K)throw Error("DisposableStore is missing...");const J={label:"",cacheId:z,tooltip:t.MarkdownString.fromStrict(j.tooltip),position:t.Position.from(j.position),textEdits:j.textEdits&&j.textEdits.map(t.TextEdit.from),kind:j.kind&&t.InlayHintKind.from(j.kind),paddingLeft:j.paddingLeft,paddingRight:j.paddingRight};if(typeof j.label=="string")J.label=j.label;else{const te=[];J.label=te;for(const le of j.label){if(!le.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Ae={label:le.value,tooltip:t.MarkdownString.fromStrict(le.tooltip)};s.$IM.isLocation(le.location)&&(Ae.location=t.location.from(le.location)),le.command&&(Ae.command=this.g.toInternal(le.command,K)),te.push(Ae)}}return J}}class we{constructor(j,z){this.e=j,this.f=z,this.d=new i.$Imc("DocumentLink")}async provideLinks(j,z){const K=this.e.getDocument(j),J=await this.f.provideDocumentLinks(K,z);if(!(!Array.isArray(J)||J.length===0)&&!z.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:J.filter(we.g).map(t.DocumentLink.from)};{const te=this.d.add(J),le={links:[],cacheId:te};for(let Ae=0;Ae<J.length;Ae++){if(!we.g(J[Ae]))continue;const je=t.DocumentLink.from(J[Ae]);je.cacheId=[te,Ae],le.links.push(je)}return le}}}static g(j){return j.target&&j.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(j,z){if(typeof this.f.resolveDocumentLink!="function")return;const K=this.d.get(...j);if(!K)return;const J=await this.f.resolveDocumentLink(K,z);if(!(!J||!we.g(J)))return t.DocumentLink.from(J)}releaseLinks(j){this.d.delete(j)}}class ae{constructor(j,z){this.d=j,this.e=z}async provideColors(j,z){const K=this.d.getDocument(j),J=await this.e.provideDocumentColors(K,z);return Array.isArray(J)?J.map(le=>({color:t.Color.from(le.color),range:t.Range.from(le.range)})):[]}async provideColorPresentations(j,z,K){const J=this.d.getDocument(j),te=t.Range.to(z.range),le=t.Color.to(z.color),Ae=await this.e.provideColorPresentations(le,{document:J,range:te},K);if(Array.isArray(Ae))return Ae.map(t.ColorPresentation.from)}}class Y{constructor(j,z){this.d=j,this.e=z}async provideFoldingRanges(j,z,K){const J=this.d.getDocument(j),te=await this.e.provideFoldingRanges(J,z,K);if(Array.isArray(te))return te.map(t.FoldingRange.from)}}class x{constructor(j,z,K){this.d=j,this.e=z,this.f=K}async provideSelectionRanges(j,z,K){const J=this.d.getDocument(j),te=z.map(t.Position.to),le=await this.e.provideSelectionRanges(J,te,K);if(!(0,E.$Lb)(le))return[];if(le.length!==te.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ae=[];for(let je=0;je<te.length;je++){const Ge=[];Ae.push(Ge);let Ze=te[je],tt=le[je];for(;;){if(!tt.range.contains(Ze))throw new Error("INVALID selection range, must contain the previous range");if(Ge.push(t.SelectionRange.from(tt)),!tt.parent)break;Ze=tt.range,tt=tt.parent}}return Ae}}class me{constructor(j,z){this.f=j,this.g=z,this.d=new A.$4O(""),this.e=new Map}async prepareSession(j,z,K){const J=this.f.getDocument(j),te=t.Position.to(z),le=await this.g.prepareCallHierarchy(J,te,K);if(!le)return;const Ae=this.d.nextId();return this.e.set(Ae,new Map),Array.isArray(le)?le.map(je=>this.h(Ae,je)):[this.h(Ae,le)]}async provideCallsTo(j,z,K){const J=this.j(j,z);if(!J)throw new Error("missing call hierarchy item");const te=await this.g.provideCallHierarchyIncomingCalls(J,K);if(te)return te.map(le=>({from:this.h(j,le.from),fromRanges:le.fromRanges.map(Ae=>t.Range.from(Ae))}))}async provideCallsFrom(j,z,K){const J=this.j(j,z);if(!J)throw new Error("missing call hierarchy item");const te=await this.g.provideCallHierarchyOutgoingCalls(J,K);if(te)return te.map(le=>({to:this.h(j,le.to),fromRanges:le.fromRanges.map(Ae=>t.Range.from(Ae))}))}releaseSession(j){this.e.delete(j)}h(j,z){const K=this.e.get(j),J=t.CallHierarchyItem.from(z,j,K.size.toString(36));return K.set(J._itemId,z),J}j(j,z){return this.e.get(j)?.get(z)}}class ge{constructor(j,z){this.f=j,this.g=z,this.d=new A.$4O(""),this.e=new Map}async prepareSession(j,z,K){const J=this.f.getDocument(j),te=t.Position.to(z),le=await this.g.prepareTypeHierarchy(J,te,K);if(!le)return;const Ae=this.d.nextId();return this.e.set(Ae,new Map),Array.isArray(le)?le.map(je=>this.h(Ae,je)):[this.h(Ae,le)]}async provideSupertypes(j,z,K){const J=this.j(j,z);if(!J)throw new Error("missing type hierarchy item");const te=await this.g.provideTypeHierarchySupertypes(J,K);if(te)return te.map(le=>this.h(j,le))}async provideSubtypes(j,z,K){const J=this.j(j,z);if(!J)throw new Error("missing type hierarchy item");const te=await this.g.provideTypeHierarchySubtypes(J,K);if(te)return te.map(le=>this.h(j,le))}releaseSession(j){this.e.delete(j)}h(j,z){const K=this.e.get(j),J=t.TypeHierarchyItem.from(z,j,K.size.toString(36));return K.set(J._itemId,z),J}j(j,z){return this.e.get(j)?.get(z)}}class Te{constructor(j,z,K,J,te){this.e=j,this.f=z,this.g=K,this.h=J,this.j=te,this.d=new i.$Imc("DocumentDropEdit")}async provideDocumentOnDropEdits(j,z,K,J,te){const le=this.f.getDocument(z),Ae=t.Position.to(K),je=t.DataTransfer.toDataTransfer(J,async _e=>(await this.e.$resolveDocumentOnDropFileData(this.h,j,_e)).buffer),Ge=await this.g.provideDocumentDropEdits(le,Ae,je,te);if(!Ge)return;const Ze=(0,E.$2b)(Ge),tt=this.d.add(Ze);return Ze.map((_e,it)=>({_cacheId:[tt,it],title:_e.title??(0,a.localize)(1,null,this.j.displayName||this.j.name),kind:_e.kind?.value,yieldTo:_e.yieldTo?.map(nt=>nt.value),insertText:typeof _e.insertText=="string"?_e.insertText:{snippet:_e.insertText.value},additionalEdit:_e.additionalEdit?t.WorkspaceEdit.from(_e.additionalEdit,void 0):void 0}))}async resolveDropEdit(j,z){const[K,J]=j,te=this.d.get(K,J);if(!te||!this.g.resolveDocumentDropEdit)return{};const le=await this.g.resolveDocumentDropEdit(te,z)??te;return{additionalEdit:le.additionalEdit?t.WorkspaceEdit.from(le.additionalEdit,void 0):void 0}}releaseDropEdits(j){this.d.delete(j)}}class Be{constructor(j,z){this.d=j,this.e=z}async provideMappedEdits(j,z,K,J){const te=u.URI.revive(j),le=this.d.getDocument(te),Ae=K.documents.map(Ze=>Ze.map(tt=>({uri:u.URI.revive(tt.uri),version:tt.version,ranges:tt.ranges.map(_e=>t.Range.to(_e))}))),je={documents:Ae,selections:Ae[0]?.[0]?.ranges??[]},Ge=await this.e.provideMappedEdits(le,z,je,J);return Ge?t.WorkspaceEdit.from(Ge):null}}class Ee{constructor(j,z){this.adapter=j,this.extension=z}}class Re{static{this.d=0}constructor(j,z,K,J,te,le,Ae,je){this.g=z,this.h=K,this.j=J,this.k=te,this.l=le,this.m=Ae,this.n=je,this.f=new Map,this.e=j.getProxy(g.$uM.MainThreadLanguageFeatures)}o(j,z){return t.DocumentSelector.from(j,this.g,z)}p(j){return new s.$wM(()=>{this.f.delete(j),this.e.$unregister(j)})}q(){return Re.d++}async s(j,z,K,J,te,le=!1){const Ae=this.f.get(j);if(!Ae||!(Ae.adapter instanceof z))return J;const je=Date.now();le||this.l.trace(`[${Ae.extension.identifier.value}] INVOKE provider '${K.toString().replace(/[\r\n]/g,"")}'`);const Ge=K(Ae.adapter,Ae.extension);return Promise.resolve(Ge).catch(Ze=>{(0,O.$4)(Ze)||(this.l.error(`[${Ae.extension.identifier.value}] provider FAILED`),this.l.error(Ze),this.n.onExtensionError(Ae.extension.identifier,Ze))}).finally(()=>{le||this.l.trace(`[${Ae.extension.identifier.value}] provider DONE after ${Date.now()-je}ms`)}),P.CancellationToken.isCancellationToken(te)?(0,R.$ph)(Ge,te):Ge}t(j,z){const K=this.q();return this.f.set(K,new Ee(j,z)),K}static u(j){return j.displayName||j.name}static w(j){return j.identifier.value}registerDocumentSymbolProvider(j,z,K,J){const te=this.t(new f(this.h,K),j),le=J&&J.label||Re.u(j);return this.e.$registerDocumentSymbolProvider(te,this.o(z,j),le),this.p(te)}$provideDocumentSymbols(j,z,K){return this.s(j,f,J=>J.provideDocumentSymbols(u.URI.revive(z),K),void 0,K)}registerCodeLensProvider(j,z,K){const J=this.q(),te=typeof K.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(J,new Ee(new l(this.h,this.j.converter,K,j,this.n,this.l),j)),this.e.$registerCodeLensSupport(J,this.o(z,j),te);let le=this.p(J);if(te!==void 0){const Ae=K.onDidChangeCodeLenses(je=>this.e.$emitCodeLensEvent(te));le=s.$wM.from(le,Ae)}return le}$provideCodeLenses(j,z,K){return this.s(j,l,J=>J.provideCodeLenses(u.URI.revive(z),K),void 0,K)}$resolveCodeLens(j,z,K){return this.s(j,l,J=>J.resolveCodeLens(z,K),void 0,void 0)}$releaseCodeLenses(j,z){this.s(j,l,K=>Promise.resolve(K.releaseCodeLenses(z)),void 0,void 0)}registerDefinitionProvider(j,z,K){const J=this.t(new I(this.h,K),j);return this.e.$registerDefinitionSupport(J,this.o(z,j)),this.p(J)}$provideDefinition(j,z,K,J){return this.s(j,I,te=>te.provideDefinition(u.URI.revive(z),K,J),[],J)}registerDeclarationProvider(j,z,K){const J=this.t(new S(this.h,K),j);return this.e.$registerDeclarationSupport(J,this.o(z,j)),this.p(J)}$provideDeclaration(j,z,K,J){return this.s(j,S,te=>te.provideDeclaration(u.URI.revive(z),K,J),[],J)}registerImplementationProvider(j,z,K){const J=this.t(new y(this.h,K),j);return this.e.$registerImplementationSupport(J,this.o(z,j)),this.p(J)}$provideImplementation(j,z,K,J){return this.s(j,y,te=>te.provideImplementation(u.URI.revive(z),K,J),[],J)}registerTypeDefinitionProvider(j,z,K){const J=this.t(new p(this.h,K),j);return this.e.$registerTypeDefinitionSupport(J,this.o(z,j)),this.p(J)}$provideTypeDefinition(j,z,K,J){return this.s(j,p,te=>te.provideTypeDefinition(u.URI.revive(z),K,J),[],J)}registerHoverProvider(j,z,K,J){const te=this.t(new k(this.h,K),j);return this.e.$registerHoverProvider(te,this.o(z,j)),this.p(te)}$provideHover(j,z,K,J,te){return this.s(j,k,le=>le.provideHover(u.URI.revive(z),K,J,te),void 0,te)}$releaseHover(j,z){this.s(j,k,K=>Promise.resolve(K.releaseHover(z)),void 0,void 0)}registerEvaluatableExpressionProvider(j,z,K,J){const te=this.t(new m(this.h,K),j);return this.e.$registerEvaluatableExpressionProvider(te,this.o(z,j)),this.p(te)}$provideEvaluatableExpression(j,z,K,J){return this.s(j,m,te=>te.provideEvaluatableExpression(u.URI.revive(z),K,J),void 0,J)}registerInlineValuesProvider(j,z,K,J){const te=typeof K.onDidChangeInlineValues=="function"?this.q():void 0,le=this.t(new w(this.h,K),j);this.e.$registerInlineValuesProvider(le,this.o(z,j),te);let Ae=this.p(le);if(te!==void 0){const je=K.onDidChangeInlineValues(Ge=>this.e.$emitInlineValuesEvent(te));Ae=s.$wM.from(Ae,je)}return Ae}$provideInlineValues(j,z,K,J,te){return this.s(j,w,le=>le.provideInlineValues(u.URI.revive(z),K,J,te),void 0,te)}registerDocumentHighlightProvider(j,z,K){const J=this.t(new F(this.h,K),j);return this.e.$registerDocumentHighlightProvider(J,this.o(z,j)),this.p(J)}registerMultiDocumentHighlightProvider(j,z,K){const J=this.t(new T(this.h,K),j);return this.e.$registerMultiDocumentHighlightProvider(J,this.o(z,j)),this.p(J)}$provideDocumentHighlights(j,z,K,J){return this.s(j,F,te=>te.provideDocumentHighlights(u.URI.revive(z),K,J),void 0,J)}$provideMultiDocumentHighlights(j,z,K,J,te){return this.s(j,T,le=>le.provideMultiDocumentHighlights(u.URI.revive(z),K,J.map(Ae=>u.URI.revive(Ae)),te),void 0,te)}registerLinkedEditingRangeProvider(j,z,K){const J=this.t(new G(this.h,K),j);return this.e.$registerLinkedEditingRangeProvider(J,this.o(z,j)),this.p(J)}$provideLinkedEditingRanges(j,z,K,J){return this.s(j,G,async te=>{const le=await te.provideLinkedEditingRanges(u.URI.revive(z),K,J);if(le)return{ranges:le.ranges,wordPattern:le.wordPattern?Re.y(le.wordPattern):void 0}},void 0,J)}registerReferenceProvider(j,z,K){const J=this.t(new q(this.h,K),j);return this.e.$registerReferenceSupport(J,this.o(z,j)),this.p(J)}$provideReferences(j,z,K,J,te){return this.s(j,q,le=>le.provideReferences(u.URI.revive(z),K,J,te),void 0,te)}registerCodeActionProvider(j,z,K,J){const te=new M.$Tc,le=this.t(new V(this.h,this.j.converter,this.k,K,this.l,j,this.m),j);return this.e.$registerCodeActionSupport(le,this.o(z,j),{providedKinds:J?.providedCodeActionKinds?.map(Ae=>Ae.value),documentation:J?.documentation?.map(Ae=>({kind:Ae.kind.value,command:this.j.converter.toInternal(Ae.command,te)}))},Re.u(j),Re.w(j),!!K.resolveCodeAction),te.add(this.p(le)),te}$provideCodeActions(j,z,K,J,te){return this.s(j,V,le=>le.provideCodeActions(u.URI.revive(z),K,J,te),void 0,te)}$resolveCodeAction(j,z,K){return this.s(j,V,J=>J.resolveCodeAction(z,K),{},void 0)}$releaseCodeActions(j,z){this.s(j,V,K=>Promise.resolve(K.releaseCodeActions(z)),void 0,void 0)}registerDocumentFormattingEditProvider(j,z,K){const J=this.t(new L(this.h,K),j);return this.e.$registerDocumentFormattingSupport(J,this.o(z,j),j.identifier,j.displayName||j.name),this.p(J)}$provideDocumentFormattingEdits(j,z,K,J){return this.s(j,L,te=>te.provideDocumentFormattingEdits(u.URI.revive(z),K,J),void 0,J)}registerDocumentRangeFormattingEditProvider(j,z,K){const J=typeof K.provideDocumentRangesFormattingEdits=="function",te=this.t(new Z(this.h,K),j);return this.e.$registerRangeFormattingSupport(te,this.o(z,j),j.identifier,j.displayName||j.name,J),this.p(te)}$provideDocumentRangeFormattingEdits(j,z,K,J,te){return this.s(j,Z,le=>le.provideDocumentRangeFormattingEdits(u.URI.revive(z),K,J,te),void 0,te)}$provideDocumentRangesFormattingEdits(j,z,K,J,te){return this.s(j,Z,le=>le.provideDocumentRangesFormattingEdits(u.URI.revive(z),K,J,te),void 0,te)}registerOnTypeFormattingEditProvider(j,z,K,J){const te=this.t(new re(this.h,K),j);return this.e.$registerOnTypeFormattingSupport(te,this.o(z,j),J,j.identifier),this.p(te)}$provideOnTypeFormattingEdits(j,z,K,J,te,le){return this.s(j,re,Ae=>Ae.provideOnTypeFormattingEdits(u.URI.revive(z),K,J,te,le),void 0,le)}registerWorkspaceSymbolProvider(j,z){const K=this.t(new fe(z,this.l),j);return this.e.$registerNavigateTypeSupport(K,typeof z.resolveWorkspaceSymbol=="function"),this.p(K)}$provideWorkspaceSymbols(j,z,K){return this.s(j,fe,J=>J.provideWorkspaceSymbols(z,K),{symbols:[]},K)}$resolveWorkspaceSymbol(j,z,K){return this.s(j,fe,J=>J.resolveWorkspaceSymbol(z,K),void 0,void 0)}$releaseWorkspaceSymbols(j,z){this.s(j,fe,K=>K.releaseWorkspaceSymbols(z),void 0,void 0)}registerRenameProvider(j,z,K){const J=this.t(new be(this.h,K,this.l),j);return this.e.$registerRenameSupport(J,this.o(z,j),be.supportsResolving(K)),this.p(J)}$provideRenameEdits(j,z,K,J,te){return this.s(j,be,le=>le.provideRenameEdits(u.URI.revive(z),K,J,te),void 0,te)}$resolveRenameLocation(j,z,K,J){return this.s(j,be,te=>te.resolveRenameLocation(u.URI.revive(z),K,J),void 0,J)}registerNewSymbolNamesProvider(j,z,K){const J=this.t(new oe(this.h,K,this.l),j);return this.e.$registerNewSymbolNamesProvider(J,this.o(z,j)),this.p(J)}$supportsAutomaticNewSymbolNamesTriggerKind(j){return this.s(j,oe,z=>z.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(j,z,K,J,te){return this.s(j,oe,le=>le.provideNewSymbolNames(u.URI.revive(z),K,J,te),void 0,te)}registerDocumentSemanticTokensProvider(j,z,K,J){const te=this.t(new $e(this.h,K),j),le=typeof K.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(te,this.o(z,j),J,le);let Ae=this.p(te);if(le){const je=K.onDidChangeSemanticTokens(Ge=>this.e.$emitDocumentSemanticTokensEvent(le));Ae=s.$wM.from(Ae,je)}return Ae}$provideDocumentSemanticTokens(j,z,K,J){return this.s(j,$e,te=>te.provideDocumentSemanticTokens(u.URI.revive(z),K,J),null,J)}$releaseDocumentSemanticTokens(j,z){this.s(j,$e,K=>K.releaseDocumentSemanticColoring(z),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(j,z,K,J){const te=this.t(new se(this.h,K),j);return this.e.$registerDocumentRangeSemanticTokensProvider(te,this.o(z,j),J),this.p(te)}$provideDocumentRangeSemanticTokens(j,z,K,J){return this.s(j,se,te=>te.provideDocumentRangeSemanticTokens(u.URI.revive(z),K,J),null,J)}registerCompletionItemProvider(j,z,K,J){const te=this.t(new Ce(this.h,this.j.converter,K,this.m,j),j);return this.e.$registerCompletionsProvider(te,this.o(z,j),J,Ce.supportsResolving(K),j.identifier),this.p(te)}$provideCompletionItems(j,z,K,J,te){return this.s(j,Ce,le=>le.provideCompletionItems(u.URI.revive(z),K,J,te),void 0,te)}$resolveCompletionItem(j,z,K){return this.s(j,Ce,J=>J.resolveCompletionItem(z,K),void 0,K)}$releaseCompletionItems(j,z){this.s(j,Ce,K=>K.releaseCompletionItems(z),void 0,void 0)}registerInlineCompletionsProvider(j,z,K,J){const te=new X(j,this.h,K,this.j.converter),le=this.t(te,j);return this.e.$registerInlineCompletionsSupport(le,this.o(z,j),te.supportsHandleEvents,h.$Wm.toKey(j.identifier.value),J?.yieldTo?.map(Ae=>h.$Wm.toKey(Ae))||[]),this.p(le)}$provideInlineCompletions(j,z,K,J,te){return this.s(j,Fe,le=>le.provideInlineCompletions(u.URI.revive(z),K,J,te),void 0,te)}$handleInlineCompletionDidShow(j,z,K,J){this.s(j,Fe,async te=>{te.handleDidShowCompletionItem(z,K,J)},void 0,void 0)}$handleInlineCompletionPartialAccept(j,z,K,J,te){this.s(j,Fe,async le=>{le.handlePartialAccept(z,K,J,te)},void 0,void 0)}$freeInlineCompletionsList(j,z){this.s(j,Fe,async K=>{K.disposeCompletions(z)},void 0,void 0)}registerInlineEditProvider(j,z,K){const J=new W(j,this.h,K,this.j.converter),te=this.t(J,j);return this.e.$registerInlineEditProvider(te,this.o(z,j),j.identifier),this.p(te)}$provideInlineEdit(j,z,K,J){return this.s(j,W,te=>te.provideInlineEdits(u.URI.revive(z),K,J),void 0,J)}$freeInlineEdit(j,z){this.s(j,W,async K=>{K.disposeEdit(z)},void 0,void 0)}registerSignatureHelpProvider(j,z,K,J){const te=Array.isArray(J)?{triggerCharacters:J,retriggerCharacters:[]}:J,le=this.t(new Se(this.h,K),j);return this.e.$registerSignatureHelpProvider(le,this.o(z,j),te),this.p(le)}$provideSignatureHelp(j,z,K,J,te){return this.s(j,Se,le=>le.provideSignatureHelp(u.URI.revive(z),K,J,te),void 0,te)}$releaseSignatureHelp(j,z){this.s(j,Se,K=>K.releaseSignatureHelp(z),void 0,void 0)}registerInlayHintsProvider(j,z,K){const J=typeof K.onDidChangeInlayHints=="function"?this.q():void 0,te=this.t(new he(this.h,this.j.converter,K,this.l,j),j);this.e.$registerInlayHintsProvider(te,this.o(z,j),typeof K.resolveInlayHint=="function",J,Re.u(j));let le=this.p(te);if(J!==void 0){const Ae=K.onDidChangeInlayHints(je=>this.e.$emitInlayHintsEvent(J));le=s.$wM.from(le,Ae)}return le}$provideInlayHints(j,z,K,J){return this.s(j,he,te=>te.provideInlayHints(u.URI.revive(z),K,J),void 0,J)}$resolveInlayHint(j,z,K){return this.s(j,he,J=>J.resolveInlayHint(z,K),void 0,K)}$releaseInlayHints(j,z){this.s(j,he,K=>K.releaseHints(z),void 0,void 0)}registerDocumentLinkProvider(j,z,K){const J=this.t(new we(this.h,K),j);return this.e.$registerDocumentLinkProvider(J,this.o(z,j),typeof K.resolveDocumentLink=="function"),this.p(J)}$provideDocumentLinks(j,z,K){return this.s(j,we,J=>J.provideLinks(u.URI.revive(z),K),void 0,K,z.scheme==="output")}$resolveDocumentLink(j,z,K){return this.s(j,we,J=>J.resolveLink(z,K),void 0,void 0,!0)}$releaseDocumentLinks(j,z){this.s(j,we,K=>K.releaseLinks(z),void 0,void 0,!0)}registerColorProvider(j,z,K){const J=this.t(new ae(this.h,K),j);return this.e.$registerDocumentColorProvider(J,this.o(z,j)),this.p(J)}$provideDocumentColors(j,z,K){return this.s(j,ae,J=>J.provideColors(u.URI.revive(z),K),[],K)}$provideColorPresentations(j,z,K,J){return this.s(j,ae,te=>te.provideColorPresentations(u.URI.revive(z),K,J),void 0,J)}registerFoldingRangeProvider(j,z,K){const J=this.q(),te=typeof K.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(J,new Ee(new Y(this.h,K),j)),this.e.$registerFoldingRangeProvider(J,this.o(z,j),j.identifier,te);let le=this.p(J);if(te!==void 0){const Ae=K.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(te));le=s.$wM.from(le,Ae)}return le}$provideFoldingRanges(j,z,K,J){return this.s(j,Y,te=>te.provideFoldingRanges(u.URI.revive(z),K,J),void 0,J)}registerSelectionRangeProvider(j,z,K){const J=this.t(new x(this.h,K,this.l),j);return this.e.$registerSelectionRangeProvider(J,this.o(z,j)),this.p(J)}$provideSelectionRanges(j,z,K,J){return this.s(j,x,te=>te.provideSelectionRanges(u.URI.revive(z),K,J),[],J)}registerCallHierarchyProvider(j,z,K){const J=this.t(new me(this.h,K),j);return this.e.$registerCallHierarchyProvider(J,this.o(z,j)),this.p(J)}$prepareCallHierarchy(j,z,K,J){return this.s(j,me,te=>Promise.resolve(te.prepareSession(u.URI.revive(z),K,J)),void 0,J)}$provideCallHierarchyIncomingCalls(j,z,K,J){return this.s(j,me,te=>te.provideCallsTo(z,K,J),void 0,J)}$provideCallHierarchyOutgoingCalls(j,z,K,J){return this.s(j,me,te=>te.provideCallsFrom(z,K,J),void 0,J)}$releaseCallHierarchy(j,z){this.s(j,me,K=>Promise.resolve(K.releaseSession(z)),void 0,void 0)}registerTypeHierarchyProvider(j,z,K){const J=this.t(new ge(this.h,K),j);return this.e.$registerTypeHierarchyProvider(J,this.o(z,j)),this.p(J)}$prepareTypeHierarchy(j,z,K,J){return this.s(j,ge,te=>Promise.resolve(te.prepareSession(u.URI.revive(z),K,J)),void 0,J)}$provideTypeHierarchySupertypes(j,z,K,J){return this.s(j,ge,te=>te.provideSupertypes(z,K,J),void 0,J)}$provideTypeHierarchySubtypes(j,z,K,J){return this.s(j,ge,te=>te.provideSubtypes(z,K,J),void 0,J)}$releaseTypeHierarchy(j,z){this.s(j,ge,K=>Promise.resolve(K.releaseSession(z)),void 0,void 0)}registerDocumentOnDropEditProvider(j,z,K,J){const te=this.q();return this.f.set(te,new Ee(new Te(this.e,this.h,K,te,j),j)),this.e.$registerDocumentOnDropEditProvider(te,this.o(z,j),(0,n.$TG)(j,"documentPaste")&&J?{supportsResolve:!!K.resolveDocumentDropEdit,dropMimeTypes:J.dropMimeTypes}:void 0),this.p(te)}$provideDocumentOnDropEdits(j,z,K,J,te,le){return this.s(j,Te,Ae=>Promise.resolve(Ae.provideDocumentOnDropEdits(z,u.URI.revive(K),J,te,le)),void 0,void 0)}$resolveDropEdit(j,z,K){return this.s(j,Te,J=>J.resolveDropEdit(z,K),{},void 0)}$releaseDropEdits(j,z){this.s(j,Te,K=>Promise.resolve(K.releaseDropEdits(z)),void 0,void 0)}registerMappedEditsProvider(j,z,K){const J=this.t(new Be(this.h,K),j);return this.e.$registerMappedEditsProvider(J,this.o(z,j)),this.p(J)}$provideMappedEdits(j,z,K,J,te){return this.s(j,Be,le=>Promise.resolve(le.provideMappedEdits(z,K,J,te)),null,te)}registerDocumentPasteEditProvider(j,z,K,J){const te=this.q();return this.f.set(te,new Ee(new N(this.e,this.h,K,te,j),j)),this.e.$registerPasteEditProvider(te,this.o(z,j),{supportsCopy:!!K.prepareDocumentPaste,supportsPaste:!!K.provideDocumentPasteEdits,supportsResolve:!!K.resolveDocumentPasteEdit,providedPasteEditKinds:J.providedPasteEditKinds?.map(le=>le.value),copyMimeTypes:J.copyMimeTypes,pasteMimeTypes:J.pasteMimeTypes}),this.p(te)}$prepareDocumentPaste(j,z,K,J,te){return this.s(j,N,le=>le.prepareDocumentPaste(u.URI.revive(z),K,J,te),void 0,te)}$providePasteEdits(j,z,K,J,te,le,Ae){return this.s(j,N,je=>je.providePasteEdits(z,u.URI.revive(K),J,te,le,Ae),void 0,Ae)}$resolvePasteEdit(j,z,K){return this.s(j,N,J=>J.resolvePasteEdit(z,K),{},void 0)}$releasePasteEdits(j,z){this.s(j,N,K=>Promise.resolve(K.releasePasteEdits(z)),void 0,void 0)}static y(j){return{pattern:j.source,flags:j.flags}}static z(j){return{decreaseIndentPattern:Re.y(j.decreaseIndentPattern),increaseIndentPattern:Re.y(j.increaseIndentPattern),indentNextLinePattern:j.indentNextLinePattern?Re.y(j.indentNextLinePattern):void 0,unIndentedLinePattern:j.unIndentedLinePattern?Re.y(j.unIndentedLinePattern):void 0}}static B(j){return{beforeText:Re.y(j.beforeText),afterText:j.afterText?Re.y(j.afterText):void 0,previousLineText:j.previousLineText?Re.y(j.previousLineText):void 0,action:j.action}}static C(j){return j.map(Re.B)}static D(j){return{open:j.open,close:j.close,notIn:j.notIn?j.notIn.map(z=>s.SyntaxTokenType.toString(z)):void 0}}static E(j){return j.map(Re.D)}setLanguageConfiguration(j,z,K){const{wordPattern:J}=K;if(J&&(0,C.$nf)(J))throw new Error(`Invalid language configuration: wordPattern '${J}' is not allowed to match the empty string.`);J?this.h.setWordDefinitionFor(z,J):this.h.setWordDefinitionFor(z,void 0),K.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",j,"Do not use."),K.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",j,"Do not use.");const te=this.q(),le={comments:K.comments,brackets:K.brackets,wordPattern:K.wordPattern?Re.y(K.wordPattern):void 0,indentationRules:K.indentationRules?Re.z(K.indentationRules):void 0,onEnterRules:K.onEnterRules?Re.C(K.onEnterRules):void 0,__electricCharacterSupport:K.__electricCharacterSupport,__characterPairSupport:K.__characterPairSupport,autoClosingPairs:K.autoClosingPairs?Re.E(K.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(te,z,le),this.p(te)}$setWordDefinitions(j){for(const z of j)this.h.setWordDefinitionFor(z.languageId,new RegExp(z.regexSource,z.regexFlags))}}e.$Smc=Re}),define(ke[95],Ie([1,0,11,22,14,4,40,6,182,19,3,12,77,5,91,17,10,7,115,25]),function(de,e,E,R,P,O,A,M,$,c,C,v,u,D,d,r,o,a,h,t){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Anc=e.$znc=void 0,e.$znc=(0,C.$Ai)("IExtHostLanguageModels");class n{constructor(l,b){this.option=l,this.stream=new E.$4h,this.stream=b??new E.$4h}}class i{constructor(){this.a=new Map,this.b=new E.$4h,this.c=!1,this.d=!1;const l=this;this.apiObject={text:l.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,l]of this.a)yield l.stream;else yield this.b}handleFragment(l){if(this.c)return;this.d=!0;let b=this.a.get(l.index);b||(this.a.size===0?b=new n(l.index,this.b):b=new n(l.index),this.a.set(l.index,b)),b.stream.emitOne(l.part)}get isStreaming(){return this.d}reject(l){this.c=!0;for(const b of this.f())b.reject(l)}resolve(){this.c=!0;for(const l of this.f())l.resolve()}}let g=class{static{s=this}static{this.a=1}constructor(l,b,I){this.j=b,this.k=I,this.c=new O.$he,this.d=new O.$he,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new c.$Ym,this.i=new Map,this.r=new Set,this.b=l.getProxy(D.$uM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(l,b,I,S){const y=s.a++;this.f.set(y,{extension:l.identifier,provider:I,languageModelId:b});let p;S.auth&&(p={providerLabel:l.displayName||l.name,accountLabel:typeof S.auth=="object"?S.auth.label:void 0}),this.b.$registerLanguageModelProvider(y,`${c.$Wm.toKey(l.identifier)}/${y}/${b}`,{extension:l.identifier,id:b,vendor:S.vendor??c.$Wm.toKey(l.identifier),name:S.name??"",family:S.family??"",version:S.version,maxInputTokens:S.maxInputTokens,maxOutputTokens:S.maxOutputTokens,auth:p,targetExtensions:S.extensions});const k=I.onDidReceiveLanguageModelResponse2?.(({extensionId:m,participant:w,tokenCount:F})=>{this.b.$whenLanguageModelChatRequestMade(b,new c.$Wm(m),w,F)});return(0,M.$Sc)(()=>{this.f.delete(y),this.b.$unregisterProvider(y),k?.dispose()})}async $provideLanguageModelResponse(l,b,I,S,y,p){const k=this.f.get(l);if(!k)return;const m=new u.$mw(async w=>{if(p.isCancellationRequested){this.j.warn(`[CHAT](${k.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(b,{index:w.index,part:w.part})});return k.provider.provideLanguageModelResponse(S.map(o.LanguageModelChatMessage.to),y,c.$Wm.toKey(I),m,p)}$provideTokenLength(l,b,I){const S=this.f.get(l);return S?Promise.resolve(S.provider.provideTokenCount(b,I)):Promise.resolve(0)}$acceptChatModelMetadata(l){if(l.added)for(const{identifier:b,metadata:I}of l.added)this.g.set(b,{metadata:I,apiObjects:new c.$Ym});if(l.removed)for(const b of l.removed){this.g.delete(b);for(const[I,S]of this.i)S.languageModelId===b&&(S.res.reject(new P.$5),this.i.delete(I))}l.added?.forEach(b=>this.p(b.metadata)),this.d.fire(void 0)}async selectLanguageModels(l,b){const I=await this.b.$selectChatModels({...b,extension:l.identifier}),S=[],y=this;for(const p of I){const k=this.g.get(p);if(!k)continue;this.o(l.identifier,k.metadata)&&await this.p(k.metadata);let m=k.apiObjects.get(l.identifier);m||(m={id:p,vendor:k.metadata.vendor,family:k.metadata.family,version:k.metadata.version,name:k.metadata.name,maxInputTokens:k.metadata.maxInputTokens,countTokens(w,F){if(!y.g.has(p))throw a.$LO.NotFound(p);return y.q(p,w,F??R.CancellationToken.None)},sendRequest(w,F,T){if(!y.g.has(p))throw a.$LO.NotFound(p);return y.l(l,p,w,F??{},T??R.CancellationToken.None)}},Object.freeze(m),k.apiObjects.set(l.identifier,m)),S.push(m)}return S}async l(l,b,I,S,y){const p=this.m(l,I),k=l.identifier,m=this.g.get(b)?.metadata;if(!m||!this.g.has(b))throw a.$LO.NotFound(`Language model '${b}' is unknown.`);if(this.o(k,m)&&(!await this.n(l,{identifier:m.extension,displayName:m.auth.providerLabel},S.justification,!1)||!this.h.get(k)?.has(m.extension)))throw a.$LO.NoPermissions(`Language model '${b}' cannot be used by '${k.value}'.`);const w=Math.random()*1e6|0,F=this.b.$fetchResponse(k,b,w,p,S.modelOptions??{},y),T=new E.$zh,G=new i;this.i.set(w,{languageModelId:b,res:G});let q;if(F.catch(V=>{T.isOpen()?G.reject(V):q=V}).finally(()=>{this.i.delete(w),G.resolve(),T.open()}),await T.wait(),q)throw q.name===a.$LO.name?q:new a.$LO(`Language model '${b}' errored, check cause for more details`,"Unknown",q);return G.apiObject}m(l,b){const I=[];for(const S of b)S.role===a.LanguageModelChatMessageRole.System&&(0,t.$UG)(l,"languageModelSystem"),I.push(o.LanguageModelChatMessage.from(S));return I}async $handleResponseFragment(l,b){const I=this.i.get(l);I&&I.res.handleFragment(b)}async n(l,b,I,S){const y=h.$wL+b.identifier.value;if(await this.k.getSession(l,y,[],{silent:!0}))return this.$updateModelAccesslist([{from:l.identifier,to:b.identifier,enabled:!0}]),!0;if(S)return!1;try{const k=I?(0,$.localize)(0,null,b.displayName,I):void 0;return await this.k.getSession(l,y,[],{forceNewSession:{detail:k}}),this.$updateModelAccesslist([{from:l.identifier,to:b.identifier,enabled:!0}]),!0}catch{return!1}}o(l,b){return!!b.auth&&!c.$Wm.equals(b.extension,l)}async p(l){if(l.auth)for(const b of this.r)try{await this.n(b,{identifier:l.extension,displayName:""},void 0,!0)}catch(I){this.j.error("Fake Auth request failed"),this.j.error(I)}}async q(l,b,I){if(!this.g.get(l))throw a.$LO.NotFound(`Language model '${l}' is unknown.`);const y=A.Iterable.find(this.f.values(),p=>p.languageModelId===l);return y?y.provider.provideTokenCount(b,I):this.b.$countTokens(l,typeof b=="string"?b:o.LanguageModelChatMessage.from(b),I)}$updateModelAccesslist(l){const b=new Array;for(const{from:I,to:S,enabled:y}of l){const p=this.h.get(I)??new c.$Xm;if(p.has(S)!==y){y?p.add(S):p.delete(S),this.h.set(I,p);const m={from:I,to:S};b.push(m),this.c.fire(m)}}}createLanguageModelAccessInformation(l){this.r.add(l);const b=this,I=O.Event.signal(O.Event.filter(this.c.event,y=>c.$Wm.equals(y.from,l.identifier))),S=O.Event.signal(this.d.event);return{get onDidChange(){return O.Event.any(I,S)},canSendRequest(y){let p;e:for(const[m,w]of b.g)for(const F of w.apiObjects.values())if(F===y){p=w.metadata;break e}if(!p)return;if(!b.o(l.identifier,p))return!0;const k=b.h.get(l.identifier);if(k)return k.has(p.extension)}}}};e.$Anc=g,e.$Anc=g=s=He([Ve(0,r.$YO),Ve(1,v.$7j),Ve(2,d.$Umc)],g)}),define(ke[285],Ie([1,0,5,10,7,35,11,6,25]),function(de,e,E,R,P,O,A,M,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$foc=void 0;class c{constructor(v,u,D,d){this.c=u,this.d=D,this.e=d,this.b=[],this.f=0,this.g=new Set,this.a=v.getProxy(E.$uM.MainThreadLanguages)}$acceptLanguageIds(v){this.b=v}async getLanguages(){return this.b.slice(0)}async changeLanguage(v,u){await this.a.$changeLanguage(v,u);const D=this.c.getDocumentData(v);if(!D)throw new Error(`document '${v.toString()}' NOT found`);return D.document}async tokenAtPosition(v,u){const D=v.version,d=R.Position.from(u),r=await this.a.$tokensAtPosition(v.uri,d),o={type:P.StandardTokenType.Other,range:v.getWordRangeAtPosition(u)??new P.$yM(u.line,u.character,u.line,u.character)};if(!r)return o;const a={range:R.Range.to(r.range),type:R.TokenType.to(r.type)};return!a.range.contains(u)||D!==v.version?o:a}createLanguageStatusItem(v,u,D){const d=this.f++,r=this.a,o=this.g,a=`${v.identifier.value}/${u}`;if(o.has(a))throw new Error(`LanguageStatusItem with id '${u}' ALREADY exists`);o.add(a);const h={selector:D,id:u,name:v.displayName??v.name,severity:P.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let t;const s=new M.$Tc,n=()=>{if(t?.dispose(),!o.has(a)){console.warn(`LanguageStatusItem (${u}) from ${v.identifier.value} has been disposed and CANNOT be updated anymore`);return}t=(0,A.$Ch)(()=>{s.clear(),this.a.$setLanguageStatus(d,{id:a,name:h.name??v.displayName??v.name,source:v.displayName??v.name,selector:R.DocumentSelector.from(h.selector,this.e),label:h.text,detail:h.detail??"",severity:h.severity===P.LanguageStatusSeverity.Error?O.default.Error:h.severity===P.LanguageStatusSeverity.Warning?O.default.Warning:O.default.Info,command:h.command&&this.d.toInternal(h.command,s),accessibilityInfo:h.accessibilityInformation,busy:h.busy})},0)},i={dispose(){s.dispose(),t?.dispose(),r.$removeLanguageStatus(d),o.delete(a)},get id(){return h.id},get name(){return h.name},set name(g){h.name=g,n()},get selector(){return h.selector},set selector(g){h.selector=g,n()},get text(){return h.text},set text(g){h.text=g,n()},set text2(g){(0,$.$UG)(v,"languageStatusText"),h.text=g,n()},get text2(){return(0,$.$UG)(v,"languageStatusText"),h.text},get detail(){return h.detail},set detail(g){h.detail=g,n()},get severity(){return h.severity},set severity(g){h.severity=g,n()},get accessibilityInformation(){return h.accessibilityInformation},set accessibilityInformation(g){h.accessibilityInformation=g,n()},get command(){return h.command},set command(g){h.command=g,n()},get busy(){return h.busy},set busy(g){h.busy=g,n()}};return n(),i}}e.$foc=c}),define(ke[286],Ie([1,0,16,2,10,7,90]),function(de,e,E,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5nc=e.$4nc=void 0;class M{constructor(v,u,D,d){this.start=v,this.deletedCount=u,this.deletedItems=D,this.items=d}asApiEvent(){return{range:new O.$YN(this.start,this.start+this.deletedCount),addedCells:this.items.map(v=>v.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(v){return{EOL:v.eol,lines:v.source,languageId:v.language,uri:v.uri,isDirty:!1,versionId:1}}constructor(v,u,D){this.notebook=v,this.h=u,this.j=D,this.handle=D.handle,this.uri=R.URI.revive(D.uri),this.cellKind=D.cellKind,this.a=D.outputs.map(P.NotebookCellOutput.to),this.e=D.internalMetadata??{},this.b=Object.freeze(D.metadata??{}),this.d=Object.freeze(P.NotebookCellExecutionSummary.to(D.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const v=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const D={get index(){return v.notebook.getCellIndex(v)},notebook:v.notebook.apiNotebook,kind:P.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return v.g},set mime(d){v.g=d},get outputs(){return v.a.slice(0)},get metadata(){return v.b},get executionSummary(){return v.d}};this.f=Object.freeze(D)}return this.f}setOutputs(v){this.a=v.map(P.NotebookCellOutput.to)}setOutputItems(v,u,D){const d=D.map(P.NotebookCellOutputItem.to),r=this.a.find(o=>o.id===v);if(r&&(u||(r.items.length=0),r.items.push(...d),r.items.length>1&&r.items.every(o=>A.$qK(o.mime)))){const o=new Map,a=[];r.items.forEach(h=>{let t;o.has(h.mime)?t=o.get(h.mime):(t=[],o.set(h.mime,t),a.push(h.mime)),t.push(h.data)}),r.items.length=0,a.forEach(h=>{const t=A.$rK(o.get(h));r.items.push({mime:h,data:t.data.buffer})})}}setMetadata(v){this.b=Object.freeze(v)}setInternalMetadata(v){this.e=v,this.d=Object.freeze(P.NotebookCellExecutionSummary.to(v))}setMime(v){}}e.$4nc=$;class c{static{this.a=0}constructor(v,u,D,d,r){this.k=v,this.l=u,this.m=D,this.uri=d,this.handle=c.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=r.viewType,this.f=Object.freeze(r.metadata??Object.create(null)),this.r([[0,0,r.cells]],!0,void 0),this.g=r.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const v=this,u={get uri(){return v.uri},get version(){return v.g},get notebookType(){return v.d},get isDirty(){return v.h},get isUntitled(){return v.uri.scheme===E.Schemas.untitled},get isClosed(){return v.j},get metadata(){return v.f},get cellCount(){return v.b.length},cellAt(D){return D=v.n(D),v.b[D].apiCell},getCells(D){return(D?v.p(D):v.b).map(r=>r.apiCell)},save(){return v.q()}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(v){v.metadata&&(this.f=Object.freeze({...this.f,...v.metadata}))}acceptDirty(v){this.h=v}acceptModelChanged(v,u,D){this.g=v.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:D});const d={notebook:this.apiNotebook,metadata:D,cellChanges:[],contentChanges:[]},r=[];for(const a of v.rawEvents)a.kind===A.NotebookCellsChangeType.ModelChange?this.r(a.changes,!1,d.contentChanges):a.kind===A.NotebookCellsChangeType.Move?this.s(a.index,a.length,a.newIdx,d.contentChanges):a.kind===A.NotebookCellsChangeType.Output?(this.t(a.index,a.outputs),r.push({cell:this.b[a.index].apiCell,outputs:this.b[a.index].apiCell.outputs})):a.kind===A.NotebookCellsChangeType.OutputItem?(this.u(a.index,a.outputId,a.append,a.outputItems),r.push({cell:this.b[a.index].apiCell,outputs:this.b[a.index].apiCell.outputs})):a.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(a.index,a.language),r.push({cell:this.b[a.index].apiCell,document:this.b[a.index].apiCell.document})):a.kind===A.NotebookCellsChangeType.ChangeCellContent?r.push({cell:this.b[a.index].apiCell,document:this.b[a.index].apiCell.document}):a.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(a.index,a.mime):a.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(a.index,a.metadata),r.push({cell:this.b[a.index].apiCell,metadata:this.b[a.index].apiCell.metadata})):a.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(a.index,a.internalMetadata),r.push({cell:this.b[a.index].apiCell,executionSummary:this.b[a.index].apiCell.executionSummary}));const o=new Map;for(let a=0;a<r.length;a++){const h=r[a],t=o.get(h.cell);if(t===void 0){const s=d.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...h});o.set(h.cell,s-1)}else d.cellChanges[t]={...d.cellChanges[t],...h}}return Object.freeze(d),Object.freeze(d.cellChanges),Object.freeze(d.contentChanges),d}n(v){return v=v|0,v<0?0:v>=this.b.length?this.b.length-1:v}o(v){let u=v.start|0,D=v.end|0;return u<0&&(u=0),D>this.b.length&&(D=this.b.length),v.with({start:u,end:D})}p(v){v=this.o(v);const u=[];for(let D=v.start;D<v.end;D++)u.push(this.b[D]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(v,u,D){if(this.j)return;const d=[],r=[],o=[];if(v.reverse().forEach(a=>{const t=a[2].map(i=>{const g=new $(this,this.l,i);return u||r.push($.asModelAddData(i)),g}),s=new M(a[0],a[1],[],t),n=this.b.splice(a[0],a[1],...t);for(const i of n)o.push(i.uri),s.deletedItems.push(i.apiCell);d.push(s)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:r,removedDocuments:o}),D)for(const a of d)D.push(a.asApiEvent())}s(v,u,D,d){const r=this.b.splice(v,u);this.b.splice(D,0,...r);const o=[new M(v,u,r.map(a=>a.apiCell),[]),new M(D,0,[],r)];for(const a of o)d.push(a.asApiEvent())}t(v,u){this.b[v].setOutputs(u)}u(v,u,D,d){this.b[v].setOutputItems(u,D,d)}v(v,u){const D=this.b[v];D.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(D.uri,u)}w(v,u){const D=this.b[v];D.apiCell.mime=u}x(v,u){this.b[v].setMetadata(u)}y(v,u){this.b[v].setInternalMetadata(u)}getCellFromApiCell(v){return this.b.find(u=>u.apiCell===v)}getCellFromIndex(v){return this.b[v]}getCell(v){return this.b.find(u=>u.handle===v)}getCellIndex(v){return this.b.indexOf(v)}}e.$5nc=c}),define(ke[287],Ie([1,0,4,2,10,7,38]),function(de,e,E,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hoc=void 0;class M{constructor(c,C,v,u={timeout:1500,errors:3}){this.b=c,this.c=C,this.d=v,this.f=u,this.a=new E.$je}dispose(){}getOnWillSaveNotebookDocumentEvent(c){return(C,v,u)=>{const D=function(r){C.call(v,r)};return D.extension=c,this.a.event(D,void 0,u)}}async $participateInSave(c,C,v){const u=R.URI.revive(c),D=this.c.getNotebookDocument(u);if(!D)throw new Error("Unable to resolve notebook document");const d=[];if(await this.a.fireAsync({notebook:D.apiNotebook,reason:P.TextDocumentSaveReason.to(C)},v,async(o,a)=>{const h=Date.now(),t=await await Promise.resolve(o);Date.now()-h>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier),!v.isCancellationRequested&&t&&(t instanceof O.$GM?d.push(t):this.b.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier,"ignored due to invalid data"))}),v.isCancellationRequested)return!1;if(d.length===0)return!0;const r={edits:[]};for(const o of d){const{edits:a}=P.WorkspaceEdit.from(o);r.edits=r.edits.concat(a)}return this.d.$tryApplyWorkspaceEdit(new A.$Kw(r))}}e.$hoc=M}),define(ke[122],Ie([1,0,14,10,7]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6nc=void 0;class O{static{this.apiEditorsToExtHost=new WeakMap}constructor(M,$,c,C,v,u){this.id=M,this.f=$,this.notebookData=c,this.a=[],this.b=[],this.d=!1,this.a=v,this.b=C,this.c=u}get apiEditor(){if(!this.e){const M=this;this.e={get notebook(){return M.notebookData.apiNotebook},get selection(){return M.a[0]},set selection($){this.selections=[$]},get selections(){return M.a},set selections($){if(!Array.isArray($)||!$.every(P.$YN.isNotebookRange))throw(0,E.$7)("selections");M.a=$,M.g($)},get visibleRanges(){return M.b},revealRange($,c){M.f.$tryRevealRange(M.id,R.NotebookRange.from($),c??P.NotebookEditorRevealType.Default)},get viewColumn(){return M.c}},O.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(M){this.d=M}_acceptVisibleRanges(M){this.b=M}_acceptSelections(M){this.a=M}g(M){this.f.$trySetSelections(this.id,M.map(R.NotebookRange.from))}_acceptViewColumn(M){this.c=M}}e.$6nc=O}),define(ke[288],Ie([1,0,4,12,10]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$joc=void 0;let O=class{constructor(M,$){this.c=M,this.d=$,this.a=new E.$he,this.b=new E.$he,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(M,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",M,$);const c=this.d.getEditorById(M);$.visibleRanges&&c._acceptVisibleRanges($.visibleRanges.ranges.map(P.NotebookRange.to)),$.selections&&c._acceptSelections($.selections.selections.map(P.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:c.apiEditor,visibleRanges:c.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:c.apiEditor,selections:c.apiEditor.selections}))}$acceptEditorViewColumns(M){for(const $ in M)this.d.getEditorById($)._acceptViewColumn(P.ViewColumn.to(M[$]))}};e.$joc=O,e.$joc=O=He([Ve(0,R.$7j)],O)}),define(ke[289],Ie([1,0,4,5,122]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$moc=void 0;class O{constructor(M,$){this.c=$,this.a=new Map,this.b=M.getProxy(R.$uM.MainThreadNotebookRenderers)}$postRendererMessage(M,$,c){const C=this.c.getEditorById(M);this.a.get($)?.fire({editor:C.apiEditor,message:c})}createRendererMessaging(M,$){if(!M.contributes?.notebookRenderer?.some(C=>C.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(C,v,u)=>this.d($).event(C,v,u),postMessage:(C,v)=>{P.$6nc.apiEditorsToExtHost.has(C)&&([C,v]=[v,C]);const u=v&&P.$6nc.apiEditorsToExtHost.get(v);return this.b.$postMessage(u?.id,$,C)}}}d(M){let $=this.a.get(M);return $||($=new E.$he({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(M)}}),this.a.set(M,$),$)}}e.$moc=O}),define(ke[290],Ie([1,0,10,77,22,72,14]),function(de,e,E,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qoc=void 0;class M{constructor(v){this.b=0,this.c=new Map,this.a=v}async withProgress(v,u,D){const d=this.b++,{title:r,location:o,cancellable:a}=u,h={label:v.displayName||v.name,id:v.identifier.value};return this.a.$startProgress(d,{location:E.ProgressLocation.from(o),title:r,source:h,cancellable:a},v.isUnderDevelopment?void 0:v.identifier.value).catch(A.$2),this.d(d,D,!!a)}d(v,u,D){let d;D&&(d=new P.$se,this.c.set(v,d));const r=a=>{this.a.$progressEnd(a),this.c.delete(a),d?.dispose()};let o;try{o=u(new c(this.a,v),D&&d?d.token:P.CancellationToken.None)}catch(a){throw r(v),a}return o.then(a=>r(v),a=>r(v)),o}$acceptProgressCanceled(v){const u=this.c.get(v);u&&(u.cancel(),this.c.delete(v))}}e.$qoc=M;function $(C,v){return C.message=v.message,typeof v.increment=="number"&&(typeof C.increment=="number"?C.increment+=v.increment:C.increment=v.increment),C}class c extends R.$mw{constructor(v,u){super(D=>this.throttledReport(D)),this.c=v,this.d=u}throttledReport(v){this.c.$progressReport(this.d,v)}}He([(0,O.$7h)(100,(C,v)=>$(C,v),()=>Object.create(null))],c.prototype,"throttledReport",null)}),define(ke[291],Ie([1,0,2,5,11,10]),function(de,e,E,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$roc=void 0;class A{static{this.a=0}constructor($,c){this.d=c,this.c=new Map,this.b=$.getProxy(R.$uM.MainThreadQuickDiff)}$provideOriginalResource($,c,C){const v=E.URI.revive(c),u=this.c.get($);return u?(0,P.$sh)(()=>u.provideOriginalResource(v,C)).then(D=>D||null):Promise.resolve(null)}registerQuickDiffProvider($,c,C,v){const u=A.a++;return this.c.set(u,c),this.b.$registerQuickDiffProvider(u,O.DocumentSelector.from($,this.d),C,v),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$roc=A}),define(ke[292],Ie([1,0,22,4,6,5,2,7,14,18,35,34,25,10]),function(de,e,E,R,P,O,A,M,$,c,C,v,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$soc=d;function d(r,o,a){const h=r.getProxy(O.$uM.MainThreadQuickOpen);class t{constructor(S,y){this.e=new Map,this.f=0,this.a=S,this.b=y}showQuickPick(S,y,p,k=E.CancellationToken.None){this.c=void 0;const m=Promise.resolve(y),w=++this.f,F=h.$show(w,{title:p?.title,placeHolder:p?.placeHolder,matchOnDescription:p?.matchOnDescription,matchOnDetail:p?.matchOnDetail,ignoreFocusLost:p?.ignoreFocusOut,canPickMany:p?.canPickMany},k),T={},G=F.then(()=>T);return Promise.race([G,m]).then(q=>{if(q===T)return;const V=(0,u.$TG)(S,"quickPickItemTooltip");return m.then(N=>{const L=[];for(let Z=0;Z<N.length;Z++){const re=N[Z];if(typeof re=="string")L.push({label:re,handle:Z});else if(re.kind===M.QuickPickItemKind.Separator)L.push({type:"separator",label:re.label});else{re.tooltip&&!V&&console.warn(`Extension '${S.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${S.identifier.value}`);const fe=re.iconPath?f(re.iconPath):void 0;L.push({label:re.label,iconPath:fe?.iconPath,iconClass:fe?.iconClass,description:re.description,detail:re.detail,picked:re.picked,alwaysShow:re.alwaysShow,tooltip:V?D.MarkdownString.fromStrict(re.tooltip):void 0,handle:Z})}}return p&&typeof p.onDidSelectItem=="function"&&(this.c=Z=>{p.onDidSelectItem(N[Z])}),h.$setItems(w,L),F.then(Z=>{if(typeof Z=="number")return N[Z];if(Array.isArray(Z))return Z.map(re=>N[re])})})}).then(void 0,q=>{if(!(0,$.$4)(q))return h.$setError(w,q),Promise.reject(q)})}$onItemSelected(S){this.c?.(S)}showInput(S,y=E.CancellationToken.None){return this.d=S?.validateInput,h.$input(S,typeof this.d=="function",y).then(void 0,p=>{if(!(0,$.$4)(p))return Promise.reject(p)})}async $validateInput(S){if(!this.d)return;const y=await this.d(S);if(!y||typeof y=="string")return y;let p;switch(y.severity){case M.InputBoxValidationSeverity.Info:p=C.default.Info;break;case M.InputBoxValidationSeverity.Warning:p=C.default.Warning;break;case M.InputBoxValidationSeverity.Error:p=C.default.Error;break;default:p=y.message?C.default.Error:C.default.Ignore;break}return{content:y.message,severity:p}}async showWorkspaceFolderPick(S,y=E.CancellationToken.None){const p=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[S]);if(!p)return;const k=await this.a.getWorkspaceFolders2();if(k)return k.find(m=>m.uri.toString()===p.uri.toString())}createQuickPick(S){const y=new l(S,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}createInputBox(S){const y=new b(S,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}$onDidChangeValue(S,y){this.e.get(S)?._fireDidChangeValue(y)}$onDidAccept(S){this.e.get(S)?._fireDidAccept()}$onDidChangeActive(S,y){const p=this.e.get(S);p instanceof l&&p._fireDidChangeActive(y)}$onDidChangeSelection(S,y){const p=this.e.get(S);p instanceof l&&p._fireDidChangeSelection(y)}$onDidTriggerButton(S,y){this.e.get(S)?._fireDidTriggerButton(y)}$onDidTriggerItemButton(S,y,p){const k=this.e.get(S);k instanceof l&&k._fireDidTriggerItemButton(y,p)}$onDidHide(S){this.e.get(S)?._fireDidHide()}}class s{static{this.a=1}constructor(S,y){this.x=S,this.y=y,this._id=l.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new R.$he,this.q=new R.$he,this.r=new R.$he,this.s=new R.$he,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(S){this.b=S,this.z({title:S})}get step(){return this.c}set step(S){this.c=S,this.z({step:S})}get totalSteps(){return this.d}set totalSteps(S){this.d=S,this.z({totalSteps:S})}get enabled(){return this.g}set enabled(S){this.g=S,this.z({enabled:S})}get busy(){return this.j}set busy(S){this.j=S,this.z({busy:S})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(S){this.k=S,this.z({ignoreFocusOut:S})}get value(){return this.l}set value(S){this.l=S,this.z({value:S})}get placeholder(){return this.m}set placeholder(S){this.m=S,this.z({placeholder:S})}get buttons(){return this.n}set buttons(S){this.n=S.slice(),this.o.clear(),S.forEach((y,p)=>{const k=y===M.$VN.Back?-1:p;this.o.set(k,y)}),this.z({buttons:S.map((y,p)=>({...f(y.iconPath),tooltip:y.tooltip,handle:y===M.$VN.Back?-1:p}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(S){this.l=S,this.q.fire(S)}_fireDidTriggerButton(S){const y=this.o.get(S);y&&this.r.fire(y)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,P.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),h.$dispose(this._id))}z(S){if(!this.v){for(const y of Object.keys(S)){const p=S[y];this.u[y]=p===void 0?null:p}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){h.$createOrUpdate(this.u),this.u={id:this._id}}}function n(I){if(I instanceof M.$tN)return{id:I.id};const S=g(I),y=i(I);return{dark:typeof S=="string"?A.URI.file(S):S,light:typeof y=="string"?A.URI.file(y):y}}function i(I){return typeof I=="object"&&"light"in I?I.light:I}function g(I){return typeof I=="object"&&"dark"in I?I.dark:I}function f(I){const S=n(I);let y,p;return"id"in S?p=v.ThemeIcon.asClassName(S):y=S,{iconPath:y,iconClass:p}}class l extends s{constructor(S,y){super(S.identifier,y),this.O=S,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new R.$he,this.L=[],this.M=new R.$he,this.N=new R.$he,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(S){this.B=S.slice(),this.C.clear(),this.D.clear(),S.forEach((k,m)=>{this.C.set(m,k),this.D.set(k,m)});const y=(0,u.$TG)(this.O,"quickPickItemTooltip"),p=[];for(let k=0;k<S.length;k++){const m=S[k];if(m.kind===M.QuickPickItemKind.Separator)p.push({type:"separator",label:m.label});else{m.tooltip&&!y&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const w=m.iconPath?f(m.iconPath):void 0;p.push({handle:k,label:m.label,iconPath:w?.iconPath,iconClass:w?.iconClass,description:m.description,detail:m.detail,picked:m.picked,alwaysShow:m.alwaysShow,tooltip:y?D.MarkdownString.fromStrict(m.tooltip):void 0,buttons:m.buttons?.map((F,T)=>({...f(F.iconPath),tooltip:F.tooltip,handle:T}))})}}this.z({items:p})}get canSelectMany(){return this.E}set canSelectMany(S){this.E=S,this.z({canSelectMany:S})}get matchOnDescription(){return this.F}set matchOnDescription(S){this.F=S,this.z({matchOnDescription:S})}get matchOnDetail(){return this.G}set matchOnDetail(S){this.G=S,this.z({matchOnDetail:S})}get sortByLabel(){return this.H}set sortByLabel(S){this.H=S,this.z({sortByLabel:S})}get keepScrollPosition(){return this.I}set keepScrollPosition(S){this.I=S,this.z({keepScrollPosition:S})}get activeItems(){return this.J}set activeItems(S){this.J=S.filter(y=>this.D.has(y)),this.z({activeItems:this.J.map(y=>this.D.get(y))})}get selectedItems(){return this.L}set selectedItems(S){this.L=S.filter(y=>this.D.has(y)),this.z({selectedItems:this.L.map(y=>this.D.get(y))})}_fireDidChangeActive(S){const y=(0,c.$Hb)(S.map(p=>this.C.get(p)));this.J=y,this.K.fire(y)}_fireDidChangeSelection(S){const y=(0,c.$Hb)(S.map(p=>this.C.get(p)));this.L=y,this.M.fire(y)}_fireDidTriggerItemButton(S,y){const p=this.C.get(S);if(!p||!p.buttons||!p.buttons.length)return;const k=p.buttons[y];k&&this.N.fire({button:k,item:p})}}class b extends s{constructor(S,y){super(S.identifier,y),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(S){this.B=S,this.z({password:S})}get prompt(){return this.C}set prompt(S){this.C=S,this.z({prompt:S})}get valueSelection(){return this.D}set valueSelection(S){this.D=S,this.z({valueSelection:S})}get validationMessage(){return this.E}set validationMessage(S){this.E=S,S?typeof S=="string"?this.z({validationMessage:S,severity:C.default.Error}):this.z({validationMessage:S.message,severity:S.severity??C.default.Error}):this.z({validationMessage:void 0,severity:C.default.Ignore})}}return new t(o,a)}}),define(ke[293],Ie([1,0,2,4,72,6,11,5,18,158,12,19,37,34,10,25,16,21]),function(de,e,E,R,P,O,A,M,$,c,C,v,u,D,d,r,o,a){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$uoc=e.$toc=void 0;function t(F){return F instanceof E.URI}function s(F,T){return F.scheme===o.Schemas.file&&T.scheme===o.Schemas.file&&a.$k?F.toString()===T.toString():F.toString().toLowerCase()===T.toString().toLowerCase()}function n(F){if(F)return typeof F.iconPath=="string"?E.URI.file(F.iconPath):E.URI.isUri(F.iconPath)||D.ThemeIcon.isThemeIcon(F.iconPath)?F.iconPath:void 0}function i(F){if(F.icon){if(E.URI.isUri(F.icon))return F.icon;if(D.ThemeIcon.isThemeIcon(F.icon))return F.icon;{const T=F.icon;return{light:T.light,dark:T.dark}}}else return}function g(F,T){if(!F.iconPath&&!T.iconPath)return 0;if(F.iconPath){if(!T.iconPath)return 1}else return-1;const G=typeof F.iconPath=="string"?F.iconPath:E.URI.isUri(F.iconPath)?F.iconPath.fsPath:F.iconPath.id,q=typeof T.iconPath=="string"?T.iconPath:E.URI.isUri(T.iconPath)?T.iconPath.fsPath:T.iconPath.id;return(0,c.$yr)(G,q)}function f(F,T){let G=0;if(F.strikeThrough!==T.strikeThrough)return F.strikeThrough?1:-1;if(F.faded!==T.faded)return F.faded?1:-1;if(F.tooltip!==T.tooltip)return(F.tooltip||"").localeCompare(T.tooltip||"");if(G=g(F,T),G!==0)return G;if(F.light&&T.light)G=g(F.light,T.light);else{if(F.light)return 1;if(T.light)return-1}if(G!==0)return G;if(F.dark&&T.dark)G=g(F.dark,T.dark);else{if(F.dark)return 1;if(T.dark)return-1}return G}function l(F,T){if(F.command!==T.command)return F.command<T.command?-1:1;if(F.title!==T.title)return F.title<T.title?-1:1;if(F.tooltip!==T.tooltip){if(F.tooltip!==void 0&&T.tooltip!==void 0)return F.tooltip<T.tooltip?-1:1;if(F.tooltip!==void 0)return 1;if(T.tooltip!==void 0)return-1}if(F.arguments===T.arguments)return 0;if(F.arguments)if(T.arguments){if(F.arguments.length!==T.arguments.length)return F.arguments.length-T.arguments.length}else return 1;else return-1;for(let G=0;G<F.arguments.length;G++){const q=F.arguments[G],V=T.arguments[G];if(q!==V&&!(t(q)&&t(V)&&s(q,V)))return q<V?-1:1}return 0}function b(F,T){let G=(0,c.$yr)(F.resourceUri.fsPath,T.resourceUri.fsPath,!0);if(G!==0)return G;if(F.command&&T.command)G=l(F.command,T.command);else{if(F.command)return 1;if(T.command)return-1}if(G!==0)return G;if(F.decorations&&T.decorations)G=f(F.decorations,T.decorations);else{if(F.decorations)return 1;if(T.decorations)return-1}if(F.multiFileDiffEditorModifiedUri&&T.multiFileDiffEditorModifiedUri)G=(0,c.$yr)(F.multiFileDiffEditorModifiedUri.fsPath,T.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(F.multiFileDiffEditorModifiedUri)return 1;if(T.multiFileDiffEditorModifiedUri)return-1}if(F.multiDiffEditorOriginalUri&&T.multiDiffEditorOriginalUri)G=(0,c.$yr)(F.multiDiffEditorOriginalUri.fsPath,T.multiDiffEditorOriginalUri.fsPath,!0);else{if(F.multiDiffEditorOriginalUri)return 1;if(T.multiDiffEditorOriginalUri)return-1}return G}function I(F,T){for(let G=0;G<F.length;G++)if(F[G]!==T[G])return!1;return!0}function S(F,T){return F.command===T.command&&F.title===T.title&&F.tooltip===T.tooltip&&(F.arguments&&T.arguments?I(F.arguments,T.arguments):F.arguments===T.arguments)}function y(F,T){return(0,$.$ub)(F,T,S)}class p{#e;#t;get value(){return this.d}set value(T){T=T??"",this.l.queue(async()=>this.#e.$setInputBoxValue(this.m,T)),this.o(T)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(T){this.l.queue(async()=>this.#e.$setInputBoxPlaceholder(this.m,T)),this.f=T}get validateInput(){return(0,r.$UG)(this.k,"scmValidation"),this.g}set validateInput(T){if((0,r.$UG)(this.k,"scmValidation"),T&&typeof T!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=T,this.l.queue(async()=>this.#e.$setValidationProviderIsEnabled(this.m,!!T))}get enabled(){return this.h}set enabled(T){T=!!T,this.h!==T&&(this.h=T,this.l.queue(async()=>this.#e.$setInputBoxEnablement(this.m,T)))}get visible(){return this.j}set visible(T){T=!!T,this.j!==T&&(this.j=T,this.l.queue(async()=>this.#e.$setInputBoxVisibility(this.m,T)))}get document(){return(0,r.$UG)(this.k,"scmTextDocument"),this.#t.getDocument(this.n)}constructor(T,G,q,V,N,L){this.k=T,this.l=V,this.m=N,this.n=L,this.d="",this.e=new R.$he,this.f="",this.h=!0,this.j=!0,this.#t=G,this.#e=q}showValidationMessage(T,G){(0,r.$UG)(this.k,"scmValidation"),this.l.queue(async()=>this.#e.$showValidationMessage(this.m,T,G))}$onInputBoxValueChange(T){this.o(T)}o(T){this.d=T,this.e.fire(T)}}e.$toc=p;class k{static{this.d=0}get disposed(){return this.l}get id(){return this.v}get label(){return this.w}set label(T){this.w=T,this.t.queue(async()=>this.q.$updateGroupLabel(this.u,this.handle,T))}get hideWhenEmpty(){return this.p}set hideWhenEmpty(T){this.p=T,this.t.queue(async()=>this.q.$updateGroup(this.u,this.handle,this.features))}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(T){this.f=[...T],this.k.fire()}constructor(T,G,q,V,N,L,Z,re){this.q=T,this.s=G,this.t=q,this.u=V,this.v=N,this.w=L,this.multiDiffEditorEnableViewChanges=Z,this.x=re,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new R.$he,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new R.$he,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=k.d++}getResourceState(T){return this.g.get(T)}$executeResourceCommand(T,G){const q=this.h.get(T);return q?(0,A.$sh)(()=>this.s.executeCommand(q.command,...q.arguments||[],G)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const T=[...this.f].sort(b),q=(0,$.$Db)(this.o,T,b).map(L=>{const Z=L.toInsert.map(re=>{const fe=this.e++;this.g.set(fe,re);const be=re.resourceUri;let oe;if(re.command)if(re.command.command==="vscode.open"||re.command.command==="vscode.diff"||re.command.command==="vscode.changes"){const Y=new O.$Tc;oe=this.s.converter.toInternal(re.command,Y),this.j.set(fe,Y)}else this.h.set(fe,re.command);const pe=(0,r.$TG)(this.x,"scmMultiDiffEditor"),$e=pe?re.multiDiffEditorOriginalUri:void 0,se=pe?re.multiFileDiffEditorModifiedUri:void 0,Ce=n(re.decorations),Fe=re.decorations&&n(re.decorations.light)||Ce,X=re.decorations&&n(re.decorations.dark)||Ce,W=[Fe,X],ie=re.decorations&&re.decorations.tooltip||"",Se=re.decorations&&!!re.decorations.strikeThrough,he=re.decorations&&!!re.decorations.faded,we=re.contextValue||"";return{rawResource:[fe,be,W,ie,Se,he,we,oe,$e,se],handle:fe}});return{start:L.start,deleteCount:L.deleteCount,toInsert:Z}}),V=q.map(({start:L,deleteCount:Z,toInsert:re})=>[L,Z,re.map(fe=>fe.rawResource)]),N=q.reverse();for(const{start:L,deleteCount:Z,toInsert:re}of N){const fe=re.map(oe=>oe.handle),be=this.n.splice(L,Z,...fe);for(const oe of be)this.g.delete(oe),this.h.delete(oe),this.j.get(oe)?.dispose(),this.j.delete(oe)}return this.o=T,V}dispose(){this.l=!0,this.m.fire()}}class m{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.g}get count(){return this.h}set count(T){this.h!==T&&(this.h=T,this.e.queue(async()=>this.#e.$updateSourceControl(this.x,{count:T})))}get quickDiffProvider(){return this.j}set quickDiffProvider(T){this.j=T;let G;(0,r.$TG)(this.y,"quickDiffProvider")&&(G=T?.label),this.e.queue(async()=>this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!T,quickDiffLabel:G}))}get historyProvider(){return(0,r.$UG)(this.y,"scmHistoryProvider"),this.k}set historyProvider(T){(0,r.$UG)(this.y,"scmHistoryProvider"),this.k=T,this.l.value=new O.$Tc,this.e.queue(async()=>this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!T})),T&&this.l.value.add(T.onDidChangeCurrentHistoryItemGroup(()=>{this.m=T?.currentHistoryItemGroup,this.e.queue(async()=>this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.m))}))}get commitTemplate(){return this.n}set commitTemplate(T){T!==this.n&&(this.n=T,this.e.queue(async()=>this.#e.$updateSourceControl(this.x,{commitTemplate:T})))}get acceptInputCommand(){return this.p}set acceptInputCommand(T){this.o.value=new O.$Tc,this.p=T;const G=this.z.converter.toInternal(T,this.o.value);this.e.queue(async()=>this.#e.$updateSourceControl(this.x,{acceptInputCommand:G}))}get actionButton(){return(0,r.$UG)(this.y,"scmActionButton"),this.s}set actionButton(T){(0,r.$UG)(this.y,"scmActionButton"),this.q.value=new O.$Tc,this.s=T;const G=T!==void 0?{command:this.z.converter.toInternal(T.command,this.q.value),secondaryCommands:T.secondaryCommands?.map(q=>q.map(V=>this.z.converter.toInternal(V,this.q.value))),description:T.description,enabled:T.enabled}:void 0;this.e.queue(async()=>this.#e.$updateSourceControl(this.x,{actionButton:G??null}))}get statusBarCommands(){return this.u}set statusBarCommands(T){if(this.u&&T&&y(this.u,T))return;this.t.value=new O.$Tc,this.u=T;const G=(T||[]).map(q=>this.z.converter.toInternal(q,this.t.value));this.e.queue(async()=>this.#e.$updateSourceControl(this.x,{statusBarCommands:G}))}get selected(){return this.v}constructor(T,G,q,V,N,L,Z){this.y=T,this.z=V,this.A=N,this.B=L,this.C=Z,this.e=new A.$vh,this.f=new Map,this.h=void 0,this.j=void 0,this.l=new O.$Vc,this.n=void 0,this.o=new O.$Vc,this.p=void 0,this.q=new O.$Vc,this.t=new O.$Vc,this.u=void 0,this.v=!1,this.w=new R.$he,this.onDidChangeSelection=this.w.event,this.x=m.d++,this.D=new Map,this.E=new Set,this.#e=q;const re=E.URI.from({scheme:o.Schemas.vscodeSourceControl,path:`${N}/scm${this.x}/input`,query:Z?`rootUri=${encodeURIComponent(Z.toString())}`:void 0});this.e.queue(()=>this.#e.$registerSourceControl(this.x,N,L,Z,re)),this.g=new p(T,G,this.#e,this.e,this.x,re)}createResourceGroup(T,G,q){const V=(0,r.$TG)(this.y,"scmMultiDiffEditor")&&q?.multiDiffEditorEnableViewChanges===!0,N=new k(this.#e,this.z,this.e,this.x,T,G,V,this.y),L=R.Event.once(N.onDidDispose)(()=>this.D.delete(N));return this.D.set(N,L),this.eventuallyAddResourceGroups(),N}eventuallyAddResourceGroups(){const T=[],G=[];for(const[q,V]of this.D){V.dispose();const N=q.onDidUpdateResourceStates(()=>{this.E.add(q),this.eventuallyUpdateResourceStates()});R.Event.once(q.onDidDispose)(()=>{this.E.delete(q),N.dispose(),this.f.delete(q.handle),this.e.queue(async()=>this.#e.$unregisterGroup(this.x,q.handle))}),T.push([q.handle,q.id,q.label,q.features,q.multiDiffEditorEnableViewChanges]);const L=q._takeResourceStateSnapshot();L.length>0&&G.push([q.handle,L]),this.f.set(q.handle,q)}this.e.queue(async()=>this.#e.$registerGroups(this.x,T,G)),this.D.clear()}eventuallyUpdateResourceStates(){const T=[];this.E.forEach(G=>{const q=G._takeResourceStateSnapshot();q.length!==0&&T.push([G.handle,q])}),T.length>0&&this.e.queue(async()=>this.#e.$spliceResourceStates(this.x,T)),this.E.clear()}getResourceGroup(T){return this.f.get(T)}setSelectionState(T){this.v=T,this.w.fire(T)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.f.forEach(T=>T.dispose()),this.e.queue(async()=>this.#e.$unregisterSourceControl(this.x))}}He([(0,P.$6h)(100)],m.prototype,"eventuallyAddResourceGroups",null),He([(0,P.$6h)(100)],m.prototype,"eventuallyUpdateResourceStates",null);let w=class{static{h=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(T,G,q,V){this.l=G,this.m=q,this.n=V,this.g=new Map,this.h=new v.$Ym,this.j=new R.$he,this.e=T.getProxy(M.$uM.MainThreadSCM),this.f=T.getProxy(M.$uM.MainThreadTelemetry),G.registerArgumentProcessor({processArgument:N=>{if(N&&N.$mid===u.MarshalledId.ScmResource){const L=this.g.get(N.sourceControlHandle);if(!L)return N;const Z=L.getResourceGroup(N.groupHandle);return Z?Z.getResourceState(N.handle):N}else if(N&&N.$mid===u.MarshalledId.ScmResourceGroup){const L=this.g.get(N.sourceControlHandle);return L?L.getResourceGroup(N.groupHandle):N}else if(N&&N.$mid===u.MarshalledId.ScmProvider){const L=this.g.get(N.handle);return L||N}return N}})}createSourceControl(T,G,q,V){this.n.trace("ExtHostSCM#createSourceControl",T.identifier.value,G,q,V),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:T.identifier.value});const N=h.d++,L=new m(T,this.m,this.e,this.l,G,q,V);this.g.set(N,L);const Z=this.h.get(T.identifier)||[];return Z.push(L),this.h.set(T.identifier,Z),L}getLastInputBox(T){this.n.trace("ExtHostSCM#getLastInputBox",T.identifier.value);const G=this.h.get(T.identifier),q=G&&G[G.length-1];return q&&q.inputBox}$provideOriginalResource(T,G,q){const V=E.URI.revive(G);this.n.trace("ExtHostSCM#$provideOriginalResource",T,V.toString());const N=this.g.get(T);return!N||!N.quickDiffProvider||!N.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$sh)(()=>N.quickDiffProvider.provideOriginalResource(V,q)).then(L=>L||null)}$onInputBoxValueChange(T,G){this.n.trace("ExtHostSCM#$onInputBoxValueChange",T);const q=this.g.get(T);return q&&q.inputBox.$onInputBoxValueChange(G),Promise.resolve(void 0)}$executeResourceCommand(T,G,q,V){this.n.trace("ExtHostSCM#$executeResourceCommand",T,G,q);const N=this.g.get(T);if(!N)return Promise.resolve(void 0);const L=N.getResourceGroup(G);return L?L.$executeResourceCommand(q,V):Promise.resolve(void 0)}$validateInput(T,G,q){this.n.trace("ExtHostSCM#$validateInput",T);const V=this.g.get(T);return!V||!V.inputBox.validateInput?Promise.resolve(void 0):(0,A.$sh)(()=>V.inputBox.validateInput(G,q)).then(N=>{if(!N)return Promise.resolve(void 0);const L=d.MarkdownString.fromStrict(N.message);return L?Promise.resolve([L,N.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(T){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",T),T!==void 0&&this.g.get(T)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=T,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(T,G,q,V){return await this.g.get(T)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(G,q,V)??void 0}async $provideHistoryItems(T,G,q,V){return(await this.g.get(T)?.historyProvider?.provideHistoryItems(G,q,V))?.map(Z=>({...Z,icon:i(Z)}))??void 0}async $provideHistoryItemSummary(T,G,q,V){const N=this.g.get(T)?.historyProvider;if(typeof N?.provideHistoryItemSummary!="function")return;const L=await N.provideHistoryItemSummary(G,q,V);return L?{...L,icon:i(L)}:void 0}async $provideHistoryItemChanges(T,G,q,V){return await this.g.get(T)?.historyProvider?.provideHistoryItemChanges(G,q,V)??void 0}};e.$uoc=w,e.$uoc=w=h=He([Ve(3,C.$7j)],w)}),define(ke[294],Ie([1,0,5,10,2]),function(de,e,E,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$voc=void 0;class O{static{this.a=0}constructor(M,$){this.d=$,this.c=new Map,this.b=M.getProxy(E.$uM.MainThreadShare)}async $provideShare(M,$,c){return await this.c.get(M)?.provideShare({selection:R.Range.to($.selection),resourceUri:P.URI.revive($.resourceUri)},c)??void 0}registerShareProvider(M,$){const c=O.a++;return this.c.set(c,$),this.b.$registerShareProvider(c,R.DocumentSelector.from(M,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(c),this.c.delete(c)}}}}e.$voc=O}),define(ke[295],Ie([1,0,7,5,185,6,10,15]),function(de,e,E,R,P,O,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yoc=e.$xoc=void 0;class ${static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new E.$uN("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new E.$uN("statusBarItem.warningForeground")]])}#e;#t;constructor(u,D,d,r,o,a=E.StatusBarAlignment.Left,h){if(this.i=!1,this.k="",this.q=new O.$Tc,this.#e=u,this.#t=D,o&&r){this.c=(0,E.$9M)(r.identifier,o);const t=d.get(this.c);t&&(a=t.alignLeft?E.StatusBarAlignment.Left:E.StatusBarAlignment.Right,h=t.priority,this.j=!0,this.name=t.name,this.text=t.text,this.tooltip=t.tooltip,this.command=t.command,this.accessibilityInformation=t.accessibilityInformation)}else this.c=String($.a++);this.e=r,this.f=o,this.g=a,this.h=this.u(h)}u(u){if((0,M.$eg)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(u){this.k=u,this.v()}set name(u){this.m=u,this.v()}set tooltip(u){this.l=u,this.v()}set color(u){this.n=u,this.v()}set backgroundColor(u){u&&!$.b.has(u.id)&&(u=void 0),this.o=u,this.v()}set command(u){this.r?.fromApi!==u&&(this.p&&this.q.add(this.p),this.p=new O.$Tc,typeof u=="string"?this.r={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this.p)}:u?this.r={fromApi:u,internal:this.#t.toInternal(u,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(u){this.t=u,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let u;this.e?this.f?u=`${this.e.identifier.value}.${this.f}`:u=this.e.identifier.value:u=this.f;let D;this.m?D=this.m:D=(0,P.localize)(0,null,this.e.displayName||this.e.name);let d=this.n;this.o&&(d=$.b.get(this.o.id));const r=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,u,this.e?.identifier.value,D,this.k,r,this.r?.internal,d,this.o,this.g===E.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$xoc=$;class c{constructor(u){this.b=[],this.a=u.createStatusBarEntry(void 0,"status.extensionMessage",E.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,P.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(u){const D={message:u};return this.b.unshift(D),this.c(),new E.$wM(()=>{const d=this.b.indexOf(D);d>=0&&(this.b.splice(d,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class C{constructor(u,D){this.e=new Map,this.a=u.getProxy(R.$uM.MainThreadStatusBar),this.b=D,this.c=new c(this)}$acceptStaticEntries(u){for(const D of u)this.e.set(D.entryId,D)}createStatusBarEntry(u,D,d,r){return new $(this.a,this.b,this.e,u,D,d,r)}setStatusBarMessage(u,D){const d=this.c.setMessage(u);let r;return typeof D=="number"?r=setTimeout(()=>d.dispose(),D):typeof D<"u"&&D.then(()=>d.dispose(),()=>d.dispose()),new E.$wM(()=>{d.dispose(),clearTimeout(r)})}}e.$yoc=C}),define(ke[123],Ie([1,0,33,114,55,82,56,10,2]),function(de,e,E,R,P,O,A,M,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bP=e.$aP=e.$_O=e.$$O=void 0;const c=(t,s,n,i)=>{let g=s;return{enumerable:!0,configurable:!1,get(){return g},set(f){if(!n(g,f)){const l=g;g=f,t.listener?.(i(f,l))}}}},C=(t,s)=>t===s,v={range:(t,s)=>t===s?!0:!t||!s?!1:t.isEqual(s),label:C,description:C,sortText:C,busy:C,error:C,canResolveChildren:C,tags:(t,s)=>!(t.length!==s.length||t.some(n=>!s.find(i=>n.id===i.id)))},u=t=>s=>({op:O.TestItemEventOp.SetProp,update:t(s)}),D=(t,s)=>({range:(()=>{let n;const i=u(g=>({range:E.$ct.lift(M.Range.from(g))}));return{enumerable:!0,configurable:!1,get(){return n},set(g){t.listener?.({op:O.TestItemEventOp.DocumentSynced}),v.range(n,g)||(n=g,t.listener?.(i(g)))}}})(),label:c(t,s,v.label,u(n=>({label:n}))),description:c(t,void 0,v.description,u(n=>({description:n}))),sortText:c(t,void 0,v.sortText,u(n=>({sortText:n}))),canResolveChildren:c(t,!1,v.canResolveChildren,n=>({op:O.TestItemEventOp.UpdateCanResolveChildren,state:n})),busy:c(t,!1,v.busy,u(n=>({busy:n}))),error:c(t,void 0,v.error,u(n=>({error:M.MarkdownString.fromStrict(n)||null}))),tags:c(t,[],v.tags,(n,i)=>({op:O.TestItemEventOp.SetTags,new:n.map(M.TestTag.from),old:i.map(M.TestTag.from)}))}),d=t=>{const s=P.$gL.fromString(t.extId),n=new o(s.controllerId,s.localId,t.label,$.URI.revive(t.uri)||void 0);return n.range=M.Range.to(t.range||void 0),n.description=t.description||void 0,n.sortText=t.sortText||void 0,n.tags=t.tags.map(i=>M.TestTag.to({id:(0,A.$mL)(i).tagId})),n},r=t=>{let s;for(const n of t.tests){const i=d(n.item);(0,R.$UO)(i).parent=s,s=i}return s};e.$$O=r;class o{constructor(s,n,i,g){if(n.includes(P.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(n)} symbol`);const f=(0,R.$TO)(this,s);Object.defineProperties(this,{id:{value:n,enumerable:!0,writable:!1},uri:{value:g,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return f.parent instanceof a?void 0:f.parent}},children:{value:(0,O.$SO)(f,R.$UO,o),enumerable:!0,writable:!1},...D(f,i)})}}e.$_O=o;class a extends o{constructor(s,n){super(s,s,n,void 0),this._isRoot=!0}}e.$aP=a;class h extends O.$OO{constructor(s,n,i){super({controllerId:s,getDocumentVersion:g=>g&&i.getDocument(g)?.version,getApiFor:R.$UO,getChildren:g=>g.children,root:new a(s,n),toITestItem:M.TestItem.from})}}e.$bP=h}),define(ke[39],Ie([1,0,15,7,10,26,5,18,12,49,33,100,2,6,3,17,123,23,38,48,69,63,66,36]),function(de,e,E,R,P,O,A,M,$,c,C,v,u,D,d,r,o,a,h,t,s,n,i,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mP=e.$lP=e.$kP=e.$jP=e.$iP=e.$hP=void 0;let f=class{#e;#t;#i;constructor(p,k,m){this.b=new Map,this.c=new Map,this.#e=p.getProxy(A.$uM.MainThreadCommands),this.d=k,this.#i=m,this.#t=p.getProxy(A.$uM.MainThreadTelemetry),this.converter=new l(this,w=>{const F=this.c.get(w);return F?.result===I.Void?F:void 0},k),this.f=[{processArgument(w){return(0,c.$0h)(w)}},{processArgument(w){return(0,O.$$n)(w,function(F){if(C.$ct.isIRange(F))return P.Range.to(F);if(v.$bt.isIPosition(F))return P.Position.to(F);if(C.$ct.isIRange(F.range)&&u.URI.isUri(F.uri))return P.location.to(F);if(F instanceof a.$Je)return F.buffer.buffer;if(!Array.isArray(F))return F})}}]}registerArgumentProcessor(p){this.f.push(p)}registerApiCommand(p){const k=this.registerCommand(!1,p.id,async(...m)=>{const w=p.args.map((T,G)=>{if(!T.validate(m[G]))throw new Error(`Invalid argument '${T.name}' when running '${p.id}', received: ${typeof m[G]=="object"?JSON.stringify(m[G],null,"	"):m[G]} `);return T.convert(m[G])}),F=await this.executeCommand(p.internalId,...w);return p.result.convert(F,m,this.converter)},void 0,{description:p.description,args:p.args,returns:p.result.description});return this.c.set(p.id,p),new R.$wM(()=>{k.dispose(),this.c.delete(p.id)})}registerCommand(p,k,m,w,F,T){if(this.d.trace("ExtHostCommands#registerCommand",k),!k.trim().length)throw new Error("invalid id");if(this.b.has(k))throw new Error(`command '${k}' already exists`);return this.b.set(k,{callback:m,thisArg:w,metadata:F,extension:T}),p&&this.#e.$registerCommand(k),new R.$wM(()=>{this.b.delete(k)&&p&&this.#e.$unregisterCommand(k)})}executeCommand(p,...k){return this.d.trace("ExtHostCommands#executeCommand",p),this.g(p,k,!0)}async g(p,k,m){if(this.b.has(p))return this.#e.$fireCommandActivationEvent(p),this.h(p,k,!1);{let w=!1;const F=(0,O.$$n)(k,function(T){if(T instanceof R.$xM)return P.Position.from(T);if(T instanceof R.$yM)return P.Range.from(T);if(T instanceof R.$IM)return P.location.from(T);if(R.$YN.isNotebookRange(T))return P.NotebookRange.from(T);if(T instanceof ArrayBuffer)return w=!0,a.$Je.wrap(new Uint8Array(T));if(T instanceof Uint8Array)return w=!0,a.$Je.wrap(T);if(T instanceof a.$Je)return w=!0,T;if(!Array.isArray(T))return T});try{const T=await this.#e.$executeCommand(p,w?new h.$Kw(F):F,m);return(0,c.$0h)(T)}catch(T){if(T instanceof Error&&T.message==="$executeCommand:retry")return this.g(p,k,!1);throw T}}}async h(p,k,m){const w=this.b.get(p);if(!w)throw new Error("Unknown command");const{callback:F,thisArg:T,metadata:G}=w;if(G?.args)for(let V=0;V<G.args.length;V++)try{(0,E.$rg)(k[V],G.args[V].constraint)}catch{throw new Error(`Running the contributed command: '${p}' failed. Illegal argument '${G.args[V].name}' - ${G.args[V].description}`)}const q=s.$be.create();try{return await F.apply(T,k)}catch(V){if(p===this.converter.delegatingCommandId){const N=this.converter.getActualCommand(...k);N&&(p=N.command)}if(this.d.error(V,p,w.extension?.identifier),!m)throw V;if(w.extension?.identifier){const N=this.#i.onExtensionError(w.extension.identifier,V);this.d.trace("forwarded error to extension?",N,w.extension?.identifier)}throw new class extends Error{constructor(){super((0,t.$lj)(V)),this.id=p,this.source=w.extension?.displayName??w.extension?.name}}}finally{this.j(w,p,q.elapsed())}}j(p,k,m){p.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:p.extension.identifier.value,id:new n.$np(k),duration:m})}$executeContributedCommand(p,...k){this.d.trace("ExtHostCommands#$executeContributedCommand",p);const m=this.b.get(p);return m?(k=k.map(w=>this.f.reduce((F,T)=>T.processArgument(F,m.extension?.identifier),w)),this.h(p,k,!0)):Promise.reject(new Error(`Contributed command '${p}' does not exist.`))}getCommands(p=!1){return this.d.trace("ExtHostCommands#getCommands",p),this.#e.$getCommands().then(k=>(p&&(k=k.filter(m=>m[0]!=="_")),k))}$getContributedCommandMetadata(){const p=Object.create(null);for(const[k,m]of this.b){const{metadata:w}=m;w&&(p[k]=w)}return Promise.resolve(p)}};e.$hP=f,e.$hP=f=He([Ve(0,r.$YO),Ve(1,$.$7j),Ve(2,i.$gP)],f),e.$iP=(0,d.$Ai)("IExtHostCommands");class l{constructor(p,k,m){this.d=p,this.f=k,this.g=m,this.delegatingCommandId=`__vsc${(0,g.$Wg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(p,k){if(!p)return;const m={$ident:void 0,id:p.command,title:p.title,tooltip:p.tooltip};if(!p.command)return m;const w=this.f(p.command);if(w)m.id=w.internalId,m.arguments=w.args.map((F,T)=>F.convert(p.arguments&&p.arguments[T]));else if((0,M.$Lb)(p.arguments)){const F=`${p.command} /${++this.c}`;this.b.set(F,p),k.add((0,D.$Sc)(()=>{this.b.delete(F),this.g.trace("CommandsConverter#DISPOSE",F)})),m.$ident=F,m.id=this.delegatingCommandId,m.arguments=[F],this.g.trace("CommandsConverter#CREATE",p.command,F)}return m}fromInternal(p){return typeof p.$ident=="string"?this.b.get(p.$ident):{command:p.id,title:p.title,arguments:p.arguments}}getActualCommand(...p){return this.b.get(p[0])}h(...p){const k=this.getActualCommand(...p);return this.g.trace("CommandsConverter#EXECUTE",p[0],k?k.command:"MISSING"),k?this.d.executeCommand(k.command,...k.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${p[0]}`)}}e.$jP=l;class b{static{this.Uri=new b("uri","Uri of a text document",p=>u.URI.isUri(p),p=>p)}static{this.Position=new b("position","A position in a text document",p=>R.$xM.isPosition(p),P.Position.from)}static{this.Range=new b("range","A range in a text document",p=>R.$yM.isRange(p),P.Range.from)}static{this.Selection=new b("selection","A selection in a text document",p=>R.$zM.isSelection(p),P.Selection.from)}static{this.Number=new b("number","",p=>typeof p=="number",p=>p)}static{this.String=new b("string","",p=>typeof p=="string",p=>p)}static{this.StringArray=b.Arr(b.String)}static Arr(p){return new b(`${p.name}_array`,`Array of ${p.name}, ${p.description}`,k=>Array.isArray(k)&&k.every(m=>p.validate(m)),k=>k.map(m=>p.convert(m)))}static{this.CallHierarchyItem=new b("item","A call hierarchy item",p=>p instanceof R.$UM,P.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new b("item","A type hierarchy item",p=>p instanceof R.$gO,P.TypeHierarchyItem.from)}static{this.TestItem=new b("testItem","A VS Code TestItem",p=>p instanceof o.$_O,P.TestItem.from)}constructor(p,k,m,w){this.name=p,this.description=k,this.validate=m,this.convert=w}optional(){return new b(this.name,`(optional) ${this.description}`,p=>p==null||this.validate(p),p=>p===void 0?void 0:p===null?null:this.convert(p))}with(p,k){return new b(p??this.name,k??this.description,this.validate,this.convert)}}e.$kP=b;class I{static{this.Void=new I("no result",p=>p)}constructor(p,k){this.description=p,this.convert=k}}e.$lP=I;class S{constructor(p,k,m,w,F){this.id=p,this.internalId=k,this.description=m,this.args=w,this.result=F}}e.$mP=S}),define(ke[296],Ie([1,0,18,16,2,94,103,32,39,10,7]),function(de,e,E,R,P,O,A,M,$,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tmc=void 0;const v=[new $.$mP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$kP.Uri,$.$kP.Position],new $.$lP("A promise that resolves to an array of DocumentHighlight-instances.",D(c.DocumentHighlight.to))),new $.$mP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$kP.Uri],new $.$lP("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,o)=>{if((0,E.$Kb)(r))return;class a extends C.$PM{static to(t){const s=new a(t.name,c.SymbolKind.to(t.kind),t.containerName||"",new C.$IM(o[0],c.Range.to(t.range)));return s.detail=t.detail,s.range=s.location.range,s.selectionRange=c.Range.to(t.selectionRange),s.children=t.children?t.children.map(a.to):[],s}}return r.map(a.to)})),new $.$mP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$kP.Uri,new $.$kP("options","Formatting options",r=>!0,r=>r)],new $.$lP("A promise that resolves to an array of TextEdits.",D(c.TextEdit.to))),new $.$mP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$kP.Uri,$.$kP.Range,new $.$kP("options","Formatting options",r=>!0,r=>r)],new $.$lP("A promise that resolves to an array of TextEdits.",D(c.TextEdit.to))),new $.$mP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$kP.Uri,$.$kP.Position,new $.$kP("ch","Trigger character",r=>typeof r=="string",r=>r),new $.$kP("options","Formatting options",r=>!0,r=>r)],new $.$lP("A promise that resolves to an array of TextEdits.",D(c.TextEdit.to))),new $.$mP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$kP.Uri,$.$kP.Position],new $.$lP("A promise that resolves to an array of Location or LocationLink instances.",d)),new $.$mP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$kP.Uri,$.$kP.Position],new $.$lP("A promise that resolves to an array of Location or LocationLink instances.",d)),new $.$mP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$kP.Uri,$.$kP.Position],new $.$lP("A promise that resolves to an array of Location or LocationLink instances.",d)),new $.$mP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$kP.Uri,$.$kP.Position],new $.$lP("A promise that resolves to an array of Location or LocationLink instances.",d)),new $.$mP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$kP.Uri,$.$kP.Position],new $.$lP("A promise that resolves to an array of Location-instances.",D(c.location.to))),new $.$mP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$kP.Uri,$.$kP.Position],new $.$lP("A promise that resolves to an array of Hover-instances.",D(c.Hover.to))),new $.$mP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$kP.Uri,new $.$kP("position","A position in a text document",r=>Array.isArray(r)&&r.every(o=>C.$xM.isPosition(o)),r=>r.map(c.Position.from))],new $.$lP("A promise that resolves to an array of ranges.",r=>r.map(o=>{let a;for(const h of o.reverse())a=new C.$TM(c.Range.to(h),a);return a}))),new $.$mP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$kP.String.with("query","Search string")],new $.$lP("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(c.WorkspaceSymbol.to))),new $.$mP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$kP.Uri,$.$kP.Position],new $.$lP("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(c.CallHierarchyItem.to))),new $.$mP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$kP.CallHierarchyItem],new $.$lP("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(c.CallHierarchyIncomingCall.to))),new $.$mP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$kP.CallHierarchyItem],new $.$lP("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(c.CallHierarchyOutgoingCall.to))),new $.$mP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$kP.Uri,$.$kP.Position],new $.$lP("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:c.Range.to(r.range),placeholder:r.text}})),new $.$mP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$kP.Uri,$.$kP.Position,$.$kP.String.with("newName","The new symbol name")],new $.$lP("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return c.WorkspaceEdit.to(r)}})),new $.$mP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$kP.Uri,$.$kP.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$lP("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(c.DocumentLink.to))),new $.$mP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$kP.Uri],new $.$lP("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new C.$PN(r.tokenTypes,r.tokenModifiers)})),new $.$mP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$kP.Uri],new $.$lP("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const o=(0,A.$6bb)(r);if(o.type==="full")return new C.$RN(o.data,void 0)})),new $.$mP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$kP.Uri,$.$kP.Range.optional()],new $.$lP("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new C.$PN(r.tokenTypes,r.tokenModifiers)})),new $.$mP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$kP.Uri,$.$kP.Range],new $.$lP("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const o=(0,A.$6bb)(r);if(o.type==="full")return new C.$RN(o.data,void 0)})),new $.$mP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$kP.Uri,$.$kP.Position,$.$kP.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$kP.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$lP("A promise that resolves to a CompletionList-instance.",(r,o,a)=>{if(!r)return new C.$6M([]);const h=r.suggestions.map(t=>c.CompletionItem.to(t,a));return new C.$6M(h,r.incomplete)})),new $.$mP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$kP.Uri,$.$kP.Position,$.$kP.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$lP("A promise that resolves to SignatureHelp.",r=>{if(r)return c.SignatureHelp.to(r)})),new $.$mP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$kP.Uri,$.$kP.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$lP("A promise that resolves to an array of CodeLens-instances.",(r,o,a)=>D(h=>new C.$XM(c.Range.to(h.range),h.command&&a.fromInternal(h.command)))(r))),new $.$mP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$kP.Uri,new $.$kP("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>C.$yM.isRange(r),r=>C.$zM.isSelection(r)?c.Selection.from(r):c.Range.from(r)),$.$kP.String.with("kind","Code action kind to return code actions for").optional(),$.$kP.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$lP("A promise that resolves to an array of Command-instances.",(r,o,a)=>D(h=>{if(h._isSynthetic){if(!h.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(h.command)}else{const t=new C.$RM(h.title,h.kind?new C.$SM(h.kind):void 0);return h.edit&&(t.edit=c.WorkspaceEdit.to(h.edit)),h.command&&(t.command=a.fromInternal(h.command)),t.isPreferred=h.isPreferred,t}})(r))),new $.$mP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$kP.Uri],new $.$lP("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(o=>new C.$_M(c.Range.to(o.range),c.Color.to(o.color))):[])),new $.$mP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$kP("color","The color to show and insert",r=>r instanceof C.$$M,c.Color.from),new $.$kP("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:c.Range.from(r.range)}))],new $.$lP("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(c.ColorPresentation.to):[])),new $.$mP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$kP.Uri,$.$kP.Range],new $.$lP("A promise that resolves to an array of Inlay objects",(r,o,a)=>r.map(c.InlayHint.to.bind(void 0,a)))),new $.$mP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$kP.Uri],new $.$lP("A promise that resolves to an array of FoldingRange objects",(r,o)=>{if(r)return r.map(c.FoldingRange.to)})),new $.$mP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$lP("A promise that resolves to an array of NotebookContentProvider static info objects.",D(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(o=>c.NotebookExclusiveDocumentPattern.to(o))})))),new $.$mP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$kP.Uri,$.$kP.Range,new $.$kP("context","An InlineValueContext",r=>r&&typeof r.frameId=="number"&&r.stoppedLocation instanceof C.$yM,r=>c.InlineValueContext.from(r))],new $.$lP("A promise that resolves to an array of InlineValue objects",r=>r.map(c.InlineValue.to))),new $.$mP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$kP("uriOrString","Uri-instance or string (only http/https)",r=>P.URI.isUri(r)||typeof r=="string"&&(0,R.$Kg)(r,R.Schemas.http,R.Schemas.https),r=>r),new $.$kP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[c.ViewColumn.from(r),void 0]:[c.ViewColumn.from(r.viewColumn),c.TextEditorOpenOptions.from(r)])).optional(),$.$kP.String.with("label","").optional()],$.$lP.Void),new $.$mP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$kP.Uri.with("resource","Resource to open"),$.$kP.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$kP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[c.ViewColumn.from(r),void 0]:[c.ViewColumn.from(r.viewColumn),c.TextEditorOpenOptions.from(r)])).optional()],$.$lP.Void),new $.$mP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$kP.Uri.with("left","Left-hand side resource of the diff editor"),$.$kP.Uri.with("right","Right-hand side resource of the diff editor"),$.$kP.String.with("title","Human readable title for the diff editor").optional(),new $.$kP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[c.ViewColumn.from(r.viewColumn),c.TextEditorOpenOptions.from(r)]).optional()],$.$lP.Void),new $.$mP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$kP.String.with("title","Human readable title for the changes editor"),new $.$kP("resourceList","List of resources to compare",r=>{for(const o of r){if(o.length!==3)return!1;const[a,h,t]=o;if(!P.URI.isUri(a)||!P.URI.isUri(h)&&h!==void 0&&h!==null||!P.URI.isUri(t)&&t!==void 0&&t!==null)return!1}return!0},r=>r)],$.$lP.Void),new $.$mP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$kP.Uri,$.$kP.Position],new $.$lP("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(c.TypeHierarchyItem.to))),new $.$mP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$kP.TypeHierarchyItem],new $.$lP("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(c.TypeHierarchyItem.to))),new $.$mP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$kP.TypeHierarchyItem],new $.$lP("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(c.TypeHierarchyItem.to))),new $.$mP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$kP.TestItem],$.$lP.Void),new $.$mP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$kP.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$lP.Void),new $.$mP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$kP.String.with("name","The context key name"),new $.$kP("value","The context key value",()=>!0,r=>r)],$.$lP.Void),new $.$mP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$kP.Uri,$.$kP.StringArray,new $.$kP("MappedEditsContext","Mapped Edits Context",r=>c.MappedEditsContext.is(r),r=>c.MappedEditsContext.from(r))],new $.$lP("A promise that resolves to a workspace edit or null",r=>r?c.WorkspaceEdit.to(r):null)),new $.$mP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new $.$kP("Run arguments","",r=>!0,r=>{if(r)return{initialRange:r.initialRange?c.Range.from(r.initialRange):void 0,initialSelection:C.$zM.isSelection(r.initialSelection)?c.Selection.from(r.initialSelection):void 0,message:r.message,autoSend:r.autoSend,position:r.position?c.Position.from(r.position):void 0}})],$.$lP.Void)];class u{static register(o){v.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",M.$zj)}}e.$Tmc=u;function D(r){return o=>{if(Array.isArray(o))return o.map(r)}}function d(r){if(!Array.isArray(r))return;const o=[];for(const a of r)O.$Lv(a)?o.push(c.DefinitionLink.to(a)):o.push(c.location.to(a));return o}}),define(ke[297],Ie([1,0,2,39]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$doc=void 0;class P{constructor(A,M,$,c,C){this.a=M,this.b=$,this.c=c;const v=new R.$mP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new R.$kP("showOptions","Show Options",u=>!0,u=>u),new R.$kP("resource","Interactive resource Uri",u=>!0,u=>u),new R.$kP("controllerId","Notebook controller Id",u=>!0,u=>u),new R.$kP("title","Interactive editor title",u=>!0,u=>u)],new R.$lP("Notebook and input URI",u=>{if(C.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const D=this.a.getEditorById(u.notebookEditorId);return C.debug("[ExtHostInteractive] notebook editor found",D.id),{notebookUri:E.URI.revive(u.notebookUri),inputUri:E.URI.revive(u.inputUri),notebookEditor:D.apiEditor}}return C.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:E.URI.revive(u.notebookUri),inputUri:E.URI.revive(u.inputUri)}}));this.c.registerApiCommand(v)}$willAddInteractiveDocument(A,M,$,c){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:M,lines:[""],languageId:$,uri:A,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(A,M){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$doc=P}),define(ke[298],Ie([1,0,18,11,22,4,6,29,2,19,12,5,39,10,7,83,237,25,38,238]),function(de,e,E,R,P,O,A,M,$,c,C,v,u,D,d,r,o,a,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$koc=void 0,e.$loc=b;let s=class{constructor(S,y,p,k,m){this.m=y,this.n=p,this.o=k,this.q=m,this.b=new M.$Ac,this.c=new M.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new O.$he,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=S.getProxy(v.$uM.MainThreadNotebookKernels);const w=new u.$mP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.$kP("options","Select kernel options",T=>!0,T=>{if(T&&"notebookEditor"in T&&"id"in T){const G=this.n.getIdByEditor(T.notebookEditor);return{id:T.id,extension:T.extension,notebookEditorId:G}}else if(T&&"notebookEditor"in T){const G=this.n.getIdByEditor(T.notebookEditor);if(G===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${T.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:G}}return T})],u.$lP.Void),F=new u.$mP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[u.$kP.Uri],new u.$lP("A promise that resolves to an array of variables",(T,G)=>T.map(q=>({variable:{name:q.name,value:q.value,expression:q.expression,type:q.type,language:q.language},hasNamedChildren:q.hasNamedChildren,indexedChildrenCount:q.indexedChildrenCount}))));this.o.registerApiCommand(w),this.o.registerApiCommand(F)}createNotebookController(S,y,p,k,m,w){for(const se of this.j.values())if(se.controller.id===y&&c.$Wm.equals(S.identifier,se.extensionId))throw new Error(`notebook controller with id '${y}' ALREADY exist`);const F=this.k++,T=this;this.q.trace(`NotebookController[${F}], CREATED by ${S.identifier.value}, ${y}`);const G=()=>console.warn(`NO execute handler from notebook controller '${L.id}' of extension: '${S.identifier}'`);let q=!1;const V=new O.$he,N=new O.$he,L={id:b(S.identifier,y),notebookType:p,extensionId:S.identifier,extensionLocation:S.extensionLocation,label:k||S.identifier.value,preloads:w?w.map(D.NotebookRendererScript.from):[]};let Z=m??G,re,fe;this.a.$addKernel(F,L).catch(se=>{console.log(se),q=!0});let be=0;const oe=()=>{if(q)return;const se=++be;Promise.resolve().then(()=>{se===be&&this.a.$updateKernel(F,L)})},pe=new M.$Ac,$e={get id(){return y},get notebookType(){return L.notebookType},onDidChangeSelectedNotebooks:V.event,get label(){return L.label},set label(se){L.label=se??S.displayName??S.name,oe()},get detail(){return L.detail??""},set detail(se){L.detail=se,oe()},get description(){return L.description??""},set description(se){L.description=se,oe()},get supportedLanguages(){return L.supportedLanguages},set supportedLanguages(se){L.supportedLanguages=se,oe()},get supportsExecutionOrder(){return L.supportsExecutionOrder??!1},set supportsExecutionOrder(se){L.supportsExecutionOrder=se,oe()},get rendererScripts(){return L.preloads?L.preloads.map(D.NotebookRendererScript.to):[]},get executeHandler(){return Z},set executeHandler(se){Z=se??G},get interruptHandler(){return re},set interruptHandler(se){re=se,L.supportsInterrupt=!!se,oe()},set variableProvider(se){(0,a.$UG)(S,"notebookVariableProvider"),fe=se,L.hasVariableProvider=!!se,se?.onDidChangeVariables(Ce=>T.a.$variablesUpdated(Ce.uri)),oe()},get variableProvider(){return fe},createNotebookCellExecution(se){if(q)throw new Error("notebook controller is DISPOSED");if(!pe.has(se.notebook.uri))throw T.q.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(pe.keys()).map(Ce=>Ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${se.notebook.uri.toString()}`);return T._createNotebookCellExecution(se,b(S.identifier,this.id))},createNotebookExecution(se){if((0,a.$UG)(S,"notebookExecution"),q)throw new Error("notebook controller is DISPOSED");if(!pe.has(se.uri))throw T.q.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(pe.keys()).map(Ce=>Ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${se.uri.toString()}`);return T._createNotebookExecution(se,b(S.identifier,this.id))},dispose:()=>{q||(this.q.trace(`NotebookController[${F}], DISPOSED`),q=!0,this.j.delete(F),V.dispose(),N.dispose(),this.a.$removeKernel(F))},updateNotebookAffinity(se,Ce){Ce===d.NotebookControllerAffinity2.Hidden&&(0,a.$UG)(S,"notebookControllerAffinityHidden"),T.a.$updateNotebookPriority(F,se.uri,Ce)},onDidReceiveMessage:N.event,postMessage(se,Ce){return(0,a.$UG)(S,"notebookMessaging"),T.a.$postMessage(F,Ce&&T.n.getIdByEditor(Ce),se)},asWebviewUri(se){return(0,a.$UG)(S,"notebookMessaging"),(0,r.$GBb)(se,T.m.remote)}};return this.j.set(F,{extensionId:S.identifier,controller:$e,onDidReceiveMessage:N,onDidChangeSelection:V,associatedNotebooks:pe}),$e}getIdByController(S){for(const[y,p]of this.j)if(p.controller===S)return b(p.extensionId,S.id);return null}createNotebookControllerDetectionTask(S,y){const p=this.g++,k=this;this.q.trace(`NotebookControllerDetectionTask[${p}], CREATED by ${S.identifier.value}`),this.a.$addKernelDetectionTask(p,y);const m={dispose:()=>{this.f.delete(p),k.a.$removeKernelDetectionTask(p)}};return this.f.set(p,m),m}registerKernelSourceActionProvider(S,y,p){const k=this.i++,m=typeof p.onDidChangeNotebookKernelSourceActions=="function"?k:void 0,w=this;this.h.set(k,p),this.q.trace(`NotebookKernelSourceActionProvider[${k}], CREATED by ${S.identifier.value}`),this.a.$addKernelSourceActionProvider(k,k,y);let F;return m!==void 0&&(F=p.onDidChangeNotebookKernelSourceActions(T=>this.a.$emitNotebookKernelSourceActionsChangeEvent(m))),{dispose:()=>{this.h.delete(k),w.a.$removeKernelSourceActionProvider(k,k),F?.dispose()}}}async $provideKernelSourceActions(S,y){const p=this.h.get(S);if(p){const k=new A.$Tc;return(await p.provideNotebookKernelSourceActions(y)??[]).map(w=>D.NotebookKernelSourceAction.from(w,this.o.converter,k))}return[]}$acceptNotebookAssociation(S,y,p){const k=this.j.get(S);if(k){const m=this.n.getNotebookDocument($.URI.revive(y));p?k.associatedNotebooks.set(m.uri,!0):k.associatedNotebooks.delete(m.uri),this.q.trace(`NotebookController[${S}] ASSOCIATE notebook`,m.uri.toString(),p),k.onDidChangeSelection.fire({selected:p,notebook:m.apiNotebook})}}async $executeCells(S,y,p){const k=this.j.get(S);if(!k)return;const m=this.n.getNotebookDocument($.URI.revive(y)),w=[];for(const F of p){const T=m.getCell(F);T&&w.push(T.apiCell)}try{this.q.trace(`NotebookController[${S}] EXECUTE cells`,m.uri.toString(),w.length),await k.controller.executeHandler.call(k.controller,w,m.apiNotebook,k.controller)}catch(F){this.q.error(`NotebookController[${S}] execute cells FAILED`,F),console.error(F)}}async $cancelCells(S,y,p){const k=this.j.get(S);if(!k)return;const m=this.n.getNotebookDocument($.URI.revive(y));if(k.controller.interruptHandler)await k.controller.interruptHandler.call(k.controller,m.apiNotebook);else for(const w of p){const F=m.getCell(w);F&&this.b.get(F.uri)?.cancel()}if(k.controller.interruptHandler){const w=this.c.get(m.uri);this.c.delete(m.uri),p.length&&Array.isArray(w)&&w.length&&w.forEach(F=>F.dispose())}}async $provideVariables(S,y,p,k,m,w,F){const T=this.j.get(S);if(!T)return;const G=this.n.getNotebookDocument($.URI.revive(p)),q=T.controller.variableProvider;if(!q)return;let V;if(k!==void 0){if(V=this.s[k],!V)return}else this.s={};const N=m==="named"?d.NotebookVariablesRequestKind.Named:d.NotebookVariablesRequestKind.Indexed,L=q.provideVariables(G.apiNotebook,V,N,w,F);let Z=0;for await(const re of L){if(F.isCancellationRequested)return;const fe={id:this.r++,name:re.variable.name,value:re.variable.value,type:re.variable.type,interfaces:re.variable.interfaces,language:re.variable.language,expression:re.variable.expression,hasNamedChildren:re.hasNamedChildren,indexedChildrenCount:re.indexedChildrenCount,extensionId:T.extensionId.value};if(this.s[fe.id]=re.variable,this.a.$receiveVariable(y,fe),Z++>=t.$sjb)return}}$acceptKernelMessageFromRenderer(S,y,p){const k=this.j.get(S);if(!k)return;const m=this.n.getEditorById(y);k.onDidReceiveMessage.fire(Object.freeze({editor:m.apiEditor,message:p}))}$cellExecutionChanged(S,y,p){const m=this.n.getNotebookDocument($.URI.revive(S)).getCell(y);if(m){const w=p?D.NotebookCellExecutionState.to(p):d.NotebookCellExecutionState.Idle;w!==void 0&&this.l.fire({cell:m.apiCell,state:w})}}_createNotebookCellExecution(S,y){if(S.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const k=this.n.getNotebookDocument(S.notebook.uri).getCellFromApiCell(S);if(!k)throw new Error("invalid cell");if(this.b.has(k.uri))throw new Error(`duplicate execution for ${k.uri}`);const m=new i(y,k,this.a);this.b.set(k.uri,m);const w=m.onDidChangeState(()=>{m.state===n.Resolved&&(m.dispose(),w.dispose(),this.b.delete(k.uri))});return m.asApiObject()}_createNotebookExecution(S,y){const p=this.n.getNotebookDocument(S.uri),k=S.getCells().find(F=>{const T=p.getCellFromApiCell(F);return T&&this.b.has(T.uri)});if(k)throw new Error(`duplicate cell execution for ${k.document.uri}`);if(this.c.has(p.uri))throw new Error(`duplicate notebook execution for ${p.uri}`);const m=new f(y,p,this.a),w=m.onDidChangeState(()=>{m.state===g.Resolved&&(m.dispose(),w.dispose(),this.c.delete(p.uri))});return this.c.set(p.uri,[m,w]),m.asApiObject()}};e.$koc=s,e.$koc=s=He([Ve(4,C.$7j)],s);var n;(function(I){I[I.Init=0]="Init",I[I.Started=1]="Started",I[I.Resolved=2]="Resolved"})(n||(n={}));class i extends A.$Uc{static{this.a=0}get state(){return this.f}constructor(S,y,p){super(),this.m=y,this.n=p,this.b=i.a++,this.c=new O.$he,this.onDidChangeState=this.c.event,this.f=n.Init,this.g=this.B(new P.$se),this.h=new l(10,k=>this.s(k)),this.j=y.internalMetadata.executionOrder,this.n.$createExecution(this.b,S,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(S){await this.h.addItem(S)}async s(S){const y=Array.isArray(S)?S:[S];return this.n.$updateExecution(this.b,new h.$Kw(y))}t(){if(this.f===n.Init)throw new Error("Must call start before modifying cell output");if(this.f===n.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(S){let y=this.m;if(S&&(y=this.m.notebook.getCellFromApiCell(S)),!y)throw new Error("INVALID cell");return y.handle}y(S){return S.map(y=>{const p=d.$3N.ensureUniqueMimeTypes(y.items,!0);return p===y.items?D.NotebookCellOutput.from(y):D.NotebookCellOutput.from({items:p,id:y.id,metadata:y.metadata})})}async z(S,y,p){const k=this.w(y),m=this.y((0,E.$2b)(S));return this.r({editType:o.CellExecutionUpdateType.Output,cellHandle:k,append:p,outputs:m})}async C(S,y,p){return S=d.$3N.ensureUniqueMimeTypes((0,E.$2b)(S),!0),this.r({editType:o.CellExecutionUpdateType.OutputItems,items:S.map(D.NotebookCellOutputItem.from),outputId:y.id,append:p})}asApiObject(){const S=this;return Object.freeze({get token(){return S.g.token},get cell(){return S.m.apiCell},get executionOrder(){return S.j},set executionOrder(p){S.j=p,S.s([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:S.j}])},start(p){if(S.f===n.Resolved||S.f===n.Started)throw new Error("Cannot call start again");S.f=n.Started,S.c.fire(),S.s({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:p})},end(p,k,m){if(S.f===n.Resolved)throw new Error("Cannot call resolve twice");S.f=n.Resolved,S.c.fire(),S.h.flush();const w=m?{message:m.message,stack:m.stack,location:m?.location?{startLineNumber:m.location.start.line,startColumn:m.location.start.character,endLineNumber:m.location.end.line,endColumn:m.location.end.character}:void 0,uri:m.uri}:void 0;S.n.$completeExecution(S.b,new h.$Kw({runEndTime:k,lastRunSuccess:p,error:w}))},clearOutput(p){return S.t(),S.z([],p,!1)},appendOutput(p,k){return S.t(),S.z(p,k,!0)},replaceOutput(p,k){return S.t(),S.z(p,k,!1)},appendOutputItems(p,k){return S.t(),S.C(p,k,!0)},replaceOutputItems(p,k){return S.t(),S.C(p,k,!1)}})}}var g;(function(I){I[I.Init=0]="Init",I[I.Started=1]="Started",I[I.Resolved=2]="Resolved"})(g||(g={}));class f extends A.$Uc{static{this.a=0}get state(){return this.f}constructor(S,y,p){super(),this.h=y,this.j=p,this.b=f.a++,this.c=new O.$he,this.onDidChangeState=this.c.event,this.f=g.Init,this.g=this.B(new P.$se),this.j.$createNotebookExecution(this.b,S,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===g.Resolved||this.f===g.Started)throw new Error("Cannot call start again");this.f=g.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===g.Resolved)throw new Error("Cannot call resolve twice");this.f=g.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class l{constructor(S,y){this.f=S,this.g=y,this.a=[],this.b=Date.now()}addItem(S){return this.a.push(S),this.c||(this.c=new R.$Xh,this.b=Date.now(),(0,R.$Bh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const S=this.c;this.c=void 0;const y=this.a;return this.a=[],this.g(y).finally(()=>S.complete())}}function b(I,S){return`${I.value}/${S}`}}),define(ke[57],Ie([1,0,4,5,3,2,17,6,7,187,14,218,22,36,219,220,34,11,10,39,37]),function(de,e,E,R,P,O,A,M,$,c,C,v,u,D,d,r,o,a,h,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ync=e.$xnc=e.$wnc=e.$vnc=void 0,e.$vnc=(0,P.$Ai)("IExtHostTerminalService");class n extends M.$Uc{constructor(m,w,F,T){super(),this.u=m,this._id=w,this.w=F,this.y=T,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new E.$he),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(q=>this.g=q);const G=this;this.value={get name(){return G.y||""},get processId(){return G.b},get creationOptions(){return G.w},get exitStatus(){return G.j},get state(){return G.m},get selection(){return G.n},get shellIntegration(){return G.shellIntegration},sendText(q,V=!0){G.C(),G.u.$sendText(G._id,q,V)},show(q){G.C(),G.u.$show(G._id,q)},hide(){G.C(),G.u.$hide(G._id)},dispose(){G.a||(G.a=!0,G.u.$dispose(G._id))},get dimensions(){if(!(G.f===void 0||G.h===void 0))return{columns:G.f,rows:G.h}}}}dispose(){this.s.fire(),super.dispose()}async create(m,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:m.name,shellPath:m.shellPath??void 0,shellArgs:m.shellArgs??void 0,cwd:m.cwd??w?.cwd??void 0,env:m.env??void 0,icon:S(m.iconPath)??void 0,color:o.ThemeColor.isThemeColor(m.color)?m.color.id:void 0,initialText:m.message??void 0,strictEnv:m.strictEnv??void 0,hideFromUser:m.hideFromUser??void 0,forceShellIntegration:w?.forceShellIntegration??void 0,isFeatureTerminal:w?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:w?.useShellEnvironment??void 0,location:w?.location||this.z(m.location,w?.resolvedExtHostIdentifier),isTransient:m.isTransient??void 0})}async createExtensionTerminal(m,w,F,T,G){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:T,color:o.ThemeColor.isThemeColor(G)?G.id:void 0,location:w?.location||this.z(m,F),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(m,w){return typeof m=="object"?"parentTerminal"in m&&m.parentTerminal&&w?{parentTerminal:w}:"viewColumn"in m?{viewColumn:h.ViewColumn.from(m.viewColumn),preserveFocus:m.preserveFocus}:void 0:m}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(m){this.y=m}setExitStatus(m,w){this.j=Object.freeze({code:m,reason:w})}setDimensions(m,w){return m===this.f&&w===this.h||m===0||w===0?!1:(this.f=m,this.h=w,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(m){this.n=m}_setProcessId(m){this.g?(this.g(m),this.g=void 0):this.b.then(w=>{w!==m&&(this.b=Promise.resolve(m))})}}e.$wnc=n;class i{get onProcessReady(){return this.b.event}constructor(m){this.g=m,this.id=0,this.shouldPersist=!1,this.a=new E.$he,this.onProcessData=this.a.event,this.b=new E.$he,this.d=new E.$he,this.onDidChangeProperty=this.d.event,this.f=new E.$he,this.onProcessExit=this.f.event}refreshProperty(m){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${m}`)}updateProperty(m,w){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${m}, value: ${w}`)}async start(){}shutdown(){this.g.close()}input(m){this.g.handleInput?.(m)}resize(m,w){this.g.setDimensions?.({columns:m,rows:w})}clearBuffer(){}async processBinary(m){}acknowledgeDataEvent(m){}async setUnicodeVersion(m){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(m){this.g.onDidWrite(w=>this.a.fire(w)),this.g.onDidClose?.((w=void 0)=>{this.f.fire(w===void 0?void 0:w)}),this.g.onDidOverrideDimensions?.(w=>{w&&this.d.fire({type:d.ProcessPropertyType.OverrideDimensions,value:{cols:w.columns,rows:w.rows}})}),this.g.onDidChangeName?.(w=>{this.d.fire({type:d.ProcessPropertyType.Title,value:w})}),this.g.open(m||void 0),m&&this.g.setDimensions?.(m),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let g=1,f=class extends M.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(m=>m.value)}constructor(m,w,F){super(),this.Q=w,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new M.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new E.$he,this.onDidCloseTerminal=this.H.event,this.I=new E.$he,this.onDidOpenTerminal=this.I.event,this.J=new E.$he,this.onDidChangeActiveTerminal=this.J.event,this.L=new E.$he,this.onDidChangeTerminalDimensions=this.L.event,this.M=new E.$he,this.onDidChangeTerminalState=this.M.event,this.N=new E.$he,this.onDidChangeShell=this.N.event,this.O=new E.$he({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new E.$he({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=F.getProxy(R.$uM.MainThreadTerminalService),this.y=new r.$5vb(this.a.$sendProcessData),this.a.$registerProcessSupport(m),this.Q.registerArgumentProcessor({processArgument:T=>{const G=q=>{const V=q;return this.getTerminalById(V.instanceId)?.value};switch(T?.$mid){case s.MarshalledId.TerminalContext:return G(T);default:{if(Array.isArray(T))for(let q=0;q<T.length&&T[q].$mid===s.MarshalledId.TerminalContext;q++)T[q]=G(T[q]);return T}}}}),this.B({dispose:()=>{for(const[T,G]of this.g)G.shutdown(!0)}})}getDefaultShell(m){return(m?this.u:this.s)?.path||""}getDefaultShellArgs(m){return(m?this.u:this.s)?.args||[]}createExtensionTerminal(m,w){const F=new n(this.a,(0,D.$Wg)(),m,m.name),T=new i(m.pty);return F.createExtensionTerminal(m.location,w,this.R(m,w).resolvedExtHostIdentifier,S(m.iconPath),y(m.color)).then(G=>{const q=this.S(G,T);this.h[G]=q}),this.f.push(F),F.value}R(m,w){if(w=w||{},m.location&&typeof m.location=="object"&&"parentTerminal"in m.location){const F=m.location.parentTerminal;if(F){const T=this.f.find(G=>G.value===F);T&&(w.resolvedExtHostIdentifier=T._id)}}else m.location&&typeof m.location!="object"?w.location=m.location:w.location&&typeof w.location=="object"&&"splitActiveTerminal"in w.location&&(w.location={splitActiveTerminal:!0});return w}attachPtyToTerminal(m,w){if(!this.getTerminalById(m))throw new Error(`Cannot resolve terminal with id ${m} for virtual process`);const T=new i(w),G=this.S(m,T);this.h[m]=G}async $acceptActiveTerminalChanged(m){const w=this.b;if(m===null){this.b=void 0,w!==this.b&&this.J.fire(this.b);return}const F=this.getTerminalById(m);F&&(this.b=F,w!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(m,w){const F=this.getTerminalById(m);F&&this.O.fire({terminal:F.value,data:w})}async $acceptTerminalDimensions(m,w,F){const T=this.getTerminalById(m);T&&T.setDimensions(w,F)&&this.L.fire({terminal:T.value,dimensions:T.value.dimensions})}async $acceptDidExecuteCommand(m,w){const F=this.getTerminalById(m);F&&this.P.fire({terminal:F.value,...w})}async $acceptTerminalMaximumDimensions(m,w,F){this.g.get(m)?.resize(w,F)}async $acceptTerminalTitleChange(m,w){const F=this.getTerminalById(m);F&&(F.name=w)}async $acceptTerminalClosed(m,w,F){const T=this.X(this.f,m);if(T!==null){const G=this.f.splice(T,1)[0];G.setExitStatus(w,F),this.H.fire(G.value)}}$acceptTerminalOpened(m,w,F,T){if(w){const V=this.X(this.f,w);if(V!==null){this.f[V]._id=m,this.I.fire(this.terminals[V]),this.f[V].isOpen=!0;return}}const G={name:T.name,shellPath:T.executable,shellArgs:T.args,cwd:typeof T.cwd=="string"?T.cwd:O.URI.revive(T.cwd),env:T.env,hideFromUser:T.hideFromUser},q=new n(this.a,m,G,F);this.f.push(q),this.I.fire(q.value),q.isOpen=!0}async $acceptTerminalProcessId(m,w){this.getTerminalById(m)?._setProcessId(w)}async $startExtensionTerminal(m,w){const F=this.getTerminalById(m);if(!F)return{message:(0,c.localize)(0,null,m)};F.isOpen||await new Promise(G=>{const q=this.onDidOpenTerminal(async V=>{V===F.value&&(q.dispose(),G())})});const T=this.g.get(m);T?T.startSendingEvents(w):this.j[m]={initialDimensions:w}}S(m,w){const F=new M.$Tc;F.add(w.onProcessReady(G=>this.a.$sendProcessReady(m,G.pid,G.cwd,G.windowsPty))),F.add(w.onDidChangeProperty(G=>this.a.$sendProcessProperty(m,G))),this.y.startBuffering(m,w.onProcessData),F.add(w.onProcessExit(G=>this.U(m,G))),this.g.set(m,w);const T=this.j[m];return T&&w instanceof i&&(w.startSendingEvents(T.initialDimensions),delete this.j[m]),F}$acceptProcessAckDataEvent(m,w){this.g.get(m)?.acknowledgeDataEvent(w)}$acceptProcessInput(m,w){this.g.get(m)?.input(w)}$acceptTerminalInteraction(m){const w=this.getTerminalById(m);w?.setInteractedWith()&&this.M.fire(w.value)}$acceptTerminalSelection(m,w){this.getTerminalById(m)?.setSelection(w)}$acceptProcessResize(m,w,F){try{this.g.get(m)?.resize(w,F)}catch(T){if(T.code!=="EPIPE"&&T.code!=="ERR_IPC_CHANNEL_CLOSED")throw T}}$acceptProcessShutdown(m,w){this.g.get(m)?.shutdown(w)}$acceptProcessRequestInitialCwd(m){this.g.get(m)?.getInitialCwd().then(w=>this.a.$sendProcessProperty(m,{type:d.ProcessPropertyType.InitialCwd,value:w}))}$acceptProcessRequestCwd(m){this.g.get(m)?.getCwd().then(w=>this.a.$sendProcessProperty(m,{type:d.ProcessPropertyType.Cwd,value:w}))}$acceptProcessRequestLatency(m){return Promise.resolve(m)}registerLinkProvider(m){return this.z.add(m),this.z.size===1&&this.a.$startLinkProvider(),new $.$wM(()=>{this.z.delete(m),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(m,w,F){if(this.C.has(w))throw new Error(`Terminal profile provider "${w}" already registered`);return this.C.set(w,F),this.a.$registerProfileProvider(w,m.identifier.value),new $.$wM(()=>{this.C.delete(w),this.a.$unregisterProfileProvider(w)})}registerTerminalQuickFixProvider(m,w,F){if(this.D.has(m))throw new Error(`Terminal quick fix provider "${m}" is already registered`);return this.D.set(m,F),this.a.$registerQuickFixProvider(m,w),new $.$wM(()=>{this.D.delete(m),this.a.$unregisterQuickFixProvider(m)})}async $provideTerminalQuickFixes(m,w){const F=new u.$se().token;if(F.isCancellationRequested)return;const T=this.D.get(m);if(!T)return;const G=await T.provideTerminalQuickFixes(w,F);if(G===null||Array.isArray(G)&&G.length===0)return;const q=new M.$Tc;if(this.w.value=q,!Array.isArray(G))return G?h.TerminalQuickFix.from(G,this.Q.converter,q):void 0;const V=[];for(const N of G){const L=h.TerminalQuickFix.from(N,this.Q.converter,q);L&&V.push(L)}return V}async $createContributedProfileTerminal(m,w){const F=new u.$se().token;let T=await this.C.get(m)?.provideTerminalProfile(F);if(!F.isCancellationRequested){if(T&&!("options"in T)&&(T={options:T}),!T||!("options"in T))throw new Error(`No terminal profile options provided for id "${m}"`);if("pty"in T.options){this.createExtensionTerminal(T.options,w);return}this.createTerminalFromOptions(T.options,w)}}async $provideLinks(m,w){const F=this.getTerminalById(m);if(!F)return[];this.F.delete(m),this.G.get(m)?.dispose(!0);const G=new u.$se;this.G.set(m,G);const q=[],V={terminal:F.value,line:w},N=[];for(const re of this.z)N.push(a.Promises.withAsyncBody(async fe=>{G.token.onCancellationRequested(()=>fe({provider:re,links:[]}));const be=await re.provideTerminalLinks(V,G.token)||[];G.token.isCancellationRequested||fe({provider:re,links:be})}));const L=await Promise.all(N);if(G.token.isCancellationRequested)return[];const Z=new Map;for(const re of L)re&&re.links.length>0&&q.push(...re.links.map(fe=>{const be={id:g++,startIndex:fe.startIndex,length:fe.length,label:fe.tooltip};return Z.set(be.id,{provider:re.provider,link:fe}),be}));return this.F.set(m,Z),q}$activateLink(m,w){const F=this.F.get(m)?.get(w);F&&F.provider.handleTerminalLink(F.link)}U(m,w){this.y.stopBuffering(m),this.g.delete(m),delete this.j[m];const F=this.h[m];F&&(F.dispose(),delete this.h[m]),this.a.$sendProcessExit(m,w)}getTerminalById(m){return this.W(this.f,m)}getTerminalIdByApiObject(m){const w=this.f.findIndex(F=>F.value===m);return w>=0?w:null}W(m,w){const F=this.X(m,w);return F!==null?m[F]:null}X(m,w){const F=m.findIndex(T=>T._id===w);return F>=0?F:null}getEnvironmentVariableCollection(m){let w=this.n.get(m.identifier.value);return w||(w=new l,this.Z(m.identifier.value,w)),w.getScopedEnvironmentVariableCollection(void 0)}Y(m,w){const F=(0,v.$ts)(w.map),T=(0,v.$us)(w.descriptionMap);this.a.$setEnvironmentVariableCollection(m,w.persistent,F.length===0?void 0:F,T)}$initEnvironmentVariableCollections(m){m.forEach(w=>{const F=w[0],T=new l(w[1]);this.Z(F,T)})}$acceptDefaultProfile(m,w){const F=this.s;this.s=m,this.u=w,F?.path!==m.path&&this.N.fire(m.path)}Z(m,w){this.n.set(m,w),w.onDidChangeCollection(()=>{this.Y(m,w)})}};e.$xnc=f,e.$xnc=f=He([Ve(1,t.$iP),Ve(2,A.$YO)],f);class l{get persistent(){return this.b}set persistent(m){this.b=m,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(m){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new E.$he,this.map=new Map(m)}getScopedEnvironmentVariableCollection(m){const w=this.h(m);let F=this.a.get(w);return F||(F=new b(this,m),this.a.set(w,F),F.onDidChangeCollection(()=>this.d.fire())),F}replace(m,w,F,T){this.f(m,{value:w,type:$.EnvironmentVariableMutatorType.Replace,options:F??{applyAtProcessCreation:!0},scope:T})}append(m,w,F,T){this.f(m,{value:w,type:$.EnvironmentVariableMutatorType.Append,options:F??{applyAtProcessCreation:!0},scope:T})}prepend(m,w,F,T){this.f(m,{value:w,type:$.EnvironmentVariableMutatorType.Prepend,options:F??{applyAtProcessCreation:!0},scope:T})}f(m,w){if(w.options&&w.options.applyAtProcessCreation===!1&&!w.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const F=this.g(m,w.scope),T=this.map.get(F),G=w.options?{applyAtProcessCreation:w.options.applyAtProcessCreation??!1,applyAtShellIntegration:w.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!T||T.value!==w.value||T.type!==w.type||T.options?.applyAtProcessCreation!==G.applyAtProcessCreation||T.options?.applyAtShellIntegration!==G.applyAtShellIntegration||T.scope?.workspaceFolder?.index!==w.scope?.workspaceFolder?.index){const q=this.g(m,w.scope),V={variable:m,...w,options:G};this.map.set(q,V),this.d.fire()}}get(m,w){const F=this.g(m,w),T=this.map.get(F);return T?p(T):void 0}g(m,w){const F=this.h(w);return F.length?`${m}:::${F}`:m}h(m){return this.j(m?.workspaceFolder)??""}j(m){return m?m.uri.toString():void 0}getVariableMap(m){const w=new Map;for(const[F,T]of this.map)this.h(T.scope)===this.h(m)&&w.set(T.variable,p(T));return w}delete(m,w){const F=this.g(m,w);this.map.delete(F),this.d.fire()}clear(m){if(m?.workspaceFolder){for(const[w,F]of this.map)F.scope?.workspaceFolder?.index===m.workspaceFolder.index&&this.map.delete(w);this.k(m)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(m,w){const F=this.h(w),T=this.descriptionMap.get(F);if(!T||T.description!==m){let G;typeof m=="string"?G=m:G=m?.value.split(`

`)[0];const q={description:G,scope:w};this.descriptionMap.set(F,q),this.d.fire()}}getDescription(m){const w=this.h(m);return this.descriptionMap.get(w)?.description}k(m){const w=this.h(m);this.descriptionMap.delete(w)}}class b{get persistent(){return this.b.persistent}set persistent(m){this.b.persistent=m}get onDidChangeCollection(){return this.a&&this.a.event}constructor(m,w){this.b=m,this.d=w,this.a=new E.$he}getScoped(m){return this.b.getScopedEnvironmentVariableCollection(m)}replace(m,w,F){this.b.replace(m,w,F,this.d)}append(m,w,F){this.b.append(m,w,F,this.d)}prepend(m,w,F){this.b.prepend(m,w,F,this.d)}get(m){return this.b.get(m,this.d)}forEach(m,w){this.b.getVariableMap(this.d).forEach((F,T)=>m.call(w,T,F,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(m){this.b.delete(m,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(m){this.b.setDescription(m,this.d)}get description(){return this.b.getDescription(this.d)}}let I=class extends f{constructor(m,w){super(!1,m,w)}createTerminal(m,w,F){throw new C.$_}createTerminalFromOptions(m,w){throw new C.$_}};e.$ync=I,e.$ync=I=He([Ve(0,t.$iP),Ve(1,A.$YO)],I);function S(k){if(!(!k||typeof k=="string"))return"id"in k?{id:k.id,color:k.color}:k}function y(k){return o.ThemeColor.isThemeColor(k)?k:void 0}function p(k){const m={...k};return delete m.scope,m.options=m.options??void 0,delete m.variable,m}}),define(ke[124],Ie([1,0,7,6,3,5,17,57,4,2,11]),function(de,e,E,R,P,O,A,M,$,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Doc=e.$Coc=void 0,e.$Coc=(0,P.$Ai)("IExtHostTerminalShellIntegration");let v=class extends R.$Uc{constructor(o,a){super(),this.h=a,this.b=new Map,this.c=new $.$he,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new $.$he,this.onDidStartTerminalShellExecution=this.f.event,this.g=new $.$he,this.onDidEndTerminalShellExecution=this.g.event,this.a=o.getProxy(O.$uM.MainThreadTerminalShellIntegration),this.B((0,R.$Sc)(()=>{for(const[h,t]of this.b)t.dispose();this.b.clear()}))}$shellIntegrationChange(o){const a=this.h.getTerminalById(o);if(!a)return;const h=a.value;let t=this.b.get(o);t||(t=new u(a.value,this.f),this.b.set(o,t),t.store.add(a.onWillDispose(()=>this.b.get(o)?.dispose())),t.store.add(t.onDidRequestShellExecution(s=>this.a.$executeCommand(o,s))),t.store.add(t.onDidRequestEndExecution(s=>this.g.fire(s))),t.store.add(t.onDidRequestChangeShellIntegration(s=>this.c.fire(s))),a.shellIntegration=t.value),this.c.fire({terminal:h,shellIntegration:t.value})}$shellExecutionStart(o,a,h,t,s){this.b.has(o)||this.$shellIntegrationChange(o);const n={value:a,confidence:h,isTrusted:t};this.b.get(o)?.startShellExecution(n,s)}$shellExecutionEnd(o,a,h,t,s){const n={value:a,confidence:h,isTrusted:t};this.b.get(o)?.endShellExecution(n,s)}$shellExecutionData(o,a){this.b.get(o)?.emitData(a)}$cwdChange(o,a){this.b.get(o)?.setCwd((0,c.$vc)(a)?c.URI.revive(a):a)}$closeTerminal(o){this.b.get(o)?.dispose(),this.b.delete(o)}};e.$Doc=v,e.$Doc=v=He([Ve(0,A.$YO),Ve(1,M.$vnc)],v);class u extends R.$Uc{get currentExecution(){return this.a}constructor(o,a){super(),this.j=o,this.m=a,this.b=!1,this.store=this.B(new R.$Tc),this.f=this.B(new $.$he),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new $.$he),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new $.$he),this.onDidRequestEndExecution=this.h.event;const h=this;this.value={get cwd(){return h.c},executeCommand(t,s){let n=t;s&&(n+=` "${s.map(f=>`${f.replaceAll('"','\\"')}`).join('" "')}"`),h.g.fire(n);const i={value:n,confidence:E.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},g=h.startShellExecution(i,h.c,!0).value;return h.b=!0,g}}}startShellExecution(o,a,h){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const t=this.a=new D(o,a);h?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:t.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(o){this.currentExecution?.emitData(o)}endShellExecution(o,a){this.a&&(this.a.endExecution(o),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:a}),this.a=void 0)}setCwd(o){let a=!1;c.URI.isUri(this.c)?a=!c.URI.isUri(o)||this.c.toString()!==o.toString():this.c!==o&&(a=!0),a&&(this.c=o,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class D{constructor(o,a){this.c=o,this.cwd=a,this.b=!1;const h=this;this.value={get commandLine(){return h.c},get cwd(){return h.cwd},read(){return h.d()}}}d(){if(!this.a){if(this.b)return C.$1h.EMPTY;this.a=new d}return this.a.createIterable()}emitData(o){this.a?.emitData(o)}endExecution(o){o&&(this.c=o),this.a?.endExecution(),this.a=void 0,this.b=!0}}class d extends R.$Uc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new C.$zh);const o=this.a;return new C.$1h(async h=>{this.b.push(h),await o.wait()})}emitData(o){for(const a of this.b)a.emitOne(o)}endExecution(){this.a?.open(),this.a=void 0}}}),define(ke[299],Ie([1,0,11,23,22,4,272,76,6,37,15,36,12,5,17,123,10,7,240,55,82,56,25]),function(de,e,E,R,P,O,A,M,$,c,C,v,u,D,d,r,o,a,h,t,s,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hoc=e.$Goc=e.$Foc=e.$Eoc=void 0;let g=0;const f=new WeakMap;let l=class extends $.$Uc{constructor(L,Z,re,fe){super(),this.C=Z,this.D=re,this.F=fe,this.f=this.B(new O.$he),this.g=new Map,this.w=this.B(new O.$he),this.y=new Set,this.z=new Map,this.onResultsChanged=this.f.event,this.results=[],this.h=L.getProxy(D.$uM.MainThreadTesting),this.m=new F(this.h),this.j=new y(this.h,Z),re.registerArgumentProcessor({processArgument:be=>{switch(be?.$mid){case c.MarshalledId.TestItemContext:{const oe=be,pe=oe.tests[oe.tests.length-1].item.extId;return this.g.get(t.$gL.root(pe))?.collection.tree.get(pe)?.actual??(0,r.$$O)(be)}case c.MarshalledId.TestMessageMenuArgs:{const{test:oe,message:pe}=be,$e=oe.item.extId;return{test:this.g.get(t.$gL.root($e))?.collection.tree.get($e)?.actual??(0,r.$$O)({$mid:c.MarshalledId.TestItemContext,tests:[oe]}),message:o.TestMessage.to(pe)}}default:return be}}}),re.registerCommand(!1,"testing.getExplorerSelection",async()=>{const be=await re.executeCommand(h.TestCommandId.GetExplorerSelection),oe=pe=>{const $e=this.g.get(t.$gL.root(pe));if($e)return t.$gL.isRoot(pe)?$e.controller:$e.collection.tree.get(pe)?.actual};return{include:be?.include.map(oe).filter(C.$ig)||[],exclude:be?.exclude.map(oe).filter(C.$ig)||[]}})}createTestController(L,Z,re,fe){if(this.g.has(Z))throw new Error(`Attempt to insert a duplicate controller with ID "${Z}"`);const be=new $.$Tc,oe=be.add(new r.$bP(Z,re,this.F));oe.root.label=re;const pe=new Map,$e=new Set,se=this.h,Ce={items:oe.root.children,get label(){return re},set label(X){re=X,oe.root.label=X,se.$updateController(Z,{label:re})},get refreshHandler(){return fe},set refreshHandler(X){fe=X,se.$updateController(Z,{canRefresh:!!X})},get id(){return Z},createRunProfile:(X,W,ie,Se,he,we)=>{let ae=(0,M.$oj)(X);for(;pe.has(ae);)ae++;return new G(this.h,pe,$e,this.w.event,Z,ae,X,W,ie,Se,he,we)},createTestItem(X,W,ie){return new r.$_O(Z,X,W,ie)},createTestRun:(X,W,ie=!0)=>this.j.createTestRun(L,Z,oe,X,W,ie),invalidateTestResults:X=>{if(X===void 0)this.h.$markTestRetired(void 0);else{const W=X instanceof Array?X:[X];this.h.$markTestRetired(W.map(ie=>t.$gL.fromExtHostTestItem(ie,Z).toString()))}},set resolveHandler(X){oe.resolveHandler=X},get resolveHandler(){return oe.resolveHandler},dispose:()=>{be.dispose()}};se.$registerTestController(Z,re,!!fe),be.add((0,$.$Sc)(()=>se.$unregisterTestController(Z)));const Fe={controller:Ce,collection:oe,profiles:pe,extension:L,activeProfiles:$e};return this.g.set(Z,Fe),be.add((0,$.$Sc)(()=>this.g.delete(Z))),be.add(oe.onDidGenerateDiff(X=>se.$publishDiff(Z,X.map(n.TestsDiffOp.serialize)))),Ce}createTestObserver(){return this.m.checkout()}async runTests(L,Z=P.CancellationToken.None){const re=p(L);if(!re)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const fe=this.g.get(re.controllerId);if(!fe)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:L.preserveFocus??!0,targets:[{testIds:L.include?.map(be=>t.$gL.fromExtHostTestItem(be,fe.collection.root.id).toString())??[fe.collection.root.id],profileGroup:q[re.kind],profileId:re.profileId,controllerId:re.controllerId}],exclude:L.exclude?.map(be=>be.id)},Z)}registerTestFollowupProvider(L){return this.y.add(L),{dispose:()=>{this.y.delete(L)}}}$syncTests(){for(const{collection:L}of this.g.values())L.flushDiff();return Promise.resolve()}async $getCoverageDetails(L,Z){return(await this.j.getCoverageDetails(L,Z))?.map(o.TestCoverage.fromDetails)}async $disposeRun(L){this.j.disposeTestRun(L)}$configureRunProfile(L,Z){this.g.get(L)?.profiles.get(Z)?.configureHandler?.()}$setDefaultRunProfiles(L){const Z=new Map;for(const[re,fe]of Object.entries(L)){const be=this.g.get(re);if(!be)continue;const oe=new Map,pe=fe.filter(se=>!be.activeProfiles.has(se)),$e=[...be.activeProfiles].filter(se=>!fe.includes(se));for(const se of pe)oe.set(se,!0),be.activeProfiles.add(se);for(const se of $e)oe.set(se,!1),be.activeProfiles.delete(se);oe.size&&Z.set(re,oe)}this.w.fire(Z)}async $refreshTests(L,Z){await this.g.get(L)?.controller.refreshHandler?.(Z)}$publishTestResults(L){this.results=Object.freeze(L.map(Z=>{const re=o.TestResults.to(Z);return f.set(re,Z.id),re}).concat(this.results).sort((Z,re)=>re.completedAt-Z.completedAt).slice(0,32)),this.f.fire()}async $expandTest(L,Z){const re=this.g.get(t.$gL.fromString(L).controllerId)?.collection;re&&(await re.expand(L,Z<0?1/0:Z),re.flushDiff())}$acceptDiff(L){this.m.applyDiff(L.map(Z=>n.TestsDiffOp.deserialize({asCanonicalUri:re=>re},Z)))}async $runControllerTests(L,Z){return Promise.all(L.map(re=>this.G(re,!1,Z)))}async $startContinuousRun(L,Z){const re=new P.$se(Z),fe=await Promise.all(L.map(be=>this.G(be,!0,re.token)));return!Z.isCancellationRequested&&!fe.some(be=>be.error)&&await new Promise(be=>Z.onCancellationRequested(be)),re.dispose(!0),fe}async $provideTestFollowups(L,Z){const re=this.results.find(oe=>f.get(oe)===L.resultId),fe=re&&V(t.$gL.fromString(L.extId),re?.results);if(!fe)return[];let be=[];return await Promise.all([...this.y].map(async oe=>{try{const pe=await oe.provideFollowup(re,fe,L.taskIndex,L.messageIndex,Z);pe&&(be=be.concat(pe))}catch(pe){this.C.error("Error thrown while providing followup for test message",pe)}})),Z.isCancellationRequested?[]:be.map(oe=>{const pe=g++;return this.z.set(pe,oe),{title:oe.title,id:pe}})}$disposeTestFollowups(L){for(const Z of L)this.z.delete(Z)}$executeTestFollowup(L){const Z=this.z.get(L);return Z?this.D.executeCommand(Z.command,...Z.arguments||[]):Promise.resolve()}async G(L,Z,re){const fe=this.g.get(L.controllerId);if(!fe)return{};const{collection:be,profiles:oe,extension:pe}=fe,$e=oe.get(L.profileId);if(!$e)return{};const se=L.testIds.map(W=>be.tree.get(W)).filter(C.$ig),Ce=L.excludeExtIds.map(W=>fe.collection.tree.get(W)).filter(C.$ig).filter(W=>se.some(ie=>ie.fullId.compare(W.fullId)===t.TestPosition.IsChild));if(!se.length)return{};const Fe=new a.$0N(se.some(W=>W.actual instanceof r.$aP)?void 0:se.map(W=>W.actual),Ce.map(W=>W.actual),$e,Z),X=(0,n.$jL)(L)&&this.j.prepareForMainThreadTestRun(pe,Fe,k.fromInternal(L,fe.collection),$e,re);try{return await $e.runHandler(Fe,re),{}}catch(W){return{error:String(W)}}finally{X&&X.hasRunningTasks&&!re.isCancellationRequested&&await O.Event.toPromise(X.onEnd)}}$cancelExtensionTestRun(L){L===void 0?this.j.cancelAllRuns():this.j.cancelRunById(L)}};e.$Eoc=l,e.$Eoc=l=He([Ve(0,d.$YO),Ve(1,u.$7j)],l);const b=1e4;var I;(function(N){N[N.Running=0]="Running",N[N.Cancelling=1]="Cancelling",N[N.Ended=2]="Ended"})(I||(I={}));class S extends $.$Uc{get hasRunningTasks(){return this.f>0}get id(){return this.z.id}constructor(L,Z,re,fe,be,oe){super(),this.z=L,this.C=Z,this.D=re,this.F=fe,this.G=be,this.c=I.Running,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new O.$he),this.y=new Map,this.onEnd=this.m.event,this.j=this.B(new P.$se(oe));const pe=this.B(new E.$Mh(()=>this.H(),b));this.B(this.j.token.onCancellationRequested(()=>pe.schedule()));const $e=new O.$he;this.w=$e.event,this.B((0,$.$Sc)(()=>{$e.fire(),$e.dispose()}))}cancel(){this.c===I.Running?(this.j.cancel(),this.c=I.Cancelling):this.c===I.Cancelling&&this.H()}getCoverageDetails(L,Z){const[,re]=t.$gL.fromString(L).path,fe=this.y.get(L);if(!fe)return[];const be=this.g.get(re);if(!be)throw new Error("unreachable: run task was not found");return this.F?.loadDetailedCoverage?.(be.run,fe,Z)??[]}createRun(L){const Z=this.z.id,re=this.z.controllerId,fe=(0,v.$Wg)(),be=Ce=>(Fe,...X)=>{if(pe){this.D.warn(`Setting the state of test "${Fe.id}" is a no-op after the run ends.`);return}this.z.isIncluded(Fe)&&(this.J(Fe),Ce(Fe,...X))},oe=(Ce,Fe)=>{const X=Fe instanceof Array?Fe.map(o.TestMessage.from):[o.TestMessage.from(Fe)];if(Ce.uri&&Ce.range){const W={range:o.Range.from(Ce.range),uri:Ce.uri};for(const ie of X)ie.location=ie.location||W}this.C.$appendTestMessagesInRun(Z,fe,t.$gL.fromExtHostTestItem(Ce,re).toString(),X)};let pe=!1;const $e=new Map,se={isPersisted:this.z.isPersisted,token:this.j.token,name:L,onDidDispose:this.w,addCoverage:Ce=>{if(pe)return;const Fe=Ce instanceof a.$cO?Ce.testItem:void 0;let X;if(Fe){if((0,i.$UG)(this.G,"attributableCoverage"),!this.z.isIncluded(Fe))throw new Error("Attempted to `addCoverage` for a test item not included in the run");this.J(Fe),X=$e.get(Fe),X===void 0&&(X=$e.size,$e.set(Fe,X))}const W=Ce.uri.toString(),ie=new t.$gL(X!==void 0?[Z,fe,W,String(X)]:[Z,fe,W]).toString();this.y.set(ie,Ce),this.C.$appendCoverage(Z,fe,o.TestCoverage.fromFile(re,ie,Ce))},enqueued:be(Ce=>{this.C.$updateTestStateInRun(Z,fe,t.$gL.fromExtHostTestItem(Ce,re).toString(),n.TestResultState.Queued)}),skipped:be(Ce=>{this.C.$updateTestStateInRun(Z,fe,t.$gL.fromExtHostTestItem(Ce,re).toString(),n.TestResultState.Skipped)}),started:be(Ce=>{this.C.$updateTestStateInRun(Z,fe,t.$gL.fromExtHostTestItem(Ce,re).toString(),n.TestResultState.Running)}),errored:be((Ce,Fe,X)=>{oe(Ce,Fe),this.C.$updateTestStateInRun(Z,fe,t.$gL.fromExtHostTestItem(Ce,re).toString(),n.TestResultState.Errored,X)}),failed:be((Ce,Fe,X)=>{oe(Ce,Fe),this.C.$updateTestStateInRun(Z,fe,t.$gL.fromExtHostTestItem(Ce,re).toString(),n.TestResultState.Failed,X)}),passed:be((Ce,Fe)=>{this.C.$updateTestStateInRun(Z,fe,t.$gL.fromExtHostTestItem(Ce,this.z.controllerId).toString(),n.TestResultState.Passed,Fe)}),appendOutput:(Ce,Fe,X)=>{pe||(X&&(this.z.isIncluded(X)?this.J(X):X=void 0),this.C.$appendOutputToRun(Z,fe,R.$Je.fromString(Ce),Fe&&o.location.from(Fe),X&&t.$gL.fromExtHostTestItem(X,re).toString()))},end:()=>{pe||(pe=!0,$e.clear(),this.C.$finishedTestRunTask(Z,fe),--this.f||this.I())}};return this.f++,this.g.set(fe,{run:se}),this.C.$startedTestRunTask(Z,{id:fe,name:L,running:!0}),se}H(){for(const{run:L}of this.g.values())L.end()}I(){this.c!==I.Ended&&(this.c=I.Ended,this.m.fire())}J(L){if(!(L instanceof r.$_O))throw new s.$QO(L.id);if(this.h.has(t.$gL.fromExtHostTestItem(L,this.z.controllerId).toString()))return;const Z=[],re=this.z.colllection.root;for(;;){const fe=o.TestItem.from(L);if(Z.unshift(fe),this.h.has(fe.extId)||(this.h.add(fe.extId),L===re))break;L=L.parent||re}this.C.$addTestsToRun(this.z.controllerId,this.z.id,Z)}dispose(){this.I(),super.dispose()}}class y{get trackers(){return this.c.values()}constructor(L,Z){this.g=L,this.h=Z,this.c=new Map,this.f=new Map}getCoverageDetails(L,Z){const re=t.$gL.root(L);return this.f.get(re)?.getCoverageDetails(L,Z)||[]}disposeTestRun(L){this.f.get(L)?.dispose(),this.f.delete(L);for(const[Z,{id:re}]of this.c)re===L&&this.c.delete(Z)}prepareForMainThreadTestRun(L,Z,re,fe,be){return this.j(Z,re,fe,L,be)}cancelRunById(L){this.f.get(L)?.cancel()}cancelAllRuns(){for(const L of this.c.values())L.cancel()}createTestRun(L,Z,re,fe,be,oe){const pe=this.c.get(fe);if(pe)return pe.createRun(be);const $e=k.fromPublic(Z,re,fe,oe),se=p(fe);this.g.$startedExtensionTestRun({controllerId:Z,continuous:!!fe.continuous,profile:se&&{group:q[se.kind],id:se.profileId},exclude:fe.exclude?.map(Fe=>t.$gL.fromExtHostTestItem(Fe,re.root.id).toString())??[],id:$e.id,include:fe.include?.map(Fe=>t.$gL.fromExtHostTestItem(Fe,re.root.id).toString())??[re.root.id],preserveFocus:fe.preserveFocus??!0,persist:oe});const Ce=this.j(fe,$e,fe.profile,L);return O.Event.once(Ce.onEnd)(()=>{this.g.$finishedExtensionTestRun($e.id)}),Ce.createRun(be)}j(L,Z,re,fe,be){const oe=new S(Z,this.g,this.h,re,fe,be);return this.c.set(L,oe),this.f.set(oe.id,oe),oe}}e.$Foc=y;const p=N=>{if(N.profile){if(!(N.profile instanceof G))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return N.profile}};class k{static fromPublic(L,Z,re,fe){return new k(L,(0,v.$Wg)(),re.include?.map(be=>t.$gL.fromExtHostTestItem(be,L).toString())??[L],re.exclude?.map(be=>t.$gL.fromExtHostTestItem(be,L).toString())??[],fe,Z)}static fromInternal(L,Z){return new k(L.controllerId,L.runId,L.testIds,L.excludeExtIds,!0,Z)}constructor(L,Z,re,fe,be,oe){this.controllerId=L,this.id=Z,this.isPersisted=be,this.colllection=oe,this.c=re.map(pe=>pe+t.TestIdPathParts.Delimiter),this.f=fe.map(pe=>pe+t.TestIdPathParts.Delimiter)}isIncluded(L){const Z=t.$gL.fromExtHostTestItem(L,this.controllerId).toString()+t.TestIdPathParts.Delimiter;for(const re of this.f)if(Z===re||Z.startsWith(re))return!1;for(const re of this.c)if(Z===re||Z.startsWith(re))return!0;return!1}}e.$Goc=k;class m{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(L){this.j=L,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(L){this.c.add(L)}update(L){Object.assign(L.revived,o.TestItem.toPlain(L.item)),this.c.has(L)||this.f.add(L)}remove(L){if(this.c.has(L)){this.c.delete(L);return}this.f.delete(L);const Z=t.$gL.parentId(L.item.extId);if(Z&&this.h.has(Z.toString())){this.h.add(L.item.extId);return}this.g.add(L)}getChangeEvent(){const{c:L,f:Z,g:re}=this;return{get added(){return[...L].map(fe=>fe.revived)},get updated(){return[...Z].map(fe=>fe.revived)},get removed(){return[...re].map(fe=>fe.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class w extends n.$pL{constructor(){super(...arguments),this.y=new O.$he,this.onDidChangeTests=this.y.event}get rootTests(){return this.g}getMirroredTestDataById(L){return this.f.get(L)}getMirroredTestDataByReference(L){return this.f.get(L.id)}x(L,Z){return{...L,revived:o.TestItem.toPlain(L.item),depth:Z?Z.depth+1:0,children:new Set}}w(){return new m(this.y)}}class F{constructor(L){this.f=L}checkout(){this.c||(this.c=this.g());const L=this.c;return L.observers++,{onDidChangeTest:L.tests.onDidChangeTests,get tests(){return[...L.tests.rootTests].map(Z=>Z.revived)},dispose:(0,A.$db)(()=>{--L.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(L){return this.c?.tests.getMirroredTestDataByReference(L)}applyDiff(L){this.c?.tests.apply(L)}g(){const L=new w({asCanonicalUri:Z=>Z});return this.f.$subscribeToDiffs(),{observers:0,tests:L}}}const T=(N,L,Z,re)=>{Z?Object.assign(Z,re):L.$updateTestRunConfig(N.controllerId,N.profileId,re)};class G{#e;#t;#i;#n;#s;get label(){return this.f}set label(L){L!==this.f&&(this.f=L,T(this,this.#e,this.#n,{label:L}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(L){L!==this.g&&(this.g=L,T(this,this.#e,this.#n,{supportsContinuousRun:L}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(L){L!==this.isDefault&&(L?this.#t.add(this.profileId):this.#t.delete(this.profileId),T(this,this.#e,this.#n,{isDefault:L}))}get tag(){return this._tag}set tag(L){L?.id!==this._tag?.id&&(this._tag=L,T(this,this.#e,this.#n,{tag:L?o.TestTag.namespace(this.controllerId,L.id):null}))}get configureHandler(){return this.c}set configureHandler(L){L!==this.c&&(this.c=L,T(this,this.#e,this.#n,{hasConfigurationHandler:!!L}))}get onDidChangeDefault(){return O.Event.chain(this.#i,L=>L.map(Z=>Z.get(this.controllerId)?.get(this.profileId)).filter(C.$ig))}constructor(L,Z,re,fe,be,oe,pe,$e,se,Ce=!1,Fe=void 0,X=!1){this.controllerId=be,this.profileId=oe,this.f=pe,this.kind=$e,this.runHandler=se,this._tag=Fe,this.g=X,this.#e=L,this.#s=Z,this.#t=re,this.#i=fe,Z.set(oe,this);const W=q[$e];if(typeof W!="number")throw new Error(`Unknown TestRunProfile.group ${$e}`);Ce&&re.add(oe),this.#n={profileId:oe,controllerId:be,tag:Fe?o.TestTag.namespace(this.controllerId,Fe.id):null,label:pe,group:W,isDefault:Ce,hasConfigurationHandler:!1,supportsContinuousRun:X},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$Hoc=G;const q={[a.TestRunProfileKind.Coverage]:n.TestRunProfileBitset.Coverage,[a.TestRunProfileKind.Debug]:n.TestRunProfileBitset.Debug,[a.TestRunProfileKind.Run]:n.TestRunProfileBitset.Run};function V(N,L){for(let Z=0;Z<N.path.length;Z++){const re=L.find(fe=>fe.id===N.path[Z]);if(!re)return;if(Z===N.path.length-1)return re;L=re.children}}}),define(ke[125],Ie([1,0,61,14,96,10,7]),function(de,e,E,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8O=e.$7O=e.$6O=void 0;class M{static{this.c=new P.$4O("TextEditorDecorationType")}constructor(u,D,d){const r=M.c.nextId();u.$registerTextEditorDecorationType(D.identifier,r,O.DecorationRenderOptions.from(d)),this.value=Object.freeze({key:r,dispose(){u.$removeTextEditorDecorationType(r)}})}}e.$6O=M;class ${constructor(u,D){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=D.undoStopBefore,this.f=D.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,D){this.k();let d=null;if(u instanceof A.$xM)d=new A.$yM(u,u);else if(u instanceof A.$yM)d=u;else throw new Error("Unrecognized location");this.l(d,D,!1)}insert(u,D){this.k(),this.l(new A.$yM(u,u),D,!0)}delete(u){this.k();let D=null;if(u instanceof A.$yM)D=u;else throw new Error("Unrecognized location");this.l(D,null,!0)}l(u,D,d){const r=this.c.validateRange(u);this.g.push({range:r,text:D,forceMoveMarkers:d})}setEndOfLine(u){if(this.k(),u!==A.EndOfLine.LF&&u!==A.EndOfLine.CRLF)throw(0,R.$7)("endOfLine");this.h=u}}class c{constructor(u,D,d,r){this.c=u,this.d=D,this._accept(d),this.e=r;const o=this;this.value={get tabSize(){return o.f},set tabSize(a){o.n(a)},get indentSize(){return o.g},set indentSize(a){o.p(a)},get insertSpaces(){return o.j},set insertSpaces(a){o.s(a)},get cursorStyle(){return o.k},set cursorStyle(a){o.t(a)},get lineNumbers(){return o.l},set lineNumbers(a){o.u(a)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.originalIndentSize,this.j=u.insertSpaces,this.k=u.cursorStyle,this.l=O.TextEditorLineNumbersStyle.to(u.lineNumbers)}m(u){if(u==="auto")return"auto";if(typeof u=="number"){const D=Math.floor(u);return D>0?D:null}if(typeof u=="string"){const D=parseInt(u,10);return isNaN(D)?null:D>0?D:null}return null}n(u){const D=this.m(u);if(D!==null){if(typeof D=="number"){if(this.f===D)return;this.f=D}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:D}))}}o(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const D=Math.floor(u);return D>0?D:null}if(typeof u=="string"){const D=parseInt(u,10);return isNaN(D)?null:D>0?D:null}return null}p(u){const D=this.o(u);if(D!==null){if(typeof D=="number"){if(this.h===D)return;this.g=D,this.h=D}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:D}))}}q(u){return u==="auto"?"auto":u==="false"?!1:!!u}s(u){const D=this.q(u);if(typeof D=="boolean"){if(this.j===D)return;this.j=D}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:D}))}t(u){this.k!==u&&(this.k=u,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}u(u){this.l!==u&&(this.l=u,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:O.TextEditorLineNumbersStyle.from(u)})))}assign(u){const D={};let d=!1;if(typeof u.tabSize<"u"){const r=this.m(u.tabSize);r==="auto"?(d=!0,D.tabSize=r):typeof r=="number"&&this.f!==r&&(this.f=r,d=!0,D.tabSize=r)}if(typeof u.indentSize<"u"){const r=this.o(u.indentSize);r==="tabSize"?(d=!0,D.indentSize=r):typeof r=="number"&&this.h!==r&&(this.g=r,this.h=r,d=!0,D.indentSize=r)}if(typeof u.insertSpaces<"u"){const r=this.q(u.insertSpaces);r==="auto"?(d=!0,D.insertSpaces=r):this.j!==r&&(this.j=r,d=!0,D.insertSpaces=r)}typeof u.cursorStyle<"u"&&this.k!==u.cursorStyle&&(this.k=u.cursorStyle,d=!0,D.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.l!==u.lineNumbers&&(this.l=u.lineNumbers,d=!0,D.lineNumbers=O.TextEditorLineNumbersStyle.from(u.lineNumbers)),d&&this.v("setOptions",this.c.$trySetOptions(this.d,D))}v(u,D){D.catch(d=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn(d)})}}e.$7O=c;class C{constructor(u,D,d,r,o,a,h,t){this.id=u,this.j=D,this.k=d,this.g=!1,this.h=new Set,this.c=o,this.d=new c(this.j,this.id,a,d),this.e=h,this.f=t;const s=this;this.value=Object.freeze({get document(){return r.value},set document(n){throw new R.$9("document")},get selection(){return s.c&&s.c[0]},set selection(n){if(!(n instanceof A.$zM))throw(0,R.$7)("selection");s.c=[n],s.l()},get selections(){return s.c},set selections(n){if(!Array.isArray(n)||n.some(i=>!(i instanceof A.$zM)))throw(0,R.$7)("selections");s.c=n,s.l()},get visibleRanges(){return s.e},set visibleRanges(n){throw new R.$9("visibleRanges")},get options(){return s.d.value},set options(n){s.g||s.d.assign(n)},get viewColumn(){return s.f},set viewColumn(n){throw new R.$9("viewColumn")},edit(n,i={undoStopBefore:!0,undoStopAfter:!0}){if(s.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const g=new $(r.value,i);return n(g),s.m(g)},insertSnippet(n,i,g={undoStopBefore:!0,undoStopAfter:!0}){if(s.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let f;if(!i||Array.isArray(i)&&i.length===0)f=s.c.map(l=>O.Range.from(l));else if(i instanceof A.$xM){const{lineNumber:l,column:b}=O.Position.from(i);f=[{startLineNumber:l,startColumn:b,endLineNumber:l,endColumn:b}]}else if(i instanceof A.$yM)f=[O.Range.from(i)];else{f=[];for(const l of i)if(l instanceof A.$yM)f.push(O.Range.from(l));else{const{lineNumber:b,column:I}=O.Position.from(l);f.push({startLineNumber:b,startColumn:I,endLineNumber:b,endColumn:I})}}return D.$tryInsertSnippet(u,r.value.version,n.value,f,g)},setDecorations(n,i){const g=i.length===0;g&&!s.h.has(n.key)||(g?s.h.delete(n.key):s.h.add(n.key),s.n(()=>{if(O.$VO(i))return D.$trySetDecorations(u,n.key,O.$WO(i));{const f=new Array(4*i.length);for(let l=0,b=i.length;l<b;l++){const I=i[l];f[4*l]=I.start.line+1,f[4*l+1]=I.start.character+1,f[4*l+2]=I.end.line+1,f[4*l+3]=I.end.character+1}return D.$trySetDecorationsFast(u,n.key,f)}}))},revealRange(n,i){s.n(()=>D.$tryRevealRange(u,O.Range.from(n),i||A.TextEditorRevealType.Default))},show(n){D.$tryShowEditor(u,O.ViewColumn.from(n))},hide(){D.$tryHideEditor(u)}})}dispose(){(0,E.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,E.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,E.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,E.ok)(!this.g),this.f=u}_acceptSelections(u){(0,E.ok)(!this.g),this.c=u}async l(){const u=this.c.map(O.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const D=u.finalize();if(D.edits.length===0&&!D.setEndOfLine)return Promise.resolve(!0);const d=D.edits.map(o=>o.range);d.sort((o,a)=>o.end.line===a.end.line?o.end.character===a.end.character?o.start.line===a.start.line?o.start.character-a.start.character:o.start.line-a.start.line:o.end.character-a.end.character:o.end.line-a.end.line);for(let o=0,a=d.length-1;o<a;o++){const h=d[o].end;if(d[o+1].start.isBefore(h))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const r=D.edits.map(o=>({range:O.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,D.documentVersionId,r,{setEndOfLine:typeof D.setEndOfLine=="number"?O.EndOfLine.from(D.setEndOfLine):void 0,undoStopBefore:D.undoStopBefore,undoStopAfter:D.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,D=>(D instanceof Error&&D.name==="DISPOSED"||this.k.warn(D),null))}}e.$8O=C}),define(ke[71],Ie([1,0,61,4,6,2,3,5,121,17,125,10,12,29,16,40,47]),function(de,e,E,R,P,O,A,M,$,c,C,v,u,D,d,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0O=e.$9O=void 0;class a{constructor(s){this.value=s,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let h=class{constructor(s,n){this.h=s,this.i=n,this.a=null,this.b=new Map,this.c=new D.$Ac,this.d=new R.$he,this.e=new R.$he,this.f=new R.$he,this.g=new R.$he,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(s){this.acceptDocumentsAndEditorsDelta(s)}acceptDocumentsAndEditorsDelta(s){const n=[],i=[],g=[];if(s.removedDocuments)for(const f of s.removedDocuments){const l=O.URI.revive(f),b=this.c.get(l);b?.unref()&&(this.c.delete(l),n.push(b.value))}if(s.addedDocuments)for(const f of s.addedDocuments){const l=O.URI.revive(f.uri);let b=this.c.get(l);if(b&&l.scheme!==d.Schemas.vscodeNotebookCell&&l.scheme!==d.Schemas.vscodeInteractiveInput)throw new Error(`document '${l} already exists!'`);b||(b=new a(new $.$2O(this.h.getProxy(M.$uM.MainThreadDocuments),l,f.lines,f.EOL,f.versionId,f.languageId,f.isDirty)),this.c.set(l,b),i.push(b.value)),b.ref()}if(s.removedEditors)for(const f of s.removedEditors){const l=this.b.get(f);this.b.delete(f),l&&g.push(l)}if(s.addedEditors)for(const f of s.addedEditors){const l=O.URI.revive(f.documentUri);E.ok(this.c.has(l),`document '${l}' does not exist`),E.ok(!this.b.has(f.id),`editor '${f.id}' already exists!`);const b=this.c.get(l).value,I=new C.$8O(f.id,this.h.getProxy(M.$uM.MainThreadTextEditors),this.i,new o.$V(()=>b.document),f.selections.map(v.Selection.to),f.options,f.visibleRanges.map(S=>v.Range.to(S)),typeof f.editorPosition=="number"?v.ViewColumn.to(f.editorPosition):void 0);this.b.set(f.id,I)}s.newActiveEditor!==void 0&&(E.ok(s.newActiveEditor===null||this.b.has(s.newActiveEditor),`active editor '${s.newActiveEditor}' does not exist`),this.a=s.newActiveEditor),(0,P.$Pc)(n),(0,P.$Pc)(g),s.removedDocuments&&this.e.fire(n),s.addedDocuments&&this.d.fire(i),(s.removedEditors||s.addedEditors)&&this.f.fire(this.allEditors().map(f=>f.value)),s.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(s){return this.c.get(s)?.value}allDocuments(){return r.Iterable.map(this.c.values(),s=>s.value)}getEditor(s){return this.b.get(s)}activeEditor(s){if(!this.a)return;const n=this.b.get(this.a);return s?n:n?.value}allEditors(){return[...this.b.values()]}};e.$9O=h,e.$9O=h=He([Ve(0,c.$YO),Ve(1,u.$7j)],h),e.$0O=(0,A.$Ai)("IExtHostDocumentsAndEditors")}),define(ke[300],Ie([1,0,18,4,5,125,10,7]),function(de,e,E,R,P,O,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1mc=void 0;class ${constructor(C,v){this.i=v,this.a=new R.$he,this.b=new R.$he,this.c=new R.$he,this.d=new R.$he,this.f=new R.$he,this.g=new R.$he,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=C.getProxy(P.$uM.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(u=>this.g.fire(u)),this.i.onDidChangeActiveTextEditor(u=>this.f.fire(u))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(C){const v=this.i.allEditors();return C?v:v.map(u=>u.value)}async showTextDocument(C,v,u){let D;typeof v=="number"?D={position:A.ViewColumn.from(v),preserveFocus:u}:typeof v=="object"?D={position:A.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus,selection:typeof v.selection=="object"?A.Range.from(v.selection):void 0,pinned:typeof v.preview=="boolean"?!v.preview:void 0}:D={preserveFocus:!1};const d=await this.h.$tryShowTextDocument(C.uri,D),r=d&&this.i.getEditor(d);if(r)return r.value;throw d?new Error(`Could NOT open editor for "${C.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${C.uri.toString()}".`)}createTextEditorDecorationType(C,v){return new O.$6O(this.h,C,v).value}$acceptEditorPropertiesChanged(C,v){const u=this.i.getEditor(C);if(!u)throw new Error("unknown text editor");if(v.options&&u._acceptOptions(v.options),v.selections){const D=v.selections.selections.map(A.Selection.to);u._acceptSelections(D)}if(v.visibleRanges){const D=E.$Hb(v.visibleRanges.map(A.Range.to));u._acceptVisibleRanges(D)}if(v.options&&this.b.fire({textEditor:u.value,options:{...v.options,lineNumbers:A.TextEditorLineNumbersStyle.to(v.options.lineNumbers)}}),v.selections){const D=M.TextEditorSelectionChangeKind.fromValue(v.selections.source),d=v.selections.selections.map(A.Selection.to);this.a.fire({textEditor:u.value,selections:d,kind:D})}if(v.visibleRanges){const D=E.$Hb(v.visibleRanges.map(A.Range.to));this.c.fire({textEditor:u.value,visibleRanges:D})}}$acceptEditorPositionData(C){for(const v in C){const u=this.i.getEditor(v);if(!u)throw new Error("Unknown text editor");const D=A.ViewColumn.to(C[v]);u.value.viewColumn!==D&&(u._acceptViewColumn(D),this.d.fire({textEditor:u.value,viewColumn:D}))}}getDiffInformation(C){return Promise.resolve(this.h.$getDiffInformation(C))}}e.$1mc=$}),define(ke[301],Ie([1,0,2,3,5,6,7,10,19,37,15]),function(de,e,E,R,P,O,A,M,$,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Koc=e.$Joc=void 0,e.$Joc=(0,R.$Ai)("IExtHostTimeline");class v{constructor(d,r){this.b=new Map,this.c=new Map,this.a=d.getProxy(P.$uM.MainThreadTimeline),r.registerArgumentProcessor({processArgument:(o,a)=>{if(o&&o.$mid===c.MarshalledId.TimelineActionContext)if(this.b.get(o.source)&&$.$Wm.equals(a,this.b.get(o.source)?.extension)){const h=o.uri===void 0?void 0:E.URI.revive(o.uri);return this.c.get(o.source)?.get(u(h))?.get(o.handle)}else return;return o}})}async $getTimeline(d,r,o,a){return this.b.get(d)?.provider.provideTimeline(E.URI.revive(r),o,a)}registerTimelineProvider(d,r,o,a){const h=new O.$Tc,t=this.d(r.id,a,h).bind(this);let s;r.onDidChange&&(s=r.onDidChange(i=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...i,id:r.id}),this));const n=this.c;return this.f({...r,scheme:d,onDidChange:void 0,async provideTimeline(i,g,f){g?.resetCache&&(h.clear(),n.get(r.id)?.clear());const l=await r.provideTimeline(i,g,f);if(l==null)return;const b=t(i,g);return{...l,source:r.id,items:l.items.map(b)}},dispose(){for(const i of n.values())i.get(r.id)?.clear();s?.dispose(),h.dispose()}},o)}d(d,r,o){return(a,h)=>{let t;if(h?.cacheResults){let s=this.c.get(d);s===void 0&&(s=new Map,this.c.set(d,s));const n=u(a);t=s.get(n),t===void 0&&(t=new Map,s.set(n,t))}return s=>{const{iconPath:n,...i}=s,g=`${d}|${s.id??s.timestamp}`;t?.set(g,s);let f,l,b;s.iconPath&&(n instanceof A.$tN?b={id:n.id,color:n.color}:E.URI.isUri(n)?(f=n,l=n):{light:f,dark:l}=n);let I;return A.$YM.isMarkdownString(i.tooltip)?I=M.MarkdownString.from(i.tooltip):(0,C.$ag)(i.tooltip)?I=i.tooltip:A.$YM.isMarkdownString(i.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),I=M.MarkdownString.from(i.detail)):(0,C.$ag)(i.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),I=i.detail),{...i,id:i.id??void 0,handle:g,source:d,command:s.command?r.toInternal(s.command,o):void 0,icon:f,iconDark:l,themeIcon:b,tooltip:I,accessibilityInformation:s.accessibilityInformation}}}}f(d,r){if(this.b.get(d.id))throw new Error(`Timeline Provider ${d.id} already exists.`);return this.a.$registerTimelineProvider({id:d.id,label:d.label,scheme:d.scheme}),this.b.set(d.id,{provider:d,extension:r}),(0,O.$Sc)(()=>{for(const a of this.c.values())a.get(d.id)?.clear();this.b.delete(d.id),this.a.$unregisterTimelineProvider(d.id),d.dispose()})}}e.$Koc=v;function u(D){return D?.toString()}}),define(ke[302],Ie([1,0,188,24,2,4,6,231,11,7,15,18,10,59,22,152,25]),function(de,e,E,R,P,O,A,M,$,c,C,v,u,D,d,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Loc=void 0;function a(s,n){if((0,C.$ag)(s))return{label:s};if(s&&typeof s=="object"&&typeof s.label=="string"){let i;return Array.isArray(s.highlights)&&(i=s.highlights.filter(g=>g.length===2&&typeof g[0]=="number"&&typeof g[1]=="number"),i=i.length?i:void 0),{label:s.label,highlights:i}}}class h extends A.$Uc{constructor(n,i,g){super(),this.f=n,this.g=i,this.h=g,this.a=new Map,this.b=new r.$00;function f(l){return l&&l.$treeViewId&&(l.$treeItemHandle||l.$selectedTreeItems||l.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:l=>f(l)?this.r(l):Array.isArray(l)&&l.length>0?l.map(b=>f(b)?this.r(b):b):l})}registerTreeDataProvider(n,i,g){const f=this.createTreeView(n,{treeDataProvider:i},g);return{dispose:()=>f.dispose()}}createTreeView(n,i,g){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const f=i.dragAndDropController?.dropMimeTypes??[],l=i.dragAndDropController?.dragMimeTypes??[],b=!!i.dragAndDropController?.handleDrag,I=!!i.dragAndDropController?.handleDrop,S=this.m(n,i,g),y={showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:f,dragMimeTypes:l,hasHandleDrag:b,hasHandleDrop:I,manuallyManageCheckboxes:!!i.manageCheckboxStateManually},p=this.f.$registerTreeViewDataProvider(n,y),k={get onDidCollapseElement(){return S.onDidCollapseElement},get onDidExpandElement(){return S.onDidExpandElement},get selection(){return S.selectedElements},get onDidChangeSelection(){return S.onDidChangeSelection},get activeItem(){return(0,o.$UG)(g,"treeViewActiveItem"),S.focusedElement},get onDidChangeActiveItem(){return(0,o.$UG)(g,"treeViewActiveItem"),S.onDidChangeActiveItem},get visible(){return S.visible},get onDidChangeVisibility(){return S.onDidChangeVisibility},get onDidChangeCheckboxState(){return S.onDidChangeCheckboxState},get message(){return S.message},set message(m){(0,D.$Zk)(m)&&(0,o.$UG)(g,"treeViewMarkdownMessage"),S.message=m},get title(){return S.title},set title(m){S.title=m},get description(){return S.description},set description(m){S.description=m},get badge(){return S.badge},set badge(m){m!==void 0&&c.ViewBadge.isViewBadge(m)?S.badge={value:Math.floor(Math.abs(m.value)),tooltip:m.tooltip}:m===void 0&&(S.badge=void 0)},reveal:(m,w)=>S.reveal(m,w),dispose:async()=>{await p,this.a.delete(n),S.dispose()}};return this.B(k),k}$getChildren(n,i){const g=this.a.get(n);return g?g.getChildren(i):Promise.reject(new M.$dG(n))}async $handleDrop(n,i,g,f,l,b,I,S){const y=this.a.get(n);if(!y)return Promise.reject(new M.$dG(n));const p=u.DataTransfer.toDataTransfer(g,async k=>(await this.f.$resolveDropFileData(n,i,k)).buffer);return I===n&&S&&await this.j(p,y,S,l,b),y.onDrop(p,f,l)}async j(n,i,g,f,l){const b=this.b.removeDragOperationTransfer(l);if(b)(await b)?.forEach((I,S)=>{I&&n.set(S,I)});else if(l&&i.handleDrag){const I=i.handleDrag(g,n,f);this.b.addDragOperationTransfer(l,I),await I}return n}async $handleDrag(n,i,g,f){const l=this.a.get(n);if(!l)return Promise.reject(new M.$dG(n));const b=await this.j(new c.$pN,l,i,f,g);if(!(!b||f.isCancellationRequested))return u.DataTransfer.from(b)}async $hasResolve(n){const i=this.a.get(n);if(!i)throw new M.$dG(n);return i.hasResolve}$resolve(n,i,g){const f=this.a.get(n);if(!f)throw new M.$dG(n);return f.resolveTreeItem(i,g)}$setExpanded(n,i,g){const f=this.a.get(n);if(!f)throw new M.$dG(n);f.setExpanded(i,g)}$setSelectionAndFocus(n,i,g){const f=this.a.get(n);if(!f)throw new M.$dG(n);f.setSelectionAndFocus(i,g)}$setVisible(n,i){const g=this.a.get(n);if(!g){if(!i)return;throw new M.$dG(n)}g.setVisible(i)}$changeCheckboxState(n,i){const g=this.a.get(n);if(!g)throw new M.$dG(n);g.setCheckboxState(i)}m(n,i,g){const f=this.B(new t(n,i,this.f,this.g.converter,this.h,g));return this.a.set(n,f),f}r(n){const i=this.a.get(n.$treeViewId);return i&&"$treeItemHandle"in n?i.getExtensionElement(n.$treeItemHandle):i&&"$focusedTreeItem"in n&&n.$focusedTreeItem?i.focusedElement:null}}e.$Loc=h;class t extends A.$Uc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(n=>this.getExtensionElement(n)).filter(n=>!(0,C.$jg)(n))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(n,i,g,f,l,b){if(super(),this.I=n,this.J=g,this.L=f,this.M=l,this.N=b,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new O.$he),this.onDidExpandElement=this.u.event,this.w=this.B(new O.$he),this.onDidCollapseElement=this.w.event,this.y=this.B(new O.$he),this.onDidChangeSelection=this.y.event,this.z=this.B(new O.$he),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new O.$he),this.onDidChangeVisibility=this.C.event,this.D=this.B(new O.$he),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new O.$he),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new d.$se,b.contributes&&b.contributes.views)for(const p in b.contributes.views)for(const k of b.contributes.views[p])k.id===n&&(this.P=k.name);this.f=i.treeDataProvider,this.g=i.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(p=>{Array.isArray(p)&&p.length===0||this.F.fire({message:!1,element:p})}));let I,S;const y=O.Event.debounce(this.F.event,(p,k)=>(p||(p={message:!1,elements:[]}),k.element!==!1&&(I||(I=new Promise(m=>S=m),this.G=this.G.then(()=>I)),Array.isArray(k.element)?p.elements.push(...k.element):p.elements.push(k.element)),k.message&&(p.message=!0),p),200,!0);this.B(y(({message:p,elements:k})=>{k.length&&(this.H=this.H.then(()=>{const m=S;return I=null,this.$(k).then(()=>m())})),p&&this.J.$setMessage(this.I,u.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(n){const i=n?this.getExtensionElement(n):void 0;if(n&&!i)return this.M.error(`No tree item with id '${n}' found.`),Promise.resolve([]);let g=this.X(n);return g||(g=await this.Y(i)),g?g.map(f=>f.item):void 0}getExtensionElement(n){return this.j.get(n)}reveal(n,i){i=i||{select:!0,focus:!1};const g=(0,C.$jg)(i.select)?!0:i.select,f=(0,C.$jg)(i.focus)?!1:i.focus,l=(0,C.$jg)(i.expand)?!1:i.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):n?this.G.then(()=>this.S(n)).then(b=>this.W(n,b[b.length-1]).then(I=>this.J.$reveal(this.I,{item:I.item,parentChain:b.map(S=>S.item)},{select:g,focus:f,expand:l})),b=>this.M.error(b)):this.J.$reveal(this.I,void 0,{select:g,focus:f,expand:l})}get message(){return this.O}set message(n){this.O=n,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(n){this.P=n,this.J.$setTitle(this.I,n,this.Q)}get description(){return this.Q}set description(n){this.Q=n,this.J.$setTitle(this.I,this.P,n)}get badge(){return this.R}set badge(n){this.R?.value===n?.value&&this.R?.tooltip===n?.tooltip||(this.R=u.ViewBadge.from(n),this.J.$setBadge(this.I,n))}setExpanded(n,i){const g=this.getExtensionElement(n);g&&(i?this.u.fire(Object.freeze({element:g})):this.w.fire(Object.freeze({element:g})))}setSelectionAndFocus(n,i){const g=!(0,v.$ub)(this.s,n);this.s=n;const f=this.t!==i;this.t=i,g&&this.y.fire(Object.freeze({selection:this.selectedElements})),f&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(n){n!==this.r&&(this.r=n,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(n){const i=(await Promise.all(n.map(async g=>{const f=this.getExtensionElement(g.treeItemHandle);return f?{extensionItem:f,treeItem:await this.f.getTreeItem(f),newState:g.newState?c.TreeItemCheckboxState.Checked:c.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(g=>g!==void 0);i.forEach(g=>{g.treeItem.checkboxState=g.newState?c.TreeItemCheckboxState.Checked:c.TreeItemCheckboxState.Unchecked}),this.D.fire({items:i.map(g=>[g.extensionItem,g.newState])})}async handleDrag(n,i,g){const f=[];for(const l of n){const b=this.getExtensionElement(l);b&&f.push(b)}if(!(!this.g?.handleDrag||f.length===0))return await this.g.handleDrag(f,i,g),i}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(n,i,g){const f=i?this.getExtensionElement(i):void 0;if(!(!f&&i||!this.g?.handleDrop))return(0,$.$sh)(()=>this.g?.handleDrop?this.g.handleDrop(f,n,g):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(n,i){if(!this.f.resolveTreeItem)return;const g=this.j.get(n);if(g){const f=this.m.get(g);if(f){const l=await this.f.resolveTreeItem(f.extensionItem,g,i)??f.extensionItem;return this.hb(l),f.item.tooltip=this.eb(l.tooltip),f.item.command=this.fb(f.disposableStore,l.command),f.item}}}S(n){return this.U(n).then(i=>i?this.S(i).then(g=>this.W(i,g[g.length-1]).then(f=>(g.push(f),g))):Promise.resolve([]))}U(n){const i=this.m.get(n);return i?Promise.resolve(i.parent?this.j.get(i.parent.item.handle):void 0):(0,$.$sh)(()=>this.f.getParent(n))}W(n,i){const g=this.m.get(n);return g?Promise.resolve(g):(0,$.$sh)(()=>this.f.getTreeItem(n)).then(f=>this.kb(n,f,i,!0)).then(f=>this.getChildren(i?i.item.handle:void 0).then(()=>{const l=this.getExtensionElement(f);if(l){const b=this.m.get(l);if(b)return Promise.resolve(b)}throw new Error(`Cannot resolve tree item for element ${f} from extension ${this.N.identifier.value}`)}))}X(n){if(n){let i;if(typeof n=="string"){const g=this.getExtensionElement(n);i=g?this.m.get(g):void 0}else i=n;return i&&i.children||void 0}return this.h}async Y(n){this.rb(n);const i=new d.$se(this.Z.token);try{const g=n?this.m.get(n):void 0,f=await this.f.getChildren(n);if(i.token.isCancellationRequested)return;const l=(0,v.$Hb)(f||[]),b=await Promise.all((0,v.$Hb)(l).map(S=>this.f.getTreeItem(S)));if(i.token.isCancellationRequested)return;const I=b.map((S,y)=>S?this.db(l[y],S,g):null);return(0,v.$Hb)(I)}finally{i.dispose()}}$(n){if(n.some(g=>!g))return this.Z.dispose(!0),this.Z=new d.$se,this.tb(),this.J.$refresh(this.I);{const g=this.ab(n);if(g.length)return this.bb(g)}return Promise.resolve(void 0)}ab(n){const i=new Set,g=n.map(l=>this.m.get(l));for(const l of g)if(l&&!i.has(l.item.handle)){let b=l;for(;b&&b.parent&&g.findIndex(I=>b&&b.parent&&I&&I.item.handle===b.parent.item.handle)===-1;){const I=this.j.get(b.parent.item.handle);b=I?this.m.get(I):void 0}b&&!b.parent&&i.add(l.item.handle)}const f=[];return i.forEach(l=>{const b=this.j.get(l);if(b){const I=this.m.get(b);I&&(!I.parent||!i.has(I.parent.item.handle))&&f.push(l)}}),f}bb(n){const i={};return Promise.all(n.map(g=>this.cb(g).then(f=>{f&&(i[g]=f.item)}))).then(()=>Object.keys(i).length?this.J.$refresh(this.I,i):void 0)}cb(n){const i=this.getExtensionElement(n);if(i){const g=this.m.get(i);if(g)return this.rb(i),(0,$.$sh)(()=>this.f.getTreeItem(i)).then(f=>{if(f){const l=this.ib(i,f,g.parent);return this.pb(i,l,g,g.parent),g.dispose(),l}return null})}return Promise.resolve(null)}db(n,i,g){const f=this.ib(n,i,g);if(i.id&&this.j.has(f.item.handle))throw new Error((0,E.localize)(0,null,i.id));return this.ob(n,f),this.qb(f,g),f}eb(n){return c.$YM.isMarkdownString(n)?u.MarkdownString.from(n):n}fb(n,i){return i?{...this.L.toInternal(i,n),originalId:i.command}:void 0}gb(n){if(n.checkboxState===void 0)return;let i,g,f;return typeof n.checkboxState=="number"?i=n.checkboxState:(i=n.checkboxState.state,g=n.checkboxState.tooltip,f=n.checkboxState.accessibilityInformation),{isChecked:i===c.TreeItemCheckboxState.Checked,tooltip:g,accessibilityInformation:f}}hb(n){if(!c.$kN.isTreeItem(n,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(n,i,g){this.hb(i);const f=this.B(new A.$Tc),l=this.kb(n,i,g),b=this.lb(i);return{item:{handle:l,parentHandle:g?g.item.handle:void 0,label:a(i.label,this.N),description:i.description,resourceUri:i.resourceUri,tooltip:this.eb(i.tooltip),command:this.fb(f,i.command),contextValue:i.contextValue,icon:b,iconDark:this.mb(i)||b,themeIcon:this.jb(i),collapsibleState:(0,C.$jg)(i.collapsibleState)?c.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.gb(i)},extensionItem:i,parent:g,children:void 0,disposableStore:f,dispose(){f.dispose()}}}jb(n){return n.iconPath instanceof c.$tN?n.iconPath:void 0}kb(n,{id:i,label:g,resourceUri:f},l,b){if(i)return`${t.b}/${i}`;const I=a(g,this.N),S=l?l.item.handle:t.a;let y=I?I.label:f?(0,R.$$g)(f):"";y=y.indexOf("/")!==-1?y.replace("/","//"):y;const p=this.m.has(n)?this.m.get(n).item.handle:void 0,k=this.X(l)||[];let m,w=0;do{if(m=`${S}/${w}:${y}`,b||!this.j.has(m)||p===m)break;w++}while(w<=k.length);return m}lb(n){if(n.iconPath&&!(n.iconPath instanceof c.$tN))return typeof n.iconPath=="string"||P.URI.isUri(n.iconPath)?this.nb(n.iconPath):this.nb(n.iconPath.light)}mb(n){if(n.iconPath&&!(n.iconPath instanceof c.$tN)&&n.iconPath.dark)return this.nb(n.iconPath.dark)}nb(n){return P.URI.isUri(n)?n:P.URI.file(n)}ob(n,i){this.j.set(i.item.handle,n),this.m.set(n,i)}pb(n,i,g,f){this.j.delete(i.item.handle),this.m.delete(n),i.item.handle!==g.item.handle&&this.j.delete(g.item.handle),this.ob(n,i);const l=this.X(f)||[],b=l.filter(I=>I.item.handle===g.item.handle)[0];b&&l.splice(l.indexOf(b),1,i)}qb(n,i){i?(i.children||(i.children=[]),i.children.push(n)):(this.h||(this.h=[]),this.h.push(n))}rb(n){if(n){const i=this.m.get(n);if(i){if(i.children)for(const g of i.children){const f=this.j.get(g.item.handle);f&&this.sb(f)}i.children=void 0}}else this.tb()}sb(n){const i=this.m.get(n);if(i){if(i.children)for(const g of i.children){const f=this.j.get(g.item.handle);f&&this.sb(f)}this.m.delete(n),this.j.delete(i.item.handle),i.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(n=>n.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(ke[303],Ie([1,0,4,6,2,36,10,67,5,7]),function(de,e,E,R,P,O,A,M,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hnc=void 0;class C extends R.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(d,r,o,a){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new E.$he),this.onDidDispose=this.#d.event,this.#h=this.B(new E.$he),this.onDidChangeViewState=this.#h.event,this.#e=d,this.#t=r,this.#n=o,this.#i=a.viewType,this.#s=a.panelOptions,this.#o=a.viewColumn,this.#r=a.title,this.#u=a.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(d){this.c(),this.#r!==d&&(this.#r=d,this.#t.$setTitle(this.#e,d))}get iconPath(){return this.c(),this.#a}set iconPath(d){this.c(),this.#a!==d&&(this.#a=d,this.#t.$setIconPath(this.#e,P.URI.isUri(d)?{light:d,dark:d}:d))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(d){this.#l||(this.active!==d.active||this.visible!==d.visible||this.viewColumn!==d.viewColumn)&&(this.#u=d.active,this.#c=d.visible,this.#o=d.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(d,r){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof d>"u"?void 0:A.ViewColumn.from(d),preserveFocus:!!r})}c(){if(this.#l)throw new Error("Webview is disposed")}}class v extends R.$Uc{static c(){return(0,O.$Wg)()}constructor(d,r,o){super(),this.j=r,this.m=o,this.g=new Map,this.h=new Map,this.f=d.getProxy($.$uM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(d=>d.dispose()),this.g.clear()}createWebviewPanel(d,r,o,a,h={}){const t=typeof a=="object"?a.viewColumn:a,s={viewColumn:A.ViewColumn.from(t),preserveFocus:typeof a=="object"&&!!a.preserveFocus},n=(0,M.$dnc)(d),i=v.c();this.f.$createWebviewPanel((0,M.$fnc)(d),i,r,{title:o,panelOptions:u(h),webviewOptions:(0,M.$gnc)(d,this.m,h),serializeBuffersForPostMessage:n},s);const g=this.j.createNewWebview(i,h,d);return this.createNewWebviewPanel(i,r,o,t,h,g,!0)}$onDidChangeWebviewPanelViewStates(d){const r=Object.keys(d);r.sort((o,a)=>{const h=d[o],t=d[a];return h.active?1:t.active?-1:+h.visible-+t.visible});for(const o of r){const a=this.getWebviewPanel(o);if(!a)continue;const h=d[o];a._updateViewState({active:h.active,visible:h.visible,viewColumn:A.ViewColumn.to(h.position)})}}async $onDidDisposeWebviewPanel(d){this.getWebviewPanel(d)?.dispose(),this.g.delete(d),this.j.deleteWebview(d)}registerWebviewPanelSerializer(d,r,o){if(this.h.has(r))throw new Error(`Serializer for '${r}' already registered`);return this.h.set(r,{serializer:o,extension:d}),this.f.$registerSerializer(r,{serializeBuffersForPostMessage:(0,M.$dnc)(d)}),new c.$wM(()=>{this.h.delete(r),this.f.$unregisterSerializer(r)})}async $deserializeWebviewPanel(d,r,o,a){const h=this.h.get(r);if(!h)throw new Error(`No serializer found for '${r}'`);const{serializer:t,extension:s}=h,n=this.j.createNewWebview(d,o.webviewOptions,s),i=this.createNewWebviewPanel(d,r,o.title,a,o.panelOptions,n,o.active);await t.deserializeWebviewPanel(i,o.state)}createNewWebviewPanel(d,r,o,a,h,t,s){const n=new C(d,this.f,t,{viewType:r,title:o,viewColumn:a,panelOptions:h,active:s});return this.g.set(d,n),n}getWebviewPanel(d){return this.g.get(d)}}e.$hnc=v;function u(D){return{enableFindWidget:D.enableFindWidget,retainContextWhenHidden:D.retainContextWhenHidden}}}),define(ke[304],Ie([1,0,4,6,67,10,5,7]),function(de,e,E,R,P,O,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ooc=void 0;class $ extends R.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(v,u,D,d,r,o){super(),this.#s=!1,this.#u=this.B(new E.$he),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new E.$he),this.onDidDispose=this.#l.event,this.#i=D,this.#a=d,this.#e=v,this.#t=u,this.#n=r,this.#r=o}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(v){this.a(),this.#a!==v&&(this.#a=v,this.#t.$setWebviewViewTitle(this.#e,v))}get description(){return this.a(),this.#o}set description(v){this.a(),this.#o!==v&&(this.#o=v,this.#t.$setWebviewViewDescription(this.#e,v))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(v){v===this.#r||this.#s||(this.#r=v,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(v){this.a(),!(v?.value===this.#c?.value&&v?.tooltip===this.#c?.tooltip)&&(this.#c=O.ViewBadge.from(v),this.#t.$setWebviewViewBadge(this.#e,v))}show(v){this.a(),this.#t.$show(this.#e,!!v)}a(){if(this.#s)throw new Error("Webview is disposed")}}class c{constructor(v,u){this.d=u,this.b=new Map,this.c=new Map,this.a=v.getProxy(A.$uM.MainThreadWebviewViews)}registerWebviewViewProvider(v,u,D,d){if(this.b.has(u))throw new Error(`View provider for '${u}' already registered`);return this.b.set(u,{provider:D,extension:v}),this.a.$registerWebviewViewProvider((0,P.$fnc)(v),u,{retainContextWhenHidden:d?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,P.$dnc)(v)}),new M.$wM(()=>{this.b.delete(u),this.a.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(v,u,D,d,r){const o=this.b.get(u);if(!o)throw new Error(`No view provider found for '${u}'`);const{provider:a,extension:h}=o,t=this.d.createNewWebview(v,{},h),s=new $(v,this.a,u,D,t,!0);this.c.set(v,s),await a.resolveWebviewView(s,{state:d},r)}async $onDidChangeWebviewViewVisibility(v,u){this.e(v)._setVisible(u)}async $disposeWebviewView(v){const u=this.e(v);this.c.delete(v),u.dispose(),this.d.deleteWebview(v)}e(v){const u=this.c.get(v);if(!u)throw new Error("No webview found");return u}}e.$Ooc=c}),define(ke[305],Ie([1,0,4,31,32,3]),function(de,e,E,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QL=e.$PL=e.OutputChannelUpdateMode=e.$OL=e.$NL=e.$ML=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=void 0,e.$CL="text/x-code-output",e.$DL="output",e.$EL="Log",e.$FL="text/x-code-log-output",e.$GL="log",e.$HL="workbench.panel.output",e.$IL=new P.$Rj("inOutput",!1),e.$JL=new P.$Rj("activeLogOutput",!1),e.$KL=new P.$Rj("activeLogOutput.levelSettable",!1),e.$LL=new P.$Rj("activeLogOutput.level",""),e.$ML=new P.$Rj("activeLogOutput.levelIsDefault",!1),e.$NL=new P.$Rj("outputView.scrollLock",!1),e.$OL=(0,O.$Ai)("outputService");var A;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$PL={OutputChannels:"workbench.contributions.outputChannels"};class M{constructor(){this.a=new Map,this.b=new E.$he,this.onDidRegisterChannel=this.b.event,this.c=new E.$he,this.onDidRemoveChannel=this.c.event}registerChannel(c){this.a.has(c.id)||(this.a.set(c.id,c),this.b.fire(c.id))}getChannels(){const c=[];return this.a.forEach(C=>c.push(C)),c}getChannel(c){return this.a.get(c)}removeChannel(c){this.a.delete(c),this.c.fire(c)}}R.$jo.add(e.$PL.OutputChannels,new M),e.$QL=new P.$Rj("activeOutputChannel","")}),define(ke[126],Ie([1,0,5,3,17,19,12,305,68,27,51,156,23,15,30,4,6]),function(de,e,E,R,P,O,A,M,$,c,C,v,u,D,d,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ooc=e.$noc=void 0;class a extends A.$ak{get disposed(){return this.n}constructor(n,i,g,f,l){super(),this.id=n,this.name=i,this.r=g,this.s=f,this.extension=l,this.m=0,this.n=!1,this.visible=!1,this.setLevel(g.getLevel()),this.B(g.onDidChangeLogLevel(b=>this.setLevel(b)))}get logLevel(){return this.getLevel()}appendLine(n){this.append(n+`
`)}append(n){this.info(n)}clear(){const n=this.m;this.r.flush(),this.s.$update(this.id,M.OutputChannelUpdateMode.Clear,n)}replace(n){const i=this.m;this.info(n),this.s.$update(this.id,M.OutputChannelUpdateMode.Replace,i),this.visible&&this.r.flush()}show(n,i){this.r.flush(),this.s.$reveal(this.id,!!(typeof n=="boolean"?n:i))}hide(){this.s.$close(this.id)}g(n,i){this.m+=u.$Je.fromString(i).byteLength,(0,A.log)(this.r,n,i),this.visible&&(this.r.flush(),this.s.$update(this.id,M.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class h extends a{appendLine(n){this.append(n)}}let t=class{constructor(n,i,g,f,l,b){this.i=i,this.j=g,this.k=f,this.l=l,this.m=b,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=n.getProxy(E.$uM.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,v.$9m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(n){this.h=n;for(const[i,g]of this.g)g.visible=i===this.h}createOutputChannel(n,i,g){if(n=n.trim(),!n)throw new Error("illegal argument `name`. must not be falsy");const f=typeof i=="object"&&i.log,l=(0,D.$ag)(i)?i:void 0;if((0,D.$ag)(l)&&!l.trim())throw new Error("illegal argument `languageId`. must not be empty");let b;const I=this.i.environment.extensionLogLevel?.find(([y])=>O.$Wm.equals(g.identifier,y))?.[1];I&&(b=(0,A.$lk)(I));const S=f?this.o(n,b,g):this.n(n,l,g);return S.then(y=>{this.g.set(y.id,y),y.visible=y.id===this.h}),f?this.r(n,b??this.m.getLevel(),S):this.q(n,S)}async n(n,i,g){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const f=await this.c,l=this.k.extUri.joinPath(f,`${this.f++}-${n.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),b=this.l.createLogger(l,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),I=await this.a.$register(n,l,i,g.identifier.value);return new a(I,n,b,this.a,g)}async o(n,i,g){const f=await this.p(g),l=n.replace(/[\\/:\*\?"<>\|]/g,""),b=this.k.extUri.joinPath(f,`${l}.log`),I=`${g.identifier.value}.${l}`,S=this.l.createLogger(b,{id:I,name:n,logLevel:i,extensionId:g.identifier.value});return new h(I,n,S,this.a,g)}p(n){let i=this.d.get(n.identifier.value);if(!i){const g=this.k.extUri.joinPath(this.i.logsLocation,n.identifier.value);this.d.set(n.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(g)}catch(f){if((0,d.$kl)(f)!==d.FileSystemProviderErrorCode.FileExists)throw f}return g})())}return i}q(n,i){let g=!1;const f=()=>{if(g)throw new Error("Channel has been closed")};return{get name(){return n},append(l){f(),i.then(b=>b.append(l))},appendLine(l){f(),i.then(b=>b.appendLine(l))},clear(){f(),i.then(l=>l.clear())},replace(l){f(),i.then(b=>b.replace(l))},show(l,b){f(),i.then(I=>I.show(l,b))},hide(){f(),i.then(l=>l.hide())},dispose(){g=!0,i.then(l=>l.dispose())}}}r(n,i,g){const f=new o.$Tc,l=()=>{if(f.isDisposed)throw new Error("Channel has been closed")},b=f.add(new r.$he);function I(S){i=S,b.fire(S)}return g.then(S=>{f.add(S),S.logLevel!==i&&I(S.logLevel),f.add(S.onDidChangeLogLevel(y=>I(y)))}),{...this.q(n,g),get logLevel(){return i},onDidChangeLogLevel:b.event,trace(S,...y){l(),g.then(p=>p.trace(S,...y))},debug(S,...y){l(),g.then(p=>p.debug(S,...y))},info(S,...y){l(),g.then(p=>p.info(S,...y))},warn(S,...y){l(),g.then(p=>p.warn(S,...y))},error(S,...y){l(),g.then(p=>p.error(S,...y))},dispose(){f.dispose()}}}};e.$noc=t,e.$noc=t=He([Ve(0,P.$YO),Ve(1,c.$cP),Ve(2,$.$_mc),Ve(3,C.$Omc),Ve(4,A.$8j),Ve(5,A.$7j)],t),e.$ooc=(0,R.$Ai)("IExtHostOutputService")}),define(ke[127],Ie([1,0,3,11]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mn=e.$ln=void 0,e.$ln=(0,E.$Ai)("remoteAgentService"),e.$mn=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(P){let O=1/0;for(let M=0;M<this.maxSampleCount;M++){const $=await P.getRoundTripTime();if($===void 0)return;O=Math.min(O,$/2),await(0,R.$Bh)(this.sampleDelay)}this.average.push(O),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(O):A=this.initial.reduce((M,$)=>M+$,0)/this.initial.length,this.lastMeasurement={initial:A,current:O,average:this.average.reduce((M,$)=>M+$,0)/this.average.length,high:typeof A>"u"?!1:O>this.highLatencyMaxThreshold||O>this.highLatencyMinThreshold&&O>A*this.highLatencyMultiple},this.lastMeasurement}}}),define(ke[306],Ie([1,0,191,54,31,50,42,6,4,127,21,26,11,112]),function(de,e,E,R,P,O,A,M,$,c,C,v,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ohb=e.$nhb=e.$mhb=e.$lhb=e.$khb=e.$jhb=e.$ihb=e.$hhb=e.$ghb=void 0,e.$ghb=Object.freeze({id:"application",order:100,title:(0,E.localize)(0,null),type:"object"}),e.$hhb=Object.freeze({id:"workbench",order:7,title:(0,E.localize)(1,null),type:"object"}),e.$ihb=Object.freeze({id:"security",scope:R.ConfigurationScope.APPLICATION,title:(0,E.localize)(2,null),type:"object",order:7}),e.$jhb=Object.freeze({id:"problems",title:(0,E.localize)(3,null),type:"object",order:101}),e.$khb=Object.freeze({id:"window",order:8,title:(0,E.localize)(4,null),type:"object"}),e.$lhb={ConfigurationMigration:"base.contributions.configuration.migration"};class d{constructor(){this.migrations=[],this.a=new $.$he,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const r=new d;P.$jo.add(e.$lhb.ConfigurationMigration,r);let o=class extends M.$Uc{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,i){super(),this.a=n,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async g=>{for(const f of g.added)await this.f(f,r.migrations)})),this.c(r.migrations),this.B(r.onDidRegisterConfigurationMigration(g=>this.c(g)))}async c(n){await this.f(void 0,n);for(const i of this.b.getWorkspace().folders)await this.f(i,n)}async f(n,i){await Promise.all([i.map(g=>this.g(g,n?.uri))])}async g(n,i){const g=this.a.inspect(n.key,{resource:i}),f=this.b.getWorkbenchState()===O.WorkbenchState.WORKSPACE?[["user",A.ConfigurationTarget.USER],["userLocal",A.ConfigurationTarget.USER_LOCAL],["userRemote",A.ConfigurationTarget.USER_REMOTE],["workspace",A.ConfigurationTarget.WORKSPACE],["workspaceFolder",A.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",A.ConfigurationTarget.USER],["userLocal",A.ConfigurationTarget.USER_LOCAL],["userRemote",A.ConfigurationTarget.USER_REMOTE],["workspace",A.ConfigurationTarget.WORKSPACE]];for(const[l,b]of f){const I=g[l];if(!I)continue;const S=[];if(I.value!==void 0){const y=await this.h(n,l,I.value,i,void 0);for(const p of y??[])S.push([p,[]])}for(const{identifiers:y,value:p}of I.overrides??[])if(p!==void 0){const k=await this.h(n,l,p,i,y);for(const m of k??[])S.push([m,y])}S.length&&await Promise.allSettled(S.map(async([[y,p],k])=>this.a.updateValue(y,p.value,{resource:i,overrideIdentifiers:k},b)))}}async h(n,i,g,f,l){const b=S=>{const p=this.a.inspect(S,{resource:f})[i];if(p)return l?p.overrides?.find(({identifiers:k})=>(0,v.$ao)(k,l))?.value:p.value},I=await n.migrateFn(g,b);return Array.isArray(I)?I:[[n.key,I]]}};e.$mhb=o,e.$mhb=o=He([Ve(0,A.$7i),Ve(1,O.$Ji)],o);let a=class extends M.$Uc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.b=n,this.a=new u.$Xh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!C.$i&&(await this.b.getEnvironment())?.os!==C.OperatingSystem.Windows)return;P.$jo.as(R.$oo.Configuration).registerConfiguration({...e.$ihb,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,E.localize)(5,null)},default:[],markdownDescription:(0,E.localize)(6,null),scope:R.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,E.localize)(7,null),scope:R.ConfigurationScope.MACHINE}}})}};e.$nhb=a,e.$nhb=a=He([Ve(0,c.$ln)],a);const h="window.newWindowProfile";let t=class extends M.$Uc{static{this.ID="workbench.contrib.dynamicWindowConfiguration"}constructor(n,i){super(),this.c=n,this.f=i,this.g(),this.B(this.c.onDidChangeProfiles(g=>this.g())),this.h(),this.j(),this.B(i.onDidChangeConfiguration(g=>{g.source!==A.ConfigurationTarget.DEFAULT&&g.affectsConfiguration(h)&&this.h()})),this.B(this.c.onDidChangeProfiles(()=>this.j()))}g(){const n=P.$jo.as(R.$oo.Configuration),i={...e.$khb,properties:{[h]:{type:["string","null"],default:null,enum:[...this.c.profiles.map(g=>g.name),null],enumItemLabels:[...this.c.profiles.map(g=>""),(0,E.localize)(8,null)],description:(0,E.localize)(9,null),scope:R.ConfigurationScope.APPLICATION}}};this.a?n.updateConfigurations({add:[i],remove:[this.a]}):n.registerConfiguration(i),this.a=i}h(){const n=this.f.getValue(h);this.b=n?this.c.profiles.find(i=>i.name===n):void 0}j(){const n=this.f.getValue(h);if(!n)return;const i=this.b?this.c.profiles.find(g=>g.id===this.b.id):void 0;n!==i?.name&&this.f.updateValue(h,i?.name)}};e.$ohb=t,e.$ohb=t=He([Ve(0,D.$Gl),Ve(1,A.$7i)],t)}),define(ke[307],Ie([1,0,41,16,20,24,202,306,54,3,31]),function(de,e,E,R,P,O,A,M,$,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$qhb=e.$phb=void 0,e.$rhb=r,e.$shb=o,e.$phb=(0,c.$Ai)("editorResolverService"),e.$qhb="workbench.editorAssociations";const v=C.$jo.as($.$oo.Configuration),u={...M.$hhb,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,A.localize)(0,null),additionalProperties:{type:"string"}}}};v.registerConfiguration(u);var D;(function(a){a.builtin="builtin",a.option="option",a.exclusive="exclusive",a.default="default"})(D||(e.RegisteredEditorPriority=D={}));var d;(function(a){a[a.ABORT=1]="ABORT",a[a.NONE=2]="NONE"})(d||(e.ResolvedStatus=d={}));function r(a){switch(a){case D.exclusive:return 5;case D.default:return 4;case D.builtin:return 3;case D.option:default:return 1}}function o(a,h){if(new Set([R.Schemas.extension,R.Schemas.webviewPanel,R.Schemas.vscodeWorkspaceTrust,R.Schemas.vscodeSettings]).has(h.scheme))return!1;const n=typeof a=="string"&&a.indexOf(P.$gc.sep)>=0?`${h.scheme}:${h.path}`:(0,O.$$g)(h);return E.$tk(typeof a=="string"?a.toLowerCase():a,n.toLowerCase())}}),define(ke[308],Ie([1,0,53,16,20,21,24,2,3,225,50,245,127]),function(de,e,E,R,P,O,A,M,$,c,C,v,u){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$0L=e.$9L=void 0,e.$9L=(0,$.$Ai)("pathService");let d=D=class{constructor(o,a,h,t){this.d=o,this.e=a,this.f=h,this.g=t,this.a=(async()=>(await this.e.getEnvironment())?.os||O.OS)(),this.b=(async()=>{const s=await this.e.getEnvironment();return this.c=s?.userHome??o})()}hasValidBasename(o,a,h){return typeof a=="string"||typeof a>"u"?this.a.then(t=>this.h(o,t,a)):this.h(o,a,h)}h(o,a,h){return o.scheme===R.Schemas.file||o.scheme===R.Schemas.vscodeRemote?(0,E.$xg)(h??(0,A.$$g)(o),a===O.OperatingSystem.Windows):!0}get defaultUriScheme(){return D.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(o,a){if(o.remoteAuthority)return R.Schemas.vscodeRemote;const h=(0,c.$6L)(a.getWorkspace());if(h)return h;const t=a.getWorkspace().folders[0];if(t)return t.uri.scheme;const s=a.getWorkspace().configuration;return s?s.scheme:R.Schemas.file}userHome(o){return o?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(o=>o===O.OperatingSystem.Windows?P.$fc:P.$gc)}async fileURI(o){let a="";if(await this.a===O.OperatingSystem.Windows&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const t=o.indexOf("/",2);t===-1?(a=o.substring(2),o="/"):(a=o.substring(2,t),o=o.substring(t)||"/")}return M.URI.from({scheme:R.Schemas.file,authority:a,path:o,query:"",fragment:""})}};e.$0L=d,e.$0L=d=D=He([Ve(1,u.$ln),Ve(2,v.$RL),Ve(3,C.$Ji)],d)}),define(ke[128],Ie([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$BK=e.$AK=void 0;class E{constructor(A,M){this.line=A,this.character=M}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,M){return new E(0,0)}with(A){return new E(0,0)}}e.$AK=E;class R{constructor(A,M,$,c){this.isEmpty=!1,this.isSingleLine=!1,this.start=new E(A,M),this.end=new E($,c)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new R(0,0,0,0)}with(A){return new R(0,0,0,0)}}e.$BK=R;var P;(function(O){O[O.Information=1]="Information",O[O.Warning=2]="Warning"})(P||(e.TextSearchCompleteMessageType=P={}))}),define(ke[43],Ie([1,0,18,41,26,53,13,3,20,14,128,11]),function(de,e,E,R,P,O,A,M,$,c,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1K=e.$YK=e.$RK=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$OK=e.$NK=e.$MK=e.$LK=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.TextSearchCompleteMessageType=void 0,e.$IK=a,e.$JK=h,e.$KK=t,e.$PK=S,e.$QK=y,e.$SK=m,e.$TK=w,e.$UK=F,e.$VK=T,e.$WK=G,e.$XK=q,e.$ZK=N,e.$2K=re,e.$3K=fe,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return C.TextSearchCompleteMessageType}}),e.$CK="workbench.view.search",e.$DK="workbench.panel.search",e.$EK="workbench.view.search",e.$FK="search-result",e.$GK="search.exclude";const u="\u27EA ",D=" characters skipped \u27EB",d=(u.length+D.length+5)*2;e.$HK=(0,M.$Ai)("searchService");var r;(function(oe){oe[oe.file=0]="file",oe[oe.text=1]="text",oe[oe.aiText=2]="aiText"})(r||(e.SearchProviderType=r={}));var o;(function(oe){oe[oe.File=1]="File",oe[oe.Text=2]="Text",oe[oe.aiText=3]="aiText"})(o||(e.QueryType=o={}));function a(oe){return!!oe.preview}function h(oe){return!!oe.resource}function t(oe){return!!oe.message}var s;(function(oe){oe[oe.Normal=0]="Normal",oe[oe.NewSearchStarted=1]="NewSearchStarted"})(s||(e.SearchCompletionExitCode=s={}));class n{constructor(pe){this.resource=pe,this.results=[]}}e.$LK=n;class i{constructor(pe,$e,se,Ce){this.ranges=$e,this.webviewIndex=Ce;const Fe=Array.isArray($e)?$e:[$e];if(se&&se.matchLines===1&&g(Fe)){pe=(0,A.$6f)(pe,se.matchLines);let X="",W=0,ie=0;const Se=Math.floor(se.charsPerLine/5),he=[];for(const we of Fe){const ae=Math.max(we.startColumn-Se,0),Y=we.startColumn+se.charsPerLine;if(ae>ie+Se+d){const x=u+(ae-ie)+D;X+=x+pe.slice(ae,Y),W+=ae-(ie+x.length)}else X+=pe.slice(ie,Y);he.push(new l(0,we.startColumn-W,we.endColumn-W)),ie=Y}this.preview={text:X,matches:Array.isArray(this.ranges)?he:he[0]}}else{const X=Array.isArray($e)?$e[0].startLineNumber:$e.startLineNumber;this.preview={text:pe,matches:(0,E.$1b)($e,W=>new f(W.startLineNumber-X,W.startColumn,W.endLineNumber-X,W.endColumn))}}}}e.$MK=i;function g(oe){const pe=oe[0].startLineNumber;for(const $e of oe)if($e.startLineNumber!==pe||$e.endLineNumber!==pe)return!1;return!0}class f{constructor(pe,$e,se,Ce){this.startLineNumber=pe,this.startColumn=$e,this.endLineNumber=se,this.endColumn=Ce}}e.$NK=f;class l extends f{constructor(pe,$e,se){super(pe,$e,pe,se)}}e.$OK=l;var b;(function(oe){oe.List="list",oe.Tree="tree"})(b||(e.ViewMode=b={}));var I;(function(oe){oe.Default="default",oe.FileNames="fileNames",oe.Type="type",oe.Modified="modified",oe.CountDescending="countDescending",oe.CountAscending="countAscending"})(I||(e.SearchSortOrder=I={}));function S(oe,pe=!0){const $e=oe&&oe.files&&oe.files.exclude,se=pe&&oe&&oe.search&&oe.search.exclude;if(!$e&&!se)return;if(!$e||!se)return $e||se;let Ce=Object.create(null);return Ce=P.$_n(Ce,P.$9n($e)),Ce=P.$_n(Ce,P.$9n(se),!0),Ce}function y(oe,pe){return oe.excludePattern&&R.$tk(oe.excludePattern,pe)?!1:oe.includePattern||oe.usingSearchPaths?oe.includePattern&&R.$tk(oe.includePattern,pe)?!0:oe.usingSearchPaths?!!oe.folderQueries&&oe.folderQueries.some($e=>{const se=$e.folder.fsPath;if(O.$zg(pe,se)){const Ce=$.$lc(se,pe);return!$e.includePattern||!!R.$tk($e.includePattern,Ce)}else return!1}):!1:!0}var p;(function(oe){oe[oe.unknownEncoding=1]="unknownEncoding",oe[oe.regexParseError=2]="regexParseError",oe[oe.globParseError=3]="globParseError",oe[oe.invalidLiteral=4]="invalidLiteral",oe[oe.rgProcessError=5]="rgProcessError",oe[oe.other=6]="other",oe[oe.canceled=7]="canceled"})(p||(e.SearchErrorCode=p={}));class k extends Error{constructor(pe,$e){super(pe),this.code=$e}}e.$RK=k;function m(oe){const pe=oe.message;if((0,c.$4)(oe))return new k(pe,p.canceled);try{const $e=JSON.parse(pe);return new k($e.message,$e.code)}catch{return new k(pe,p.other)}}function w(oe){const pe={message:oe.message,code:oe.code};return new Error(JSON.stringify(pe))}function F(oe){return oe.type==="error"?!0:oe.type==="success"}function T(oe){return oe.type==="success"}function G(oe){return!!oe.path}function q(oe,pe,$e=!0){const se=oe.searchPath?oe.searchPath:oe.relativePath;return $e?(0,A.$3f)(se,pe):R.$tk(pe,se)}class V{constructor(pe){this.path=pe,this.results=[]}addMatch(pe){this.results.push(pe)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$YK=V;function N(oe,pe){const $e={...oe||{},...pe||{}};return Object.keys($e).filter(se=>{const Ce=$e[se];return typeof Ce=="boolean"&&Ce})}class L{constructor(pe,$e){this.c=null,this.a={...pe.excludePattern||{},...$e.excludePattern||{}},this.b=R.$uk(this.a);let se=pe.includePattern;$e.includePattern&&(se?se={...se,...$e.includePattern}:se=$e.includePattern),se&&(this.c=R.$uk(se))}matchesExcludesSync(pe,$e,se){return!!(this.b&&this.b(pe,$e,se))}includedInQuerySync(pe,$e,se){return!(this.b&&this.b(pe,$e,se)||this.c&&!this.c(pe,$e,se))}includedInQuery(pe,$e,se){const Ce=this.b(pe,$e,se),Fe=()=>this.c?!!this.c(pe,$e,se):!0;return(0,v.$mh)(Ce)?Ce.then(X=>X?!1:Fe()):Fe()}hasSiblingExcludeClauses(){return Z(this.a)}}e.$1K=L;function Z(oe){for(const pe in oe)if(typeof oe[pe]!="boolean")return!0;return!1}function re(oe){if(!oe)return;let pe;return $e=>(pe||(pe=(oe()||Promise.resolve([])).then(se=>se?be(se):{})),pe.then(se=>!!se[$e]))}function fe(oe){if(!oe)return;let pe;return $e=>{if(!pe){const se=oe();pe=se?be(se):{}}return!!pe[$e]}}function be(oe){const pe={};for(const $e of oe)pe[$e]=!0;return pe}}),define(ke[44],Ie([1,0,18,11,22,4,6,58,16,137,24,13,2,190,30,3,12,213,50,51,27,17,10,7,65,43,5,49]),function(de,e,E,R,P,O,A,M,$,c,C,v,u,D,d,r,o,a,h,t,s,n,i,g,f,l,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7mc=e.$6mc=void 0;function S(G,q,V){return new C.$3g(N=>m(N,V)).isEqual(G,q)}function y(G,q,V){return S(G.uri,q.uri,V)?0:(0,v.$uf)(G.uri.toString(),q.uri.toString())}function p(G,q,V){return G.index!==q.index?G.index<q.index?-1:1:S(G.uri,q.uri,V)?(0,v.$uf)(G.name,q.name):(0,v.$uf)(G.uri.toString(),q.uri.toString())}function k(G,q,V,N){const L=G.slice(0).sort((re,fe)=>V(re,fe,N)),Z=q.slice(0).sort((re,fe)=>V(re,fe,N));return(0,E.$Eb)(L,Z,(re,fe)=>V(re,fe,N))}function m(G,q){const V=q.getCapabilities(G.scheme);return!(V&&V&d.FileSystemProviderCapabilities.PathCaseSensitive)}class w extends h.$Ti{static toExtHostWorkspace(q,V,N,L){if(!q)return{workspace:null,added:[],removed:[]};const{id:Z,name:re,folders:fe,configuration:be,transient:oe,isUntitled:pe}=q,$e=[],se=V;V?fe.forEach((W,ie)=>{const Se=u.URI.revive(W.uri),he=w.o(N||V,Se,L);he?(he.name=W.name,he.index=W.index,$e.push(he)):$e.push({uri:Se,name:W.name,index:ie})}):$e.push(...fe.map(({uri:W,name:ie,index:Se})=>({uri:u.URI.revive(W),name:ie,index:Se}))),$e.sort((W,ie)=>W.index<ie.index?-1:1);const Ce=new w(Z,re,$e,!!oe,be?u.URI.revive(be):null,!!pe,W=>m(W,L)),{added:Fe,removed:X}=k(se?se.workspaceFolders:[],Ce.workspaceFolders,y,L);return{workspace:Ce,added:Fe,removed:X}}static o(q,V,N){for(let L=0;L<q.folders.length;L++){const Z=q.workspaceFolders[L];if(S(Z.uri,V,N))return Z}}constructor(q,V,N,L,Z,re,fe){super(q,N.map(be=>new h.$Ui(be)),L,Z,fe),this.t=V,this.u=re,this.q=[],this.s=M.$Gi.forUris(fe),N.forEach(be=>{this.q.push(be),this.s.set(be.uri,be)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(q,V){return V&&this.s.get(q)&&(q=(0,C.$ah)(q)),this.s.findSubstr(q)}resolveWorkspaceFolder(q){return this.s.get(q)}}let F=class{constructor(q,V,N,L,Z){this.c=new O.$he,this.onDidChangeWorkspace=this.c.event,this.g=new O.$he,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new O.$je,this.C=new Map,this.h=L,this.s=N,this.t=Z,this.j=new c.$Im,this.k=new R.$zh,this.o=q.getProxy(b.$uM.MainThreadWorkspace),this.q=q.getProxy(b.$uM.MainThreadMessageService);const re=V.workspace;this.l=re?new w(re.id,re.name,[],!!re.transient,re.configuration?u.URI.revive(re.configuration):null,!!re.isUntitled,fe=>m(fe,N)):void 0}$initializeWorkspace(q,V){this.v=V,this.$acceptWorkspaceData(q),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:$.Schemas.untitled,path:(0,C.$$g)((0,C.$ah)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(q,V,N,...L){const Z=[];if(Array.isArray(L)&&L.forEach(pe=>{u.URI.isUri(pe.uri)&&!Z.some($e=>S($e.uri,pe.uri,this.s))&&Z.push({uri:pe.uri,name:pe.name||(0,C.$0g)(pe.uri)})}),this.n||[V,N].some(pe=>typeof pe!="number"||pe<0)||N===0&&Z.length===0)return!1;const re=this.x?this.x.workspaceFolders:[];if(V+N>re.length)return!1;const fe=re.slice(0);fe.splice(V,N,...Z.map(pe=>({uri:pe.uri,name:pe.name||(0,C.$0g)(pe.uri),index:void 0})));for(let pe=0;pe<fe.length;pe++){const $e=fe[pe];if(fe.some((se,Ce)=>Ce!==pe&&S($e.uri,se.uri,this.s)))return!1}fe.forEach((pe,$e)=>pe.index=$e);const{added:be,removed:oe}=k(re,fe,p,this.s);if(be.length===0&&oe.length===0)return!1;if(this.o){const pe=q.displayName||q.name;this.o.$updateWorkspaceFolders(pe,V,N,Z).then(void 0,$e=>{this.n=void 0;const se={source:{identifier:q.identifier,label:q.displayName||q.name}};this.q.$showMessage(a.Severity.Error,(0,D.localize)(0,null,pe,$e.toString()),se,[])})}return this.y(fe),!0}getWorkspaceFolder(q,V){if(this.x)return this.x.getWorkspaceFolder(q,V)}async getWorkspaceFolder2(q,V){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(q,V)}async resolveWorkspaceFolder(q){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(q)}getPath(){if(!this.x)return;const{folders:q}=this.x;if(q.length!==0)return q[0].uri.fsPath}getRelativePath(q,V){let N,L="";if(typeof q=="string"?(N=u.URI.file(q),L=q):typeof q<"u"&&(N=q,L=q.fsPath),!N)return L;const Z=this.getWorkspaceFolder(N,!0);if(!Z)return L;typeof V>"u"&&this.x&&(V=this.x.folders.length>1);let re=(0,C.$dh)(Z.uri,N);return V&&Z.name&&(re=`${Z.name}/${re}`),re}y(q){this.x&&(this.n=w.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:q,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(q){const{workspace:V,added:N,removed:L}=w.toExtHostWorkspace(q,this.l,this.n,this.s);this.l=V||void 0,this.n=void 0,this.c.fire(Object.freeze({added:N,removed:L}))}findFiles(q,V,N,L,Z=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${L.value}, entryPoint: findFiles`);let re="",fe=!0;return V===null?fe=!1:V!==void 0&&(typeof V=="string"?re=V:re=V.pattern),this.z(q,void 0,{exclude:re,maxResults:N,useDefaultExcludes:fe,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},Z)}findFiles2(q,V={},N,L=P.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${N.value}, entryPoint: findFiles2`),this.z(void 0,q,V,L)}async z(q,V,N,L=P.CancellationToken.None){if(L&&L.isCancellationRequested)return Promise.resolve([]);const Z=typeof N.exclude=="string"?N.exclude:N.exclude?N.exclude.pattern:void 0,re={ignoreSymlinks:typeof N.followSymlinks=="boolean"?!N.followSymlinks:void 0,disregardIgnoreFiles:typeof N.useIgnoreFiles=="boolean"?!N.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof N.useGlobalIgnoreFiles=="boolean"?!N.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof N.useParentIgnoreFiles=="boolean"?!N.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof N.useDefaultExcludes=="boolean"?!N.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof N.useDefaultSearchExcludes=="boolean"?!N.useDefaultSearchExcludes:!1,maxResults:N.maxResults,excludePattern:Z,shouldGlobSearch:typeof N.fuzzy=="boolean"?!N.fuzzy:!0,_reason:"startFileSearch"};let fe;if(q){const{includePattern:be,folder:oe}=T(i.GlobPattern.from(q));fe=oe,re.includePattern=be}else{const{includePattern:be,folder:oe}=T(i.GlobPattern.from(V));fe=oe,re.filePattern=be}return this.o.$startFileSearch(fe??null,re,L).then(be=>Array.isArray(be)?be.map(oe=>u.URI.revive(oe)):[])}async findTextInFiles(q,V,N,L,Z=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${L.value}, entryPoint: findTextInFiles`);const re=this.j.getNext(),fe=typeof V.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:V.previewOptions,{includePattern:be,folder:oe}=T(i.GlobPattern.from(V.include)),pe=typeof V.exclude=="string"?V.exclude:V.exclude?V.exclude.pattern:void 0,$e={ignoreSymlinks:typeof V.followSymlinks=="boolean"?!V.followSymlinks:void 0,disregardIgnoreFiles:typeof V.useIgnoreFiles=="boolean"?!V.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof V.useGlobalIgnoreFiles=="boolean"?!V.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof V.useParentIgnoreFiles=="boolean"?!V.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof V.useDefaultExcludes=="boolean"?!V.useDefaultExcludes:!0,fileEncoding:V.encoding,maxResults:V.maxResults,previewOptions:fe,afterContext:V.afterContext,beforeContext:V.beforeContext,includePattern:be,excludePattern:pe},se=!1;if(this.u[re]=Ce=>{if(se)return;const Fe=u.URI.revive(Ce.resource);Ce.results.forEach(X=>{const W=(0,I.$0h)(X);(0,l.$IK)(W)?N({uri:Fe,preview:{text:W.preview.text,matches:(0,E.$1b)(W.preview.matches,ie=>new g.$yM(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))},ranges:(0,E.$1b)(W.ranges,ie=>new g.$yM(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))}):N({uri:Fe,text:W.text,lineNumber:W.lineNumber})})},Z.isCancellationRequested)return{};try{const Ce=await this.o.$startTextSearch(q,oe??null,$e,re,Z);return delete this.u[re],Ce||{}}catch(Ce){throw delete this.u[re],Ce}}$handleTextSearchResult(q,V){this.u[V]?.(q)}async save(q){const V=await this.o.$save(q,{saveAs:!1});return u.URI.revive(V)}async saveAs(q){const V=await this.o.$save(q,{saveAs:!0});return u.URI.revive(V)}saveAll(q){return this.o.$saveAll(q)}resolveProxy(q){return this.o.$resolveProxy(q)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(q){return this.o.$requestWorkspaceTrust(q)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(q,V){if(this.w.has(q))throw new Error(`A provider has already been registered for scheme ${q}`);this.w.set(q,V);const N=this.t.transformOutgoingScheme(q),L=this.A++;return this.o.$registerEditSessionIdentityProvider(L,N),(0,A.$Sc)(()=>{this.w.delete(q),this.o.$unregisterEditSessionIdentityProvider(L)})}async $getEditSessionIdentifier(q,V){this.h.info("Getting edit session identifier for workspaceFolder",q);const N=await this.resolveWorkspaceFolder(u.URI.revive(q));if(!N){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const L=this.w.get(N.uri.scheme);if(this.h.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!L),!L)return;const Z=await L.provideEditSessionIdentity(N,V);if(this.h.info("Provider returned edit session identifier: ",Z),!!Z)return Z}async $provideEditSessionIdentityMatch(q,V,N,L){this.h.info("Getting edit session identifier for workspaceFolder",q);const Z=await this.resolveWorkspaceFolder(u.URI.revive(q));if(!Z){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",Z);const re=this.w.get(Z.uri.scheme);if(this.h.info(`Provider for scheme ${Z.uri.scheme} is defined: `,!!re),!re)return;const fe=await re.provideEditSessionIdentityMatch?.(V,N,L);if(this.h.info("Provider returned edit session identifier match result: ",fe),!!fe)return fe}getOnWillCreateEditSessionIdentityEvent(q){return(V,N,L)=>{const Z=function(fe){V.call(N,fe)};return Z.extension=q,this.B.event(Z,void 0,L)}}async $onWillCreateEditSessionIdentity(q,V,N){const L=await this.resolveWorkspaceFolder(u.URI.revive(q));if(L===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:L},V,async(Z,re)=>{const fe=Date.now();await Promise.resolve(Z),Date.now()-fe>N&&this.h.warn("SLOW edit session create-participant",re.extension.identifier)}),V.isCancellationRequested}registerCanonicalUriProvider(q,V){if(this.C.has(q))throw new Error(`A provider has already been registered for scheme ${q}`);this.C.set(q,V);const N=this.t.transformOutgoingScheme(q),L=this.A++;return this.o.$registerCanonicalUriProvider(L,N),(0,A.$Sc)(()=>{this.C.delete(q),this.o.$unregisterCanonicalUriProvider(L)})}async provideCanonicalUri(q,V,N){const L=this.C.get(q.scheme);if(!L)return;const Z=await L.provideCanonicalUri?.(u.URI.revive(q),V,N);if(Z)return Z}async $provideCanonicalUri(q,V,N){return this.provideCanonicalUri(u.URI.revive(q),{targetScheme:V},N)}};e.$6mc=F,e.$6mc=F=He([Ve(0,n.$YO),Ve(1,s.$cP),Ve(2,t.$Omc),Ve(3,o.$7j),Ve(4,f.$4mc)],F),e.$7mc=(0,r.$Ai)("IExtHostWorkspace");function T(G){let q,V;return G&&(typeof G=="string"?q=G:(q=G.pattern,V=u.URI.revive(G.baseUri))),{includePattern:q,folder:V}}}),define(ke[45],Ie([1,0,26,4,44,5,7,42,214,54,15,11,3,17,12,2]),function(de,e,E,R,P,O,A,M,$,c,C,v,u,D,d,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0mc=e.$9mc=e.$8mc=void 0;function o(f,l){if(l){const b=l.split(".");let I=f;for(let S=0;I&&S<b.length;S++)I=I[b[S]];return I}}function a(f){return f instanceof r.URI}function h(f){return f&&f.uri instanceof r.URI&&f.languageId&&typeof f.languageId=="string"}function t(f){return f&&!f.uri&&f.languageId&&typeof f.languageId=="string"}function s(f){return f&&f.uri instanceof r.URI&&(!f.name||typeof f.name=="string")&&(!f.index||typeof f.index=="number")}function n(f){if(a(f))return{resource:f};if(h(f))return{resource:f.uri,overrideIdentifier:f.languageId};if(t(f))return{overrideIdentifier:f.languageId};if(s(f))return{resource:f.uri};if(f===null)return{resource:null}}let i=class{constructor(l,b,I){this.a=l.getProxy(O.$uM.MainThreadConfiguration),this.c=b,this.b=I,this.d=new v.$zh,this.e=null}getConfigProvider(){return this.d.wait().then(l=>this.e)}$initializeConfiguration(l){this.e=new g(this.a,this.c,l,this.b),this.d.open()}$acceptConfigurationChanged(l,b){this.getConfigProvider().then(I=>I.$acceptConfigurationChanged(l,b))}};e.$8mc=i,e.$8mc=i=He([Ve(0,D.$YO),Ve(1,P.$7mc),Ve(2,d.$7j)],i);class g{constructor(l,b,I,S){this.a=new R.$he,this.b=l,this.f=S,this.c=b,this.e=$.$Ho.parse(I,S),this.d=this.k(I.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(l,b){const I={data:this.e.toData(),workspace:this.c.workspace};this.e=$.$Ho.parse(l,this.f),this.d=this.k(l.configurationScopes),this.a.fire(this.j(b,I))}getConfiguration(l,b,I){const S=n(b)||{},y=this.g(l?o(this.e.getValue(void 0,S,this.c.workspace),l):this.e.getValue(void 0,S,this.c.workspace));l&&this.h(l,S,I?.identifier);function p(m){if(m==null)return null;if(typeof m=="boolean")return m?M.ConfigurationTarget.USER:M.ConfigurationTarget.WORKSPACE;switch(m){case A.ConfigurationTarget.Global:return M.ConfigurationTarget.USER;case A.ConfigurationTarget.Workspace:return M.ConfigurationTarget.WORKSPACE;case A.ConfigurationTarget.WorkspaceFolder:return M.ConfigurationTarget.WORKSPACE_FOLDER}}const k={has(m){return typeof o(y,m)<"u"},get:(m,w)=>{this.h(l?`${l}.${m}`:m,S,I?.identifier);let F=o(y,m);if(typeof F>"u")F=w;else{let T;const G=(q,V)=>{if((0,C.$cg)(q)){let N;const L=()=>{T=T||(0,E.$9n)(y),N=N||o(T,V)};return new Proxy(q,{get:(Z,re)=>{if(typeof re=="string"&&re.toLowerCase()==="tojson")return L(),()=>N;if(T)return N=N||o(T,V),N[re];const fe=Z[re];return typeof re=="string"?G(fe,`${V}.${re}`):fe},set:(Z,re,fe)=>(L(),N&&(N[re]=fe),!0),deleteProperty:(Z,re)=>(L(),N&&delete N[re],!0),defineProperty:(Z,re,fe)=>(L(),N&&Object.defineProperty(N,re,fe),!0)})}return Array.isArray(q)?(0,E.$9n)(q):q};F=G(F,m)}return F},update:(m,w,F,T)=>{m=l?`${l}.${m}`:m;const G=p(F);return w!==void 0?this.b.$updateConfigurationOption(G,m,w,S,T):this.b.$removeConfigurationOption(G,m,S,T)},inspect:m=>{m=l?`${l}.${m}`:m;const w=this.e.inspect(m,S,this.c.workspace);if(w)return{key:m,defaultValue:(0,E.$9n)(w.policy?.value??w.default?.value),globalValue:(0,E.$9n)(w.user?.value??w.application?.value),workspaceValue:(0,E.$9n)(w.workspace?.value),workspaceFolderValue:(0,E.$9n)(w.workspaceFolder?.value),defaultLanguageValue:(0,E.$9n)(w.default?.override),globalLanguageValue:(0,E.$9n)(w.user?.override??w.application?.override),workspaceLanguageValue:(0,E.$9n)(w.workspace?.override),workspaceFolderLanguageValue:(0,E.$9n)(w.workspaceFolder?.override),languageIds:(0,E.$9n)(w.overrideIdentifiers)}}};return typeof y=="object"&&(0,E.$_n)(k,y,!1),Object.freeze(k)}g(l){const b=I=>(0,C.$cg)(I)?new Proxy(I,{get:(S,y)=>b(S[y]),set:(S,y,p)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(y)}' of object`)},deleteProperty:(S,y)=>{throw new Error(`TypeError: Cannot delete read only property '${String(y)}' of object`)},defineProperty:(S,y)=>{throw new Error(`TypeError: Cannot define property '${String(y)}' for a readonly object`)},setPrototypeOf:S=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):I;return b(l)}h(l,b,I){const S=c.$yo.test(l)?c.ConfigurationScope.RESOURCE:this.d.get(l),y=I?`[${I.value}] `:"";if(c.ConfigurationScope.RESOURCE===S){typeof b?.resource>"u"&&this.f.warn(`${y}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${l}', provide the URI of a resource or 'null' for any resource.`);return}if(c.ConfigurationScope.WINDOW===S){b?.resource&&this.f.warn(`${y}Accessing a window scoped configuration for a resource is not expected. To associate '${l}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(l,b){const I=new $.$Jo(l,b,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(S,y)=>I.affectsConfiguration(S,n(y))})}k(l){return l.reduce((b,I)=>(b.set(I[0],I[1]),b),new Map)}}e.$9mc=g,e.$0mc=(0,u.$Ai)("IExtHostConfiguration")}),define(ke[129],Ie([1,0,2,11,4,5,7,44,71,45,22,57,17,27,3,16,21,12,85,250,14]),function(de,e,E,R,P,O,A,M,$,c,C,v,u,D,d,r,o,a,h,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Boc=e.$Aoc=e.$zoc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var n;(function(T){function G(V){if(V!=null)return V}T.from=G;function q(V){if(V!=null)return V}T.to=q})(n||(n={}));var i;(function(T){function G(V){if(V!=null)return V}T.from=G;function q(V){if(V!=null)return V}T.to=q})(i||(i={}));var g;(function(T){function G(V){if(V!=null)return V}T.from=G;function q(V){if(V!=null)return V}T.to=q})(g||(g={}));var f;(function(T){function G(N){if(N){const L=N;return L&&!!L.process}else return!1}T.is=G;function q(N){if(N==null)return;const L={process:N.process,args:N.args};return N.options&&(L.options=g.from(N.options)),L}T.from=q;function V(N){if(N!=null)return new A.$gN(N.process,N.args,N.options)}T.to=V})(f||(f={}));var l;(function(T){function G(V){if(V!=null)return V}T.from=G;function q(V){if(V!=null)return V}T.to=q})(l||(l={}));var b;(function(T){function G(N){if(N){const L=N;return L&&(!!L.commandLine||!!L.command)}else return!1}T.is=G;function q(N){if(N==null)return;const L={};return N.commandLine!==void 0?L.commandLine=N.commandLine:(L.command=N.command,L.args=N.args),N.options&&(L.options=l.from(N.options)),L}T.from=q;function V(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new A.$hN(N.commandLine,N.options):new A.$hN(N.command,N.args?N.args:[],N.options)}T.to=V})(b||(b={}));var I;(function(T){function G(N){if(N){const L=N;return L&&L.customExecution==="customExecution"}else return!1}T.is=G;function q(N){return{customExecution:"customExecution"}}T.from=q;function V(N,L){return L.get(N)}T.to=V})(I||(e.CustomExecutionDTO=I={}));var S;(function(T){function G(q,V){let N;return q.scope!==void 0&&typeof q.scope!="number"?N=q.scope.uri:q.scope!==void 0&&typeof q.scope=="number"&&(q.scope===A.TaskScope.Workspace&&V&&V.workspaceFile?N=V.workspaceFile:N=t.$uI),{id:q._id,workspaceFolder:N}}T.from=G})(S||(e.TaskHandleDTO=S={}));var y;(function(T){function G(q){if(q!=null)return{_id:q.id,isDefault:q.isDefault}}T.from=G})(y||(y={}));var p;(function(T){function G(N,L){if(N==null)return[];const Z=[];for(const re of N){const fe=q(re,L);fe&&Z.push(fe)}return Z}T.fromMany=G;function q(N,L){if(N==null)return;let Z;N.execution instanceof A.$gN?Z=f.from(N.execution):N.execution instanceof A.$hN?Z=b.from(N.execution):N.execution&&N.execution instanceof A.$iN&&(Z=I.from(N.execution));const re=n.from(N.definition);let fe;return N.scope?typeof N.scope=="number"?fe=N.scope:fe=N.scope.uri:fe=A.TaskScope.Workspace,!re||!fe?void 0:{_id:N._id,definition:re,name:N.name,source:{extensionId:L.identifier.value,label:N.source,scope:fe},execution:Z,isBackground:N.isBackground,group:y.from(N.group),presentationOptions:i.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}T.from=q;async function V(N,L,Z){if(N==null)return;let re;f.is(N.execution)?re=f.to(N.execution):b.is(N.execution)?re=b.to(N.execution):I.is(N.execution)&&(re=I.to(N._id,Z));const fe=n.to(N.definition);let be;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?be=N.source.scope:be=await L.resolveWorkspaceFolder(E.URI.revive(N.source.scope)):be=A.TaskScope.Workspace),!fe||!be)return;const oe=new A.$jN(fe,be,N.name,N.source.label,re,N.problemMatchers);return N.isBackground!==void 0&&(oe.isBackground=N.isBackground),N.group!==void 0&&(oe.group=A.$fN.from(N.group._id),oe.group&&N.group.isDefault&&(oe.group=new A.$fN(oe.group.id,oe.group.label),N.group.isDefault===!0&&(oe.group.isDefault=N.group.isDefault))),N.presentationOptions&&(oe.presentationOptions=i.to(N.presentationOptions)),N._id&&(oe._id=N._id),N.detail&&(oe.detail=N.detail),oe}T.to=V})(p||(e.TaskDTO=p={}));var k;(function(T){function G(V){return V}T.from=G;function q(V){if(V)return Object.assign(Object.create(null),V)}T.to=q})(k||(k={}));class m{#e;constructor(G,q,V){this._id=q,this.a=V,this.#e=G}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(G){}fireDidEndProcess(G){}}let w=class{constructor(G,q,V,N,L,Z,re,fe){this.q=new P.$he,this.r=new P.$he,this.s=new P.$he,this.u=new P.$he,this.a=G.getProxy(O.$uM.MainThreadTask),this.b=V,this.c=N,this.d=L,this.e=Z,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=re,this.g=fe,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(G,q,V){if(!V)return new A.$wM(()=>{});const N=this.x();return this.j.set(N,{type:q,provider:V,extension:G}),this.a.$registerTaskProvider(N,q),new A.$wM(()=>{this.j.delete(N),this.a.$unregisterTaskProvider(N)})}registerTaskSystem(G,q){this.a.$registerTaskSystem(G,q)}fetchTasks(G){return this.a.$fetchTasks(k.from(G)).then(async q=>{const V=[];for(const N of q){const L=await p.to(N,this.b,this.m);L&&V.push(L)}return V})}get taskExecutions(){const G=[];return this.k.forEach(q=>G.push(q)),G}terminateTask(G){if(!(G instanceof m))throw new Error("No valid task execution provided");return this.a.$terminateTask(G._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(G,q,V){const N=this.m.get(G.id);N&&(this.o.set(G.id,N),this.e.attachPtyToTerminal(q,await N.callback(V))),this.p=G.id,this.q.fire({execution:await this.z(G)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(G){if(!this.l.has(G.id))return;const q=await this.z(G);this.l.delete(G.id),this.k.delete(G.id),this.B(G),this.r.fire({execution:q})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(G){const q=await this.z(G.id);this.s.fire({execution:q,processId:G.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(G){const q=await this.z(G.id);this.u.fire({execution:q,exitCode:G.exitCode})}$provideTasks(G,q){const V=this.j.get(G);if(!V)return Promise.reject(new Error("no handler found"));const N=[],L=(0,R.$sh)(()=>V.provider.provideTasks(C.CancellationToken.None)).then(Z=>this.v(q,N,V,Z));return new Promise(Z=>{L.then(re=>{Promise.all(N).then(()=>{Z(re)})})})}async $resolveTask(G,q){const V=this.j.get(G);if(!V)return Promise.reject(new Error("no handler found"));if(q.definition.type!==V.type)throw new Error(`Unexpected: Task of type [${q.definition.type}] cannot be resolved by provider of type [${V.type}].`);const N=await p.to(q,this.b,this.m);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const L=await V.provider.resolveTask(N,C.CancellationToken.None);if(!L)return;this.A(L,V);const Z=p.from(L,V.extension);if(!Z)throw new Error("Unexpected: Task cannot be resolved.");if(L.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return I.is(Z.execution)&&await this.y(Z,L,!0),await this.w(Z)}x(){return this.h++}async y(G,q,V){const N=await this.a.$createTaskId(G);!V&&!this.m.has(N)&&(this.n.add(N),this.o.set(N,q.execution)),this.m.set(N,q.execution)}async z(G,q){if(typeof G=="string"){const L=this.l.get(G);if(!L)throw new s.$bb("Unexpected: The specified task is missing an execution");return L}const V=this.l.get(G.id);if(V)return V;let N;return q?N=Promise.resolve(new m(this,G.id,q)):N=p.to(G.task,this.b,this.m).then(L=>{if(!L)throw new s.$bb("Unexpected: Task does not exist.");return new m(this,G.id,L)}),this.l.set(G.id,N),N.then(L=>(this.k.set(G.id,L),L))}A(G,q){G._deprecated&&this.g.report("Task.constructor",q.extension,"Use the Task constructor that takes a `scope` instead.")}B(G){this.o.get(G.id)&&this.o.delete(G.id),this.n.has(G.id)&&this.p!==G.id&&(this.m.delete(G.id),this.n.delete(G.id));const V=this.n.values();let N=V.next();for(;!N.done;)!this.o.has(N.value)&&this.p!==N.value&&(this.m.delete(N.value),this.n.delete(N.value)),N=V.next()}};e.$zoc=w,e.$zoc=w=He([Ve(0,u.$YO),Ve(1,D.$cP),Ve(2,M.$7mc),Ve(3,$.$0O),Ve(4,c.$0mc),Ve(5,v.$vnc),Ve(6,a.$7j),Ve(7,h.$Kmc)],w);let F=class extends w{constructor(G,q,V,N,L,Z,re,fe){super(G,q,V,N,L,Z,re,fe),this.registerTaskSystem(r.Schemas.vscodeRemote,{scheme:r.Schemas.vscodeRemote,authority:"",platform:o.$h(o.Platform.Web)})}async executeTask(G,q){if(!q.execution)throw new Error("Tasks to execute must include an execution");const V=p.from(q,G);if(V===void 0)throw new Error("Task is not valid");if(I.is(V.execution))await this.y(V,q,!1);else throw new s.$_;const N=await this.z(await this.a.$getTaskExecution(V),q);return this.a.$executeTask(V).catch(L=>{throw new Error(L)}),N}v(G,q,V,N){const L=[];if(N)for(const Z of N){if(this.A(Z,V),!Z.definition||!G[Z.definition.type]){const fe=Z.source?Z.source:"No task source";this.f.warn(`The task [${fe}, ${Z.name}] uses an undefined task type. The task will be ignored in the future.`)}const re=p.from(Z,V.extension);re&&I.is(re.execution)?(L.push(re),q.push(this.y(re,Z,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:L,extension:V.extension}}async w(G){if(I.is(G.execution))return G;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(G,q){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(G,q,V){}};e.$Aoc=F,e.$Aoc=F=He([Ve(0,u.$YO),Ve(1,D.$cP),Ve(2,M.$7mc),Ve(3,$.$0O),Ve(4,c.$0mc),Ve(5,v.$vnc),Ve(6,a.$7j),Ve(7,h.$Kmc)],F),e.$Boc=(0,d.$Ai)("IExtHostTask")}),define(ke[309],Ie([1,0,43,33]),function(de,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0K=void 0,e.$9K=P,e.$$K=O;function P(A){return"cellResults"in A}e.$0K="rawCell#";function O(A,M){let $=-1;const c=[];let C=[];return A.forEach(u=>{u.range.startLineNumber!==$&&C.length>0&&(c.push([...C]),C=[]),C.push(u),$=u.range.endLineNumber}),C.length>0&&c.push([...C]),c.map(u=>{const D=[],d=u[0].range.startLineNumber,r=u[u.length-1].range.endLineNumber;for(let o=d;o<=r;o++)D.push(M.getLineContent(o));return new E.$MK(D.join(`
`)+`
`,u.map(o=>new R.$ct(o.range.startLineNumber-1,o.range.startColumn-1,o.range.endLineNumber-1,o.range.endColumn-1)))})}}),define(ke[310],Ie([1,0,184,23,4,6,29,37,13,15,2,30,80,5,39,10,7,38,286,122,26,16,43,239,309,307]),function(de,e,E,R,P,O,A,M,$,c,C,v,u,D,d,r,o,a,h,t,s,n,i,g,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$coc=void 0;class b{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(S=>S.apiEditor)}constructor(S,y,p,k,m,w,F){this.q=p,this.r=k,this.s=m,this.t=w,this.u=F,this.f=new Map,this.g=new A.$Ac,this.h=new Map,this.j=new P.$he,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new P.$he,this.onDidOpenNotebookDocument=this.m.event,this.n=new P.$he,this.onDidCloseNotebookDocument=this.n.event,this.o=new P.$he,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new u.$Imc("NotebookCellStatusBarCache"),this.x=0,this.y=new Map,this.b=S.getProxy(D.$uM.MainThreadNotebook),this.c=S.getProxy(D.$uM.MainThreadNotebookDocuments),this.d=S.getProxy(D.$uM.MainThreadNotebookEditors),this.i=y.converter,y.registerArgumentProcessor({processArgument:T=>{if(T&&T.$mid===M.MarshalledId.NotebookCellActionContext){const G=T.notebookEditor?.notebookUri,q=T.cell.handle,N=this.g.get(G)?.getCell(q);if(N)return N.apiCell}if(T&&T.$mid===M.MarshalledId.NotebookActionContext){const G=T.uri,q=this.g.get(G);if(q)return q.apiNotebook}return T}}),b.C(y)}getEditorById(S){const y=this.h.get(S);if(!y)throw new Error(`unknown text editor: ${S}. known editors: ${[...this.h.keys()]} `);return y}getIdByEditor(S){for(const[y,p]of this.h)if(p.apiEditor===S)return y}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(S,y){const p=this.g.get(S);if(!p&&!y)throw new Error(`NO notebook document for '${S}'`);return p}static w(S,y){if(!y)return;const p=y.filenamePattern.map(k=>r.NotebookExclusiveDocumentPattern.from(k)).filter(k=>k!==void 0);if(y.filenamePattern&&!p){console.warn(`Notebook content provider view options file name pattern is invalid ${y.filenamePattern}`);return}return{extension:S.identifier,providerDisplayName:S.displayName||S.name,displayName:y.displayName,filenamePattern:p,exclusive:y.exclusive||!1}}registerNotebookCellStatusBarItemProvider(S,y,p){const k=b.a++,m=typeof p.onDidChangeCellStatusBarItems=="function"?b.a++:void 0;this.f.set(k,p),this.b.$registerNotebookCellStatusBarItemProvider(k,m,y);let w;return m!==void 0&&(w=p.onDidChangeCellStatusBarItems(F=>this.b.$emitCellStatusBarEvent(m))),new o.$wM(()=>{this.f.delete(k),this.b.$unregisterNotebookCellStatusBarItemProvider(k,m),w?.dispose()})}async createNotebookDocument(S){const y=await this.c.$tryCreateNotebook({viewType:S.viewType,content:S.content&&r.NotebookData.from(S.content)});return C.URI.revive(y)}async openNotebookDocument(S){const y=this.g.get(S);if(y)return y.apiNotebook;const p=await this.c.$tryOpenNotebook(S),k=this.g.get(C.URI.revive(p));return(0,c.$lg)(k?.apiNotebook)}async showNotebookDocument(S,y){C.URI.isUri(S)&&(S=await this.openNotebookDocument(S));let p;typeof y=="object"?p={position:r.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selections:y.selections&&y.selections.map(r.NotebookRange.from),pinned:typeof y.preview=="boolean"?!y.preview:void 0}:p={preserveFocus:!1};const k=await this.d.$tryShowNotebookDocument(S.uri,S.notebookType,p),m=k&&this.h.get(k)?.apiEditor;if(m)return m;throw k?new Error(`Could NOT open editor for "${S.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${S.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(S,y,p,k){const m=this.f.get(S),w=C.URI.revive(y),F=this.g.get(w);if(!F||!m)return;const T=F.getCellFromIndex(p);if(!T)return;const G=await m.provideCellStatusBarItems(T.apiCell,k);if(!G)return;const q=new O.$Tc,V=this.p.add([q]),L=(Array.isArray(G)?G:[G]).map(Z=>r.NotebookStatusBarItem.from(Z,this.i,q));return{cacheId:V,items:L}}$releaseNotebookCellStatusBarItems(S){this.p.delete(S)}registerNotebookSerializer(S,y,p,k,m){if((0,$.$$e)(y))throw new Error("viewType cannot be empty or just whitespace");const w=this.x++;return this.y.set(w,{viewType:y,serializer:p,options:k}),this.b.$registerNotebookSerializer(w,{id:S.identifier,location:S.extensionLocation},y,r.NotebookDocumentContentOptions.from(k),b.w(S,m)),(0,O.$Sc)(()=>{this.b.$unregisterNotebookSerializer(w)})}async $dataToNotebook(S,y,p){const k=this.y.get(S);if(!k)throw new Error("NO serializer found");const m=await k.serializer.deserializeNotebook(y.buffer,p);return new a.$Kw(r.NotebookData.from(m))}async $notebookToData(S,y,p){const k=this.y.get(S);if(!k)throw new Error("NO serializer found");const m=await k.serializer.serializeNotebook(r.NotebookData.to(y.value),p);return R.$Je.wrap(m)}async $saveNotebook(S,y,p,k,m){const w=C.URI.revive(y),F=this.y.get(S);if(this.D(`enter saveNotebook(versionId: ${p}, ${w.toString()})`),!F)throw new Error("NO serializer found");const T=this.g.get(w);if(!T)throw new Error("Document NOT found");if(T.versionId!==p)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(w.scheme))throw new v.$pl((0,E.localize)(0,null,this.A(w)),v.FileOperationResult.FILE_PERMISSION_DENIED);const G={metadata:(0,s.$eo)(T.apiNotebook.metadata,Z=>!(F.options?.transientDocumentMetadata??{})[Z]),cells:[]};for(const Z of T.apiNotebook.getCells()){const re=new o.$ZN(Z.kind,Z.document.getText(),Z.document.languageId,Z.mime,F.options?.transientOutputs?[]:[...Z.outputs],Z.metadata,Z.executionSummary);re.metadata=(0,s.$eo)(Z.metadata,fe=>!(F.options?.transientCellMetadata??{})[fe]),G.cells.push(re)}if(await this.z(w,k),m.isCancellationRequested)throw new Error("canceled");const q=await F.serializer.serializeNotebook(G,m);if(m.isCancellationRequested)throw new Error("canceled");this.D(`serialized versionId: ${p} ${w.toString()}`),await this.s.value.writeFile(w,q),this.D(`Finished write versionId: ${p} ${w.toString()}`);const V=this.s.getFileSystemProviderExtUri(w.scheme),N=await this.s.value.stat(w),L={name:V.basename(w),isFile:(N.type&v.FileType.File)!==0,isDirectory:(N.type&v.FileType.Directory)!==0,isSymbolicLink:(N.type&v.FileType.SymbolicLink)!==0,mtime:N.mtime,ctime:N.ctime,size:N.size,readonly:!!((N.permissions??0)&v.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(w.scheme),locked:!!((N.permissions??0)&v.FilePermission.Locked),etag:v.$Al({mtime:N.mtime,size:N.size}),children:void 0};return this.D(`exit saveNotebook(versionId: ${p}, ${w.toString()})`),L}async $searchInNotebooks(S,y,p,k,m){const w=this.y.get(S)?.serializer;if(!w)return{limitHit:!1,results:[]};const F=new A.$Bc;await(async(N,L,Z)=>{await Promise.all(N.map(async re=>await Promise.all(re.filenamePatterns.map(fe=>{const be={_reason:Z._reason,folderQueries:Z.folderQueries,includePattern:Z.includePattern,excludePattern:Z.excludePattern,maxResults:Z.maxResults,type:i.QueryType.File,filePattern:fe};return this.t.doInternalFileSearchWithCustomCallback(be,L,oe=>{oe.forEach(pe=>{F.has(pe)||k.some(se=>re.isFromSettings&&!se.isFromSettings?!1:se.filenamePatterns.some(Ce=>(0,l.$shb)(Ce,pe)))||F.add(pe)})}).catch(oe=>{if(oe.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw oe})}))))})(p,m,y);const G=new A.$Ac;let q=!1;const V=Array.from(F).map(async N=>{const L=[];try{if(m.isCancellationRequested)return;if(y.maxResults&&[...G.values()].reduce((be,oe)=>be+oe.cellResults.length,0)>y.maxResults){q=!0;return}const Z=[],re=this.g.get(N);if(re)re.apiNotebook.getCells().forEach(oe=>Z.push({input:oe.document.getText(),outputs:oe.outputs.flatMap(pe=>pe.items.map($e=>$e.data.toString()))}));else{const be=await this.s.value.readFile(N),oe=R.$Je.fromString(be.toString()),pe=await w.deserializeNotebook(oe.buffer,m);if(m.isCancellationRequested)return;r.NotebookData.from(pe).cells.forEach(se=>Z.push({input:se.source,outputs:se.outputs.flatMap(Ce=>Ce.items.map(Fe=>Fe.valueBytes.toString()))}))}if(m.isCancellationRequested)return;Z.forEach((be,oe)=>{const pe=y.contentPattern.pattern,$e=new g.$0Xb(be.input,void 0,be.outputs),se=$e.findInInputs(pe),Ce=$e.findInOutputs(pe),Fe=Ce.flatMap(X=>(0,f.$$K)(X.matches,X.textBuffer)).map((X,W)=>(X.webviewIndex=W,X));if(se.length>0||Ce.length>0){const X={index:oe,contentResults:(0,f.$$K)(se,$e.inputTextBuffer),webviewResults:Fe};L.push(X)}});const fe={resource:N,cellResults:L};G.set(N,fe);return}catch{return}});return await Promise.all(V),{limitHit:q,results:[...G.values()]}}async z(S,y){const p=await this.s.value.stat(S);if(typeof y?.mtime=="number"&&typeof y.etag=="string"&&y.etag!==v.$zl&&typeof p.mtime=="number"&&typeof p.size=="number"&&y.mtime<p.mtime&&y.etag!==v.$Al({mtime:y.mtime,size:p.size}))throw new v.$pl((0,E.localize)(1,null),v.FileOperationResult.FILE_MODIFIED_SINCE,y)}A(S){return S.scheme===n.Schemas.file?S.fsPath:S.toString()}B(S,y,p){if(this.h.has(y))throw new Error(`editor with id ALREADY EXSIST: ${y}`);const k=new t.$6nc(y,this.d,S,p.visibleRanges.map(r.NotebookRange.to),p.selections.map(r.NotebookRange.to),typeof p.viewColumn=="number"?r.ViewColumn.to(p.viewColumn):void 0);this.h.set(y,k)}$acceptDocumentAndEditorsDelta(S){if(S.value.removedDocuments)for(const p of S.value.removedDocuments){const k=C.URI.revive(p),m=this.g.get(k);m&&(m.dispose(),this.g.delete(k),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:m.apiNotebook.getCells().map(w=>w.document.uri)}),this.n.fire(m.apiNotebook));for(const w of this.h.values())w.notebookData.uri.toString()===k.toString()&&this.h.delete(w.id)}if(S.value.addedDocuments){const p=[];for(const k of S.value.addedDocuments){const m=C.URI.revive(k.uri);if(this.g.has(m))throw new Error(`adding EXISTING notebook ${m} `);const w=new h.$5nc(this.c,this.q,this.r,m,k);p.push(...k.cells.map(F=>h.$4nc.asModelAddData(F))),this.g.get(m)?.dispose(),this.g.set(m,w),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:p}),this.m.fire(w.apiNotebook)}}if(S.value.addedEditors)for(const p of S.value.addedEditors){if(this.h.has(p.id))return;const k=C.URI.revive(p.documentUri),m=this.g.get(k);m&&this.B(m,p.id,p)}const y=[];if(S.value.removedEditors)for(const p of S.value.removedEditors){const k=this.h.get(p);k&&(this.h.delete(p),this.k?.id===k.id&&(this.k=void 0),y.push(k))}if(S.value.visibleEditors){this.l=S.value.visibleEditors.map(k=>this.h.get(k)).filter(k=>!!k);const p=new Set;this.l.forEach(k=>p.add(k.id));for(const k of this.h.values()){const m=p.has(k.id);k._acceptVisibility(m)}this.l=[...this.h.values()].map(k=>k).filter(k=>k.visible),this.o.fire(this.visibleNotebookEditors)}S.value.newActiveEditor===null?this.k=void 0:S.value.newActiveEditor&&(this.h.get(S.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${S.value.newActiveEditor}`),this.k=this.h.get(S.value.newActiveEditor)),S.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static C(S){const y=d.$kP.String.with("notebookType","A notebook type"),p=new d.$mP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[y,new d.$kP("data","Bytes to convert to data",m=>m instanceof Uint8Array,m=>R.$Je.wrap(m))],new d.$lP("Notebook Data",m=>r.NotebookData.to(m.value))),k=new d.$mP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[y,new d.$kP("NotebookData","Notebook data to convert to bytes",m=>!0,m=>new a.$Kw(r.NotebookData.from(m)))],new d.$lP("Bytes",m=>m.buffer));S.registerApiCommand(p),S.registerApiCommand(k)}D(S){this.u.trace(`[Extension Host Notebook] ${S}`)}}e.$coc=b}),define(ke[311],Ie([1,0,20,22,48,41,24,69,43]),function(de,e,E,R,P,O,A,M,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7nc=void 0;class c{constructor(u,D,d){this.k=u,this.l=D,this.o=d,this.e=!1,this.f=0,this.g=!1,this.a=u.filePattern,this.b=u.includePattern&&O.$uk(u.includePattern),this.c=u.maxResults||void 0,this.d=u.exists,this.h=new Set,this.j=u.excludePattern&&O.$uk(u.excludePattern)}cancel(){this.g=!0,this.h.forEach(u=>u.cancel()),this.h=new Set}search(u){const D=this.k.folderQueries||[];return new Promise((d,r)=>{const o=a=>{this.f++,u(a)};if(this.g)return d({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(a=>{const h=a.toString(),t=E.$nc(h);this.j&&this.j(h,t)||this.v(o,{base:a,basename:t})}),Promise.all(D.map(a=>this.p(a,o))).then(a=>{d({limitHit:this.e,stats:a[0]||void 0})},a=>{r(new Error((0,P.$lj)(a)))})})}async p(u,D){const d=new R.$se,r=this.q(u),o=this.r(),a=new $.$1K(this.k,u),h=!a.hasSiblingExcludeClauses();let t;try{this.h.add(d),t=M.$be.create();const s=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},r,d.token),n=t.elapsed(),i=M.$be.create();return this.g&&!this.e||(s&&s.forEach(g=>{const f=E.$gc.relative(u.folder.path,g.path);if(h){const l=E.$nc(g.path);this.v(D,{base:u.folder,relativePath:f,basename:l});return}this.s(o,u.folder,f,D)}),this.g&&!this.e)?null:(this.u(o,a,D),{providerTime:n,postProcessTime:i.elapsed()})}finally{d.dispose(),this.h.delete(d)}}q(u){const D=(0,$.$ZK)(this.k.includePattern,u.includePattern),d=(0,$.$ZK)(this.k.excludePattern,u.excludePattern);return{folder:u.folder,excludes:d,includes:D,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}s({pathToEntries:u},D,d,r){if(d===this.a){const a=E.$nc(this.a);this.v(r,{base:D,relativePath:this.a,basename:a})}function o(a){const h=E.$nc(a),t=E.$mc(a);let s=u[t];s||(s=u[t]=[],o(t)),s.push({base:D,relativePath:a,basename:h})}o(d)}u({rootEntries:u,pathToEntries:D},d,r){const o=this,a=this.a;function h(t){const s=(0,$.$3K)(()=>t.map(n=>n.basename));for(let n=0,i=t.length;n<i;n++){const g=t[n],{relativePath:f,basename:l}=g;if(d.matchesExcludesSync(f,l,a!==l?s:void 0))continue;const b=D[f];if(b)h(b);else{if(f===a)continue;o.v(r,g)}if(o.e)break}}h(u)}v(u,D){(!this.b||D.relativePath&&this.b(D.relativePath,D.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||u(D))}}class C{constructor(){this.b=new Map}static{this.a=512}fileSearch(u,D,d,r){const o=this.c(u.cacheKey),a=new c(u,D,o&&o.token);let h=0;const t=s=>{h+=s.length,d(s.map(n=>this.d(n)))};return this.e(a,C.a,t,r).then(s=>({limitHit:s.limitHit,stats:s.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:h,detailStats:s.stats}:void 0,messages:[]}))}clearCache(u){this.c(u)?.cancel()}c(u){if(u)return this.b.has(u)||this.b.set(u,new R.$se),this.b.get(u)}d(u){return u.relativePath?{resource:A.$bh(u.base,u.relativePath)}:{resource:u.base}}e(u,D,d,r){const o=r.onCancellationRequested(()=>{u.cancel()}),a=t=>{t&&(h.push(t),D>0&&h.length>=D&&(d(h),h=[]))};let h=[];return u.search(a).then(t=>(h.length&&d(h),o.dispose(),t),t=>(h.length&&d(h),o.dispose(),Promise.reject(t)))}}e.$7nc=C}),define(ke[312],Ie([1,0,18,281,41,102,29,16,20,24,13,15,2,101,204,42,12,50,116,308,43]),function(de,e,E,R,P,O,A,M,$,c,C,v,u,D,d,r,o,a,h,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$L=void 0,e.$_L=y;let n=class{constructor(k,m,w,F,T){this.a=k,this.b=m,this.c=w,this.d=F,this.e=T}text(k,m,w={}){k=this.f(k,w);const F=this.a.getValue(),T=m&&m.some(q=>!this.a.getValue({resource:q}).search.useRipgrep);return{...this.h(m?.map(a.$Vi),w),type:s.QueryType.Text,contentPattern:k,previewOptions:w.previewOptions,maxFileSize:w.maxFileSize,usePCRE2:F.search.usePCRE2||T||!1,beforeContext:w.beforeContext,afterContext:w.afterContext,userDisabledExcludesAndIgnoreFiles:w.disregardExcludeSettings&&w.disregardIgnoreFiles}}f(k,m){const w=this.a.getValue();k.isRegExp&&(k.pattern=k.pattern.replace(/\r?\n/g,"\\n"));const F={...k,wordSeparators:w.editor.wordSeparators};return this.j(k,m)&&(F.isCaseSensitive=!0),this.k(k)&&(F.isMultiline=!0),m.notebookSearchConfig?.includeMarkupInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownInput=m.notebookSearchConfig.includeMarkupInput),m.notebookSearchConfig?.includeMarkupPreview&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownPreview=m.notebookSearchConfig.includeMarkupPreview),m.notebookSearchConfig?.includeCodeInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellInput=m.notebookSearchConfig.includeCodeInput),m.notebookSearchConfig?.includeOutput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellOutput=m.notebookSearchConfig.includeOutput),F}file(k,m={}){return{...this.h(k,m),type:s.QueryType.File,filePattern:m.filePattern?m.filePattern.trim():m.filePattern,exists:m.exists,sortByScore:m.sortByScore,cacheKey:m.cacheKey,shouldGlobMatchFilePattern:m.shouldGlobSearch}}g(k,m){return k?(k=Array.isArray(k)?k.map(b):b(k),m?this.parseSearchPaths(k):{pattern:g(...Array.isArray(k)?k:[k])}):{}}h(k=[],m={}){const w=this.g(m.includePattern,m.expandPatterns),F=this.g(m.excludePattern,m.expandPatterns),T=k.length>1,G=(w.searchPaths&&w.searchPaths.length?w.searchPaths.map(N=>this.q(N,m,F)):k.map(N=>this.r(N,m,F,T))).filter(N=>!!N),q={_reason:m._reason,folderQueries:G,usingSearchPaths:!!(w.searchPaths&&w.searchPaths.length),extraFileResources:m.extraFileResources,excludePattern:F.pattern,includePattern:w.pattern,onlyOpenEditors:m.onlyOpenEditors,maxResults:m.maxResults};if(m.onlyOpenEditors){const N=E.$Hb(this.c.groups.flatMap(re=>re.editors.map(fe=>fe.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(N));const L=N.filter(re=>(0,s.$QK)(q,re.fsPath)),Z=this.i(L);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Z)),{...q,...Z}}const V=m.extraFileResources&&m.extraFileResources.filter(N=>(0,s.$QK)(q,N.fsPath));return q.extraFileResources=V&&V.length?V:void 0,q}i(k){const m=[],w=new A.$Ac,F={};let T=!1;return k.forEach(G=>{if(G.scheme===M.Schemas.walkThrough)return;if((0,c.$fh)(G)){const V=this.b.getWorkspaceFolder(G)?.uri??G.with({path:$.$mc(G.fsPath)});let N=w.get(V);N||(T=!0,N={folder:V,includePattern:{}},m.push(N),w.set(V,N));const L=$.$lc(V.fsPath,G.fsPath);(0,v.$lg)(N.includePattern)[L.replace(/\\/g,"/")]=!0}else G.fsPath&&(T=!0,F[G.fsPath]=!0)}),{folderQueries:m,includePattern:F,usingSearchPaths:!0,excludePattern:T?void 0:{"**/*":!0}}}j(k,m){if(m.isSmartCase){if(k.isRegExp){if(C.$4f(k.pattern,!0))return!0}else if(C.$4f(k.pattern))return!0}return!!k.isCaseSensitive}k(k){return k.isMultiline||k.isRegExp&&(0,D.$2C)(k.pattern)||k.pattern.indexOf(`
`)>=0?!0:!!k.isMultiline}parseSearchPaths(k){const m=Z=>$.$ic(Z)||/^\.\.?([\/\\]|$)/.test(Z),F=(Array.isArray(k)?k:f(k)).map(Z=>{const re=this.e.resolvedUserHome;return re?(0,O.$Pw)(Z,re.scheme===M.Schemas.file?re.fsPath:re.path):Z}),T=R.$K(F,Z=>m(Z)?"searchPaths":"exprSegments"),G=(T.exprSegments||[]).map(Z=>C.$jf(Z,"/")).map(Z=>C.$jf(Z,"\\")).map(Z=>(Z[0]==="."&&(Z="*"+Z),l(Z))),q={},V=this.m(T.searchPaths||[]);V&&V.length&&(q.searchPaths=V);const N=G.flat(),L=g(...N);return L&&(q.pattern=L),q}l(k,m){return m.disregardExcludeSettings?void 0:(0,s.$PK)(k,!m.disregardSearchExcludeSettings)}m(k){if(!k||!k.length)return[];const m=k.flatMap(F=>{let{pathPortion:T,globPortion:G}=i(F);return G&&(G=I(G)),this.n(T).flatMap(V=>this.o(V,G))}),w=new Map;return m.forEach(F=>{const T=F.searchPath.toString(),G=w.get(T);G?F.pattern&&(G.pattern=G.pattern||{},G.pattern[F.pattern]=!0):w.set(T,{searchPath:F.searchPath,pattern:F.pattern?g(F.pattern):void 0})}),Array.from(w.values())}n(k){if($.$ic(k)){const m=this.b.getWorkspace().folders;return m[0]&&m[0].uri.scheme!==M.Schemas.file?[{searchPath:m[0].uri.with({path:k})}]:[{searchPath:u.URI.file($.$hc(k))}]}if(this.b.getWorkbenchState()===a.WorkbenchState.FOLDER){const m=this.b.getWorkspace().folders[0].uri;if(k=b(k),k.startsWith("../")||k===".."){const F=$.$gc.resolve(m.path,k);return[{searchPath:m.with({path:F})}]}const w=I(k);return[{searchPath:m,pattern:w}]}else{if(k==="./"||k===".\\")return[];{const m=k.replace(/^\.[\/\\]/,""),F=this.b.getWorkspace().folders.map(T=>{const G=m.match(new RegExp(`^${C.$df(T.name)}(?:/(.*)|$)`));return G?{match:G,folder:T}:null}).filter(v.$ig);if(F.length)return F.map(T=>{const G=T.match[1];return{searchPath:T.folder.uri,pattern:G&&I(G)}});{const T=k.match(/\.[\/\\](.+)[\/\\]?/),G=T?T[1]:k,q=d.localize(0,null,G);throw new Error(q)}}}}o(k,m){const w=k.pattern&&m?`${k.pattern}/${m}`:k.pattern||m,F=[{searchPath:k.searchPath,pattern:w}];return w&&!w.endsWith("**")&&F.push({searchPath:k.searchPath,pattern:w+"/**"}),F}q(k,m,w){const F=this.r((0,a.$Vi)(k.searchPath),m,w,!1);return F?{...F,includePattern:k.pattern}:null}r(k,m,w,F){let T;const G=u.URI.isUri(k)?k:k.uri;if(w.searchPaths){const Z=w.searchPaths.filter(re=>(0,c.$7g)(re.searchPath,G))[0];if(Z&&!Z.pattern)return null;Z&&(T=Z.pattern)}const q=this.a.getValue({resource:G}),N={...this.l(q,m)||{},...T||{}},L=u.URI.isUri(k)?(0,c.$$g)(k):k.name;return{folder:G,folderName:F?L:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:q.files&&q.files.encoding,disregardIgnoreFiles:typeof m.disregardIgnoreFiles=="boolean"?m.disregardIgnoreFiles:!q.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof m.disregardGlobalIgnoreFiles=="boolean"?m.disregardGlobalIgnoreFiles:!q.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof m.disregardParentIgnoreFiles=="boolean"?m.disregardParentIgnoreFiles:!q.search.useParentIgnoreFiles,ignoreSymlinks:typeof m.ignoreSymlinks=="boolean"?m.ignoreSymlinks:!q.search.followSymlinks}}};e.$$L=n,e.$$L=n=He([Ve(0,r.$7i),Ve(1,a.$Ji),Ve(2,h.$0D),Ve(3,o.$7j),Ve(4,t.$9L)],n);function i(p){const k=p.match(/[\*\{\}\(\)\[\]\?]/);if(k){const m=k.index,w=p.substr(0,m).match(/[/|\\][^/\\]*$/);if(w){let F=p.substr(0,w.index);return F.match(/[/\\]/)||(F+="/"),{pathPortion:F,globPortion:p.substr((w.index||0)+1)}}}return{pathPortion:p}}function g(...p){return p.length?p.reduce((k,m)=>(k[m]=!0,k),Object.create(null)):void 0}function f(p){return P.$sk(p,",").map(k=>k.trim()).filter(k=>!!k.length)}function l(p){return[`**/${p}/**`,`**/${p}`].map(m=>m.replace(/\*\*\/\*\*/g,"**"))}function b(p){return p.replace(/\\/g,"/")}function I(p){return b(p).replace(/^\.\//,"").replace(/\/+$/g,"")}function S(p){return p.replace(/([?*[\]])/g,"[$1]")}function y(p,k){p=E.$Mb(p,F=>F.toString());const m=[],w=k.getWorkspace();return p&&p.forEach(F=>{let T;if(k.getWorkbenchState()===a.WorkbenchState.FOLDER)T=(0,c.$dh)(w.folders[0].uri,F),T&&T!=="."&&(T="./"+T);else{const G=k.getWorkspaceFolder(F);if(G){const q=G.name;if(w.folders.filter(N=>N.name===q).length===1){const N=(0,c.$dh)(G.uri,F);N===""?T=`./${G.name}`:T=`./${G.name}/${N}`}else T=F.fsPath}}T&&m.push(S(T))}),m}}),define(ke[313],Ie([1,0,24,2,22,14,3,312,43,50,11]),function(de,e,E,R,P,O,A,M,$,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kwb=u,e.$Lwb=r;const v=7e3;function u(o,a){const h=a.activationEvents;if(!h)return Promise.resolve(void 0);const t=[],s=[];for(const b of h)if(/^workspaceContains:/.test(b)){const I=b.substr(18);I.indexOf("*")>=0||I.indexOf("?")>=0||o.forceUsingSearch?s.push(I):t.push(I)}if(t.length===0&&s.length===0)return Promise.resolve(void 0);const{promise:n,resolve:i}=(0,C.$th)(),g=b=>i({activationEvent:b}),f=Promise.all(t.map(b=>D(o,b,g))).then(()=>{}),l=d(o,a.identifier,s,g);return Promise.all([f,l]).then(()=>{i(void 0)}),n}async function D(o,a,h){for(const t of o.folders)if(await o.exists(E.$bh(R.URI.revive(t),a))){h(`workspaceContains:${a}`);return}}async function d(o,a,h,t){if(h.length===0)return Promise.resolve(void 0);const s=new P.$se,n=o.checkExists(o.folders,h,s.token),i=setTimeout(async()=>{s.cancel(),o.logService.info(`Not activating extension '${a.value}': Timed out while searching for 'workspaceContains' pattern ${h.join(",")}`)},v);let g=!1;try{g=await n}catch(f){O.$4(f)||O.$1(f)}s.dispose(),clearTimeout(i),g&&t(`workspaceContains:${h.join(",")}`)}function r(o,a,h,t){const s=o.get(A.$zi),n=o.get($.$HK),g=s.createInstance(M.$$L).file(a.map(f=>(0,c.$Vi)(R.URI.revive(f))),{_reason:"checkExists",includePattern:h,exists:!0});return n.fileSearch(g,t).then(f=>!!f.limitHit,f=>O.$4(f)?!1:Promise.reject(f))}}),define(ke[46],Ie([1,0,180,20,64,24,11,6,58,2,12,5,45,246,89,44,25,117,14,19,23,228,7,108,3,27,92,17,75,93,57,95,4,313,88,230,16,86,69,21,87]),function(de,e,E,R,P,O,A,M,$,c,C,v,u,D,d,r,o,a,h,t,s,n,i,g,f,l,b,I,S,y,p,k,m,w,F,T,G,q,V,N,L){"use strict";var Z;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mnc=e.$Lnc=e.$Knc=e.$Jnc=e.$Inc=void 0,e.$Inc=(0,f.$Ai)("IHostUtils");let re=Z=class extends M.$Uc{constructor(X,W,ie,Se,he,we,ae,Y,x,me,ge,Te,Be){super(),this.Y=Te,this.Z=Be,this.a=this.B(new m.$he),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=W,this.g=ie,this.f=ae,this.j=Se,this.m=he,this.s=we,this.t=x,this.u=me,this.w=ge,this.y=this.g.getProxy(v.$uM.MainThreadWorkspace),this.z=this.g.getProxy(v.$uM.MainThreadTelemetry),this.C=this.g.getProxy(v.$uM.MainThreadExtensionService),this.D=new A.$zh,this.F=new A.$zh,this.G=new A.$zh,this.H=new A.$zh,this.I=new Ce(this.f.extensions.activationEvents),this.L=new a.$bbc(this.I,this.f.extensions.allExtensions);const Ee=new t.$Xm(this.f.extensions.myExtensions);this.J=new a.$bbc(this.I,$e(this.L,Ee)),N.$t&&(this.s.info(`Creating extension host with the following global extensions: ${oe(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${oe(this.J)}`)),this.M=new d.$rnc(this.g,this.s),this.N=new F.$Bnc(this.g),this.O=Y,this.h=X.createChild(new S.$yi([d.$snc,this.M],[F.$Cnc,this.N])),this.P=this.B(new D.$qnc(this.J,this.L,{onExtensionActivationError:(Re,Oe,j)=>{this.C.$onExtensionActivationError(Re,h.$3(Oe),j)},actualActivateExtension:async(Re,Oe)=>{if(a.$bbc.isHostExtension(Re,this.J,this.L))return await this.C.$activateExtension(Re,Oe),new D.$pnc;const j=this.J.getExtensionDescription(Re);return this.fb(j,Oe)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),P.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(X){h.$1(X)}}async $(){this.O.onWillDeactivateAll();let X=[];try{X=this.J.getAllExtensionDescriptions().map(he=>he.identifier).filter(he=>this.isActivated(he)).map(he=>this.eb(he))}catch{}await Promise.all(X)}terminate(X,W=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${X}`),this.s.flush(),this.u.dispose(),this.P.dispose(),h.setUnexpectedErrorHandler(Se=>{this.s.error(Se)}),this.g.dispose();const ie=this.$();Promise.race([(0,A.$Bh)(5e3),ie]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${W}`):this.s.info(`Extension host exiting with code ${W}`),this.s.flush(),this.s.dispose(),this.c.exit(W)})}isActivated(X){return this.G.isOpen()?this.P.isActivated(X):!1}async getExtension(X){const W=await this.C.$getExtension(X);return W&&{...W,identifier:new t.$Wm(W.identifier.value),extensionLocation:c.URI.revive(W.extensionLocation)}}ab(X,W){return this.P.activateByEvent(X,W)}bb(X,W){return this.P.activateById(X,W)}activateByIdWithErrors(X,W){return this.bb(X,W).then(()=>{const ie=this.P.getActivatedExtension(X);if(ie.activationFailed)return Promise.reject(ie.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(X=>this.J)}getExtensionExports(X){if(this.G.isOpen())return this.P.getActivatedExtension(X).exports;try{return this.P.getActivatedExtension(X).exports}catch{return null}}async cb(X){if(X.scheme===G.Schemas.file&&this.c.fsRealpath){const W=X.fsPath;this.R.has(W)||this.R.set(W,this.c.fsRealpath(W));const ie=await this.R.get(W);return c.URI.file(ie)}return X}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(X=>new se(X))),this.Q}async db(X){const W=$.$Gi.forUris(ie=>O.$5g.ignorePathCasing(ie));return await Promise.all(X.map(async ie=>{if(this.wb(ie)){const Se=await this.cb(ie.extensionLocation);W.set(Se,ie)}})),W}eb(X){let W=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(X))return W;const ie=this.P.getActivatedExtension(X);if(!ie)return W;try{typeof ie.module.deactivate=="function"&&(W=Promise.resolve(ie.module.deactivate()).then(void 0,Se=>(this.s.error(Se),Promise.resolve(void 0))))}catch(Se){this.s.error(`An error occurred when deactivating the extension '${X.value}':`),this.s.error(Se)}try{(0,M.$Pc)(ie.subscriptions)}catch(Se){this.s.error(`An error occurred when deactivating the subscriptions for extension '${X.value}':`),this.s.error(Se)}return W}async fb(X,W){return this.f.remote.isRemote?this.C.$onWillActivateExtension(X.identifier):await this.C.$onWillActivateExtension(X.identifier),this.hb(X,W).then(ie=>{const Se=ie.activationTimes;return this.C.$onDidActivateExtension(X.identifier,Se.codeLoadingTime,Se.activateCallTime,Se.activateResolvedTime,W),this.gb(X,W,"success",Se),ie},ie=>{throw this.gb(X,W,"failure"),ie})}gb(X,W,ie,Se){const he=be(X,W);this.z.$publicLog2("extensionActivationTimes",{...he,...Se||{},outcome:ie})}hb(X,W){const ie=be(X,W);this.z.$publicLog2("activatePlugin",ie);const Se=this.wb(X);if(!Se)return Promise.resolve(new D.$onc(D.$lnc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${X.identifier.value}, startup: ${W.startup}, activationEvent: '${W.activationEvent}'${X.identifier.value!==W.extensionId.value?`, root cause: ${W.extensionId.value}`:""}`),this.s.flush();const he=new D.$mnc(W.startup);return Promise.all([this.xb(X,(0,O.$bh)(X.extensionLocation,Se),he),this.ib(X)]).then(we=>(P.mark(`code/extHost/willActivateExtension/${X.identifier.value}`),Z.jb(this.s,X.identifier,we[0],we[1],he))).then(we=>(P.mark(`code/extHost/didActivateExtension/${X.identifier.value}`),we))}ib(X){const W=this.Z.createLanguageModelAccessInformation(X),ie=new n.$unc(X,this.M),Se=new n.$tnc(X.identifier.value,!1,this.M),he=new T.$Dnc(X,this.N),we=X.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,ae=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${X.identifier.value}`),Promise.all([ie.whenReady,Se.whenReady,this.O.whenReady]).then(()=>{const Y=this;let x,me;const ge=(0,o.$TG)(X,"ipc")?this.f.messagePorts?.get(t.$Wm.toKey(X.identifier)):void 0;return Object.freeze({globalState:ie,workspaceState:Se,secrets:he,subscriptions:[],get languageModelAccessInformation(){return W},get extensionUri(){return X.extensionLocation},get extensionPath(){return X.extensionLocation.fsPath},asAbsolutePath(Te){return R.$jc(X.extensionLocation.fsPath,Te)},get storagePath(){return Y.O.workspaceValue(X)?.fsPath},get globalStoragePath(){return Y.O.globalValue(X).fsPath},get logPath(){return R.$jc(Y.f.logsLocation.fsPath,X.identifier.value)},get logUri(){return c.URI.joinPath(Y.f.logsLocation,X.identifier.value)},get storageUri(){return Y.O.workspaceValue(X)},get globalStorageUri(){return Y.O.globalValue(X)},get extensionMode(){return we},get extension(){return x===void 0&&(x=new pe(Y,X.identifier,X,ae,!1)),x},get extensionRuntime(){return(0,o.$UG)(X,"extensionRuntime"),Y.extensionRuntime},get environmentVariableCollection(){return Y.u.getEnvironmentVariableCollection(X)},get messagePassingProtocol(){if(!me){if(!ge)return;const Te=m.Event.buffer(m.Event.fromDOMEventEmitter(ge,"message",Be=>Be.data));ge.start(),me={onDidReceiveMessage:Te,postMessage:ge.postMessage.bind(ge)}}return me}})})}static jb(X,W,ie,Se,he){return ie=ie||{activate:void 0,deactivate:void 0},this.kb(X,W,ie,Se,he).then(we=>new D.$nnc(!1,null,he.build(),ie,we,Se.subscriptions))}static kb(X,W,ie,Se,he){if(typeof ie.activate=="function")try{he.activateCallStart(),X.trace(`ExtensionService#_callActivateOptional ${W.value}`);const we=typeof global=="object"?global:self,ae=ie.activate.apply(we,[Se]);return he.activateCallStop(),he.activateResolveStart(),Promise.resolve(ae).then(Y=>(he.activateResolveStop(),Y))}catch(we){return Promise.reject(we)}else return Promise.resolve(ie)}lb(X,W){this.bb(X.identifier,{startup:!1,extensionId:X.identifier,activationEvent:W}).then(void 0,ie=>{this.s.error(ie)})}mb(X,W=0){const Se=Date.now();(0,N.$B)(()=>{for(let he=W;he<X.length;he+=1){const we=X[he];for(const ae of we.activationEvents??[])if(ae==="onStartupFinished")if(Date.now()-Se>50){this.mb(X,he);break}else this.lb(we,ae)}})}nb(){this.C.$setPerformanceMarks(P.getMarks()),this.m.getConfigProvider().then(X=>{const W=X.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ie=this.J.getAllExtensionDescriptions();if(W)this.mb(ie);else for(const Se of ie)if(Se.activationEvents)for(const he of Se.activationEvents)he==="onStartupFinished"&&this.lb(Se,he)})}ob(){const X=this.ab("*",!0).then(void 0,we=>{this.s.error(we)});this.B(this.j.onDidChangeWorkspace(we=>this.pb(we.added)));const W=this.j.workspace?this.j.workspace.folders:[],ie=this.pb(W),Se=this.rb(),he=Promise.all([Se,X,ie]).then(()=>{});return Promise.race([he,(0,A.$Bh)(1e4)]).then(()=>{this.nb()}),he}pb(X){return X.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(W=>this.qb(X,W))).then(()=>{})}async qb(X,W){if(this.isActivated(W.identifier))return;const ie=!this.f.remote.isRemote&&!!this.f.remote.authority,Se={logService:this.s,folders:X.map(we=>we.uri),forceUsingSearch:ie||!this.c.fsExists,exists:we=>this.c.fsExists(we.fsPath),checkExists:(we,ae,Y)=>this.y.$checkExists(we,ae,Y)},he=await(0,w.$Kwb)(Se,W);if(he)return this.bb(W.identifier,{startup:!0,extensionId:W.identifier,activationEvent:he.activationEvent}).then(void 0,we=>this.s.error(we))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(X){throw console.error(X),X}}async sb(){const{extensionDevelopmentLocationURI:X,extensionTestsLocationURI:W}=this.f.environment;if(!X||!W)throw new Error(E.localize(0,null));const ie=await this.xb(null,W,new D.$mnc(!1));if(!ie||typeof ie.run!="function")throw new Error(E.localize(1,null,W.toString()));return new Promise((Se,he)=>{const we=(x,me)=>{x?(N.$t&&this.s.error("Test runner called back with error",x),he(x)):(N.$t&&(me?this.s.info(`Test runner called back with ${me} failures.`):this.s.info("Test runner called back with successful outcome.")),Se(typeof me=="number"&&me>0?1:0))},ae=(0,O.$2g)(W),Y=ie.run(ae,we);Y&&Y.then&&Y.then(()=>{N.$t&&this.s.info("Test runner finished successfully."),Se(0)}).catch(x=>{N.$t&&this.s.error("Test runner finished with error",x),he(x instanceof Error&&x.stack?x.stack:String(x))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$Bh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(X,W){return this.S[X]=W,(0,M.$Sc)(()=>{delete this.S[X]})}async getRemoteExecServer(X){const{resolver:W}=await this.ub(X);return W?.resolveExecServer?.(X,{resolveAttempt:0})}async ub(X){const W=X.indexOf("+");if(W===-1)throw new i.$CM("Not an authority that can be resolved!",g.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ie=X.substr(0,W);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${ie}`,!1),{authorityPrefix:ie,resolver:this.S[ie]}}async $resolveAuthority(X,W){const ie=V.$be.create(!1),Se=()=>`[resolveAuthority(${(0,g.$Pl)(X)},${W})][${ie.elapsed()}ms] `,he=z=>this.s.info(`${Se()}${z}`),we=z=>this.s.warn(`${Se()}${z}`),ae=(z,K=void 0)=>this.s.error(`${Se()}${z}`,K),Y=z=>{if(z instanceof i.$CM)return{type:"error",error:{code:z._code,message:z._message,detail:z._detail}};throw z},x=async z=>{he(`activating resolver for ${z}...`);const{resolver:K,authorityPrefix:J}=await this.ub(z);if(!K)throw ae(`no resolver for ${J}`),new i.$CM(`No remote extension installed to resolve ${J}.`,g.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:K,authorityPrefix:J,remoteAuthority:z}},me=X.split(/@|%40/g).reverse();he(`activating remote resolvers ${me.join(" -> ")}`);let ge;try{ge=await Promise.all(me.map(x)).catch(async z=>{if(!(z instanceof i.$CM)||z._code!==g.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw z;return we(`resolving nested authorities failed: ${z.message}`),[await x(X)]})}catch(z){return Y(z)}const Te=new A.$Lh;Te.cancelAndSet(()=>he("waiting..."),1e3);let Be,Ee;for(const[z,{authorityPrefix:K,resolver:J,remoteAuthority:te}]of ge.entries())try{if(z===ge.length-1)he("invoking final resolve()..."),P.mark(`code/extHost/willResolveAuthority/${K}`),Be=await J.resolve(te,{resolveAttempt:W,execServer:Ee}),P.mark(`code/extHost/didResolveAuthorityOK/${K}`),he("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(J,i.$BM.isManagedResolvedAuthority(Be)?Be:void 0));else{if(he(`invoking resolveExecServer() for ${te}`),P.mark(`code/extHost/willResolveExecServer/${K}`),Ee=await J.resolveExecServer?.(te,{resolveAttempt:W,execServer:Ee}),!Ee)throw new i.$CM(`Exec server was not available for ${te}`,g.RemoteAuthorityResolverErrorCode.NoResolverFound);P.mark(`code/extHost/didResolveExecServerOK/${K}`)}}catch(le){return P.mark(`code/extHost/didResolveAuthorityError/${K}`),ae("returned an error",le),Te.dispose(),Y(le)}Te.dispose();const Re={environmentTunnels:Be.environmentTunnels,features:Be.tunnelFeatures?{elevation:Be.tunnelFeatures.elevation,privacyOptions:Be.tunnelFeatures.privacyOptions,protocol:Be.tunnelFeatures.protocol===void 0?!0:Be.tunnelFeatures.protocol}:void 0},Oe={extensionHostEnv:Be.extensionHostEnv,isTrusted:Be.isTrusted,authenticationSession:Be.authenticationSessionForInitializingExtensions?{id:Be.authenticationSessionForInitializingExtensions.id,providerId:Be.authenticationSessionForInitializingExtensions.providerId}:void 0};he(`returned ${i.$BM.isManagedResolvedAuthority(Be)?"managed authority":`${Be.host}:${Be.port}`}`);let j;if(i.$BM.isManagedResolvedAuthority(Be)){const z=W;this.Y.setFactory(z,Be.makeConnection),j={authority:X,connectTo:new g.$Ml(z),connectionToken:Be.connectionToken}}else j={authority:X,connectTo:new g.$Nl(Be.host,Be.port),connectionToken:Be.connectionToken};return{type:"ok",value:{authority:j,options:Oe,tunnelInformation:Re}}}async $getCanonicalURI(X,W){this.s.info(`$getCanonicalURI invoked for authority (${(0,g.$Pl)(X)})`);const{resolver:ie}=await this.ub(X);if(!ie)return null;const Se=c.URI.revive(W);if(typeof ie.getCanonicalURI>"u")return Se;const he=await(0,A.$sh)(()=>ie.getCanonicalURI(Se));return he||Se}async $startExtensionHost(X){X.toAdd.forEach(we=>we.extensionLocation=c.URI.revive(we.extensionLocation));const{globalRegistry:W,myExtensions:ie}=fe(this.I,this.L,this.J,X),Se=await this.db(ie);return(await this.getExtensionPathIndex()).setSearchTree(Se),this.L.set(W.getAllExtensionDescriptions()),this.J.set(ie),N.$t&&(this.s.info(`$startExtensionHost: global extensions: ${oe(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${oe(this.J)}`)),this.tb()}$activateByEvent(X,W){return W===o.ActivationKind.Immediate?this.D.wait().then(ie=>this.ab(X,!1)):this.G.wait().then(ie=>this.ab(X,!1))}async $activate(X,W){return await this.G.wait(),this.J.getExtensionDescription(X)?(await this.bb(X,W),!0):!1}async $deltaExtensions(X){X.toAdd.forEach(we=>we.extensionLocation=c.URI.revive(we.extensionLocation));const{globalRegistry:W,myExtensions:ie}=fe(this.I,this.L,this.J,X),Se=await this.db(ie);return(await this.getExtensionPathIndex()).setSearchTree(Se),this.L.set(W.getAllExtensionDescriptions()),this.J.set(ie),N.$t&&(this.s.info(`$deltaExtensions: global extensions: ${oe(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${oe(this.J)}`)),Promise.resolve(void 0)}async $test_latency(X){return X}async $test_up(X){return X.byteLength}async $test_down(X){const W=s.$Je.alloc(X),ie=Math.random()%256;for(let Se=0;Se<X;Se++)W.writeUInt8(ie,Se);return W}async $updateRemoteConnectionData(X){this.X=X,this.a.fire()}};e.$Jnc=re,e.$Jnc=re=Z=He([Ve(0,f.$zi),Ve(1,e.$Inc),Ve(2,I.$YO),Ve(3,r.$7mc),Ve(4,u.$0mc),Ve(5,C.$7j),Ve(6,l.$cP),Ve(7,b.$anc),Ve(8,y.$nEb),Ve(9,p.$vnc),Ve(10,q.$Fnc),Ve(11,L.$Gnc),Ve(12,k.$znc)],re);function fe(Fe,X,W,ie){Fe.addActivationEvents(ie.addActivationEvents);const Se=new a.$bbc(Fe,X.getAllExtensionDescriptions());Se.deltaExtensions(ie.toAdd,ie.toRemove);const he=new t.$Xm(W.getAllExtensionDescriptions().map(ae=>ae.identifier));for(const ae of ie.myToRemove)he.delete(ae);for(const ae of ie.myToAdd)he.add(ae);const we=$e(Se,he);return{globalRegistry:Se,myExtensions:we}}function be(Fe,X){return{id:Fe.identifier.value,name:Fe.name,extensionVersion:Fe.version,publisherDisplayName:Fe.publisher,activationEvents:Fe.activationEvents?Fe.activationEvents.join(","):null,isBuiltin:Fe.isBuiltin,reason:X.activationEvent,reasonId:X.extensionId.value}}function oe(Fe){return Fe.getAllExtensionDescriptions().map(X=>X.identifier.value).join(",")}e.$Knc=(0,f.$Ai)("IExtHostExtensionService");class pe{#e;#t;#i;constructor(X,W,ie,Se,he){this.#e=X,this.#t=W,this.#i=ie.identifier,this.id=ie.identifier.value,this.extensionUri=ie.extensionLocation,this.extensionPath=R.$hc((0,O.$2g)(ie.extensionLocation)),this.packageJSON=ie,this.extensionKind=Se,this.isFromDifferentExtensionHost=he}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Lnc=pe;function $e(Fe,X){return Fe.getAllExtensionDescriptions().filter(W=>X.has(W.identifier))}class se{constructor(X){this.a=X}setSearchTree(X){this.a=X}findSubstr(X){return this.a.findSubstr(X)}forEach(X){return this.a.forEach(X)}}e.$Mnc=se;class Ce{constructor(X){this.a=new t.$Ym,this.addActivationEvents(X)}readActivationEvents(X){return this.a.get(X.identifier)??[]}addActivationEvents(X){for(const W of Object.keys(X))this.a.set(W,X[W])}}}),define(ke[314],Ie([1,0,64,2,5,45,25,19,17,27,3,46,12,13]),function(de,e,E,R,P,O,A,M,$,c,C,v,u,D){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$Voc=void 0;let r=class{constructor(s,n,i,g,f,l,b){this.c=s,this.d=n,this.e=i,this.f=g,this.g=f,this.h=l,this.i=b,this.a=new Map,this.b=[]}async install(){this.j(),E.mark("code/extHost/willWaitForConfig");const s=await this.f.getConfigProvider();E.mark("code/extHost/didWaitForConfig");const n=await this.g.getExtensionPathIndex();this.register(new a(this.c,n,this.d,s,this.i)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(h,n,this.h.environment.appUriScheme))}register(s){if("nodeModuleName"in s)if(Array.isArray(s.nodeModuleName))for(const n of s.nodeModuleName)this.a.set(n,s);else this.a.set(s.nodeModuleName,s);typeof s.alternativeModuleName=="function"&&this.b.push(n=>s.alternativeModuleName(n))}};e.$Voc=r,e.$Voc=r=He([Ve(2,C.$zi),Ve(3,O.$0mc),Ve(4,v.$Knc),Ve(5,c.$cP),Ve(6,u.$7j)],r);let o=class{static{d=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(s){if(s.environment.appRoot&&d.a.size){const n=(0,D.$df)(this.c(s.environment.appRoot.fsPath)),i="[a-z0-9_.-]",g=`@${i}+\\/${i}+|${i}+`,f="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${n}/${f}\\/)(${g})(.*)$`,"i")}}alternativeModuleName(s){if(!this.b)return;const n=this.b.exec(this.c(s));if(!n)return;const[,i,g,f]=n,l=d.a.get(g);if(l!==void 0)return console.warn(`${g} as been renamed to ${l}, please update your imports`),i+l+f}c(s){return s.replace(/\\/g,"/")}};o=d=He([Ve(0,c.$cP)],o);class a{constructor(s,n,i,g,f){this.c=s,this.d=n,this.e=i,this.f=g,this.g=f,this.nodeModuleName="vscode",this.a=new M.$Ym}load(s,n){const i=this.d.findSubstr(n);if(i){let g=this.a.get(i.identifier);return g||(g=this.c(i,this.e,this.f),this.a.set(i.identifier,g)),g}if(!this.b){let g="";this.d.forEach((f,l)=>g+=`	${l} -> ${f.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${n}. These are the extension path mappings: 
${g}`),this.b=this.c(A.$OG,this.e,this.f)}return this.b}}let h=class{constructor(s,n,i){this.e=s,this.f=n,this.nodeModuleName=["open","opn"],this.d=i.getProxy(P.$uM.MainThreadTelemetry);const g=i.getProxy(P.$uM.MainThreadWindow);this.c=(f,l)=>{const b=R.URI.parse(f);return l?this.g(f,l):b.scheme==="http"||b.scheme==="https"?g.$openUri(b,f,{allowTunneling:!0}):b.scheme==="mailto"||b.scheme===this.f?g.$openUri(b,f,{}):this.g(f,l)}}load(s,n,i){const g=this.e.findSubstr(n);return g&&(this.a=g.identifier.value,this.h()),this.b=i(s),this.c}g(s,n){return this.i(),this.b(s,n)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};h=He([Ve(2,$.$YO)],h)}),define(ke[130],Ie([1,0,47,6,20,79,3,71,70,46,7,44,243,45]),function(de,e,E,R,P,O,A,M,$,c,C,v,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Onc=e.$Nnc=void 0,e.$Nnc=(0,A.$Ai)("IExtHostVariableResolverProvider");class d extends u.$3P{constructor(a,h,t,s,n,i,g){function f(){if(t){const l=t.activeEditor();if(l)return l.document.uri;const b=s.tabGroups.all.find(I=>I.isActive)?.activeTab;if(b!==void 0){if(b.input instanceof C.$iO||b.input instanceof C.$nO)return b.input.modified;if(b.input instanceof C.$hO||b.input instanceof C.$mO||b.input instanceof C.$kO)return b.input.uri}}}super({getFolderUri:l=>{const b=i.folders.filter(I=>I.name===l);if(b&&b.length>0)return b[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(l,b)=>n.getConfiguration(void 0,l).get(b),getAppRoot:()=>O.cwd(),getExecPath:()=>O.env.VSCODE_EXEC_PATH,getFilePath:()=>{const l=f();if(l)return P.$hc(l.fsPath)},getWorkspaceFolderPathForFile:()=>{if(h){const l=f();if(l){const b=h.getWorkspaceFolder(l);if(b)return P.$hc(b.uri.fsPath)}}},getSelectedText:()=>{if(t){const l=t.activeEditor();if(l&&!l.selection.isEmpty)return l.document.getText(l.selection)}},getLineNumber:()=>{if(t){const l=t.activeEditor();if(l)return String(l.selection.end.line+1)}},getExtension:l=>a.getExtension(l)},void 0,g?Promise.resolve(g):void 0,Promise.resolve(O.env))}}let r=class extends R.$Uc{constructor(a,h,t,s,n){super(),this.b=a,this.c=h,this.g=t,this.h=s,this.j=n,this.a=new E.$V(async()=>{const i=await this.h.getConfigProvider(),f={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async l=>{f.folders=await this.c.getWorkspaceFolders2()||[]})),new d(this.b,this.c,this.g,this.j,i,f,this.m())})}getResolver(){return this.a.value}m(){}};e.$Onc=r,e.$Onc=r=He([Ve(0,c.$Knc),Ve(1,v.$7mc),Ve(2,M.$0O),Ve(3,D.$0mc),Ve(4,$.$jnc)],r)}),define(ke[131],Ie([1,0,11,4,2,19,3,5,70,46,17,7,44,235,81,236,45,130,6,34,39,10,18]),function(de,e,E,R,P,O,A,M,$,c,C,v,u,D,d,r,o,a,h,t,s,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tnc=e.$Snc=e.$Rnc=e.$Qnc=e.$Pnc=void 0,e.$Pnc=(0,A.$Ai)("IExtHostDebugService");let g=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(p,k,m,w,F,T,G){this.N=k,this.O=m,this.P=w,this.Q=F,this.R=T,this.S=G,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new R.$he,this.o=new R.$he,this.q=new R.$he,this.w=new R.$he,this.l=p.getProxy(M.$uM.MainThreadDebugService),this.A=new R.$he,this.C=new R.$he,this.y=new l(this.l),this.z=new Map,this.O.getExtensionRegistry().then(q=>{q.onDidChange(V=>{this.V(q)}),this.V(q)})}async $getVisualizerTreeItem(p,k){const m=this.W(k);if(!m)return;const w=await this.H.get(p)?.getTreeItem?.(m);return w?this.U(p,w):void 0}registerDebugVisualizationTree(p,k,m){const w=O.$Wm.toKey(p.identifier),F=this.jb(w,k);if(this.G.has(F))throw new Error(`A debug visualization provider with id '${k}' is already registered`);return this.H.set(F,m),this.l.$registerDebugVisualizerTree(F,!!m.editItem),(0,h.$Sc)(()=>{this.l.$unregisterDebugVisualizerTree(F),this.H.delete(k)})}async $getVisualizerTreeItemChildren(p,k){const m=this.J.get(k)?.item;return m?(await this.H.get(p)?.getChildren?.(m))?.map(F=>this.U(p,F))||[]:[]}async $editVisualizerTreeItem(p,k){const m=this.J.get(p);if(!m)return;const w=await this.H.get(m.provider)?.editItem?.(m.item,k);return this.U(m.provider,w||m.item)}$disposeVisualizedTree(p){const k=this.J.get(p);if(!k)return;const m=[k.children];for(const w of m)if(w)for(const F of w)m.push(this.J.get(F)?.children),this.J.delete(F)}U(p,k){let m=this.I.get(k);return m||(m=this.F++,this.I.set(k,m),this.J.set(m,{provider:p,item:k})),n.DebugTreeItem.from(k,m)}asDebugSourceUri(p,k){const m=p;if(typeof m.sourceReference=="number"&&m.sourceReference>0){let w=`debug:${encodeURIComponent(m.path||"")}`,F="?";return k&&(w+=`${F}session=${encodeURIComponent(k.id)}`,F="&"),w+=`${F}ref=${m.sourceReference}`,P.URI.parse(w)}else{if(m.path)return P.URI.file(m.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(p){const k=[];for(const m of p.getAllExtensionDescriptions())if(m.contributes){const w=m.contributes.debuggers;if(w&&w.length>0)for(const F of w)(0,r.$KH)(F)&&k.push(F.type)}this.l.$registerDebugTypes(k)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const p=[];return this.z.forEach(k=>p.push(k)),p}async $resolveDebugVisualizer(p,k){const m=this.L.get(p);if(!m)throw new Error(`No debug visualizer found with id '${p}'`);let{v:w,provider:F,extensionId:T}=m;if(w.visualization||(w=await F.resolveDebugVisualization?.(w,k)||w,m.v=w),!w.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${F}'`);return this.kb(T,w.visualization)}async $executeDebugVisualizerCommand(p){const k=this.L.get(p);if(!k)throw new Error(`No debug visualizer found with id '${p}'`);const m=k.v.visualization;m&&"command"in m&&this.S.executeCommand(m.command,...m.arguments||[])}W(p){const k=this.m.get(p.sessionId);return k&&{session:k.api,variable:p.variable,containerId:p.containerId,frameId:p.frameId,threadId:p.threadId}}async $provideDebugVisualizers(p,k,m,w){const F=this.W(m),T=this.jb(p,k),G=this.G.get(T);if(!F||!G)return[];const q=await G.provideDebugVisualization(F,w);return q?q.map(V=>{const N=++this.M;this.L.set(N,{v:V,provider:G,extensionId:p});const L=V.iconPath?this.lb(V.iconPath):void 0;return{id:N,name:V.name,iconClass:L?.iconClass,iconPath:L?.iconPath,visualization:this.kb(p,V.visualization)}}):[]}$disposeDebugVisualizers(p){for(const k of p)this.L.delete(k)}registerDebugVisualizationProvider(p,k,m){if(!p.contributes?.debugVisualizers?.some(T=>T.id===k))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${k})`);const w=O.$Wm.toKey(p.identifier),F=this.jb(w,k);if(this.G.has(F))throw new Error(`A debug visualization provider with id '${k}' is already registered`);return this.G.set(F,m),this.l.$registerDebugVisualizer(w,k),(0,h.$Sc)(()=>{this.l.$unregisterDebugVisualizer(w,k),this.G.delete(k)})}addBreakpoints(p){const k=p.filter(F=>{const T=F.id;return this.z.has(T)?!1:(this.z.set(T,F),!0)});this.gb(k,[],[]);const m=[],w=new Map;for(const F of k)if(F instanceof v.$yN){let T=w.get(F.location.uri.toString());T||(T={type:"sourceMulti",uri:F.location.uri,lines:[]},w.set(F.location.uri.toString(),T),m.push(T)),T.lines.push({id:F.id,enabled:F.enabled,condition:F.condition,hitCondition:F.hitCondition,logMessage:F.logMessage,line:F.location.range.start.line,character:F.location.range.start.character,mode:F.mode})}else F instanceof v.$zN&&m.push({type:"function",id:F.id,enabled:F.enabled,hitCondition:F.hitCondition,logMessage:F.logMessage,condition:F.condition,functionName:F.functionName,mode:F.mode});return this.l.$registerBreakpoints(m)}removeBreakpoints(p){const k=p.filter(T=>this.z.delete(T.id));this.gb([],k,[]);const m=k.filter(T=>T instanceof v.$yN).map(T=>T.id),w=k.filter(T=>T instanceof v.$zN).map(T=>T.id),F=k.filter(T=>T instanceof v.$AN).map(T=>T.id);return this.l.$unregisterBreakpoints(m,w,F)}startDebugging(p,k,m){return this.l.$startDebugging(p?p.uri:void 0,k,{parentSessionID:m.parentSession?m.parentSession.id:void 0,lifecycleManagedByParent:m.lifecycleManagedByParent,repl:m.consoleMode===v.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:m.noDebug,compact:m.compact,suppressSaveBeforeStart:m.suppressSaveBeforeStart,suppressDebugStatusbar:m.suppressDebugStatusbar??m.debugUI?.simple,suppressDebugToolbar:m.suppressDebugToolbar??m.debugUI?.simple,suppressDebugView:m.suppressDebugView??m.debugUI?.simple})}stopDebugging(p){return this.l.$stopDebugging(p?p.id:void 0)}registerDebugConfigurationProvider(p,k,m){if(!k)return new v.$wM(()=>{});const w=this.d++;return this.f.push({type:p,handle:w,provider:k}),this.l.$registerDebugConfigurationProvider(p,m,!!k.provideDebugConfigurations,!!k.resolveDebugConfiguration,!!k.resolveDebugConfigurationWithSubstitutedVariables,w),new v.$wM(()=>{this.f=this.f.filter(F=>F.provider!==k),this.l.$unregisterDebugConfigurationProvider(w)})}registerDebugAdapterDescriptorFactory(p,k,m){if(!m)return new v.$wM(()=>{});if(!this.cb(p,k))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${k}' debugger.`);if(this.$(k))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const w=this.g++;return this.h.push({type:k,handle:w,factory:m}),this.l.$registerDebugAdapterDescriptorFactory(k,w),new v.$wM(()=>{this.h=this.h.filter(F=>F.factory!==m),this.l.$unregisterDebugAdapterDescriptorFactory(w)})}registerDebugAdapterTrackerFactory(p,k){if(!k)return new v.$wM(()=>{});const m=this.j++;return this.k.push({type:p,handle:m,factory:k}),new v.$wM(()=>{this.k=this.k.filter(w=>w.factory!==k)})}async $runInTerminal(p,k){return Promise.resolve(void 0)}async $substituteVariables(p,k){let m;const w=await this.ib(p);return w&&(m={uri:w.uri,name:w.name,index:w.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(m,k)}X(p,k){if(p.type==="implementation")return new I(p.implementation)}Y(){}async $startDASession(p,k){const m=this,w=await this.hb(k);return this.eb(this.$(w.type),w).then(F=>{if(!F)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}' (extension might have failed to activate)`);const T=this.Z(F),G=this.X(T,w);if(!G)throw new Error(`Couldn't create a debug adapter for type '${w.type}'.`);const q=G;return this.D.set(p,q),this.db(w).then(V=>(V&&this.E.set(p,V),q.onMessage(async N=>{if(N.type==="request"&&N.command==="handshake"){const L=N,Z={type:"response",seq:0,command:L.command,request_seq:L.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const re=await this.K.sign(L.arguments.value);Z.body={signature:re},q.sendResponse(Z)}else throw new Error("no signer")}catch(re){Z.success=!1,Z.message=re.message,q.sendResponse(Z)}}else V&&V.onDidSendMessage&&V.onDidSendMessage(N),N=(0,r.$PH)(N,!0),m.l.$acceptDAMessage(p,N)}),q.onError(N=>{V&&V.onError&&V.onError(N),this.l.$acceptDAError(p,N.name,N.message,N.stack)}),q.onExit(N=>{V&&V.onExit&&V.onExit(N??void 0,void 0),this.l.$acceptDAExit(p,N??void 0,void 0)}),V&&V.onWillStartSession&&V.onWillStartSession(),q.startSession()))})}$sendDAMessage(p,k){k=(0,r.$OH)(k,!1);const m=this.E.get(p);m&&m.onWillReceiveMessage&&m.onWillReceiveMessage(k),this.D.get(p)?.sendMessage(k)}$stopDASession(p){const k=this.E.get(p);this.E.delete(p),k&&k.onWillStopSession&&k.onWillStopSession();const m=this.D.get(p);return this.D.delete(p),m?m.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(p){const k=[],m=[],w=[];if(p.added)for(const F of p.added){const T=F.id;if(T&&!this.z.has(T)){let G;if(F.type==="function")G=new v.$zN(F.functionName,F.enabled,F.condition,F.hitCondition,F.logMessage,F.mode);else if(F.type==="data")G=new v.$AN(F.label,F.dataId,F.canPersist,F.enabled,F.hitCondition,F.condition,F.logMessage,F.mode);else{const q=P.URI.revive(F.uri);G=new v.$yN(new v.$IM(q,new v.$xM(F.line,F.character)),F.enabled,F.condition,F.hitCondition,F.logMessage,F.mode)}(0,v.$wN)(G,T),this.z.set(T,G),k.push(G)}}if(p.removed)for(const F of p.removed){const T=this.z.get(F);T&&(this.z.delete(F),m.push(T))}if(p.changed){for(const F of p.changed)if(F.id){const T=this.z.get(F.id);if(T){if(T instanceof v.$zN&&F.type==="function"){const G=T;G.enabled=F.enabled,G.condition=F.condition,G.hitCondition=F.hitCondition,G.logMessage=F.logMessage,G.functionName=F.functionName}else if(T instanceof v.$yN&&F.type==="source"){const G=T;G.enabled=F.enabled,G.condition=F.condition,G.hitCondition=F.hitCondition,G.logMessage=F.logMessage,G.location=new v.$IM(P.URI.revive(F.uri),new v.$xM(F.line,F.character))}w.push(T)}}}this.gb(k,m,w)}async $acceptStackFrameFocus(p){let k;if(p){const m=await this.hb(p.sessionId);p.kind==="thread"?k=new v.$GN(m.api,p.threadId):k=new v.$FN(m.api,p.threadId,p.frameId)}this.B=k,this.C.fire(this.B)}$provideDebugConfigurations(p,k,m){return(0,E.$sh)(async()=>{const w=this.bb(p);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const F=await this.ib(k);return w.provideDebugConfigurations(F,m)}).then(w=>{if(!w)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return w})}$resolveDebugConfiguration(p,k,m,w){return(0,E.$sh)(async()=>{const F=this.bb(p);if(!F)throw new Error("no DebugConfigurationProvider found");if(!F.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const T=await this.ib(k);return F.resolveDebugConfiguration(T,m,w)})}$resolveDebugConfigurationWithSubstitutedVariables(p,k,m,w){return(0,E.$sh)(async()=>{const F=this.bb(p);if(!F)throw new Error("no DebugConfigurationProvider found");if(!F.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const T=await this.ib(k);return F.resolveDebugConfigurationWithSubstitutedVariables(T,m,w)})}async $provideDebugAdapter(p,k){const m=this.ab(p);if(!m)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const w=await this.hb(k);return this.eb(m,w).then(F=>{if(!F)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}'`);return this.Z(F)})}async $acceptDebugSessionStarted(p){const k=await this.hb(p);this.n.fire(k.api)}async $acceptDebugSessionTerminated(p){const k=await this.hb(p);k&&(this.o.fire(k.api),this.m.delete(k.id))}async $acceptDebugSessionActiveChanged(p){this.u=p?await this.hb(p):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(p,k){(await this.hb(p))?._acceptNameChanged(k)}async $acceptDebugSessionCustomEvent(p,k){const w={session:(await this.hb(p)).api,event:k.event,body:k.body};this.w.fire(w)}Z(p){if(p instanceof v.$BN)return{type:"executable",command:p.command,args:p.args,options:p.options};if(p instanceof v.$CN)return{type:"server",port:p.port,host:p.host};if(p instanceof v.$DN)return{type:"pipeServer",path:p.path};if(p instanceof v.$EN)return{type:"implementation",implementation:p.implementation};throw new Error("convertToDto unexpected type")}$(p){const k=this.h.filter(m=>m.type===p);if(k.length>0)return k[0].factory}ab(p){const k=this.h.filter(m=>m.handle===p);if(k.length>0)return k[0].factory}bb(p){const k=this.f.filter(m=>m.handle===p);if(k.length>0)return k[0].provider}cb(p,k){if(p.contributes){const m=p.contributes.debuggers;if(m&&m.length>0){for(const w of m)if(w.label&&w.type&&w.type===k)return!0}}return!1}db(p){const m=p.configuration.type,w=this.k.filter(F=>F.type===m||F.type==="*").map(F=>(0,E.$sh)(()=>F.factory.createDebugAdapterTracker(p.api)).then(T=>T,T=>null));return Promise.race([Promise.all(w).then(F=>{const T=(0,i.$Hb)(F);if(T.length>0)return new b(T)}),new Promise(F=>setTimeout(()=>F(void 0),1e3))]).catch(F=>{})}async eb(p,k){const m=k.configuration.debugServer;if(typeof m=="number")return Promise.resolve(new v.$CN(m));if(p){const F=await this.O.getExtensionRegistry();return(0,E.$sh)(()=>p.createDebugAdapterDescriptor(k.api,this.fb(k,F))).then(T=>{if(T)return T})}const w=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(k,w))}fb(p,k){}gb(p,k,m){(p.length>0||k.length>0||m.length>0)&&this.A.fire(Object.freeze({added:p,removed:k,changed:m}))}async hb(p){if(p)if(typeof p=="string"){const k=this.m.get(p);if(k)return k}else{let k=this.m.get(p.id);if(!k){const m=await this.ib(p.folderUri),w=p.parent?this.m.get(p.parent):void 0;k=new f(this.l,p.id,p.type,p.name,m,p.configuration,w?.api),this.m.set(k.id,k),this.l.$sessionCached(k.id)}return k}throw new Error("cannot find session")}ib(p){if(p){const k=P.URI.revive(p);return this.N.resolveWorkspaceFolder(k)}return Promise.resolve(void 0)}jb(p,k){return`${p}\0${k}`}kb(p,k){if(k){if("title"in k&&"command"in k)return{type:d.DebugVisualizationType.Command};if("treeId"in k)return{type:d.DebugVisualizationType.Tree,id:`${p}\0${k.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(p){const k=this.mb(p);let m,w;return"id"in k?w=t.ThemeIcon.asClassName(k):m=k,{iconPath:m,iconClass:w}}mb(p){if(p instanceof v.$tN)return{id:p.id};const k=typeof p=="object"&&"dark"in p?p.dark:p,m=typeof p=="object"&&"light"in p?p.light:p;return{dark:typeof k=="string"?P.URI.file(k):k,light:typeof m=="string"?P.URI.file(m):m}}};e.$Qnc=g,e.$Qnc=g=He([Ve(0,C.$YO),Ve(1,u.$7mc),Ve(2,c.$Knc),Ve(3,o.$0mc),Ve(4,$.$jnc),Ve(5,a.$Nnc),Ve(6,s.$iP)],g);class f{constructor(p,k,m,w,F,T,G){this.f=p,this.g=k,this.h=m,this.j=w,this.k=F,this.l=T,this.m=G}get api(){const p=this;return this.d??=Object.freeze({id:p.g,type:p.h,get name(){return p.j},set name(k){p.j=k,p.f.$setDebugSessionName(p.g,k)},parentSession:p.m,workspaceFolder:p.k,configuration:p.l,customRequest(k,m){return p.f.$customDebugAdapterRequest(p.g,k,m)},getDebugProtocolBreakpoint(k){return p.f.$getDebugProtocolBreakpoint(p.g,k.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(p){this.j=p}get configuration(){return this.l}}e.$Rnc=f;class l{constructor(p){this.value=Object.freeze({append(k){p.$appendDebugConsole(k)},appendLine(k){this.append(k+`
`)}})}}e.$Snc=l;class b{constructor(p){this.d=p}onWillStartSession(){this.d.forEach(p=>p.onWillStartSession?p.onWillStartSession():void 0)}onWillReceiveMessage(p){this.d.forEach(k=>k.onWillReceiveMessage?k.onWillReceiveMessage(p):void 0)}onDidSendMessage(p){this.d.forEach(k=>k.onDidSendMessage?k.onDidSendMessage(p):void 0)}onWillStopSession(){this.d.forEach(p=>p.onWillStopSession?p.onWillStopSession():void 0)}onError(p){this.d.forEach(k=>k.onError?k.onError(p):void 0)}onExit(p,k){this.d.forEach(m=>m.onExit?m.onExit(p,k):void 0)}}class I extends D.$fsb{constructor(p){super(),this.h=p,p.onDidSendMessage(k=>{this.acceptMessage(k)})}startSession(){return Promise.resolve(void 0)}sendMessage(p){this.h.handleMessage(p)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let S=class extends g{constructor(p,k,m,w,F,T,G){super(p,k,m,w,F,T,G)}};e.$Tnc=S,e.$Tnc=S=He([Ve(0,C.$YO),Ve(1,u.$7mc),Ve(2,c.$Knc),Ve(3,o.$0mc),Ve(4,$.$jnc),Ve(5,a.$Nnc),Ve(6,s.$iP)],S)}),define(ke[315],Ie([1,0,14,64,2,5,265,12,60,75,27,210,17,65,46,66]),function(de,e,E,R,P,O,A,M,$,c,C,v,u,D,d,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xoc=e.$Woc=void 0;class o{static async installEarlyHandler(t){Error.stackTraceLimit=100;const s=t.get(M.$7j),i=t.get(u.$YO).getProxy(O.$uM.MainThreadErrors);E.setUnexpectedErrorHandler(g=>{s.error(g);const f=E.$3(g);i.$onUnexpectedError(f)})}static async installFullHandler(t){const s=t.get(M.$7j),n=t.get(u.$YO),i=t.get(d.$Knc),g=t.get(r.$gP),f=n.getProxy(O.$uM.MainThreadExtensionService),l=n.getProxy(O.$uM.MainThreadErrors),b=await i.getExtensionPathIndex(),I=new WeakMap;function S(k,m){if(I.has(k))return I.get(k).stack;let w="",F,T;for(const q of m)w+=`
	at ${q.toString()}`,T=q.getFileName(),!F&&T&&(F=b.findSubstr(P.URI.file(T)));const G=`${k.name||"Error"}: ${k.message||""}${w}`;return I.set(k,{extensionIdentifier:F?.identifier,stack:G}),G}const y=Symbol("prepareStackTrace wrapped");let p=S;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return p},set(k){if(k===S||!k||k[y]){p=k||S;return}p=function(m,w){return S(m,w),k.call(Error,m,w)},Object.assign(p,{[y]:!0})}}),E.setUnexpectedErrorHandler(k=>{s.error(k);const m=E.$3(k),w=I.get(k);if(!w?.extensionIdentifier){l.$onUnexpectedError(m);return}f.$onExtensionRuntimeError(w.extensionIdentifier,m);const F=g.onExtensionError(w.extensionIdentifier,k);s.trace("forwarded error to extension?",F,w)})}}e.$Woc=o;class a{constructor(t,s,n,i,g){this.a=n,this.b=new A.$jbc(t,null,i),s=a.e(s,this.b);const f=new c.$yi(...(0,$.$Gs)());f.set(C.$cP,{_serviceBrand:void 0,...s,messagePorts:g}),f.set(u.$YO,new u.$ZO(this.b)),f.set(D.$4mc,new D.$5mc(i)),f.set(d.$Inc,n);const l=new v.$kr(f,!0);l.invokeFunction(o.installEarlyHandler),this.d=l.invokeFunction(b=>b.get(M.$7j)),R.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",s),this.c=l.invokeFunction(b=>b.get(d.$Knc)),this.c.initialize(),l.invokeFunction(o.installFullHandler)}async asBrowserUri(t){const s=this.b.getProxy(O.$uM.MainThreadExtensionService);return P.URI.revive(await s.$asBrowserUri(t))}terminate(t){this.c.terminate(t)}static e(t,s){t.extensions.allExtensions.forEach(i=>{i.extensionLocation=P.URI.revive(s.transformIncomingURIs(i.extensionLocation))}),t.environment.appRoot=P.URI.revive(s.transformIncomingURIs(t.environment.appRoot));const n=t.environment.extensionDevelopmentLocationURI;return n&&(t.environment.extensionDevelopmentLocationURI=n.map(i=>P.URI.revive(s.transformIncomingURIs(i)))),t.environment.extensionTestsLocationURI=P.URI.revive(s.transformIncomingURIs(t.environment.extensionTestsLocationURI)),t.environment.globalStorageHome=P.URI.revive(s.transformIncomingURIs(t.environment.globalStorageHome)),t.environment.workspaceStorageHome=P.URI.revive(s.transformIncomingURIs(t.environment.workspaceStorageHome)),t.environment.extensionTelemetryLogResource=P.URI.revive(s.transformIncomingURIs(t.environment.extensionTelemetryLogResource)),t.nlsBaseUrl=P.URI.revive(s.transformIncomingURIs(t.nlsBaseUrl)),t.logsLocation=P.URI.revive(s.transformIncomingURIs(t.logsLocation)),t.workspace=s.transformIncomingURIs(t.workspace),t}}e.$Xoc=a}),define(ke[316],Ie([1,0,18,11,22,48,16,20,24,2,43]),function(de,e,E,R,P,O,A,M,$,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$nc=e.$9nc=e.$8nc=void 0,e.$0nc=r;class v{constructor(h,t,s){this.d=h,this.e=t,this.f=s,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(h,t){const s=this.g.folderQueries||[],n=new P.$se(t);return new Promise((i,g)=>{this.a=new D(h);let f=!1;const l=(b,I)=>{if(!f&&!this.b){const S=this.h(b);r(b)&&typeof this.g.maxResults=="number"&&this.c+S>this.g.maxResults&&(this.b=!0,f=!0,n.cancel(),b=this.j(b,this.g.maxResults-this.c));const y=this.h(b);this.c+=y,(y>0||!r(b))&&this.a.add(b,I)}};Promise.all(s.map((b,I)=>this.k(b,S=>l(S,I),n.token))).then(b=>{n.dispose(),this.a.flush();const I=b.some(S=>!!S&&!!S.limitHit);i({limitHit:this.b||I,messages:b.flatMap(S=>S?.message?Array.isArray(S.message)?S.message:[S.message]:[]),stats:{type:this.f}})},b=>{n.dispose();const I=(0,O.$lj)(b);g(new Error(I))})})}h(h){return r(h)?Array.isArray(h.ranges)?h.ranges.length:1:0}j(h,t){const s=Array.isArray(h.ranges)?h.ranges:[h.ranges],n=Array.isArray(h.preview.matches)?h.preview.matches:[h.preview.matches];return{ranges:s.slice(0,t),preview:{matches:n.slice(0,t),text:h.preview.text},uri:h.uri}}async k(h,t,s){const n=new C.$1K(this.g,h),i=[],g={report:b=>{if(!this.l(b))return;const I=h.folder.scheme===A.Schemas.file?(0,C.$2K)(()=>this.e.readdir($.$ah(b.uri))):void 0,S=$.$dh(h.folder,b.uri);if(S){const y=n.includedInQuery(S,M.$nc(S),I);(0,R.$mh)(y)?i.push(y.then(p=>{p&&t(b)})):y&&t(b)}}},f=this.n(h);let l;return this.d.query.type===C.QueryType.aiText?l=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,f,g,s):l=await this.d.provider.provideTextSearchResults(u(this.d.query.contentPattern),f,g,s),i.length&&await Promise.all(i),l}l(h){if(r(h)){if(Array.isArray(h.ranges)){if(!Array.isArray(h.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(h.preview.matches.length!==h.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(h.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(h){const t=(0,C.$ZK)(this.g.includePattern,h.includePattern),s=(0,C.$ZK)(this.g.excludePattern,h.excludePattern),n={folder:c.URI.from(h.folder),excludes:s,includes:t,useIgnoreFiles:!h.disregardIgnoreFiles,useGlobalIgnoreFiles:!h.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!h.disregardParentIgnoreFiles,followSymlinks:!h.ignoreSymlinks,encoding:h.fileEncoding&&this.e.toCanonicalName(h.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults??Number.MAX_SAFE_INTEGER,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(n.usePCRE2=this.g.usePCRE2),n}}e.$8nc=v;function u(a){return{isCaseSensitive:a.isCaseSensitive||!1,isRegExp:a.isRegExp||!1,isWordMatch:a.isWordMatch||!1,isMultiline:a.isMultiline||!1,pattern:a.pattern}}class D{constructor(h){this.e=h,this.b=-1,this.d=null,this.a=new o(512,t=>this.g(t))}add(h,t){this.d&&(this.b!==t||!$.$7g(this.c,h.uri))&&(this.f(),this.d=null),this.d||(this.b=t,this.d={resource:h.uri,results:[]}),this.d.results.push(d(h))}f(){const h=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,h)}flush(){this.f(),this.a.flush()}g(h){this.e(h)}}e.$9nc=D;function d(a){return r(a)?{preview:{matches:(0,E.$1b)(a.preview.matches,h=>({startLineNumber:h.start.line,startColumn:h.start.character,endLineNumber:h.end.line,endColumn:h.end.character})),text:a.preview.text},ranges:(0,E.$1b)(a.ranges,h=>({startLineNumber:h.start.line,startColumn:h.start.character,endLineNumber:h.end.line,endColumn:h.end.character}))}:{text:a.text,lineNumber:a.lineNumber}}function r(a){return!!a.preview}class o{static{this.a=4e3}static{this.b=50}constructor(h,t){this.g=h,this.h=t,this.c=0,this.d=[],this.e=0}addItem(h,t){h&&this.j(h,t)}addItems(h,t){h&&this.k(h,t)}j(h,t){this.d.push(h),this.e+=t,this.l()}k(h,t){this.d=this.d.concat(h),this.e+=t,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$$nc=o}),define(ke[132],Ie([1,0,6,5,3,311,17,65,12,2,316]),function(de,e,E,R,P,O,A,M,$,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aoc=e.$_nc=void 0,e.$boc=u,e.$_nc=(0,P.$Ai)("IExtHostSearch");let v=class{constructor(r,o,a){this.n=r,this.o=o,this.q=a,this.c=this.n.getProxy(R.$uM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new O.$7nc}s(r){return this.o.transformOutgoingScheme(r)}registerTextSearchProvider(r,o){if(this.g.has(r))throw new Error(`a text search provider for the scheme '${r}' is already registered`);this.g.add(r);const a=this.d++;return this.e.set(a,o),this.c.$registerTextSearchProvider(a,this.s(r)),(0,E.$Sc)(()=>{this.g.delete(r),this.e.delete(a),this.c.$unregisterProvider(a)})}registerAITextSearchProvider(r,o){if(this.i.has(r))throw new Error(`an AI text search provider for the scheme '${r}'is already registered`);this.i.add(r);const a=this.d++;return this.h.set(a,o),this.c.$registerAITextSearchProvider(a,this.s(r)),(0,E.$Sc)(()=>{this.i.delete(r),this.h.delete(a),this.c.$unregisterProvider(a)})}registerFileSearchProvider(r,o){if(this.k.has(r))throw new Error(`a file search provider for the scheme '${r}' is already registered`);this.k.add(r);const a=this.d++;return this.j.set(a,o),this.c.$registerFileSearchProvider(a,this.s(r)),(0,E.$Sc)(()=>{this.k.delete(r),this.j.delete(a),this.c.$unregisterProvider(a)})}$provideFileSearchResults(r,o,a,h){const t=u(a),s=this.j.get(r);if(s)return this.l.fileSearch(t,s,n=>{this.c.$handleFileMatch(r,o,n.map(i=>i.resource))},h);throw new Error("3 unknown provider: "+r)}async doInternalFileSearchWithCustomCallback(r,o,a){return{messages:[]}}$clearCache(r){return this.l.clearCache(r),Promise.resolve(void 0)}$provideTextSearchResults(r,o,a,h){const t=this.e.get(r);if(!t||!t.provideTextSearchResults)throw new Error(`2 Unknown provider ${r}`);const s=u(a);return this.t(s,t).search(i=>this.c.$handleTextMatch(r,o,i),h)}$provideAITextSearchResults(r,o,a,h){const t=this.h.get(r);if(!t||!t.provideAITextSearchResults)throw new Error(`1 Unknown provider ${r}`);const s=u(a);return this.v(s,t).search(i=>this.c.$handleTextMatch(r,o,i),h)}$enableExtensionHostSearch(){}t(r,o){return new C.$8nc({query:r,provider:o},{readdir:a=>Promise.resolve([]),toCanonicalName:a=>a},"textSearchProvider")}v(r,o){return new C.$8nc({query:r,provider:o},{readdir:a=>Promise.resolve([]),toCanonicalName:a=>a},"aiTextSearchProvider")}};e.$aoc=v,e.$aoc=v=He([Ve(0,A.$YO),Ve(1,M.$4mc),Ve(2,$.$7j)],v);function u(d){return{...d,folderQueries:d.folderQueries&&d.folderQueries.map(D),extraFileResources:d.extraFileResources&&d.extraFileResources.map(r=>c.URI.revive(r))}}function D(d){return{...d,folder:c.URI.revive(d.folder)}}}),define(ke[317],Ie([1,0,22,14,4,6,16,35,2,104,163,149,52,19,30,12,62,63,224,5,268,296,85,91,273,274,275,252,241,39,276,45,277,131,120,278,254,269,279,280,71,70,255,270,46,282,68,283,51,27,297,256,284,95,285,86,87,258,310,287,229,288,298,289,126,259,290,291,292,17,293,132,88,294,260,295,89,92,129,66,57,124,299,300,271,301,302,93,10,7,261,65,262,67,303,304,119,44,81,84,25,128]),function(de,e,E,R,P,O,A,M,$,c,C,v,u,D,d,r,o,a,h,t,s,n,i,g,f,l,b,I,S,y,p,k,m,w,F,T,G,q,V,N,L,Z,re,fe,be,oe,pe,$e,se,Ce,Fe,X,W,ie,Se,he,we,ae,Y,x,me,ge,Te,Be,Ee,Re,Oe,j,z,K,J,te,le,Ae,je,Ge,Ze,tt,_e,it,nt,mt,lt,rt,at,dt,We,ze,_,H,ye,Ke,xe,ct,gt,Mt,Qt,Ut,li,xt,Ye,Wt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Roc=zt;function zt(ft){const pt=ft.get(Ce.$cP),_t=ft.get(se.$Omc),Yt=ft.get(pe.$_mc),jt=ft.get(be.$Knc),bt=ft.get(Ut.$7mc),Ot=ft.get(it.$gP),Gt=ft.get(k.$0mc),Bt=ft.get(Ke.$4mc),Qe=ft.get(K.$YO),ei=ft.get(Ze.$snc),ti=ft.get(tt.$anc),ci=ft.get(r.$8j),St=ft.get(r.$7j),Tt=ft.get(ze.$nEb),Pt=ft.get(i.$Kmc),Nt=ft.get(Qt.$Qoc),ui=ft.get(le.$Cnc),Vt=ft.get(Z.$jnc),ri=ft.get(we.$Gnc),Lt=ft.get(g.$Umc),Xt=ft.get(ie.$znc);Qe.set(t.$vM.ExtHostFileSystemInfo,_t),Qe.set(t.$vM.ExtHostLogLevelServiceShape,ci),Qe.set(t.$vM.ExtHostWorkspace,bt),Qe.set(t.$vM.ExtHostConfiguration,Gt),Qe.set(t.$vM.ExtHostExtensionService,jt),Qe.set(t.$vM.ExtHostStorage,ei),Qe.set(t.$vM.ExtHostTunnelService,Tt),Qe.set(t.$vM.ExtHostWindow,Nt),Qe.set(t.$vM.ExtHostSecretState,ui),Qe.set(t.$vM.ExtHostTelemetry,Ot),Qe.set(t.$vM.ExtHostEditorTabs,Vt),Qe.set(t.$vM.ExtHostManagedSockets,ri),Qe.set(t.$vM.ExtHostAuthentication,Lt),Qe.set(t.$vM.ExtHostChatProvider,Xt);const si=Qe.set(t.$vM.ExtHostDecorations,ft.get(F.$Vnc)),Ct=Qe.set(t.$vM.ExtHostDocumentsAndEditors,ft.get(L.$0O)),wt=Qe.set(t.$vM.ExtHostCommands,ft.get(y.$iP)),$t=Qe.set(t.$vM.ExtHostTerminalService,ft.get(nt.$vnc)),qt=Qe.set(t.$vM.ExtHostTerminalShellIntegration,ft.get(mt.$Coc)),Dt=Qe.set(t.$vM.ExtHostDebugService,ft.get(w.$Pnc)),oi=Qe.set(t.$vM.ExtHostSearch,ft.get(te.$_nc)),Kt=Qe.set(t.$vM.ExtHostTask,ft.get(_e.$Boc)),pi=Qe.set(t.$vM.ExtHostOutputService,ft.get(Ee.$ooc)),di=Qe.set(t.$vM.ExtHostLocalization,ft.get(he.$Fnc)),ki=Qe.set(t.$vM.ExtHostUrls,new xe.$Noc(Qe)),Rt=Qe.set(t.$vM.ExtHostDocuments,new N.$Rmc(Qe,Ct)),Pi=Qe.set(t.$vM.ExtHostDocumentContentProviders,new q.$Xnc(Qe,Ct,St)),ai=Qe.set(t.$vM.ExtHostDocumentSaveParticipant,new V.$Ync(St,Rt,Qe.getProxy(t.$uM.MainThreadBulkEdits))),It=Qe.set(t.$vM.ExtHostNotebook,new Y.$coc(Qe,wt,Ct,Rt,Yt,oi,St)),Ii=Qe.set(t.$vM.ExtHostNotebookDocuments,new me.$ioc(It)),wi=Qe.set(t.$vM.ExtHostNotebookEditors,new ge.$joc(St,It)),$i=Qe.set(t.$vM.ExtHostNotebookKernels,new Te.$koc(Qe,pt,It,wt,St)),Ri=Qe.set(t.$vM.ExtHostNotebookRenderers,new Be.$moc(Qe,It)),fi=Qe.set(t.$vM.ExtHostNotebookDocumentSaveParticipant,new x.$hoc(St,It,Qe.getProxy(t.$uM.MainThreadBulkEdits))),ve=Qe.set(t.$vM.ExtHostEditors,new rt.$1mc(Qe,Ct)),Me=Qe.set(t.$vM.ExtHostTreeViews,new We.$Loc(Qe.getProxy(t.$uM.MainThreadTreeViews),wt,St)),ue=Qe.set(t.$vM.ExtHostEditorInsets,new S.$2mc(Qe.getProxy(t.$uM.MainThreadEditorInsets),ve,pt.remote)),Q=Qe.set(t.$vM.ExtHostDiagnostics,new T.$Qmc(Qe,St,_t,Ct)),Pe=Qe.set(t.$vM.ExtHostLanguages,new Se.$foc(Qe,Rt,wt.converter,Bt)),Ue=Qe.set(t.$vM.ExtHostLanguageFeatures,new W.$Smc(Qe,Bt,Rt,wt,Q,St,Pt,Ot)),Xe=Qe.set(t.$vM.ExtHostFileSystem,new oe.$2nc(Qe,Ue)),qe=Qe.set(t.$vM.ExtHostFileSystemEventService,new $e.$3nc(Qe,St,Ct)),ut=Qe.set(t.$vM.ExtHostQuickOpen,(0,z.$soc)(Qe,bt,wt)),kt=Qe.set(t.$vM.ExtHostSCM,new J.$uoc(Qe,wt,Rt,St)),Zt=Qe.set(t.$vM.ExtHostQuickDiff,new j.$roc(Qe,Bt)),ii=Qe.set(t.$vM.ExtHostShare,new Ae.$voc(Qe,Bt)),Ft=Qe.set(t.$vM.ExtHostComments,(0,p.$3mc)(Qe,wt,Rt)),Ht=Qe.set(t.$vM.ExtHostProgress,new Oe.$qoc(Qe.getProxy(t.$uM.MainThreadProgress))),Li=Qe.set(t.$vM.ExtHostLabelService,new X.$eoc(Qe)),Ui=Qe.set(t.$vM.ExtHostTheming,new at.$Ioc(Qe)),Xi=Qe.set(t.$vM.ExtHostTimeline,new dt.$Koc(Qe,wt)),zi=Qe.set(t.$vM.ExtHostWebviews,new ct.$enc(Qe,pt.remote,bt,St,Pt)),Mi=Qe.set(t.$vM.ExtHostWebviewPanels,new gt.$hnc(Qe,zi,bt)),ji=Qe.set(t.$vM.ExtHostCustomEditors,new m.$inc(Qe,Rt,ti,zi,Mi)),Bi=Qe.set(t.$vM.ExtHostWebviewViews,new Mt.$Ooc(Qe,zi)),yi=Qe.set(t.$vM.ExtHostTesting,new lt.$Eoc(Qe,St,wt,Ct)),Zi=Qe.set(t.$vM.ExtHostUriOpeners,new ye.$Moc(Qe)),xi=Qe.set(t.$vM.ExtHostProfileContentHandlers,new Re.$poc(Qe));Qe.set(t.$vM.ExtHostInteractive,new Fe.$doc(Qe,It,Ct,wt,St));const Ti=Qe.set(t.$vM.ExtHostChatAgents2,new l.$Xmc(Qe,St,wt,pt.quality)),Wi=Qe.set(t.$vM.ExtHostChatVariables,new b.$Ymc(Qe)),Vi=Qe.set(t.$vM.ExtHostAiRelatedInformation,new s.$Jmc(Qe)),gn=Qe.set(t.$vM.ExtHostAiEmbeddingVector,new fe.$1nc(Qe)),_i=Qe.set(t.$vM.ExtHostStatusBar,new Ge.$yoc(Qe,wt.converter)),qi=Qe.set(t.$vM.ExtHostSpeech,new je.$woc(Qe)),Ei=Qe.set(t.$vM.ExtHostEmbeddings,new re.$Znc(Qe)),mn=Object.values(t.$vM);Qe.assertRegistered(mn);const pn=new f.$Wmc(Qe,Ct),en=new I.$Zmc(Qe),Gi=new ae.$goc(Qe,St),Oi=new G.$Wnc(Qe);return n.$Tmc.register(wt),function(Le,gi,Ki){function st(ee){return(ce,Ne,ot)=>{const Et=ee(At=>{try{ce.call(Ne,At)}catch(Di){R.$2(new Error(`[ExtensionListenerError] Extension '${Le.identifier.value}' FAILED to handle event: ${Di.toString()}`,{cause:Di})),Ot.onExtensionError(Le.identifier,Di)}});return ot?.push(Et),Et}}const yt=function(){let ee=!Le.isUnderDevelopment;function ce(){ee||(St.info(`Extension '${Le.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ee=!0)}return function Ne(ot){if(Array.isArray(ot))ot.forEach(Ne);else if(typeof ot=="string")ce();else{const Et=ot;typeof Et.scheme>"u"&&ce(),typeof Et.exclusive=="boolean"&&(0,Ye.$UG)(Le,"documentFiltersExclusive")}return ot}}(),tn={getSession(ee,ce,Ne){return typeof Ne?.forceNewSession=="object"&&Ne.forceNewSession.learnMore&&(0,Ye.$UG)(Le,"authLearnMore"),Lt.getSession(Le,ee,ce,Ne)},getSessions(ee,ce){return(0,Ye.$UG)(Le,"authGetSessions"),Lt.getSessions(Le,ee,ce)},async hasSession(ee,ce){return(0,Ye.$UG)(Le,"authSession"),!!await Lt.getSession(Le,ee,ce,{silent:!0})},get onDidChangeSessions(){return st(Lt.onDidChangeSessions)},registerAuthenticationProvider(ee,ce,Ne,ot){return Lt.registerAuthenticationProvider(ee,ce,Ne,ot)}},bi={registerCommand(ee,ce,Ne){return wt.registerCommand(!0,ee,ce,Ne,void 0,Le)},registerTextEditorCommand(ee,ce,Ne){return wt.registerCommand(!0,ee,(...ot)=>{const Et=ve.getActiveTextEditor();if(!Et){St.warn("Cannot execute "+ee+" because there is no active text editor.");return}return Et.edit(At=>{ce.apply(Ne,[Et,At,...ot])}).then(At=>{At||St.warn("Edits from command "+ee+" were not applied.")},At=>{St.warn("An error occurred while running command "+ee,At)})},void 0,void 0,Le)},registerDiffInformationCommand:(ee,ce,Ne)=>((0,Ye.$UG)(Le,"diffCommand"),wt.registerCommand(!0,ee,async(...ot)=>{const Et=Ct.activeEditor(!0);if(!Et){St.warn("Cannot execute "+ee+" because there is no active text editor.");return}const At=await ve.getDiffInformation(Et.id);ce.apply(Ne,[At,...ot])},void 0,void 0,Le)),executeCommand(ee,...ce){return wt.executeCommand(ee,...ce)},getCommands(ee=!1){return wt.getCommands(ee)}},Ai={get machineId(){return pt.telemetryInfo.machineId},get sessionId(){return pt.telemetryInfo.sessionId},get language(){return pt.environment.appLanguage},get appName(){return pt.environment.appName},get appRoot(){return pt.environment.appRoot?.fsPath??""},get appHost(){return pt.environment.appHost},get uriScheme(){return pt.environment.appUriScheme},get clipboard(){return en.value},get shell(){return $t.getDefaultShell(!1)},get onDidChangeShell(){return st($t.onDidChangeShell)},get isTelemetryEnabled(){return Ot.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return st(Ot.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Ye.$UG)(Le,"telemetry"),Ot.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ye.$UG)(Le,"telemetry"),st(Ot.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,it.$fP)(pt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ee,ce){return it.$eP.validateSender(ee),Ot.instantiateLogger(Le,ee,ce)},openExternal(ee,ce){return Nt.openUri(ee,{allowTunneling:!!pt.remote.authority,allowContributedOpeners:ce?.allowContributedOpeners})},async asExternalUri(ee){if(ee.scheme===pt.environment.appUriScheme)return ki.createAppUri(ee);try{return await Nt.asExternalUri(ee,{allowTunneling:!!pt.remote.authority})}catch(ce){if((0,A.$Jg)(ee,A.Schemas.http)||(0,A.$Jg)(ee,A.Schemas.https))return ee;throw ce}},get remoteName(){return(0,o.$Nm)(pt.remote.authority)},get remoteAuthority(){return(0,Ye.$UG)(Le,"resolvers"),pt.remote.authority},get uiKind(){return pt.uiKind},get logLevel(){return St.getLevel()},get onDidChangeLogLevel(){return st(St.onDidChangeLogLevel)},get appQuality(){return(0,Ye.$UG)(Le,"resolvers"),pt.quality},get appCommit(){return(0,Ye.$UG)(Le,"resolvers"),pt.commit}};pt.environment.extensionTestsLocationURI||Object.freeze(Ai);const $n={createTestController(ee,ce,Ne){return yi.createTestController(Le,ee,ce,Ne)},createTestObserver(){return(0,Ye.$UG)(Le,"testObserver"),yi.createTestObserver()},runTests(ee){return(0,Ye.$UG)(Le,"testObserver"),yi.runTests(ee)},registerTestFollowupProvider(ee){return(0,Ye.$UG)(Le,"testObserver"),yi.registerTestFollowupProvider(ee)},get onDidChangeTestResults(){return(0,Ye.$UG)(Le,"testObserver"),st(yi.onResultsChanged)},get testResults(){return(0,Ye.$UG)(Le,"testObserver"),yi.results}},ni=pt.remote.isRemote?H.ExtensionKind.Workspace:H.ExtensionKind.UI,Ni={getExtension(ee,ce){(0,Ye.$TG)(Le,"extensionsAny")||(ce=!1);const Ne=gi.mine.getExtensionDescription(ee);if(Ne)return new be.$Lnc(jt,Le.identifier,Ne,ni,!1);if(ce){const ot=gi.all.getExtensionDescription(ee);if(ot)return new be.$Lnc(jt,Le.identifier,ot,ni,!0)}},get all(){const ee=[];for(const ce of gi.mine.getAllExtensionDescriptions())ee.push(new be.$Lnc(jt,Le.identifier,ce,ni,!1));return ee},get allAcrossExtensionHosts(){(0,Ye.$UG)(Le,"extensionsAny");const ee=new D.$Xm(gi.mine.getAllExtensionDescriptions().map(Ne=>Ne.identifier)),ce=[];for(const Ne of gi.all.getAllExtensionDescriptions()){const ot=!ee.has(Ne.identifier);ce.push(new be.$Lnc(jt,Le.identifier,Ne,ni,ot))}return ce},get onDidChange(){return(0,Ye.$TG)(Le,"extensionsAny")?st(P.Event.any(gi.mine.onDidChange,gi.all.onDidChange)):st(gi.mine.onDidChange)}},nn={createDiagnosticCollection(ee){return Q.createDiagnosticCollection(Le.identifier,ee)},get onDidChangeDiagnostics(){return st(Q.onDidChangeDiagnostics)},getDiagnostics:ee=>Q.getDiagnostics(ee),getLanguages(){return Pe.getLanguages()},setTextDocumentLanguage(ee,ce){return Pe.changeLanguage(ee.uri,ce)},match(ee,ce){const Ne=_.LanguageSelector.from(ee);let ot;return(0,C.$ht)(Ne)&&(ot=It.notebookDocuments.find(Et=>Et.apiNotebook.getCells().find(At=>At.document===ce))?.apiNotebook),(0,C.$gt)(Ne,ce.uri,ce.languageId,!0,ot?.uri,ot?.notebookType)},registerCodeActionsProvider(ee,ce,Ne){return Ue.registerCodeActionProvider(Le,yt(ee),ce,Ne)},registerDocumentPasteEditProvider(ee,ce,Ne){return(0,Ye.$UG)(Le,"documentPaste"),Ue.registerDocumentPasteEditProvider(Le,yt(ee),ce,Ne)},registerCodeLensProvider(ee,ce){return Ue.registerCodeLensProvider(Le,yt(ee),ce)},registerDefinitionProvider(ee,ce){return Ue.registerDefinitionProvider(Le,yt(ee),ce)},registerDeclarationProvider(ee,ce){return Ue.registerDeclarationProvider(Le,yt(ee),ce)},registerImplementationProvider(ee,ce){return Ue.registerImplementationProvider(Le,yt(ee),ce)},registerTypeDefinitionProvider(ee,ce){return Ue.registerTypeDefinitionProvider(Le,yt(ee),ce)},registerHoverProvider(ee,ce){return Ue.registerHoverProvider(Le,yt(ee),ce,Le.identifier)},registerEvaluatableExpressionProvider(ee,ce){return Ue.registerEvaluatableExpressionProvider(Le,yt(ee),ce,Le.identifier)},registerInlineValuesProvider(ee,ce){return Ue.registerInlineValuesProvider(Le,yt(ee),ce,Le.identifier)},registerDocumentHighlightProvider(ee,ce){return Ue.registerDocumentHighlightProvider(Le,yt(ee),ce)},registerMultiDocumentHighlightProvider(ee,ce){return Ue.registerMultiDocumentHighlightProvider(Le,yt(ee),ce)},registerLinkedEditingRangeProvider(ee,ce){return Ue.registerLinkedEditingRangeProvider(Le,yt(ee),ce)},registerReferenceProvider(ee,ce){return Ue.registerReferenceProvider(Le,yt(ee),ce)},registerRenameProvider(ee,ce){return Ue.registerRenameProvider(Le,yt(ee),ce)},registerNewSymbolNamesProvider(ee,ce){return(0,Ye.$UG)(Le,"newSymbolNamesProvider"),Ue.registerNewSymbolNamesProvider(Le,yt(ee),ce)},registerDocumentSymbolProvider(ee,ce,Ne){return Ue.registerDocumentSymbolProvider(Le,yt(ee),ce,Ne)},registerWorkspaceSymbolProvider(ee){return Ue.registerWorkspaceSymbolProvider(Le,ee)},registerDocumentFormattingEditProvider(ee,ce){return Ue.registerDocumentFormattingEditProvider(Le,yt(ee),ce)},registerDocumentRangeFormattingEditProvider(ee,ce){return Ue.registerDocumentRangeFormattingEditProvider(Le,yt(ee),ce)},registerOnTypeFormattingEditProvider(ee,ce,Ne,...ot){return Ue.registerOnTypeFormattingEditProvider(Le,yt(ee),ce,[Ne].concat(ot))},registerDocumentSemanticTokensProvider(ee,ce,Ne){return Ue.registerDocumentSemanticTokensProvider(Le,yt(ee),ce,Ne)},registerDocumentRangeSemanticTokensProvider(ee,ce,Ne){return Ue.registerDocumentRangeSemanticTokensProvider(Le,yt(ee),ce,Ne)},registerSignatureHelpProvider(ee,ce,Ne,...ot){return typeof Ne=="object"?Ue.registerSignatureHelpProvider(Le,yt(ee),ce,Ne):Ue.registerSignatureHelpProvider(Le,yt(ee),ce,typeof Ne>"u"?[]:[Ne,...ot])},registerCompletionItemProvider(ee,ce,...Ne){return Ue.registerCompletionItemProvider(Le,yt(ee),ce,Ne)},registerInlineCompletionItemProvider(ee,ce,Ne){return ce.handleDidShowCompletionItem&&(0,Ye.$UG)(Le,"inlineCompletionsAdditions"),ce.handleDidPartiallyAcceptCompletionItem&&(0,Ye.$UG)(Le,"inlineCompletionsAdditions"),Ne&&(0,Ye.$UG)(Le,"inlineCompletionsAdditions"),Ue.registerInlineCompletionsProvider(Le,yt(ee),ce,Ne)},registerInlineEditProvider(ee,ce){return(0,Ye.$UG)(Le,"inlineEdit"),Ue.registerInlineEditProvider(Le,yt(ee),ce)},registerDocumentLinkProvider(ee,ce){return Ue.registerDocumentLinkProvider(Le,yt(ee),ce)},registerColorProvider(ee,ce){return Ue.registerColorProvider(Le,yt(ee),ce)},registerFoldingRangeProvider(ee,ce){return Ue.registerFoldingRangeProvider(Le,yt(ee),ce)},registerSelectionRangeProvider(ee,ce){return Ue.registerSelectionRangeProvider(Le,ee,ce)},registerCallHierarchyProvider(ee,ce){return Ue.registerCallHierarchyProvider(Le,ee,ce)},registerTypeHierarchyProvider(ee,ce){return Ue.registerTypeHierarchyProvider(Le,ee,ce)},setLanguageConfiguration:(ee,ce)=>Ue.setLanguageConfiguration(Le,ee,ce),getTokenInformationAtPosition(ee,ce){return(0,Ye.$UG)(Le,"tokenInformation"),Pe.tokenAtPosition(ee,ce)},registerInlayHintsProvider(ee,ce){return Ue.registerInlayHintsProvider(Le,ee,ce)},createLanguageStatusItem(ee,ce){return Pe.createLanguageStatusItem(Le,ee,ce)},registerDocumentDropEditProvider(ee,ce,Ne){return Ue.registerDocumentOnDropEditProvider(Le,ee,ce,(0,Ye.$TG)(Le,"documentPaste")?Ne:void 0)}},rn={get activeTextEditor(){return ve.getActiveTextEditor()},get visibleTextEditors(){return ve.getVisibleTextEditors()},get activeTerminal(){return $t.activeTerminal},get terminals(){return $t.terminals},async showTextDocument(ee,ce,Ne){$.URI.isUri(ee)&&ee.scheme===A.Schemas.vscodeRemote&&!ee.authority&&Pt.report("workspace.showTextDocument",Le,"A URI of 'vscode-remote' scheme requires an authority.");const ot=await($.URI.isUri(ee)?Promise.resolve(Hi.openTextDocument(ee)):Promise.resolve(ee));return ve.showTextDocument(ot,ce,Ne)},createTextEditorDecorationType(ee){return ve.createTextEditorDecorationType(Le,ee)},onDidChangeActiveTextEditor(ee,ce,Ne){return st(ve.onDidChangeActiveTextEditor)(ee,ce,Ne)},onDidChangeVisibleTextEditors(ee,ce,Ne){return st(ve.onDidChangeVisibleTextEditors)(ee,ce,Ne)},onDidChangeTextEditorSelection(ee,ce,Ne){return st(ve.onDidChangeTextEditorSelection)(ee,ce,Ne)},onDidChangeTextEditorOptions(ee,ce,Ne){return st(ve.onDidChangeTextEditorOptions)(ee,ce,Ne)},onDidChangeTextEditorVisibleRanges(ee,ce,Ne){return st(ve.onDidChangeTextEditorVisibleRanges)(ee,ce,Ne)},onDidChangeTextEditorViewColumn(ee,ce,Ne){return st(ve.onDidChangeTextEditorViewColumn)(ee,ce,Ne)},onDidCloseTerminal(ee,ce,Ne){return st($t.onDidCloseTerminal)(ee,ce,Ne)},onDidOpenTerminal(ee,ce,Ne){return st($t.onDidOpenTerminal)(ee,ce,Ne)},onDidChangeActiveTerminal(ee,ce,Ne){return st($t.onDidChangeActiveTerminal)(ee,ce,Ne)},onDidChangeTerminalDimensions(ee,ce,Ne){return(0,Ye.$UG)(Le,"terminalDimensions"),st($t.onDidChangeTerminalDimensions)(ee,ce,Ne)},onDidChangeTerminalState(ee,ce,Ne){return st($t.onDidChangeTerminalState)(ee,ce,Ne)},onDidWriteTerminalData(ee,ce,Ne){return(0,Ye.$UG)(Le,"terminalDataWriteEvent"),st($t.onDidWriteTerminalData)(ee,ce,Ne)},onDidExecuteTerminalCommand(ee,ce,Ne){return(0,Ye.$UG)(Le,"terminalExecuteCommandEvent"),st($t.onDidExecuteTerminalCommand)(ee,ce,Ne)},onDidChangeTerminalShellIntegration(ee,ce,Ne){return(0,Ye.$UG)(Le,"terminalShellIntegration"),st(qt.onDidChangeTerminalShellIntegration)(ee,ce,Ne)},onDidStartTerminalShellExecution(ee,ce,Ne){return(0,Ye.$UG)(Le,"terminalShellIntegration"),st(qt.onDidStartTerminalShellExecution)(ee,ce,Ne)},onDidEndTerminalShellExecution(ee,ce,Ne){return(0,Ye.$UG)(Le,"terminalShellIntegration"),st(qt.onDidEndTerminalShellExecution)(ee,ce,Ne)},get state(){return Nt.getState()},onDidChangeWindowState(ee,ce,Ne){return st(Nt.onDidChangeWindowState)(ee,ce,Ne)},showInformationMessage(ee,...ce){return Gi.showMessage(Le,M.default.Info,ee,ce[0],ce.slice(1))},showWarningMessage(ee,...ce){return Gi.showMessage(Le,M.default.Warning,ee,ce[0],ce.slice(1))},showErrorMessage(ee,...ce){return Gi.showMessage(Le,M.default.Error,ee,ce[0],ce.slice(1))},showQuickPick(ee,ce,Ne){return ut.showQuickPick(Le,ee,ce,Ne)},showWorkspaceFolderPick(ee){return ut.showWorkspaceFolderPick(ee)},showInputBox(ee,ce){return ut.showInput(ee,ce)},showOpenDialog(ee){return Oi.showOpenDialog(Le,ee)},showSaveDialog(ee){return Oi.showSaveDialog(ee)},createStatusBarItem(ee,ce,Ne){let ot,Et,At;return typeof ee=="string"?(ot=ee,Et=ce,At=Ne):(Et=ee,At=ce),_i.createStatusBarEntry(Le,ot,Et,At)},setStatusBarMessage(ee,ce){return _i.setStatusBarMessage(ee,ce)},withScmProgress(ee){return Pt.report("window.withScmProgress",Le,"Use 'withProgress' instead."),Ht.withProgress(Le,{location:H.ProgressLocation.SourceControl},(ce,Ne)=>ee({report(ot){}}))},withProgress(ee,ce){return Ht.withProgress(Le,ee,ce)},createOutputChannel(ee,ce){return pi.createOutputChannel(ee,ce,Le)},createWebviewPanel(ee,ce,Ne,ot){return Mi.createWebviewPanel(Le,ee,ce,Ne,ot)},createWebviewTextEditorInset(ee,ce,Ne,ot){return(0,Ye.$UG)(Le,"editorInsets"),ue.createWebviewEditorInset(ee,ce,Ne,ot,Le)},createTerminal(ee,ce,Ne){return typeof ee=="object"?"pty"in ee?$t.createExtensionTerminal(ee):$t.createTerminalFromOptions(ee):$t.createTerminal(ee,ce,Ne)},registerTerminalLinkProvider(ee){return $t.registerLinkProvider(ee)},registerTerminalProfileProvider(ee,ce){return $t.registerProfileProvider(Le,ee,ce)},registerTerminalQuickFixProvider(ee,ce){return(0,Ye.$UG)(Le,"terminalQuickFixProvider"),$t.registerTerminalQuickFixProvider(ee,Le.identifier.value,ce)},registerTreeDataProvider(ee,ce){return Me.registerTreeDataProvider(ee,ce,Le)},createTreeView(ee,ce){return Me.createTreeView(ee,ce,Le)},registerWebviewPanelSerializer:(ee,ce)=>Mi.registerWebviewPanelSerializer(Le,ee,ce),registerCustomEditorProvider:(ee,ce,Ne={})=>ji.registerCustomEditorProvider(Le,ee,ce,Ne),registerFileDecorationProvider(ee){return si.registerFileDecorationProvider(ee,Le)},registerUriHandler(ee){return ki.registerUriHandler(Le,ee)},createQuickPick(){return ut.createQuickPick(Le)},createInputBox(){return ut.createInputBox(Le)},get activeColorTheme(){return Ui.activeColorTheme},onDidChangeActiveColorTheme(ee,ce,Ne){return st(Ui.onDidChangeActiveColorTheme)(ee,ce,Ne)},registerWebviewViewProvider(ee,ce,Ne){return Bi.registerWebviewViewProvider(Le,ee,ce,Ne?.webviewOptions)},get activeNotebookEditor(){return It.activeNotebookEditor},onDidChangeActiveNotebookEditor(ee,ce,Ne){return st(It.onDidChangeActiveNotebookEditor)(ee,ce,Ne)},get visibleNotebookEditors(){return It.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return st(It.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(ee,ce,Ne){return st(wi.onDidChangeNotebookEditorSelection)(ee,ce,Ne)},onDidChangeNotebookEditorVisibleRanges(ee,ce,Ne){return st(wi.onDidChangeNotebookEditorVisibleRanges)(ee,ce,Ne)},showNotebookDocument(ee,ce){return It.showNotebookDocument(ee,ce)},registerExternalUriOpener(ee,ce,Ne){return(0,Ye.$UG)(Le,"externalUriOpener"),Zi.registerExternalUriOpener(Le.identifier,ee,ce,Ne)},registerProfileContentHandler(ee,ce){return(0,Ye.$UG)(Le,"profileContentHandlers"),xi.registerProfileContentHandler(Le,ee,ce)},registerQuickDiffProvider(ee,ce,Ne,ot){return(0,Ye.$UG)(Le,"quickDiffProvider"),Zt.registerQuickDiffProvider(yt(ee),ce,Ne,ot)},get tabGroups(){return Vt.tabGroups},registerShareProvider(ee,ce){return(0,Ye.$UG)(Le,"shareProvider"),ii.registerShareProvider(yt(ee),ce)}},Hi={get rootPath(){return Pt.report("workspace.rootPath",Le,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),bt.getPath()},set rootPath(ee){throw new R.$9("rootPath")},getWorkspaceFolder(ee){return bt.getWorkspaceFolder(ee)},get workspaceFolders(){return bt.getWorkspaceFolders()},get name(){return bt.name},set name(ee){throw new R.$9("name")},get workspaceFile(){return bt.workspaceFile},set workspaceFile(ee){throw new R.$9("workspaceFile")},updateWorkspaceFolders:(ee,ce,...Ne)=>bt.updateWorkspaceFolders(Le,ee,ce||0,...Ne),onDidChangeWorkspaceFolders:function(ee,ce,Ne){return st(bt.onDidChangeWorkspace)(ee,ce,Ne)},asRelativePath:(ee,ce)=>bt.getRelativePath(ee,ce),findFiles:(ee,ce,Ne,ot)=>bt.findFiles(ee,ce,Ne,Le.identifier,ot),findFiles2:(ee,ce,Ne)=>((0,Ye.$UG)(Le,"findFiles2"),bt.findFiles2(ee,ce,Le.identifier,Ne)),findTextInFiles:(ee,ce,Ne,ot)=>{(0,Ye.$UG)(Le,"findTextInFiles");let Et,At;return typeof ce=="object"?(Et=ce,At=Ne):(Et={},At=ce,ot=Ne),bt.findTextInFiles(ee,Et||{},At,Le.identifier,ot)},save:ee=>bt.save(ee),saveAs:ee=>bt.saveAs(ee),saveAll:ee=>bt.saveAll(ee),applyEdit(ee,ce){return pn.applyWorkspaceEdit(ee,Le,ce)},createFileSystemWatcher:(ee,ce,Ne,ot)=>{let Et;return typeof ce=="boolean"?Et={ignoreCreateEvents:!!ce,ignoreChangeEvents:!!Ne,ignoreDeleteEvents:!!ot,correlate:!1}:ce&&((0,Ye.$UG)(Le,"createFileSystemWatcher"),Et={...ce,correlate:!0}),qe.createFileSystemWatcher(bt,Le,ee,Et)},get textDocuments(){return Rt.getAllDocumentData().map(ee=>ee.document)},set textDocuments(ee){throw new R.$9("textDocuments")},openTextDocument(ee){let ce;const Ne=ee;if(typeof ee=="string")ce=Promise.resolve($.URI.file(ee));else if($.URI.isUri(ee))ce=Promise.resolve(ee);else if(!Ne||typeof Ne=="object")ce=Rt.createDocumentData(Ne);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ce.then(ot=>(ot.scheme===A.Schemas.vscodeRemote&&!ot.authority&&Pt.report("workspace.openTextDocument",Le,"A URI of 'vscode-remote' scheme requires an authority."),Rt.ensureDocumentData(ot).then(Et=>Et.document)))},onDidOpenTextDocument:(ee,ce,Ne)=>st(Rt.onDidAddDocument)(ee,ce,Ne),onDidCloseTextDocument:(ee,ce,Ne)=>st(Rt.onDidRemoveDocument)(ee,ce,Ne),onDidChangeTextDocument:(ee,ce,Ne)=>st(Rt.onDidChangeDocument)(ee,ce,Ne),onDidSaveTextDocument:(ee,ce,Ne)=>st(Rt.onDidSaveDocument)(ee,ce,Ne),onWillSaveTextDocument:(ee,ce,Ne)=>st(ai.getOnWillSaveTextDocumentEvent(Le))(ee,ce,Ne),get notebookDocuments(){return It.notebookDocuments.map(ee=>ee.apiNotebook)},async openNotebookDocument(ee,ce){let Ne;if($.URI.isUri(ee))Ne=ee,await It.openNotebookDocument(ee);else if(typeof ee=="string")Ne=$.URI.revive(await It.createNotebookDocument({viewType:ee,content:ce}));else throw new Error("Invalid arguments");return It.getNotebookDocument(Ne).apiNotebook},onDidSaveNotebookDocument(ee,ce,Ne){return st(Ii.onDidSaveNotebookDocument)(ee,ce,Ne)},onDidChangeNotebookDocument(ee,ce,Ne){return st(Ii.onDidChangeNotebookDocument)(ee,ce,Ne)},onWillSaveNotebookDocument(ee,ce,Ne){return st(fi.getOnWillSaveNotebookDocumentEvent(Le))(ee,ce,Ne)},get onDidOpenNotebookDocument(){return st(It.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return st(It.onDidCloseNotebookDocument)},registerNotebookSerializer(ee,ce,Ne,ot){return It.registerNotebookSerializer(Le,ee,ce,Ne,(0,Ye.$TG)(Le,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(ee,ce,Ne)=>st(Ki.onDidChangeConfiguration)(ee,ce,Ne),getConfiguration(ee,ce){return ce=arguments.length===1?void 0:ce,Ki.getConfiguration(ee,ce,Le)},registerTextDocumentContentProvider(ee,ce){return Pi.registerTextDocumentContentProvider(ee,ce)},registerTaskProvider:(ee,ce)=>(Pt.report("window.registerTaskProvider",Le,"Use the corresponding function on the 'tasks' namespace instead"),Kt.registerTaskProvider(Le,ee,ce)),registerFileSystemProvider(ee,ce,Ne){return(0,O.$Rc)(Xe.registerFileSystemProvider(Le,ee,ce,Ne),Yt.addFileSystemProvider(ee,ce,Ne))},get fs(){return Yt.value},registerFileSearchProvider:(ee,ce)=>((0,Ye.$UG)(Le,"fileSearchProvider"),oi.registerFileSearchProvider(ee,ce)),registerTextSearchProvider:(ee,ce)=>((0,Ye.$UG)(Le,"textSearchProvider"),oi.registerTextSearchProvider(ee,ce)),registerAITextSearchProvider:(ee,ce)=>((0,Ye.$UG)(Le,"aiTextSearchProvider"),(0,Ye.$UG)(Le,"textSearchProvider"),oi.registerAITextSearchProvider(ee,ce)),registerRemoteAuthorityResolver:(ee,ce)=>((0,Ye.$UG)(Le,"resolvers"),jt.registerRemoteAuthorityResolver(ee,ce)),registerResourceLabelFormatter:ee=>((0,Ye.$UG)(Le,"resolvers"),Li.$registerResourceLabelFormatter(ee)),getRemoteExecServer:ee=>((0,Ye.$UG)(Le,"resolvers"),jt.getRemoteExecServer(ee)),onDidCreateFiles:(ee,ce,Ne)=>st(qe.onDidCreateFile)(ee,ce,Ne),onDidDeleteFiles:(ee,ce,Ne)=>st(qe.onDidDeleteFile)(ee,ce,Ne),onDidRenameFiles:(ee,ce,Ne)=>st(qe.onDidRenameFile)(ee,ce,Ne),onWillCreateFiles:(ee,ce,Ne)=>st(qe.getOnWillCreateFileEvent(Le))(ee,ce,Ne),onWillDeleteFiles:(ee,ce,Ne)=>st(qe.getOnWillDeleteFileEvent(Le))(ee,ce,Ne),onWillRenameFiles:(ee,ce,Ne)=>st(qe.getOnWillRenameFileEvent(Le))(ee,ce,Ne),openTunnel:ee=>((0,Ye.$UG)(Le,"tunnels"),Tt.openTunnel(Le,ee).then(ce=>{if(!ce)throw new Error("cannot open tunnel");return ce})),get tunnels(){return(0,Ye.$UG)(Le,"tunnels"),Tt.getTunnels()},onDidChangeTunnels:(ee,ce,Ne)=>((0,Ye.$UG)(Le,"tunnels"),st(Tt.onDidChangeTunnels)(ee,ce,Ne)),registerPortAttributesProvider:(ee,ce)=>((0,Ye.$UG)(Le,"portsAttributes"),Tt.registerPortsAttributesProvider(ee,ce)),registerTunnelProvider:(ee,ce)=>((0,Ye.$UG)(Le,"tunnelFactory"),Tt.registerTunnelProvider(ee,ce)),registerTimelineProvider:(ee,ce)=>((0,Ye.$UG)(Le,"timeline"),Xi.registerTimelineProvider(ee,ce,Le.identifier,wt.converter)),get isTrusted(){return bt.trusted},requestWorkspaceTrust:ee=>((0,Ye.$UG)(Le,"workspaceTrust"),bt.requestWorkspaceTrust(ee)),onDidGrantWorkspaceTrust:(ee,ce,Ne)=>st(bt.onDidGrantWorkspaceTrust)(ee,ce,Ne),registerEditSessionIdentityProvider:(ee,ce)=>((0,Ye.$UG)(Le,"editSessionIdentityProvider"),bt.registerEditSessionIdentityProvider(ee,ce)),onWillCreateEditSessionIdentity:(ee,ce,Ne)=>((0,Ye.$UG)(Le,"editSessionIdentityProvider"),st(bt.getOnWillCreateEditSessionIdentityEvent(Le))(ee,ce,Ne)),registerCanonicalUriProvider:(ee,ce)=>((0,Ye.$UG)(Le,"canonicalUriProvider"),bt.registerCanonicalUriProvider(ee,ce)),getCanonicalUri:(ee,ce,Ne)=>((0,Ye.$UG)(Le,"canonicalUriProvider"),bt.provideCanonicalUri(ee,ce,Ne))},sn={get inputBox(){return Pt.report("scm.inputBox",Le,"Use 'SourceControl.inputBox' instead"),kt.getLastInputBox(Le)},createSourceControl(ee,ce,Ne){return kt.createSourceControl(Le,ee,ce,Ne)}},bn={createCommentController(ee,ce){return Ft.createCommentController(Le,ee,ce)}},on={get activeDebugSession(){return Dt.activeDebugSession},get activeDebugConsole(){return Dt.activeDebugConsole},get breakpoints(){return Dt.breakpoints},get activeStackItem(){return Dt.activeStackItem},registerDebugVisualizationProvider(ee,ce){return(0,Ye.$UG)(Le,"debugVisualization"),Dt.registerDebugVisualizationProvider(Le,ee,ce)},registerDebugVisualizationTreeProvider(ee,ce){return(0,Ye.$UG)(Le,"debugVisualization"),Dt.registerDebugVisualizationTree(Le,ee,ce)},onDidStartDebugSession(ee,ce,Ne){return st(Dt.onDidStartDebugSession)(ee,ce,Ne)},onDidTerminateDebugSession(ee,ce,Ne){return st(Dt.onDidTerminateDebugSession)(ee,ce,Ne)},onDidChangeActiveDebugSession(ee,ce,Ne){return st(Dt.onDidChangeActiveDebugSession)(ee,ce,Ne)},onDidReceiveDebugSessionCustomEvent(ee,ce,Ne){return st(Dt.onDidReceiveDebugSessionCustomEvent)(ee,ce,Ne)},onDidChangeBreakpoints(ee,ce,Ne){return st(Dt.onDidChangeBreakpoints)(ee,ce,Ne)},onDidChangeActiveStackItem(ee,ce,Ne){return st(Dt.onDidChangeActiveStackItem)(ee,ce,Ne)},registerDebugConfigurationProvider(ee,ce,Ne){return Dt.registerDebugConfigurationProvider(ee,ce,Ne||li.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ee,ce){return Dt.registerDebugAdapterDescriptorFactory(Le,ee,ce)},registerDebugAdapterTrackerFactory(ee,ce){return Dt.registerDebugAdapterTrackerFactory(ee,ce)},startDebugging(ee,ce,Ne){return!Ne||typeof Ne=="object"&&"configuration"in Ne?Dt.startDebugging(ee,ce,{parentSession:Ne}):Dt.startDebugging(ee,ce,Ne||{})},stopDebugging(ee){return Dt.stopDebugging(ee)},addBreakpoints(ee){return Dt.addBreakpoints(ee)},removeBreakpoints(ee){return Dt.removeBreakpoints(ee)},asDebugSourceUri(ee,ce){return Dt.asDebugSourceUri(ee,ce)}},an={registerTaskProvider:(ee,ce)=>Kt.registerTaskProvider(Le,ee,ce),fetchTasks:ee=>Kt.fetchTasks(ee),executeTask:ee=>Kt.executeTask(Le,ee),get taskExecutions(){return Kt.taskExecutions},onDidStartTask:(ee,ce,Ne)=>st(Kt.onDidStartTask)(ee,ce,Ne),onDidEndTask:(ee,ce,Ne)=>st(Kt.onDidEndTask)(ee,ce,Ne),onDidStartTaskProcess:(ee,ce,Ne)=>st(Kt.onDidStartTaskProcess)(ee,ce,Ne),onDidEndTaskProcess:(ee,ce,Ne)=>st(Kt.onDidEndTaskProcess)(ee,ce,Ne)},vn={createNotebookController(ee,ce,Ne,ot,Et){return $i.createNotebookController(Le,ee,ce,Ne,ot,(0,Ye.$TG)(Le,"notebookMessaging")?Et:void 0)},registerNotebookCellStatusBarItemProvider:(ee,ce)=>It.registerNotebookCellStatusBarItemProvider(Le,ee,ce),createRendererMessaging(ee){return Ri.createRendererMessaging(Le,ee)},createNotebookControllerDetectionTask(ee){return(0,Ye.$UG)(Le,"notebookKernelSource"),$i.createNotebookControllerDetectionTask(Le,ee)},registerKernelSourceActionProvider(ee,ce){return(0,Ye.$UG)(Le,"notebookKernelSource"),$i.registerKernelSourceActionProvider(Le,ee,ce)},onDidChangeNotebookCellExecutionState(ee,ce,Ne){return(0,Ye.$UG)(Le,"notebookCellExecutionState"),st($i.onDidChangeNotebookCellExecutionState)(ee,ce,Ne)}},wn={t(...ee){if(typeof ee[0]=="string"){const ce=ee.shift(),Ne=!ee||typeof ee[0]!="object"?ee:ee[0];return di.getMessage(Le.identifier.value,{message:ce,args:Ne})}return di.getMessage(Le.identifier.value,ee[0])},get bundle(){return di.getBundle(Le.identifier.value)},get uri(){return di.getBundleUri(Le.identifier.value)}},cn={_version:1,transferActiveChat(ee){return(0,Ye.$UG)(Le,"interactive"),Ti.transferActiveChat(ee)}},Ji={getRelatedInformation(ee,ce){return(0,Ye.$UG)(Le,"aiRelatedInformation"),Vi.getRelatedInformation(Le,ee,ce)},registerRelatedInformationProvider(ee,ce){return(0,Ye.$UG)(Le,"aiRelatedInformation"),Vi.registerRelatedInformationProvider(Le,ee,ce)},registerEmbeddingVectorProvider(ee,ce){return(0,Ye.$UG)(Le,"aiRelatedInformation"),gn.registerEmbeddingVectorProvider(Le,ee,ce)}},un={_version:1,registerChatResponseProvider(ee,ce,Ne){return(0,Ye.$UG)(Le,"chatProvider"),Xt.registerLanguageModel(Le,ee,ce,Ne)},registerChatVariableResolver(ee,ce,Ne,ot,Et,At,Di,Fi){return(0,Ye.$UG)(Le,"chatVariableResolver"),Wi.registerVariableResolver(Le,ee,ce,Ne,ot,Et,At,Di,Fi?.id)},registerMappedEditsProvider(ee,ce){return(0,Ye.$UG)(Le,"mappedEditsProvider"),Ue.registerMappedEditsProvider(Le,ee,ce)},createChatParticipant(ee,ce){return Ti.createChatAgent(Le,ee,ce)},createDynamicChatParticipant(ee,ce,Ne){return(0,Ye.$UG)(Le,"chatParticipantPrivate"),Ti.createDynamicChatAgent(Le,ee,ce,Ne)},attachContext(ee,ce,Ne){return(0,Ye.$UG)(Le,"chatVariableResolver"),Wi.attachContext(ee,ce,Ne)}},ln={selectChatModels:ee=>pt.quality==="stable"?(console.warn(`[${D.$Wm.toKey(Le.identifier)}] This API is disabled in '${pt.environment.appName}'-stable.`),Promise.resolve([])):Xt.selectLanguageModels(Le,ee??{}),onDidChangeChatModels:(ee,ce,Ne)=>pt.quality==="stable"?(console.warn(`[${D.$Wm.toKey(Le.identifier)}] This API is disabled in '${pt.environment.appName}'-stable.`),P.Event.None(ee,ce,Ne)):Xt.onDidChangeProviders(ee,ce,Ne),get embeddingModels(){return(0,Ye.$UG)(Le,"embeddings"),Ei.embeddingsModels},onDidChangeEmbeddingModels:(ee,ce,Ne)=>((0,Ye.$UG)(Le,"embeddings"),Ei.onDidChange(ee,ce,Ne)),registerEmbeddingsProvider(ee,ce){return(0,Ye.$UG)(Le,"embeddings"),Ei.registerEmbeddingsProvider(Le,ee,ce)},async computeEmbeddings(ee,ce,Ne){return(0,Ye.$UG)(Le,"embeddings"),Ei.computeEmbeddings(ee,ce,Ne)}},hn={registerSpeechProvider(ee,ce){return(0,Ye.$UG)(Le,"speech"),qi.registerProvider(Le.identifier,ee,ce)}};return{version:pt.version,ai:Ji,authentication:tn,commands:bi,comments:bn,chat:un,debug:on,env:Ai,extensions:Ni,interactive:cn,l10n:wn,languages:nn,lm:ln,notebooks:vn,scm:sn,speech:hn,tasks:an,tests:$n,window:rn,workspace:Hi,Breakpoint:H.$xN,TerminalOutputAnchor:H.TerminalOutputAnchor,ChatResultFeedbackKind:H.ChatResultFeedbackKind,ChatVariableLevel:H.ChatVariableLevel,ChatCompletionItem:H.$sO,CallHierarchyIncomingCall:H.$VM,CallHierarchyItem:H.$UM,CallHierarchyOutgoingCall:H.$WM,CancellationError:R.$5,CancellationTokenSource:E.$se,CandidatePortSource:t.CandidatePortSource,CodeAction:H.$RM,CodeActionKind:H.$SM,CodeActionTriggerKind:H.CodeActionTriggerKind,CodeLens:H.$XM,Color:H.$$M,ColorInformation:H.$_M,ColorPresentation:H.$aN,ColorThemeKind:H.ColorThemeKind,CommentMode:H.CommentMode,CommentState:H.CommentState,CommentThreadCollapsibleState:H.CommentThreadCollapsibleState,CommentThreadState:H.CommentThreadState,CommentThreadApplicability:H.CommentThreadApplicability,CompletionItem:H.$5M,CompletionItemKind:H.CompletionItemKind,CompletionItemTag:H.CompletionItemTag,CompletionList:H.$6M,CompletionTriggerKind:H.CompletionTriggerKind,ConfigurationTarget:H.ConfigurationTarget,CustomExecution:H.$iN,DebugAdapterExecutable:H.$BN,DebugAdapterInlineImplementation:H.$EN,DebugAdapterNamedPipeServer:H.$DN,DebugAdapterServer:H.$CN,DebugConfigurationProviderTriggerKind:li.DebugConfigurationProviderTriggerKind,DebugConsoleMode:H.DebugConsoleMode,DebugVisualization:H.$UN,DecorationRangeBehavior:H.DecorationRangeBehavior,Diagnostic:H.$KM,DiagnosticRelatedInformation:H.$JM,DiagnosticSeverity:H.DiagnosticSeverity,DiagnosticTag:H.DiagnosticTag,Disposable:H.$wM,DocumentHighlight:H.$NM,DocumentHighlightKind:H.DocumentHighlightKind,MultiDocumentHighlight:H.$OM,DocumentLink:H.$0M,DocumentSymbol:H.$QM,EndOfLine:H.EndOfLine,EnvironmentVariableMutatorType:H.EnvironmentVariableMutatorType,EvaluatableExpression:H.$HN,InlineValueText:H.$IN,InlineValueVariableLookup:H.$JN,InlineValueEvaluatableExpression:H.$KN,InlineCompletionTriggerKind:H.InlineCompletionTriggerKind,EventEmitter:P.$he,ExtensionKind:H.ExtensionKind,ExtensionMode:H.ExtensionMode,ExternalUriOpenerPriority:H.ExternalUriOpenerPriority,FileChangeType:H.FileChangeType,FileDecoration:H.$WN,FileDecoration2:H.$WN,FileSystemError:H.$NN,FileType:d.FileType,FilePermission:d.FilePermission,FoldingRange:H.$ON,FoldingRangeKind:H.FoldingRangeKind,FunctionBreakpoint:H.$zN,InlineCompletionItem:H.$7M,InlineCompletionList:H.$8M,Hover:H.$LM,VerboseHover:H.$MM,HoverVerbosityAction:H.HoverVerbosityAction,IndentAction:v.IndentAction,Location:H.$IM,MarkdownString:H.$YM,OverviewRulerLane:u.OverviewRulerLane,ParameterInformation:H.$ZM,PortAutoForwardAction:H.PortAutoForwardAction,Position:H.$xM,ProcessExecution:H.$gN,ProgressLocation:H.ProgressLocation,QuickInputButtons:H.$VN,Range:H.$yM,RelativePattern:H.$vN,Selection:H.$zM,SelectionRange:H.$TM,SemanticTokens:H.$RN,SemanticTokensBuilder:H.$QN,SemanticTokensEdit:H.$SN,SemanticTokensEdits:H.$TN,SemanticTokensLegend:H.$PN,ShellExecution:H.$hN,ShellQuoting:H.ShellQuoting,SignatureHelp:H.$2M,SignatureHelpTriggerKind:H.SignatureHelpTriggerKind,SignatureInformation:H.$1M,SnippetString:H.$HM,SourceBreakpoint:H.$yN,StandardTokenType:H.StandardTokenType,StatusBarAlignment:H.StatusBarAlignment,SymbolInformation:H.$PM,SymbolKind:H.SymbolKind,SymbolTag:H.SymbolTag,Task:H.$jN,TaskGroup:H.$fN,TaskPanelKind:H.TaskPanelKind,TaskRevealKind:H.TaskRevealKind,TaskScope:H.TaskScope,TerminalLink:H.$bN,TerminalQuickFixTerminalCommand:H.$dN,TerminalQuickFixOpener:H.$cN,TerminalLocation:H.TerminalLocation,TerminalProfile:H.$eN,TerminalExitReason:H.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:H.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:H.TextDocumentSaveReason,TextEdit:H.$DM,SnippetTextEdit:H.$FM,TextEditorCursorStyle:c.TextEditorCursorStyle,TextEditorLineNumbersStyle:H.TextEditorLineNumbersStyle,TextEditorRevealType:H.TextEditorRevealType,TextEditorSelectionChangeKind:H.TextEditorSelectionChangeKind,SyntaxTokenType:H.SyntaxTokenType,TextDocumentChangeReason:H.TextDocumentChangeReason,ThemeColor:H.$uN,ThemeIcon:H.$tN,TreeItem:H.$kN,TreeItemCheckboxState:H.TreeItemCheckboxState,TreeItemCollapsibleState:H.TreeItemCollapsibleState,TypeHierarchyItem:H.$gO,UIKind:xt.UIKind,Uri:$.URI,ViewColumn:H.ViewColumn,WorkspaceEdit:H.$GM,DocumentPasteTriggerKind:H.DocumentPasteTriggerKind,DocumentDropEdit:H.$qN,DocumentDropOrPasteEditKind:H.$rN,DocumentPasteEdit:H.$sN,InlayHint:H.$4M,InlayHintLabelPart:H.$3M,InlayHintKind:H.InlayHintKind,RemoteAuthorityResolverError:H.$CM,ResolvedAuthority:H.$AM,ManagedResolvedAuthority:H.$BM,SourceControlInputBoxValidationType:H.SourceControlInputBoxValidationType,ExtensionRuntime:H.ExtensionRuntime,TimelineItem:H.$7N,NotebookRange:H.$YN,NotebookCellKind:H.NotebookCellKind,NotebookCellExecutionState:H.NotebookCellExecutionState,NotebookCellData:H.$ZN,NotebookData:H.$1N,NotebookRendererScript:H.$5N,NotebookCellStatusBarAlignment:H.NotebookCellStatusBarAlignment,NotebookEditorRevealType:H.NotebookEditorRevealType,NotebookCellOutput:H.$3N,NotebookCellOutputItem:H.$2N,NotebookCellStatusBarItem:H.$4N,NotebookControllerAffinity:H.NotebookControllerAffinity,NotebookControllerAffinity2:H.NotebookControllerAffinity2,NotebookEdit:H.$EM,NotebookKernelSourceAction:H.$6N,NotebookVariablesRequestKind:H.NotebookVariablesRequestKind,PortAttributes:H.$9N,LinkedEditingRanges:H.$8N,TestResultState:H.TestResultState,TestRunRequest:H.$0N,TestMessage:H.$$N,TestTag:H.$_N,TestRunProfileKind:H.TestRunProfileKind,TextSearchCompleteMessageType:Wt.TextSearchCompleteMessageType,DataTransfer:H.$pN,DataTransferItem:H.$lN,TestCoverageCount:H.$aO,FileCoverage:H.$cO,FileCoverage2:H.$cO,StatementCoverage:H.$dO,BranchCoverage:H.$eO,DeclarationCoverage:H.$fO,WorkspaceTrustState:H.WorkspaceTrustState,LanguageStatusSeverity:H.LanguageStatusSeverity,QuickPickItemKind:H.QuickPickItemKind,InputBoxValidationSeverity:H.InputBoxValidationSeverity,TabInputText:H.$hO,TabInputTextDiff:H.$iO,TabInputTextMerge:H.$jO,TabInputCustom:H.$kO,TabInputNotebook:H.$mO,TabInputNotebookDiff:H.$nO,TabInputWebview:H.$lO,TabInputTerminal:H.$oO,TabInputInteractiveWindow:H.$pO,TabInputChat:H.$qO,TabInputTextMultiDiff:H.$rO,TelemetryTrustedValue:a.$np,LogLevel:r.LogLevel,EditSessionIdentityMatch:h.EditSessionIdentityMatch,InteractiveSessionVoteDirection:H.InteractiveSessionVoteDirection,ChatCopyKind:H.ChatCopyKind,InteractiveEditorResponseFeedbackKind:H.InteractiveEditorResponseFeedbackKind,DebugStackFrame:H.$FN,DebugThread:H.$GN,RelatedInformationType:H.RelatedInformationType,SpeechToTextStatus:H.SpeechToTextStatus,TextToSpeechStatus:H.TextToSpeechStatus,PartialAcceptTriggerKind:H.PartialAcceptTriggerKind,KeywordRecognitionStatus:H.KeywordRecognitionStatus,ChatResponseMarkdownPart:H.$tO,ChatResponseFileTreePart:H.$xO,ChatResponseAnchorPart:H.$yO,ChatResponseProgressPart:H.$zO,ChatResponseProgressPart2:H.$AO,ChatResponseReferencePart:H.$DO,ChatResponseWarningPart:H.$BO,ChatResponseTextEditPart:H.$EO,ChatResponseMarkdownWithVulnerabilitiesPart:H.$uO,ChatResponseCommandButtonPart:H.$CO,ChatResponseDetectedParticipantPart:H.$vO,ChatResponseConfirmationPart:H.$wO,ChatRequestTurn:H.$FO,ChatResponseTurn:H.$GO,ChatLocation:H.ChatLocation,LanguageModelChatMessageRole:H.LanguageModelChatMessageRole,LanguageModelChatMessage:H.$HO,LanguageModelChatMessage2:H.$HO,LanguageModelChatSystemMessage:H.$IO,LanguageModelChatUserMessage:H.$JO,LanguageModelChatAssistantMessage:H.$KO,LanguageModelError:H.$LO,NewSymbolName:H.$MN,NewSymbolNameTag:H.NewSymbolNameTag,NewSymbolNameTriggerKind:H.NewSymbolNameTriggerKind,InlineEdit:H.$MO,InlineEditTriggerKind:H.InlineEditTriggerKind}}}}),define(ke[318],Ie([1,0,60,126,44,120,45,39,71,57,129,131,132,89,93,85,119,68,51,88,66,70,257,12,130,86,87,91,95,124]),function(de,e,E,R,P,O,A,M,$,c,C,v,u,D,d,r,o,a,h,t,s,n,i,g,f,l,b,I,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,E.$Fs)(l.$Fnc,l.$Enc,E.InstantiationType.Delayed),(0,E.$Fs)(g.$8j,i.$Soc,E.InstantiationType.Delayed),(0,E.$Fs)(r.$Kmc,r.$Lmc,E.InstantiationType.Delayed),(0,E.$Fs)(M.$iP,M.$hP,E.InstantiationType.Eager),(0,E.$Fs)(I.$Umc,I.$Vmc,E.InstantiationType.Eager),(0,E.$Fs)(S.$znc,S.$Anc,E.InstantiationType.Eager),(0,E.$Fs)(A.$0mc,A.$8mc,E.InstantiationType.Eager),(0,E.$Fs)(a.$_mc,a.$$mc,E.InstantiationType.Eager),(0,E.$Fs)(v.$Pnc,v.$Tnc,E.InstantiationType.Eager),(0,E.$Fs)(O.$Vnc,O.$Unc,E.InstantiationType.Eager),(0,E.$Fs)($.$0O,$.$9O,E.InstantiationType.Eager),(0,E.$Fs)(b.$Gnc,b.$Hnc,E.InstantiationType.Eager),(0,E.$Fs)(h.$Omc,h.$Nmc,E.InstantiationType.Eager),(0,E.$Fs)(R.$ooc,R.$noc,E.InstantiationType.Delayed),(0,E.$Fs)(u.$_nc,u.$aoc,E.InstantiationType.Eager),(0,E.$Fs)(D.$snc,D.$rnc,E.InstantiationType.Eager),(0,E.$Fs)(C.$Boc,C.$Aoc,E.InstantiationType.Eager),(0,E.$Fs)(c.$vnc,c.$ync,E.InstantiationType.Eager),(0,E.$Fs)(y.$Coc,y.$Doc,E.InstantiationType.Eager),(0,E.$Fs)(d.$nEb,d.$oEb,E.InstantiationType.Eager),(0,E.$Fs)(o.$Qoc,o.$Poc,E.InstantiationType.Eager),(0,E.$Fs)(P.$7mc,P.$6mc,E.InstantiationType.Eager),(0,E.$Fs)(t.$Cnc,t.$Bnc,E.InstantiationType.Eager),(0,E.$Fs)(s.$gP,s.$dP,E.InstantiationType.Eager),(0,E.$Fs)(n.$jnc,n.$knc,E.InstantiationType.Eager),(0,E.$Fs)(f.$Nnc,f.$Onc,E.InstantiationType.Eager)}),define(ke[319],Ie([1,0,317,46,2,314,7,11,264]),function(de,e,E,R,P,O,A,M,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5qc=void 0;class c extends O.$Voc{j(){}getModule(D,d){for(const r of this.b){const o=r(D);if(o){D=o;break}}if(this.a.has(D))return this.a.get(D).load(D,d,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class C extends R.$Jnc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async vb(){this.h.createInstance($.$4qc);const D=this.h.invokeFunction(E.$Roc);this.r=this.h.createInstance(c,D,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(D){return D.browser}async xb(D,d,r){d=d.with({path:v(d.path,".js")});const o=D?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const a=P.URI.revive(await this.C.$asBrowserUri(d)),h=await fetch(a.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),h.status!==200)throw new Error(h.statusText);const t=await h.text(),s=`${d.toString(!0)}#vscode-extension`,n=`${t}
//# sourceURL=${s}`;let i;try{i=new Function("module","exports","require",n)}catch(b){throw console.error(o?`Loading code for extension ${o} failed: ${b.message}`:`Loading code failed: ${b.message}`),console.error(`${d.toString(!0)}${typeof b.line=="number"?` line ${b.line}`:""}${typeof b.column=="number"?` column ${b.column}`:""}`),console.error(b),b}D&&await this.w.initializeLocalizedMessages(D);const g={},f={exports:g},l=b=>{const I=this.r.getModule(b,d);if(I===void 0)throw new Error(`Cannot load module '${b}'`);return I};try{return r.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),i(f,g,l),f.exports!==g?f.exports:g}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),r.codeLoadingStop()}}async $setRemoteEnvironment(D){}async Bb(D=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const d=Date.now()+D;for(;Date.now()<d&&!("__jsDebugIsReady"in globalThis);)await(0,M.$Bh)(10)}}e.$5qc=C;function v(u,D){return u.endsWith(D)?u:u+D}}),define(ke[320],Ie([1,0,74,60,12,46,227,92,319]),function(de,e,E,R,P,O,A,M,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,R.$Fs)(P.$7j,new E.$xi(A.$Uoc,[!0],!0)),(0,R.$Fs)(O.$Knc,$.$5qc,R.InstantiationType.Eager),(0,R.$Fs)(M.$anc,M.$bnc,R.InstantiationType.Eager)}),define(ke[328],Ie([1,0,23,4,84,315,266,20,64,16,2,318,320]),function(de,e,E,R,P,O,A,M,$,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=n;const v=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const u=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function D(i){return/^(file|vscode-remote):/i.test(i)}const d=fetch.bind(self);function r(i){self.fetch=async function(g,f){return g instanceof Request||D(String(g))&&(g=(await i(C.URI.parse(String(g)))).toString(!0)),d(g,f)},self.XMLHttpRequest=class extends XMLHttpRequest{open(g,f,l,b,I){(async()=>(D(f.toString())&&(f=(await i(C.URI.parse(f.toString()))).toString(!0)),super.open(g,f,l??!0,b,I)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const i=self.Worker;Worker=function(g,f){if(/^file:/i.test(g.toString()))g=c.$Ug.uriToBrowserUri(C.URI.parse(g.toString())).toString(!0);else if(/^vscode-remote:/i.test(g.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const b=`(${function(p){function k(F){return typeof F=="string"||F instanceof URL?String(F).replace(/^file:\/\//i,"vscode-file://vscode-app"):F}const m=fetch.bind(self);self.fetch=function(F,T){return F instanceof Request?m(F,T):m(k(F),T)},self.XMLHttpRequest=class extends XMLHttpRequest{open(F,T,G,q,V){return super.open(F,k(T),G??!0,q,V)}};const w=importScripts.bind(self);self.importScripts=(...F)=>{w(...F.map(k))},w(p)}.toString()}('${g}'))`;f=f||{},f.name=`${name} -> ${f.name||M.$nc(g.toString())}`;const I=new Blob([b],{type:"application/javascript"}),S=URL.createObjectURL(I);return new i(S,f)}}else self.Worker=class extends A.$6qc{constructor(i,g){super(u,i,{name:M.$nc(i.toString()),...g})}};const o=new class{constructor(){this.pid=void 0}exit(i){v()}};class a{constructor(){const g=new MessageChannel,f=new R.$he;let l=!1;u(g.port2,[g.port2]),g.port1.onmessage=b=>{const{data:I}=b;if(!(I instanceof ArrayBuffer)){console.warn("UNKNOWN data received",I);return}const S=E.$Je.wrap(new Uint8Array(I,0,I.byteLength));if((0,P.$6m)(S,P.MessageType.Terminate)){l=!0,t("received terminate message from renderer");return}f.fire(S)},this.protocol={onMessage:f.event,send:b=>{if(!l){const I=b.buffer.buffer.slice(b.buffer.byteOffset,b.buffer.byteOffset+b.buffer.byteLength);g.port1.postMessage(I,[I])}}}}}function h(i){return new Promise(g=>{const f=i.onMessage(l=>{f.dispose();const b=JSON.parse(l.toString());i.send((0,P.$5m)(P.MessageType.Initialized)),g({protocol:i,initData:b})});i.send((0,P.$5m)(P.MessageType.Ready))})}let t=i=>v();function s(i){return!!i&&typeof i=="object"&&i.type==="vscode.init"&&i.data instanceof Map}function n(){$.mark("code/extHost/willConnectToRenderer");const i=new a;return{onmessage(g){s(g)&&h(i.protocol).then(f=>{$.mark("code/extHost/didWaitForInitData");const l=new O.$Xoc(f.protocol,f.initData,o,null,g.data);r(b=>l.asBrowserUri(b)),t=b=>l.terminate(b)})}}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f36826b4c1737fcc234a73ec043261ea893e6698/core/vs/workbench/api/worker/extensionHostWorker.js.map
